/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _47MP7JRSABSTRACTIONLEVELTYPE_H
#define _47MP7JRSABSTRACTIONLEVELTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAbstractionLevelTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAbstractionLevelType_ExtInclude.h


class IMp7JrsAbstractionLevelType;
typedef Mp7JrsPtr< IMp7JrsAbstractionLevelType> Mp7JrsAbstractionLevelPtr;

/** 
 * Generated interface IMp7JrsAbstractionLevelType for class Mp7JrsAbstractionLevelType<br>
 * Located at: mds-2001.xsd, line 4427<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsAbstractionLevelType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAbstractionLevelType();
    virtual ~IMp7JrsAbstractionLevelType();
    /**
     * Get dimension attribute.
     * @return unsigned
     */
    virtual unsigned Getdimension() const = 0;

    /**
     * Set dimension attribute.
     * @param item unsigned
     */
    virtual void Setdimension(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

// no includefile for extension defined 
// file Mp7JrsAbstractionLevelType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAbstractionLevelType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAbstractionLevelType<br>
 * Located at: mds-2001.xsd, line 4427<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 4427.<br>
 */
class MP7JRS_EXPORT Mp7JrsAbstractionLevelType :
        public IMp7JrsAbstractionLevelType
{
    friend class Mp7JrsAbstractionLevelTypeFactory; // constructs objects

public:
    /*
     * Get dimension attribute.
     * @return unsigned
     */
    virtual unsigned Getdimension() const;

    /*
     * Set dimension attribute.
     * @param item unsigned
     */
    virtual void Setdimension(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAbstractionLevelType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAbstractionLevelType();

protected:
    Mp7JrsAbstractionLevelType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_dimension;



// no includefile for extension defined 
// file Mp7JrsAbstractionLevelType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _47MP7JRSABSTRACTIONLEVELTYPE_H

