/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _87MP7JRSANALYTICMODELTYPE_SEMANTICS_LOCALTYPE_H
#define _87MP7JRSANALYTICMODELTYPE_SEMANTICS_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAnalyticModelType_Semantics_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_Semantics_LocalType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsSemanticBaseType.h"
class IMp7JrsAbstractionLevelType;
class IMp7JrsAnalyticModelType_Semantics_LocalType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsSemanticBaseType;
class IMp7JrsSemanticBaseType_Label_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType;
class IMp7JrsSemanticBaseType_Property_CollectionType;
class IMp7JrsSemanticBaseType_Relation_CollectionType;
class IMp7JrsTextAnnotationType;
class IMp7JrsxPathRefType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsAbstractionLevelType > Mp7JrsAbstractionLevelPtr;
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType_Semantics_LocalType> Mp7JrsAnalyticModelType_Semantics_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType > Mp7JrsSemanticBasePtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Label_CollectionType > Mp7JrsSemanticBaseType_Label_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Property_CollectionType > Mp7JrsSemanticBaseType_Property_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Relation_CollectionType > Mp7JrsSemanticBaseType_Relation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsAnalyticModelType_Semantics_LocalType for class Mp7JrsAnalyticModelType_Semantics_LocalType<br>
 * Located at: mds-2001.xsd, line 5670<br>
 * Classified: Class<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Derived from: SemanticBaseType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsAnalyticModelType_Semantics_LocalType 
 :
        public IMp7JrsSemanticBaseType
{
public:
    // TODO: make these protected?
    IMp7JrsAnalyticModelType_Semantics_LocalType();
    virtual ~IMp7JrsAnalyticModelType_Semantics_LocalType();
    /**
     * Get relevance attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getrelevance() const = 0;

    /**
     * Get relevance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrelevance() const = 0;

    /**
     * Set relevance attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setrelevance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate relevance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterelevance() = 0;

    /**
     * Get confidence attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * Get confidence attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const = 0;

    /**
     * Set confidence attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confidence attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence() = 0;

    /**
     * Get reliability attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const = 0;

    /**
     * Get reliability attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const = 0;

    /**
     * Set reliability attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate reliability attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsAbstractionLevelPtr
     */
    virtual Mp7JrsAbstractionLevelPtr GetAbstractionLevel() const = 0;

    virtual bool IsValidAbstractionLevel() const = 0;

    /**
     * Set AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsAbstractionLevelPtr &
     */
    virtual void SetAbstractionLevel(const Mp7JrsAbstractionLevelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate AbstractionLevel element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAbstractionLevel() = 0;

    /**
     * Get Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Label_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Label_CollectionPtr GetLabel() const = 0;

    /**
     * Set Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Label_CollectionPtr &
     */
    virtual void SetLabel(const Mp7JrsSemanticBaseType_Label_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetDefinition() const = 0;

    virtual bool IsValidDefinition() const = 0;

    /**
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetDefinition(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Definition element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDefinition() = 0;

    /**
     * Get Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Property_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Property_CollectionPtr GetProperty() const = 0;

    /**
     * Set Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Property_CollectionPtr &
     */
    virtual void SetProperty(const Mp7JrsSemanticBaseType_Property_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr GetMediaOccurrence() const = 0;

    /**
     * Set MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr &
     */
    virtual void SetMediaOccurrence(const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Relation_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Relation_CollectionPtr GetRelation() const = 0;

    /**
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Relation_CollectionPtr &
     */
    virtual void SetRelation(const Mp7JrsSemanticBaseType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_Semantics_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_Semantics_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAnalyticModelType_Semantics_LocalType<br>
 * Located at: mds-2001.xsd, line 5670<br>
 * Classified: Class<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Defined in mds-2001.xsd, line 5670.<br>
 */
class MP7JRS_EXPORT Mp7JrsAnalyticModelType_Semantics_LocalType :
        public IMp7JrsAnalyticModelType_Semantics_LocalType
{
    friend class Mp7JrsAnalyticModelType_Semantics_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAnalyticModelType_Semantics_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsSemanticBaseType >
     */
    virtual Mp7JrsPtr< Mp7JrsSemanticBaseType > GetBase() const;
    /*
     * Get relevance attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getrelevance() const;

    /*
     * Get relevance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrelevance() const;

    /*
     * Set relevance attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setrelevance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate relevance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterelevance();

    /*
     * Get confidence attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

    /*
     * Get reliability attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const;

    /*
     * Get reliability attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const;

    /*
     * Set reliability attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate reliability attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability();

        /* @name Sequence

         */
        //@{
    /*
     * Get AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsAbstractionLevelPtr
     */
    virtual Mp7JrsAbstractionLevelPtr GetAbstractionLevel() const;

    virtual bool IsValidAbstractionLevel() const;

    /*
     * Set AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsAbstractionLevelPtr &
     */
    virtual void SetAbstractionLevel(const Mp7JrsAbstractionLevelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate AbstractionLevel element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAbstractionLevel();

    /*
     * Get Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Label_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Label_CollectionPtr GetLabel() const;

    /*
     * Set Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Label_CollectionPtr &
     */
    virtual void SetLabel(const Mp7JrsSemanticBaseType_Label_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetDefinition() const;

    virtual bool IsValidDefinition() const;

    /*
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetDefinition(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Definition element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDefinition();

    /*
     * Get Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Property_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Property_CollectionPtr GetProperty() const;

    /*
     * Set Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Property_CollectionPtr &
     */
    virtual void SetProperty(const Mp7JrsSemanticBaseType_Property_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr GetMediaOccurrence() const;

    /*
     * Set MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr &
     */
    virtual void SetMediaOccurrence(const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Relation_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Relation_CollectionPtr GetRelation() const;

    /*
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Relation_CollectionPtr &
     */
    virtual void SetRelation(const Mp7JrsSemanticBaseType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_Semantics_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAnalyticModelType_Semantics_LocalType();

protected:
    Mp7JrsAnalyticModelType_Semantics_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrszeroToOnePtr m_relevance;
    bool m_relevance_Exist;
    Mp7JrszeroToOnePtr m_confidence;
    bool m_confidence_Exist;
    Mp7JrszeroToOnePtr m_reliability;
    bool m_reliability_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsSemanticBaseType > m_Base;


// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_Semantics_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _87MP7JRSANALYTICMODELTYPE_SEMANTICS_LOCALTYPE_H

