/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _95MP7JRSAUDIOFUNDAMENTALFREQUENCYTYPE_H
#define _95MP7JRSAUDIOFUNDAMENTALFREQUENCYTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioFundamentalFrequencyTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAudioFundamentalFrequencyType_ExtInclude.h


#include "Mp7JrsAudioDType.h"
#include "Mp7JrsAudioLLDScalarType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioFundamentalFrequencyType;
class IMp7JrsAudioLLDScalarType;
class IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsAudioFundamentalFrequencyType> Mp7JrsAudioFundamentalFrequencyPtr;
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType > Mp7JrsAudioLLDScalarPtr;
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType > Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsAudioFundamentalFrequencyType for class Mp7JrsAudioFundamentalFrequencyType<br>
 * Located at: audio-2001.xsd, line 148<br>
 * Classified: Class<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioFundamentalFrequencyType 
 :
        public IMp7JrsAudioLLDScalarType
{
public:
    // TODO: make these protected?
    IMp7JrsAudioFundamentalFrequencyType();
    virtual ~IMp7JrsAudioFundamentalFrequencyType();
    /**
     * Get loLimit attribute.
     * @return float
     */
    virtual float GetloLimit() const = 0;

    /**
     * Get loLimit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistloLimit() const = 0;

    /**
     * Set loLimit attribute.
     * @param item float
     */
    virtual void SetloLimit(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate loLimit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateloLimit() = 0;

    /**
     * Get hiLimit attribute.
     * @return float
     */
    virtual float GethiLimit() const = 0;

    /**
     * Get hiLimit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisthiLimit() const = 0;

    /**
     * Set hiLimit attribute.
     * @param item float
     */
    virtual void SethiLimit(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate hiLimit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatehiLimit() = 0;

    /**
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const = 0;

    /**
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return float
     */
    virtual float GetScalar() const = 0;

    /**
     * Set Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item float
     */
    virtual void SetScalar(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr
     */
    virtual Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr GetSeriesOfScalar() const = 0;

    /**
     * Set SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr &
     */
    virtual void SetSeriesOfScalar(const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioFundamentalFrequencyType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioFundamentalFrequencyType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioFundamentalFrequencyType<br>
 * Located at: audio-2001.xsd, line 148<br>
 * Classified: Class<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 * Defined in audio-2001.xsd, line 148.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioFundamentalFrequencyType :
        public IMp7JrsAudioFundamentalFrequencyType
{
    friend class Mp7JrsAudioFundamentalFrequencyTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAudioFundamentalFrequencyType
     
     * @return Mp7JrsPtr< Mp7JrsAudioLLDScalarType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioLLDScalarType > GetBase() const;
    /*
     * Get loLimit attribute.
     * @return float
     */
    virtual float GetloLimit() const;

    /*
     * Get loLimit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistloLimit() const;

    /*
     * Set loLimit attribute.
     * @param item float
     */
    virtual void SetloLimit(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate loLimit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateloLimit();

    /*
     * Get hiLimit attribute.
     * @return float
     */
    virtual float GethiLimit() const;

    /*
     * Get hiLimit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisthiLimit() const;

    /*
     * Set hiLimit attribute.
     * @param item float
     */
    virtual void SethiLimit(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate hiLimit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatehiLimit();

    /*
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

        /* @name Choice

         */
        //@{
    /*
     * Get Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return float
     */
    virtual float GetScalar() const;

    /*
     * Set Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item float
     */
    virtual void SetScalar(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr
     */
    virtual Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr GetSeriesOfScalar() const;

    /*
     * Set SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr &
     */
    virtual void SetSeriesOfScalar(const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioFundamentalFrequencyType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioFundamentalFrequencyType();

protected:
    Mp7JrsAudioFundamentalFrequencyType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    float m_loLimit;
    bool m_loLimit_Exist;
    float m_loLimit_Default;
    float m_hiLimit;
    bool m_hiLimit_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioLLDScalarType > m_Base;


// no includefile for extension defined 
// file Mp7JrsAudioFundamentalFrequencyType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _95MP7JRSAUDIOFUNDAMENTALFREQUENCYTYPE_H

