/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _105MP7JRSAUDIOLLDVECTORTYPE_H
#define _105MP7JRSAUDIOLLDVECTORTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioLLDVectorTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAudioLLDVectorType_ExtInclude.h


#include "Mp7JrsAudioDType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioDType;
class IMp7JrsAudioLLDVectorType;
class IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType;
class IMp7JrsfloatVector;
typedef Mp7JrsPtr< IMp7JrsAudioDType > Mp7JrsAudioDPtr;
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType > Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType> Mp7JrsAudioLLDVectorPtr;
typedef Mp7JrsPtr< IMp7JrsfloatVector > Mp7JrsfloatVectorPtr;

/** 
 * Generated interface IMp7JrsAudioLLDVectorType for class Mp7JrsAudioLLDVectorType<br>
 * Located at: audio-2001.xsd, line 60<br>
 * Classified: Class<br>
 * Derived from: AudioDType (Class)<br>
 * Abstract class <br>
 */
class MP7JRS_EXPORT IMp7JrsAudioLLDVectorType 
 :
        public IMp7JrsAudioDType
{
public:
    // TODO: make these protected?
    IMp7JrsAudioLLDVectorType();
    virtual ~IMp7JrsAudioLLDVectorType();
        /** @name Choice

         */
        //@{
    /**
     * Get Vector element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetVector() const = 0;

    /**
     * Set Vector element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetVector(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SeriesOfVector element.
     * @return Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr
     */
    virtual Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr GetSeriesOfVector() const = 0;

    /**
     * Set SeriesOfVector element.
     * @param item const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr &
     */
    virtual void SetSeriesOfVector(const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioLLDVectorType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioLLDVectorType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioLLDVectorType<br>
 * Located at: audio-2001.xsd, line 60<br>
 * Classified: Class<br>
 * Derived from: AudioDType (Class)<br>
 * Abstract class <br>
 * Defined in audio-2001.xsd, line 60.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioLLDVectorType :
        public IMp7JrsAudioLLDVectorType
{
    friend class Mp7JrsAudioLLDVectorTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAudioLLDVectorType
     
     * @return Mp7JrsPtr< Mp7JrsAudioDType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioDType > GetBase() const;
        /* @name Choice

         */
        //@{
    /*
     * Get Vector element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetVector() const;

    /*
     * Set Vector element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetVector(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SeriesOfVector element.
     * @return Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr
     */
    virtual Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr GetSeriesOfVector() const;

    /*
     * Set SeriesOfVector element.
     * @param item const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr &
     */
    virtual void SetSeriesOfVector(const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioLLDVectorType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioLLDVectorType();

protected:
    Mp7JrsAudioLLDVectorType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioDType > m_Base;

// DefinionChoice
    Mp7JrsfloatVectorPtr m_Vector;
    Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr m_SeriesOfVector;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAudioLLDVectorType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _105MP7JRSAUDIOLLDVECTORTYPE_H

