/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _145MP7JRSAUDIOSPECTRUMFLATNESSTYPE_H
#define _145MP7JRSAUDIOSPECTRUMFLATNESSTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioSpectrumFlatnessTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAudioSpectrumFlatnessType_ExtInclude.h


#include "Mp7JrsAudioDType.h"
#include "Mp7JrsAudioLLDVectorType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioLLDVectorType;
class IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType;
class IMp7JrsAudioSpectrumFlatnessType;
class IMp7JrsfloatVector;
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType > Mp7JrsAudioLLDVectorPtr;
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType > Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumFlatnessType> Mp7JrsAudioSpectrumFlatnessPtr;
typedef Mp7JrsPtr< IMp7JrsfloatVector > Mp7JrsfloatVectorPtr;

/** 
 * Generated interface IMp7JrsAudioSpectrumFlatnessType for class Mp7JrsAudioSpectrumFlatnessType<br>
 * Located at: audio-2001.xsd, line 172<br>
 * Classified: Class<br>
 * Derived from: AudioLLDVectorType (Class)<br>
 * Derived from: AudioLLDVectorType (Class)<br>
 * Derived from: AudioLLDVectorType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioSpectrumFlatnessType 
 :
        public IMp7JrsAudioLLDVectorType
{
public:
    // TODO: make these protected?
    IMp7JrsAudioSpectrumFlatnessType();
    virtual ~IMp7JrsAudioSpectrumFlatnessType();
    /**
     * Get loEdge attribute.
     * @return float
     */
    virtual float GetloEdge() const = 0;

    /**
     * Get loEdge attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistloEdge() const = 0;

    /**
     * Set loEdge attribute.
     * @param item float
     */
    virtual void SetloEdge(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate loEdge attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateloEdge() = 0;

    /**
     * Get hiEdge attribute.
     * @return float
     */
    virtual float GethiEdge() const = 0;

    /**
     * Get hiEdge attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisthiEdge() const = 0;

    /**
     * Set hiEdge attribute.
     * @param item float
     */
    virtual void SethiEdge(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate hiEdge attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatehiEdge() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Vector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetVector() const = 0;

    /**
     * Set Vector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetVector(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SeriesOfVector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @return Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr
     */
    virtual Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr GetSeriesOfVector() const = 0;

    /**
     * Set SeriesOfVector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @param item const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr &
     */
    virtual void SetSeriesOfVector(const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioSpectrumFlatnessType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioSpectrumFlatnessType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioSpectrumFlatnessType<br>
 * Located at: audio-2001.xsd, line 172<br>
 * Classified: Class<br>
 * Derived from: AudioLLDVectorType (Class)<br>
 * Derived from: AudioLLDVectorType (Class)<br>
 * Derived from: AudioLLDVectorType (Class)<br>
 * Defined in audio-2001.xsd, line 172.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioSpectrumFlatnessType :
        public IMp7JrsAudioSpectrumFlatnessType
{
    friend class Mp7JrsAudioSpectrumFlatnessTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAudioSpectrumFlatnessType
     
     * @return Mp7JrsPtr< Mp7JrsAudioLLDVectorType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioLLDVectorType > GetBase() const;
    /*
     * Get loEdge attribute.
     * @return float
     */
    virtual float GetloEdge() const;

    /*
     * Get loEdge attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistloEdge() const;

    /*
     * Set loEdge attribute.
     * @param item float
     */
    virtual void SetloEdge(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate loEdge attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateloEdge();

    /*
     * Get hiEdge attribute.
     * @return float
     */
    virtual float GethiEdge() const;

    /*
     * Get hiEdge attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisthiEdge() const;

    /*
     * Set hiEdge attribute.
     * @param item float
     */
    virtual void SethiEdge(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate hiEdge attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatehiEdge();

        /* @name Choice

         */
        //@{
    /*
     * Get Vector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetVector() const;

    /*
     * Set Vector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetVector(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SeriesOfVector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @return Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr
     */
    virtual Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr GetSeriesOfVector() const;

    /*
     * Set SeriesOfVector element.
<br>
     * (Inherited from Mp7JrsAudioLLDVectorType)
     * @param item const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr &
     */
    virtual void SetSeriesOfVector(const Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioSpectrumFlatnessType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioSpectrumFlatnessType();

protected:
    Mp7JrsAudioSpectrumFlatnessType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    float m_loEdge;
    bool m_loEdge_Exist;
    float m_loEdge_Default;
    float m_hiEdge;
    bool m_hiEdge_Exist;
    float m_hiEdge_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioLLDVectorType > m_Base;


// no includefile for extension defined 
// file Mp7JrsAudioSpectrumFlatnessType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _145MP7JRSAUDIOSPECTRUMFLATNESSTYPE_H

