/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _151MP7JRSAUDIOSUMMARYCOMPONENTTYPE_H
#define _151MP7JRSAUDIOSUMMARYCOMPONENTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioSummaryComponentTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAudioSummaryComponentType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioSummaryComponentType;
class IMp7JrsAudioSummaryComponentType_Title_CollectionType;
class IMp7JrsDType;
class IMp7JrsMediaTimeType;
class IMp7JrsTemporalSegmentLocatorType;
class IMp7JrsUniqueIDType;
typedef Mp7JrsPtr< IMp7JrsAudioSummaryComponentType_Title_CollectionType > Mp7JrsAudioSummaryComponentType_Title_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioSummaryComponentType> Mp7JrsAudioSummaryComponentPtr;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsTemporalSegmentLocatorType > Mp7JrsTemporalSegmentLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsUniqueIDType > Mp7JrsUniqueIDPtr;

/** 
 * Generated interface IMp7JrsAudioSummaryComponentType for class Mp7JrsAudioSummaryComponentType<br>
 * Located at: mds-2001.xsd, line 4652<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioSummaryComponentType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsAudioSummaryComponentType();
    virtual ~IMp7JrsAudioSummaryComponentType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Title element.
     * @return Mp7JrsAudioSummaryComponentType_Title_CollectionPtr
     */
    virtual Mp7JrsAudioSummaryComponentType_Title_CollectionPtr GetTitle() const = 0;

    /**
     * Set Title element.
     * @param item const Mp7JrsAudioSummaryComponentType_Title_CollectionPtr &
     */
    virtual void SetTitle(const Mp7JrsAudioSummaryComponentType_Title_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioSourceID element.
     * @return Mp7JrsUniqueIDPtr
     */
    virtual Mp7JrsUniqueIDPtr GetAudioSourceID() const = 0;

    virtual bool IsValidAudioSourceID() const = 0;

    /**
     * Set AudioSourceID element.
     * @param item const Mp7JrsUniqueIDPtr &
     */
    virtual void SetAudioSourceID(const Mp7JrsUniqueIDPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate AudioSourceID element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioSourceID() = 0;

    /**
     * Get AudioSourceLocator element.
     * @return Mp7JrsTemporalSegmentLocatorPtr
     */
    virtual Mp7JrsTemporalSegmentLocatorPtr GetAudioSourceLocator() const = 0;

    virtual bool IsValidAudioSourceLocator() const = 0;

    /**
     * Set AudioSourceLocator element.
     * @param item const Mp7JrsTemporalSegmentLocatorPtr &
     */
    virtual void SetAudioSourceLocator(const Mp7JrsTemporalSegmentLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate AudioSourceLocator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioSourceLocator() = 0;

    /**
     * Get ComponentSourceTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetComponentSourceTime() const = 0;

    virtual bool IsValidComponentSourceTime() const = 0;

    /**
     * Set ComponentSourceTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetComponentSourceTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ComponentSourceTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateComponentSourceTime() = 0;

    /**
     * Get SoundLocator element.
     * @return Mp7JrsTemporalSegmentLocatorPtr
     */
    virtual Mp7JrsTemporalSegmentLocatorPtr GetSoundLocator() const = 0;

    virtual bool IsValidSoundLocator() const = 0;

    /**
     * Set SoundLocator element.
     * @param item const Mp7JrsTemporalSegmentLocatorPtr &
     */
    virtual void SetSoundLocator(const Mp7JrsTemporalSegmentLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SoundLocator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSoundLocator() = 0;

    /**
     * Get SyncTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetSyncTime() const = 0;

    virtual bool IsValidSyncTime() const = 0;

    /**
     * Set SyncTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetSyncTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SyncTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSyncTime() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioSummaryComponentType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioSummaryComponentType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioSummaryComponentType<br>
 * Located at: mds-2001.xsd, line 4652<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 4652.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioSummaryComponentType :
        public IMp7JrsAudioSummaryComponentType
{
    friend class Mp7JrsAudioSummaryComponentTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAudioSummaryComponentType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Title element.
     * @return Mp7JrsAudioSummaryComponentType_Title_CollectionPtr
     */
    virtual Mp7JrsAudioSummaryComponentType_Title_CollectionPtr GetTitle() const;

    /*
     * Set Title element.
     * @param item const Mp7JrsAudioSummaryComponentType_Title_CollectionPtr &
     */
    virtual void SetTitle(const Mp7JrsAudioSummaryComponentType_Title_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioSourceID element.
     * @return Mp7JrsUniqueIDPtr
     */
    virtual Mp7JrsUniqueIDPtr GetAudioSourceID() const;

    virtual bool IsValidAudioSourceID() const;

    /*
     * Set AudioSourceID element.
     * @param item const Mp7JrsUniqueIDPtr &
     */
    virtual void SetAudioSourceID(const Mp7JrsUniqueIDPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate AudioSourceID element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioSourceID();

    /*
     * Get AudioSourceLocator element.
     * @return Mp7JrsTemporalSegmentLocatorPtr
     */
    virtual Mp7JrsTemporalSegmentLocatorPtr GetAudioSourceLocator() const;

    virtual bool IsValidAudioSourceLocator() const;

    /*
     * Set AudioSourceLocator element.
     * @param item const Mp7JrsTemporalSegmentLocatorPtr &
     */
    virtual void SetAudioSourceLocator(const Mp7JrsTemporalSegmentLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate AudioSourceLocator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioSourceLocator();

    /*
     * Get ComponentSourceTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetComponentSourceTime() const;

    virtual bool IsValidComponentSourceTime() const;

    /*
     * Set ComponentSourceTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetComponentSourceTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ComponentSourceTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateComponentSourceTime();

    /*
     * Get SoundLocator element.
     * @return Mp7JrsTemporalSegmentLocatorPtr
     */
    virtual Mp7JrsTemporalSegmentLocatorPtr GetSoundLocator() const;

    virtual bool IsValidSoundLocator() const;

    /*
     * Set SoundLocator element.
     * @param item const Mp7JrsTemporalSegmentLocatorPtr &
     */
    virtual void SetSoundLocator(const Mp7JrsTemporalSegmentLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SoundLocator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSoundLocator();

    /*
     * Get SyncTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetSyncTime() const;

    virtual bool IsValidSyncTime() const;

    /*
     * Set SyncTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetSyncTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SyncTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSyncTime();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioSummaryComponentType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioSummaryComponentType();

protected:
    Mp7JrsAudioSummaryComponentType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsAudioSummaryComponentType_Title_CollectionPtr m_Title;
    Mp7JrsUniqueIDPtr m_AudioSourceID;
    bool m_AudioSourceID_Exist; // For optional elements 
    Mp7JrsTemporalSegmentLocatorPtr m_AudioSourceLocator;
    bool m_AudioSourceLocator_Exist; // For optional elements 
    Mp7JrsMediaTimePtr m_ComponentSourceTime;
    bool m_ComponentSourceTime_Exist; // For optional elements 
    Mp7JrsTemporalSegmentLocatorPtr m_SoundLocator;
    bool m_SoundLocator_Exist; // For optional elements 
    Mp7JrsMediaTimePtr m_SyncTime;
    bool m_SyncTime_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsAudioSummaryComponentType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _151MP7JRSAUDIOSUMMARYCOMPONENTTYPE_H

