/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _161MP7JRSAUDIOVISUALREGIONMEDIASOURCEDECOMPOSITIONTYPE_LOCALTYPE_H
#define _161MP7JRSAUDIOVISUALREGIONMEDIASOURCEDECOMPOSITIONTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtInclude.h


class IMp7JrsAudioSegmentType;
class IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType;
class IMp7JrsAudioVisualRegionType;
class IMp7JrsMovingRegionType;
class IMp7JrsReferenceType;
class IMp7JrsStillRegionType;
class IMp7JrsVideoSegmentType;
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType > Mp7JrsAudioSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType> Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionType > Mp7JrsAudioVisualRegionPtr;
typedef Mp7JrsPtr< IMp7JrsMovingRegionType > Mp7JrsMovingRegionPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsStillRegionType > Mp7JrsStillRegionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType > Mp7JrsVideoSegmentPtr;

/** 
 * Generated interface IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType for class Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType();
    virtual ~IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get AudioVisualRegion element.
     * @return Mp7JrsAudioVisualRegionPtr
     */
    virtual Mp7JrsAudioVisualRegionPtr GetAudioVisualRegion() const = 0;

    /**
     * Set AudioVisualRegion element.
     * @param item const Mp7JrsAudioVisualRegionPtr &
     */
    virtual void SetAudioVisualRegion(const Mp7JrsAudioVisualRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioVisualRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioVisualRegionRef() const = 0;

    /**
     * Set AudioVisualRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAudioVisualRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VideoSegment element.
     * @return Mp7JrsVideoSegmentPtr
     */
    virtual Mp7JrsVideoSegmentPtr GetVideoSegment() const = 0;

    /**
     * Set VideoSegment element.
     * @param item const Mp7JrsVideoSegmentPtr &
     */
    virtual void SetVideoSegment(const Mp7JrsVideoSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VideoSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetVideoSegmentRef() const = 0;

    /**
     * Set VideoSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetVideoSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MovingRegion element.
     * @return Mp7JrsMovingRegionPtr
     */
    virtual Mp7JrsMovingRegionPtr GetMovingRegion() const = 0;

    /**
     * Set MovingRegion element.
     * @param item const Mp7JrsMovingRegionPtr &
     */
    virtual void SetMovingRegion(const Mp7JrsMovingRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MovingRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMovingRegionRef() const = 0;

    /**
     * Set MovingRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get StillRegion element.
     * @return Mp7JrsStillRegionPtr
     */
    virtual Mp7JrsStillRegionPtr GetStillRegion() const = 0;

    /**
     * Set StillRegion element.
     * @param item const Mp7JrsStillRegionPtr &
     */
    virtual void SetStillRegion(const Mp7JrsStillRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get StillRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetStillRegionRef() const = 0;

    /**
     * Set StillRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetStillRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioSegment element.
     * @return Mp7JrsAudioSegmentPtr
     */
    virtual Mp7JrsAudioSegmentPtr GetAudioSegment() const = 0;

    /**
     * Set AudioSegment element.
     * @param item const Mp7JrsAudioSegmentPtr &
     */
    virtual void SetAudioSegment(const Mp7JrsAudioSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioSegmentRef() const = 0;

    /**
     * Set AudioSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAudioSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType<br>
 * Defined in mds-2001.xsd, line 3666.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType :
        public IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType
{
    friend class Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get AudioVisualRegion element.
     * @return Mp7JrsAudioVisualRegionPtr
     */
    virtual Mp7JrsAudioVisualRegionPtr GetAudioVisualRegion() const;

    /*
     * Set AudioVisualRegion element.
     * @param item const Mp7JrsAudioVisualRegionPtr &
     */
    virtual void SetAudioVisualRegion(const Mp7JrsAudioVisualRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioVisualRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioVisualRegionRef() const;

    /*
     * Set AudioVisualRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAudioVisualRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VideoSegment element.
     * @return Mp7JrsVideoSegmentPtr
     */
    virtual Mp7JrsVideoSegmentPtr GetVideoSegment() const;

    /*
     * Set VideoSegment element.
     * @param item const Mp7JrsVideoSegmentPtr &
     */
    virtual void SetVideoSegment(const Mp7JrsVideoSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VideoSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetVideoSegmentRef() const;

    /*
     * Set VideoSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetVideoSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MovingRegion element.
     * @return Mp7JrsMovingRegionPtr
     */
    virtual Mp7JrsMovingRegionPtr GetMovingRegion() const;

    /*
     * Set MovingRegion element.
     * @param item const Mp7JrsMovingRegionPtr &
     */
    virtual void SetMovingRegion(const Mp7JrsMovingRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MovingRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMovingRegionRef() const;

    /*
     * Set MovingRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get StillRegion element.
     * @return Mp7JrsStillRegionPtr
     */
    virtual Mp7JrsStillRegionPtr GetStillRegion() const;

    /*
     * Set StillRegion element.
     * @param item const Mp7JrsStillRegionPtr &
     */
    virtual void SetStillRegion(const Mp7JrsStillRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get StillRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetStillRegionRef() const;

    /*
     * Set StillRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetStillRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioSegment element.
     * @return Mp7JrsAudioSegmentPtr
     */
    virtual Mp7JrsAudioSegmentPtr GetAudioSegment() const;

    /*
     * Set AudioSegment element.
     * @param item const Mp7JrsAudioSegmentPtr &
     */
    virtual void SetAudioSegment(const Mp7JrsAudioSegmentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAudioSegmentRef() const;

    /*
     * Set AudioSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAudioSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType();

protected:
    Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsAudioVisualRegionPtr m_AudioVisualRegion;
    Mp7JrsReferencePtr m_AudioVisualRegionRef;
    Mp7JrsVideoSegmentPtr m_VideoSegment;
    Mp7JrsReferencePtr m_VideoSegmentRef;
    Mp7JrsMovingRegionPtr m_MovingRegion;
    Mp7JrsReferencePtr m_MovingRegionRef;
    Mp7JrsStillRegionPtr m_StillRegion;
    Mp7JrsReferencePtr m_StillRegionRef;
    Mp7JrsAudioSegmentPtr m_AudioSegment;
    Mp7JrsReferencePtr m_AudioSegmentRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _161MP7JRSAUDIOVISUALREGIONMEDIASOURCEDECOMPOSITIONTYPE_LOCALTYPE_H

