/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _185MP7JRSAUDIOVISUALREGIONTYPE_LOCALTYPE_H
#define _185MP7JRSAUDIOVISUALREGIONTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioVisualRegionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionType_LocalType_ExtInclude.h


class IMp7JrsAudioVisualRegionMediaSourceDecompositionType;
class IMp7JrsAudioVisualRegionSpatialDecompositionType;
class IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType;
class IMp7JrsAudioVisualRegionTemporalDecompositionType;
class IMp7JrsAudioVisualRegionType_LocalType;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionMediaSourceDecompositionType > Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatialDecompositionType > Mp7JrsAudioVisualRegionSpatialDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType > Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionTemporalDecompositionType > Mp7JrsAudioVisualRegionTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionType_LocalType> Mp7JrsAudioVisualRegionType_LocalPtr;

/** 
 * Generated interface IMp7JrsAudioVisualRegionType_LocalType for class Mp7JrsAudioVisualRegionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioVisualRegionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAudioVisualRegionType_LocalType();
    virtual ~IMp7JrsAudioVisualRegionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get SpatialDecomposition element.
     * @return Mp7JrsAudioVisualRegionSpatialDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionSpatialDecompositionPtr GetSpatialDecomposition() const = 0;

    /**
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsAudioVisualRegionSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TemporalDecomposition element.
     * @return Mp7JrsAudioVisualRegionTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionTemporalDecompositionPtr GetTemporalDecomposition() const = 0;

    /**
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsAudioVisualRegionTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const = 0;

    /**
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr GetMediaSourceDecomposition() const = 0;

    /**
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioVisualRegionType_LocalType<br>
 * Defined in mds-2001.xsd, line 3616.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioVisualRegionType_LocalType :
        public IMp7JrsAudioVisualRegionType_LocalType
{
    friend class Mp7JrsAudioVisualRegionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get SpatialDecomposition element.
     * @return Mp7JrsAudioVisualRegionSpatialDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionSpatialDecompositionPtr GetSpatialDecomposition() const;

    /*
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsAudioVisualRegionSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TemporalDecomposition element.
     * @return Mp7JrsAudioVisualRegionTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionTemporalDecompositionPtr GetTemporalDecomposition() const;

    /*
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsAudioVisualRegionTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const;

    /*
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr
     */
    virtual Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr GetMediaSourceDecomposition() const;

    /*
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioVisualRegionType_LocalType();

protected:
    Mp7JrsAudioVisualRegionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsAudioVisualRegionSpatialDecompositionPtr m_SpatialDecomposition;
    Mp7JrsAudioVisualRegionTemporalDecompositionPtr m_TemporalDecomposition;
    Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr m_SpatioTemporalDecomposition;
    Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr m_MediaSourceDecomposition;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAudioVisualRegionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _185MP7JRSAUDIOVISUALREGIONTYPE_LOCALTYPE_H

