/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _233MP7JRSAVAILABILITYTYPE_AVAILABILITYPERIOD_LOCALTYPE_H
#define _233MP7JRSAVAILABILITYTYPE_AVAILABILITYPERIOD_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtInclude.h


#include "Mp7JrsTimeType.h"
class IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType;
class IMp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsIncrDurationType;
class IMp7JrsRelIncrTimePointType;
class IMp7JrsRelTimePointType;
class IMp7JrstimePointType;
class IMp7JrsTimeType;
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType> Mp7JrsAvailabilityType_AvailabilityPeriod_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType > Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsIncrDurationType > Mp7JrsIncrDurationPtr;
typedef Mp7JrsPtr< IMp7JrsRelIncrTimePointType > Mp7JrsRelIncrTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsRelTimePointType > Mp7JrsRelTimePointPtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;
typedef Mp7JrsPtr< IMp7JrsTimeType > Mp7JrsTimePtr;

/** 
 * Generated interface IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType for class Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType<br>
 * Located at: mds-2001.xsd, line 2793<br>
 * Classified: Class<br>
 * Derived from: TimeType (Class)<br>
 * Derived from: TimeType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType 
 :
        public IMp7JrsTimeType
{
public:
    // TODO: make these protected?
    IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType();
    virtual ~IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType();
    /**
     * Get type attribute.
     * @return Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr
     */
    virtual Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
     * @param item const Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr &
     */
    virtual void Settype(const Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get TimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetTimePoint() const = 0;

    /**
     * Set TimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetTimePoint(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RelTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsRelTimePointPtr
     */
    virtual Mp7JrsRelTimePointPtr GetRelTimePoint() const = 0;

    /**
     * Set RelTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsRelTimePointPtr &
     */
    virtual void SetRelTimePoint(const Mp7JrsRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RelIncrTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsRelIncrTimePointPtr
     */
    virtual Mp7JrsRelIncrTimePointPtr GetRelIncrTimePoint() const = 0;

    /**
     * Set RelIncrTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsRelIncrTimePointPtr &
     */
    virtual void SetRelIncrTimePoint(const Mp7JrsRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get Duration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GetDuration() const = 0;

    /**
     * Set Duration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SetDuration(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get IncrDuration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsIncrDurationPtr
     */
    virtual Mp7JrsIncrDurationPtr GetIncrDuration() const = 0;

    /**
     * Set IncrDuration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsIncrDurationPtr &
     */
    virtual void SetIncrDuration(const Mp7JrsIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType<br>
 * Located at: mds-2001.xsd, line 2793<br>
 * Classified: Class<br>
 * Derived from: TimeType (Class)<br>
 * Derived from: TimeType (Class)<br>
 * Defined in mds-2001.xsd, line 2793.<br>
 */
class MP7JRS_EXPORT Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType :
        public IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType
{
    friend class Mp7JrsAvailabilityType_AvailabilityPeriod_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsTimeType >
     */
    virtual Mp7JrsPtr< Mp7JrsTimeType > GetBase() const;
    /*
     * Get type attribute.
     * @return Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr
     */
    virtual Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr Gettype() const;

    /*
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
     * @param item const Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr &
     */
    virtual void Settype(const Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get TimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetTimePoint() const;

    /*
     * Set TimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetTimePoint(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RelTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsRelTimePointPtr
     */
    virtual Mp7JrsRelTimePointPtr GetRelTimePoint() const;

    /*
     * Set RelTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsRelTimePointPtr &
     */
    virtual void SetRelTimePoint(const Mp7JrsRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RelIncrTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsRelIncrTimePointPtr
     */
    virtual Mp7JrsRelIncrTimePointPtr GetRelIncrTimePoint() const;

    /*
     * Set RelIncrTimePoint element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsRelIncrTimePointPtr &
     */
    virtual void SetRelIncrTimePoint(const Mp7JrsRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get Duration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GetDuration() const;

    /*
     * Set Duration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SetDuration(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get IncrDuration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @return Mp7JrsIncrDurationPtr
     */
    virtual Mp7JrsIncrDurationPtr GetIncrDuration() const;

    /*
     * Set IncrDuration element.
<br>
     * (Inherited from Mp7JrsTimeType)
     * @param item const Mp7JrsIncrDurationPtr &
     */
    virtual void SetIncrDuration(const Mp7JrsIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType();

protected:
    Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr m_type;
    bool m_type_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsTimeType > m_Base;


// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _233MP7JRSAVAILABILITYTYPE_AVAILABILITYPERIOD_LOCALTYPE_H

