/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _259MP7JRSBROWSINGPREFERENCESTYPE_PREFERENCECONDITION_LOCALTYPE_H
#define _259MP7JRSBROWSINGPREFERENCESTYPE_PREFERENCECONDITION_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsPreferenceConditionType.h"
class IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType;
class IMp7JrsPlaceType;
class IMp7JrsPreferenceConditionType;
class IMp7JrsPreferenceConditionType_Time_CollectionType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType> Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType > Mp7JrsPreferenceConditionPtr;
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_CollectionType > Mp7JrsPreferenceConditionType_Time_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType for class Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType<br>
 * Located at: mds-2001.xsd, line 6186<br>
 * Classified: Class<br>
 * Derived from: PreferenceConditionType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType 
 :
        public IMp7JrsPreferenceConditionType
{
public:
    // TODO: make these protected?
    IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType();
    virtual ~IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Genre element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetGenre() const = 0;

    virtual bool IsValidGenre() const = 0;

    /**
     * Set Genre element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetGenre(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Genre element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGenre() = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get Place element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetPlace() const = 0;

    virtual bool IsValidPlace() const = 0;

    /**
     * Set Place element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetPlace(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Place element.
     * (Inherited from Mp7JrsPreferenceConditionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePlace() = 0;

    /**
     * Get Time element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @return Mp7JrsPreferenceConditionType_Time_CollectionPtr
     */
    virtual Mp7JrsPreferenceConditionType_Time_CollectionPtr GetTime() const = 0;

    /**
     * Set Time element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @param item const Mp7JrsPreferenceConditionType_Time_CollectionPtr &
     */
    virtual void SetTime(const Mp7JrsPreferenceConditionType_Time_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType<br>
 * Located at: mds-2001.xsd, line 6186<br>
 * Classified: Class<br>
 * Derived from: PreferenceConditionType (Class)<br>
 * Defined in mds-2001.xsd, line 6186.<br>
 */
class MP7JRS_EXPORT Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType :
        public IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType
{
    friend class Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsPreferenceConditionType >
     */
    virtual Mp7JrsPtr< Mp7JrsPreferenceConditionType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Genre element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetGenre() const;

    virtual bool IsValidGenre() const;

    /*
     * Set Genre element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetGenre(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Genre element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGenre();

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get Place element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetPlace() const;

    virtual bool IsValidPlace() const;

    /*
     * Set Place element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetPlace(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Place element.
     * (Inherited from Mp7JrsPreferenceConditionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePlace();

    /*
     * Get Time element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @return Mp7JrsPreferenceConditionType_Time_CollectionPtr
     */
    virtual Mp7JrsPreferenceConditionType_Time_CollectionPtr GetTime() const;

    /*
     * Set Time element.
<br>
     * (Inherited from Mp7JrsPreferenceConditionType)
     * @param item const Mp7JrsPreferenceConditionType_Time_CollectionPtr &
     */
    virtual void SetTime(const Mp7JrsPreferenceConditionType_Time_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType();

protected:
    Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsPreferenceConditionType > m_Base;

    Mp7JrsTermUsePtr m_Genre;
    bool m_Genre_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _259MP7JRSBROWSINGPREFERENCESTYPE_PREFERENCECONDITION_LOCALTYPE_H

