/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _265MP7JRSCAMERAMOTIONTYPE_H
#define _265MP7JRSCAMERAMOTIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCameraMotionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCameraMotionType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsCameraMotionType;
class IMp7JrsCameraMotionType_Segment_CollectionType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsCameraMotionType_Segment_CollectionType > Mp7JrsCameraMotionType_Segment_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCameraMotionType> Mp7JrsCameraMotionPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsCameraMotionType for class Mp7JrsCameraMotionType<br>
 * Located at: visual-2001.xsd, line 830<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsCameraMotionType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsCameraMotionType();
    virtual ~IMp7JrsCameraMotionType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Segment element.
     * @return Mp7JrsCameraMotionType_Segment_CollectionPtr
     */
    virtual Mp7JrsCameraMotionType_Segment_CollectionPtr GetSegment() const = 0;

    /**
     * Set Segment element.
     * @param item const Mp7JrsCameraMotionType_Segment_CollectionPtr &
     */
    virtual void SetSegment(const Mp7JrsCameraMotionType_Segment_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsCameraMotionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCameraMotionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCameraMotionType<br>
 * Located at: visual-2001.xsd, line 830<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 830.<br>
 */
class MP7JRS_EXPORT Mp7JrsCameraMotionType :
        public IMp7JrsCameraMotionType
{
    friend class Mp7JrsCameraMotionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsCameraMotionType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Segment element.
     * @return Mp7JrsCameraMotionType_Segment_CollectionPtr
     */
    virtual Mp7JrsCameraMotionType_Segment_CollectionPtr GetSegment() const;

    /*
     * Set Segment element.
     * @param item const Mp7JrsCameraMotionType_Segment_CollectionPtr &
     */
    virtual void SetSegment(const Mp7JrsCameraMotionType_Segment_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCameraMotionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCameraMotionType();

protected:
    Mp7JrsCameraMotionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsCameraMotionType_Segment_CollectionPtr m_Segment;

// no includefile for extension defined 
// file Mp7JrsCameraMotionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _265MP7JRSCAMERAMOTIONTYPE_H

