/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _273MP7JRSCLASSIFICATIONPREFERENCESTYPE_H
#define _273MP7JRSCLASSIFICATIONPREFERENCESTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationPreferencesTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsClassificationPreferencesType;
class IMp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType;
class IMp7JrsClassificationPreferencesType_Country_CollectionType;
class IMp7JrsClassificationPreferencesType_DatePeriod_CollectionType;
class IMp7JrsClassificationPreferencesType_Form_CollectionType;
class IMp7JrsClassificationPreferencesType_Genre_CollectionType;
class IMp7JrsClassificationPreferencesType_Language_CollectionType;
class IMp7JrsClassificationPreferencesType_LanguageFormat_CollectionType;
class IMp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType;
class IMp7JrsClassificationPreferencesType_Review_CollectionType;
class IMp7JrsClassificationPreferencesType_Subject_CollectionType;
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrspreferenceValueType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType > Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Country_CollectionType > Mp7JrsClassificationPreferencesType_Country_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_DatePeriod_CollectionType > Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Form_CollectionType > Mp7JrsClassificationPreferencesType_Form_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Genre_CollectionType > Mp7JrsClassificationPreferencesType_Genre_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Language_CollectionType > Mp7JrsClassificationPreferencesType_Language_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_LanguageFormat_CollectionType > Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType > Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Review_CollectionType > Mp7JrsClassificationPreferencesType_Review_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Subject_CollectionType > Mp7JrsClassificationPreferencesType_Subject_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType> Mp7JrsClassificationPreferencesPtr;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsClassificationPreferencesType for class Mp7JrsClassificationPreferencesType<br>
 * Located at: mds-2001.xsd, line 5982<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationPreferencesType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationPreferencesType();
    virtual ~IMp7JrsClassificationPreferencesType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Country element.
     * @return Mp7JrsClassificationPreferencesType_Country_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Country_CollectionPtr GetCountry() const = 0;

    /**
     * Set Country element.
     * @param item const Mp7JrsClassificationPreferencesType_Country_CollectionPtr &
     */
    virtual void SetCountry(const Mp7JrsClassificationPreferencesType_Country_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DatePeriod element.
     * @return Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr GetDatePeriod() const = 0;

    /**
     * Set DatePeriod element.
     * @param item const Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr &
     */
    virtual void SetDatePeriod(const Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get LanguageFormat element.
     * @return Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr GetLanguageFormat() const = 0;

    /**
     * Set LanguageFormat element.
     * @param item const Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr &
     */
    virtual void SetLanguageFormat(const Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Language element.
     * @return Mp7JrsClassificationPreferencesType_Language_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Language_CollectionPtr GetLanguage() const = 0;

    /**
     * Set Language element.
     * @param item const Mp7JrsClassificationPreferencesType_Language_CollectionPtr &
     */
    virtual void SetLanguage(const Mp7JrsClassificationPreferencesType_Language_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CaptionLanguage element.
     * @return Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr GetCaptionLanguage() const = 0;

    /**
     * Set CaptionLanguage element.
     * @param item const Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr &
     */
    virtual void SetCaptionLanguage(const Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Form element.
     * @return Mp7JrsClassificationPreferencesType_Form_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Form_CollectionPtr GetForm() const = 0;

    /**
     * Set Form element.
     * @param item const Mp7JrsClassificationPreferencesType_Form_CollectionPtr &
     */
    virtual void SetForm(const Mp7JrsClassificationPreferencesType_Form_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Genre element.
     * @return Mp7JrsClassificationPreferencesType_Genre_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Genre_CollectionPtr GetGenre() const = 0;

    /**
     * Set Genre element.
     * @param item const Mp7JrsClassificationPreferencesType_Genre_CollectionPtr &
     */
    virtual void SetGenre(const Mp7JrsClassificationPreferencesType_Genre_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Subject element.
     * @return Mp7JrsClassificationPreferencesType_Subject_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Subject_CollectionPtr GetSubject() const = 0;

    /**
     * Set Subject element.
     * @param item const Mp7JrsClassificationPreferencesType_Subject_CollectionPtr &
     */
    virtual void SetSubject(const Mp7JrsClassificationPreferencesType_Subject_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Review element.
     * @return Mp7JrsClassificationPreferencesType_Review_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Review_CollectionPtr GetReview() const = 0;

    /**
     * Set Review element.
     * @param item const Mp7JrsClassificationPreferencesType_Review_CollectionPtr &
     */
    virtual void SetReview(const Mp7JrsClassificationPreferencesType_Review_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ParentalGuidance element.
     * @return Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr GetParentalGuidance() const = 0;

    /**
     * Set ParentalGuidance element.
     * @param item const Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr &
     */
    virtual void SetParentalGuidance(const Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationPreferencesType<br>
 * Located at: mds-2001.xsd, line 5982<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 5982.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationPreferencesType :
        public IMp7JrsClassificationPreferencesType
{
    friend class Mp7JrsClassificationPreferencesTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsClassificationPreferencesType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
    /*
     * Get Country element.
     * @return Mp7JrsClassificationPreferencesType_Country_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Country_CollectionPtr GetCountry() const;

    /*
     * Set Country element.
     * @param item const Mp7JrsClassificationPreferencesType_Country_CollectionPtr &
     */
    virtual void SetCountry(const Mp7JrsClassificationPreferencesType_Country_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DatePeriod element.
     * @return Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr GetDatePeriod() const;

    /*
     * Set DatePeriod element.
     * @param item const Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr &
     */
    virtual void SetDatePeriod(const Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get LanguageFormat element.
     * @return Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr GetLanguageFormat() const;

    /*
     * Set LanguageFormat element.
     * @param item const Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr &
     */
    virtual void SetLanguageFormat(const Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Language element.
     * @return Mp7JrsClassificationPreferencesType_Language_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Language_CollectionPtr GetLanguage() const;

    /*
     * Set Language element.
     * @param item const Mp7JrsClassificationPreferencesType_Language_CollectionPtr &
     */
    virtual void SetLanguage(const Mp7JrsClassificationPreferencesType_Language_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CaptionLanguage element.
     * @return Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr GetCaptionLanguage() const;

    /*
     * Set CaptionLanguage element.
     * @param item const Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr &
     */
    virtual void SetCaptionLanguage(const Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Form element.
     * @return Mp7JrsClassificationPreferencesType_Form_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Form_CollectionPtr GetForm() const;

    /*
     * Set Form element.
     * @param item const Mp7JrsClassificationPreferencesType_Form_CollectionPtr &
     */
    virtual void SetForm(const Mp7JrsClassificationPreferencesType_Form_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Genre element.
     * @return Mp7JrsClassificationPreferencesType_Genre_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Genre_CollectionPtr GetGenre() const;

    /*
     * Set Genre element.
     * @param item const Mp7JrsClassificationPreferencesType_Genre_CollectionPtr &
     */
    virtual void SetGenre(const Mp7JrsClassificationPreferencesType_Genre_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Subject element.
     * @return Mp7JrsClassificationPreferencesType_Subject_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Subject_CollectionPtr GetSubject() const;

    /*
     * Set Subject element.
     * @param item const Mp7JrsClassificationPreferencesType_Subject_CollectionPtr &
     */
    virtual void SetSubject(const Mp7JrsClassificationPreferencesType_Subject_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Review element.
     * @return Mp7JrsClassificationPreferencesType_Review_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_Review_CollectionPtr GetReview() const;

    /*
     * Set Review element.
     * @param item const Mp7JrsClassificationPreferencesType_Review_CollectionPtr &
     */
    virtual void SetReview(const Mp7JrsClassificationPreferencesType_Review_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ParentalGuidance element.
     * @return Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr
     */
    virtual Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr GetParentalGuidance() const;

    /*
     * Set ParentalGuidance element.
     * @param item const Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr &
     */
    virtual void SetParentalGuidance(const Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationPreferencesType();

protected:
    Mp7JrsClassificationPreferencesType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsClassificationPreferencesType_Country_CollectionPtr m_Country;
    Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr m_DatePeriod;
    Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr m_LanguageFormat;
    Mp7JrsClassificationPreferencesType_Language_CollectionPtr m_Language;
    Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr m_CaptionLanguage;
    Mp7JrsClassificationPreferencesType_Form_CollectionPtr m_Form;
    Mp7JrsClassificationPreferencesType_Genre_CollectionPtr m_Genre;
    Mp7JrsClassificationPreferencesType_Subject_CollectionPtr m_Subject;
    Mp7JrsClassificationPreferencesType_Review_CollectionPtr m_Review;
    Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr m_ParentalGuidance;

// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _273MP7JRSCLASSIFICATIONPREFERENCESTYPE_H

