/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _277MP7JRSCLASSIFICATIONPREFERENCESTYPE_CAPTIONLANGUAGE_LOCALTYPE_H
#define _277MP7JRSCLASSIFICATIONPREFERENCESTYPE_CAPTIONLANGUAGE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType_ExtInclude.h


class IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType;
class IMp7JrspreferenceValueType;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType> Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;

/** 
 * Generated interface IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType for class Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType<br>
 * Located at: mds-2001.xsd, line 6023<br>
 * Classified: Class<br>
 * Derived from: language (String)<br>
 * Derived from: language (String)<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType();
    virtual ~IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType();
    /**
     * Sets the content of Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType 
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const = 0;

    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType<br>
 * Located at: mds-2001.xsd, line 6023<br>
 * Classified: Class<br>
 * Derived from: language (String)<br>
 * Derived from: language (String)<br>
 * Defined in mds-2001.xsd, line 6023.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType :
        public IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType
{
    friend class Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalTypeFactory; // constructs objects

public:
    /*
     * Sets the content of Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType 
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const;

    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType();

protected:
    Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base String
    XMLCh * m_Base;


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _277MP7JRSCLASSIFICATIONPREFERENCESTYPE_CAPTIONLANGUAGE_LOCALTYPE_H

