/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _301MP7JRSCLASSIFICATIONPREFERENCESTYPE_LANGUAGEFORMAT_LOCALTYPE_H
#define _301MP7JRSCLASSIFICATIONPREFERENCESTYPE_LANGUAGEFORMAT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType_ExtInclude.h


#include "Mp7JrsauxiliaryLanguageType.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType.h"
class IMp7JrsauxiliaryLanguageType;
class IMp7JrsauxiliaryLanguageType_LocalType0;
class IMp7JrsauxiliaryLanguageType_LocalType1;
class IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType;
class IMp7JrspreferenceValueType;
typedef Mp7JrsPtr< IMp7JrsauxiliaryLanguageType > Mp7JrsauxiliaryLanguagePtr;
typedef Mp7JrsPtr< IMp7JrsauxiliaryLanguageType_LocalType0 > Mp7JrsauxiliaryLanguageType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsauxiliaryLanguageType_LocalType1 > Mp7JrsauxiliaryLanguageType_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType> Mp7JrsClassificationPreferencesType_LanguageFormat_LocalPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;

/** 
 * Generated interface IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType for class Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType<br>
 * Located at: mds-2001.xsd, line 6005<br>
 * Classified: Class<br>
 * Derived from: auxiliaryLanguageType (Class)<br>
 * Derived from: auxiliaryLanguageType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType 
 :
        public IMp7JrsauxiliaryLanguageType
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType();
    virtual ~IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

    /** @name Union

     */
    //@{
    /**
     * Get Mp7JrsauxiliaryLanguageType_LocalType element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @return Mp7JrsauxiliaryLanguageType_LocalType::Enumeration
     */
    virtual Mp7JrsauxiliaryLanguageType_LocalType::Enumeration GetauxiliaryLanguageType_LocalType() const = 0;

    /**
     * Set Mp7JrsauxiliaryLanguageType_LocalType element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @param item Mp7JrsauxiliaryLanguageType_LocalType::Enumeration
     */
    virtual void SetauxiliaryLanguageType_LocalType(Mp7JrsauxiliaryLanguageType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrsauxiliaryLanguageType_LocalType0 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @return Mp7JrsauxiliaryLanguageType_Local0Ptr
     */
    virtual Mp7JrsauxiliaryLanguageType_Local0Ptr GetauxiliaryLanguageType_LocalType0() const = 0;

    /**
     * Set Mp7JrsauxiliaryLanguageType_LocalType0 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @param item const Mp7JrsauxiliaryLanguageType_Local0Ptr &
     */
    virtual void SetauxiliaryLanguageType_LocalType0(const Mp7JrsauxiliaryLanguageType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrsauxiliaryLanguageType_LocalType1 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @return Mp7JrsauxiliaryLanguageType_Local1Ptr
     */
    virtual Mp7JrsauxiliaryLanguageType_Local1Ptr GetauxiliaryLanguageType_LocalType1() const = 0;

    /**
     * Set Mp7JrsauxiliaryLanguageType_LocalType1 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @param item const Mp7JrsauxiliaryLanguageType_Local1Ptr &
     */
    virtual void SetauxiliaryLanguageType_LocalType1(const Mp7JrsauxiliaryLanguageType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    //@}
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType<br>
 * Located at: mds-2001.xsd, line 6005<br>
 * Classified: Class<br>
 * Derived from: auxiliaryLanguageType (Class)<br>
 * Derived from: auxiliaryLanguageType (Class)<br>
 * Defined in mds-2001.xsd, line 6005.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType :
        public IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType
{
    friend class Mp7JrsClassificationPreferencesType_LanguageFormat_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsauxiliaryLanguageType >
     */
    virtual Mp7JrsPtr< Mp7JrsauxiliaryLanguageType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

    /* @name Union

     */
    //@{
    /*
     * Get Mp7JrsauxiliaryLanguageType_LocalType element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @return Mp7JrsauxiliaryLanguageType_LocalType::Enumeration
     */
    virtual Mp7JrsauxiliaryLanguageType_LocalType::Enumeration GetauxiliaryLanguageType_LocalType() const;

    /*
     * Set Mp7JrsauxiliaryLanguageType_LocalType element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @param item Mp7JrsauxiliaryLanguageType_LocalType::Enumeration
     */
    virtual void SetauxiliaryLanguageType_LocalType(Mp7JrsauxiliaryLanguageType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrsauxiliaryLanguageType_LocalType0 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @return Mp7JrsauxiliaryLanguageType_Local0Ptr
     */
    virtual Mp7JrsauxiliaryLanguageType_Local0Ptr GetauxiliaryLanguageType_LocalType0() const;

    /*
     * Set Mp7JrsauxiliaryLanguageType_LocalType0 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @param item const Mp7JrsauxiliaryLanguageType_Local0Ptr &
     */
    virtual void SetauxiliaryLanguageType_LocalType0(const Mp7JrsauxiliaryLanguageType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrsauxiliaryLanguageType_LocalType1 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @return Mp7JrsauxiliaryLanguageType_Local1Ptr
     */
    virtual Mp7JrsauxiliaryLanguageType_Local1Ptr GetauxiliaryLanguageType_LocalType1() const;

    /*
     * Set Mp7JrsauxiliaryLanguageType_LocalType1 element.
<br>
     * (Inherited from Mp7JrsauxiliaryLanguageType)
     * @param item const Mp7JrsauxiliaryLanguageType_Local1Ptr &
     */
    virtual void SetauxiliaryLanguageType_LocalType1(const Mp7JrsauxiliaryLanguageType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType();

protected:
    Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsauxiliaryLanguageType > m_Base;


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _301MP7JRSCLASSIFICATIONPREFERENCESTYPE_LANGUAGEFORMAT_LOCALTYPE_H

