/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _305MP7JRSCLASSIFICATIONPREFERENCESTYPE_PARENTALGUIDANCE_LOCALTYPE_H
#define _305MP7JRSCLASSIFICATIONPREFERENCESTYPE_PARENTALGUIDANCE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType_ExtInclude.h


#include "Mp7JrsParentalGuidanceType.h"
class IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType;
class IMp7JrsControlledTermUseType;
class IMp7JrsParentalGuidanceType;
class IMp7JrsParentalGuidanceType_Region_CollectionType;
class IMp7JrspreferenceValueType;
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType> Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsParentalGuidanceType > Mp7JrsParentalGuidancePtr;
typedef Mp7JrsPtr< IMp7JrsParentalGuidanceType_Region_CollectionType > Mp7JrsParentalGuidanceType_Region_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;

/** 
 * Generated interface IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType for class Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType<br>
 * Located at: mds-2001.xsd, line 6068<br>
 * Classified: Class<br>
 * Derived from: ParentalGuidanceType (Class)<br>
 * Derived from: ParentalGuidanceType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType 
 :
        public IMp7JrsParentalGuidanceType
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType();
    virtual ~IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get ParentalRating element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetParentalRating() const = 0;

    /**
     * Set ParentalRating element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetParentalRating(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MinimumAge element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @return unsigned
     */
    virtual unsigned GetMinimumAge() const = 0;

    /**
     * Set MinimumAge element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @param item unsigned
     */
    virtual void SetMinimumAge(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get Region element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @return Mp7JrsParentalGuidanceType_Region_CollectionPtr
     */
    virtual Mp7JrsParentalGuidanceType_Region_CollectionPtr GetRegion() const = 0;

    /**
     * Set Region element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @param item const Mp7JrsParentalGuidanceType_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsParentalGuidanceType_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType<br>
 * Located at: mds-2001.xsd, line 6068<br>
 * Classified: Class<br>
 * Derived from: ParentalGuidanceType (Class)<br>
 * Derived from: ParentalGuidanceType (Class)<br>
 * Defined in mds-2001.xsd, line 6068.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType :
        public IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType
{
    friend class Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsParentalGuidanceType >
     */
    virtual Mp7JrsPtr< Mp7JrsParentalGuidanceType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get ParentalRating element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetParentalRating() const;

    /*
     * Set ParentalRating element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetParentalRating(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MinimumAge element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @return unsigned
     */
    virtual unsigned GetMinimumAge() const;

    /*
     * Set MinimumAge element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @param item unsigned
     */
    virtual void SetMinimumAge(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get Region element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @return Mp7JrsParentalGuidanceType_Region_CollectionPtr
     */
    virtual Mp7JrsParentalGuidanceType_Region_CollectionPtr GetRegion() const;

    /*
     * Set Region element.
<br>
     * (Inherited from Mp7JrsParentalGuidanceType)
     * @param item const Mp7JrsParentalGuidanceType_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsParentalGuidanceType_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType();

protected:
    Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsParentalGuidanceType > m_Base;


// no includefile for extension defined 
// file Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _305MP7JRSCLASSIFICATIONPREFERENCESTYPE_PARENTALGUIDANCE_LOCALTYPE_H

