/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _323MP7JRSCLASSIFICATIONSCHEMEDESCRIPTIONTYPE_H
#define _323MP7JRSCLASSIFICATIONSCHEMEDESCRIPTIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationSchemeDescriptionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtInclude.h


#include "Mp7JrsCompleteDescriptionType.h"
#include "Mp7JrsContentManagementType.h"
class IMp7JrsClassificationSchemeDescriptionType;
class IMp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType;
class IMp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType;
class IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType;
class IMp7JrsCompleteDescriptionType_Relationships_CollectionType;
class IMp7JrsContentManagementType;
class IMp7JrsDescriptionMetadataType;
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType > Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType > Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeDescriptionType> Mp7JrsClassificationSchemeDescriptionPtr;
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType > Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType_Relationships_CollectionType > Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsContentManagementType > Mp7JrsContentManagementPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType > Mp7JrsDescriptionMetadataPtr;

/** 
 * Generated interface IMp7JrsClassificationSchemeDescriptionType for class Mp7JrsClassificationSchemeDescriptionType<br>
 * Located at: mds-2001.xsd, line 279<br>
 * Classified: Class<br>
 * Derived from: ContentManagementType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationSchemeDescriptionType 
 :
        public IMp7JrsContentManagementType
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationSchemeDescriptionType();
    virtual ~IMp7JrsClassificationSchemeDescriptionType();
        /** @name Choice

         */
        //@{
    /**
     * Get ClassificationScheme element.
     * @return Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr GetClassificationScheme() const = 0;

    /**
     * Set ClassificationScheme element.
     * @param item const Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr &
     */
    virtual void SetClassificationScheme(const Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ClassificationSchemeBase element.
     * @return Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr GetClassificationSchemeBase() const = 0;

    /**
     * Set ClassificationSchemeBase element.
     * @param item const Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr &
     */
    virtual void SetClassificationSchemeBase(const Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsDescriptionMetadataPtr
     */
    virtual Mp7JrsDescriptionMetadataPtr GetDescriptionMetadata() const = 0;

    virtual bool IsValidDescriptionMetadata() const = 0;

    /**
     * Set DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsDescriptionMetadataPtr &
     */
    virtual void SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DescriptionMetadata element.
     * (Inherited from Mp7JrsCompleteDescriptionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDescriptionMetadata() = 0;

    /**
     * Get Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr GetRelationships() const = 0;

    /**
     * Set Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr &
     */
    virtual void SetRelationships(const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr GetOrderingKey() const = 0;

    /**
     * Set OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr &
     */
    virtual void SetOrderingKey(const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationSchemeDescriptionType<br>
 * Located at: mds-2001.xsd, line 279<br>
 * Classified: Class<br>
 * Derived from: ContentManagementType (Class)<br>
 * Defined in mds-2001.xsd, line 279.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationSchemeDescriptionType :
        public IMp7JrsClassificationSchemeDescriptionType
{
    friend class Mp7JrsClassificationSchemeDescriptionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsClassificationSchemeDescriptionType
     
     * @return Mp7JrsPtr< Mp7JrsContentManagementType >
     */
    virtual Mp7JrsPtr< Mp7JrsContentManagementType > GetBase() const;
        /* @name Choice

         */
        //@{
    /*
     * Get ClassificationScheme element.
     * @return Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr GetClassificationScheme() const;

    /*
     * Set ClassificationScheme element.
     * @param item const Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr &
     */
    virtual void SetClassificationScheme(const Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ClassificationSchemeBase element.
     * @return Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr GetClassificationSchemeBase() const;

    /*
     * Set ClassificationSchemeBase element.
     * @param item const Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr &
     */
    virtual void SetClassificationSchemeBase(const Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsDescriptionMetadataPtr
     */
    virtual Mp7JrsDescriptionMetadataPtr GetDescriptionMetadata() const;

    virtual bool IsValidDescriptionMetadata() const;

    /*
     * Set DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsDescriptionMetadataPtr &
     */
    virtual void SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DescriptionMetadata element.
     * (Inherited from Mp7JrsCompleteDescriptionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDescriptionMetadata();

    /*
     * Get Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr GetRelationships() const;

    /*
     * Set Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr &
     */
    virtual void SetRelationships(const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr GetOrderingKey() const;

    /*
     * Set OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr &
     */
    virtual void SetOrderingKey(const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationSchemeDescriptionType();

protected:
    Mp7JrsClassificationSchemeDescriptionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsContentManagementType > m_Base;

// DefinionChoice
    Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr m_ClassificationScheme;
    Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr m_ClassificationSchemeBase;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsClassificationSchemeDescriptionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _323MP7JRSCLASSIFICATIONSCHEMEDESCRIPTIONTYPE_H

