/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _333MP7JRSCLASSIFICATIONTYPE_H
#define _333MP7JRSCLASSIFICATIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsClassificationType;
class IMp7JrsClassificationType_CaptionLanguage_CollectionType;
class IMp7JrsClassificationType_Genre_CollectionType;
class IMp7JrsClassificationType_Language_CollectionType;
class IMp7JrsClassificationType_MediaReview_CollectionType;
class IMp7JrsClassificationType_ParentalGuidance_CollectionType;
class IMp7JrsClassificationType_Purpose_CollectionType;
class IMp7JrsClassificationType_Release_LocalType;
class IMp7JrsClassificationType_SignLanguage_CollectionType;
class IMp7JrsClassificationType_Target_LocalType;
class IMp7JrsControlledTermUseType;
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsTextAnnotationType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsClassificationType_CaptionLanguage_CollectionType > Mp7JrsClassificationType_CaptionLanguage_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Genre_CollectionType > Mp7JrsClassificationType_Genre_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Language_CollectionType > Mp7JrsClassificationType_Language_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_MediaReview_CollectionType > Mp7JrsClassificationType_MediaReview_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_ParentalGuidance_CollectionType > Mp7JrsClassificationType_ParentalGuidance_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Purpose_CollectionType > Mp7JrsClassificationType_Purpose_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Release_LocalType > Mp7JrsClassificationType_Release_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_SignLanguage_CollectionType > Mp7JrsClassificationType_SignLanguage_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_LocalType > Mp7JrsClassificationType_Target_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType> Mp7JrsClassificationPtr;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsClassificationType for class Mp7JrsClassificationType<br>
 * Located at: mds-2001.xsd, line 2599<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationType();
    virtual ~IMp7JrsClassificationType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Form element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetForm() const = 0;

    virtual bool IsValidForm() const = 0;

    /**
     * Set Form element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetForm(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Form element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateForm() = 0;

    /**
     * Get Genre element.
     * @return Mp7JrsClassificationType_Genre_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Genre_CollectionPtr GetGenre() const = 0;

    /**
     * Set Genre element.
     * @param item const Mp7JrsClassificationType_Genre_CollectionPtr &
     */
    virtual void SetGenre(const Mp7JrsClassificationType_Genre_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Subject element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetSubject() const = 0;

    virtual bool IsValidSubject() const = 0;

    /**
     * Set Subject element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetSubject(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Subject element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSubject() = 0;

    /**
     * Get Purpose element.
     * @return Mp7JrsClassificationType_Purpose_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Purpose_CollectionPtr GetPurpose() const = 0;

    /**
     * Set Purpose element.
     * @param item const Mp7JrsClassificationType_Purpose_CollectionPtr &
     */
    virtual void SetPurpose(const Mp7JrsClassificationType_Purpose_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Language element.
     * @return Mp7JrsClassificationType_Language_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Language_CollectionPtr GetLanguage() const = 0;

    /**
     * Set Language element.
     * @param item const Mp7JrsClassificationType_Language_CollectionPtr &
     */
    virtual void SetLanguage(const Mp7JrsClassificationType_Language_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CaptionLanguage element.
     * @return Mp7JrsClassificationType_CaptionLanguage_CollectionPtr
     */
    virtual Mp7JrsClassificationType_CaptionLanguage_CollectionPtr GetCaptionLanguage() const = 0;

    /**
     * Set CaptionLanguage element.
     * @param item const Mp7JrsClassificationType_CaptionLanguage_CollectionPtr &
     */
    virtual void SetCaptionLanguage(const Mp7JrsClassificationType_CaptionLanguage_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SignLanguage element.
     * @return Mp7JrsClassificationType_SignLanguage_CollectionPtr
     */
    virtual Mp7JrsClassificationType_SignLanguage_CollectionPtr GetSignLanguage() const = 0;

    /**
     * Set SignLanguage element.
     * @param item const Mp7JrsClassificationType_SignLanguage_CollectionPtr &
     */
    virtual void SetSignLanguage(const Mp7JrsClassificationType_SignLanguage_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Release element.
     * @return Mp7JrsClassificationType_Release_LocalPtr
     */
    virtual Mp7JrsClassificationType_Release_LocalPtr GetRelease() const = 0;

    virtual bool IsValidRelease() const = 0;

    /**
     * Set Release element.
     * @param item const Mp7JrsClassificationType_Release_LocalPtr &
     */
    virtual void SetRelease(const Mp7JrsClassificationType_Release_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Release element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRelease() = 0;

    /**
     * Get Target element.
     * @return Mp7JrsClassificationType_Target_LocalPtr
     */
    virtual Mp7JrsClassificationType_Target_LocalPtr GetTarget() const = 0;

    virtual bool IsValidTarget() const = 0;

    /**
     * Set Target element.
     * @param item const Mp7JrsClassificationType_Target_LocalPtr &
     */
    virtual void SetTarget(const Mp7JrsClassificationType_Target_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Target element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTarget() = 0;

    /**
     * Get ParentalGuidance element.
     * @return Mp7JrsClassificationType_ParentalGuidance_CollectionPtr
     */
    virtual Mp7JrsClassificationType_ParentalGuidance_CollectionPtr GetParentalGuidance() const = 0;

    /**
     * Set ParentalGuidance element.
     * @param item const Mp7JrsClassificationType_ParentalGuidance_CollectionPtr &
     */
    virtual void SetParentalGuidance(const Mp7JrsClassificationType_ParentalGuidance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaReview element.
     * @return Mp7JrsClassificationType_MediaReview_CollectionPtr
     */
    virtual Mp7JrsClassificationType_MediaReview_CollectionPtr GetMediaReview() const = 0;

    /**
     * Set MediaReview element.
     * @param item const Mp7JrsClassificationType_MediaReview_CollectionPtr &
     */
    virtual void SetMediaReview(const Mp7JrsClassificationType_MediaReview_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationType<br>
 * Located at: mds-2001.xsd, line 2599<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 2599.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationType :
        public IMp7JrsClassificationType
{
    friend class Mp7JrsClassificationTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsClassificationType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Form element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetForm() const;

    virtual bool IsValidForm() const;

    /*
     * Set Form element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetForm(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Form element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateForm();

    /*
     * Get Genre element.
     * @return Mp7JrsClassificationType_Genre_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Genre_CollectionPtr GetGenre() const;

    /*
     * Set Genre element.
     * @param item const Mp7JrsClassificationType_Genre_CollectionPtr &
     */
    virtual void SetGenre(const Mp7JrsClassificationType_Genre_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Subject element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetSubject() const;

    virtual bool IsValidSubject() const;

    /*
     * Set Subject element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetSubject(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Subject element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSubject();

    /*
     * Get Purpose element.
     * @return Mp7JrsClassificationType_Purpose_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Purpose_CollectionPtr GetPurpose() const;

    /*
     * Set Purpose element.
     * @param item const Mp7JrsClassificationType_Purpose_CollectionPtr &
     */
    virtual void SetPurpose(const Mp7JrsClassificationType_Purpose_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Language element.
     * @return Mp7JrsClassificationType_Language_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Language_CollectionPtr GetLanguage() const;

    /*
     * Set Language element.
     * @param item const Mp7JrsClassificationType_Language_CollectionPtr &
     */
    virtual void SetLanguage(const Mp7JrsClassificationType_Language_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CaptionLanguage element.
     * @return Mp7JrsClassificationType_CaptionLanguage_CollectionPtr
     */
    virtual Mp7JrsClassificationType_CaptionLanguage_CollectionPtr GetCaptionLanguage() const;

    /*
     * Set CaptionLanguage element.
     * @param item const Mp7JrsClassificationType_CaptionLanguage_CollectionPtr &
     */
    virtual void SetCaptionLanguage(const Mp7JrsClassificationType_CaptionLanguage_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SignLanguage element.
     * @return Mp7JrsClassificationType_SignLanguage_CollectionPtr
     */
    virtual Mp7JrsClassificationType_SignLanguage_CollectionPtr GetSignLanguage() const;

    /*
     * Set SignLanguage element.
     * @param item const Mp7JrsClassificationType_SignLanguage_CollectionPtr &
     */
    virtual void SetSignLanguage(const Mp7JrsClassificationType_SignLanguage_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Release element.
     * @return Mp7JrsClassificationType_Release_LocalPtr
     */
    virtual Mp7JrsClassificationType_Release_LocalPtr GetRelease() const;

    virtual bool IsValidRelease() const;

    /*
     * Set Release element.
     * @param item const Mp7JrsClassificationType_Release_LocalPtr &
     */
    virtual void SetRelease(const Mp7JrsClassificationType_Release_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Release element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRelease();

    /*
     * Get Target element.
     * @return Mp7JrsClassificationType_Target_LocalPtr
     */
    virtual Mp7JrsClassificationType_Target_LocalPtr GetTarget() const;

    virtual bool IsValidTarget() const;

    /*
     * Set Target element.
     * @param item const Mp7JrsClassificationType_Target_LocalPtr &
     */
    virtual void SetTarget(const Mp7JrsClassificationType_Target_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Target element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTarget();

    /*
     * Get ParentalGuidance element.
     * @return Mp7JrsClassificationType_ParentalGuidance_CollectionPtr
     */
    virtual Mp7JrsClassificationType_ParentalGuidance_CollectionPtr GetParentalGuidance() const;

    /*
     * Set ParentalGuidance element.
     * @param item const Mp7JrsClassificationType_ParentalGuidance_CollectionPtr &
     */
    virtual void SetParentalGuidance(const Mp7JrsClassificationType_ParentalGuidance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaReview element.
     * @return Mp7JrsClassificationType_MediaReview_CollectionPtr
     */
    virtual Mp7JrsClassificationType_MediaReview_CollectionPtr GetMediaReview() const;

    /*
     * Set MediaReview element.
     * @param item const Mp7JrsClassificationType_MediaReview_CollectionPtr &
     */
    virtual void SetMediaReview(const Mp7JrsClassificationType_MediaReview_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationType();

protected:
    Mp7JrsClassificationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsControlledTermUsePtr m_Form;
    bool m_Form_Exist; // For optional elements 
    Mp7JrsClassificationType_Genre_CollectionPtr m_Genre;
    Mp7JrsTextAnnotationPtr m_Subject;
    bool m_Subject_Exist; // For optional elements 
    Mp7JrsClassificationType_Purpose_CollectionPtr m_Purpose;
    Mp7JrsClassificationType_Language_CollectionPtr m_Language;
    Mp7JrsClassificationType_CaptionLanguage_CollectionPtr m_CaptionLanguage;
    Mp7JrsClassificationType_SignLanguage_CollectionPtr m_SignLanguage;
    Mp7JrsClassificationType_Release_LocalPtr m_Release;
    bool m_Release_Exist; // For optional elements 
    Mp7JrsClassificationType_Target_LocalPtr m_Target;
    bool m_Target_Exist; // For optional elements 
    Mp7JrsClassificationType_ParentalGuidance_CollectionPtr m_ParentalGuidance;
    Mp7JrsClassificationType_MediaReview_CollectionPtr m_MediaReview;

// no includefile for extension defined 
// file Mp7JrsClassificationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _333MP7JRSCLASSIFICATIONTYPE_H

