/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _353MP7JRSCLASSIFICATIONTYPE_RELEASE_LOCALTYPE_H
#define _353MP7JRSCLASSIFICATIONTYPE_RELEASE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationType_Release_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationType_Release_LocalType_ExtInclude.h


class IMp7JrsClassificationType_Release_LocalType;
class IMp7JrsClassificationType_Release_Region_CollectionType;
class IMp7JrstimePointType;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Release_LocalType> Mp7JrsClassificationType_Release_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Release_Region_CollectionType > Mp7JrsClassificationType_Release_Region_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;

/** 
 * Generated interface IMp7JrsClassificationType_Release_LocalType for class Mp7JrsClassificationType_Release_LocalType<br>
 * Located at: mds-2001.xsd, line 2644<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationType_Release_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationType_Release_LocalType();
    virtual ~IMp7JrsClassificationType_Release_LocalType();
    /**
     * Get date attribute.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr Getdate() const = 0;

    /**
     * Get date attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdate() const = 0;

    /**
     * Set date attribute.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void Setdate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate date attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedate() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Region element.
     * @return Mp7JrsClassificationType_Release_Region_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Release_Region_CollectionPtr GetRegion() const = 0;

    /**
     * Set Region element.
     * @param item const Mp7JrsClassificationType_Release_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsClassificationType_Release_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsClassificationType_Release_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationType_Release_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationType_Release_LocalType<br>
 * Located at: mds-2001.xsd, line 2644<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2644.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationType_Release_LocalType :
        public IMp7JrsClassificationType_Release_LocalType
{
    friend class Mp7JrsClassificationType_Release_LocalTypeFactory; // constructs objects

public:
    /*
     * Get date attribute.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr Getdate() const;

    /*
     * Get date attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdate() const;

    /*
     * Set date attribute.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void Setdate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate date attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedate();

        /* @name Sequence

         */
        //@{
    /*
     * Get Region element.
     * @return Mp7JrsClassificationType_Release_Region_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Release_Region_CollectionPtr GetRegion() const;

    /*
     * Set Region element.
     * @param item const Mp7JrsClassificationType_Release_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsClassificationType_Release_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationType_Release_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationType_Release_LocalType();

protected:
    Mp7JrsClassificationType_Release_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrstimePointPtr m_date;
    bool m_date_Exist;


    Mp7JrsClassificationType_Release_Region_CollectionPtr m_Region;

// no includefile for extension defined 
// file Mp7JrsClassificationType_Release_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _353MP7JRSCLASSIFICATIONTYPE_RELEASE_LOCALTYPE_H

