/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _363MP7JRSCLASSIFICATIONTYPE_TARGET_LOCALTYPE_H
#define _363MP7JRSCLASSIFICATIONTYPE_TARGET_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClassificationType_Target_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtInclude.h


class IMp7JrsClassificationType_Target_Age_LocalType;
class IMp7JrsClassificationType_Target_LocalType;
class IMp7JrsClassificationType_Target_Market_CollectionType;
class IMp7JrsClassificationType_Target_Region_CollectionType;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_Age_LocalType > Mp7JrsClassificationType_Target_Age_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_LocalType> Mp7JrsClassificationType_Target_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_Market_CollectionType > Mp7JrsClassificationType_Target_Market_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_Region_CollectionType > Mp7JrsClassificationType_Target_Region_CollectionPtr;

/** 
 * Generated interface IMp7JrsClassificationType_Target_LocalType for class Mp7JrsClassificationType_Target_LocalType<br>
 * Located at: mds-2001.xsd, line 2652<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsClassificationType_Target_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsClassificationType_Target_LocalType();
    virtual ~IMp7JrsClassificationType_Target_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Market element.
     * @return Mp7JrsClassificationType_Target_Market_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Target_Market_CollectionPtr GetMarket() const = 0;

    /**
     * Set Market element.
     * @param item const Mp7JrsClassificationType_Target_Market_CollectionPtr &
     */
    virtual void SetMarket(const Mp7JrsClassificationType_Target_Market_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Age element.
     * @return Mp7JrsClassificationType_Target_Age_LocalPtr
     */
    virtual Mp7JrsClassificationType_Target_Age_LocalPtr GetAge() const = 0;

    virtual bool IsValidAge() const = 0;

    /**
     * Set Age element.
     * @param item const Mp7JrsClassificationType_Target_Age_LocalPtr &
     */
    virtual void SetAge(const Mp7JrsClassificationType_Target_Age_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Age element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAge() = 0;

    /**
     * Get Region element.
     * @return Mp7JrsClassificationType_Target_Region_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Target_Region_CollectionPtr GetRegion() const = 0;

    /**
     * Set Region element.
     * @param item const Mp7JrsClassificationType_Target_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsClassificationType_Target_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClassificationType_Target_LocalType<br>
 * Located at: mds-2001.xsd, line 2652<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2652.<br>
 */
class MP7JRS_EXPORT Mp7JrsClassificationType_Target_LocalType :
        public IMp7JrsClassificationType_Target_LocalType
{
    friend class Mp7JrsClassificationType_Target_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Market element.
     * @return Mp7JrsClassificationType_Target_Market_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Target_Market_CollectionPtr GetMarket() const;

    /*
     * Set Market element.
     * @param item const Mp7JrsClassificationType_Target_Market_CollectionPtr &
     */
    virtual void SetMarket(const Mp7JrsClassificationType_Target_Market_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Age element.
     * @return Mp7JrsClassificationType_Target_Age_LocalPtr
     */
    virtual Mp7JrsClassificationType_Target_Age_LocalPtr GetAge() const;

    virtual bool IsValidAge() const;

    /*
     * Set Age element.
     * @param item const Mp7JrsClassificationType_Target_Age_LocalPtr &
     */
    virtual void SetAge(const Mp7JrsClassificationType_Target_Age_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Age element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAge();

    /*
     * Get Region element.
     * @return Mp7JrsClassificationType_Target_Region_CollectionPtr
     */
    virtual Mp7JrsClassificationType_Target_Region_CollectionPtr GetRegion() const;

    /*
     * Set Region element.
     * @param item const Mp7JrsClassificationType_Target_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsClassificationType_Target_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClassificationType_Target_LocalType();

protected:
    Mp7JrsClassificationType_Target_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsClassificationType_Target_Market_CollectionPtr m_Market;
    Mp7JrsClassificationType_Target_Age_LocalPtr m_Age;
    bool m_Age_Exist; // For optional elements 
    Mp7JrsClassificationType_Target_Region_CollectionPtr m_Region;

// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _363MP7JRSCLASSIFICATIONTYPE_TARGET_LOCALTYPE_H

