/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _395MP7JRSCOLORLAYOUTTYPE_H
#define _395MP7JRSCOLORLAYOUTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorLayoutTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorLayoutType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsColorLayoutType;
class IMp7JrsColorLayoutType_CbACCoeff14_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff2_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff20_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff27_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff5_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff63_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff9_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff14_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff2_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff20_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff27_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff5_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff63_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff9_LocalType;
class IMp7JrsColorLayoutType_YACCoeff14_LocalType;
class IMp7JrsColorLayoutType_YACCoeff2_LocalType;
class IMp7JrsColorLayoutType_YACCoeff20_LocalType;
class IMp7JrsColorLayoutType_YACCoeff27_LocalType;
class IMp7JrsColorLayoutType_YACCoeff5_LocalType;
class IMp7JrsColorLayoutType_YACCoeff63_LocalType;
class IMp7JrsColorLayoutType_YACCoeff9_LocalType;
class IMp7Jrsunsigned6;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff14_LocalType > Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff2_LocalType > Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff20_LocalType > Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff27_LocalType > Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff5_LocalType > Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff63_LocalType > Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff9_LocalType > Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff14_LocalType > Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff2_LocalType > Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff20_LocalType > Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff27_LocalType > Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff5_LocalType > Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff63_LocalType > Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff9_LocalType > Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff14_LocalType > Mp7JrsColorLayoutType_YACCoeff14_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff2_LocalType > Mp7JrsColorLayoutType_YACCoeff2_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff20_LocalType > Mp7JrsColorLayoutType_YACCoeff20_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff27_LocalType > Mp7JrsColorLayoutType_YACCoeff27_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff5_LocalType > Mp7JrsColorLayoutType_YACCoeff5_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff63_LocalType > Mp7JrsColorLayoutType_YACCoeff63_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff9_LocalType > Mp7JrsColorLayoutType_YACCoeff9_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType> Mp7JrsColorLayoutPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned6 > Mp7Jrsunsigned6Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsColorLayoutType for class Mp7JrsColorLayoutType<br>
 * Located at: visual-2001.xsd, line 376<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsColorLayoutType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsColorLayoutType();
    virtual ~IMp7JrsColorLayoutType();
        /** @name Sequence

         */
        //@{
    /**
     * Get YDCCoeff element.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetYDCCoeff() const = 0;

    /**
     * Set YDCCoeff element.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetYDCCoeff(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CbDCCoeff element.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetCbDCCoeff() const = 0;

    /**
     * Set CbDCCoeff element.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetCbDCCoeff(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrDCCoeff element.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetCrDCCoeff() const = 0;

    /**
     * Set CrDCCoeff element.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetCrDCCoeff(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get YACCoeff2 element.
     * @return Mp7JrsColorLayoutType_YACCoeff2_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff2_LocalPtr GetYACCoeff2() const = 0;

    /**
     * Set YACCoeff2 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff2_LocalPtr &
     */
    virtual void SetYACCoeff2(const Mp7JrsColorLayoutType_YACCoeff2_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get YACCoeff5 element.
     * @return Mp7JrsColorLayoutType_YACCoeff5_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff5_LocalPtr GetYACCoeff5() const = 0;

    /**
     * Set YACCoeff5 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff5_LocalPtr &
     */
    virtual void SetYACCoeff5(const Mp7JrsColorLayoutType_YACCoeff5_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get YACCoeff9 element.
     * @return Mp7JrsColorLayoutType_YACCoeff9_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff9_LocalPtr GetYACCoeff9() const = 0;

    /**
     * Set YACCoeff9 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff9_LocalPtr &
     */
    virtual void SetYACCoeff9(const Mp7JrsColorLayoutType_YACCoeff9_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get YACCoeff14 element.
     * @return Mp7JrsColorLayoutType_YACCoeff14_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff14_LocalPtr GetYACCoeff14() const = 0;

    /**
     * Set YACCoeff14 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff14_LocalPtr &
     */
    virtual void SetYACCoeff14(const Mp7JrsColorLayoutType_YACCoeff14_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get YACCoeff20 element.
     * @return Mp7JrsColorLayoutType_YACCoeff20_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff20_LocalPtr GetYACCoeff20() const = 0;

    /**
     * Set YACCoeff20 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff20_LocalPtr &
     */
    virtual void SetYACCoeff20(const Mp7JrsColorLayoutType_YACCoeff20_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get YACCoeff27 element.
     * @return Mp7JrsColorLayoutType_YACCoeff27_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff27_LocalPtr GetYACCoeff27() const = 0;

    /**
     * Set YACCoeff27 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff27_LocalPtr &
     */
    virtual void SetYACCoeff27(const Mp7JrsColorLayoutType_YACCoeff27_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get YACCoeff63 element.
     * @return Mp7JrsColorLayoutType_YACCoeff63_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff63_LocalPtr GetYACCoeff63() const = 0;

    /**
     * Set YACCoeff63 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff63_LocalPtr &
     */
    virtual void SetYACCoeff63(const Mp7JrsColorLayoutType_YACCoeff63_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff2 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr GetCbACCoeff2() const = 0;

    /**
     * Set CbACCoeff2 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr &
     */
    virtual void SetCbACCoeff2(const Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff2 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr GetCrACCoeff2() const = 0;

    /**
     * Set CrACCoeff2 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr &
     */
    virtual void SetCrACCoeff2(const Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff5 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr GetCbACCoeff5() const = 0;

    /**
     * Set CbACCoeff5 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr &
     */
    virtual void SetCbACCoeff5(const Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff5 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr GetCrACCoeff5() const = 0;

    /**
     * Set CrACCoeff5 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr &
     */
    virtual void SetCrACCoeff5(const Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff9 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr GetCbACCoeff9() const = 0;

    /**
     * Set CbACCoeff9 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr &
     */
    virtual void SetCbACCoeff9(const Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff9 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr GetCrACCoeff9() const = 0;

    /**
     * Set CrACCoeff9 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr &
     */
    virtual void SetCrACCoeff9(const Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff14 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr GetCbACCoeff14() const = 0;

    /**
     * Set CbACCoeff14 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr &
     */
    virtual void SetCbACCoeff14(const Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff14 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr GetCrACCoeff14() const = 0;

    /**
     * Set CrACCoeff14 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr &
     */
    virtual void SetCrACCoeff14(const Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff20 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr GetCbACCoeff20() const = 0;

    /**
     * Set CbACCoeff20 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr &
     */
    virtual void SetCbACCoeff20(const Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff20 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr GetCrACCoeff20() const = 0;

    /**
     * Set CrACCoeff20 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr &
     */
    virtual void SetCrACCoeff20(const Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff27 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr GetCbACCoeff27() const = 0;

    /**
     * Set CbACCoeff27 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr &
     */
    virtual void SetCbACCoeff27(const Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff27 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr GetCrACCoeff27() const = 0;

    /**
     * Set CrACCoeff27 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr &
     */
    virtual void SetCrACCoeff27(const Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get CbACCoeff63 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr GetCbACCoeff63() const = 0;

    /**
     * Set CbACCoeff63 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr &
     */
    virtual void SetCbACCoeff63(const Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrACCoeff63 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr GetCrACCoeff63() const = 0;

    /**
     * Set CrACCoeff63 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr &
     */
    virtual void SetCrACCoeff63(const Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
        //@}
// begin extension included
// file Mp7JrsColorLayoutType_ExtMethodDef.h

public:
	
	/** Set the number of AC coefficients.
	  * @param y Number of Y AC coefficients.
	  * @param c Number of Cb/Cr AC coefficients.
	  */
	virtual void SetNrCoefficients(unsigned* y, unsigned* c, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get number of Y coefficents (DC+AC). */
	virtual unsigned GetNrYCoeffs();

	/** Get number of Cb/Cr AC coefficents (DC+AC). */
	virtual unsigned GetNrCCoeffs();

	/** Set Y coefficents.
	  * @param coeffs The number of coefficients stored in this array must equal the number of DC
	  *    + AC coefficients. The coefficients must be ordered by ascending frequency. */
	virtual void SetY(unsigned* coeffs, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get Y coefficents.
	  * param The size of this array must equal the number of DC
	  *    + AC coefficients. The coefficients are ordered by ascending frequency. */
	virtual void GetY(unsigned* coeffs);

	/** Set Cb coefficents.
	  * @param coeffs The number of coefficients stored in this array must equal the number of DC
	  *    + AC coefficients. The coefficients must be ordered by ascending frequency. */
	virtual void SetCb(unsigned* coeffs, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get Cb coefficents.
	  * param The size of this array must equal the number of DC
	  *    + AC coefficients. The coefficients are ordered by ascending frequency. */
	virtual void GetCb(unsigned* coeffs);

	/** Set Cr coefficents.
	  * @param coeffs The number of coefficients stored in this array must equal the number of DC
	  *    + AC coefficients. The coefficients must be ordered by ascending frequency. */
	virtual void SetCr(unsigned* coeffs, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get Cr coefficents.
	  * param The size of this array must equal the number of DC
	  *    + AC coefficients. The coefficients are ordered by ascending frequency. */
	virtual void GetCr(unsigned* coeffs);


private:
	/** number of coefficients to be used for MPEG-7 representation
	  * @param nrCoeffs nr of defined coefficients
	  * @return one of the predefined numbers of coefficients
	  */
	unsigned _NrCoeffsToUse(unsigned nrCoeffs);

	/** init the y coefficents list */
	void _CreateCoeffListsY(unsigned y, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** init the Cb/Cr coefficients lists */
	void _CreateCoeffListsC(unsigned c, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);






// end extension included


// begin extension included
// file Mp7JrsColorLayoutType_ExtPropDef.h



	// nr coefficients
	int _nrYCoeff;
	int _nrCCoeff;
// end extension included

};




/*
 * Generated class Mp7JrsColorLayoutType<br>
 * Located at: visual-2001.xsd, line 376<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 376.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorLayoutType :
        public IMp7JrsColorLayoutType
{
    friend class Mp7JrsColorLayoutTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsColorLayoutType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get YDCCoeff element.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetYDCCoeff() const;

    /*
     * Set YDCCoeff element.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetYDCCoeff(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CbDCCoeff element.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetCbDCCoeff() const;

    /*
     * Set CbDCCoeff element.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetCbDCCoeff(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrDCCoeff element.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetCrDCCoeff() const;

    /*
     * Set CrDCCoeff element.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetCrDCCoeff(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Choice

         */
        //@{
    /*
     * Get YACCoeff2 element.
     * @return Mp7JrsColorLayoutType_YACCoeff2_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff2_LocalPtr GetYACCoeff2() const;

    /*
     * Set YACCoeff2 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff2_LocalPtr &
     */
    virtual void SetYACCoeff2(const Mp7JrsColorLayoutType_YACCoeff2_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get YACCoeff5 element.
     * @return Mp7JrsColorLayoutType_YACCoeff5_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff5_LocalPtr GetYACCoeff5() const;

    /*
     * Set YACCoeff5 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff5_LocalPtr &
     */
    virtual void SetYACCoeff5(const Mp7JrsColorLayoutType_YACCoeff5_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get YACCoeff9 element.
     * @return Mp7JrsColorLayoutType_YACCoeff9_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff9_LocalPtr GetYACCoeff9() const;

    /*
     * Set YACCoeff9 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff9_LocalPtr &
     */
    virtual void SetYACCoeff9(const Mp7JrsColorLayoutType_YACCoeff9_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get YACCoeff14 element.
     * @return Mp7JrsColorLayoutType_YACCoeff14_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff14_LocalPtr GetYACCoeff14() const;

    /*
     * Set YACCoeff14 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff14_LocalPtr &
     */
    virtual void SetYACCoeff14(const Mp7JrsColorLayoutType_YACCoeff14_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get YACCoeff20 element.
     * @return Mp7JrsColorLayoutType_YACCoeff20_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff20_LocalPtr GetYACCoeff20() const;

    /*
     * Set YACCoeff20 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff20_LocalPtr &
     */
    virtual void SetYACCoeff20(const Mp7JrsColorLayoutType_YACCoeff20_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get YACCoeff27 element.
     * @return Mp7JrsColorLayoutType_YACCoeff27_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff27_LocalPtr GetYACCoeff27() const;

    /*
     * Set YACCoeff27 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff27_LocalPtr &
     */
    virtual void SetYACCoeff27(const Mp7JrsColorLayoutType_YACCoeff27_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get YACCoeff63 element.
     * @return Mp7JrsColorLayoutType_YACCoeff63_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_YACCoeff63_LocalPtr GetYACCoeff63() const;

    /*
     * Set YACCoeff63 element.
     * @param item const Mp7JrsColorLayoutType_YACCoeff63_LocalPtr &
     */
    virtual void SetYACCoeff63(const Mp7JrsColorLayoutType_YACCoeff63_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff2 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr GetCbACCoeff2() const;

    /*
     * Set CbACCoeff2 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr &
     */
    virtual void SetCbACCoeff2(const Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff2 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr GetCrACCoeff2() const;

    /*
     * Set CrACCoeff2 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr &
     */
    virtual void SetCrACCoeff2(const Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff5 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr GetCbACCoeff5() const;

    /*
     * Set CbACCoeff5 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr &
     */
    virtual void SetCbACCoeff5(const Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff5 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr GetCrACCoeff5() const;

    /*
     * Set CrACCoeff5 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr &
     */
    virtual void SetCrACCoeff5(const Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff9 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr GetCbACCoeff9() const;

    /*
     * Set CbACCoeff9 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr &
     */
    virtual void SetCbACCoeff9(const Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff9 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr GetCrACCoeff9() const;

    /*
     * Set CrACCoeff9 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr &
     */
    virtual void SetCrACCoeff9(const Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff14 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr GetCbACCoeff14() const;

    /*
     * Set CbACCoeff14 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr &
     */
    virtual void SetCbACCoeff14(const Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff14 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr GetCrACCoeff14() const;

    /*
     * Set CrACCoeff14 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr &
     */
    virtual void SetCrACCoeff14(const Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff20 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr GetCbACCoeff20() const;

    /*
     * Set CbACCoeff20 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr &
     */
    virtual void SetCbACCoeff20(const Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff20 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr GetCrACCoeff20() const;

    /*
     * Set CrACCoeff20 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr &
     */
    virtual void SetCrACCoeff20(const Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff27 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr GetCbACCoeff27() const;

    /*
     * Set CbACCoeff27 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr &
     */
    virtual void SetCbACCoeff27(const Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff27 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr GetCrACCoeff27() const;

    /*
     * Set CrACCoeff27 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr &
     */
    virtual void SetCrACCoeff27(const Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get CbACCoeff63 element.
     * @return Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr GetCbACCoeff63() const;

    /*
     * Set CbACCoeff63 element.
     * @param item const Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr &
     */
    virtual void SetCbACCoeff63(const Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrACCoeff63 element.
     * @return Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr
     */
    virtual Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr GetCrACCoeff63() const;

    /*
     * Set CrACCoeff63 element.
     * @param item const Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr &
     */
    virtual void SetCrACCoeff63(const Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorLayoutType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorLayoutType();

protected:
    Mp7JrsColorLayoutType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7Jrsunsigned6Ptr m_YDCCoeff;
    Mp7Jrsunsigned6Ptr m_CbDCCoeff;
    Mp7Jrsunsigned6Ptr m_CrDCCoeff;
// DefinionChoice
    Mp7JrsColorLayoutType_YACCoeff2_LocalPtr m_YACCoeff2;
    Mp7JrsColorLayoutType_YACCoeff5_LocalPtr m_YACCoeff5;
    Mp7JrsColorLayoutType_YACCoeff9_LocalPtr m_YACCoeff9;
    Mp7JrsColorLayoutType_YACCoeff14_LocalPtr m_YACCoeff14;
    Mp7JrsColorLayoutType_YACCoeff20_LocalPtr m_YACCoeff20;
    Mp7JrsColorLayoutType_YACCoeff27_LocalPtr m_YACCoeff27;
    Mp7JrsColorLayoutType_YACCoeff63_LocalPtr m_YACCoeff63;
// End DefinionChoice
// DefinionChoice
    Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr m_CbACCoeff2;
    Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr m_CrACCoeff2;
    Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr m_CbACCoeff5;
    Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr m_CrACCoeff5;
    Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr m_CbACCoeff9;
    Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr m_CrACCoeff9;
    Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr m_CbACCoeff14;
    Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr m_CrACCoeff14;
    Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr m_CbACCoeff20;
    Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr m_CrACCoeff20;
    Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr m_CbACCoeff27;
    Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr m_CrACCoeff27;
    Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr m_CbACCoeff63;
    Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr m_CrACCoeff63;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsColorLayoutType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _395MP7JRSCOLORLAYOUTTYPE_H

