/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _419MP7JRSCOLORLAYOUTTYPE_CBACCOEFF63_LOCALTYPE_H
#define _419MP7JRSCOLORLAYOUTTYPE_CBACCOEFF63_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorLayoutType_CbACCoeff63_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorLayoutType_CbACCoeff63_LocalType_ExtInclude.h


#include "Mp7JrsColorLayoutType_CbACCoeff63_CollectionType.h"
class IMp7JrsColorLayoutType_CbACCoeff63_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff63_LocalType;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff63_CollectionType > Mp7JrsColorLayoutType_CbACCoeff63_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff63_LocalType> Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr;

/** 
 * Generated interface IMp7JrsColorLayoutType_CbACCoeff63_LocalType for class Mp7JrsColorLayoutType_CbACCoeff63_LocalType<br>
 * Located at: visual-2001.xsd, line 590<br>
 * Derived from: ColorLayoutType_CbACCoeff63_CollectionType (Collection)<br>
 */
class MP7JRS_EXPORT IMp7JrsColorLayoutType_CbACCoeff63_LocalType 
 :
        public IMp7JrsColorLayoutType_CbACCoeff63_CollectionType
{
public:
    // TODO: make these protected?
    IMp7JrsColorLayoutType_CbACCoeff63_LocalType();
    virtual ~IMp7JrsColorLayoutType_CbACCoeff63_LocalType();
    /**
     * Retrieves the base collection of Mp7JrsColorLayoutType_CbACCoeff63_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType >
     */
    virtual Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType > GetBaseCollection() const = 0;


    /**
     * Initializes the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param maxElems Number of elements for which memory is initially allocated.
     */
    virtual void Initialize(unsigned int maxElems) = 0;


    /**
     * Adds a new element to the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toAdd Element to be added. Default element type: Mp7Jrsunsigned5
     */
    virtual void addElement(const Mp7JrsNodePtr &toAdd, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Sets the element at the given position in the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toSet New value of the element. Default element type: Mp7Jrsunsigned5
     * @param setAt Position of the element which shall be set.
     */
    virtual void setElementAt(const Mp7JrsNodePtr &toSet, unsigned int setAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Inserts the element at the given position in the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toInsert Element to be inserted. Default element type: Mp7Jrsunsigned5
     * @param insertAt Position where the element will be inserted.
     */
    virtual void insertElementAt(const Mp7JrsNodePtr &toInsert, unsigned int insertAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Removes all elements from the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     */
    virtual void removeAllElements(Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Removes the specified element from the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param removeAt Position of the element to be removed. 
     */
    virtual void removeElementAt(unsigned int removeAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;



    /**
     * Check whether the collection contains the given element.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toCheck Element to be checked for. Default element type: Mp7Jrsunsigned5
     * @return True if the element is in the collection, false otherwise.
     */
    virtual bool containsElement(const Mp7JrsNodePtr &toCheck) = 0;


    /**
     * Get the current capacity of the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @return The number of elements for which memory has been allocated.
     */
    virtual unsigned int curCapacity() const = 0;


    /**
     * Gets a constant pointer to the element at the given position.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7Jrsunsigned5.
     */
    virtual const Mp7JrsNodePtr elementAt(unsigned int getAt) const = 0;


    /**
     * Gets a pointer to the element at the given position.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7Jrsunsigned5.
     */
    virtual Mp7JrsNodePtr elementAt(unsigned int getAt) = 0;


    /**
     * Gets an enumeration of all contained elements of the specified type.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param The class id of the wanted elements.
     * @return A (possibly empty) enumeration of all contained elements of type id.
     */
    virtual Mp7JrsNodeEnum GetElementsOfType(unsigned int id) const = 0;

        
    /**
     * Gets an enumeration of all contained elements.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @return A (possibly empty) enumeration of all contained elements.
     */
    virtual Mp7JrsNodeEnum GetElements() const = 0;



    /**
     * Get the size of the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @return The current number of elements in the collection.
     */
    virtual unsigned int size() const = 0;


    /**
     * Allocate additional memory for the speciifed number of elements.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param length Number of elements to allocate memory for.
     */
    virtual void ensureExtraCapacity(unsigned int length) = 0;


    // JRS: addition to Xerces collection
    /**
     * Get the position of the specified element. 
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toCheck Element to be found in the collection. Default element type: Mp7Jrsunsigned5
     * @return The position of the specified element or -1 if the element has not been found.
     */
    virtual int elementIndexOf(const Mp7JrsNodePtr &toCheck) const = 0;


// no includefile for extension defined 
// file Mp7JrsColorLayoutType_CbACCoeff63_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorLayoutType_CbACCoeff63_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorLayoutType_CbACCoeff63_LocalType<br>
 * Located at: visual-2001.xsd, line 590<br>
 * Derived from: ColorLayoutType_CbACCoeff63_CollectionType (Collection)<br>
 * Defined in visual-2001.xsd, line 590.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorLayoutType_CbACCoeff63_LocalType :
        public IMp7JrsColorLayoutType_CbACCoeff63_LocalType
{
    friend class Mp7JrsColorLayoutType_CbACCoeff63_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsColorLayoutType_CbACCoeff63_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType >
     */
    virtual Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType > GetBase() const;
    /*
     * Retrieves the base collection of Mp7JrsColorLayoutType_CbACCoeff63_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType >
     */
    virtual Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType > GetBaseCollection() const;


    /*
     * Initializes the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param maxElems Number of elements for which memory is initially allocated.
     */
    virtual void Initialize(unsigned int maxElems);


    /*
     * Adds a new element to the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toAdd Element to be added. Default element type: Mp7Jrsunsigned5
     */
    virtual void addElement(const Mp7JrsNodePtr &toAdd, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Sets the element at the given position in the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toSet New value of the element. Default element type: Mp7Jrsunsigned5
     * @param setAt Position of the element which shall be set.
     */
    virtual void setElementAt(const Mp7JrsNodePtr &toSet, unsigned int setAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Inserts the element at the given position in the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toInsert Element to be inserted. Default element type: Mp7Jrsunsigned5
     * @param insertAt Position where the element will be inserted.
     */
    virtual void insertElementAt(const Mp7JrsNodePtr &toInsert, unsigned int insertAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Removes all elements from the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     */
    virtual void removeAllElements(Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Removes the specified element from the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param removeAt Position of the element to be removed. 
     */
    virtual void removeElementAt(unsigned int removeAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);



    /*
     * Check whether the collection contains the given element.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toCheck Element to be checked for. Default element type: Mp7Jrsunsigned5
     * @return True if the element is in the collection, false otherwise.
     */
    virtual bool containsElement(const Mp7JrsNodePtr &toCheck);


    /*
     * Get the current capacity of the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @return The number of elements for which memory has been allocated.
     */
    virtual unsigned int curCapacity() const;


    /*
     * Gets a constant pointer to the element at the given position.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7Jrsunsigned5.
     */
    virtual const Mp7JrsNodePtr elementAt(unsigned int getAt) const;


    /*
     * Gets a pointer to the element at the given position.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7Jrsunsigned5.
     */
    virtual Mp7JrsNodePtr elementAt(unsigned int getAt);


    /*
     * Gets an enumeration of all contained elements of the specified type.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param The class id of the wanted elements.
     * @return A (possibly empty) enumeration of all contained elements of type id.
     */
    virtual Mp7JrsNodeEnum GetElementsOfType(unsigned int id) const;

        
    /*
     * Gets an enumeration of all contained elements.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @return A (possibly empty) enumeration of all contained elements.
     */
    virtual Mp7JrsNodeEnum GetElements() const;



    /*
     * Get the size of the collection.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @return The current number of elements in the collection.
     */
    virtual unsigned int size() const;


    /*
     * Allocate additional memory for the speciifed number of elements.
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param length Number of elements to allocate memory for.
     */
    virtual void ensureExtraCapacity(unsigned int length);


    // JRS: addition to Xerces collection
    /*
     * Get the position of the specified element. 
     * (Inherited from Mp7JrsColorLayoutType_CbACCoeff63_CollectionType)
     * @param toCheck Element to be found in the collection. Default element type: Mp7Jrsunsigned5
     * @return The position of the specified element or -1 if the element has not been found.
     */
    virtual int elementIndexOf(const Mp7JrsNodePtr &toCheck) const;



    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorLayoutType_CbACCoeff63_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorLayoutType_CbACCoeff63_LocalType();

protected:
    Mp7JrsColorLayoutType_CbACCoeff63_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Collection
    Mp7JrsPtr< Mp7JrsColorLayoutType_CbACCoeff63_CollectionType > m_Base;


// no includefile for extension defined 
// file Mp7JrsColorLayoutType_CbACCoeff63_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _419MP7JRSCOLORLAYOUTTYPE_CBACCOEFF63_LOCALTYPE_H

