/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _489MP7JRSCOLORSAMPLINGTYPE_H
#define _489MP7JRSCOLORSAMPLINGTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorSamplingTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsColorSamplingType;
class IMp7JrsColorSamplingType_Field_CollectionType;
class IMp7JrsColorSamplingType_Lattice_LocalType;
class IMp7JrsDType;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_CollectionType > Mp7JrsColorSamplingType_Field_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Lattice_LocalType > Mp7JrsColorSamplingType_Lattice_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType> Mp7JrsColorSamplingPtr;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;

/** 
 * Generated interface IMp7JrsColorSamplingType for class Mp7JrsColorSamplingType<br>
 * Located at: mds-2001.xsd, line 2308<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsColorSamplingType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsColorSamplingType();
    virtual ~IMp7JrsColorSamplingType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Lattice element.
     * @return Mp7JrsColorSamplingType_Lattice_LocalPtr
     */
    virtual Mp7JrsColorSamplingType_Lattice_LocalPtr GetLattice() const = 0;

    virtual bool IsValidLattice() const = 0;

    /**
     * Set Lattice element.
     * @param item const Mp7JrsColorSamplingType_Lattice_LocalPtr &
     */
    virtual void SetLattice(const Mp7JrsColorSamplingType_Lattice_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Lattice element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLattice() = 0;

    /**
     * Get Field element.
     * @return Mp7JrsColorSamplingType_Field_CollectionPtr
     */
    virtual Mp7JrsColorSamplingType_Field_CollectionPtr GetField() const = 0;

    /**
     * Set Field element.
     * @param item const Mp7JrsColorSamplingType_Field_CollectionPtr &
     */
    virtual void SetField(const Mp7JrsColorSamplingType_Field_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorSamplingType<br>
 * Located at: mds-2001.xsd, line 2308<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 2308.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorSamplingType :
        public IMp7JrsColorSamplingType
{
    friend class Mp7JrsColorSamplingTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsColorSamplingType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Lattice element.
     * @return Mp7JrsColorSamplingType_Lattice_LocalPtr
     */
    virtual Mp7JrsColorSamplingType_Lattice_LocalPtr GetLattice() const;

    virtual bool IsValidLattice() const;

    /*
     * Set Lattice element.
     * @param item const Mp7JrsColorSamplingType_Lattice_LocalPtr &
     */
    virtual void SetLattice(const Mp7JrsColorSamplingType_Lattice_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Lattice element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLattice();

    /*
     * Get Field element.
     * @return Mp7JrsColorSamplingType_Field_CollectionPtr
     */
    virtual Mp7JrsColorSamplingType_Field_CollectionPtr GetField() const;

    /*
     * Set Field element.
     * @param item const Mp7JrsColorSamplingType_Field_CollectionPtr &
     */
    virtual void SetField(const Mp7JrsColorSamplingType_Field_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorSamplingType();

protected:
    Mp7JrsColorSamplingType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsColorSamplingType_Lattice_LocalPtr m_Lattice;
    bool m_Lattice_Exist; // For optional elements 
    Mp7JrsColorSamplingType_Field_CollectionPtr m_Field;

// no includefile for extension defined 
// file Mp7JrsColorSamplingType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _489MP7JRSCOLORSAMPLINGTYPE_H

