/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _495MP7JRSCOLORSAMPLINGTYPE_FIELD_COMPONENT_LOCALTYPE_H
#define _495MP7JRSCOLORSAMPLINGTYPE_FIELD_COMPONENT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorSamplingType_Field_Component_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtInclude.h


#include "Mp7JrsInlineTermDefinitionType.h"
#include "Mp7JrsTermUseType.h"
class IMp7JrsColorSamplingType_Field_Component_LocalType;
class IMp7JrsColorSamplingType_Field_Component_Offset_LocalType;
class IMp7JrsColorSamplingType_Field_Component_Period_LocalType;
class IMp7JrsInlineTermDefinitionType_Definition_CollectionType;
class IMp7JrsInlineTermDefinitionType_Name_CollectionType;
class IMp7JrsInlineTermDefinitionType_Term_CollectionType;
class IMp7JrstermReferenceType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_LocalType> Mp7JrsColorSamplingType_Field_Component_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_Offset_LocalType > Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_Period_LocalType > Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Definition_CollectionType > Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Name_CollectionType > Mp7JrsInlineTermDefinitionType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Term_CollectionType > Mp7JrsInlineTermDefinitionType_Term_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrstermReferenceType > Mp7JrstermReferencePtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsColorSamplingType_Field_Component_LocalType for class Mp7JrsColorSamplingType_Field_Component_LocalType<br>
 * Located at: mds-2001.xsd, line 2322<br>
 * Classified: Class<br>
 * Derived from: TermUseType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsColorSamplingType_Field_Component_LocalType 
 :
        public IMp7JrsTermUseType
{
public:
    // TODO: make these protected?
    IMp7JrsColorSamplingType_Field_Component_LocalType();
    virtual ~IMp7JrsColorSamplingType_Field_Component_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Offset element.
     * @return Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr
     */
    virtual Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr GetOffset() const = 0;

    virtual bool IsValidOffset() const = 0;

    /**
     * Set Offset element.
     * @param item const Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr &
     */
    virtual void SetOffset(const Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Offset element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOffset() = 0;

    /**
     * Get Period element.
     * @return Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr
     */
    virtual Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr GetPeriod() const = 0;

    virtual bool IsValidPeriod() const = 0;

    /**
     * Set Period element.
     * @param item const Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr &
     */
    virtual void SetPeriod(const Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Period element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePeriod() = 0;

        //@}
    /**
     * Get href attribute.
<br>
     * (Inherited from Mp7JrsTermUseType)
     * @return Mp7JrstermReferencePtr
     */
    virtual Mp7JrstermReferencePtr Gethref() const = 0;

    /**
     * Get href attribute validity information.
     * (Inherited from Mp7JrsTermUseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existhref() const = 0;

    /**
     * Set href attribute.
<br>
     * (Inherited from Mp7JrsTermUseType)
     * @param item const Mp7JrstermReferencePtr &
     */
    virtual void Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate href attribute.
     * (Inherited from Mp7JrsTermUseType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatehref() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Name_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr GetDefinition() const = 0;

    /**
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Term_CollectionPtr GetTerm() const = 0;

    /**
     * Set Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorSamplingType_Field_Component_LocalType<br>
 * Located at: mds-2001.xsd, line 2322<br>
 * Classified: Class<br>
 * Derived from: TermUseType (Class)<br>
 * Defined in mds-2001.xsd, line 2322.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorSamplingType_Field_Component_LocalType :
        public IMp7JrsColorSamplingType_Field_Component_LocalType
{
    friend class Mp7JrsColorSamplingType_Field_Component_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsColorSamplingType_Field_Component_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsTermUseType >
     */
    virtual Mp7JrsPtr< Mp7JrsTermUseType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Offset element.
     * @return Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr
     */
    virtual Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr GetOffset() const;

    virtual bool IsValidOffset() const;

    /*
     * Set Offset element.
     * @param item const Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr &
     */
    virtual void SetOffset(const Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Offset element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOffset();

    /*
     * Get Period element.
     * @return Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr
     */
    virtual Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr GetPeriod() const;

    virtual bool IsValidPeriod() const;

    /*
     * Set Period element.
     * @param item const Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr &
     */
    virtual void SetPeriod(const Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Period element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePeriod();

        //@}
    /*
     * Get href attribute.
<br>
     * (Inherited from Mp7JrsTermUseType)
     * @return Mp7JrstermReferencePtr
     */
    virtual Mp7JrstermReferencePtr Gethref() const;

    /*
     * Get href attribute validity information.
     * (Inherited from Mp7JrsTermUseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existhref() const;

    /*
     * Set href attribute.
<br>
     * (Inherited from Mp7JrsTermUseType)
     * @param item const Mp7JrstermReferencePtr &
     */
    virtual void Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate href attribute.
     * (Inherited from Mp7JrsTermUseType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatehref();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Name_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr GetDefinition() const;

    /*
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Term_CollectionPtr GetTerm() const;

    /*
     * Set Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorSamplingType_Field_Component_LocalType();

protected:
    Mp7JrsColorSamplingType_Field_Component_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsTermUseType > m_Base;

    Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr m_Offset;
    bool m_Offset_Exist; // For optional elements 
    Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr m_Period;
    bool m_Period_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _495MP7JRSCOLORSAMPLINGTYPE_FIELD_COMPONENT_LOCALTYPE_H

