/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _501MP7JRSCOLORSAMPLINGTYPE_FIELD_LOCALTYPE_H
#define _501MP7JRSCOLORSAMPLINGTYPE_FIELD_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorSamplingType_Field_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_LocalType_ExtInclude.h


class IMp7JrsColorSamplingType_Field_Component_CollectionType;
class IMp7JrsColorSamplingType_Field_LocalType;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_CollectionType > Mp7JrsColorSamplingType_Field_Component_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_LocalType> Mp7JrsColorSamplingType_Field_LocalPtr;

/** 
 * Generated interface IMp7JrsColorSamplingType_Field_LocalType for class Mp7JrsColorSamplingType_Field_LocalType<br>
 * Located at: mds-2001.xsd, line 2319<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsColorSamplingType_Field_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsColorSamplingType_Field_LocalType();
    virtual ~IMp7JrsColorSamplingType_Field_LocalType();
    /**
     * Get temporalOrder attribute.
     * @return unsigned
     */
    virtual unsigned GettemporalOrder() const = 0;

    /**
     * Get temporalOrder attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttemporalOrder() const = 0;

    /**
     * Set temporalOrder attribute.
     * @param item unsigned
     */
    virtual void SettemporalOrder(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate temporalOrder attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetemporalOrder() = 0;

    /**
     * Get positionalOrder attribute.
     * @return unsigned
     */
    virtual unsigned GetpositionalOrder() const = 0;

    /**
     * Get positionalOrder attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpositionalOrder() const = 0;

    /**
     * Set positionalOrder attribute.
     * @param item unsigned
     */
    virtual void SetpositionalOrder(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate positionalOrder attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepositionalOrder() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Component element.
     * @return Mp7JrsColorSamplingType_Field_Component_CollectionPtr
     */
    virtual Mp7JrsColorSamplingType_Field_Component_CollectionPtr GetComponent() const = 0;

    /**
     * Set Component element.
     * @param item const Mp7JrsColorSamplingType_Field_Component_CollectionPtr &
     */
    virtual void SetComponent(const Mp7JrsColorSamplingType_Field_Component_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorSamplingType_Field_LocalType<br>
 * Located at: mds-2001.xsd, line 2319<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2319.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorSamplingType_Field_LocalType :
        public IMp7JrsColorSamplingType_Field_LocalType
{
    friend class Mp7JrsColorSamplingType_Field_LocalTypeFactory; // constructs objects

public:
    /*
     * Get temporalOrder attribute.
     * @return unsigned
     */
    virtual unsigned GettemporalOrder() const;

    /*
     * Get temporalOrder attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttemporalOrder() const;

    /*
     * Set temporalOrder attribute.
     * @param item unsigned
     */
    virtual void SettemporalOrder(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate temporalOrder attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetemporalOrder();

    /*
     * Get positionalOrder attribute.
     * @return unsigned
     */
    virtual unsigned GetpositionalOrder() const;

    /*
     * Get positionalOrder attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpositionalOrder() const;

    /*
     * Set positionalOrder attribute.
     * @param item unsigned
     */
    virtual void SetpositionalOrder(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate positionalOrder attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepositionalOrder();

        /* @name Sequence

         */
        //@{
    /*
     * Get Component element.
     * @return Mp7JrsColorSamplingType_Field_Component_CollectionPtr
     */
    virtual Mp7JrsColorSamplingType_Field_Component_CollectionPtr GetComponent() const;

    /*
     * Set Component element.
     * @param item const Mp7JrsColorSamplingType_Field_Component_CollectionPtr &
     */
    virtual void SetComponent(const Mp7JrsColorSamplingType_Field_Component_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorSamplingType_Field_LocalType();

protected:
    Mp7JrsColorSamplingType_Field_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_temporalOrder;
    bool m_temporalOrder_Exist;
    unsigned m_positionalOrder;
    bool m_positionalOrder_Exist;


    Mp7JrsColorSamplingType_Field_Component_CollectionPtr m_Component;

// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _501MP7JRSCOLORSAMPLINGTYPE_FIELD_LOCALTYPE_H

