/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _505MP7JRSCOLORSPACETYPE_H
#define _505MP7JRSCOLORSPACETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorSpaceTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorSpaceType_ExtInclude.h


#include "Mp7JrsColorSpaceType_type_LocalType.h"
class IMp7JrsColorSpaceType;
class IMp7JrsColorSpaceType_ColorTransMat_LocalType;
typedef Mp7JrsPtr< IMp7JrsColorSpaceType_ColorTransMat_LocalType > Mp7JrsColorSpaceType_ColorTransMat_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorSpaceType> Mp7JrsColorSpacePtr;

/** 
 * Generated interface IMp7JrsColorSpaceType for class Mp7JrsColorSpaceType<br>
 * Located at: visual-2001.xsd, line 242<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsColorSpaceType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsColorSpaceType();
    virtual ~IMp7JrsColorSpaceType();
    /**
     * Get colorReferenceFlag attribute.
     * @return bool
     */
    virtual bool GetcolorReferenceFlag() const = 0;

    /**
     * Get colorReferenceFlag attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistcolorReferenceFlag() const = 0;

    /**
     * Set colorReferenceFlag attribute.
     * @param item bool
     */
    virtual void SetcolorReferenceFlag(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate colorReferenceFlag attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatecolorReferenceFlag() = 0;

    /**
     * Get type attribute.
     * @return Mp7JrsColorSpaceType_type_LocalType::Enumeration
     */
    virtual Mp7JrsColorSpaceType_type_LocalType::Enumeration Gettype() const = 0;

    /**
     * Set type attribute.
     * @param item Mp7JrsColorSpaceType_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsColorSpaceType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get ColorTransMat element.
     * @return Mp7JrsColorSpaceType_ColorTransMat_LocalPtr
     */
    virtual Mp7JrsColorSpaceType_ColorTransMat_LocalPtr GetColorTransMat() const = 0;

    virtual bool IsValidColorTransMat() const = 0;

    /**
     * Set ColorTransMat element.
     * @param item const Mp7JrsColorSpaceType_ColorTransMat_LocalPtr &
     */
    virtual void SetColorTransMat(const Mp7JrsColorSpaceType_ColorTransMat_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ColorTransMat element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorTransMat() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsColorSpaceType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorSpaceType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorSpaceType<br>
 * Located at: visual-2001.xsd, line 242<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 242.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorSpaceType :
        public IMp7JrsColorSpaceType
{
    friend class Mp7JrsColorSpaceTypeFactory; // constructs objects

public:
    /*
     * Get colorReferenceFlag attribute.
     * @return bool
     */
    virtual bool GetcolorReferenceFlag() const;

    /*
     * Get colorReferenceFlag attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistcolorReferenceFlag() const;

    /*
     * Set colorReferenceFlag attribute.
     * @param item bool
     */
    virtual void SetcolorReferenceFlag(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate colorReferenceFlag attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatecolorReferenceFlag();

    /*
     * Get type attribute.
     * @return Mp7JrsColorSpaceType_type_LocalType::Enumeration
     */
    virtual Mp7JrsColorSpaceType_type_LocalType::Enumeration Gettype() const;

    /*
     * Set type attribute.
     * @param item Mp7JrsColorSpaceType_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsColorSpaceType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get ColorTransMat element.
     * @return Mp7JrsColorSpaceType_ColorTransMat_LocalPtr
     */
    virtual Mp7JrsColorSpaceType_ColorTransMat_LocalPtr GetColorTransMat() const;

    virtual bool IsValidColorTransMat() const;

    /*
     * Set ColorTransMat element.
     * @param item const Mp7JrsColorSpaceType_ColorTransMat_LocalPtr &
     */
    virtual void SetColorTransMat(const Mp7JrsColorSpaceType_ColorTransMat_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ColorTransMat element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorTransMat();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorSpaceType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorSpaceType();

protected:
    Mp7JrsColorSpaceType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_colorReferenceFlag;
    bool m_colorReferenceFlag_Exist;
    bool m_colorReferenceFlag_Default;
    Mp7JrsColorSpaceType_type_LocalType::Enumeration m_type;


    Mp7JrsColorSpaceType_ColorTransMat_LocalPtr m_ColorTransMat;
    bool m_ColorTransMat_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsColorSpaceType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _505MP7JRSCOLORSPACETYPE_H

