/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _513MP7JRSCOLORSTRUCTURETYPE_H
#define _513MP7JRSCOLORSTRUCTURETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorStructureTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsColorStructureType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsColorStructureType;
class IMp7JrsColorStructureType_Values_LocalType;
class IMp7Jrsunsigned3;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsColorStructureType_Values_LocalType > Mp7JrsColorStructureType_Values_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsColorStructureType> Mp7JrsColorStructurePtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned3 > Mp7Jrsunsigned3Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsColorStructureType for class Mp7JrsColorStructureType<br>
 * Located at: visual-2001.xsd, line 618<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsColorStructureType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsColorStructureType();
    virtual ~IMp7JrsColorStructureType();
    /**
     * Get colorQuant attribute.
     * @return Mp7Jrsunsigned3Ptr
     */
    virtual Mp7Jrsunsigned3Ptr GetcolorQuant() const = 0;

    /**
     * Set colorQuant attribute.
     * @param item const Mp7Jrsunsigned3Ptr &
     */
    virtual void SetcolorQuant(const Mp7Jrsunsigned3Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Values element.
     * @return Mp7JrsColorStructureType_Values_LocalPtr
     */
    virtual Mp7JrsColorStructureType_Values_LocalPtr GetValues() const = 0;

    /**
     * Set Values element.
     * @param item const Mp7JrsColorStructureType_Values_LocalPtr &
     */
    virtual void SetValues(const Mp7JrsColorStructureType_Values_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsColorStructureType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorStructureType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorStructureType<br>
 * Located at: visual-2001.xsd, line 618<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 618.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorStructureType :
        public IMp7JrsColorStructureType
{
    friend class Mp7JrsColorStructureTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsColorStructureType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
    /*
     * Get colorQuant attribute.
     * @return Mp7Jrsunsigned3Ptr
     */
    virtual Mp7Jrsunsigned3Ptr GetcolorQuant() const;

    /*
     * Set colorQuant attribute.
     * @param item const Mp7Jrsunsigned3Ptr &
     */
    virtual void SetcolorQuant(const Mp7Jrsunsigned3Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get Values element.
     * @return Mp7JrsColorStructureType_Values_LocalPtr
     */
    virtual Mp7JrsColorStructureType_Values_LocalPtr GetValues() const;

    /*
     * Set Values element.
     * @param item const Mp7JrsColorStructureType_Values_LocalPtr &
     */
    virtual void SetValues(const Mp7JrsColorStructureType_Values_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorStructureType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorStructureType();

protected:
    Mp7JrsColorStructureType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7Jrsunsigned3Ptr m_colorQuant;

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsColorStructureType_Values_LocalPtr m_Values;

// no includefile for extension defined 
// file Mp7JrsColorStructureType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _513MP7JRSCOLORSTRUCTURETYPE_H

