/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _557MP7JRSCONFUSIONCOUNTTYPE_H
#define _557MP7JRSCONFUSIONCOUNTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConfusionCountTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsConfusionCountType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsConfusionCountType;
class IMp7JrsHeaderType;
class IMp7JrsIntegerMatrixType;
class IMp7JrsintegerVector;
typedef Mp7JrsPtr< IMp7JrsConfusionCountType> Mp7JrsConfusionCountPtr;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsIntegerMatrixType > Mp7JrsIntegerMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsintegerVector > Mp7JrsintegerVectorPtr;

/** 
 * Generated interface IMp7JrsConfusionCountType for class Mp7JrsConfusionCountType<br>
 * Located at: audio-2001.xsd, line 581<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsConfusionCountType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsConfusionCountType();
    virtual ~IMp7JrsConfusionCountType();
    /**
     * Get numOfDimensions attribute.
     * @return unsigned
     */
    virtual unsigned GetnumOfDimensions() const = 0;

    /**
     * Set numOfDimensions attribute.
     * @param item unsigned
     */
    virtual void SetnumOfDimensions(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Insertion element.
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr GetInsertion() const = 0;

    /**
     * Set Insertion element.
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void SetInsertion(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Deletion element.
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr GetDeletion() const = 0;

    /**
     * Set Deletion element.
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void SetDeletion(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Substitution element.
     * @return Mp7JrsIntegerMatrixPtr
     */
    virtual Mp7JrsIntegerMatrixPtr GetSubstitution() const = 0;

    /**
     * Set Substitution element.
     * @param item const Mp7JrsIntegerMatrixPtr &
     */
    virtual void SetSubstitution(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsConfusionCountType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsConfusionCountType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsConfusionCountType<br>
 * Located at: audio-2001.xsd, line 581<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in audio-2001.xsd, line 581.<br>
 */
class MP7JRS_EXPORT Mp7JrsConfusionCountType :
        public IMp7JrsConfusionCountType
{
    friend class Mp7JrsConfusionCountTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsConfusionCountType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
    /*
     * Get numOfDimensions attribute.
     * @return unsigned
     */
    virtual unsigned GetnumOfDimensions() const;

    /*
     * Set numOfDimensions attribute.
     * @param item unsigned
     */
    virtual void SetnumOfDimensions(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get Insertion element.
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr GetInsertion() const;

    /*
     * Set Insertion element.
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void SetInsertion(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Deletion element.
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr GetDeletion() const;

    /*
     * Set Deletion element.
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void SetDeletion(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Substitution element.
     * @return Mp7JrsIntegerMatrixPtr
     */
    virtual Mp7JrsIntegerMatrixPtr GetSubstitution() const;

    /*
     * Set Substitution element.
     * @param item const Mp7JrsIntegerMatrixPtr &
     */
    virtual void SetSubstitution(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsConfusionCountType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsConfusionCountType();

protected:
    Mp7JrsConfusionCountType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_numOfDimensions;

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    Mp7JrsintegerVectorPtr m_Insertion;
    Mp7JrsintegerVectorPtr m_Deletion;
    Mp7JrsIntegerMatrixPtr m_Substitution;

// no includefile for extension defined 
// file Mp7JrsConfusionCountType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _557MP7JRSCONFUSIONCOUNTTYPE_H

