/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _599MP7JRSCONTOURSHAPETYPE_PEAK_LOCALTYPE_H
#define _599MP7JRSCONTOURSHAPETYPE_PEAK_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsContourShapeType_Peak_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsContourShapeType_Peak_LocalType_ExtInclude.h


class IMp7JrsContourShapeType_Peak_LocalType;
class IMp7Jrsunsigned3;
class IMp7Jrsunsigned6;
typedef Mp7JrsPtr< IMp7JrsContourShapeType_Peak_LocalType> Mp7JrsContourShapeType_Peak_LocalPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned3 > Mp7Jrsunsigned3Ptr;
typedef Mp7JrsPtr< IMp7Jrsunsigned6 > Mp7Jrsunsigned6Ptr;

/** 
 * Generated interface IMp7JrsContourShapeType_Peak_LocalType for class Mp7JrsContourShapeType_Peak_LocalType<br>
 * Located at: visual-2001.xsd, line 784<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsContourShapeType_Peak_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsContourShapeType_Peak_LocalType();
    virtual ~IMp7JrsContourShapeType_Peak_LocalType();
    /**
     * Get peakX attribute.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetpeakX() const = 0;

    /**
     * Get peakX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpeakX() const = 0;

    /**
     * Set peakX attribute.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetpeakX(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate peakX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepeakX() = 0;

    /**
     * Get peakY attribute.
     * @return Mp7Jrsunsigned3Ptr
     */
    virtual Mp7Jrsunsigned3Ptr GetpeakY() const = 0;

    /**
     * Get peakY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpeakY() const = 0;

    /**
     * Set peakY attribute.
     * @param item const Mp7Jrsunsigned3Ptr &
     */
    virtual void SetpeakY(const Mp7Jrsunsigned3Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate peakY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepeakY() = 0;

// no includefile for extension defined 
// file Mp7JrsContourShapeType_Peak_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsContourShapeType_Peak_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsContourShapeType_Peak_LocalType<br>
 * Located at: visual-2001.xsd, line 784<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 784.<br>
 */
class MP7JRS_EXPORT Mp7JrsContourShapeType_Peak_LocalType :
        public IMp7JrsContourShapeType_Peak_LocalType
{
    friend class Mp7JrsContourShapeType_Peak_LocalTypeFactory; // constructs objects

public:
    /*
     * Get peakX attribute.
     * @return Mp7Jrsunsigned6Ptr
     */
    virtual Mp7Jrsunsigned6Ptr GetpeakX() const;

    /*
     * Get peakX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpeakX() const;

    /*
     * Set peakX attribute.
     * @param item const Mp7Jrsunsigned6Ptr &
     */
    virtual void SetpeakX(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate peakX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepeakX();

    /*
     * Get peakY attribute.
     * @return Mp7Jrsunsigned3Ptr
     */
    virtual Mp7Jrsunsigned3Ptr GetpeakY() const;

    /*
     * Get peakY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpeakY() const;

    /*
     * Set peakY attribute.
     * @param item const Mp7Jrsunsigned3Ptr &
     */
    virtual void SetpeakY(const Mp7Jrsunsigned3Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate peakY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepeakY();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsContourShapeType_Peak_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsContourShapeType_Peak_LocalType();

protected:
    Mp7JrsContourShapeType_Peak_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7Jrsunsigned6Ptr m_peakX;
    bool m_peakX_Exist;
    Mp7Jrsunsigned3Ptr m_peakY;
    bool m_peakY_Exist;



// no includefile for extension defined 
// file Mp7JrsContourShapeType_Peak_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _599MP7JRSCONTOURSHAPETYPE_PEAK_LOCALTYPE_H

