/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _605MP7JRSCONTROLLEDTERMUSETYPE_H
#define _605MP7JRSCONTROLLEDTERMUSETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsControlledTermUseTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// begin extension included
// file Mp7JrsControlledTermUseType_ExtInclude.h
	
	
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrstermReferenceType_LocalType.h"
#include "Mp7JrstermReferenceType_LocalType0.h"
#include "Mp7JrsTextualType.h"
#include "Mp7JrsTextualBaseType.h"


// end extension included


#include "Mp7JrsInlineTermDefinitionType.h"
class IMp7JrsControlledTermUseType;
class IMp7JrsInlineTermDefinitionType;
class IMp7JrsInlineTermDefinitionType_Definition_CollectionType;
class IMp7JrsInlineTermDefinitionType_Name_CollectionType;
class IMp7JrsInlineTermDefinitionType_Term_CollectionType;
class IMp7JrstermReferenceType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType> Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType > Mp7JrsInlineTermDefinitionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Definition_CollectionType > Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Name_CollectionType > Mp7JrsInlineTermDefinitionType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Term_CollectionType > Mp7JrsInlineTermDefinitionType_Term_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrstermReferenceType > Mp7JrstermReferencePtr;

/** 
 * Generated interface IMp7JrsControlledTermUseType for class Mp7JrsControlledTermUseType<br>
 * Located at: mds-2001.xsd, line 1510<br>
 * Classified: Class<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsControlledTermUseType 
 :
        public IMp7JrsInlineTermDefinitionType
{
public:
    // TODO: make these protected?
    IMp7JrsControlledTermUseType();
    virtual ~IMp7JrsControlledTermUseType();
    /**
     * Get href attribute.
     * @return Mp7JrstermReferencePtr
     */
    virtual Mp7JrstermReferencePtr Gethref() const = 0;

    /**
     * Set href attribute.
     * @param item const Mp7JrstermReferencePtr &
     */
    virtual void Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Name_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr GetDefinition() const = 0;

    /**
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Term_CollectionPtr GetTerm() const = 0;

    /**
     * Set Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// begin extension included
// file Mp7JrsControlledTermUseType_ExtMethodDef.h


public:
	/** Set a term reference, using a URN to reference the classification scheme.
	  * @param urn The URN of the classification scheme.
	  * @param term The term ID.
	  * @param name The name of the term (optional). If name is NULL, no name element will be written.
	  * @param client ID of the client modifying the element.
	  */
	virtual void SetTermReferenceURN(XMLCh* urn, XMLCh* term, XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Set a term reference, using a URI to reference the classification scheme.
	  * @param urn The URI of the classification scheme.
	  * @param term The term ID.
	  * @param name The name of the term (optional). If name is NULL, no name element will be written.
	  * @param client ID of the client modifying the element.
	  */
	virtual void SetTermReferenceAnyURI(XMLCh* uri, XMLCh* term, XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get a term reference.
	  * @param uri Contains the URI/URN of the classification scheme after return. 
	  *        The caller is responsible for releasing this string by calling XMLString::release().
	  * @param term Contains the term ID after return.
	  *        The caller is responsible for releasing this string by calling XMLString::release().
	  */
	virtual void GetTermReference(XMLCh** uri, XMLCh** term);


private:
	/** Set the name element for the term reference. */
	void SetTermName(XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);
// end extension included


// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsControlledTermUseType<br>
 * Located at: mds-2001.xsd, line 1510<br>
 * Classified: Class<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Defined in mds-2001.xsd, line 1510.<br>
 */
class MP7JRS_EXPORT Mp7JrsControlledTermUseType :
        public IMp7JrsControlledTermUseType
{
    friend class Mp7JrsControlledTermUseTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsControlledTermUseType
     
     * @return Mp7JrsPtr< Mp7JrsInlineTermDefinitionType >
     */
    virtual Mp7JrsPtr< Mp7JrsInlineTermDefinitionType > GetBase() const;
    /*
     * Get href attribute.
     * @return Mp7JrstermReferencePtr
     */
    virtual Mp7JrstermReferencePtr Gethref() const;

    /*
     * Set href attribute.
     * @param item const Mp7JrstermReferencePtr &
     */
    virtual void Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Name_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr GetDefinition() const;

    /*
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Term_CollectionPtr GetTerm() const;

    /*
     * Set Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsControlledTermUseType();

protected:
    Mp7JrsControlledTermUseType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrstermReferencePtr m_href;

    // Base Class
    Mp7JrsPtr< Mp7JrsInlineTermDefinitionType > m_Base;


// no includefile for extension defined 
// file Mp7JrsControlledTermUseType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _605MP7JRSCONTROLLEDTERMUSETYPE_H

