/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _609MP7JRSCREATIONDESCRIPTIONTYPE_H
#define _609MP7JRSCREATIONDESCRIPTIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCreationDescriptionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCreationDescriptionType_ExtInclude.h


#include "Mp7JrsCompleteDescriptionType.h"
#include "Mp7JrsContentManagementType.h"
class IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType;
class IMp7JrsCompleteDescriptionType_Relationships_CollectionType;
class IMp7JrsContentManagementType;
class IMp7JrsCreationDescriptionType;
class IMp7JrsCreationDescriptionType_CreationInformation_CollectionType;
class IMp7JrsDescriptionMetadataType;
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType > Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType_Relationships_CollectionType > Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsContentManagementType > Mp7JrsContentManagementPtr;
typedef Mp7JrsPtr< IMp7JrsCreationDescriptionType_CreationInformation_CollectionType > Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationDescriptionType> Mp7JrsCreationDescriptionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType > Mp7JrsDescriptionMetadataPtr;

/** 
 * Generated interface IMp7JrsCreationDescriptionType for class Mp7JrsCreationDescriptionType<br>
 * Located at: mds-2001.xsd, line 259<br>
 * Classified: Class<br>
 * Derived from: ContentManagementType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsCreationDescriptionType 
 :
        public IMp7JrsContentManagementType
{
public:
    // TODO: make these protected?
    IMp7JrsCreationDescriptionType();
    virtual ~IMp7JrsCreationDescriptionType();
        /** @name Sequence

         */
        //@{
    /**
     * Get CreationInformation element.
     * @return Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr
     */
    virtual Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr GetCreationInformation() const = 0;

    /**
     * Set CreationInformation element.
     * @param item const Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr &
     */
    virtual void SetCreationInformation(const Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsDescriptionMetadataPtr
     */
    virtual Mp7JrsDescriptionMetadataPtr GetDescriptionMetadata() const = 0;

    virtual bool IsValidDescriptionMetadata() const = 0;

    /**
     * Set DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsDescriptionMetadataPtr &
     */
    virtual void SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DescriptionMetadata element.
     * (Inherited from Mp7JrsCompleteDescriptionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDescriptionMetadata() = 0;

    /**
     * Get Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr GetRelationships() const = 0;

    /**
     * Set Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr &
     */
    virtual void SetRelationships(const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr GetOrderingKey() const = 0;

    /**
     * Set OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr &
     */
    virtual void SetOrderingKey(const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsCreationDescriptionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCreationDescriptionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCreationDescriptionType<br>
 * Located at: mds-2001.xsd, line 259<br>
 * Classified: Class<br>
 * Derived from: ContentManagementType (Class)<br>
 * Defined in mds-2001.xsd, line 259.<br>
 */
class MP7JRS_EXPORT Mp7JrsCreationDescriptionType :
        public IMp7JrsCreationDescriptionType
{
    friend class Mp7JrsCreationDescriptionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsCreationDescriptionType
     
     * @return Mp7JrsPtr< Mp7JrsContentManagementType >
     */
    virtual Mp7JrsPtr< Mp7JrsContentManagementType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get CreationInformation element.
     * @return Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr
     */
    virtual Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr GetCreationInformation() const;

    /*
     * Set CreationInformation element.
     * @param item const Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr &
     */
    virtual void SetCreationInformation(const Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsDescriptionMetadataPtr
     */
    virtual Mp7JrsDescriptionMetadataPtr GetDescriptionMetadata() const;

    virtual bool IsValidDescriptionMetadata() const;

    /*
     * Set DescriptionMetadata element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsDescriptionMetadataPtr &
     */
    virtual void SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DescriptionMetadata element.
     * (Inherited from Mp7JrsCompleteDescriptionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDescriptionMetadata();

    /*
     * Get Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr GetRelationships() const;

    /*
     * Set Relationships element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr &
     */
    virtual void SetRelationships(const Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @return Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr
     */
    virtual Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr GetOrderingKey() const;

    /*
     * Set OrderingKey element.
<br>
     * (Inherited from Mp7JrsCompleteDescriptionType)
     * @param item const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr &
     */
    virtual void SetOrderingKey(const Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCreationDescriptionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCreationDescriptionType();

protected:
    Mp7JrsCreationDescriptionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsContentManagementType > m_Base;

    Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr m_CreationInformation;

// no includefile for extension defined 
// file Mp7JrsCreationDescriptionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _609MP7JRSCREATIONDESCRIPTIONTYPE_H

