/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _617MP7JRSCREATIONPREFERENCESTYPE_H
#define _617MP7JRSCREATIONPREFERENCESTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCreationPreferencesTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsCreationPreferencesType;
class IMp7JrsCreationPreferencesType_Creator_CollectionType;
class IMp7JrsCreationPreferencesType_DatePeriod_CollectionType;
class IMp7JrsCreationPreferencesType_Keyword_CollectionType;
class IMp7JrsCreationPreferencesType_Location_CollectionType;
class IMp7JrsCreationPreferencesType_Title_CollectionType;
class IMp7JrsCreationPreferencesType_Tool_CollectionType;
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrspreferenceValueType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Creator_CollectionType > Mp7JrsCreationPreferencesType_Creator_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_DatePeriod_CollectionType > Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Keyword_CollectionType > Mp7JrsCreationPreferencesType_Keyword_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Location_CollectionType > Mp7JrsCreationPreferencesType_Location_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Title_CollectionType > Mp7JrsCreationPreferencesType_Title_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Tool_CollectionType > Mp7JrsCreationPreferencesType_Tool_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType> Mp7JrsCreationPreferencesPtr;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsCreationPreferencesType for class Mp7JrsCreationPreferencesType<br>
 * Located at: mds-2001.xsd, line 5915<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsCreationPreferencesType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsCreationPreferencesType();
    virtual ~IMp7JrsCreationPreferencesType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Title element.
     * @return Mp7JrsCreationPreferencesType_Title_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Title_CollectionPtr GetTitle() const = 0;

    /**
     * Set Title element.
     * @param item const Mp7JrsCreationPreferencesType_Title_CollectionPtr &
     */
    virtual void SetTitle(const Mp7JrsCreationPreferencesType_Title_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Creator element.
     * @return Mp7JrsCreationPreferencesType_Creator_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Creator_CollectionPtr GetCreator() const = 0;

    /**
     * Set Creator element.
     * @param item const Mp7JrsCreationPreferencesType_Creator_CollectionPtr &
     */
    virtual void SetCreator(const Mp7JrsCreationPreferencesType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Keyword element.
     * @return Mp7JrsCreationPreferencesType_Keyword_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Keyword_CollectionPtr GetKeyword() const = 0;

    /**
     * Set Keyword element.
     * @param item const Mp7JrsCreationPreferencesType_Keyword_CollectionPtr &
     */
    virtual void SetKeyword(const Mp7JrsCreationPreferencesType_Keyword_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Location element.
     * @return Mp7JrsCreationPreferencesType_Location_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Location_CollectionPtr GetLocation() const = 0;

    /**
     * Set Location element.
     * @param item const Mp7JrsCreationPreferencesType_Location_CollectionPtr &
     */
    virtual void SetLocation(const Mp7JrsCreationPreferencesType_Location_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DatePeriod element.
     * @return Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr GetDatePeriod() const = 0;

    /**
     * Set DatePeriod element.
     * @param item const Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr &
     */
    virtual void SetDatePeriod(const Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Tool element.
     * @return Mp7JrsCreationPreferencesType_Tool_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Tool_CollectionPtr GetTool() const = 0;

    /**
     * Set Tool element.
     * @param item const Mp7JrsCreationPreferencesType_Tool_CollectionPtr &
     */
    virtual void SetTool(const Mp7JrsCreationPreferencesType_Tool_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCreationPreferencesType<br>
 * Located at: mds-2001.xsd, line 5915<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 5915.<br>
 */
class MP7JRS_EXPORT Mp7JrsCreationPreferencesType :
        public IMp7JrsCreationPreferencesType
{
    friend class Mp7JrsCreationPreferencesTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsCreationPreferencesType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
    /*
     * Get Title element.
     * @return Mp7JrsCreationPreferencesType_Title_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Title_CollectionPtr GetTitle() const;

    /*
     * Set Title element.
     * @param item const Mp7JrsCreationPreferencesType_Title_CollectionPtr &
     */
    virtual void SetTitle(const Mp7JrsCreationPreferencesType_Title_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Creator element.
     * @return Mp7JrsCreationPreferencesType_Creator_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Creator_CollectionPtr GetCreator() const;

    /*
     * Set Creator element.
     * @param item const Mp7JrsCreationPreferencesType_Creator_CollectionPtr &
     */
    virtual void SetCreator(const Mp7JrsCreationPreferencesType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Keyword element.
     * @return Mp7JrsCreationPreferencesType_Keyword_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Keyword_CollectionPtr GetKeyword() const;

    /*
     * Set Keyword element.
     * @param item const Mp7JrsCreationPreferencesType_Keyword_CollectionPtr &
     */
    virtual void SetKeyword(const Mp7JrsCreationPreferencesType_Keyword_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Location element.
     * @return Mp7JrsCreationPreferencesType_Location_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Location_CollectionPtr GetLocation() const;

    /*
     * Set Location element.
     * @param item const Mp7JrsCreationPreferencesType_Location_CollectionPtr &
     */
    virtual void SetLocation(const Mp7JrsCreationPreferencesType_Location_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DatePeriod element.
     * @return Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr GetDatePeriod() const;

    /*
     * Set DatePeriod element.
     * @param item const Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr &
     */
    virtual void SetDatePeriod(const Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Tool element.
     * @return Mp7JrsCreationPreferencesType_Tool_CollectionPtr
     */
    virtual Mp7JrsCreationPreferencesType_Tool_CollectionPtr GetTool() const;

    /*
     * Set Tool element.
     * @param item const Mp7JrsCreationPreferencesType_Tool_CollectionPtr &
     */
    virtual void SetTool(const Mp7JrsCreationPreferencesType_Tool_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCreationPreferencesType();

protected:
    Mp7JrsCreationPreferencesType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsCreationPreferencesType_Title_CollectionPtr m_Title;
    Mp7JrsCreationPreferencesType_Creator_CollectionPtr m_Creator;
    Mp7JrsCreationPreferencesType_Keyword_CollectionPtr m_Keyword;
    Mp7JrsCreationPreferencesType_Location_CollectionPtr m_Location;
    Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr m_DatePeriod;
    Mp7JrsCreationPreferencesType_Tool_CollectionPtr m_Tool;

// no includefile for extension defined 
// file Mp7JrsCreationPreferencesType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _617MP7JRSCREATIONPREFERENCESTYPE_H

