/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _643MP7JRSCREATIONTOOLTYPE_H
#define _643MP7JRSCREATIONTOOLTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCreationToolTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCreationToolType_ExtInclude.h


class IMp7JrsCreationToolType;
class IMp7JrsCreationToolType_Setting_CollectionType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsCreationToolType_Setting_CollectionType > Mp7JrsCreationToolType_Setting_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationToolType> Mp7JrsCreationToolPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsCreationToolType for class Mp7JrsCreationToolType<br>
 * Located at: mds-2001.xsd, line 2584<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsCreationToolType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsCreationToolType();
    virtual ~IMp7JrsCreationToolType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Tool element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetTool() const = 0;

    /**
     * Set Tool element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetTool(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Setting element.
     * @return Mp7JrsCreationToolType_Setting_CollectionPtr
     */
    virtual Mp7JrsCreationToolType_Setting_CollectionPtr GetSetting() const = 0;

    /**
     * Set Setting element.
     * @param item const Mp7JrsCreationToolType_Setting_CollectionPtr &
     */
    virtual void SetSetting(const Mp7JrsCreationToolType_Setting_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsCreationToolType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCreationToolType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCreationToolType<br>
 * Located at: mds-2001.xsd, line 2584<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2584.<br>
 */
class MP7JRS_EXPORT Mp7JrsCreationToolType :
        public IMp7JrsCreationToolType
{
    friend class Mp7JrsCreationToolTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Tool element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetTool() const;

    /*
     * Set Tool element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetTool(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Setting element.
     * @return Mp7JrsCreationToolType_Setting_CollectionPtr
     */
    virtual Mp7JrsCreationToolType_Setting_CollectionPtr GetSetting() const;

    /*
     * Set Setting element.
     * @param item const Mp7JrsCreationToolType_Setting_CollectionPtr &
     */
    virtual void SetSetting(const Mp7JrsCreationToolType_Setting_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCreationToolType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCreationToolType();

protected:
    Mp7JrsCreationToolType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsTermUsePtr m_Tool;
    Mp7JrsCreationToolType_Setting_CollectionPtr m_Setting;

// no includefile for extension defined 
// file Mp7JrsCreationToolType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _643MP7JRSCREATIONTOOLTYPE_H

