/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _647MP7JRSCREATIONTOOLTYPE_SETTING_LOCALTYPE_H
#define _647MP7JRSCREATIONTOOLTYPE_SETTING_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCreationToolType_Setting_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCreationToolType_Setting_LocalType_ExtInclude.h


class IMp7JrsCreationToolType_Setting_LocalType;
typedef Mp7JrsPtr< IMp7JrsCreationToolType_Setting_LocalType> Mp7JrsCreationToolType_Setting_LocalPtr;

/** 
 * Generated interface IMp7JrsCreationToolType_Setting_LocalType for class Mp7JrsCreationToolType_Setting_LocalType<br>
 * Located at: mds-2001.xsd, line 2588<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsCreationToolType_Setting_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsCreationToolType_Setting_LocalType();
    virtual ~IMp7JrsCreationToolType_Setting_LocalType();
    /**
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const = 0;

    /**
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get value attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getvalue() const = 0;

    /**
     * Set value attribute.
     * @param item XMLCh *
     */
    virtual void Setvalue(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

// no includefile for extension defined 
// file Mp7JrsCreationToolType_Setting_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCreationToolType_Setting_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCreationToolType_Setting_LocalType<br>
 * Located at: mds-2001.xsd, line 2588<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2588.<br>
 */
class MP7JRS_EXPORT Mp7JrsCreationToolType_Setting_LocalType :
        public IMp7JrsCreationToolType_Setting_LocalType
{
    friend class Mp7JrsCreationToolType_Setting_LocalTypeFactory; // constructs objects

public:
    /*
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const;

    /*
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get value attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getvalue() const;

    /*
     * Set value attribute.
     * @param item XMLCh *
     */
    virtual void Setvalue(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCreationToolType_Setting_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCreationToolType_Setting_LocalType();

protected:
    Mp7JrsCreationToolType_Setting_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_name;
    XMLCh * m_value;



// no includefile for extension defined 
// file Mp7JrsCreationToolType_Setting_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _647MP7JRSCREATIONTOOLTYPE_SETTING_LOCALTYPE_H

