/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _649MP7JRSCREATIONTYPE_H
#define _649MP7JRSCREATIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCreationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCreationType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsCreationType;
class IMp7JrsCreationType_Abstract_CollectionType;
class IMp7JrsCreationType_CopyrightString_CollectionType;
class IMp7JrsCreationType_CreationCoordinates_CollectionType;
class IMp7JrsCreationType_CreationTool_CollectionType;
class IMp7JrsCreationType_Creator_CollectionType;
class IMp7JrsCreationType_Title_CollectionType;
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsTitleMediaType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsCreationType_Abstract_CollectionType > Mp7JrsCreationType_Abstract_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationType_CopyrightString_CollectionType > Mp7JrsCreationType_CopyrightString_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationType_CreationCoordinates_CollectionType > Mp7JrsCreationType_CreationCoordinates_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationType_CreationTool_CollectionType > Mp7JrsCreationType_CreationTool_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationType_Creator_CollectionType > Mp7JrsCreationType_Creator_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationType_Title_CollectionType > Mp7JrsCreationType_Title_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsCreationType> Mp7JrsCreationPtr;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsTitleMediaType > Mp7JrsTitleMediaPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsCreationType for class Mp7JrsCreationType<br>
 * Located at: mds-2001.xsd, line 2494<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsCreationType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsCreationType();
    virtual ~IMp7JrsCreationType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Title element.
     * @return Mp7JrsCreationType_Title_CollectionPtr
     */
    virtual Mp7JrsCreationType_Title_CollectionPtr GetTitle() const = 0;

    /**
     * Set Title element.
     * @param item const Mp7JrsCreationType_Title_CollectionPtr &
     */
    virtual void SetTitle(const Mp7JrsCreationType_Title_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TitleMedia element.
     * @return Mp7JrsTitleMediaPtr
     */
    virtual Mp7JrsTitleMediaPtr GetTitleMedia() const = 0;

    virtual bool IsValidTitleMedia() const = 0;

    /**
     * Set TitleMedia element.
     * @param item const Mp7JrsTitleMediaPtr &
     */
    virtual void SetTitleMedia(const Mp7JrsTitleMediaPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TitleMedia element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTitleMedia() = 0;

    /**
     * Get Abstract element.
     * @return Mp7JrsCreationType_Abstract_CollectionPtr
     */
    virtual Mp7JrsCreationType_Abstract_CollectionPtr GetAbstract() const = 0;

    /**
     * Set Abstract element.
     * @param item const Mp7JrsCreationType_Abstract_CollectionPtr &
     */
    virtual void SetAbstract(const Mp7JrsCreationType_Abstract_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Creator element.
     * @return Mp7JrsCreationType_Creator_CollectionPtr
     */
    virtual Mp7JrsCreationType_Creator_CollectionPtr GetCreator() const = 0;

    /**
     * Set Creator element.
     * @param item const Mp7JrsCreationType_Creator_CollectionPtr &
     */
    virtual void SetCreator(const Mp7JrsCreationType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CreationCoordinates element.
     * @return Mp7JrsCreationType_CreationCoordinates_CollectionPtr
     */
    virtual Mp7JrsCreationType_CreationCoordinates_CollectionPtr GetCreationCoordinates() const = 0;

    /**
     * Set CreationCoordinates element.
     * @param item const Mp7JrsCreationType_CreationCoordinates_CollectionPtr &
     */
    virtual void SetCreationCoordinates(const Mp7JrsCreationType_CreationCoordinates_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CreationTool element.
     * @return Mp7JrsCreationType_CreationTool_CollectionPtr
     */
    virtual Mp7JrsCreationType_CreationTool_CollectionPtr GetCreationTool() const = 0;

    /**
     * Set CreationTool element.
     * @param item const Mp7JrsCreationType_CreationTool_CollectionPtr &
     */
    virtual void SetCreationTool(const Mp7JrsCreationType_CreationTool_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CopyrightString element.
     * @return Mp7JrsCreationType_CopyrightString_CollectionPtr
     */
    virtual Mp7JrsCreationType_CopyrightString_CollectionPtr GetCopyrightString() const = 0;

    /**
     * Set CopyrightString element.
     * @param item const Mp7JrsCreationType_CopyrightString_CollectionPtr &
     */
    virtual void SetCopyrightString(const Mp7JrsCreationType_CopyrightString_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsCreationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCreationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCreationType<br>
 * Located at: mds-2001.xsd, line 2494<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 2494.<br>
 */
class MP7JRS_EXPORT Mp7JrsCreationType :
        public IMp7JrsCreationType
{
    friend class Mp7JrsCreationTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsCreationType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Title element.
     * @return Mp7JrsCreationType_Title_CollectionPtr
     */
    virtual Mp7JrsCreationType_Title_CollectionPtr GetTitle() const;

    /*
     * Set Title element.
     * @param item const Mp7JrsCreationType_Title_CollectionPtr &
     */
    virtual void SetTitle(const Mp7JrsCreationType_Title_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TitleMedia element.
     * @return Mp7JrsTitleMediaPtr
     */
    virtual Mp7JrsTitleMediaPtr GetTitleMedia() const;

    virtual bool IsValidTitleMedia() const;

    /*
     * Set TitleMedia element.
     * @param item const Mp7JrsTitleMediaPtr &
     */
    virtual void SetTitleMedia(const Mp7JrsTitleMediaPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TitleMedia element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTitleMedia();

    /*
     * Get Abstract element.
     * @return Mp7JrsCreationType_Abstract_CollectionPtr
     */
    virtual Mp7JrsCreationType_Abstract_CollectionPtr GetAbstract() const;

    /*
     * Set Abstract element.
     * @param item const Mp7JrsCreationType_Abstract_CollectionPtr &
     */
    virtual void SetAbstract(const Mp7JrsCreationType_Abstract_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Creator element.
     * @return Mp7JrsCreationType_Creator_CollectionPtr
     */
    virtual Mp7JrsCreationType_Creator_CollectionPtr GetCreator() const;

    /*
     * Set Creator element.
     * @param item const Mp7JrsCreationType_Creator_CollectionPtr &
     */
    virtual void SetCreator(const Mp7JrsCreationType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CreationCoordinates element.
     * @return Mp7JrsCreationType_CreationCoordinates_CollectionPtr
     */
    virtual Mp7JrsCreationType_CreationCoordinates_CollectionPtr GetCreationCoordinates() const;

    /*
     * Set CreationCoordinates element.
     * @param item const Mp7JrsCreationType_CreationCoordinates_CollectionPtr &
     */
    virtual void SetCreationCoordinates(const Mp7JrsCreationType_CreationCoordinates_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CreationTool element.
     * @return Mp7JrsCreationType_CreationTool_CollectionPtr
     */
    virtual Mp7JrsCreationType_CreationTool_CollectionPtr GetCreationTool() const;

    /*
     * Set CreationTool element.
     * @param item const Mp7JrsCreationType_CreationTool_CollectionPtr &
     */
    virtual void SetCreationTool(const Mp7JrsCreationType_CreationTool_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CopyrightString element.
     * @return Mp7JrsCreationType_CopyrightString_CollectionPtr
     */
    virtual Mp7JrsCreationType_CopyrightString_CollectionPtr GetCopyrightString() const;

    /*
     * Set CopyrightString element.
     * @param item const Mp7JrsCreationType_CopyrightString_CollectionPtr &
     */
    virtual void SetCopyrightString(const Mp7JrsCreationType_CopyrightString_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCreationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCreationType();

protected:
    Mp7JrsCreationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsCreationType_Title_CollectionPtr m_Title;
    Mp7JrsTitleMediaPtr m_TitleMedia;
    bool m_TitleMedia_Exist; // For optional elements 
    Mp7JrsCreationType_Abstract_CollectionPtr m_Abstract;
    Mp7JrsCreationType_Creator_CollectionPtr m_Creator;
    Mp7JrsCreationType_CreationCoordinates_CollectionPtr m_CreationCoordinates;
    Mp7JrsCreationType_CreationTool_CollectionPtr m_CreationTool;
    Mp7JrsCreationType_CopyrightString_CollectionPtr m_CopyrightString;

// no includefile for extension defined 
// file Mp7JrsCreationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _649MP7JRSCREATIONTYPE_H

