/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _657MP7JRSCREATIONTYPE_CREATIONCOORDINATES_LOCALTYPE_H
#define _657MP7JRSCREATIONTYPE_CREATIONCOORDINATES_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsCreationType_CreationCoordinates_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsCreationType_CreationCoordinates_LocalType_ExtInclude.h


class IMp7JrsCreationType_CreationCoordinates_LocalType;
class IMp7JrsPlaceType;
class IMp7JrsTimeType;
typedef Mp7JrsPtr< IMp7JrsCreationType_CreationCoordinates_LocalType> Mp7JrsCreationType_CreationCoordinates_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsTimeType > Mp7JrsTimePtr;

/** 
 * Generated interface IMp7JrsCreationType_CreationCoordinates_LocalType for class Mp7JrsCreationType_CreationCoordinates_LocalType<br>
 * Located at: mds-2001.xsd, line 2503<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsCreationType_CreationCoordinates_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsCreationType_CreationCoordinates_LocalType();
    virtual ~IMp7JrsCreationType_CreationCoordinates_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Location element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetLocation() const = 0;

    virtual bool IsValidLocation() const = 0;

    /**
     * Set Location element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetLocation(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Location element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLocation() = 0;

    /**
     * Get Date element.
     * @return Mp7JrsTimePtr
     */
    virtual Mp7JrsTimePtr GetDate() const = 0;

    virtual bool IsValidDate() const = 0;

    /**
     * Set Date element.
     * @param item const Mp7JrsTimePtr &
     */
    virtual void SetDate(const Mp7JrsTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Date element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDate() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsCreationType_CreationCoordinates_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsCreationType_CreationCoordinates_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsCreationType_CreationCoordinates_LocalType<br>
 * Located at: mds-2001.xsd, line 2503<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2503.<br>
 */
class MP7JRS_EXPORT Mp7JrsCreationType_CreationCoordinates_LocalType :
        public IMp7JrsCreationType_CreationCoordinates_LocalType
{
    friend class Mp7JrsCreationType_CreationCoordinates_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Location element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetLocation() const;

    virtual bool IsValidLocation() const;

    /*
     * Set Location element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetLocation(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Location element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLocation();

    /*
     * Get Date element.
     * @return Mp7JrsTimePtr
     */
    virtual Mp7JrsTimePtr GetDate() const;

    virtual bool IsValidDate() const;

    /*
     * Set Date element.
     * @param item const Mp7JrsTimePtr &
     */
    virtual void SetDate(const Mp7JrsTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Date element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDate();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsCreationType_CreationCoordinates_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsCreationType_CreationCoordinates_LocalType();

protected:
    Mp7JrsCreationType_CreationCoordinates_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsPlacePtr m_Location;
    bool m_Location_Exist; // For optional elements 
    Mp7JrsTimePtr m_Date;
    bool m_Date_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsCreationType_CreationCoordinates_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _657MP7JRSCREATIONTYPE_CREATIONCOORDINATES_LOCALTYPE_H

