/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _685MP7JRSDEPENDENCYSTRUCTUREPHRASETYPE_H
#define _685MP7JRSDEPENDENCYSTRUCTUREPHRASETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDependencyStructurePhraseTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_ExtInclude.h


class IMp7JrsDependencyStructurePhraseType;
class IMp7JrsDependencyStructurePhraseType_CollectionType;
class IMp7JrsDependencyStructurePhraseType_CollectionType0;
class IMp7JrsDependencyStructurePhraseType_operator_LocalType2;
class IMp7JrsNonDependencyStructurePhraseType;
class IMp7JrsWordFormType;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_CollectionType > Mp7JrsDependencyStructurePhraseType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_CollectionType0 > Mp7JrsDependencyStructurePhraseType_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_operator_LocalType2 > Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType> Mp7JrsDependencyStructurePhrasePtr;
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType > Mp7JrsNonDependencyStructurePhrasePtr;
typedef Mp7JrsPtr< IMp7JrsWordFormType > Mp7JrsWordFormPtr;

/** 
 * Generated interface IMp7JrsDependencyStructurePhraseType for class Mp7JrsDependencyStructurePhraseType<br>
 * Located at: mds-2001.xsd, line 1244<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsDependencyStructurePhraseType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsDependencyStructurePhraseType();
    virtual ~IMp7JrsDependencyStructurePhraseType();
    /**
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get equal attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getequal() const = 0;

    /**
     * Get equal attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existequal() const = 0;

    /**
     * Set equal attribute.
     * @param item XMLCh *
     */
    virtual void Setequal(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate equal attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateequal() = 0;

    /**
     * Get operator attribute.
     * @return Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr
     */
    virtual Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr Getoperator() const = 0;

    /**
     * Get operator attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existoperator() const = 0;

    /**
     * Set operator attribute.
     * @param item const Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr &
     */
    virtual void Setoperator(const Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate operator attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateoperator() = 0;

    /**
     * Get functionWord attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetfunctionWord() const = 0;

    /**
     * Get functionWord attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistfunctionWord() const = 0;

    /**
     * Set functionWord attribute.
     * @param item XMLCh *
     */
    virtual void SetfunctionWord(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate functionWord attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatefunctionWord() = 0;

    /**
     * Get synthesis attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getsynthesis() const = 0;

    /**
     * Get synthesis attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsynthesis() const = 0;

    /**
     * Set synthesis attribute.
     * @param item XMLCh *
     */
    virtual void Setsynthesis(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate synthesis attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesynthesis() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get DependencyStructurePhraseType_LocalType element.
     * @return Mp7JrsDependencyStructurePhraseType_CollectionPtr
     */
    virtual Mp7JrsDependencyStructurePhraseType_CollectionPtr GetDependencyStructurePhraseType_LocalType() const = 0;

    /**
     * Set DependencyStructurePhraseType_LocalType element.
     * @param item const Mp7JrsDependencyStructurePhraseType_CollectionPtr &
     */
    virtual void SetDependencyStructurePhraseType_LocalType(const Mp7JrsDependencyStructurePhraseType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Head element.
     * @return Mp7JrsWordFormPtr
     */
    virtual Mp7JrsWordFormPtr GetHead() const = 0;

    /**
     * Set Head element.
     * @param item const Mp7JrsWordFormPtr &
     */
    virtual void SetHead(const Mp7JrsWordFormPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CompoundHead element.
     * @return Mp7JrsNonDependencyStructurePhrasePtr
     */
    virtual Mp7JrsNonDependencyStructurePhrasePtr GetCompoundHead() const = 0;

    /**
     * Set CompoundHead element.
     * @param item const Mp7JrsNonDependencyStructurePhrasePtr &
     */
    virtual void SetCompoundHead(const Mp7JrsNonDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get DependencyStructurePhraseType_LocalType0 element.
     * @return Mp7JrsDependencyStructurePhraseType_Collection0Ptr
     */
    virtual Mp7JrsDependencyStructurePhraseType_Collection0Ptr GetDependencyStructurePhraseType_LocalType0() const = 0;

    /**
     * Set DependencyStructurePhraseType_LocalType0 element.
     * @param item const Mp7JrsDependencyStructurePhraseType_Collection0Ptr &
     */
    virtual void SetDependencyStructurePhraseType_LocalType0(const Mp7JrsDependencyStructurePhraseType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDependencyStructurePhraseType<br>
 * Located at: mds-2001.xsd, line 1244<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1244.<br>
 */
class MP7JRS_EXPORT Mp7JrsDependencyStructurePhraseType :
        public IMp7JrsDependencyStructurePhraseType
{
    friend class Mp7JrsDependencyStructurePhraseTypeFactory; // constructs objects

public:
    /*
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get equal attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getequal() const;

    /*
     * Get equal attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existequal() const;

    /*
     * Set equal attribute.
     * @param item XMLCh *
     */
    virtual void Setequal(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate equal attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateequal();

    /*
     * Get operator attribute.
     * @return Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr
     */
    virtual Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr Getoperator() const;

    /*
     * Get operator attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existoperator() const;

    /*
     * Set operator attribute.
     * @param item const Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr &
     */
    virtual void Setoperator(const Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate operator attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateoperator();

    /*
     * Get functionWord attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetfunctionWord() const;

    /*
     * Get functionWord attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistfunctionWord() const;

    /*
     * Set functionWord attribute.
     * @param item XMLCh *
     */
    virtual void SetfunctionWord(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate functionWord attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatefunctionWord();

    /*
     * Get synthesis attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getsynthesis() const;

    /*
     * Get synthesis attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsynthesis() const;

    /*
     * Set synthesis attribute.
     * @param item XMLCh *
     */
    virtual void Setsynthesis(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate synthesis attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesynthesis();

        /* @name Sequence

         */
        //@{
    /*
     * Get DependencyStructurePhraseType_LocalType element.
     * @return Mp7JrsDependencyStructurePhraseType_CollectionPtr
     */
    virtual Mp7JrsDependencyStructurePhraseType_CollectionPtr GetDependencyStructurePhraseType_LocalType() const;

    /*
     * Set DependencyStructurePhraseType_LocalType element.
     * @param item const Mp7JrsDependencyStructurePhraseType_CollectionPtr &
     */
    virtual void SetDependencyStructurePhraseType_LocalType(const Mp7JrsDependencyStructurePhraseType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Choice

         */
        //@{
    /*
     * Get Head element.
     * @return Mp7JrsWordFormPtr
     */
    virtual Mp7JrsWordFormPtr GetHead() const;

    /*
     * Set Head element.
     * @param item const Mp7JrsWordFormPtr &
     */
    virtual void SetHead(const Mp7JrsWordFormPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CompoundHead element.
     * @return Mp7JrsNonDependencyStructurePhrasePtr
     */
    virtual Mp7JrsNonDependencyStructurePhrasePtr GetCompoundHead() const;

    /*
     * Set CompoundHead element.
     * @param item const Mp7JrsNonDependencyStructurePhrasePtr &
     */
    virtual void SetCompoundHead(const Mp7JrsNonDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get DependencyStructurePhraseType_LocalType0 element.
     * @return Mp7JrsDependencyStructurePhraseType_Collection0Ptr
     */
    virtual Mp7JrsDependencyStructurePhraseType_Collection0Ptr GetDependencyStructurePhraseType_LocalType0() const;

    /*
     * Set DependencyStructurePhraseType_LocalType0 element.
     * @param item const Mp7JrsDependencyStructurePhraseType_Collection0Ptr &
     */
    virtual void SetDependencyStructurePhraseType_LocalType0(const Mp7JrsDependencyStructurePhraseType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDependencyStructurePhraseType();

protected:
    Mp7JrsDependencyStructurePhraseType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_id;
    bool m_id_Exist;
    XMLCh * m_equal;
    bool m_equal_Exist;
    Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr m_operator;
    bool m_operator_Exist;
    XMLCh * m_functionWord;
    bool m_functionWord_Exist;
    XMLCh * m_synthesis;
    bool m_synthesis_Exist;


    Mp7JrsDependencyStructurePhraseType_CollectionPtr m_DependencyStructurePhraseType_LocalType;
// DefinionChoice
    Mp7JrsWordFormPtr m_Head;
    Mp7JrsNonDependencyStructurePhrasePtr m_CompoundHead;
// End DefinionChoice
    Mp7JrsDependencyStructurePhraseType_Collection0Ptr m_DependencyStructurePhraseType_LocalType0;

// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _685MP7JRSDEPENDENCYSTRUCTUREPHRASETYPE_H

