/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _703MP7JRSDEPENDENCYSTRUCTURETYPE_H
#define _703MP7JRSDEPENDENCYSTRUCTURETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDependencyStructureTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsDependencyStructureType_ExtInclude.h


class IMp7JrsDependencyStructureType;
class IMp7JrsDependencyStructureType_Sentence_CollectionType;
typedef Mp7JrsPtr< IMp7JrsDependencyStructureType_Sentence_CollectionType > Mp7JrsDependencyStructureType_Sentence_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDependencyStructureType> Mp7JrsDependencyStructurePtr;

/** 
 * Generated interface IMp7JrsDependencyStructureType for class Mp7JrsDependencyStructureType<br>
 * Located at: mds-2001.xsd, line 1237<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsDependencyStructureType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsDependencyStructureType();
    virtual ~IMp7JrsDependencyStructureType();
    /**
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Sentence element.
     * @return Mp7JrsDependencyStructureType_Sentence_CollectionPtr
     */
    virtual Mp7JrsDependencyStructureType_Sentence_CollectionPtr GetSentence() const = 0;

    /**
     * Set Sentence element.
     * @param item const Mp7JrsDependencyStructureType_Sentence_CollectionPtr &
     */
    virtual void SetSentence(const Mp7JrsDependencyStructureType_Sentence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsDependencyStructureType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDependencyStructureType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDependencyStructureType<br>
 * Located at: mds-2001.xsd, line 1237<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1237.<br>
 */
class MP7JRS_EXPORT Mp7JrsDependencyStructureType :
        public IMp7JrsDependencyStructureType
{
    friend class Mp7JrsDependencyStructureTypeFactory; // constructs objects

public:
    /*
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get Sentence element.
     * @return Mp7JrsDependencyStructureType_Sentence_CollectionPtr
     */
    virtual Mp7JrsDependencyStructureType_Sentence_CollectionPtr GetSentence() const;

    /*
     * Set Sentence element.
     * @param item const Mp7JrsDependencyStructureType_Sentence_CollectionPtr &
     */
    virtual void SetSentence(const Mp7JrsDependencyStructureType_Sentence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDependencyStructureType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDependencyStructureType();

protected:
    Mp7JrsDependencyStructureType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_lang;
    bool m_lang_Exist;


    Mp7JrsDependencyStructureType_Sentence_CollectionPtr m_Sentence;

// no includefile for extension defined 
// file Mp7JrsDependencyStructureType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _703MP7JRSDEPENDENCYSTRUCTURETYPE_H

