/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _707MP7JRSDESCRIPTIONMETADATATYPE_H
#define _707MP7JRSDESCRIPTIONMETADATATYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDescriptionMetadataTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDescriptionMetadataType;
class IMp7JrsDescriptionMetadataType_Creator_CollectionType;
class IMp7JrsDescriptionMetadataType_Instrument_CollectionType;
class IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType;
class IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType;
class IMp7JrsHeaderType;
class IMp7JrsPackageType;
class IMp7JrsPlaceType;
class IMp7JrsRightsType;
class IMp7JrsTextAnnotationType;
class IMp7JrstimePointType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_Creator_CollectionType > Mp7JrsDescriptionMetadataType_Creator_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_Instrument_CollectionType > Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType > Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType > Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType> Mp7JrsDescriptionMetadataPtr;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsPackageType > Mp7JrsPackagePtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsRightsType > Mp7JrsRightsPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsDescriptionMetadataType for class Mp7JrsDescriptionMetadataType<br>
 * Located at: mds-2001.xsd, line 415<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsDescriptionMetadataType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsDescriptionMetadataType();
    virtual ~IMp7JrsDescriptionMetadataType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Confidence element.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr GetConfidence() const = 0;

    virtual bool IsValidConfidence() const = 0;

    /**
     * Set Confidence element.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void SetConfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Confidence element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateConfidence() = 0;

    /**
     * Get Version element.
     * @return XMLCh *
     */
    virtual XMLCh * GetVersion() const = 0;

    virtual bool IsValidVersion() const = 0;

    /**
     * Set Version element.
     * @param item XMLCh *
     */
    virtual void SetVersion(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Version element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVersion() = 0;

    /**
     * Get LastUpdate element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetLastUpdate() const = 0;

    virtual bool IsValidLastUpdate() const = 0;

    /**
     * Set LastUpdate element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetLastUpdate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate LastUpdate element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLastUpdate() = 0;

    /**
     * Get Comment element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetComment() const = 0;

    virtual bool IsValidComment() const = 0;

    /**
     * Set Comment element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetComment(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Comment element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateComment() = 0;

    /**
     * Get PublicIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr GetPublicIdentifier() const = 0;

    /**
     * Set PublicIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr &
     */
    virtual void SetPublicIdentifier(const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PrivateIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr GetPrivateIdentifier() const = 0;

    /**
     * Set PrivateIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr &
     */
    virtual void SetPrivateIdentifier(const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Creator element.
     * @return Mp7JrsDescriptionMetadataType_Creator_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Creator_CollectionPtr GetCreator() const = 0;

    /**
     * Set Creator element.
     * @param item const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr &
     */
    virtual void SetCreator(const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CreationLocation element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetCreationLocation() const = 0;

    virtual bool IsValidCreationLocation() const = 0;

    /**
     * Set CreationLocation element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetCreationLocation(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate CreationLocation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationLocation() = 0;

    /**
     * Get CreationTime element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetCreationTime() const = 0;

    virtual bool IsValidCreationTime() const = 0;

    /**
     * Set CreationTime element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetCreationTime(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate CreationTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationTime() = 0;

    /**
     * Get Instrument element.
     * @return Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr GetInstrument() const = 0;

    /**
     * Set Instrument element.
     * @param item const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr &
     */
    virtual void SetInstrument(const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Rights element.
     * @return Mp7JrsRightsPtr
     */
    virtual Mp7JrsRightsPtr GetRights() const = 0;

    virtual bool IsValidRights() const = 0;

    /**
     * Set Rights element.
     * @param item const Mp7JrsRightsPtr &
     */
    virtual void SetRights(const Mp7JrsRightsPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Rights element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRights() = 0;

    /**
     * Get Package element.
     * @return Mp7JrsPackagePtr
     */
    virtual Mp7JrsPackagePtr GetPackage() const = 0;

    virtual bool IsValidPackage() const = 0;

    /**
     * Set Package element.
     * @param item const Mp7JrsPackagePtr &
     */
    virtual void SetPackage(const Mp7JrsPackagePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Package element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePackage() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDescriptionMetadataType<br>
 * Located at: mds-2001.xsd, line 415<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in mds-2001.xsd, line 415.<br>
 */
class MP7JRS_EXPORT Mp7JrsDescriptionMetadataType :
        public IMp7JrsDescriptionMetadataType
{
    friend class Mp7JrsDescriptionMetadataTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsDescriptionMetadataType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Confidence element.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr GetConfidence() const;

    virtual bool IsValidConfidence() const;

    /*
     * Set Confidence element.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void SetConfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Confidence element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateConfidence();

    /*
     * Get Version element.
     * @return XMLCh *
     */
    virtual XMLCh * GetVersion() const;

    virtual bool IsValidVersion() const;

    /*
     * Set Version element.
     * @param item XMLCh *
     */
    virtual void SetVersion(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Version element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVersion();

    /*
     * Get LastUpdate element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetLastUpdate() const;

    virtual bool IsValidLastUpdate() const;

    /*
     * Set LastUpdate element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetLastUpdate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate LastUpdate element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLastUpdate();

    /*
     * Get Comment element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetComment() const;

    virtual bool IsValidComment() const;

    /*
     * Set Comment element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetComment(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Comment element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateComment();

    /*
     * Get PublicIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr GetPublicIdentifier() const;

    /*
     * Set PublicIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr &
     */
    virtual void SetPublicIdentifier(const Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PrivateIdentifier element.
     * @return Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr GetPrivateIdentifier() const;

    /*
     * Set PrivateIdentifier element.
     * @param item const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr &
     */
    virtual void SetPrivateIdentifier(const Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Creator element.
     * @return Mp7JrsDescriptionMetadataType_Creator_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Creator_CollectionPtr GetCreator() const;

    /*
     * Set Creator element.
     * @param item const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr &
     */
    virtual void SetCreator(const Mp7JrsDescriptionMetadataType_Creator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CreationLocation element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetCreationLocation() const;

    virtual bool IsValidCreationLocation() const;

    /*
     * Set CreationLocation element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetCreationLocation(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate CreationLocation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationLocation();

    /*
     * Get CreationTime element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetCreationTime() const;

    virtual bool IsValidCreationTime() const;

    /*
     * Set CreationTime element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetCreationTime(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate CreationTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCreationTime();

    /*
     * Get Instrument element.
     * @return Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr
     */
    virtual Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr GetInstrument() const;

    /*
     * Set Instrument element.
     * @param item const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr &
     */
    virtual void SetInstrument(const Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Rights element.
     * @return Mp7JrsRightsPtr
     */
    virtual Mp7JrsRightsPtr GetRights() const;

    virtual bool IsValidRights() const;

    /*
     * Set Rights element.
     * @param item const Mp7JrsRightsPtr &
     */
    virtual void SetRights(const Mp7JrsRightsPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Rights element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRights();

    /*
     * Get Package element.
     * @return Mp7JrsPackagePtr
     */
    virtual Mp7JrsPackagePtr GetPackage() const;

    virtual bool IsValidPackage() const;

    /*
     * Set Package element.
     * @param item const Mp7JrsPackagePtr &
     */
    virtual void SetPackage(const Mp7JrsPackagePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Package element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePackage();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDescriptionMetadataType();

protected:
    Mp7JrsDescriptionMetadataType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    Mp7JrszeroToOnePtr m_Confidence;
    bool m_Confidence_Exist; // For optional elements 
    XMLCh * m_Version;
    bool m_Version_Exist; // For optional elements 
    Mp7JrstimePointPtr m_LastUpdate;
    bool m_LastUpdate_Exist; // For optional elements 
    Mp7JrsTextAnnotationPtr m_Comment;
    bool m_Comment_Exist; // For optional elements 
    Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr m_PublicIdentifier;
    Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr m_PrivateIdentifier;
    Mp7JrsDescriptionMetadataType_Creator_CollectionPtr m_Creator;
    Mp7JrsPlacePtr m_CreationLocation;
    bool m_CreationLocation_Exist; // For optional elements 
    Mp7JrstimePointPtr m_CreationTime;
    bool m_CreationTime_Exist; // For optional elements 
    Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr m_Instrument;
    Mp7JrsRightsPtr m_Rights;
    bool m_Rights_Exist; // For optional elements 
    Mp7JrsPackagePtr m_Package;
    bool m_Package_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsDescriptionMetadataType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _707MP7JRSDESCRIPTIONMETADATATYPE_H

