/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _737MP7JRSDISCRETEHIDDENMARKOVMODELTYPE_LOCALTYPE_H
#define _737MP7JRSDISCRETEHIDDENMARKOVMODELTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_LocalType_ExtInclude.h


class IMp7JrsDiscreteDistributionType;
class IMp7JrsDiscreteHiddenMarkovModelType_LocalType;
class IMp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType;
typedef Mp7JrsPtr< IMp7JrsDiscreteDistributionType > Mp7JrsDiscreteDistributionPtr;
typedef Mp7JrsPtr< IMp7JrsDiscreteHiddenMarkovModelType_LocalType> Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType > Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr;

/** 
 * Generated interface IMp7JrsDiscreteHiddenMarkovModelType_LocalType for class Mp7JrsDiscreteHiddenMarkovModelType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsDiscreteHiddenMarkovModelType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsDiscreteHiddenMarkovModelType_LocalType();
    virtual ~IMp7JrsDiscreteHiddenMarkovModelType_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get NumOfObservationsPerState element.
     * @return unsigned
     */
    virtual unsigned GetNumOfObservationsPerState() const = 0;

    /**
     * Set NumOfObservationsPerState element.
     * @param item unsigned
     */
    virtual void SetNumOfObservationsPerState(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Observation element.
     * @return Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr
     */
    virtual Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr GetObservation() const = 0;

    /**
     * Set Observation element.
     * @param item const Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr &
     */
    virtual void SetObservation(const Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ObservationDistribution element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetObservationDistribution() const = 0;

    /**
     * Set ObservationDistribution element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * </ul>
     */
    virtual void SetObservationDistribution(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDiscreteHiddenMarkovModelType_LocalType<br>
 * Defined in mds-2001.xsd, line 5631.<br>
 */
class MP7JRS_EXPORT Mp7JrsDiscreteHiddenMarkovModelType_LocalType :
        public IMp7JrsDiscreteHiddenMarkovModelType_LocalType
{
    friend class Mp7JrsDiscreteHiddenMarkovModelType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get NumOfObservationsPerState element.
     * @return unsigned
     */
    virtual unsigned GetNumOfObservationsPerState() const;

    /*
     * Set NumOfObservationsPerState element.
     * @param item unsigned
     */
    virtual void SetNumOfObservationsPerState(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Observation element.
     * @return Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr
     */
    virtual Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr GetObservation() const;

    /*
     * Set Observation element.
     * @param item const Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr &
     */
    virtual void SetObservation(const Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ObservationDistribution element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetObservationDistribution() const;

    /*
     * Set ObservationDistribution element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * </ul>
     */
    virtual void SetObservationDistribution(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDiscreteHiddenMarkovModelType_LocalType();

protected:
    Mp7JrsDiscreteHiddenMarkovModelType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    unsigned m_NumOfObservationsPerState;
    Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr m_Observation;
    Mp7JrsPtr< Mp7JrsNode > m_ObservationDistribution;

// no includefile for extension defined 
// file Mp7JrsDiscreteHiddenMarkovModelType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _737MP7JRSDISCRETEHIDDENMARKOVMODELTYPE_LOCALTYPE_H

