/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _745MP7JRSDOMINANTCOLORTYPE_H
#define _745MP7JRSDOMINANTCOLORTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDominantColorTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsDominantColorType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsColorQuantizationType;
class IMp7JrsColorSpaceType;
class IMp7JrsDominantColorType;
class IMp7JrsDominantColorType_Value_CollectionType;
class IMp7Jrsunsigned5;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsColorQuantizationType > Mp7JrsColorQuantizationPtr;
typedef Mp7JrsPtr< IMp7JrsColorSpaceType > Mp7JrsColorSpacePtr;
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_CollectionType > Mp7JrsDominantColorType_Value_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDominantColorType> Mp7JrsDominantColorPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned5 > Mp7Jrsunsigned5Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsDominantColorType for class Mp7JrsDominantColorType<br>
 * Located at: visual-2001.xsd, line 299<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsDominantColorType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsDominantColorType();
    virtual ~IMp7JrsDominantColorType();
        /** @name Sequence

         */
        //@{
    /**
     * Get ColorSpace element.
     * @return Mp7JrsColorSpacePtr
     */
    virtual Mp7JrsColorSpacePtr GetColorSpace() const = 0;

    virtual bool IsValidColorSpace() const = 0;

    /**
     * Set ColorSpace element.
     * @param item const Mp7JrsColorSpacePtr &
     */
    virtual void SetColorSpace(const Mp7JrsColorSpacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ColorSpace element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorSpace() = 0;

    /**
     * Get ColorQuantization element.
     * @return Mp7JrsColorQuantizationPtr
     */
    virtual Mp7JrsColorQuantizationPtr GetColorQuantization() const = 0;

    virtual bool IsValidColorQuantization() const = 0;

    /**
     * Set ColorQuantization element.
     * @param item const Mp7JrsColorQuantizationPtr &
     */
    virtual void SetColorQuantization(const Mp7JrsColorQuantizationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ColorQuantization element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorQuantization() = 0;

    /**
     * Get SpatialCoherency element.
     * @return Mp7Jrsunsigned5Ptr
     */
    virtual Mp7Jrsunsigned5Ptr GetSpatialCoherency() const = 0;

    /**
     * Set SpatialCoherency element.
     * @param item const Mp7Jrsunsigned5Ptr &
     */
    virtual void SetSpatialCoherency(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Value element.
     * @return Mp7JrsDominantColorType_Value_CollectionPtr
     */
    virtual Mp7JrsDominantColorType_Value_CollectionPtr GetValue() const = 0;

    /**
     * Set Value element.
     * @param item const Mp7JrsDominantColorType_Value_CollectionPtr &
     */
    virtual void SetValue(const Mp7JrsDominantColorType_Value_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsDominantColorType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDominantColorType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDominantColorType<br>
 * Located at: visual-2001.xsd, line 299<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 299.<br>
 */
class MP7JRS_EXPORT Mp7JrsDominantColorType :
        public IMp7JrsDominantColorType
{
    friend class Mp7JrsDominantColorTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsDominantColorType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get ColorSpace element.
     * @return Mp7JrsColorSpacePtr
     */
    virtual Mp7JrsColorSpacePtr GetColorSpace() const;

    virtual bool IsValidColorSpace() const;

    /*
     * Set ColorSpace element.
     * @param item const Mp7JrsColorSpacePtr &
     */
    virtual void SetColorSpace(const Mp7JrsColorSpacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ColorSpace element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorSpace();

    /*
     * Get ColorQuantization element.
     * @return Mp7JrsColorQuantizationPtr
     */
    virtual Mp7JrsColorQuantizationPtr GetColorQuantization() const;

    virtual bool IsValidColorQuantization() const;

    /*
     * Set ColorQuantization element.
     * @param item const Mp7JrsColorQuantizationPtr &
     */
    virtual void SetColorQuantization(const Mp7JrsColorQuantizationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ColorQuantization element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorQuantization();

    /*
     * Get SpatialCoherency element.
     * @return Mp7Jrsunsigned5Ptr
     */
    virtual Mp7Jrsunsigned5Ptr GetSpatialCoherency() const;

    /*
     * Set SpatialCoherency element.
     * @param item const Mp7Jrsunsigned5Ptr &
     */
    virtual void SetSpatialCoherency(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Value element.
     * @return Mp7JrsDominantColorType_Value_CollectionPtr
     */
    virtual Mp7JrsDominantColorType_Value_CollectionPtr GetValue() const;

    /*
     * Set Value element.
     * @param item const Mp7JrsDominantColorType_Value_CollectionPtr &
     */
    virtual void SetValue(const Mp7JrsDominantColorType_Value_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDominantColorType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDominantColorType();

protected:
    Mp7JrsDominantColorType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsColorSpacePtr m_ColorSpace;
    bool m_ColorSpace_Exist; // For optional elements 
    Mp7JrsColorQuantizationPtr m_ColorQuantization;
    bool m_ColorQuantization_Exist; // For optional elements 
    Mp7Jrsunsigned5Ptr m_SpatialCoherency;
    Mp7JrsDominantColorType_Value_CollectionPtr m_Value;

// no includefile for extension defined 
// file Mp7JrsDominantColorType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _745MP7JRSDOMINANTCOLORTYPE_H

