/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _757MP7JRSDOMINANTCOLORTYPE_VALUE_LOCALTYPE_H
#define _757MP7JRSDOMINANTCOLORTYPE_VALUE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDominantColorType_Value_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtInclude.h


class IMp7JrsDominantColorType_Value_ColorVariance_LocalType;
class IMp7JrsDominantColorType_Value_Index_LocalType;
class IMp7JrsDominantColorType_Value_LocalType;
class IMp7Jrsunsigned5;
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_ColorVariance_LocalType > Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_Index_LocalType > Mp7JrsDominantColorType_Value_Index_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_LocalType> Mp7JrsDominantColorType_Value_LocalPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned5 > Mp7Jrsunsigned5Ptr;

/** 
 * Generated interface IMp7JrsDominantColorType_Value_LocalType for class Mp7JrsDominantColorType_Value_LocalType<br>
 * Located at: visual-2001.xsd, line 307<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsDominantColorType_Value_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsDominantColorType_Value_LocalType();
    virtual ~IMp7JrsDominantColorType_Value_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Percentage element.
     * @return Mp7Jrsunsigned5Ptr
     */
    virtual Mp7Jrsunsigned5Ptr GetPercentage() const = 0;

    /**
     * Set Percentage element.
     * @param item const Mp7Jrsunsigned5Ptr &
     */
    virtual void SetPercentage(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Index element.
     * @return Mp7JrsDominantColorType_Value_Index_LocalPtr
     */
    virtual Mp7JrsDominantColorType_Value_Index_LocalPtr GetIndex() const = 0;

    /**
     * Set Index element.
     * @param item const Mp7JrsDominantColorType_Value_Index_LocalPtr &
     */
    virtual void SetIndex(const Mp7JrsDominantColorType_Value_Index_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ColorVariance element.
     * @return Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr
     */
    virtual Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr GetColorVariance() const = 0;

    virtual bool IsValidColorVariance() const = 0;

    /**
     * Set ColorVariance element.
     * @param item const Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr &
     */
    virtual void SetColorVariance(const Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ColorVariance element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorVariance() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDominantColorType_Value_LocalType<br>
 * Located at: visual-2001.xsd, line 307<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 307.<br>
 */
class MP7JRS_EXPORT Mp7JrsDominantColorType_Value_LocalType :
        public IMp7JrsDominantColorType_Value_LocalType
{
    friend class Mp7JrsDominantColorType_Value_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Percentage element.
     * @return Mp7Jrsunsigned5Ptr
     */
    virtual Mp7Jrsunsigned5Ptr GetPercentage() const;

    /*
     * Set Percentage element.
     * @param item const Mp7Jrsunsigned5Ptr &
     */
    virtual void SetPercentage(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Index element.
     * @return Mp7JrsDominantColorType_Value_Index_LocalPtr
     */
    virtual Mp7JrsDominantColorType_Value_Index_LocalPtr GetIndex() const;

    /*
     * Set Index element.
     * @param item const Mp7JrsDominantColorType_Value_Index_LocalPtr &
     */
    virtual void SetIndex(const Mp7JrsDominantColorType_Value_Index_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ColorVariance element.
     * @return Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr
     */
    virtual Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr GetColorVariance() const;

    virtual bool IsValidColorVariance() const;

    /*
     * Set ColorVariance element.
     * @param item const Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr &
     */
    virtual void SetColorVariance(const Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ColorVariance element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorVariance();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDominantColorType_Value_LocalType();

protected:
    Mp7JrsDominantColorType_Value_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7Jrsunsigned5Ptr m_Percentage;
    Mp7JrsDominantColorType_Value_Index_LocalPtr m_Index;
    Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr m_ColorVariance;
    bool m_ColorVariance_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _757MP7JRSDOMINANTCOLORTYPE_VALUE_LOCALTYPE_H

