/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _801MP7JRSELECTRONICADDRESSTYPE_H
#define _801MP7JRSELECTRONICADDRESSTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsElectronicAddressTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsElectronicAddressType_ExtInclude.h


class IMp7JrsElectronicAddressType;
class IMp7JrsElectronicAddressType_Email_CollectionType;
class IMp7JrsElectronicAddressType_Fax_CollectionType;
class IMp7JrsElectronicAddressType_Telephone_CollectionType;
class IMp7JrsElectronicAddressType_Url_CollectionType;
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Email_CollectionType > Mp7JrsElectronicAddressType_Email_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Fax_CollectionType > Mp7JrsElectronicAddressType_Fax_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Telephone_CollectionType > Mp7JrsElectronicAddressType_Telephone_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Url_CollectionType > Mp7JrsElectronicAddressType_Url_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType> Mp7JrsElectronicAddressPtr;

/** 
 * Generated interface IMp7JrsElectronicAddressType for class Mp7JrsElectronicAddressType<br>
 * Located at: mds-2001.xsd, line 1859<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsElectronicAddressType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsElectronicAddressType();
    virtual ~IMp7JrsElectronicAddressType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Telephone element.
     * @return Mp7JrsElectronicAddressType_Telephone_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Telephone_CollectionPtr GetTelephone() const = 0;

    /**
     * Set Telephone element.
     * @param item const Mp7JrsElectronicAddressType_Telephone_CollectionPtr &
     */
    virtual void SetTelephone(const Mp7JrsElectronicAddressType_Telephone_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Fax element.
     * @return Mp7JrsElectronicAddressType_Fax_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Fax_CollectionPtr GetFax() const = 0;

    /**
     * Set Fax element.
     * @param item const Mp7JrsElectronicAddressType_Fax_CollectionPtr &
     */
    virtual void SetFax(const Mp7JrsElectronicAddressType_Fax_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Email element.
     * @return Mp7JrsElectronicAddressType_Email_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Email_CollectionPtr GetEmail() const = 0;

    /**
     * Set Email element.
     * @param item const Mp7JrsElectronicAddressType_Email_CollectionPtr &
     */
    virtual void SetEmail(const Mp7JrsElectronicAddressType_Email_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Url element.
     * @return Mp7JrsElectronicAddressType_Url_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Url_CollectionPtr GetUrl() const = 0;

    /**
     * Set Url element.
     * @param item const Mp7JrsElectronicAddressType_Url_CollectionPtr &
     */
    virtual void SetUrl(const Mp7JrsElectronicAddressType_Url_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsElectronicAddressType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsElectronicAddressType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsElectronicAddressType<br>
 * Located at: mds-2001.xsd, line 1859<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1859.<br>
 */
class MP7JRS_EXPORT Mp7JrsElectronicAddressType :
        public IMp7JrsElectronicAddressType
{
    friend class Mp7JrsElectronicAddressTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Telephone element.
     * @return Mp7JrsElectronicAddressType_Telephone_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Telephone_CollectionPtr GetTelephone() const;

    /*
     * Set Telephone element.
     * @param item const Mp7JrsElectronicAddressType_Telephone_CollectionPtr &
     */
    virtual void SetTelephone(const Mp7JrsElectronicAddressType_Telephone_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Fax element.
     * @return Mp7JrsElectronicAddressType_Fax_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Fax_CollectionPtr GetFax() const;

    /*
     * Set Fax element.
     * @param item const Mp7JrsElectronicAddressType_Fax_CollectionPtr &
     */
    virtual void SetFax(const Mp7JrsElectronicAddressType_Fax_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Email element.
     * @return Mp7JrsElectronicAddressType_Email_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Email_CollectionPtr GetEmail() const;

    /*
     * Set Email element.
     * @param item const Mp7JrsElectronicAddressType_Email_CollectionPtr &
     */
    virtual void SetEmail(const Mp7JrsElectronicAddressType_Email_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Url element.
     * @return Mp7JrsElectronicAddressType_Url_CollectionPtr
     */
    virtual Mp7JrsElectronicAddressType_Url_CollectionPtr GetUrl() const;

    /*
     * Set Url element.
     * @param item const Mp7JrsElectronicAddressType_Url_CollectionPtr &
     */
    virtual void SetUrl(const Mp7JrsElectronicAddressType_Url_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsElectronicAddressType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsElectronicAddressType();

protected:
    Mp7JrsElectronicAddressType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsElectronicAddressType_Telephone_CollectionPtr m_Telephone;
    Mp7JrsElectronicAddressType_Fax_CollectionPtr m_Fax;
    Mp7JrsElectronicAddressType_Email_CollectionPtr m_Email;
    Mp7JrsElectronicAddressType_Url_CollectionPtr m_Url;

// no includefile for extension defined 
// file Mp7JrsElectronicAddressType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _801MP7JRSELECTRONICADDRESSTYPE_H

