/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _843MP7JRSFILTER2DTYPE_H
#define _843MP7JRSFILTER2DTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsFilter2DTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsFilter2DType_ExtInclude.h


#include "Mp7JrsFilterType.h"
class IMp7JrsDoubleMatrixType;
class IMp7JrsFilter2DType;
class IMp7JrsFilterType;
typedef Mp7JrsPtr< IMp7JrsDoubleMatrixType > Mp7JrsDoubleMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsFilter2DType> Mp7JrsFilter2DPtr;
typedef Mp7JrsPtr< IMp7JrsFilterType > Mp7JrsFilterPtr;

/** 
 * Generated interface IMp7JrsFilter2DType for class Mp7JrsFilter2DType<br>
 * Located at: mds-2001.xsd, line 4793<br>
 * Classified: Class<br>
 * Derived from: FilterType (Class)<br>
 * Derived from: FilterType (Class)<br>
 * Derived from: FilterType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsFilter2DType 
 :
        public IMp7JrsFilterType
{
public:
    // TODO: make these protected?
    IMp7JrsFilter2DType();
    virtual ~IMp7JrsFilter2DType();
    /**
     * Get xPhase attribute.
     * @return int
     */
    virtual int GetxPhase() const = 0;

    /**
     * Get xPhase attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistxPhase() const = 0;

    /**
     * Set xPhase attribute.
     * @param item int
     */
    virtual void SetxPhase(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate xPhase attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatexPhase() = 0;

    /**
     * Get yPhase attribute.
     * @return int
     */
    virtual int GetyPhase() const = 0;

    /**
     * Get yPhase attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistyPhase() const = 0;

    /**
     * Set yPhase attribute.
     * @param item int
     */
    virtual void SetyPhase(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate yPhase attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateyPhase() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Terms element.
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetTerms() const = 0;

    /**
     * Set Terms element.
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetTerms(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsFilterType)
     * @return unsigned
     */
    virtual unsigned Getdim() const = 0;

    /**
     * Get dim attribute validity information.
     * (Inherited from Mp7JrsFilterType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const = 0;

    /**
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsFilterType)
     * @param item unsigned
     */
    virtual void Setdim(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dim attribute.
     * (Inherited from Mp7JrsFilterType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim() = 0;

// no includefile for extension defined 
// file Mp7JrsFilter2DType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsFilter2DType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsFilter2DType<br>
 * Located at: mds-2001.xsd, line 4793<br>
 * Classified: Class<br>
 * Derived from: FilterType (Class)<br>
 * Derived from: FilterType (Class)<br>
 * Derived from: FilterType (Class)<br>
 * Defined in mds-2001.xsd, line 4793.<br>
 */
class MP7JRS_EXPORT Mp7JrsFilter2DType :
        public IMp7JrsFilter2DType
{
    friend class Mp7JrsFilter2DTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsFilter2DType
     
     * @return Mp7JrsPtr< Mp7JrsFilterType >
     */
    virtual Mp7JrsPtr< Mp7JrsFilterType > GetBase() const;
    /*
     * Get xPhase attribute.
     * @return int
     */
    virtual int GetxPhase() const;

    /*
     * Get xPhase attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistxPhase() const;

    /*
     * Set xPhase attribute.
     * @param item int
     */
    virtual void SetxPhase(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate xPhase attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatexPhase();

    /*
     * Get yPhase attribute.
     * @return int
     */
    virtual int GetyPhase() const;

    /*
     * Get yPhase attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistyPhase() const;

    /*
     * Set yPhase attribute.
     * @param item int
     */
    virtual void SetyPhase(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate yPhase attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateyPhase();

        /* @name Sequence

         */
        //@{
    /*
     * Get Terms element.
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetTerms() const;

    /*
     * Set Terms element.
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetTerms(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsFilterType)
     * @return unsigned
     */
    virtual unsigned Getdim() const;

    /*
     * Get dim attribute validity information.
     * (Inherited from Mp7JrsFilterType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const;

    /*
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsFilterType)
     * @param item unsigned
     */
    virtual void Setdim(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dim attribute.
     * (Inherited from Mp7JrsFilterType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsFilter2DType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsFilter2DType();

protected:
    Mp7JrsFilter2DType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    int m_xPhase;
    bool m_xPhase_Exist;
    int m_xPhase_Default;
    int m_yPhase;
    bool m_yPhase_Exist;
    int m_yPhase_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsFilterType > m_Base;

    Mp7JrsDoubleMatrixPtr m_Terms;

// no includefile for extension defined 
// file Mp7JrsFilter2DType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _843MP7JRSFILTER2DTYPE_H

