/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _845MP7JRSFILTERINGANDSEARCHPREFERENCESTYPE_H
#define _845MP7JRSFILTERINGANDSEARCHPREFERENCESTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsFilteringAndSearchPreferencesTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsuserChoiceType.h"
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsFilteringAndSearchPreferencesType;
class IMp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType;
class IMp7JrsmediaDurationType;
class IMp7JrspreferenceValueType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType> Mp7JrsFilteringAndSearchPreferencesPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsFilteringAndSearchPreferencesType for class Mp7JrsFilteringAndSearchPreferencesType<br>
 * Located at: mds-2001.xsd, line 5896<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsFilteringAndSearchPreferencesType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsFilteringAndSearchPreferencesType();
    virtual ~IMp7JrsFilteringAndSearchPreferencesType();
    /**
     * Get protected attribute.
     * @return Mp7JrsuserChoiceType::Enumeration
     */
    virtual Mp7JrsuserChoiceType::Enumeration Getprotected() const = 0;

    /**
     * Get protected attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existprotected() const = 0;

    /**
     * Set protected attribute.
     * @param item Mp7JrsuserChoiceType::Enumeration
     */
    virtual void Setprotected(Mp7JrsuserChoiceType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate protected attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateprotected() = 0;

    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get CreationPreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr GetCreationPreferences() const = 0;

    /**
     * Set CreationPreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr &
     */
    virtual void SetCreationPreferences(const Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ClassificationPreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr GetClassificationPreferences() const = 0;

    /**
     * Set ClassificationPreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr &
     */
    virtual void SetClassificationPreferences(const Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SourcePreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr GetSourcePreferences() const = 0;

    /**
     * Set SourcePreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr &
     */
    virtual void SetSourcePreferences(const Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PreferenceCondition element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr GetPreferenceCondition() const = 0;

    /**
     * Set PreferenceCondition element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr &
     */
    virtual void SetPreferenceCondition(const Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get FilteringAndSearchPreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr GetFilteringAndSearchPreferences() const = 0;

    /**
     * Set FilteringAndSearchPreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr &
     */
    virtual void SetFilteringAndSearchPreferences(const Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsFilteringAndSearchPreferencesType<br>
 * Located at: mds-2001.xsd, line 5896<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 5896.<br>
 */
class MP7JRS_EXPORT Mp7JrsFilteringAndSearchPreferencesType :
        public IMp7JrsFilteringAndSearchPreferencesType
{
    friend class Mp7JrsFilteringAndSearchPreferencesTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsFilteringAndSearchPreferencesType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get protected attribute.
     * @return Mp7JrsuserChoiceType::Enumeration
     */
    virtual Mp7JrsuserChoiceType::Enumeration Getprotected() const;

    /*
     * Get protected attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existprotected() const;

    /*
     * Set protected attribute.
     * @param item Mp7JrsuserChoiceType::Enumeration
     */
    virtual void Setprotected(Mp7JrsuserChoiceType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate protected attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateprotected();

    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
    /*
     * Get CreationPreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr GetCreationPreferences() const;

    /*
     * Set CreationPreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr &
     */
    virtual void SetCreationPreferences(const Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ClassificationPreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr GetClassificationPreferences() const;

    /*
     * Set ClassificationPreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr &
     */
    virtual void SetClassificationPreferences(const Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SourcePreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr GetSourcePreferences() const;

    /*
     * Set SourcePreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr &
     */
    virtual void SetSourcePreferences(const Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PreferenceCondition element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr GetPreferenceCondition() const;

    /*
     * Set PreferenceCondition element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr &
     */
    virtual void SetPreferenceCondition(const Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get FilteringAndSearchPreferences element.
     * @return Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr
     */
    virtual Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr GetFilteringAndSearchPreferences() const;

    /*
     * Set FilteringAndSearchPreferences element.
     * @param item const Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr &
     */
    virtual void SetFilteringAndSearchPreferences(const Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsFilteringAndSearchPreferencesType();

protected:
    Mp7JrsFilteringAndSearchPreferencesType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsuserChoiceType::Enumeration m_protected;
    bool m_protected_Exist;
    Mp7JrsuserChoiceType::Enumeration m_protected_Default;
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr m_CreationPreferences;
    Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr m_ClassificationPreferences;
    Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr m_SourcePreferences;
    Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr m_PreferenceCondition;
    Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr m_FilteringAndSearchPreferences;

// no includefile for extension defined 
// file Mp7JrsFilteringAndSearchPreferencesType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _845MP7JRSFILTERINGANDSEARCHPREFERENCESTYPE_H

