/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _869MP7JRSFINANCIALTYPE_ACCOUNTITEM_LOCALTYPE_H
#define _869MP7JRSFINANCIALTYPE_ACCOUNTITEM_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsFinancialType_AccountItem_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtInclude.h


class IMp7JrscurrencyCode;
class IMp7JrsFinancialType_AccountItem_LocalType;
class IMp7JrsTermUseType;
class IMp7JrstimePointType;
typedef Mp7JrsPtr< IMp7JrscurrencyCode > Mp7JrscurrencyCodePtr;
typedef Mp7JrsPtr< IMp7JrsFinancialType_AccountItem_LocalType> Mp7JrsFinancialType_AccountItem_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;

/** 
 * Generated interface IMp7JrsFinancialType_AccountItem_LocalType for class Mp7JrsFinancialType_AccountItem_LocalType<br>
 * Located at: mds-2001.xsd, line 2766<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsFinancialType_AccountItem_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsFinancialType_AccountItem_LocalType();
    virtual ~IMp7JrsFinancialType_AccountItem_LocalType();
    /**
     * Get currency attribute.
     * @return Mp7JrscurrencyCodePtr
     */
    virtual Mp7JrscurrencyCodePtr Getcurrency() const = 0;

    /**
     * Set currency attribute.
     * @param item const Mp7JrscurrencyCodePtr &
     */
    virtual void Setcurrency(const Mp7JrscurrencyCodePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get value attribute.
     * @return double
     */
    virtual double Getvalue() const = 0;

    /**
     * Set value attribute.
     * @param item double
     */
    virtual void Setvalue(double item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get EffectiveDate element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetEffectiveDate() const = 0;

    virtual bool IsValidEffectiveDate() const = 0;

    /**
     * Set EffectiveDate element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetEffectiveDate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate EffectiveDate element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateEffectiveDate() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get CostType element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetCostType() const = 0;

    /**
     * Set CostType element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetCostType(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get IncomeType element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetIncomeType() const = 0;

    /**
     * Set IncomeType element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetIncomeType(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsFinancialType_AccountItem_LocalType<br>
 * Located at: mds-2001.xsd, line 2766<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2766.<br>
 */
class MP7JRS_EXPORT Mp7JrsFinancialType_AccountItem_LocalType :
        public IMp7JrsFinancialType_AccountItem_LocalType
{
    friend class Mp7JrsFinancialType_AccountItem_LocalTypeFactory; // constructs objects

public:
    /*
     * Get currency attribute.
     * @return Mp7JrscurrencyCodePtr
     */
    virtual Mp7JrscurrencyCodePtr Getcurrency() const;

    /*
     * Set currency attribute.
     * @param item const Mp7JrscurrencyCodePtr &
     */
    virtual void Setcurrency(const Mp7JrscurrencyCodePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get value attribute.
     * @return double
     */
    virtual double Getvalue() const;

    /*
     * Set value attribute.
     * @param item double
     */
    virtual void Setvalue(double item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get EffectiveDate element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetEffectiveDate() const;

    virtual bool IsValidEffectiveDate() const;

    /*
     * Set EffectiveDate element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetEffectiveDate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate EffectiveDate element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateEffectiveDate();

        /* @name Choice

         */
        //@{
    /*
     * Get CostType element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetCostType() const;

    /*
     * Set CostType element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetCostType(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get IncomeType element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetIncomeType() const;

    /*
     * Set IncomeType element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetIncomeType(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsFinancialType_AccountItem_LocalType();

protected:
    Mp7JrsFinancialType_AccountItem_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrscurrencyCodePtr m_currency;
    double m_value;


    Mp7JrstimePointPtr m_EffectiveDate;
    bool m_EffectiveDate_Exist; // For optional elements 
// DefinionChoice
    Mp7JrsTermUsePtr m_CostType;
    Mp7JrsTermUsePtr m_IncomeType;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _869MP7JRSFINANCIALTYPE_ACCOUNTITEM_LOCALTYPE_H

