/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _881MP7JRSFRACTIONALPRESENCETYPE_H
#define _881MP7JRSFRACTIONALPRESENCETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsFractionalPresenceTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsFractionalPresenceType_ExtInclude.h


class IMp7JrsFractionalPresenceType;
class IMp7Jrsunsigned7;
typedef Mp7JrsPtr< IMp7JrsFractionalPresenceType> Mp7JrsFractionalPresencePtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned7 > Mp7Jrsunsigned7Ptr;

/** 
 * Generated interface IMp7JrsFractionalPresenceType for class Mp7JrsFractionalPresenceType<br>
 * Located at: visual-2001.xsd, line 875<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsFractionalPresenceType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsFractionalPresenceType();
    virtual ~IMp7JrsFractionalPresenceType();
        /** @name Sequence

         */
        //@{
    /**
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTrackLeft() const = 0;

    virtual bool IsValidTrackLeft() const = 0;

    /**
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTrackLeft(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TrackLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackLeft() = 0;

    /**
     * Get TrackRight element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTrackRight() const = 0;

    virtual bool IsValidTrackRight() const = 0;

    /**
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTrackRight(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TrackRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackRight() = 0;

    /**
     * Get BoomDown element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetBoomDown() const = 0;

    virtual bool IsValidBoomDown() const = 0;

    /**
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetBoomDown(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate BoomDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomDown() = 0;

    /**
     * Get BoomUp element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetBoomUp() const = 0;

    virtual bool IsValidBoomUp() const = 0;

    /**
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetBoomUp(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate BoomUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomUp() = 0;

    /**
     * Get DollyForward element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetDollyForward() const = 0;

    virtual bool IsValidDollyForward() const = 0;

    /**
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetDollyForward(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DollyForward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyForward() = 0;

    /**
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetDollyBackward() const = 0;

    virtual bool IsValidDollyBackward() const = 0;

    /**
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetDollyBackward(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DollyBackward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyBackward() = 0;

    /**
     * Get PanLeft element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetPanLeft() const = 0;

    virtual bool IsValidPanLeft() const = 0;

    /**
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetPanLeft(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PanLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanLeft() = 0;

    /**
     * Get PanRight element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetPanRight() const = 0;

    virtual bool IsValidPanRight() const = 0;

    /**
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetPanRight(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PanRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanRight() = 0;

    /**
     * Get TiltDown element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTiltDown() const = 0;

    virtual bool IsValidTiltDown() const = 0;

    /**
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTiltDown(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TiltDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltDown() = 0;

    /**
     * Get TiltUp element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTiltUp() const = 0;

    virtual bool IsValidTiltUp() const = 0;

    /**
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTiltUp(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TiltUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltUp() = 0;

    /**
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetRollClockwise() const = 0;

    virtual bool IsValidRollClockwise() const = 0;

    /**
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetRollClockwise(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate RollClockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollClockwise() = 0;

    /**
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetRollAnticlockwise() const = 0;

    virtual bool IsValidRollAnticlockwise() const = 0;

    /**
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate RollAnticlockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollAnticlockwise() = 0;

    /**
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetZoomIn() const = 0;

    virtual bool IsValidZoomIn() const = 0;

    /**
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetZoomIn(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ZoomIn element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomIn() = 0;

    /**
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetZoomOut() const = 0;

    virtual bool IsValidZoomOut() const = 0;

    /**
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetZoomOut(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ZoomOut element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomOut() = 0;

    /**
     * Get Fixed element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetFixed() const = 0;

    virtual bool IsValidFixed() const = 0;

    /**
     * Set Fixed element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetFixed(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Fixed element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFixed() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsFractionalPresenceType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsFractionalPresenceType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsFractionalPresenceType<br>
 * Located at: visual-2001.xsd, line 875<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 875.<br>
 */
class MP7JRS_EXPORT Mp7JrsFractionalPresenceType :
        public IMp7JrsFractionalPresenceType
{
    friend class Mp7JrsFractionalPresenceTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTrackLeft() const;

    virtual bool IsValidTrackLeft() const;

    /*
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTrackLeft(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TrackLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackLeft();

    /*
     * Get TrackRight element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTrackRight() const;

    virtual bool IsValidTrackRight() const;

    /*
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTrackRight(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TrackRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTrackRight();

    /*
     * Get BoomDown element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetBoomDown() const;

    virtual bool IsValidBoomDown() const;

    /*
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetBoomDown(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate BoomDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomDown();

    /*
     * Get BoomUp element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetBoomUp() const;

    virtual bool IsValidBoomUp() const;

    /*
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetBoomUp(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate BoomUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBoomUp();

    /*
     * Get DollyForward element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetDollyForward() const;

    virtual bool IsValidDollyForward() const;

    /*
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetDollyForward(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DollyForward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyForward();

    /*
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetDollyBackward() const;

    virtual bool IsValidDollyBackward() const;

    /*
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetDollyBackward(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DollyBackward element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDollyBackward();

    /*
     * Get PanLeft element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetPanLeft() const;

    virtual bool IsValidPanLeft() const;

    /*
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetPanLeft(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PanLeft element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanLeft();

    /*
     * Get PanRight element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetPanRight() const;

    virtual bool IsValidPanRight() const;

    /*
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetPanRight(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PanRight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePanRight();

    /*
     * Get TiltDown element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTiltDown() const;

    virtual bool IsValidTiltDown() const;

    /*
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTiltDown(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TiltDown element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltDown();

    /*
     * Get TiltUp element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetTiltUp() const;

    virtual bool IsValidTiltUp() const;

    /*
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetTiltUp(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TiltUp element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTiltUp();

    /*
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetRollClockwise() const;

    virtual bool IsValidRollClockwise() const;

    /*
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetRollClockwise(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate RollClockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollClockwise();

    /*
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetRollAnticlockwise() const;

    virtual bool IsValidRollAnticlockwise() const;

    /*
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate RollAnticlockwise element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRollAnticlockwise();

    /*
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetZoomIn() const;

    virtual bool IsValidZoomIn() const;

    /*
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetZoomIn(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ZoomIn element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomIn();

    /*
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetZoomOut() const;

    virtual bool IsValidZoomOut() const;

    /*
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetZoomOut(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ZoomOut element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateZoomOut();

    /*
     * Get Fixed element.
     * @return Mp7Jrsunsigned7Ptr
     */
    virtual Mp7Jrsunsigned7Ptr GetFixed() const;

    virtual bool IsValidFixed() const;

    /*
     * Set Fixed element.
     * @param item const Mp7Jrsunsigned7Ptr &
     */
    virtual void SetFixed(const Mp7Jrsunsigned7Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Fixed element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFixed();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsFractionalPresenceType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsFractionalPresenceType();

protected:
    Mp7JrsFractionalPresenceType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7Jrsunsigned7Ptr m_TrackLeft;
    bool m_TrackLeft_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_TrackRight;
    bool m_TrackRight_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_BoomDown;
    bool m_BoomDown_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_BoomUp;
    bool m_BoomUp_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_DollyForward;
    bool m_DollyForward_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_DollyBackward;
    bool m_DollyBackward_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_PanLeft;
    bool m_PanLeft_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_PanRight;
    bool m_PanRight_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_TiltDown;
    bool m_TiltDown_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_TiltUp;
    bool m_TiltUp_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_RollClockwise;
    bool m_RollClockwise_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_RollAnticlockwise;
    bool m_RollAnticlockwise_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_ZoomIn;
    bool m_ZoomIn_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_ZoomOut;
    bool m_ZoomOut_Exist; // For optional elements 
    Mp7Jrsunsigned7Ptr m_Fixed;
    bool m_Fixed_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsFractionalPresenceType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _881MP7JRSFRACTIONALPRESENCETYPE_H

