/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _913MP7JRSGOFGOPCOLORTYPE_H
#define _913MP7JRSGOFGOPCOLORTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGoFGoPColorTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsGoFGoPColorType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsGoFGoPColorType_aggregation_LocalType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsGoFGoPColorType;
class IMp7JrsScalableColorType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsGoFGoPColorType> Mp7JrsGoFGoPColorPtr;
typedef Mp7JrsPtr< IMp7JrsScalableColorType > Mp7JrsScalableColorPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsGoFGoPColorType for class Mp7JrsGoFGoPColorType<br>
 * Located at: visual-2001.xsd, line 641<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsGoFGoPColorType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsGoFGoPColorType();
    virtual ~IMp7JrsGoFGoPColorType();
    /**
     * Get aggregation attribute.
     * @return Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration
     */
    virtual Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration Getaggregation() const = 0;

    /**
     * Set aggregation attribute.
     * @param item Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration
     */
    virtual void Setaggregation(Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get ScalableColor element.
     * @return Mp7JrsScalableColorPtr
     */
    virtual Mp7JrsScalableColorPtr GetScalableColor() const = 0;

    /**
     * Set ScalableColor element.
     * @param item const Mp7JrsScalableColorPtr &
     */
    virtual void SetScalableColor(const Mp7JrsScalableColorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsGoFGoPColorType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGoFGoPColorType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGoFGoPColorType<br>
 * Located at: visual-2001.xsd, line 641<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 641.<br>
 */
class MP7JRS_EXPORT Mp7JrsGoFGoPColorType :
        public IMp7JrsGoFGoPColorType
{
    friend class Mp7JrsGoFGoPColorTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsGoFGoPColorType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
    /*
     * Get aggregation attribute.
     * @return Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration
     */
    virtual Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration Getaggregation() const;

    /*
     * Set aggregation attribute.
     * @param item Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration
     */
    virtual void Setaggregation(Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get ScalableColor element.
     * @return Mp7JrsScalableColorPtr
     */
    virtual Mp7JrsScalableColorPtr GetScalableColor() const;

    /*
     * Set ScalableColor element.
     * @param item const Mp7JrsScalableColorPtr &
     */
    virtual void SetScalableColor(const Mp7JrsScalableColorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGoFGoPColorType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGoFGoPColorType();

protected:
    Mp7JrsGoFGoPColorType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsGoFGoPColorType_aggregation_LocalType::Enumeration m_aggregation;

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsScalableColorPtr m_ScalableColor;

// no includefile for extension defined 
// file Mp7JrsGoFGoPColorType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _913MP7JRSGOFGOPCOLORTYPE_H

