/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _931MP7JRSGRAPHTYPE_NODE_LOCALTYPE_H
#define _931MP7JRSGRAPHTYPE_NODE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGraphType_Node_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsGraphType_Node_LocalType_ExtInclude.h


#include "Mp7JrsReferenceType.h"
class IMp7JrsGraphType_Node_LocalType;
class IMp7JrsReferenceType;
class IMp7JrsTermUseType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsGraphType_Node_LocalType> Mp7JrsGraphType_Node_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsGraphType_Node_LocalType for class Mp7JrsGraphType_Node_LocalType<br>
 * Located at: mds-2001.xsd, line 1944<br>
 * Classified: Class<br>
 * Derived from: ReferenceType (Class)<br>
 * Derived from: ReferenceType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsGraphType_Node_LocalType 
 :
        public IMp7JrsReferenceType
{
public:
    // TODO: make these protected?
    IMp7JrsGraphType_Node_LocalType();
    virtual ~IMp7JrsGraphType_Node_LocalType();
    /**
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetName() const = 0;

    virtual bool IsValidName() const = 0;

    /**
     * Set Name element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetName(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Name element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateName() = 0;

        //@}
    /**
     * Get idref attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @return XMLCh *
     */
    virtual XMLCh * Getidref() const = 0;

    /**
     * Get idref attribute validity information.
     * (Inherited from Mp7JrsReferenceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existidref() const = 0;

    /**
     * Set idref attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @param item XMLCh *
     */
    virtual void Setidref(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate idref attribute.
     * (Inherited from Mp7JrsReferenceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateidref() = 0;

    /**
     * Get xpath attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr Getxpath() const = 0;

    /**
     * Get xpath attribute validity information.
     * (Inherited from Mp7JrsReferenceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existxpath() const = 0;

    /**
     * Set xpath attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void Setxpath(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate xpath attribute.
     * (Inherited from Mp7JrsReferenceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatexpath() = 0;

    /**
     * Get href attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @return XMLCh *
     */
    virtual XMLCh * Gethref() const = 0;

    /**
     * Get href attribute validity information.
     * (Inherited from Mp7JrsReferenceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existhref() const = 0;

    /**
     * Set href attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @param item XMLCh *
     */
    virtual void Sethref(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate href attribute.
     * (Inherited from Mp7JrsReferenceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatehref() = 0;

// no includefile for extension defined 
// file Mp7JrsGraphType_Node_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGraphType_Node_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGraphType_Node_LocalType<br>
 * Located at: mds-2001.xsd, line 1944<br>
 * Classified: Class<br>
 * Derived from: ReferenceType (Class)<br>
 * Derived from: ReferenceType (Class)<br>
 * Defined in mds-2001.xsd, line 1944.<br>
 */
class MP7JRS_EXPORT Mp7JrsGraphType_Node_LocalType :
        public IMp7JrsGraphType_Node_LocalType
{
    friend class Mp7JrsGraphType_Node_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsGraphType_Node_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsReferenceType >
     */
    virtual Mp7JrsPtr< Mp7JrsReferenceType > GetBase() const;
    /*
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetName() const;

    virtual bool IsValidName() const;

    /*
     * Set Name element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetName(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Name element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateName();

        //@}
    /*
     * Get idref attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @return XMLCh *
     */
    virtual XMLCh * Getidref() const;

    /*
     * Get idref attribute validity information.
     * (Inherited from Mp7JrsReferenceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existidref() const;

    /*
     * Set idref attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @param item XMLCh *
     */
    virtual void Setidref(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate idref attribute.
     * (Inherited from Mp7JrsReferenceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateidref();

    /*
     * Get xpath attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr Getxpath() const;

    /*
     * Get xpath attribute validity information.
     * (Inherited from Mp7JrsReferenceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existxpath() const;

    /*
     * Set xpath attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void Setxpath(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate xpath attribute.
     * (Inherited from Mp7JrsReferenceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatexpath();

    /*
     * Get href attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @return XMLCh *
     */
    virtual XMLCh * Gethref() const;

    /*
     * Get href attribute validity information.
     * (Inherited from Mp7JrsReferenceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existhref() const;

    /*
     * Set href attribute.
<br>
     * (Inherited from Mp7JrsReferenceType)
     * @param item XMLCh *
     */
    virtual void Sethref(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate href attribute.
     * (Inherited from Mp7JrsReferenceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatehref();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGraphType_Node_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGraphType_Node_LocalType();

protected:
    Mp7JrsGraphType_Node_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_id;
    bool m_id_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsReferenceType > m_Base;

    Mp7JrsTermUsePtr m_Name;
    bool m_Name_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsGraphType_Node_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _931MP7JRSGRAPHTYPE_NODE_LOCALTYPE_H

