/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _917MP7JRSGRAPHICALCLASSIFICATIONSCHEMETYPE_H
#define _917MP7JRSGRAPHICALCLASSIFICATIONSCHEMETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGraphicalClassificationSchemeTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsGraphicalClassificationSchemeType_ExtInclude.h


#include "Mp7JrsClassificationSchemeBaseType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsClassificationSchemeBaseType;
class IMp7JrsClassificationSchemeBaseType_domain_CollectionType;
class IMp7JrsClassificationSchemeBaseType_Import_CollectionType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsGraphicalClassificationSchemeType;
class IMp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType;
class IMp7JrsmediaDurationType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeBaseType > Mp7JrsClassificationSchemeBasePtr;
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeBaseType_domain_CollectionType > Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeBaseType_Import_CollectionType > Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType > Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsGraphicalClassificationSchemeType> Mp7JrsGraphicalClassificationSchemePtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsGraphicalClassificationSchemeType for class Mp7JrsGraphicalClassificationSchemeType<br>
 * Located at: mds-2001.xsd, line 1550<br>
 * Classified: Class<br>
 * Derived from: ClassificationSchemeBaseType (Class)<br>
 * Derived from: ClassificationSchemeBaseType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsGraphicalClassificationSchemeType 
 :
        public IMp7JrsClassificationSchemeBaseType
{
public:
    // TODO: make these protected?
    IMp7JrsGraphicalClassificationSchemeType();
    virtual ~IMp7JrsGraphicalClassificationSchemeType();
    /**
     * Get strict attribute.
     * @return bool
     */
    virtual bool Getstrict() const = 0;

    /**
     * Get strict attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existstrict() const = 0;

    /**
     * Set strict attribute.
     * @param item bool
     */
    virtual void Setstrict(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate strict attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatestrict() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get GraphicalTerm element.
     * @return Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr
     */
    virtual Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr GetGraphicalTerm() const = 0;

    /**
     * Set GraphicalTerm element.
     * @param item const Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr &
     */
    virtual void SetGraphicalTerm(const Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get uri attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * Geturi() const = 0;

    /**
     * Set uri attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @param item XMLCh *
     */
    virtual void Seturi(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get domain attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr Getdomain() const = 0;

    /**
     * Get domain attribute validity information.
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdomain() const = 0;

    /**
     * Set domain attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @param item const Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr &
     */
    virtual void Setdomain(const Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate domain attribute.
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedomain() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Import element.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr GetImport() const = 0;

    /**
     * Set Import element.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @param item const Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr &
     */
    virtual void SetImport(const Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsGraphicalClassificationSchemeType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGraphicalClassificationSchemeType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGraphicalClassificationSchemeType<br>
 * Located at: mds-2001.xsd, line 1550<br>
 * Classified: Class<br>
 * Derived from: ClassificationSchemeBaseType (Class)<br>
 * Derived from: ClassificationSchemeBaseType (Class)<br>
 * Defined in mds-2001.xsd, line 1550.<br>
 */
class MP7JRS_EXPORT Mp7JrsGraphicalClassificationSchemeType :
        public IMp7JrsGraphicalClassificationSchemeType
{
    friend class Mp7JrsGraphicalClassificationSchemeTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsGraphicalClassificationSchemeType
     
     * @return Mp7JrsPtr< Mp7JrsClassificationSchemeBaseType >
     */
    virtual Mp7JrsPtr< Mp7JrsClassificationSchemeBaseType > GetBase() const;
    /*
     * Get strict attribute.
     * @return bool
     */
    virtual bool Getstrict() const;

    /*
     * Get strict attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existstrict() const;

    /*
     * Set strict attribute.
     * @param item bool
     */
    virtual void Setstrict(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate strict attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatestrict();

        /* @name Sequence

         */
        //@{
    /*
     * Get GraphicalTerm element.
     * @return Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr
     */
    virtual Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr GetGraphicalTerm() const;

    /*
     * Set GraphicalTerm element.
     * @param item const Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr &
     */
    virtual void SetGraphicalTerm(const Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get uri attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * Geturi() const;

    /*
     * Set uri attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @param item XMLCh *
     */
    virtual void Seturi(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get domain attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr Getdomain() const;

    /*
     * Get domain attribute validity information.
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdomain() const;

    /*
     * Set domain attribute.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @param item const Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr &
     */
    virtual void Setdomain(const Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate domain attribute.
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedomain();

        /* @name Sequence

         */
        //@{
    /*
     * Get Import element.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @return Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr
     */
    virtual Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr GetImport() const;

    /*
     * Set Import element.
<br>
     * (Inherited from Mp7JrsClassificationSchemeBaseType)
     * @param item const Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr &
     */
    virtual void SetImport(const Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGraphicalClassificationSchemeType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGraphicalClassificationSchemeType();

protected:
    Mp7JrsGraphicalClassificationSchemeType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_strict;
    bool m_strict_Exist;
    bool m_strict_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsClassificationSchemeBaseType > m_Base;

    Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr m_GraphicalTerm;

// no includefile for extension defined 
// file Mp7JrsGraphicalClassificationSchemeType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _917MP7JRSGRAPHICALCLASSIFICATIONSCHEMETYPE_H

