/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _923MP7JRSGRAPHICALTERMDEFINITIONTYPE_H
#define _923MP7JRSGRAPHICALTERMDEFINITIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGraphicalTermDefinitionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsGraphicalTermDefinitionType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsTermDefinitionBaseType.h"
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsGraphicalRuleDefinitionType;
class IMp7JrsGraphicalTermDefinitionType;
class IMp7JrsGraphType;
class IMp7JrsmediaDurationType;
class IMp7JrsTermDefinitionBaseType;
class IMp7JrsTermDefinitionBaseType_Definition_CollectionType;
class IMp7JrsTermDefinitionBaseType_Name_CollectionType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsGraphicalRuleDefinitionType > Mp7JrsGraphicalRuleDefinitionPtr;
typedef Mp7JrsPtr< IMp7JrsGraphicalTermDefinitionType> Mp7JrsGraphicalTermDefinitionPtr;
typedef Mp7JrsPtr< IMp7JrsGraphType > Mp7JrsGraphPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType > Mp7JrsTermDefinitionBasePtr;
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType_Definition_CollectionType > Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType_Name_CollectionType > Mp7JrsTermDefinitionBaseType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsGraphicalTermDefinitionType for class Mp7JrsGraphicalTermDefinitionType<br>
 * Located at: mds-2001.xsd, line 1564<br>
 * Classified: Class<br>
 * Derived from: TermDefinitionBaseType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsGraphicalTermDefinitionType 
 :
        public IMp7JrsTermDefinitionBaseType
{
public:
    // TODO: make these protected?
    IMp7JrsGraphicalTermDefinitionType();
    virtual ~IMp7JrsGraphicalTermDefinitionType();
        /** @name Choice

         */
        //@{
    /**
     * Get TemplateGraph element.
     * @return Mp7JrsGraphPtr
     */
    virtual Mp7JrsGraphPtr GetTemplateGraph() const = 0;

    /**
     * Set TemplateGraph element.
     * @param item const Mp7JrsGraphPtr &
     */
    virtual void SetTemplateGraph(const Mp7JrsGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AlphabetGraph element.
     * @return Mp7JrsGraphPtr
     */
    virtual Mp7JrsGraphPtr GetAlphabetGraph() const = 0;

    /**
     * Set AlphabetGraph element.
     * @param item const Mp7JrsGraphPtr &
     */
    virtual void SetAlphabetGraph(const Mp7JrsGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ProductionRule element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsDoublePullbackDefinitionPtr</li>
     * <li>IMp7JrsDoublePushoutDefinitionPtr</li>
     * <li>IMp7JrsPullbackDefinitionPtr</li>
     * <li>IMp7JrsPushoutDefinitionPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetProductionRule() const = 0;

    /**
     * Set ProductionRule element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsDoublePullbackDefinitionPtr</li>
     * <li>IMp7JrsDoublePushoutDefinitionPtr</li>
     * <li>IMp7JrsPullbackDefinitionPtr</li>
     * <li>IMp7JrsPushoutDefinitionPtr</li>
     * </ul>
     */
    virtual void SetProductionRule(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get termID attribute.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * GettermID() const = 0;

    /**
     * Get termID attribute validity information.
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttermID() const = 0;

    /**
     * Set termID attribute.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @param item XMLCh *
     */
    virtual void SettermID(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate termID attribute.
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetermID() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return Mp7JrsTermDefinitionBaseType_Name_CollectionPtr
     */
    virtual Mp7JrsTermDefinitionBaseType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @param item const Mp7JrsTermDefinitionBaseType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsTermDefinitionBaseType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr
     */
    virtual Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr GetDefinition() const = 0;

    /**
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @param item const Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsGraphicalTermDefinitionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGraphicalTermDefinitionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGraphicalTermDefinitionType<br>
 * Located at: mds-2001.xsd, line 1564<br>
 * Classified: Class<br>
 * Derived from: TermDefinitionBaseType (Class)<br>
 * Defined in mds-2001.xsd, line 1564.<br>
 */
class MP7JRS_EXPORT Mp7JrsGraphicalTermDefinitionType :
        public IMp7JrsGraphicalTermDefinitionType
{
    friend class Mp7JrsGraphicalTermDefinitionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsGraphicalTermDefinitionType
     
     * @return Mp7JrsPtr< Mp7JrsTermDefinitionBaseType >
     */
    virtual Mp7JrsPtr< Mp7JrsTermDefinitionBaseType > GetBase() const;
        /* @name Choice

         */
        //@{
    /*
     * Get TemplateGraph element.
     * @return Mp7JrsGraphPtr
     */
    virtual Mp7JrsGraphPtr GetTemplateGraph() const;

    /*
     * Set TemplateGraph element.
     * @param item const Mp7JrsGraphPtr &
     */
    virtual void SetTemplateGraph(const Mp7JrsGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AlphabetGraph element.
     * @return Mp7JrsGraphPtr
     */
    virtual Mp7JrsGraphPtr GetAlphabetGraph() const;

    /*
     * Set AlphabetGraph element.
     * @param item const Mp7JrsGraphPtr &
     */
    virtual void SetAlphabetGraph(const Mp7JrsGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ProductionRule element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsDoublePullbackDefinitionPtr</li>
     * <li>IMp7JrsDoublePushoutDefinitionPtr</li>
     * <li>IMp7JrsPullbackDefinitionPtr</li>
     * <li>IMp7JrsPushoutDefinitionPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetProductionRule() const;

    /*
     * Set ProductionRule element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsDoublePullbackDefinitionPtr</li>
     * <li>IMp7JrsDoublePushoutDefinitionPtr</li>
     * <li>IMp7JrsPullbackDefinitionPtr</li>
     * <li>IMp7JrsPushoutDefinitionPtr</li>
     * </ul>
     */
    virtual void SetProductionRule(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get termID attribute.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * GettermID() const;

    /*
     * Get termID attribute validity information.
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttermID() const;

    /*
     * Set termID attribute.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @param item XMLCh *
     */
    virtual void SettermID(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate termID attribute.
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetermID();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return Mp7JrsTermDefinitionBaseType_Name_CollectionPtr
     */
    virtual Mp7JrsTermDefinitionBaseType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @param item const Mp7JrsTermDefinitionBaseType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsTermDefinitionBaseType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @return Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr
     */
    virtual Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr GetDefinition() const;

    /*
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsTermDefinitionBaseType)
     * @param item const Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGraphicalTermDefinitionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGraphicalTermDefinitionType();

protected:
    Mp7JrsGraphicalTermDefinitionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsTermDefinitionBaseType > m_Base;

// DefinionChoice
    Mp7JrsGraphPtr m_TemplateGraph;
    Mp7JrsGraphPtr m_AlphabetGraph;
    Mp7JrsPtr< Mp7JrsNode > m_ProductionRule;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsGraphicalTermDefinitionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _923MP7JRSGRAPHICALTERMDEFINITIONTYPE_H

