/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _933MP7JRSGRIDLAYOUTTYPE_H
#define _933MP7JRSGRIDLAYOUTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGridLayoutTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsGridLayoutType_ExtInclude.h


class IMp7JrsGridLayoutType;
class IMp7JrsGridLayoutType_Descriptor_CollectionType;
class IMp7JrsGridLayoutType_descriptorMask_LocalType;
class IMp7Jrsunsigned8;
typedef Mp7JrsPtr< IMp7JrsGridLayoutType_Descriptor_CollectionType > Mp7JrsGridLayoutType_Descriptor_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsGridLayoutType_descriptorMask_LocalType > Mp7JrsGridLayoutType_descriptorMask_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsGridLayoutType> Mp7JrsGridLayoutPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned8 > Mp7Jrsunsigned8Ptr;

/** 
 * Generated interface IMp7JrsGridLayoutType for class Mp7JrsGridLayoutType<br>
 * Located at: visual-2001.xsd, line 43<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsGridLayoutType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsGridLayoutType();
    virtual ~IMp7JrsGridLayoutType();
    /**
     * Get numOfPartX attribute.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetnumOfPartX() const = 0;

    /**
     * Set numOfPartX attribute.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetnumOfPartX(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get numOfPartY attribute.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetnumOfPartY() const = 0;

    /**
     * Set numOfPartY attribute.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetnumOfPartY(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get descriptorMask attribute.
     * @return Mp7JrsGridLayoutType_descriptorMask_LocalPtr
     */
    virtual Mp7JrsGridLayoutType_descriptorMask_LocalPtr GetdescriptorMask() const = 0;

    /**
     * Get descriptorMask attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdescriptorMask() const = 0;

    /**
     * Set descriptorMask attribute.
     * @param item const Mp7JrsGridLayoutType_descriptorMask_LocalPtr &
     */
    virtual void SetdescriptorMask(const Mp7JrsGridLayoutType_descriptorMask_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate descriptorMask attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedescriptorMask() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Descriptor element.
     * @return Mp7JrsGridLayoutType_Descriptor_CollectionPtr
     */
    virtual Mp7JrsGridLayoutType_Descriptor_CollectionPtr GetDescriptor() const = 0;

    /**
     * Set Descriptor element.
     * @param item const Mp7JrsGridLayoutType_Descriptor_CollectionPtr &
     */
    virtual void SetDescriptor(const Mp7JrsGridLayoutType_Descriptor_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsGridLayoutType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGridLayoutType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGridLayoutType<br>
 * Located at: visual-2001.xsd, line 43<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 43.<br>
 */
class MP7JRS_EXPORT Mp7JrsGridLayoutType :
        public IMp7JrsGridLayoutType
{
    friend class Mp7JrsGridLayoutTypeFactory; // constructs objects

public:
    /*
     * Get numOfPartX attribute.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetnumOfPartX() const;

    /*
     * Set numOfPartX attribute.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetnumOfPartX(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get numOfPartY attribute.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetnumOfPartY() const;

    /*
     * Set numOfPartY attribute.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetnumOfPartY(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get descriptorMask attribute.
     * @return Mp7JrsGridLayoutType_descriptorMask_LocalPtr
     */
    virtual Mp7JrsGridLayoutType_descriptorMask_LocalPtr GetdescriptorMask() const;

    /*
     * Get descriptorMask attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdescriptorMask() const;

    /*
     * Set descriptorMask attribute.
     * @param item const Mp7JrsGridLayoutType_descriptorMask_LocalPtr &
     */
    virtual void SetdescriptorMask(const Mp7JrsGridLayoutType_descriptorMask_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate descriptorMask attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedescriptorMask();

        /* @name Sequence

         */
        //@{
    /*
     * Get Descriptor element.
     * @return Mp7JrsGridLayoutType_Descriptor_CollectionPtr
     */
    virtual Mp7JrsGridLayoutType_Descriptor_CollectionPtr GetDescriptor() const;

    /*
     * Set Descriptor element.
     * @param item const Mp7JrsGridLayoutType_Descriptor_CollectionPtr &
     */
    virtual void SetDescriptor(const Mp7JrsGridLayoutType_Descriptor_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGridLayoutType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGridLayoutType();

protected:
    Mp7JrsGridLayoutType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7Jrsunsigned8Ptr m_numOfPartX;
    Mp7Jrsunsigned8Ptr m_numOfPartY;
    Mp7JrsGridLayoutType_descriptorMask_LocalPtr m_descriptorMask;
    bool m_descriptorMask_Exist;


    Mp7JrsGridLayoutType_Descriptor_CollectionPtr m_Descriptor;

// no includefile for extension defined 
// file Mp7JrsGridLayoutType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _933MP7JRSGRIDLAYOUTTYPE_H

