/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _943MP7JRSHANDWRITINGRECOGINFORMATIONTYPE_INKLEXICON_ENTRY_LOCALTYPE_H
#define _943MP7JRSHANDWRITINGRECOGINFORMATIONTYPE_INKLEXICON_ENTRY_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtInclude.h


class IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType;
class IMp7JrsReferenceType;
class IMp7JrsTermUseType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType> Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType for class Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType<br>
 * Located at: mds-2001.xsd, line 3878<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType();
    virtual ~IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType();
    /**
     * Get index attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getindex() const = 0;

    /**
     * Get index attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existindex() const = 0;

    /**
     * Set index attribute.
     * @param item XMLCh *
     */
    virtual void Setindex(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate index attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateindex() = 0;

    /**
     * Get frequency attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getfrequency() const = 0;

    /**
     * Get frequency attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existfrequency() const = 0;

    /**
     * Set frequency attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setfrequency(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate frequency attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatefrequency() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Text element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetText() const = 0;

    virtual bool IsValidText() const = 0;

    /**
     * Set Text element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetText(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Text element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateText() = 0;

    /**
     * Get InkSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetInkSegmentRef() const = 0;

    virtual bool IsValidInkSegmentRef() const = 0;

    /**
     * Set InkSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetInkSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate InkSegmentRef element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateInkSegmentRef() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType<br>
 * Located at: mds-2001.xsd, line 3878<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3878.<br>
 */
class MP7JRS_EXPORT Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType :
        public IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType
{
    friend class Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalTypeFactory; // constructs objects

public:
    /*
     * Get index attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getindex() const;

    /*
     * Get index attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existindex() const;

    /*
     * Set index attribute.
     * @param item XMLCh *
     */
    virtual void Setindex(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate index attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateindex();

    /*
     * Get frequency attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getfrequency() const;

    /*
     * Get frequency attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existfrequency() const;

    /*
     * Set frequency attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setfrequency(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate frequency attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatefrequency();

        /* @name Sequence

         */
        //@{
    /*
     * Get Text element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetText() const;

    virtual bool IsValidText() const;

    /*
     * Set Text element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetText(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Text element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateText();

    /*
     * Get InkSegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetInkSegmentRef() const;

    virtual bool IsValidInkSegmentRef() const;

    /*
     * Set InkSegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetInkSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate InkSegmentRef element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateInkSegmentRef();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType();

protected:
    Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_index;
    bool m_index_Exist;
    Mp7JrszeroToOnePtr m_frequency;
    bool m_frequency_Exist;


    Mp7JrsTermUsePtr m_Text;
    bool m_Text_Exist; // For optional elements 
    Mp7JrsReferencePtr m_InkSegmentRef;
    bool m_InkSegmentRef_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _943MP7JRSHANDWRITINGRECOGINFORMATIONTYPE_INKLEXICON_ENTRY_LOCALTYPE_H

