/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _945MP7JRSHANDWRITINGRECOGINFORMATIONTYPE_INKLEXICON_LOCALTYPE_H
#define _945MP7JRSHANDWRITINGRECOGINFORMATIONTYPE_INKLEXICON_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType_ExtInclude.h


class IMp7JrsAgentType;
class IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType;
class IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType;
class IMp7JrsMediaLocatorType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsAgentType > Mp7JrsAgentPtr;
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType > Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType> Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaLocatorType > Mp7JrsMediaLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType for class Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType<br>
 * Located at: mds-2001.xsd, line 3871<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType();
    virtual ~IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetName() const = 0;

    virtual bool IsValidName() const = 0;

    /**
     * Set Name element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetName(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Name element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateName() = 0;

    /**
     * Get Owner element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetOwner() const = 0;

    virtual bool IsValidOwner() const = 0;

    /**
     * Set Owner element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual void SetOwner(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Owner element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOwner() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Resource element.
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetResource() const = 0;

    /**
     * Set Resource element.
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetResource(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Entry element.
     * @return Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr
     */
    virtual Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr GetEntry() const = 0;

    /**
     * Set Entry element.
     * @param item const Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr &
     */
    virtual void SetEntry(const Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType<br>
 * Located at: mds-2001.xsd, line 3871<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3871.<br>
 */
class MP7JRS_EXPORT Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType :
        public IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType
{
    friend class Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetName() const;

    virtual bool IsValidName() const;

    /*
     * Set Name element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetName(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Name element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateName();

    /*
     * Get Owner element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetOwner() const;

    virtual bool IsValidOwner() const;

    /*
     * Set Owner element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual void SetOwner(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Owner element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOwner();

        /* @name Choice

         */
        //@{
    /*
     * Get Resource element.
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetResource() const;

    /*
     * Set Resource element.
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetResource(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Entry element.
     * @return Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr
     */
    virtual Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr GetEntry() const;

    /*
     * Set Entry element.
     * @param item const Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr &
     */
    virtual void SetEntry(const Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType();

protected:
    Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsTermUsePtr m_Name;
    bool m_Name_Exist; // For optional elements 
    Mp7JrsPtr< Mp7JrsNode > m_Owner;
    bool m_Owner_Exist; // For optional elements 
// DefinionChoice
    Mp7JrsMediaLocatorPtr m_Resource;
    Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr m_Entry;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _945MP7JRSHANDWRITINGRECOGINFORMATIONTYPE_INKLEXICON_LOCALTYPE_H

