/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _953MP7JRSHANDWRITINGRECOGRESULTTYPE_RESULT_LOCALTYPE_H
#define _953MP7JRSHANDWRITINGRECOGRESULTTYPE_RESULT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHandWritingRecogResultType_Result_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtInclude.h


class IMp7JrsHandWritingRecogResultType_Result_LocalType;
class IMp7JrsReferenceType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogResultType_Result_LocalType> Mp7JrsHandWritingRecogResultType_Result_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsHandWritingRecogResultType_Result_LocalType for class Mp7JrsHandWritingRecogResultType_Result_LocalType<br>
 * Located at: mds-2001.xsd, line 3906<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsHandWritingRecogResultType_Result_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsHandWritingRecogResultType_Result_LocalType();
    virtual ~IMp7JrsHandWritingRecogResultType_Result_LocalType();
    /**
     * Get score attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getscore() const = 0;

    /**
     * Get score attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existscore() const = 0;

    /**
     * Set score attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setscore(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate score attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatescore() = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get Text element.
     * @return XMLCh *
     */
    virtual XMLCh * GetText() const = 0;

    /**
     * Set Text element.
     * @param item XMLCh *
     */
    virtual void SetText(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get LexiconIndexRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetLexiconIndexRef() const = 0;

    /**
     * Set LexiconIndexRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetLexiconIndexRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHandWritingRecogResultType_Result_LocalType<br>
 * Located at: mds-2001.xsd, line 3906<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3906.<br>
 */
class MP7JRS_EXPORT Mp7JrsHandWritingRecogResultType_Result_LocalType :
        public IMp7JrsHandWritingRecogResultType_Result_LocalType
{
    friend class Mp7JrsHandWritingRecogResultType_Result_LocalTypeFactory; // constructs objects

public:
    /*
     * Get score attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getscore() const;

    /*
     * Get score attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existscore() const;

    /*
     * Set score attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setscore(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate score attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatescore();

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get Text element.
     * @return XMLCh *
     */
    virtual XMLCh * GetText() const;

    /*
     * Set Text element.
     * @param item XMLCh *
     */
    virtual void SetText(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get LexiconIndexRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetLexiconIndexRef() const;

    /*
     * Set LexiconIndexRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetLexiconIndexRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHandWritingRecogResultType_Result_LocalType();

protected:
    Mp7JrsHandWritingRecogResultType_Result_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrszeroToOnePtr m_score;
    bool m_score_Exist;


// DefinionChoice
    XMLCh * m_Text;
    Mp7JrsReferencePtr m_LexiconIndexRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _953MP7JRSHANDWRITINGRECOGRESULTTYPE_RESULT_LOCALTYPE_H

