/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _955MP7JRSHARMONICINSTRUMENTTIMBRETYPE_H
#define _955MP7JRSHARMONICINSTRUMENTTIMBRETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHarmonicInstrumentTimbreTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsHarmonicInstrumentTimbreType_ExtInclude.h


#include "Mp7JrsAudioDSType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsHarmonicInstrumentTimbreType;
class IMp7JrsHarmonicSpectralCentroidType;
class IMp7JrsHarmonicSpectralDeviationType;
class IMp7JrsHarmonicSpectralSpreadType;
class IMp7JrsHarmonicSpectralVariationType;
class IMp7JrsLogAttackTimeType;
class IMp7JrsmediaDurationType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAudioDSType > Mp7JrsAudioDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicInstrumentTimbreType> Mp7JrsHarmonicInstrumentTimbrePtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralCentroidType > Mp7JrsHarmonicSpectralCentroidPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralDeviationType > Mp7JrsHarmonicSpectralDeviationPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralSpreadType > Mp7JrsHarmonicSpectralSpreadPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralVariationType > Mp7JrsHarmonicSpectralVariationPtr;
typedef Mp7JrsPtr< IMp7JrsLogAttackTimeType > Mp7JrsLogAttackTimePtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsHarmonicInstrumentTimbreType for class Mp7JrsHarmonicInstrumentTimbreType<br>
 * Located at: audio-2001.xsd, line 390<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsHarmonicInstrumentTimbreType 
 :
        public IMp7JrsAudioDSType
{
public:
    // TODO: make these protected?
    IMp7JrsHarmonicInstrumentTimbreType();
    virtual ~IMp7JrsHarmonicInstrumentTimbreType();
        /** @name Sequence

         */
        //@{
    /**
     * Get LogAttackTime element.
     * @return Mp7JrsLogAttackTimePtr
     */
    virtual Mp7JrsLogAttackTimePtr GetLogAttackTime() const = 0;

    /**
     * Set LogAttackTime element.
     * @param item const Mp7JrsLogAttackTimePtr &
     */
    virtual void SetLogAttackTime(const Mp7JrsLogAttackTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get HarmonicSpectralCentroid element.
     * @return Mp7JrsHarmonicSpectralCentroidPtr
     */
    virtual Mp7JrsHarmonicSpectralCentroidPtr GetHarmonicSpectralCentroid() const = 0;

    /**
     * Set HarmonicSpectralCentroid element.
     * @param item const Mp7JrsHarmonicSpectralCentroidPtr &
     */
    virtual void SetHarmonicSpectralCentroid(const Mp7JrsHarmonicSpectralCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get HarmonicSpectralDeviation element.
     * @return Mp7JrsHarmonicSpectralDeviationPtr
     */
    virtual Mp7JrsHarmonicSpectralDeviationPtr GetHarmonicSpectralDeviation() const = 0;

    /**
     * Set HarmonicSpectralDeviation element.
     * @param item const Mp7JrsHarmonicSpectralDeviationPtr &
     */
    virtual void SetHarmonicSpectralDeviation(const Mp7JrsHarmonicSpectralDeviationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get HarmonicSpectralSpread element.
     * @return Mp7JrsHarmonicSpectralSpreadPtr
     */
    virtual Mp7JrsHarmonicSpectralSpreadPtr GetHarmonicSpectralSpread() const = 0;

    /**
     * Set HarmonicSpectralSpread element.
     * @param item const Mp7JrsHarmonicSpectralSpreadPtr &
     */
    virtual void SetHarmonicSpectralSpread(const Mp7JrsHarmonicSpectralSpreadPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get HarmonicSpectralVariation element.
     * @return Mp7JrsHarmonicSpectralVariationPtr
     */
    virtual Mp7JrsHarmonicSpectralVariationPtr GetHarmonicSpectralVariation() const = 0;

    /**
     * Set HarmonicSpectralVariation element.
     * @param item const Mp7JrsHarmonicSpectralVariationPtr &
     */
    virtual void SetHarmonicSpectralVariation(const Mp7JrsHarmonicSpectralVariationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsHarmonicInstrumentTimbreType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsHarmonicInstrumentTimbreType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHarmonicInstrumentTimbreType<br>
 * Located at: audio-2001.xsd, line 390<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 * Defined in audio-2001.xsd, line 390.<br>
 */
class MP7JRS_EXPORT Mp7JrsHarmonicInstrumentTimbreType :
        public IMp7JrsHarmonicInstrumentTimbreType
{
    friend class Mp7JrsHarmonicInstrumentTimbreTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsHarmonicInstrumentTimbreType
     
     * @return Mp7JrsPtr< Mp7JrsAudioDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioDSType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get LogAttackTime element.
     * @return Mp7JrsLogAttackTimePtr
     */
    virtual Mp7JrsLogAttackTimePtr GetLogAttackTime() const;

    /*
     * Set LogAttackTime element.
     * @param item const Mp7JrsLogAttackTimePtr &
     */
    virtual void SetLogAttackTime(const Mp7JrsLogAttackTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get HarmonicSpectralCentroid element.
     * @return Mp7JrsHarmonicSpectralCentroidPtr
     */
    virtual Mp7JrsHarmonicSpectralCentroidPtr GetHarmonicSpectralCentroid() const;

    /*
     * Set HarmonicSpectralCentroid element.
     * @param item const Mp7JrsHarmonicSpectralCentroidPtr &
     */
    virtual void SetHarmonicSpectralCentroid(const Mp7JrsHarmonicSpectralCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get HarmonicSpectralDeviation element.
     * @return Mp7JrsHarmonicSpectralDeviationPtr
     */
    virtual Mp7JrsHarmonicSpectralDeviationPtr GetHarmonicSpectralDeviation() const;

    /*
     * Set HarmonicSpectralDeviation element.
     * @param item const Mp7JrsHarmonicSpectralDeviationPtr &
     */
    virtual void SetHarmonicSpectralDeviation(const Mp7JrsHarmonicSpectralDeviationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get HarmonicSpectralSpread element.
     * @return Mp7JrsHarmonicSpectralSpreadPtr
     */
    virtual Mp7JrsHarmonicSpectralSpreadPtr GetHarmonicSpectralSpread() const;

    /*
     * Set HarmonicSpectralSpread element.
     * @param item const Mp7JrsHarmonicSpectralSpreadPtr &
     */
    virtual void SetHarmonicSpectralSpread(const Mp7JrsHarmonicSpectralSpreadPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get HarmonicSpectralVariation element.
     * @return Mp7JrsHarmonicSpectralVariationPtr
     */
    virtual Mp7JrsHarmonicSpectralVariationPtr GetHarmonicSpectralVariation() const;

    /*
     * Set HarmonicSpectralVariation element.
     * @param item const Mp7JrsHarmonicSpectralVariationPtr &
     */
    virtual void SetHarmonicSpectralVariation(const Mp7JrsHarmonicSpectralVariationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHarmonicInstrumentTimbreType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHarmonicInstrumentTimbreType();

protected:
    Mp7JrsHarmonicInstrumentTimbreType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioDSType > m_Base;

    Mp7JrsLogAttackTimePtr m_LogAttackTime;
    Mp7JrsHarmonicSpectralCentroidPtr m_HarmonicSpectralCentroid;
    Mp7JrsHarmonicSpectralDeviationPtr m_HarmonicSpectralDeviation;
    Mp7JrsHarmonicSpectralSpreadPtr m_HarmonicSpectralSpread;
    Mp7JrsHarmonicSpectralVariationPtr m_HarmonicSpectralVariation;

// no includefile for extension defined 
// file Mp7JrsHarmonicInstrumentTimbreType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _955MP7JRSHARMONICINSTRUMENTTIMBRETYPE_H

