/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _967MP7JRSHIERARCHICALSUMMARYTYPE_H
#define _967MP7JRSHIERARCHICALSUMMARYTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHierarchicalSummaryTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// begin extension included
// file Mp7JrsHierarchicalSummaryType_ExtInclude.h

class Mp7JrsSummarySegmentGroupType;
class Mp7JrsSummarySegmentType;


// end extension included


#include "Mp7JrsDSType.h"
#include "Mp7JrsHierarchicalSummaryType_hierarchy_LocalType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsSummaryType.h"
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsHierarchicalSummaryType;
class IMp7JrsHierarchicalSummaryType_CollectionType;
class IMp7JrsHierarchicalSummaryType_components_CollectionType;
class IMp7JrsmediaDurationType;
class IMp7JrsReferenceType;
class IMp7JrsSummaryThemeListType;
class IMp7JrsSummaryType;
class IMp7JrsSummaryType_Name_CollectionType;
class IMp7JrsTemporalSegmentLocatorType;
class IMp7JrsUniqueIDType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType_CollectionType > Mp7JrsHierarchicalSummaryType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType_components_CollectionType > Mp7JrsHierarchicalSummaryType_components_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType> Mp7JrsHierarchicalSummaryPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSummaryThemeListType > Mp7JrsSummaryThemeListPtr;
typedef Mp7JrsPtr< IMp7JrsSummaryType > Mp7JrsSummaryPtr;
typedef Mp7JrsPtr< IMp7JrsSummaryType_Name_CollectionType > Mp7JrsSummaryType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalSegmentLocatorType > Mp7JrsTemporalSegmentLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsUniqueIDType > Mp7JrsUniqueIDPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsHierarchicalSummaryType for class Mp7JrsHierarchicalSummaryType<br>
 * Located at: mds-2001.xsd, line 4483<br>
 * Classified: Class<br>
 * Derived from: SummaryType (Class)<br>
 * Derived from: SummaryType (Class)<br>
 * Derived from: SummaryType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsHierarchicalSummaryType 
 :
        public IMp7JrsSummaryType
{
public:
    // TODO: make these protected?
    IMp7JrsHierarchicalSummaryType();
    virtual ~IMp7JrsHierarchicalSummaryType();
    /**
     * Get components attribute.
     * @return Mp7JrsHierarchicalSummaryType_components_CollectionPtr
     */
    virtual Mp7JrsHierarchicalSummaryType_components_CollectionPtr Getcomponents() const = 0;

    /**
     * Get components attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existcomponents() const = 0;

    /**
     * Set components attribute.
     * @param item const Mp7JrsHierarchicalSummaryType_components_CollectionPtr &
     */
    virtual void Setcomponents(const Mp7JrsHierarchicalSummaryType_components_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate components attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatecomponents() = 0;

    /**
     * Get hierarchy attribute.
     * @return Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration
     */
    virtual Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration Gethierarchy() const = 0;

    /**
     * Set hierarchy attribute.
     * @param item Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration
     */
    virtual void Sethierarchy(Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get SummaryThemeList element.
     * @return Mp7JrsSummaryThemeListPtr
     */
    virtual Mp7JrsSummaryThemeListPtr GetSummaryThemeList() const = 0;

    virtual bool IsValidSummaryThemeList() const = 0;

    /**
     * Set SummaryThemeList element.
     * @param item const Mp7JrsSummaryThemeListPtr &
     */
    virtual void SetSummaryThemeList(const Mp7JrsSummaryThemeListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SummaryThemeList element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSummaryThemeList() = 0;

    /**
     * Get HierarchicalSummaryType_LocalType element.
     * @return Mp7JrsHierarchicalSummaryType_CollectionPtr
     */
    virtual Mp7JrsHierarchicalSummaryType_CollectionPtr GetHierarchicalSummaryType_LocalType() const = 0;

    /**
     * Set HierarchicalSummaryType_LocalType element.
     * @param item const Mp7JrsHierarchicalSummaryType_CollectionPtr &
     */
    virtual void SetHierarchicalSummaryType_LocalType(const Mp7JrsHierarchicalSummaryType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsSummaryType_Name_CollectionPtr
     */
    virtual Mp7JrsSummaryType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsSummaryType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsSummaryType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SourceID element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsUniqueIDPtr
     */
    virtual Mp7JrsUniqueIDPtr GetSourceID() const = 0;

    virtual bool IsValidSourceID() const = 0;

    /**
     * Set SourceID element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsUniqueIDPtr &
     */
    virtual void SetSourceID(const Mp7JrsUniqueIDPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SourceID element.
     * (Inherited from Mp7JrsSummaryType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSourceID() = 0;

    /**
     * Get SourceLocator element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsTemporalSegmentLocatorPtr
     */
    virtual Mp7JrsTemporalSegmentLocatorPtr GetSourceLocator() const = 0;

    virtual bool IsValidSourceLocator() const = 0;

    /**
     * Set SourceLocator element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsTemporalSegmentLocatorPtr &
     */
    virtual void SetSourceLocator(const Mp7JrsTemporalSegmentLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SourceLocator element.
     * (Inherited from Mp7JrsSummaryType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSourceLocator() = 0;

    /**
     * Get SourceInformation element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSourceInformation() const = 0;

    virtual bool IsValidSourceInformation() const = 0;

    /**
     * Set SourceInformation element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSourceInformation(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SourceInformation element.
     * (Inherited from Mp7JrsSummaryType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSourceInformation() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// begin extension included
// file Mp7JrsHierarchicalSummaryType_ExtMethodDef.h

public:

	/** Adds a segment group.
	  * @param segmentGroup Segment group to be added. */
	virtual void AddSegmentGroup(Mp7JrsSummarySegmentGroupPtr segmentGroup, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

// end extension included


// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHierarchicalSummaryType<br>
 * Located at: mds-2001.xsd, line 4483<br>
 * Classified: Class<br>
 * Derived from: SummaryType (Class)<br>
 * Derived from: SummaryType (Class)<br>
 * Derived from: SummaryType (Class)<br>
 * Defined in mds-2001.xsd, line 4483.<br>
 */
class MP7JRS_EXPORT Mp7JrsHierarchicalSummaryType :
        public IMp7JrsHierarchicalSummaryType
{
    friend class Mp7JrsHierarchicalSummaryTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsHierarchicalSummaryType
     
     * @return Mp7JrsPtr< Mp7JrsSummaryType >
     */
    virtual Mp7JrsPtr< Mp7JrsSummaryType > GetBase() const;
    /*
     * Get components attribute.
     * @return Mp7JrsHierarchicalSummaryType_components_CollectionPtr
     */
    virtual Mp7JrsHierarchicalSummaryType_components_CollectionPtr Getcomponents() const;

    /*
     * Get components attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existcomponents() const;

    /*
     * Set components attribute.
     * @param item const Mp7JrsHierarchicalSummaryType_components_CollectionPtr &
     */
    virtual void Setcomponents(const Mp7JrsHierarchicalSummaryType_components_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate components attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatecomponents();

    /*
     * Get hierarchy attribute.
     * @return Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration
     */
    virtual Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration Gethierarchy() const;

    /*
     * Set hierarchy attribute.
     * @param item Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration
     */
    virtual void Sethierarchy(Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get SummaryThemeList element.
     * @return Mp7JrsSummaryThemeListPtr
     */
    virtual Mp7JrsSummaryThemeListPtr GetSummaryThemeList() const;

    virtual bool IsValidSummaryThemeList() const;

    /*
     * Set SummaryThemeList element.
     * @param item const Mp7JrsSummaryThemeListPtr &
     */
    virtual void SetSummaryThemeList(const Mp7JrsSummaryThemeListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SummaryThemeList element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSummaryThemeList();

    /*
     * Get HierarchicalSummaryType_LocalType element.
     * @return Mp7JrsHierarchicalSummaryType_CollectionPtr
     */
    virtual Mp7JrsHierarchicalSummaryType_CollectionPtr GetHierarchicalSummaryType_LocalType() const;

    /*
     * Set HierarchicalSummaryType_LocalType element.
     * @param item const Mp7JrsHierarchicalSummaryType_CollectionPtr &
     */
    virtual void SetHierarchicalSummaryType_LocalType(const Mp7JrsHierarchicalSummaryType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsSummaryType_Name_CollectionPtr
     */
    virtual Mp7JrsSummaryType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsSummaryType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsSummaryType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SourceID element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsUniqueIDPtr
     */
    virtual Mp7JrsUniqueIDPtr GetSourceID() const;

    virtual bool IsValidSourceID() const;

    /*
     * Set SourceID element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsUniqueIDPtr &
     */
    virtual void SetSourceID(const Mp7JrsUniqueIDPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SourceID element.
     * (Inherited from Mp7JrsSummaryType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSourceID();

    /*
     * Get SourceLocator element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsTemporalSegmentLocatorPtr
     */
    virtual Mp7JrsTemporalSegmentLocatorPtr GetSourceLocator() const;

    virtual bool IsValidSourceLocator() const;

    /*
     * Set SourceLocator element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsTemporalSegmentLocatorPtr &
     */
    virtual void SetSourceLocator(const Mp7JrsTemporalSegmentLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SourceLocator element.
     * (Inherited from Mp7JrsSummaryType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSourceLocator();

    /*
     * Get SourceInformation element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSourceInformation() const;

    virtual bool IsValidSourceInformation() const;

    /*
     * Set SourceInformation element.
<br>
     * (Inherited from Mp7JrsSummaryType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSourceInformation(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SourceInformation element.
     * (Inherited from Mp7JrsSummaryType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSourceInformation();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHierarchicalSummaryType();

protected:
    Mp7JrsHierarchicalSummaryType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsHierarchicalSummaryType_components_CollectionPtr m_components;
    bool m_components_Exist;
    Mp7JrsHierarchicalSummaryType_hierarchy_LocalType::Enumeration m_hierarchy;

    // Base Class
    Mp7JrsPtr< Mp7JrsSummaryType > m_Base;

    Mp7JrsSummaryThemeListPtr m_SummaryThemeList;
    bool m_SummaryThemeList_Exist; // For optional elements 
    Mp7JrsHierarchicalSummaryType_CollectionPtr m_HierarchicalSummaryType_LocalType;

// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _967MP7JRSHIERARCHICALSUMMARYTYPE_H

