/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _981MP7JRSHOMOGENEOUSTEXTURETYPE_H
#define _981MP7JRSHOMOGENEOUSTEXTURETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHomogeneousTextureTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsHomogeneousTextureType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsHomogeneousTextureType;
class IMp7JrstextureListType;
class IMp7Jrsunsigned8;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsHomogeneousTextureType> Mp7JrsHomogeneousTexturePtr;
typedef Mp7JrsPtr< IMp7JrstextureListType > Mp7JrstextureListPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned8 > Mp7Jrsunsigned8Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsHomogeneousTextureType for class Mp7JrsHomogeneousTextureType<br>
 * Located at: visual-2001.xsd, line 663<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsHomogeneousTextureType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsHomogeneousTextureType();
    virtual ~IMp7JrsHomogeneousTextureType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Average element.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetAverage() const = 0;

    /**
     * Set Average element.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetAverage(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get StandardDeviation element.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetStandardDeviation() const = 0;

    /**
     * Set StandardDeviation element.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetStandardDeviation(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Energy element.
     * @return Mp7JrstextureListPtr
     */
    virtual Mp7JrstextureListPtr GetEnergy() const = 0;

    /**
     * Set Energy element.
     * @param item const Mp7JrstextureListPtr &
     */
    virtual void SetEnergy(const Mp7JrstextureListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get EnergyDeviation element.
     * @return Mp7JrstextureListPtr
     */
    virtual Mp7JrstextureListPtr GetEnergyDeviation() const = 0;

    virtual bool IsValidEnergyDeviation() const = 0;

    /**
     * Set EnergyDeviation element.
     * @param item const Mp7JrstextureListPtr &
     */
    virtual void SetEnergyDeviation(const Mp7JrstextureListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate EnergyDeviation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateEnergyDeviation() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsHomogeneousTextureType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsHomogeneousTextureType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHomogeneousTextureType<br>
 * Located at: visual-2001.xsd, line 663<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 663.<br>
 */
class MP7JRS_EXPORT Mp7JrsHomogeneousTextureType :
        public IMp7JrsHomogeneousTextureType
{
    friend class Mp7JrsHomogeneousTextureTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsHomogeneousTextureType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Average element.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetAverage() const;

    /*
     * Set Average element.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetAverage(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get StandardDeviation element.
     * @return Mp7Jrsunsigned8Ptr
     */
    virtual Mp7Jrsunsigned8Ptr GetStandardDeviation() const;

    /*
     * Set StandardDeviation element.
     * @param item const Mp7Jrsunsigned8Ptr &
     */
    virtual void SetStandardDeviation(const Mp7Jrsunsigned8Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Energy element.
     * @return Mp7JrstextureListPtr
     */
    virtual Mp7JrstextureListPtr GetEnergy() const;

    /*
     * Set Energy element.
     * @param item const Mp7JrstextureListPtr &
     */
    virtual void SetEnergy(const Mp7JrstextureListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get EnergyDeviation element.
     * @return Mp7JrstextureListPtr
     */
    virtual Mp7JrstextureListPtr GetEnergyDeviation() const;

    virtual bool IsValidEnergyDeviation() const;

    /*
     * Set EnergyDeviation element.
     * @param item const Mp7JrstextureListPtr &
     */
    virtual void SetEnergyDeviation(const Mp7JrstextureListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate EnergyDeviation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateEnergyDeviation();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHomogeneousTextureType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHomogeneousTextureType();

protected:
    Mp7JrsHomogeneousTextureType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7Jrsunsigned8Ptr m_Average;
    Mp7Jrsunsigned8Ptr m_StandardDeviation;
    Mp7JrstextureListPtr m_Energy;
    Mp7JrstextureListPtr m_EnergyDeviation;
    bool m_EnergyDeviation_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsHomogeneousTextureType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _981MP7JRSHOMOGENEOUSTEXTURETYPE_H

