/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _985MP7JRSIMAGELOCATORTYPE_H
#define _985MP7JRSIMAGELOCATORTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsImageLocatorTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsImageLocatorType_ExtInclude.h


#include "Mp7JrsMediaLocatorType.h"
class IMp7JrsImageLocatorType;
class IMp7JrsImageLocatorType_BytePosition_LocalType;
class IMp7JrsInlineMediaType;
class IMp7JrsMediaLocatorType;
class IMp7JrsMediaRelIncrTimePointType;
class IMp7JrsMediaRelTimePointType;
class IMp7JrsmediaTimePointType;
typedef Mp7JrsPtr< IMp7JrsImageLocatorType_BytePosition_LocalType > Mp7JrsImageLocatorType_BytePosition_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsImageLocatorType> Mp7JrsImageLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsInlineMediaType > Mp7JrsInlineMediaPtr;
typedef Mp7JrsPtr< IMp7JrsMediaLocatorType > Mp7JrsMediaLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsMediaRelIncrTimePointType > Mp7JrsMediaRelIncrTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsMediaRelTimePointType > Mp7JrsMediaRelTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsmediaTimePointType > Mp7JrsmediaTimePointPtr;

/** 
 * Generated interface IMp7JrsImageLocatorType for class Mp7JrsImageLocatorType<br>
 * Located at: mds-2001.xsd, line 1136<br>
 * Classified: Class<br>
 * Derived from: MediaLocatorType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsImageLocatorType 
 :
        public IMp7JrsMediaLocatorType
{
public:
    // TODO: make these protected?
    IMp7JrsImageLocatorType();
    virtual ~IMp7JrsImageLocatorType();
        /** @name Choice

         */
        //@{
    /**
     * Get MediaTimePoint element.
     * @return Mp7JrsmediaTimePointPtr
     */
    virtual Mp7JrsmediaTimePointPtr GetMediaTimePoint() const = 0;

    /**
     * Set MediaTimePoint element.
     * @param item const Mp7JrsmediaTimePointPtr &
     */
    virtual void SetMediaTimePoint(const Mp7JrsmediaTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaRelTimePoint element.
     * @return Mp7JrsMediaRelTimePointPtr
     */
    virtual Mp7JrsMediaRelTimePointPtr GetMediaRelTimePoint() const = 0;

    /**
     * Set MediaRelTimePoint element.
     * @param item const Mp7JrsMediaRelTimePointPtr &
     */
    virtual void SetMediaRelTimePoint(const Mp7JrsMediaRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaRelIncrTimePoint element.
     * @return Mp7JrsMediaRelIncrTimePointPtr
     */
    virtual Mp7JrsMediaRelIncrTimePointPtr GetMediaRelIncrTimePoint() const = 0;

    /**
     * Set MediaRelIncrTimePoint element.
     * @param item const Mp7JrsMediaRelIncrTimePointPtr &
     */
    virtual void SetMediaRelIncrTimePoint(const Mp7JrsMediaRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get BytePosition element.
     * @return Mp7JrsImageLocatorType_BytePosition_LocalPtr
     */
    virtual Mp7JrsImageLocatorType_BytePosition_LocalPtr GetBytePosition() const = 0;

    /**
     * Set BytePosition element.
     * @param item const Mp7JrsImageLocatorType_BytePosition_LocalPtr &
     */
    virtual void SetBytePosition(const Mp7JrsImageLocatorType_BytePosition_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get MediaUri element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @return XMLCh *
     */
    virtual XMLCh * GetMediaUri() const = 0;

    /**
     * Set MediaUri element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @param item XMLCh *
     */
    virtual void SetMediaUri(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get InlineMedia element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @return Mp7JrsInlineMediaPtr
     */
    virtual Mp7JrsInlineMediaPtr GetInlineMedia() const = 0;

    /**
     * Set InlineMedia element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @param item const Mp7JrsInlineMediaPtr &
     */
    virtual void SetInlineMedia(const Mp7JrsInlineMediaPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get StreamID element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @return unsigned
     */
    virtual unsigned GetStreamID() const = 0;

    virtual bool IsValidStreamID() const = 0;

    /**
     * Set StreamID element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @param item unsigned
     */
    virtual void SetStreamID(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate StreamID element.
     * (Inherited from Mp7JrsMediaLocatorType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStreamID() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsImageLocatorType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsImageLocatorType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsImageLocatorType<br>
 * Located at: mds-2001.xsd, line 1136<br>
 * Classified: Class<br>
 * Derived from: MediaLocatorType (Class)<br>
 * Defined in mds-2001.xsd, line 1136.<br>
 */
class MP7JRS_EXPORT Mp7JrsImageLocatorType :
        public IMp7JrsImageLocatorType
{
    friend class Mp7JrsImageLocatorTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsImageLocatorType
     
     * @return Mp7JrsPtr< Mp7JrsMediaLocatorType >
     */
    virtual Mp7JrsPtr< Mp7JrsMediaLocatorType > GetBase() const;
        /* @name Choice

         */
        //@{
    /*
     * Get MediaTimePoint element.
     * @return Mp7JrsmediaTimePointPtr
     */
    virtual Mp7JrsmediaTimePointPtr GetMediaTimePoint() const;

    /*
     * Set MediaTimePoint element.
     * @param item const Mp7JrsmediaTimePointPtr &
     */
    virtual void SetMediaTimePoint(const Mp7JrsmediaTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaRelTimePoint element.
     * @return Mp7JrsMediaRelTimePointPtr
     */
    virtual Mp7JrsMediaRelTimePointPtr GetMediaRelTimePoint() const;

    /*
     * Set MediaRelTimePoint element.
     * @param item const Mp7JrsMediaRelTimePointPtr &
     */
    virtual void SetMediaRelTimePoint(const Mp7JrsMediaRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaRelIncrTimePoint element.
     * @return Mp7JrsMediaRelIncrTimePointPtr
     */
    virtual Mp7JrsMediaRelIncrTimePointPtr GetMediaRelIncrTimePoint() const;

    /*
     * Set MediaRelIncrTimePoint element.
     * @param item const Mp7JrsMediaRelIncrTimePointPtr &
     */
    virtual void SetMediaRelIncrTimePoint(const Mp7JrsMediaRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get BytePosition element.
     * @return Mp7JrsImageLocatorType_BytePosition_LocalPtr
     */
    virtual Mp7JrsImageLocatorType_BytePosition_LocalPtr GetBytePosition() const;

    /*
     * Set BytePosition element.
     * @param item const Mp7JrsImageLocatorType_BytePosition_LocalPtr &
     */
    virtual void SetBytePosition(const Mp7JrsImageLocatorType_BytePosition_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get MediaUri element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @return XMLCh *
     */
    virtual XMLCh * GetMediaUri() const;

    /*
     * Set MediaUri element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @param item XMLCh *
     */
    virtual void SetMediaUri(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get InlineMedia element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @return Mp7JrsInlineMediaPtr
     */
    virtual Mp7JrsInlineMediaPtr GetInlineMedia() const;

    /*
     * Set InlineMedia element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @param item const Mp7JrsInlineMediaPtr &
     */
    virtual void SetInlineMedia(const Mp7JrsInlineMediaPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get StreamID element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @return unsigned
     */
    virtual unsigned GetStreamID() const;

    virtual bool IsValidStreamID() const;

    /*
     * Set StreamID element.
<br>
     * (Inherited from Mp7JrsMediaLocatorType)
     * @param item unsigned
     */
    virtual void SetStreamID(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate StreamID element.
     * (Inherited from Mp7JrsMediaLocatorType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStreamID();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsImageLocatorType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsImageLocatorType();

protected:
    Mp7JrsImageLocatorType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsMediaLocatorType > m_Base;

// DefinionChoice
    Mp7JrsmediaTimePointPtr m_MediaTimePoint;
    Mp7JrsMediaRelTimePointPtr m_MediaRelTimePoint;
    Mp7JrsMediaRelIncrTimePointPtr m_MediaRelIncrTimePoint;
    Mp7JrsImageLocatorType_BytePosition_LocalPtr m_BytePosition;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsImageLocatorType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _985MP7JRSIMAGELOCATORTYPE_H

