/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1009MP7JRSINKMEDIAINFORMATIONTYPE_BRUSH_LOCALTYPE_H
#define _1009MP7JRSINKMEDIAINFORMATIONTYPE_BRUSH_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkMediaInformationType_Brush_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Brush_LocalType_ExtInclude.h


class IMp7JrsInkMediaInformationType_Brush_LocalType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Brush_LocalType> Mp7JrsInkMediaInformationType_Brush_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsInkMediaInformationType_Brush_LocalType for class Mp7JrsInkMediaInformationType_Brush_LocalType<br>
 * Located at: mds-2001.xsd, line 3800<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsInkMediaInformationType_Brush_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsInkMediaInformationType_Brush_LocalType();
    virtual ~IMp7JrsInkMediaInformationType_Brush_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetName() const = 0;

    virtual bool IsValidName() const = 0;

    /**
     * Set Name element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetName(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Name element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateName() = 0;

    /**
     * Get Color element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetColor() const = 0;

    virtual bool IsValidColor() const = 0;

    /**
     * Set Color element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetColor(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Color element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColor() = 0;

    /**
     * Get Shape element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetShape() const = 0;

    virtual bool IsValidShape() const = 0;

    /**
     * Set Shape element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetShape(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Shape element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateShape() = 0;

    /**
     * Get Size element.
     * @return unsigned
     */
    virtual unsigned GetSize() const = 0;

    virtual bool IsValidSize() const = 0;

    /**
     * Set Size element.
     * @param item unsigned
     */
    virtual void SetSize(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Size element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSize() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Brush_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Brush_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkMediaInformationType_Brush_LocalType<br>
 * Located at: mds-2001.xsd, line 3800<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3800.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkMediaInformationType_Brush_LocalType :
        public IMp7JrsInkMediaInformationType_Brush_LocalType
{
    friend class Mp7JrsInkMediaInformationType_Brush_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetName() const;

    virtual bool IsValidName() const;

    /*
     * Set Name element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetName(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Name element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateName();

    /*
     * Get Color element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetColor() const;

    virtual bool IsValidColor() const;

    /*
     * Set Color element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetColor(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Color element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColor();

    /*
     * Get Shape element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetShape() const;

    virtual bool IsValidShape() const;

    /*
     * Set Shape element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetShape(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Shape element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateShape();

    /*
     * Get Size element.
     * @return unsigned
     */
    virtual unsigned GetSize() const;

    virtual bool IsValidSize() const;

    /*
     * Set Size element.
     * @param item unsigned
     */
    virtual void SetSize(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Size element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSize();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Brush_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkMediaInformationType_Brush_LocalType();

protected:
    Mp7JrsInkMediaInformationType_Brush_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsTermUsePtr m_Name;
    bool m_Name_Exist; // For optional elements 
    Mp7JrsTermUsePtr m_Color;
    bool m_Color_Exist; // For optional elements 
    Mp7JrsTermUsePtr m_Shape;
    bool m_Shape_Exist; // For optional elements 
    unsigned m_Size;
    bool m_Size_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_Brush_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1009MP7JRSINKMEDIAINFORMATIONTYPE_BRUSH_LOCALTYPE_H

