/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1013MP7JRSINKMEDIAINFORMATIONTYPE_INPUTDEVICE_LOCALTYPE_H
#define _1013MP7JRSINKMEDIAINFORMATIONTYPE_INPUTDEVICE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkMediaInformationType_InputDevice_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtInclude.h


class IMp7JrsInkMediaInformationType_InputDevice_LocalType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_InputDevice_LocalType> Mp7JrsInkMediaInformationType_InputDevice_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsInkMediaInformationType_InputDevice_LocalType for class Mp7JrsInkMediaInformationType_InputDevice_LocalType<br>
 * Located at: mds-2001.xsd, line 3757<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsInkMediaInformationType_InputDevice_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsInkMediaInformationType_InputDevice_LocalType();
    virtual ~IMp7JrsInkMediaInformationType_InputDevice_LocalType();
    /**
     * Get xWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetxWidth() const = 0;

    /**
     * Get xWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistxWidth() const = 0;

    /**
     * Set xWidth attribute.
     * @param item unsigned
     */
    virtual void SetxWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate xWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatexWidth() = 0;

    /**
     * Get yWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetyWidth() const = 0;

    /**
     * Get yWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistyWidth() const = 0;

    /**
     * Set yWidth attribute.
     * @param item unsigned
     */
    virtual void SetyWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate yWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateyWidth() = 0;

    /**
     * Get resolutionX attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionX() const = 0;

    /**
     * Get resolutionX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionX() const = 0;

    /**
     * Set resolutionX attribute.
     * @param item unsigned
     */
    virtual void SetresolutionX(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionX() = 0;

    /**
     * Get resolutionY attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionY() const = 0;

    /**
     * Get resolutionY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionY() const = 0;

    /**
     * Set resolutionY attribute.
     * @param item unsigned
     */
    virtual void SetresolutionY(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionY() = 0;

    /**
     * Get resolutionZ attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionZ() const = 0;

    /**
     * Get resolutionZ attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionZ() const = 0;

    /**
     * Set resolutionZ attribute.
     * @param item unsigned
     */
    virtual void SetresolutionZ(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionZ attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionZ() = 0;

    /**
     * Get resolutionP attribute.
     * @return int
     */
    virtual int GetresolutionP() const = 0;

    /**
     * Get resolutionP attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionP() const = 0;

    /**
     * Set resolutionP attribute.
     * @param item int
     */
    virtual void SetresolutionP(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionP attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionP() = 0;

    /**
     * Get resolutionS attribute.
     * @return int
     */
    virtual int GetresolutionS() const = 0;

    /**
     * Get resolutionS attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionS() const = 0;

    /**
     * Set resolutionS attribute.
     * @param item int
     */
    virtual void SetresolutionS(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionS attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionS() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Device element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetDevice() const = 0;

    /**
     * Set Device element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetDevice(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkMediaInformationType_InputDevice_LocalType<br>
 * Located at: mds-2001.xsd, line 3757<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3757.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkMediaInformationType_InputDevice_LocalType :
        public IMp7JrsInkMediaInformationType_InputDevice_LocalType
{
    friend class Mp7JrsInkMediaInformationType_InputDevice_LocalTypeFactory; // constructs objects

public:
    /*
     * Get xWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetxWidth() const;

    /*
     * Get xWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistxWidth() const;

    /*
     * Set xWidth attribute.
     * @param item unsigned
     */
    virtual void SetxWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate xWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatexWidth();

    /*
     * Get yWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetyWidth() const;

    /*
     * Get yWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistyWidth() const;

    /*
     * Set yWidth attribute.
     * @param item unsigned
     */
    virtual void SetyWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate yWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateyWidth();

    /*
     * Get resolutionX attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionX() const;

    /*
     * Get resolutionX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionX() const;

    /*
     * Set resolutionX attribute.
     * @param item unsigned
     */
    virtual void SetresolutionX(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionX();

    /*
     * Get resolutionY attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionY() const;

    /*
     * Get resolutionY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionY() const;

    /*
     * Set resolutionY attribute.
     * @param item unsigned
     */
    virtual void SetresolutionY(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionY();

    /*
     * Get resolutionZ attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionZ() const;

    /*
     * Get resolutionZ attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionZ() const;

    /*
     * Set resolutionZ attribute.
     * @param item unsigned
     */
    virtual void SetresolutionZ(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionZ attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionZ();

    /*
     * Get resolutionP attribute.
     * @return int
     */
    virtual int GetresolutionP() const;

    /*
     * Get resolutionP attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionP() const;

    /*
     * Set resolutionP attribute.
     * @param item int
     */
    virtual void SetresolutionP(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionP attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionP();

    /*
     * Get resolutionS attribute.
     * @return int
     */
    virtual int GetresolutionS() const;

    /*
     * Get resolutionS attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionS() const;

    /*
     * Set resolutionS attribute.
     * @param item int
     */
    virtual void SetresolutionS(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionS attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionS();

        /* @name Sequence

         */
        //@{
    /*
     * Get Device element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetDevice() const;

    /*
     * Set Device element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetDevice(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkMediaInformationType_InputDevice_LocalType();

protected:
    Mp7JrsInkMediaInformationType_InputDevice_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_xWidth;
    bool m_xWidth_Exist;
    unsigned m_yWidth;
    bool m_yWidth_Exist;
    unsigned m_resolutionX;
    bool m_resolutionX_Exist;
    unsigned m_resolutionY;
    bool m_resolutionY_Exist;
    unsigned m_resolutionZ;
    bool m_resolutionZ_Exist;
    int m_resolutionP;
    bool m_resolutionP_Exist;
    int m_resolutionS;
    bool m_resolutionS_Exist;


    Mp7JrsTermUsePtr m_Device;

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1013MP7JRSINKMEDIAINFORMATIONTYPE_INPUTDEVICE_LOCALTYPE_H

