/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1017MP7JRSINKMEDIAINFORMATIONTYPE_OVERLAIDMEDIA_LOCALTYPE_H
#define _1017MP7JRSINKMEDIAINFORMATIONTYPE_OVERLAIDMEDIA_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtInclude.h


class IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType;
class IMp7JrsMediaLocatorType;
class IMp7JrsReferenceType;
class IMp7JrsRegionLocatorType;
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType> Mp7JrsInkMediaInformationType_OverlaidMedia_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaLocatorType > Mp7JrsMediaLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType > Mp7JrsRegionLocatorPtr;

/** 
 * Generated interface IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType for class Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType<br>
 * Located at: mds-2001.xsd, line 3783<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType();
    virtual ~IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType();
    /**
     * Get fieldIDRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetfieldIDRef() const = 0;

    /**
     * Get fieldIDRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistfieldIDRef() const = 0;

    /**
     * Set fieldIDRef attribute.
     * @param item XMLCh *
     */
    virtual void SetfieldIDRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate fieldIDRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatefieldIDRef() = 0;

    /**
     * Get translationX attribute.
     * @return int
     */
    virtual int GettranslationX() const = 0;

    /**
     * Get translationX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttranslationX() const = 0;

    /**
     * Set translationX attribute.
     * @param item int
     */
    virtual void SettranslationX(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate translationX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetranslationX() = 0;

    /**
     * Get translationY attribute.
     * @return int
     */
    virtual int GettranslationY() const = 0;

    /**
     * Get translationY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttranslationY() const = 0;

    /**
     * Set translationY attribute.
     * @param item int
     */
    virtual void SettranslationY(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate translationY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetranslationY() = 0;

    /**
     * Get rotation attribute.
     * @return float
     */
    virtual float Getrotation() const = 0;

    /**
     * Get rotation attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrotation() const = 0;

    /**
     * Set rotation attribute.
     * @param item float
     */
    virtual void Setrotation(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate rotation attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterotation() = 0;

    /**
     * Get scaleX attribute.
     * @return float
     */
    virtual float GetscaleX() const = 0;

    /**
     * Get scaleX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistscaleX() const = 0;

    /**
     * Set scaleX attribute.
     * @param item float
     */
    virtual void SetscaleX(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate scaleX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatescaleX() = 0;

    /**
     * Get scaleY attribute.
     * @return float
     */
    virtual float GetscaleY() const = 0;

    /**
     * Get scaleY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistscaleY() const = 0;

    /**
     * Set scaleY attribute.
     * @param item float
     */
    virtual void SetscaleY(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate scaleY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatescaleY() = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get OverlaidMediaLocator element.
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetOverlaidMediaLocator() const = 0;

    /**
     * Set OverlaidMediaLocator element.
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetOverlaidMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get OverlaidMediaRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetOverlaidMediaRef() const = 0;

    /**
     * Set OverlaidMediaRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetOverlaidMediaRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get MediaRegionLocator element.
     * @return Mp7JrsRegionLocatorPtr
     */
    virtual Mp7JrsRegionLocatorPtr GetMediaRegionLocator() const = 0;

    virtual bool IsValidMediaRegionLocator() const = 0;

    /**
     * Set MediaRegionLocator element.
     * @param item const Mp7JrsRegionLocatorPtr &
     */
    virtual void SetMediaRegionLocator(const Mp7JrsRegionLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaRegionLocator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaRegionLocator() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType<br>
 * Located at: mds-2001.xsd, line 3783<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3783.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType :
        public IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType
{
    friend class Mp7JrsInkMediaInformationType_OverlaidMedia_LocalTypeFactory; // constructs objects

public:
    /*
     * Get fieldIDRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetfieldIDRef() const;

    /*
     * Get fieldIDRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistfieldIDRef() const;

    /*
     * Set fieldIDRef attribute.
     * @param item XMLCh *
     */
    virtual void SetfieldIDRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate fieldIDRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatefieldIDRef();

    /*
     * Get translationX attribute.
     * @return int
     */
    virtual int GettranslationX() const;

    /*
     * Get translationX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttranslationX() const;

    /*
     * Set translationX attribute.
     * @param item int
     */
    virtual void SettranslationX(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate translationX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetranslationX();

    /*
     * Get translationY attribute.
     * @return int
     */
    virtual int GettranslationY() const;

    /*
     * Get translationY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttranslationY() const;

    /*
     * Set translationY attribute.
     * @param item int
     */
    virtual void SettranslationY(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate translationY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetranslationY();

    /*
     * Get rotation attribute.
     * @return float
     */
    virtual float Getrotation() const;

    /*
     * Get rotation attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrotation() const;

    /*
     * Set rotation attribute.
     * @param item float
     */
    virtual void Setrotation(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate rotation attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterotation();

    /*
     * Get scaleX attribute.
     * @return float
     */
    virtual float GetscaleX() const;

    /*
     * Get scaleX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistscaleX() const;

    /*
     * Set scaleX attribute.
     * @param item float
     */
    virtual void SetscaleX(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate scaleX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatescaleX();

    /*
     * Get scaleY attribute.
     * @return float
     */
    virtual float GetscaleY() const;

    /*
     * Get scaleY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistscaleY() const;

    /*
     * Set scaleY attribute.
     * @param item float
     */
    virtual void SetscaleY(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate scaleY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatescaleY();

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get OverlaidMediaLocator element.
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetOverlaidMediaLocator() const;

    /*
     * Set OverlaidMediaLocator element.
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetOverlaidMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get OverlaidMediaRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetOverlaidMediaRef() const;

    /*
     * Set OverlaidMediaRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetOverlaidMediaRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get MediaRegionLocator element.
     * @return Mp7JrsRegionLocatorPtr
     */
    virtual Mp7JrsRegionLocatorPtr GetMediaRegionLocator() const;

    virtual bool IsValidMediaRegionLocator() const;

    /*
     * Set MediaRegionLocator element.
     * @param item const Mp7JrsRegionLocatorPtr &
     */
    virtual void SetMediaRegionLocator(const Mp7JrsRegionLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaRegionLocator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaRegionLocator();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType();

protected:
    Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_fieldIDRef;
    bool m_fieldIDRef_Exist;
    int m_translationX;
    bool m_translationX_Exist;
    int m_translationX_Default;
    int m_translationY;
    bool m_translationY_Exist;
    int m_translationY_Default;
    float m_rotation;
    bool m_rotation_Exist;
    float m_rotation_Default;
    float m_scaleX;
    bool m_scaleX_Exist;
    float m_scaleX_Default;
    float m_scaleY;
    bool m_scaleY_Exist;
    float m_scaleY_Default;


// DefinionChoice
    Mp7JrsMediaLocatorPtr m_OverlaidMediaLocator;
    Mp7JrsReferencePtr m_OverlaidMediaRef;
// End DefinionChoice
    Mp7JrsRegionLocatorPtr m_MediaRegionLocator;
    bool m_MediaRegionLocator_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1017MP7JRSINKMEDIAINFORMATIONTYPE_OVERLAIDMEDIA_LOCALTYPE_H

