/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1075MP7JRSINLINETERMDEFINITIONTYPE_TERM_LOCALTYPE_H
#define _1075MP7JRSINLINETERMDEFINITIONTYPE_TERM_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInlineTermDefinitionType_Term_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtInclude.h


#include "Mp7JrsInlineTermDefinitionType.h"
class IMp7JrsInlineTermDefinitionType;
class IMp7JrsInlineTermDefinitionType_Definition_CollectionType;
class IMp7JrsInlineTermDefinitionType_Name_CollectionType;
class IMp7JrsInlineTermDefinitionType_Term_CollectionType;
class IMp7JrsInlineTermDefinitionType_Term_LocalType;
class IMp7JrstermRelationQualifierType;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType > Mp7JrsInlineTermDefinitionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Definition_CollectionType > Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Name_CollectionType > Mp7JrsInlineTermDefinitionType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Term_CollectionType > Mp7JrsInlineTermDefinitionType_Term_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Term_LocalType> Mp7JrsInlineTermDefinitionType_Term_LocalPtr;
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType > Mp7JrstermRelationQualifierPtr;

/** 
 * Generated interface IMp7JrsInlineTermDefinitionType_Term_LocalType for class Mp7JrsInlineTermDefinitionType_Term_LocalType<br>
 * Located at: mds-2001.xsd, line 1487<br>
 * Classified: Class<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsInlineTermDefinitionType_Term_LocalType 
 :
        public IMp7JrsInlineTermDefinitionType
{
public:
    // TODO: make these protected?
    IMp7JrsInlineTermDefinitionType_Term_LocalType();
    virtual ~IMp7JrsInlineTermDefinitionType_Term_LocalType();
    /**
     * Get relation attribute.
     * @return Mp7JrstermRelationQualifierPtr
     */
    virtual Mp7JrstermRelationQualifierPtr Getrelation() const = 0;

    /**
     * Get relation attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrelation() const = 0;

    /**
     * Set relation attribute.
     * @param item const Mp7JrstermRelationQualifierPtr &
     */
    virtual void Setrelation(const Mp7JrstermRelationQualifierPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate relation attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterelation() = 0;

    /**
     * Get termID attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GettermID() const = 0;

    /**
     * Get termID attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttermID() const = 0;

    /**
     * Set termID attribute.
     * @param item XMLCh *
     */
    virtual void SettermID(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate termID attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetermID() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Name_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr GetDefinition() const = 0;

    /**
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Term_CollectionPtr GetTerm() const = 0;

    /**
     * Set Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInlineTermDefinitionType_Term_LocalType<br>
 * Located at: mds-2001.xsd, line 1487<br>
 * Classified: Class<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Derived from: InlineTermDefinitionType (Class)<br>
 * Defined in mds-2001.xsd, line 1487.<br>
 */
class MP7JRS_EXPORT Mp7JrsInlineTermDefinitionType_Term_LocalType :
        public IMp7JrsInlineTermDefinitionType_Term_LocalType
{
    friend class Mp7JrsInlineTermDefinitionType_Term_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsInlineTermDefinitionType_Term_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsInlineTermDefinitionType >
     */
    virtual Mp7JrsPtr< Mp7JrsInlineTermDefinitionType > GetBase() const;
    /*
     * Get relation attribute.
     * @return Mp7JrstermRelationQualifierPtr
     */
    virtual Mp7JrstermRelationQualifierPtr Getrelation() const;

    /*
     * Get relation attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrelation() const;

    /*
     * Set relation attribute.
     * @param item const Mp7JrstermRelationQualifierPtr &
     */
    virtual void Setrelation(const Mp7JrstermRelationQualifierPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate relation attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterelation();

    /*
     * Get termID attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GettermID() const;

    /*
     * Get termID attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttermID() const;

    /*
     * Set termID attribute.
     * @param item XMLCh *
     */
    virtual void SettermID(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate termID attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetermID();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Name_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr GetDefinition() const;

    /*
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr &
     */
    virtual void SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @return Mp7JrsInlineTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsInlineTermDefinitionType_Term_CollectionPtr GetTerm() const;

    /*
     * Set Term element.
<br>
     * (Inherited from Mp7JrsInlineTermDefinitionType)
     * @param item const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInlineTermDefinitionType_Term_LocalType();

protected:
    Mp7JrsInlineTermDefinitionType_Term_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrstermRelationQualifierPtr m_relation;
    bool m_relation_Exist;
    Mp7JrstermRelationQualifierPtr m_relation_Default;
    XMLCh * m_termID;
    bool m_termID_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsInlineTermDefinitionType > m_Base;


// no includefile for extension defined 
// file Mp7JrsInlineTermDefinitionType_Term_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1075MP7JRSINLINETERMDEFINITIONTYPE_TERM_LOCALTYPE_H

