/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1097MP7JRSIRREGULARVISUALTIMESERIESTYPE_H
#define _1097MP7JRSIRREGULARVISUALTIMESERIESTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsIrregularVisualTimeSeriesTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtInclude.h


#include "Mp7JrsVisualTimeSeriesType.h"
class IMp7JrsIrregularVisualTimeSeriesType;
class IMp7JrsIrregularVisualTimeSeriesType_CollectionType;
class IMp7JrsmediaDurationType;
class IMp7JrsVisualTimeSeriesType;
typedef Mp7JrsPtr< IMp7JrsIrregularVisualTimeSeriesType_CollectionType > Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsIrregularVisualTimeSeriesType> Mp7JrsIrregularVisualTimeSeriesPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsVisualTimeSeriesType > Mp7JrsVisualTimeSeriesPtr;

/** 
 * Generated interface IMp7JrsIrregularVisualTimeSeriesType for class Mp7JrsIrregularVisualTimeSeriesType<br>
 * Located at: visual-2001.xsd, line 78<br>
 * Classified: Class<br>
 * Derived from: VisualTimeSeriesType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsIrregularVisualTimeSeriesType 
 :
        public IMp7JrsVisualTimeSeriesType
{
public:
    // TODO: make these protected?
    IMp7JrsIrregularVisualTimeSeriesType();
    virtual ~IMp7JrsIrregularVisualTimeSeriesType();
        /** @name Sequence

         */
        //@{
    /**
     * Get IrregularVisualTimeSeriesType_LocalType element.
     * @return Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr
     */
    virtual Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr GetIrregularVisualTimeSeriesType_LocalType() const = 0;

    /**
     * Set IrregularVisualTimeSeriesType_LocalType element.
     * @param item const Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr &
     */
    virtual void SetIrregularVisualTimeSeriesType_LocalType(const Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get offset attribute.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr Getoffset() const = 0;

    /**
     * Get offset attribute validity information.
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existoffset() const = 0;

    /**
     * Set offset attribute.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void Setoffset(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate offset attribute.
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateoffset() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get TimeIncr element.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetTimeIncr() const = 0;

    /**
     * Set TimeIncr element.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetTimeIncr(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsIrregularVisualTimeSeriesType<br>
 * Located at: visual-2001.xsd, line 78<br>
 * Classified: Class<br>
 * Derived from: VisualTimeSeriesType (Class)<br>
 * Defined in visual-2001.xsd, line 78.<br>
 */
class MP7JRS_EXPORT Mp7JrsIrregularVisualTimeSeriesType :
        public IMp7JrsIrregularVisualTimeSeriesType
{
    friend class Mp7JrsIrregularVisualTimeSeriesTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsIrregularVisualTimeSeriesType
     
     * @return Mp7JrsPtr< Mp7JrsVisualTimeSeriesType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualTimeSeriesType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get IrregularVisualTimeSeriesType_LocalType element.
     * @return Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr
     */
    virtual Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr GetIrregularVisualTimeSeriesType_LocalType() const;

    /*
     * Set IrregularVisualTimeSeriesType_LocalType element.
     * @param item const Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr &
     */
    virtual void SetIrregularVisualTimeSeriesType_LocalType(const Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get offset attribute.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr Getoffset() const;

    /*
     * Get offset attribute validity information.
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existoffset() const;

    /*
     * Set offset attribute.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void Setoffset(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate offset attribute.
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateoffset();

        /* @name Sequence

         */
        //@{
    /*
     * Get TimeIncr element.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetTimeIncr() const;

    /*
     * Set TimeIncr element.
<br>
     * (Inherited from Mp7JrsVisualTimeSeriesType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetTimeIncr(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsIrregularVisualTimeSeriesType();

protected:
    Mp7JrsIrregularVisualTimeSeriesType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualTimeSeriesType > m_Base;

    Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr m_IrregularVisualTimeSeriesType_LocalType;

// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1097MP7JRSIRREGULARVISUALTIMESERIESTYPE_H

