/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1107MP7JRSKEYWORDANNOTATIONTYPE_H
#define _1107MP7JRSKEYWORDANNOTATIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsKeywordAnnotationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsKeywordAnnotationType_ExtInclude.h


class IMp7JrsKeywordAnnotationType;
class IMp7JrsKeywordAnnotationType_Keyword_CollectionType;
typedef Mp7JrsPtr< IMp7JrsKeywordAnnotationType_Keyword_CollectionType > Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsKeywordAnnotationType> Mp7JrsKeywordAnnotationPtr;

/** 
 * Generated interface IMp7JrsKeywordAnnotationType for class Mp7JrsKeywordAnnotationType<br>
 * Located at: mds-2001.xsd, line 1211<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsKeywordAnnotationType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsKeywordAnnotationType();
    virtual ~IMp7JrsKeywordAnnotationType();
    /**
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Keyword element.
     * @return Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr
     */
    virtual Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr GetKeyword() const = 0;

    /**
     * Set Keyword element.
     * @param item const Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr &
     */
    virtual void SetKeyword(const Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsKeywordAnnotationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsKeywordAnnotationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsKeywordAnnotationType<br>
 * Located at: mds-2001.xsd, line 1211<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1211.<br>
 */
class MP7JRS_EXPORT Mp7JrsKeywordAnnotationType :
        public IMp7JrsKeywordAnnotationType
{
    friend class Mp7JrsKeywordAnnotationTypeFactory; // constructs objects

public:
    /*
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get Keyword element.
     * @return Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr
     */
    virtual Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr GetKeyword() const;

    /*
     * Set Keyword element.
     * @param item const Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr &
     */
    virtual void SetKeyword(const Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsKeywordAnnotationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsKeywordAnnotationType();

protected:
    Mp7JrsKeywordAnnotationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_lang;
    bool m_lang_Exist;


    Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr m_Keyword;

// no includefile for extension defined 
// file Mp7JrsKeywordAnnotationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1107MP7JRSKEYWORDANNOTATIONTYPE_H

