/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1123MP7JRSMASKTYPE_H
#define _1123MP7JRSMASKTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMaskTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMaskType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDType;
class IMp7JrsMaskType;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsMaskType> Mp7JrsMaskPtr;

/** 
 * Generated interface IMp7JrsMaskType for class Mp7JrsMaskType<br>
 * Located at: mds-2001.xsd, line 2966<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Abstract class <br>
 */
class MP7JRS_EXPORT IMp7JrsMaskType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsMaskType();
    virtual ~IMp7JrsMaskType();
// no includefile for extension defined 
// file Mp7JrsMaskType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMaskType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMaskType<br>
 * Located at: mds-2001.xsd, line 2966<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Abstract class <br>
 * Defined in mds-2001.xsd, line 2966.<br>
 */
class MP7JRS_EXPORT Mp7JrsMaskType :
        public IMp7JrsMaskType
{
    friend class Mp7JrsMaskTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMaskType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMaskType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMaskType();

protected:
    Mp7JrsMaskType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;


// no includefile for extension defined 
// file Mp7JrsMaskType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1123MP7JRSMASKTYPE_H

