/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1125MP7JRSMATCHINGHINTTYPE_H
#define _1125MP7JRSMATCHINGHINTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMatchingHintTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMatchingHintType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDType;
class IMp7JrsMatchingHintType;
class IMp7JrsMatchingHintType_Hint_CollectionType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsMatchingHintType_Hint_CollectionType > Mp7JrsMatchingHintType_Hint_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMatchingHintType> Mp7JrsMatchingHintPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsMatchingHintType for class Mp7JrsMatchingHintType<br>
 * Located at: mds-2001.xsd, line 3067<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMatchingHintType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsMatchingHintType();
    virtual ~IMp7JrsMatchingHintType();
    /**
     * Get reliability attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const = 0;

    /**
     * Get reliability attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const = 0;

    /**
     * Set reliability attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate reliability attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Hint element.
     * @return Mp7JrsMatchingHintType_Hint_CollectionPtr
     */
    virtual Mp7JrsMatchingHintType_Hint_CollectionPtr GetHint() const = 0;

    /**
     * Set Hint element.
     * @param item const Mp7JrsMatchingHintType_Hint_CollectionPtr &
     */
    virtual void SetHint(const Mp7JrsMatchingHintType_Hint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMatchingHintType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMatchingHintType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMatchingHintType<br>
 * Located at: mds-2001.xsd, line 3067<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 3067.<br>
 */
class MP7JRS_EXPORT Mp7JrsMatchingHintType :
        public IMp7JrsMatchingHintType
{
    friend class Mp7JrsMatchingHintTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMatchingHintType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
    /*
     * Get reliability attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const;

    /*
     * Get reliability attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const;

    /*
     * Set reliability attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate reliability attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability();

        /* @name Sequence

         */
        //@{
    /*
     * Get Hint element.
     * @return Mp7JrsMatchingHintType_Hint_CollectionPtr
     */
    virtual Mp7JrsMatchingHintType_Hint_CollectionPtr GetHint() const;

    /*
     * Set Hint element.
     * @param item const Mp7JrsMatchingHintType_Hint_CollectionPtr &
     */
    virtual void SetHint(const Mp7JrsMatchingHintType_Hint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMatchingHintType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMatchingHintType();

protected:
    Mp7JrsMatchingHintType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrszeroToOnePtr m_reliability;
    bool m_reliability_Exist;
    Mp7JrszeroToOnePtr m_reliability_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsMatchingHintType_Hint_CollectionPtr m_Hint;

// no includefile for extension defined 
// file Mp7JrsMatchingHintType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1125MP7JRSMATCHINGHINTTYPE_H

