/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1151MP7JRSMEDIAFORMATTYPE_AUDIOCODING_LOCALTYPE_H
#define _1151MP7JRSMEDIAFORMATTYPE_AUDIOCODING_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaFormatType_AudioCoding_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtInclude.h


class IMp7JrsControlledTermUseType;
class IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType;
class IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2;
class IMp7JrsMediaFormatType_AudioCoding_LocalType;
class IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType > Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2 > Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_LocalType> Mp7JrsMediaFormatType_AudioCoding_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType > Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr;

/** 
 * Generated interface IMp7JrsMediaFormatType_AudioCoding_LocalType for class Mp7JrsMediaFormatType_AudioCoding_LocalType<br>
 * Located at: mds-2001.xsd, line 2250<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaFormatType_AudioCoding_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaFormatType_AudioCoding_LocalType();
    virtual ~IMp7JrsMediaFormatType_AudioCoding_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Format element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetFormat() const = 0;

    virtual bool IsValidFormat() const = 0;

    /**
     * Set Format element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Format element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFormat() = 0;

    /**
     * Get AudioChannels element.
     * @return Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr GetAudioChannels() const = 0;

    virtual bool IsValidAudioChannels() const = 0;

    /**
     * Set AudioChannels element.
     * @param item const Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr &
     */
    virtual void SetAudioChannels(const Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate AudioChannels element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioChannels() = 0;

    /**
     * Get Sample element.
     * @return Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr GetSample() const = 0;

    virtual bool IsValidSample() const = 0;

    /**
     * Set Sample element.
     * @param item const Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr &
     */
    virtual void SetSample(const Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Sample element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSample() = 0;

    /**
     * Get Emphasis element.
     * @return Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr GetEmphasis() const = 0;

    virtual bool IsValidEmphasis() const = 0;

    /**
     * Set Emphasis element.
     * @param item const Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr &
     */
    virtual void SetEmphasis(const Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Emphasis element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateEmphasis() = 0;

    /**
     * Get Presentation element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetPresentation() const = 0;

    virtual bool IsValidPresentation() const = 0;

    /**
     * Set Presentation element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetPresentation(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Presentation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePresentation() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaFormatType_AudioCoding_LocalType<br>
 * Located at: mds-2001.xsd, line 2250<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2250.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_AudioCoding_LocalType :
        public IMp7JrsMediaFormatType_AudioCoding_LocalType
{
    friend class Mp7JrsMediaFormatType_AudioCoding_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Format element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetFormat() const;

    virtual bool IsValidFormat() const;

    /*
     * Set Format element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Format element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFormat();

    /*
     * Get AudioChannels element.
     * @return Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr GetAudioChannels() const;

    virtual bool IsValidAudioChannels() const;

    /*
     * Set AudioChannels element.
     * @param item const Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr &
     */
    virtual void SetAudioChannels(const Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate AudioChannels element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioChannels();

    /*
     * Get Sample element.
     * @return Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr GetSample() const;

    virtual bool IsValidSample() const;

    /*
     * Set Sample element.
     * @param item const Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr &
     */
    virtual void SetSample(const Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Sample element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSample();

    /*
     * Get Emphasis element.
     * @return Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr GetEmphasis() const;

    virtual bool IsValidEmphasis() const;

    /*
     * Set Emphasis element.
     * @param item const Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr &
     */
    virtual void SetEmphasis(const Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Emphasis element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateEmphasis();

    /*
     * Get Presentation element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetPresentation() const;

    virtual bool IsValidPresentation() const;

    /*
     * Set Presentation element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetPresentation(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Presentation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePresentation();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaFormatType_AudioCoding_LocalType();

protected:
    Mp7JrsMediaFormatType_AudioCoding_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsControlledTermUsePtr m_Format;
    bool m_Format_Exist; // For optional elements 
    Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr m_AudioChannels;
    bool m_AudioChannels_Exist; // For optional elements 
    Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr m_Sample;
    bool m_Sample_Exist; // For optional elements 
    Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr m_Emphasis;
    bool m_Emphasis_Exist; // For optional elements 
    Mp7JrsControlledTermUsePtr m_Presentation;
    bool m_Presentation_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1151MP7JRSMEDIAFORMATTYPE_AUDIOCODING_LOCALTYPE_H

