/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1179MP7JRSMEDIAFORMATTYPE_VISUALCODING_LOCALTYPE_H
#define _1179MP7JRSMEDIAFORMATTYPE_VISUALCODING_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaFormatType_VisualCoding_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtInclude.h


class IMp7JrsColorSamplingType;
class IMp7JrsMediaFormatType_VisualCoding_Format_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Pixel_LocalType;
typedef Mp7JrsPtr< IMp7JrsColorSamplingType > Mp7JrsColorSamplingPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Format_LocalType > Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType > Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_LocalType> Mp7JrsMediaFormatType_VisualCoding_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Pixel_LocalType > Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr;

/** 
 * Generated interface IMp7JrsMediaFormatType_VisualCoding_LocalType for class Mp7JrsMediaFormatType_VisualCoding_LocalType<br>
 * Located at: mds-2001.xsd, line 2187<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaFormatType_VisualCoding_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaFormatType_VisualCoding_LocalType();
    virtual ~IMp7JrsMediaFormatType_VisualCoding_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Format element.
     * @return Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr GetFormat() const = 0;

    virtual bool IsValidFormat() const = 0;

    /**
     * Set Format element.
     * @param item const Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr &
     */
    virtual void SetFormat(const Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Format element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFormat() = 0;

    /**
     * Get Pixel element.
     * @return Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr GetPixel() const = 0;

    virtual bool IsValidPixel() const = 0;

    /**
     * Set Pixel element.
     * @param item const Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr &
     */
    virtual void SetPixel(const Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Pixel element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePixel() = 0;

    /**
     * Get Frame element.
     * @return Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr GetFrame() const = 0;

    virtual bool IsValidFrame() const = 0;

    /**
     * Set Frame element.
     * @param item const Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr &
     */
    virtual void SetFrame(const Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Frame element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFrame() = 0;

    /**
     * Get ColorSampling element.
     * @return Mp7JrsColorSamplingPtr
     */
    virtual Mp7JrsColorSamplingPtr GetColorSampling() const = 0;

    virtual bool IsValidColorSampling() const = 0;

    /**
     * Set ColorSampling element.
     * @param item const Mp7JrsColorSamplingPtr &
     */
    virtual void SetColorSampling(const Mp7JrsColorSamplingPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ColorSampling element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorSampling() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaFormatType_VisualCoding_LocalType<br>
 * Located at: mds-2001.xsd, line 2187<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2187.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_VisualCoding_LocalType :
        public IMp7JrsMediaFormatType_VisualCoding_LocalType
{
    friend class Mp7JrsMediaFormatType_VisualCoding_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Format element.
     * @return Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr GetFormat() const;

    virtual bool IsValidFormat() const;

    /*
     * Set Format element.
     * @param item const Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr &
     */
    virtual void SetFormat(const Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Format element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFormat();

    /*
     * Get Pixel element.
     * @return Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr GetPixel() const;

    virtual bool IsValidPixel() const;

    /*
     * Set Pixel element.
     * @param item const Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr &
     */
    virtual void SetPixel(const Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Pixel element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePixel();

    /*
     * Get Frame element.
     * @return Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr GetFrame() const;

    virtual bool IsValidFrame() const;

    /*
     * Set Frame element.
     * @param item const Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr &
     */
    virtual void SetFrame(const Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Frame element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFrame();

    /*
     * Get ColorSampling element.
     * @return Mp7JrsColorSamplingPtr
     */
    virtual Mp7JrsColorSamplingPtr GetColorSampling() const;

    virtual bool IsValidColorSampling() const;

    /*
     * Set ColorSampling element.
     * @param item const Mp7JrsColorSamplingPtr &
     */
    virtual void SetColorSampling(const Mp7JrsColorSamplingPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ColorSampling element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateColorSampling();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaFormatType_VisualCoding_LocalType();

protected:
    Mp7JrsMediaFormatType_VisualCoding_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr m_Format;
    bool m_Format_Exist; // For optional elements 
    Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr m_Pixel;
    bool m_Pixel_Exist; // For optional elements 
    Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr m_Frame;
    bool m_Frame_Exist; // For optional elements 
    Mp7JrsColorSamplingPtr m_ColorSampling;
    bool m_ColorSampling_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1179MP7JRSMEDIAFORMATTYPE_VISUALCODING_LOCALTYPE_H

