/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1183MP7JRSMEDIAIDENTIFICATIONTYPE_H
#define _1183MP7JRSMEDIAIDENTIFICATIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaIdentificationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaIdentificationType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDType;
class IMp7JrsMediaIdentificationType;
class IMp7JrsMediaIdentificationType_AudioDomain_CollectionType;
class IMp7JrsMediaIdentificationType_ImageDomain_CollectionType;
class IMp7JrsMediaIdentificationType_VideoDomain_CollectionType;
class IMp7JrsUniqueIDType;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType_AudioDomain_CollectionType > Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType_ImageDomain_CollectionType > Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType_VideoDomain_CollectionType > Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType> Mp7JrsMediaIdentificationPtr;
typedef Mp7JrsPtr< IMp7JrsUniqueIDType > Mp7JrsUniqueIDPtr;

/** 
 * Generated interface IMp7JrsMediaIdentificationType for class Mp7JrsMediaIdentificationType<br>
 * Located at: mds-2001.xsd, line 2104<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaIdentificationType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsMediaIdentificationType();
    virtual ~IMp7JrsMediaIdentificationType();
        /** @name Sequence

         */
        //@{
    /**
     * Get EntityIdentifier element.
     * @return Mp7JrsUniqueIDPtr
     */
    virtual Mp7JrsUniqueIDPtr GetEntityIdentifier() const = 0;

    /**
     * Set EntityIdentifier element.
     * @param item const Mp7JrsUniqueIDPtr &
     */
    virtual void SetEntityIdentifier(const Mp7JrsUniqueIDPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioDomain element.
     * @return Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr
     */
    virtual Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr GetAudioDomain() const = 0;

    /**
     * Set AudioDomain element.
     * @param item const Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr &
     */
    virtual void SetAudioDomain(const Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VideoDomain element.
     * @return Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr
     */
    virtual Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr GetVideoDomain() const = 0;

    /**
     * Set VideoDomain element.
     * @param item const Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr &
     */
    virtual void SetVideoDomain(const Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ImageDomain element.
     * @return Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr
     */
    virtual Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr GetImageDomain() const = 0;

    /**
     * Set ImageDomain element.
     * @param item const Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr &
     */
    virtual void SetImageDomain(const Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaIdentificationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaIdentificationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaIdentificationType<br>
 * Located at: mds-2001.xsd, line 2104<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 2104.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaIdentificationType :
        public IMp7JrsMediaIdentificationType
{
    friend class Mp7JrsMediaIdentificationTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMediaIdentificationType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get EntityIdentifier element.
     * @return Mp7JrsUniqueIDPtr
     */
    virtual Mp7JrsUniqueIDPtr GetEntityIdentifier() const;

    /*
     * Set EntityIdentifier element.
     * @param item const Mp7JrsUniqueIDPtr &
     */
    virtual void SetEntityIdentifier(const Mp7JrsUniqueIDPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioDomain element.
     * @return Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr
     */
    virtual Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr GetAudioDomain() const;

    /*
     * Set AudioDomain element.
     * @param item const Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr &
     */
    virtual void SetAudioDomain(const Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VideoDomain element.
     * @return Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr
     */
    virtual Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr GetVideoDomain() const;

    /*
     * Set VideoDomain element.
     * @param item const Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr &
     */
    virtual void SetVideoDomain(const Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ImageDomain element.
     * @return Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr
     */
    virtual Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr GetImageDomain() const;

    /*
     * Set ImageDomain element.
     * @param item const Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr &
     */
    virtual void SetImageDomain(const Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaIdentificationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaIdentificationType();

protected:
    Mp7JrsMediaIdentificationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsUniqueIDPtr m_EntityIdentifier;
    Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr m_AudioDomain;
    Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr m_VideoDomain;
    Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr m_ImageDomain;

// no includefile for extension defined 
// file Mp7JrsMediaIdentificationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1183MP7JRSMEDIAIDENTIFICATIONTYPE_H

