/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1201MP7JRSMEDIAPROFILETYPE_H
#define _1201MP7JRSMEDIAPROFILETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaProfileTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaProfileType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsMediaFormatType;
class IMp7JrsMediaProfileType;
class IMp7JrsMediaProfileType_ComponentMediaProfile_CollectionType;
class IMp7JrsMediaProfileType_MediaInstance_CollectionType;
class IMp7JrsMediaQualityType;
class IMp7JrsMediaTranscodingHintsType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType > Mp7JrsMediaFormatPtr;
typedef Mp7JrsPtr< IMp7JrsMediaProfileType_ComponentMediaProfile_CollectionType > Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaProfileType_MediaInstance_CollectionType > Mp7JrsMediaProfileType_MediaInstance_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaProfileType> Mp7JrsMediaProfilePtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType > Mp7JrsMediaQualityPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType > Mp7JrsMediaTranscodingHintsPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsMediaProfileType for class Mp7JrsMediaProfileType<br>
 * Located at: mds-2001.xsd, line 2120<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaProfileType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsMediaProfileType();
    virtual ~IMp7JrsMediaProfileType();
    /**
     * Get master attribute.
     * @return bool
     */
    virtual bool Getmaster() const = 0;

    /**
     * Get master attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existmaster() const = 0;

    /**
     * Set master attribute.
     * @param item bool
     */
    virtual void Setmaster(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate master attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatemaster() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get ComponentMediaProfile element.
     * @return Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr
     */
    virtual Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr GetComponentMediaProfile() const = 0;

    /**
     * Set ComponentMediaProfile element.
     * @param item const Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr &
     */
    virtual void SetComponentMediaProfile(const Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaFormat element.
     * @return Mp7JrsMediaFormatPtr
     */
    virtual Mp7JrsMediaFormatPtr GetMediaFormat() const = 0;

    virtual bool IsValidMediaFormat() const = 0;

    /**
     * Set MediaFormat element.
     * @param item const Mp7JrsMediaFormatPtr &
     */
    virtual void SetMediaFormat(const Mp7JrsMediaFormatPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaFormat element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaFormat() = 0;

    /**
     * Get MediaTranscodingHints element.
     * @return Mp7JrsMediaTranscodingHintsPtr
     */
    virtual Mp7JrsMediaTranscodingHintsPtr GetMediaTranscodingHints() const = 0;

    virtual bool IsValidMediaTranscodingHints() const = 0;

    /**
     * Set MediaTranscodingHints element.
     * @param item const Mp7JrsMediaTranscodingHintsPtr &
     */
    virtual void SetMediaTranscodingHints(const Mp7JrsMediaTranscodingHintsPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaTranscodingHints element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaTranscodingHints() = 0;

    /**
     * Get MediaQuality element.
     * @return Mp7JrsMediaQualityPtr
     */
    virtual Mp7JrsMediaQualityPtr GetMediaQuality() const = 0;

    virtual bool IsValidMediaQuality() const = 0;

    /**
     * Set MediaQuality element.
     * @param item const Mp7JrsMediaQualityPtr &
     */
    virtual void SetMediaQuality(const Mp7JrsMediaQualityPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaQuality element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaQuality() = 0;

    /**
     * Get MediaInstance element.
     * @return Mp7JrsMediaProfileType_MediaInstance_CollectionPtr
     */
    virtual Mp7JrsMediaProfileType_MediaInstance_CollectionPtr GetMediaInstance() const = 0;

    /**
     * Set MediaInstance element.
     * @param item const Mp7JrsMediaProfileType_MediaInstance_CollectionPtr &
     */
    virtual void SetMediaInstance(const Mp7JrsMediaProfileType_MediaInstance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaProfileType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaProfileType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaProfileType<br>
 * Located at: mds-2001.xsd, line 2120<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 2120.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaProfileType :
        public IMp7JrsMediaProfileType
{
    friend class Mp7JrsMediaProfileTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMediaProfileType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get master attribute.
     * @return bool
     */
    virtual bool Getmaster() const;

    /*
     * Get master attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existmaster() const;

    /*
     * Set master attribute.
     * @param item bool
     */
    virtual void Setmaster(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate master attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatemaster();

        /* @name Sequence

         */
        //@{
    /*
     * Get ComponentMediaProfile element.
     * @return Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr
     */
    virtual Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr GetComponentMediaProfile() const;

    /*
     * Set ComponentMediaProfile element.
     * @param item const Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr &
     */
    virtual void SetComponentMediaProfile(const Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaFormat element.
     * @return Mp7JrsMediaFormatPtr
     */
    virtual Mp7JrsMediaFormatPtr GetMediaFormat() const;

    virtual bool IsValidMediaFormat() const;

    /*
     * Set MediaFormat element.
     * @param item const Mp7JrsMediaFormatPtr &
     */
    virtual void SetMediaFormat(const Mp7JrsMediaFormatPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaFormat element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaFormat();

    /*
     * Get MediaTranscodingHints element.
     * @return Mp7JrsMediaTranscodingHintsPtr
     */
    virtual Mp7JrsMediaTranscodingHintsPtr GetMediaTranscodingHints() const;

    virtual bool IsValidMediaTranscodingHints() const;

    /*
     * Set MediaTranscodingHints element.
     * @param item const Mp7JrsMediaTranscodingHintsPtr &
     */
    virtual void SetMediaTranscodingHints(const Mp7JrsMediaTranscodingHintsPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaTranscodingHints element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaTranscodingHints();

    /*
     * Get MediaQuality element.
     * @return Mp7JrsMediaQualityPtr
     */
    virtual Mp7JrsMediaQualityPtr GetMediaQuality() const;

    virtual bool IsValidMediaQuality() const;

    /*
     * Set MediaQuality element.
     * @param item const Mp7JrsMediaQualityPtr &
     */
    virtual void SetMediaQuality(const Mp7JrsMediaQualityPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaQuality element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaQuality();

    /*
     * Get MediaInstance element.
     * @return Mp7JrsMediaProfileType_MediaInstance_CollectionPtr
     */
    virtual Mp7JrsMediaProfileType_MediaInstance_CollectionPtr GetMediaInstance() const;

    /*
     * Set MediaInstance element.
     * @param item const Mp7JrsMediaProfileType_MediaInstance_CollectionPtr &
     */
    virtual void SetMediaInstance(const Mp7JrsMediaProfileType_MediaInstance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaProfileType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaProfileType();

protected:
    Mp7JrsMediaProfileType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_master;
    bool m_master_Exist;
    bool m_master_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr m_ComponentMediaProfile;
    Mp7JrsMediaFormatPtr m_MediaFormat;
    bool m_MediaFormat_Exist; // For optional elements 
    Mp7JrsMediaTranscodingHintsPtr m_MediaTranscodingHints;
    bool m_MediaTranscodingHints_Exist; // For optional elements 
    Mp7JrsMediaQualityPtr m_MediaQuality;
    bool m_MediaQuality_Exist; // For optional elements 
    Mp7JrsMediaProfileType_MediaInstance_CollectionPtr m_MediaInstance;

// no includefile for extension defined 
// file Mp7JrsMediaProfileType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1201MP7JRSMEDIAPROFILETYPE_H

