/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1207MP7JRSMEDIAQUALITYTYPE_H
#define _1207MP7JRSMEDIAQUALITYTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaQualityTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAgentType;
class IMp7JrsDType;
class IMp7JrsMediaQualityType;
class IMp7JrsMediaQualityType_PerceptibleDefects_LocalType;
class IMp7JrsMediaQualityType_QualityRating_CollectionType;
class IMp7JrsMediaQualityType_RatingInformationLocator_CollectionType;
typedef Mp7JrsPtr< IMp7JrsAgentType > Mp7JrsAgentPtr;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_LocalType > Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_QualityRating_CollectionType > Mp7JrsMediaQualityType_QualityRating_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_RatingInformationLocator_CollectionType > Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType> Mp7JrsMediaQualityPtr;

/** 
 * Generated interface IMp7JrsMediaQualityType for class Mp7JrsMediaQualityType<br>
 * Located at: mds-2001.xsd, line 2400<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaQualityType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsMediaQualityType();
    virtual ~IMp7JrsMediaQualityType();
        /** @name Sequence

         */
        //@{
    /**
     * Get QualityRating element.
     * @return Mp7JrsMediaQualityType_QualityRating_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_QualityRating_CollectionPtr GetQualityRating() const = 0;

    /**
     * Set QualityRating element.
     * @param item const Mp7JrsMediaQualityType_QualityRating_CollectionPtr &
     */
    virtual void SetQualityRating(const Mp7JrsMediaQualityType_QualityRating_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RatingSource element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetRatingSource() const = 0;

    virtual bool IsValidRatingSource() const = 0;

    /**
     * Set RatingSource element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual void SetRatingSource(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate RatingSource element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRatingSource() = 0;

    /**
     * Get RatingInformationLocator element.
     * @return Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr GetRatingInformationLocator() const = 0;

    /**
     * Set RatingInformationLocator element.
     * @param item const Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr &
     */
    virtual void SetRatingInformationLocator(const Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PerceptibleDefects element.
     * @return Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr
     */
    virtual Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr GetPerceptibleDefects() const = 0;

    virtual bool IsValidPerceptibleDefects() const = 0;

    /**
     * Set PerceptibleDefects element.
     * @param item const Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr &
     */
    virtual void SetPerceptibleDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PerceptibleDefects element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePerceptibleDefects() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaQualityType<br>
 * Located at: mds-2001.xsd, line 2400<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 2400.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaQualityType :
        public IMp7JrsMediaQualityType
{
    friend class Mp7JrsMediaQualityTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMediaQualityType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get QualityRating element.
     * @return Mp7JrsMediaQualityType_QualityRating_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_QualityRating_CollectionPtr GetQualityRating() const;

    /*
     * Set QualityRating element.
     * @param item const Mp7JrsMediaQualityType_QualityRating_CollectionPtr &
     */
    virtual void SetQualityRating(const Mp7JrsMediaQualityType_QualityRating_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RatingSource element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetRatingSource() const;

    virtual bool IsValidRatingSource() const;

    /*
     * Set RatingSource element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual void SetRatingSource(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate RatingSource element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRatingSource();

    /*
     * Get RatingInformationLocator element.
     * @return Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr GetRatingInformationLocator() const;

    /*
     * Set RatingInformationLocator element.
     * @param item const Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr &
     */
    virtual void SetRatingInformationLocator(const Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PerceptibleDefects element.
     * @return Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr
     */
    virtual Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr GetPerceptibleDefects() const;

    virtual bool IsValidPerceptibleDefects() const;

    /*
     * Set PerceptibleDefects element.
     * @param item const Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr &
     */
    virtual void SetPerceptibleDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PerceptibleDefects element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePerceptibleDefects();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaQualityType();

protected:
    Mp7JrsMediaQualityType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsMediaQualityType_QualityRating_CollectionPtr m_QualityRating;
    Mp7JrsPtr< Mp7JrsNode > m_RatingSource;
    bool m_RatingSource_Exist; // For optional elements 
    Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr m_RatingInformationLocator;
    Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr m_PerceptibleDefects;
    bool m_PerceptibleDefects_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMediaQualityType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1207MP7JRSMEDIAQUALITYTYPE_H

