/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1211MP7JRSMEDIAQUALITYTYPE_PERCEPTIBLEDEFECTS_LOCALTYPE_H
#define _1211MP7JRSMEDIAQUALITYTYPE_PERCEPTIBLEDEFECTS_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_PerceptibleDefects_LocalType_ExtInclude.h


class IMp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType;
class IMp7JrsMediaQualityType_PerceptibleDefects_LocalType;
class IMp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType > Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_LocalType> Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType > Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr;

/** 
 * Generated interface IMp7JrsMediaQualityType_PerceptibleDefects_LocalType for class Mp7JrsMediaQualityType_PerceptibleDefects_LocalType<br>
 * Located at: mds-2001.xsd, line 2423<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaQualityType_PerceptibleDefects_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaQualityType_PerceptibleDefects_LocalType();
    virtual ~IMp7JrsMediaQualityType_PerceptibleDefects_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get VisualDefects element.
     * @return Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr GetVisualDefects() const = 0;

    /**
     * Set VisualDefects element.
     * @param item const Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr &
     */
    virtual void SetVisualDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioDefects element.
     * @return Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr GetAudioDefects() const = 0;

    /**
     * Set AudioDefects element.
     * @param item const Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr &
     */
    virtual void SetAudioDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_PerceptibleDefects_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_PerceptibleDefects_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaQualityType_PerceptibleDefects_LocalType<br>
 * Located at: mds-2001.xsd, line 2423<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2423.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaQualityType_PerceptibleDefects_LocalType :
        public IMp7JrsMediaQualityType_PerceptibleDefects_LocalType
{
    friend class Mp7JrsMediaQualityType_PerceptibleDefects_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get VisualDefects element.
     * @return Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr GetVisualDefects() const;

    /*
     * Set VisualDefects element.
     * @param item const Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr &
     */
    virtual void SetVisualDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioDefects element.
     * @return Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr
     */
    virtual Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr GetAudioDefects() const;

    /*
     * Set AudioDefects element.
     * @param item const Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr &
     */
    virtual void SetAudioDefects(const Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_PerceptibleDefects_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaQualityType_PerceptibleDefects_LocalType();

protected:
    Mp7JrsMediaQualityType_PerceptibleDefects_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr m_VisualDefects;
    Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr m_AudioDefects;

// no includefile for extension defined 
// file Mp7JrsMediaQualityType_PerceptibleDefects_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1211MP7JRSMEDIAQUALITYTYPE_PERCEPTIBLEDEFECTS_LOCALTYPE_H

