/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1217MP7JRSMEDIAQUALITYTYPE_QUALITYRATING_LOCALTYPE_H
#define _1217MP7JRSMEDIAQUALITYTYPE_QUALITYRATING_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaQualityType_QualityRating_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_QualityRating_LocalType_ExtInclude.h


#include "Mp7JrsMediaQualityType_QualityRating_type_LocalType.h"
#include "Mp7JrsRatingType.h"
class IMp7JrsMediaQualityType_QualityRating_LocalType;
class IMp7JrsRatingType;
class IMp7JrsRatingType_RatingScheme_LocalType;
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_QualityRating_LocalType> Mp7JrsMediaQualityType_QualityRating_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsRatingType > Mp7JrsRatingPtr;
typedef Mp7JrsPtr< IMp7JrsRatingType_RatingScheme_LocalType > Mp7JrsRatingType_RatingScheme_LocalPtr;

/** 
 * Generated interface IMp7JrsMediaQualityType_QualityRating_LocalType for class Mp7JrsMediaQualityType_QualityRating_LocalType<br>
 * Located at: mds-2001.xsd, line 2405<br>
 * Classified: Class<br>
 * Derived from: RatingType (Class)<br>
 * Derived from: RatingType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaQualityType_QualityRating_LocalType 
 :
        public IMp7JrsRatingType
{
public:
    // TODO: make these protected?
    IMp7JrsMediaQualityType_QualityRating_LocalType();
    virtual ~IMp7JrsMediaQualityType_QualityRating_LocalType();
    /**
     * Get type attribute.
     * @return Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration
     */
    virtual Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration Gettype() const = 0;

    /**
     * Set type attribute.
     * @param item Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get RatingValue element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @return float
     */
    virtual float GetRatingValue() const = 0;

    /**
     * Set RatingValue element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @param item float
     */
    virtual void SetRatingValue(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RatingScheme element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @return Mp7JrsRatingType_RatingScheme_LocalPtr
     */
    virtual Mp7JrsRatingType_RatingScheme_LocalPtr GetRatingScheme() const = 0;

    /**
     * Set RatingScheme element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @param item const Mp7JrsRatingType_RatingScheme_LocalPtr &
     */
    virtual void SetRatingScheme(const Mp7JrsRatingType_RatingScheme_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_QualityRating_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_QualityRating_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaQualityType_QualityRating_LocalType<br>
 * Located at: mds-2001.xsd, line 2405<br>
 * Classified: Class<br>
 * Derived from: RatingType (Class)<br>
 * Derived from: RatingType (Class)<br>
 * Defined in mds-2001.xsd, line 2405.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaQualityType_QualityRating_LocalType :
        public IMp7JrsMediaQualityType_QualityRating_LocalType
{
    friend class Mp7JrsMediaQualityType_QualityRating_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMediaQualityType_QualityRating_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsRatingType >
     */
    virtual Mp7JrsPtr< Mp7JrsRatingType > GetBase() const;
    /*
     * Get type attribute.
     * @return Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration
     */
    virtual Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration Gettype() const;

    /*
     * Set type attribute.
     * @param item Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get RatingValue element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @return float
     */
    virtual float GetRatingValue() const;

    /*
     * Set RatingValue element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @param item float
     */
    virtual void SetRatingValue(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RatingScheme element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @return Mp7JrsRatingType_RatingScheme_LocalPtr
     */
    virtual Mp7JrsRatingType_RatingScheme_LocalPtr GetRatingScheme() const;

    /*
     * Set RatingScheme element.
<br>
     * (Inherited from Mp7JrsRatingType)
     * @param item const Mp7JrsRatingType_RatingScheme_LocalPtr &
     */
    virtual void SetRatingScheme(const Mp7JrsRatingType_RatingScheme_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaQualityType_QualityRating_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaQualityType_QualityRating_LocalType();

protected:
    Mp7JrsMediaQualityType_QualityRating_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsMediaQualityType_QualityRating_type_LocalType::Enumeration m_type;

    // Base Class
    Mp7JrsPtr< Mp7JrsRatingType > m_Base;


// no includefile for extension defined 
// file Mp7JrsMediaQualityType_QualityRating_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1217MP7JRSMEDIAQUALITYTYPE_QUALITYRATING_LOCALTYPE_H

