/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1233MP7JRSMEDIASPACEMASKTYPE_H
#define _1233MP7JRSMEDIASPACEMASKTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaSpaceMaskTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMaskType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsMaskType;
class IMp7JrsMediaSpaceMaskType;
class IMp7JrsMediaSpaceMaskType_SubInterval_CollectionType;
typedef Mp7JrsPtr< IMp7JrsMaskType > Mp7JrsMaskPtr;
typedef Mp7JrsPtr< IMp7JrsMediaSpaceMaskType_SubInterval_CollectionType > Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMediaSpaceMaskType> Mp7JrsMediaSpaceMaskPtr;

/** 
 * Generated interface IMp7JrsMediaSpaceMaskType for class Mp7JrsMediaSpaceMaskType<br>
 * Located at: mds-2001.xsd, line 3014<br>
 * Classified: Class<br>
 * Derived from: MaskType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaSpaceMaskType 
 :
        public IMp7JrsMaskType
{
public:
    // TODO: make these protected?
    IMp7JrsMediaSpaceMaskType();
    virtual ~IMp7JrsMediaSpaceMaskType();
        /** @name Sequence

         */
        //@{
    /**
     * Get SubInterval element.
     * @return Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr
     */
    virtual Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr GetSubInterval() const = 0;

    /**
     * Set SubInterval element.
     * @param item const Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr &
     */
    virtual void SetSubInterval(const Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaSpaceMaskType<br>
 * Located at: mds-2001.xsd, line 3014<br>
 * Classified: Class<br>
 * Derived from: MaskType (Class)<br>
 * Defined in mds-2001.xsd, line 3014.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaSpaceMaskType :
        public IMp7JrsMediaSpaceMaskType
{
    friend class Mp7JrsMediaSpaceMaskTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMediaSpaceMaskType
     
     * @return Mp7JrsPtr< Mp7JrsMaskType >
     */
    virtual Mp7JrsPtr< Mp7JrsMaskType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get SubInterval element.
     * @return Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr
     */
    virtual Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr GetSubInterval() const;

    /*
     * Set SubInterval element.
     * @param item const Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr &
     */
    virtual void SetSubInterval(const Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaSpaceMaskType();

protected:
    Mp7JrsMediaSpaceMaskType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsMaskType > m_Base;

    Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr m_SubInterval;

// no includefile for extension defined 
// file Mp7JrsMediaSpaceMaskType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1233MP7JRSMEDIASPACEMASKTYPE_H

