/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1245MP7JRSMEDIATRANSCODINGHINTSTYPE_H
#define _1245MP7JRSMEDIATRANSCODINGHINTSTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaTranscodingHintsTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDType;
class IMp7JrsMediaTranscodingHintsType;
class IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType;
class IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType;
class IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType > Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType > Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType > Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType> Mp7JrsMediaTranscodingHintsPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsMediaTranscodingHintsType for class Mp7JrsMediaTranscodingHintsType<br>
 * Located at: mds-2001.xsd, line 2356<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaTranscodingHintsType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsMediaTranscodingHintsType();
    virtual ~IMp7JrsMediaTranscodingHintsType();
    /**
     * Get difficulty attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getdifficulty() const = 0;

    /**
     * Get difficulty attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdifficulty() const = 0;

    /**
     * Set difficulty attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setdifficulty(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate difficulty attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedifficulty() = 0;

    /**
     * Get importance attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getimportance() const = 0;

    /**
     * Get importance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existimportance() const = 0;

    /**
     * Set importance attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setimportance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate importance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateimportance() = 0;

    /**
     * Get spatialResolutionHint attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr GetspatialResolutionHint() const = 0;

    /**
     * Get spatialResolutionHint attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistspatialResolutionHint() const = 0;

    /**
     * Set spatialResolutionHint attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void SetspatialResolutionHint(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate spatialResolutionHint attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatespatialResolutionHint() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get MotionHint element.
     * @return Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr GetMotionHint() const = 0;

    virtual bool IsValidMotionHint() const = 0;

    /**
     * Set MotionHint element.
     * @param item const Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr &
     */
    virtual void SetMotionHint(const Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MotionHint element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMotionHint() = 0;

    /**
     * Get ShapeHint element.
     * @return Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr GetShapeHint() const = 0;

    virtual bool IsValidShapeHint() const = 0;

    /**
     * Set ShapeHint element.
     * @param item const Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr &
     */
    virtual void SetShapeHint(const Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ShapeHint element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateShapeHint() = 0;

    /**
     * Get CodingHints element.
     * @return Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr GetCodingHints() const = 0;

    virtual bool IsValidCodingHints() const = 0;

    /**
     * Set CodingHints element.
     * @param item const Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr &
     */
    virtual void SetCodingHints(const Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate CodingHints element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCodingHints() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaTranscodingHintsType<br>
 * Located at: mds-2001.xsd, line 2356<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 2356.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaTranscodingHintsType :
        public IMp7JrsMediaTranscodingHintsType
{
    friend class Mp7JrsMediaTranscodingHintsTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMediaTranscodingHintsType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
    /*
     * Get difficulty attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getdifficulty() const;

    /*
     * Get difficulty attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdifficulty() const;

    /*
     * Set difficulty attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setdifficulty(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate difficulty attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedifficulty();

    /*
     * Get importance attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getimportance() const;

    /*
     * Get importance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existimportance() const;

    /*
     * Set importance attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setimportance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate importance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateimportance();

    /*
     * Get spatialResolutionHint attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr GetspatialResolutionHint() const;

    /*
     * Get spatialResolutionHint attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistspatialResolutionHint() const;

    /*
     * Set spatialResolutionHint attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void SetspatialResolutionHint(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate spatialResolutionHint attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatespatialResolutionHint();

        /* @name Sequence

         */
        //@{
    /*
     * Get MotionHint element.
     * @return Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr GetMotionHint() const;

    virtual bool IsValidMotionHint() const;

    /*
     * Set MotionHint element.
     * @param item const Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr &
     */
    virtual void SetMotionHint(const Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MotionHint element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMotionHint();

    /*
     * Get ShapeHint element.
     * @return Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr GetShapeHint() const;

    virtual bool IsValidShapeHint() const;

    /*
     * Set ShapeHint element.
     * @param item const Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr &
     */
    virtual void SetShapeHint(const Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ShapeHint element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateShapeHint();

    /*
     * Get CodingHints element.
     * @return Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr GetCodingHints() const;

    virtual bool IsValidCodingHints() const;

    /*
     * Set CodingHints element.
     * @param item const Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr &
     */
    virtual void SetCodingHints(const Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate CodingHints element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCodingHints();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaTranscodingHintsType();

protected:
    Mp7JrsMediaTranscodingHintsType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrszeroToOnePtr m_difficulty;
    bool m_difficulty_Exist;
    Mp7JrszeroToOnePtr m_importance;
    bool m_importance_Exist;
    Mp7JrszeroToOnePtr m_spatialResolutionHint;
    bool m_spatialResolutionHint_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr m_MotionHint;
    bool m_MotionHint_Exist; // For optional elements 
    Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr m_ShapeHint;
    bool m_ShapeHint_Exist; // For optional elements 
    Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr m_CodingHints;
    bool m_CodingHints_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1245MP7JRSMEDIATRANSCODINGHINTSTYPE_H

