/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1249MP7JRSMEDIATRANSCODINGHINTSTYPE_MOTIONHINT_LOCALTYPE_H
#define _1249MP7JRSMEDIATRANSCODINGHINTSTYPE_MOTIONHINT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaTranscodingHintsType_MotionHint_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType_ExtInclude.h


class IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType;
class IMp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType> Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType > Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType for class Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType<br>
 * Located at: mds-2001.xsd, line 2361<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType();
    virtual ~IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType();
    /**
     * Get uncompensability attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getuncompensability() const = 0;

    /**
     * Get uncompensability attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existuncompensability() const = 0;

    /**
     * Set uncompensability attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setuncompensability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate uncompensability attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateuncompensability() = 0;

    /**
     * Get intensity attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getintensity() const = 0;

    /**
     * Get intensity attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existintensity() const = 0;

    /**
     * Set intensity attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setintensity(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate intensity attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateintensity() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get MotionRange element.
     * @return Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr GetMotionRange() const = 0;

    virtual bool IsValidMotionRange() const = 0;

    /**
     * Set MotionRange element.
     * @param item const Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr &
     */
    virtual void SetMotionRange(const Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MotionRange element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMotionRange() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType<br>
 * Located at: mds-2001.xsd, line 2361<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2361.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType :
        public IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType
{
    friend class Mp7JrsMediaTranscodingHintsType_MotionHint_LocalTypeFactory; // constructs objects

public:
    /*
     * Get uncompensability attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getuncompensability() const;

    /*
     * Get uncompensability attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existuncompensability() const;

    /*
     * Set uncompensability attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setuncompensability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate uncompensability attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateuncompensability();

    /*
     * Get intensity attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getintensity() const;

    /*
     * Get intensity attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existintensity() const;

    /*
     * Set intensity attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setintensity(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate intensity attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateintensity();

        /* @name Sequence

         */
        //@{
    /*
     * Get MotionRange element.
     * @return Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr
     */
    virtual Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr GetMotionRange() const;

    virtual bool IsValidMotionRange() const;

    /*
     * Set MotionRange element.
     * @param item const Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr &
     */
    virtual void SetMotionRange(const Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MotionRange element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMotionRange();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType();

protected:
    Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrszeroToOnePtr m_uncompensability;
    bool m_uncompensability_Exist;
    Mp7JrszeroToOnePtr m_intensity;
    bool m_intensity_Exist;


    Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr m_MotionRange;
    bool m_MotionRange_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1249MP7JRSMEDIATRANSCODINGHINTSTYPE_MOTIONHINT_LOCALTYPE_H

