/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1265MP7JRSMELODYSEQUENCETYPE_NOTEARRAY_NOTE_LOCALTYPE_H
#define _1265MP7JRSMELODYSEQUENCETYPE_NOTEARRAY_NOTE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMelodySequenceType_NoteArray_Note_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtInclude.h


class IMp7JrsMelodySequenceType_NoteArray_Note_LocalType;
class IMp7JrsTextualType;
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_NoteArray_Note_LocalType> Mp7JrsMelodySequenceType_NoteArray_Note_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;

/** 
 * Generated interface IMp7JrsMelodySequenceType_NoteArray_Note_LocalType for class Mp7JrsMelodySequenceType_NoteArray_Note_LocalType<br>
 * Located at: audio-2001.xsd, line 885<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMelodySequenceType_NoteArray_Note_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMelodySequenceType_NoteArray_Note_LocalType();
    virtual ~IMp7JrsMelodySequenceType_NoteArray_Note_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Interval element.
     * @return float
     */
    virtual float GetInterval() const = 0;

    /**
     * Set Interval element.
     * @param item float
     */
    virtual void SetInterval(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get NoteRelDuration element.
     * @return float
     */
    virtual float GetNoteRelDuration() const = 0;

    /**
     * Set NoteRelDuration element.
     * @param item float
     */
    virtual void SetNoteRelDuration(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Lyric element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetLyric() const = 0;

    virtual bool IsValidLyric() const = 0;

    /**
     * Set Lyric element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetLyric(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Lyric element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLyric() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMelodySequenceType_NoteArray_Note_LocalType<br>
 * Located at: audio-2001.xsd, line 885<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 885.<br>
 */
class MP7JRS_EXPORT Mp7JrsMelodySequenceType_NoteArray_Note_LocalType :
        public IMp7JrsMelodySequenceType_NoteArray_Note_LocalType
{
    friend class Mp7JrsMelodySequenceType_NoteArray_Note_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Interval element.
     * @return float
     */
    virtual float GetInterval() const;

    /*
     * Set Interval element.
     * @param item float
     */
    virtual void SetInterval(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get NoteRelDuration element.
     * @return float
     */
    virtual float GetNoteRelDuration() const;

    /*
     * Set NoteRelDuration element.
     * @param item float
     */
    virtual void SetNoteRelDuration(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Lyric element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetLyric() const;

    virtual bool IsValidLyric() const;

    /*
     * Set Lyric element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetLyric(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Lyric element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLyric();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMelodySequenceType_NoteArray_Note_LocalType();

protected:
    Mp7JrsMelodySequenceType_NoteArray_Note_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    float m_Interval;
    float m_NoteRelDuration;
    Mp7JrsTextualPtr m_Lyric;
    bool m_Lyric_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_NoteArray_Note_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1265MP7JRSMELODYSEQUENCETYPE_NOTEARRAY_NOTE_LOCALTYPE_H

