/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1267MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_LOCALTYPE_H
#define _1267MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMelodySequenceType_StartingNote_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtInclude.h


class IMp7JrsMelodySequenceType_StartingNote_LocalType;
class IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType;
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_LocalType> Mp7JrsMelodySequenceType_StartingNote_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType > Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr;

/** 
 * Generated interface IMp7JrsMelodySequenceType_StartingNote_LocalType for class Mp7JrsMelodySequenceType_StartingNote_LocalType<br>
 * Located at: audio-2001.xsd, line 856<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMelodySequenceType_StartingNote_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMelodySequenceType_StartingNote_LocalType();
    virtual ~IMp7JrsMelodySequenceType_StartingNote_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get StartingFrequency element.
     * @return float
     */
    virtual float GetStartingFrequency() const = 0;

    virtual bool IsValidStartingFrequency() const = 0;

    /**
     * Set StartingFrequency element.
     * @param item float
     */
    virtual void SetStartingFrequency(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate StartingFrequency element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStartingFrequency() = 0;

    /**
     * Get StartingPitch element.
     * @return Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr
     */
    virtual Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr GetStartingPitch() const = 0;

    virtual bool IsValidStartingPitch() const = 0;

    /**
     * Set StartingPitch element.
     * @param item const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr &
     */
    virtual void SetStartingPitch(const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate StartingPitch element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStartingPitch() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMelodySequenceType_StartingNote_LocalType<br>
 * Located at: audio-2001.xsd, line 856<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 856.<br>
 */
class MP7JRS_EXPORT Mp7JrsMelodySequenceType_StartingNote_LocalType :
        public IMp7JrsMelodySequenceType_StartingNote_LocalType
{
    friend class Mp7JrsMelodySequenceType_StartingNote_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get StartingFrequency element.
     * @return float
     */
    virtual float GetStartingFrequency() const;

    virtual bool IsValidStartingFrequency() const;

    /*
     * Set StartingFrequency element.
     * @param item float
     */
    virtual void SetStartingFrequency(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate StartingFrequency element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStartingFrequency();

    /*
     * Get StartingPitch element.
     * @return Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr
     */
    virtual Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr GetStartingPitch() const;

    virtual bool IsValidStartingPitch() const;

    /*
     * Set StartingPitch element.
     * @param item const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr &
     */
    virtual void SetStartingPitch(const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate StartingPitch element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStartingPitch();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMelodySequenceType_StartingNote_LocalType();

protected:
    Mp7JrsMelodySequenceType_StartingNote_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    float m_StartingFrequency;
    bool m_StartingFrequency_Exist; // For optional elements 
    Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr m_StartingPitch;
    bool m_StartingPitch_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1267MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_LOCALTYPE_H

