/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1269MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_STARTINGPITCH_LOCALTYPE_H
#define _1269MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_STARTINGPITCH_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType_ExtInclude.h


#include "Mp7JrsdegreeAccidentalType.h"
class IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType;
class IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType;
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType> Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType > Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr;

/** 
 * Generated interface IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType for class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType<br>
 * Located at: audio-2001.xsd, line 860<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType();
    virtual ~IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType();
    /**
     * Get accidental attribute.
     * @return Mp7JrsdegreeAccidentalType::Enumeration
     */
    virtual Mp7JrsdegreeAccidentalType::Enumeration Getaccidental() const = 0;

    /**
     * Get accidental attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existaccidental() const = 0;

    /**
     * Set accidental attribute.
     * @param item Mp7JrsdegreeAccidentalType::Enumeration
     */
    virtual void Setaccidental(Mp7JrsdegreeAccidentalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate accidental attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateaccidental() = 0;

    /**
     * Get height attribute.
     * @return int
     */
    virtual int Getheight() const = 0;

    /**
     * Get height attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existheight() const = 0;

    /**
     * Set height attribute.
     * @param item int
     */
    virtual void Setheight(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate height attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateheight() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get PitchNote element.
     * @return Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr
     */
    virtual Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr GetPitchNote() const = 0;

    /**
     * Set PitchNote element.
     * @param item const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr &
     */
    virtual void SetPitchNote(const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType<br>
 * Located at: audio-2001.xsd, line 860<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 860.<br>
 */
class MP7JRS_EXPORT Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType :
        public IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType
{
    friend class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalTypeFactory; // constructs objects

public:
    /*
     * Get accidental attribute.
     * @return Mp7JrsdegreeAccidentalType::Enumeration
     */
    virtual Mp7JrsdegreeAccidentalType::Enumeration Getaccidental() const;

    /*
     * Get accidental attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existaccidental() const;

    /*
     * Set accidental attribute.
     * @param item Mp7JrsdegreeAccidentalType::Enumeration
     */
    virtual void Setaccidental(Mp7JrsdegreeAccidentalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate accidental attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateaccidental();

    /*
     * Get height attribute.
     * @return int
     */
    virtual int Getheight() const;

    /*
     * Get height attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existheight() const;

    /*
     * Set height attribute.
     * @param item int
     */
    virtual void Setheight(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate height attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateheight();

        /* @name Sequence

         */
        //@{
    /*
     * Get PitchNote element.
     * @return Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr
     */
    virtual Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr GetPitchNote() const;

    /*
     * Set PitchNote element.
     * @param item const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr &
     */
    virtual void SetPitchNote(const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType();

protected:
    Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsdegreeAccidentalType::Enumeration m_accidental;
    bool m_accidental_Exist;
    Mp7JrsdegreeAccidentalType::Enumeration m_accidental_Default;
    int m_height;
    bool m_height_Exist;


    Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr m_PitchNote;

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1269MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_STARTINGPITCH_LOCALTYPE_H

