/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1273MP7JRSMELODYTYPE_H
#define _1273MP7JRSMELODYTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMelodyTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMelodyType_ExtInclude.h


#include "Mp7JrsAudioDSType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsKeyType;
class IMp7JrsmediaDurationType;
class IMp7JrsMelodyContourType;
class IMp7JrsMelodyType;
class IMp7JrsMelodyType_MelodySequence_CollectionType;
class IMp7JrsMeterType;
class IMp7JrsscaleType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAudioDSType > Mp7JrsAudioDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsKeyType > Mp7JrsKeyPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsMelodyContourType > Mp7JrsMelodyContourPtr;
typedef Mp7JrsPtr< IMp7JrsMelodyType_MelodySequence_CollectionType > Mp7JrsMelodyType_MelodySequence_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMelodyType> Mp7JrsMelodyPtr;
typedef Mp7JrsPtr< IMp7JrsMeterType > Mp7JrsMeterPtr;
typedef Mp7JrsPtr< IMp7JrsscaleType > Mp7JrsscalePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsMelodyType for class Mp7JrsMelodyType<br>
 * Located at: audio-2001.xsd, line 717<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMelodyType 
 :
        public IMp7JrsAudioDSType
{
public:
    // TODO: make these protected?
    IMp7JrsMelodyType();
    virtual ~IMp7JrsMelodyType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Meter element.
     * @return Mp7JrsMeterPtr
     */
    virtual Mp7JrsMeterPtr GetMeter() const = 0;

    virtual bool IsValidMeter() const = 0;

    /**
     * Set Meter element.
     * @param item const Mp7JrsMeterPtr &
     */
    virtual void SetMeter(const Mp7JrsMeterPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Meter element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMeter() = 0;

    /**
     * Get Scale element.
     * @return Mp7JrsscalePtr
     */
    virtual Mp7JrsscalePtr GetScale() const = 0;

    virtual bool IsValidScale() const = 0;

    /**
     * Set Scale element.
     * @param item const Mp7JrsscalePtr &
     */
    virtual void SetScale(const Mp7JrsscalePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Scale element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateScale() = 0;

    /**
     * Get Key element.
     * @return Mp7JrsKeyPtr
     */
    virtual Mp7JrsKeyPtr GetKey() const = 0;

    virtual bool IsValidKey() const = 0;

    /**
     * Set Key element.
     * @param item const Mp7JrsKeyPtr &
     */
    virtual void SetKey(const Mp7JrsKeyPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Key element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateKey() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get MelodyContour element.
     * @return Mp7JrsMelodyContourPtr
     */
    virtual Mp7JrsMelodyContourPtr GetMelodyContour() const = 0;

    /**
     * Set MelodyContour element.
     * @param item const Mp7JrsMelodyContourPtr &
     */
    virtual void SetMelodyContour(const Mp7JrsMelodyContourPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MelodySequence element.
     * @return Mp7JrsMelodyType_MelodySequence_CollectionPtr
     */
    virtual Mp7JrsMelodyType_MelodySequence_CollectionPtr GetMelodySequence() const = 0;

    /**
     * Set MelodySequence element.
     * @param item const Mp7JrsMelodyType_MelodySequence_CollectionPtr &
     */
    virtual void SetMelodySequence(const Mp7JrsMelodyType_MelodySequence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMelodyType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMelodyType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMelodyType<br>
 * Located at: audio-2001.xsd, line 717<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 * Defined in audio-2001.xsd, line 717.<br>
 */
class MP7JRS_EXPORT Mp7JrsMelodyType :
        public IMp7JrsMelodyType
{
    friend class Mp7JrsMelodyTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMelodyType
     
     * @return Mp7JrsPtr< Mp7JrsAudioDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioDSType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Meter element.
     * @return Mp7JrsMeterPtr
     */
    virtual Mp7JrsMeterPtr GetMeter() const;

    virtual bool IsValidMeter() const;

    /*
     * Set Meter element.
     * @param item const Mp7JrsMeterPtr &
     */
    virtual void SetMeter(const Mp7JrsMeterPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Meter element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMeter();

    /*
     * Get Scale element.
     * @return Mp7JrsscalePtr
     */
    virtual Mp7JrsscalePtr GetScale() const;

    virtual bool IsValidScale() const;

    /*
     * Set Scale element.
     * @param item const Mp7JrsscalePtr &
     */
    virtual void SetScale(const Mp7JrsscalePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Scale element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateScale();

    /*
     * Get Key element.
     * @return Mp7JrsKeyPtr
     */
    virtual Mp7JrsKeyPtr GetKey() const;

    virtual bool IsValidKey() const;

    /*
     * Set Key element.
     * @param item const Mp7JrsKeyPtr &
     */
    virtual void SetKey(const Mp7JrsKeyPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Key element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateKey();

        /* @name Choice

         */
        //@{
    /*
     * Get MelodyContour element.
     * @return Mp7JrsMelodyContourPtr
     */
    virtual Mp7JrsMelodyContourPtr GetMelodyContour() const;

    /*
     * Set MelodyContour element.
     * @param item const Mp7JrsMelodyContourPtr &
     */
    virtual void SetMelodyContour(const Mp7JrsMelodyContourPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MelodySequence element.
     * @return Mp7JrsMelodyType_MelodySequence_CollectionPtr
     */
    virtual Mp7JrsMelodyType_MelodySequence_CollectionPtr GetMelodySequence() const;

    /*
     * Set MelodySequence element.
     * @param item const Mp7JrsMelodyType_MelodySequence_CollectionPtr &
     */
    virtual void SetMelodySequence(const Mp7JrsMelodyType_MelodySequence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMelodyType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMelodyType();

protected:
    Mp7JrsMelodyType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioDSType > m_Base;

    Mp7JrsMeterPtr m_Meter;
    bool m_Meter_Exist; // For optional elements 
    Mp7JrsscalePtr m_Scale;
    bool m_Scale_Exist; // For optional elements 
    Mp7JrsKeyPtr m_Key;
    bool m_Key_Exist; // For optional elements 
// DefinionChoice
    Mp7JrsMelodyContourPtr m_MelodyContour;
    Mp7JrsMelodyType_MelodySequence_CollectionPtr m_MelodySequence;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsMelodyType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1273MP7JRSMELODYTYPE_H

