/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1311MP7JRSMIXEDCOLLECTIONTYPE_LOCALTYPE2_H
#define _1311MP7JRSMIXEDCOLLECTIONTYPE_LOCALTYPE2_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMixedCollectionType_LocalType2Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtInclude.h


class IMp7JrsMixedCollectionType;
class IMp7JrsMixedCollectionType_LocalType2;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType > Mp7JrsMixedCollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_LocalType2> Mp7JrsMixedCollectionType_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsMixedCollectionType_LocalType2 for class Mp7JrsMixedCollectionType_LocalType2<br>
 */
class MP7JRS_EXPORT IMp7JrsMixedCollectionType_LocalType2 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMixedCollectionType_LocalType2();
    virtual ~IMp7JrsMixedCollectionType_LocalType2();
        /** @name Choice

         */
        //@{
    /**
     * Get MixedCollection element.
     * @return Mp7JrsMixedCollectionPtr
     */
    virtual Mp7JrsMixedCollectionPtr GetMixedCollection() const = 0;

    /**
     * Set MixedCollection element.
     * @param item const Mp7JrsMixedCollectionPtr &
     */
    virtual void SetMixedCollection(const Mp7JrsMixedCollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MixedCollectionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMixedCollectionRef() const = 0;

    /**
     * Set MixedCollectionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMixedCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMixedCollectionType_LocalType2<br>
 * Defined in mds-2001.xsd, line 5335.<br>
 */
class MP7JRS_EXPORT Mp7JrsMixedCollectionType_LocalType2 :
        public IMp7JrsMixedCollectionType_LocalType2
{
    friend class Mp7JrsMixedCollectionType_LocalType2Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get MixedCollection element.
     * @return Mp7JrsMixedCollectionPtr
     */
    virtual Mp7JrsMixedCollectionPtr GetMixedCollection() const;

    /*
     * Set MixedCollection element.
     * @param item const Mp7JrsMixedCollectionPtr &
     */
    virtual void SetMixedCollection(const Mp7JrsMixedCollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MixedCollectionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMixedCollectionRef() const;

    /*
     * Set MixedCollectionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMixedCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMixedCollectionType_LocalType2();

protected:
    Mp7JrsMixedCollectionType_LocalType2();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsMixedCollectionPtr m_MixedCollection;
    Mp7JrsReferencePtr m_MixedCollectionRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1311MP7JRSMIXEDCOLLECTIONTYPE_LOCALTYPE2_H

