/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1315MP7JRSMIXTURECAMERAMOTIONSEGMENTTYPE_H
#define _1315MP7JRSMIXTURECAMERAMOTIONSEGMENTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMixtureCameraMotionSegmentTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtInclude.h


#include "Mp7JrsCameraMotionSegmentType.h"
class IMp7JrsCameraMotionSegmentType;
class IMp7JrsFocusOfExpansionType;
class IMp7JrsFractionalPresenceType;
class IMp7JrsMediaTimeType;
class IMp7JrsMixtureAmountOfMotionType;
class IMp7JrsMixtureCameraMotionSegmentType;
typedef Mp7JrsPtr< IMp7JrsCameraMotionSegmentType > Mp7JrsCameraMotionSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsFocusOfExpansionType > Mp7JrsFocusOfExpansionPtr;
typedef Mp7JrsPtr< IMp7JrsFractionalPresenceType > Mp7JrsFractionalPresencePtr;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsMixtureAmountOfMotionType > Mp7JrsMixtureAmountOfMotionPtr;
typedef Mp7JrsPtr< IMp7JrsMixtureCameraMotionSegmentType> Mp7JrsMixtureCameraMotionSegmentPtr;

/** 
 * Generated interface IMp7JrsMixtureCameraMotionSegmentType for class Mp7JrsMixtureCameraMotionSegmentType<br>
 * Located at: visual-2001.xsd, line 847<br>
 * Classified: Class<br>
 * Derived from: CameraMotionSegmentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMixtureCameraMotionSegmentType 
 :
        public IMp7JrsCameraMotionSegmentType
{
public:
    // TODO: make these protected?
    IMp7JrsMixtureCameraMotionSegmentType();
    virtual ~IMp7JrsMixtureCameraMotionSegmentType();
        /** @name Sequence

         */
        //@{
    /**
     * Get FractionalPresence element.
     * @return Mp7JrsFractionalPresencePtr
     */
    virtual Mp7JrsFractionalPresencePtr GetFractionalPresence() const = 0;

    /**
     * Set FractionalPresence element.
     * @param item const Mp7JrsFractionalPresencePtr &
     */
    virtual void SetFractionalPresence(const Mp7JrsFractionalPresencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AmountOfMotion element.
     * @return Mp7JrsMixtureAmountOfMotionPtr
     */
    virtual Mp7JrsMixtureAmountOfMotionPtr GetAmountOfMotion() const = 0;

    /**
     * Set AmountOfMotion element.
     * @param item const Mp7JrsMixtureAmountOfMotionPtr &
     */
    virtual void SetAmountOfMotion(const Mp7JrsMixtureAmountOfMotionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get MediaTime element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const = 0;

    /**
     * Set MediaTime element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get FocusOfExpansion element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @return Mp7JrsFocusOfExpansionPtr
     */
    virtual Mp7JrsFocusOfExpansionPtr GetFocusOfExpansion() const = 0;

    virtual bool IsValidFocusOfExpansion() const = 0;

    /**
     * Set FocusOfExpansion element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @param item const Mp7JrsFocusOfExpansionPtr &
     */
    virtual void SetFocusOfExpansion(const Mp7JrsFocusOfExpansionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate FocusOfExpansion element.
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFocusOfExpansion() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMixtureCameraMotionSegmentType<br>
 * Located at: visual-2001.xsd, line 847<br>
 * Classified: Class<br>
 * Derived from: CameraMotionSegmentType (Class)<br>
 * Defined in visual-2001.xsd, line 847.<br>
 */
class MP7JRS_EXPORT Mp7JrsMixtureCameraMotionSegmentType :
        public IMp7JrsMixtureCameraMotionSegmentType
{
    friend class Mp7JrsMixtureCameraMotionSegmentTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMixtureCameraMotionSegmentType
     
     * @return Mp7JrsPtr< Mp7JrsCameraMotionSegmentType >
     */
    virtual Mp7JrsPtr< Mp7JrsCameraMotionSegmentType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get FractionalPresence element.
     * @return Mp7JrsFractionalPresencePtr
     */
    virtual Mp7JrsFractionalPresencePtr GetFractionalPresence() const;

    /*
     * Set FractionalPresence element.
     * @param item const Mp7JrsFractionalPresencePtr &
     */
    virtual void SetFractionalPresence(const Mp7JrsFractionalPresencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AmountOfMotion element.
     * @return Mp7JrsMixtureAmountOfMotionPtr
     */
    virtual Mp7JrsMixtureAmountOfMotionPtr GetAmountOfMotion() const;

    /*
     * Set AmountOfMotion element.
     * @param item const Mp7JrsMixtureAmountOfMotionPtr &
     */
    virtual void SetAmountOfMotion(const Mp7JrsMixtureAmountOfMotionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get MediaTime element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const;

    /*
     * Set MediaTime element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get FocusOfExpansion element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @return Mp7JrsFocusOfExpansionPtr
     */
    virtual Mp7JrsFocusOfExpansionPtr GetFocusOfExpansion() const;

    virtual bool IsValidFocusOfExpansion() const;

    /*
     * Set FocusOfExpansion element.
<br>
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     * @param item const Mp7JrsFocusOfExpansionPtr &
     */
    virtual void SetFocusOfExpansion(const Mp7JrsFocusOfExpansionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate FocusOfExpansion element.
     * (Inherited from Mp7JrsCameraMotionSegmentType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFocusOfExpansion();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMixtureCameraMotionSegmentType();

protected:
    Mp7JrsMixtureCameraMotionSegmentType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsCameraMotionSegmentType > m_Base;

    Mp7JrsFractionalPresencePtr m_FractionalPresence;
    Mp7JrsMixtureAmountOfMotionPtr m_AmountOfMotion;

// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1315MP7JRSMIXTURECAMERAMOTIONSEGMENTTYPE_H

