/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1333MP7JRSMOSAICTYPE_WARPINGPARAM_LOCALTYPE0_H
#define _1333MP7JRSMOSAICTYPE_WARPINGPARAM_LOCALTYPE0_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtInclude.h


class IMp7JrsMosaicType_WarpingParam_CollectionType;
class IMp7JrsMosaicType_WarpingParam_LocalType0;
class IMp7JrsMosaicType_WarpingParam_modelType_LocalType2;
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_CollectionType > Mp7JrsMosaicType_WarpingParam_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_LocalType0> Mp7JrsMosaicType_WarpingParam_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_modelType_LocalType2 > Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr;

/** 
 * Generated interface IMp7JrsMosaicType_WarpingParam_LocalType0 for class Mp7JrsMosaicType_WarpingParam_LocalType0<br>
 * Located at: mds-2001.xsd, line 3196<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMosaicType_WarpingParam_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMosaicType_WarpingParam_LocalType0();
    virtual ~IMp7JrsMosaicType_WarpingParam_LocalType0();
    /**
     * Get modelType attribute.
     * @return Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr
     */
    virtual Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr GetmodelType() const = 0;

    /**
     * Set modelType attribute.
     * @param item const Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr &
     */
    virtual void SetmodelType(const Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get sourceSequenceWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetsourceSequenceWidth() const = 0;

    /**
     * Set sourceSequenceWidth attribute.
     * @param item unsigned
     */
    virtual void SetsourceSequenceWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get sourceSequenceHeight attribute.
     * @return unsigned
     */
    virtual unsigned GetsourceSequenceHeight() const = 0;

    /**
     * Set sourceSequenceHeight attribute.
     * @param item unsigned
     */
    virtual void SetsourceSequenceHeight(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get xOffset attribute.
     * @return float
     */
    virtual float GetxOffset() const = 0;

    /**
     * Set xOffset attribute.
     * @param item float
     */
    virtual void SetxOffset(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get yOffset attribute.
     * @return float
     */
    virtual float GetyOffset() const = 0;

    /**
     * Set yOffset attribute.
     * @param item float
     */
    virtual void SetyOffset(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get xOrigin attribute.
     * @return float
     */
    virtual float GetxOrigin() const = 0;

    /**
     * Set xOrigin attribute.
     * @param item float
     */
    virtual void SetxOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get yOrigin attribute.
     * @return float
     */
    virtual float GetyOrigin() const = 0;

    /**
     * Set yOrigin attribute.
     * @param item float
     */
    virtual void SetyOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get MosaicType_WarpingParam_LocalType element.
     * @return Mp7JrsMosaicType_WarpingParam_CollectionPtr
     */
    virtual Mp7JrsMosaicType_WarpingParam_CollectionPtr GetMosaicType_WarpingParam_LocalType() const = 0;

    /**
     * Set MosaicType_WarpingParam_LocalType element.
     * @param item const Mp7JrsMosaicType_WarpingParam_CollectionPtr &
     */
    virtual void SetMosaicType_WarpingParam_LocalType(const Mp7JrsMosaicType_WarpingParam_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMosaicType_WarpingParam_LocalType0<br>
 * Located at: mds-2001.xsd, line 3196<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3196.<br>
 */
class MP7JRS_EXPORT Mp7JrsMosaicType_WarpingParam_LocalType0 :
        public IMp7JrsMosaicType_WarpingParam_LocalType0
{
    friend class Mp7JrsMosaicType_WarpingParam_LocalType0Factory; // constructs objects

public:
    /*
     * Get modelType attribute.
     * @return Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr
     */
    virtual Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr GetmodelType() const;

    /*
     * Set modelType attribute.
     * @param item const Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr &
     */
    virtual void SetmodelType(const Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get sourceSequenceWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetsourceSequenceWidth() const;

    /*
     * Set sourceSequenceWidth attribute.
     * @param item unsigned
     */
    virtual void SetsourceSequenceWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get sourceSequenceHeight attribute.
     * @return unsigned
     */
    virtual unsigned GetsourceSequenceHeight() const;

    /*
     * Set sourceSequenceHeight attribute.
     * @param item unsigned
     */
    virtual void SetsourceSequenceHeight(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get xOffset attribute.
     * @return float
     */
    virtual float GetxOffset() const;

    /*
     * Set xOffset attribute.
     * @param item float
     */
    virtual void SetxOffset(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get yOffset attribute.
     * @return float
     */
    virtual float GetyOffset() const;

    /*
     * Set yOffset attribute.
     * @param item float
     */
    virtual void SetyOffset(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get xOrigin attribute.
     * @return float
     */
    virtual float GetxOrigin() const;

    /*
     * Set xOrigin attribute.
     * @param item float
     */
    virtual void SetxOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get yOrigin attribute.
     * @return float
     */
    virtual float GetyOrigin() const;

    /*
     * Set yOrigin attribute.
     * @param item float
     */
    virtual void SetyOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get MosaicType_WarpingParam_LocalType element.
     * @return Mp7JrsMosaicType_WarpingParam_CollectionPtr
     */
    virtual Mp7JrsMosaicType_WarpingParam_CollectionPtr GetMosaicType_WarpingParam_LocalType() const;

    /*
     * Set MosaicType_WarpingParam_LocalType element.
     * @param item const Mp7JrsMosaicType_WarpingParam_CollectionPtr &
     */
    virtual void SetMosaicType_WarpingParam_LocalType(const Mp7JrsMosaicType_WarpingParam_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMosaicType_WarpingParam_LocalType0();

protected:
    Mp7JrsMosaicType_WarpingParam_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr m_modelType;
    unsigned m_sourceSequenceWidth;
    unsigned m_sourceSequenceHeight;
    float m_xOffset;
    float m_yOffset;
    float m_xOrigin;
    float m_yOrigin;


    Mp7JrsMosaicType_WarpingParam_CollectionPtr m_MosaicType_WarpingParam_LocalType;

// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1333MP7JRSMOSAICTYPE_WARPINGPARAM_LOCALTYPE0_H

