/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1343MP7JRSMOTIONACTIVITYTYPE_H
#define _1343MP7JRSMOTIONACTIVITYTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMotionActivityTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsMotionActivityType;
class IMp7JrsMotionActivityType_Intensity_LocalType;
class IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType;
class IMp7JrsMotionActivityType_TemporalParams_LocalType;
class IMp7Jrsunsigned3;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_Intensity_LocalType > Mp7JrsMotionActivityType_Intensity_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType > Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_TemporalParams_LocalType > Mp7JrsMotionActivityType_TemporalParams_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType> Mp7JrsMotionActivityPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned3 > Mp7Jrsunsigned3Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsMotionActivityType for class Mp7JrsMotionActivityType<br>
 * Located at: visual-2001.xsd, line 1040<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsMotionActivityType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsMotionActivityType();
    virtual ~IMp7JrsMotionActivityType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Intensity element.
     * @return Mp7JrsMotionActivityType_Intensity_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_Intensity_LocalPtr GetIntensity() const = 0;

    /**
     * Set Intensity element.
     * @param item const Mp7JrsMotionActivityType_Intensity_LocalPtr &
     */
    virtual void SetIntensity(const Mp7JrsMotionActivityType_Intensity_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DominantDirection element.
     * @return Mp7Jrsunsigned3Ptr
     */
    virtual Mp7Jrsunsigned3Ptr GetDominantDirection() const = 0;

    virtual bool IsValidDominantDirection() const = 0;

    /**
     * Set DominantDirection element.
     * @param item const Mp7Jrsunsigned3Ptr &
     */
    virtual void SetDominantDirection(const Mp7Jrsunsigned3Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DominantDirection element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDominantDirection() = 0;

    /**
     * Get SpatialDistributionParams element.
     * @return Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr GetSpatialDistributionParams() const = 0;

    virtual bool IsValidSpatialDistributionParams() const = 0;

    /**
     * Set SpatialDistributionParams element.
     * @param item const Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr &
     */
    virtual void SetSpatialDistributionParams(const Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SpatialDistributionParams element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSpatialDistributionParams() = 0;

    /**
     * Get SpatialLocalizationParams element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr GetSpatialLocalizationParams() const = 0;

    virtual bool IsValidSpatialLocalizationParams() const = 0;

    /**
     * Set SpatialLocalizationParams element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr &
     */
    virtual void SetSpatialLocalizationParams(const Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SpatialLocalizationParams element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSpatialLocalizationParams() = 0;

    /**
     * Get TemporalParams element.
     * @return Mp7JrsMotionActivityType_TemporalParams_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_TemporalParams_LocalPtr GetTemporalParams() const = 0;

    virtual bool IsValidTemporalParams() const = 0;

    /**
     * Set TemporalParams element.
     * @param item const Mp7JrsMotionActivityType_TemporalParams_LocalPtr &
     */
    virtual void SetTemporalParams(const Mp7JrsMotionActivityType_TemporalParams_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TemporalParams element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTemporalParams() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMotionActivityType<br>
 * Located at: visual-2001.xsd, line 1040<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 1040.<br>
 */
class MP7JRS_EXPORT Mp7JrsMotionActivityType :
        public IMp7JrsMotionActivityType
{
    friend class Mp7JrsMotionActivityTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsMotionActivityType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Intensity element.
     * @return Mp7JrsMotionActivityType_Intensity_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_Intensity_LocalPtr GetIntensity() const;

    /*
     * Set Intensity element.
     * @param item const Mp7JrsMotionActivityType_Intensity_LocalPtr &
     */
    virtual void SetIntensity(const Mp7JrsMotionActivityType_Intensity_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DominantDirection element.
     * @return Mp7Jrsunsigned3Ptr
     */
    virtual Mp7Jrsunsigned3Ptr GetDominantDirection() const;

    virtual bool IsValidDominantDirection() const;

    /*
     * Set DominantDirection element.
     * @param item const Mp7Jrsunsigned3Ptr &
     */
    virtual void SetDominantDirection(const Mp7Jrsunsigned3Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DominantDirection element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDominantDirection();

    /*
     * Get SpatialDistributionParams element.
     * @return Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr GetSpatialDistributionParams() const;

    virtual bool IsValidSpatialDistributionParams() const;

    /*
     * Set SpatialDistributionParams element.
     * @param item const Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr &
     */
    virtual void SetSpatialDistributionParams(const Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SpatialDistributionParams element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSpatialDistributionParams();

    /*
     * Get SpatialLocalizationParams element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr GetSpatialLocalizationParams() const;

    virtual bool IsValidSpatialLocalizationParams() const;

    /*
     * Set SpatialLocalizationParams element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr &
     */
    virtual void SetSpatialLocalizationParams(const Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SpatialLocalizationParams element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSpatialLocalizationParams();

    /*
     * Get TemporalParams element.
     * @return Mp7JrsMotionActivityType_TemporalParams_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_TemporalParams_LocalPtr GetTemporalParams() const;

    virtual bool IsValidTemporalParams() const;

    /*
     * Set TemporalParams element.
     * @param item const Mp7JrsMotionActivityType_TemporalParams_LocalPtr &
     */
    virtual void SetTemporalParams(const Mp7JrsMotionActivityType_TemporalParams_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TemporalParams element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTemporalParams();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMotionActivityType();

protected:
    Mp7JrsMotionActivityType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsMotionActivityType_Intensity_LocalPtr m_Intensity;
    Mp7Jrsunsigned3Ptr m_DominantDirection;
    bool m_DominantDirection_Exist; // For optional elements 
    Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr m_SpatialDistributionParams;
    bool m_SpatialDistributionParams_Exist; // For optional elements 
    Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr m_SpatialLocalizationParams;
    bool m_SpatialLocalizationParams_Exist; // For optional elements 
    Mp7JrsMotionActivityType_TemporalParams_LocalPtr m_TemporalParams;
    bool m_TemporalParams_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1343MP7JRSMOTIONACTIVITYTYPE_H

