/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1349MP7JRSMOTIONACTIVITYTYPE_SPATIALLOCALIZATIONPARAMS_LOCALTYPE_H
#define _1349MP7JRSMOTIONACTIVITYTYPE_SPATIALLOCALIZATIONPARAMS_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtInclude.h


class IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType> Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr;

/** 
 * Generated interface IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType for class Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType<br>
 * Located at: visual-2001.xsd, line 1059<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType();
    virtual ~IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Vector4 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr GetVector4() const = 0;

    /**
     * Set Vector4 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr &
     */
    virtual void SetVector4(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Vector16 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr GetVector16() const = 0;

    /**
     * Set Vector16 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr &
     */
    virtual void SetVector16(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Vector64 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr GetVector64() const = 0;

    /**
     * Set Vector64 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr &
     */
    virtual void SetVector64(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Vector256 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr GetVector256() const = 0;

    /**
     * Set Vector256 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr &
     */
    virtual void SetVector256(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType<br>
 * Located at: visual-2001.xsd, line 1059<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 1059.<br>
 */
class MP7JRS_EXPORT Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType :
        public IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType
{
    friend class Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Vector4 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr GetVector4() const;

    /*
     * Set Vector4 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr &
     */
    virtual void SetVector4(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Vector16 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr GetVector16() const;

    /*
     * Set Vector16 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr &
     */
    virtual void SetVector16(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Vector64 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr GetVector64() const;

    /*
     * Set Vector64 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr &
     */
    virtual void SetVector64(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Vector256 element.
     * @return Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr
     */
    virtual Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr GetVector256() const;

    /*
     * Set Vector256 element.
     * @param item const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr &
     */
    virtual void SetVector256(const Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType();

protected:
    Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr m_Vector4;
    Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr m_Vector16;
    Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr m_Vector64;
    Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr m_Vector256;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1349MP7JRSMOTIONACTIVITYTYPE_SPATIALLOCALIZATIONPARAMS_LOCALTYPE_H

