/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1413MP7JRSMOVINGREGIONTYPE_LOCALTYPE0_H
#define _1413MP7JRSMOVINGREGIONTYPE_LOCALTYPE0_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMovingRegionType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtInclude.h


class IMp7JrsMovingRegionMediaSourceDecompositionType;
class IMp7JrsMovingRegionSpatialDecompositionType;
class IMp7JrsMovingRegionSpatioTemporalDecompositionType;
class IMp7JrsMovingRegionTemporalDecompositionType;
class IMp7JrsMovingRegionType_LocalType0;
typedef Mp7JrsPtr< IMp7JrsMovingRegionMediaSourceDecompositionType > Mp7JrsMovingRegionMediaSourceDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatialDecompositionType > Mp7JrsMovingRegionSpatialDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatioTemporalDecompositionType > Mp7JrsMovingRegionSpatioTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsMovingRegionTemporalDecompositionType > Mp7JrsMovingRegionTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsMovingRegionType_LocalType0> Mp7JrsMovingRegionType_Local0Ptr;

/** 
 * Generated interface IMp7JrsMovingRegionType_LocalType0 for class Mp7JrsMovingRegionType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsMovingRegionType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMovingRegionType_LocalType0();
    virtual ~IMp7JrsMovingRegionType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get SpatialDecomposition element.
     * @return Mp7JrsMovingRegionSpatialDecompositionPtr
     */
    virtual Mp7JrsMovingRegionSpatialDecompositionPtr GetSpatialDecomposition() const = 0;

    /**
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsMovingRegionSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsMovingRegionSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TemporalDecomposition element.
     * @return Mp7JrsMovingRegionTemporalDecompositionPtr
     */
    virtual Mp7JrsMovingRegionTemporalDecompositionPtr GetTemporalDecomposition() const = 0;

    /**
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsMovingRegionTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsMovingRegionTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsMovingRegionSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsMovingRegionSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const = 0;

    /**
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsMovingRegionSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsMovingRegionSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsMovingRegionMediaSourceDecompositionPtr
     */
    virtual Mp7JrsMovingRegionMediaSourceDecompositionPtr GetMediaSourceDecomposition() const = 0;

    /**
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsMovingRegionMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsMovingRegionMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMovingRegionType_LocalType0<br>
 * Defined in mds-2001.xsd, line 3375.<br>
 */
class MP7JRS_EXPORT Mp7JrsMovingRegionType_LocalType0 :
        public IMp7JrsMovingRegionType_LocalType0
{
    friend class Mp7JrsMovingRegionType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get SpatialDecomposition element.
     * @return Mp7JrsMovingRegionSpatialDecompositionPtr
     */
    virtual Mp7JrsMovingRegionSpatialDecompositionPtr GetSpatialDecomposition() const;

    /*
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsMovingRegionSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsMovingRegionSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TemporalDecomposition element.
     * @return Mp7JrsMovingRegionTemporalDecompositionPtr
     */
    virtual Mp7JrsMovingRegionTemporalDecompositionPtr GetTemporalDecomposition() const;

    /*
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsMovingRegionTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsMovingRegionTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsMovingRegionSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsMovingRegionSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const;

    /*
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsMovingRegionSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsMovingRegionSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsMovingRegionMediaSourceDecompositionPtr
     */
    virtual Mp7JrsMovingRegionMediaSourceDecompositionPtr GetMediaSourceDecomposition() const;

    /*
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsMovingRegionMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsMovingRegionMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMovingRegionType_LocalType0();

protected:
    Mp7JrsMovingRegionType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsMovingRegionSpatialDecompositionPtr m_SpatialDecomposition;
    Mp7JrsMovingRegionTemporalDecompositionPtr m_TemporalDecomposition;
    Mp7JrsMovingRegionSpatioTemporalDecompositionPtr m_SpatioTemporalDecomposition;
    Mp7JrsMovingRegionMediaSourceDecompositionPtr m_MediaSourceDecomposition;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1413MP7JRSMOVINGREGIONTYPE_LOCALTYPE0_H

