/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1419MP7JRSMPEG7BASETYPE_H
#define _1419MP7JRSMPEG7BASETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMpeg7BaseTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMpeg7BaseType_ExtInclude.h


class IMp7JrsMpeg7BaseType;
typedef Mp7JrsPtr< IMp7JrsMpeg7BaseType> Mp7JrsMpeg7BasePtr;

/** 
 * Generated interface IMp7JrsMpeg7BaseType for class Mp7JrsMpeg7BaseType<br>
 * Located at: mds-2001.xsd, line 52<br>
 * Classified: Class<br>
 * Abstract class <br>
 */
class MP7JRS_EXPORT IMp7JrsMpeg7BaseType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMpeg7BaseType();
    virtual ~IMp7JrsMpeg7BaseType();
// no includefile for extension defined 
// file Mp7JrsMpeg7BaseType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMpeg7BaseType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMpeg7BaseType<br>
 * Located at: mds-2001.xsd, line 52<br>
 * Classified: Class<br>
 * Abstract class <br>
 * Defined in mds-2001.xsd, line 52.<br>
 */
class MP7JRS_EXPORT Mp7JrsMpeg7BaseType :
        public IMp7JrsMpeg7BaseType
{
    friend class Mp7JrsMpeg7BaseTypeFactory; // constructs objects

public:

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMpeg7BaseType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMpeg7BaseType();

protected:
    Mp7JrsMpeg7BaseType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:



// no includefile for extension defined 
// file Mp7JrsMpeg7BaseType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1419MP7JRSMPEG7BASETYPE_H

