/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1443MP7JRSMULTIPLEVIEWTYPE_H
#define _1443MP7JRSMULTIPLEVIEWTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMultipleViewTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsMultipleViewType_ExtInclude.h


class IMp7JrsMultipleViewType;
class IMp7JrsMultipleViewType_CollectionType;
typedef Mp7JrsPtr< IMp7JrsMultipleViewType_CollectionType > Mp7JrsMultipleViewType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsMultipleViewType> Mp7JrsMultipleViewPtr;

/** 
 * Generated interface IMp7JrsMultipleViewType for class Mp7JrsMultipleViewType<br>
 * Located at: visual-2001.xsd, line 91<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMultipleViewType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMultipleViewType();
    virtual ~IMp7JrsMultipleViewType();
    /**
     * Get fixedViewsFlag attribute.
     * @return bool
     */
    virtual bool GetfixedViewsFlag() const = 0;

    /**
     * Set fixedViewsFlag attribute.
     * @param item bool
     */
    virtual void SetfixedViewsFlag(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get MultipleViewType_LocalType element.
     * @return Mp7JrsMultipleViewType_CollectionPtr
     */
    virtual Mp7JrsMultipleViewType_CollectionPtr GetMultipleViewType_LocalType() const = 0;

    /**
     * Set MultipleViewType_LocalType element.
     * @param item const Mp7JrsMultipleViewType_CollectionPtr &
     */
    virtual void SetMultipleViewType_LocalType(const Mp7JrsMultipleViewType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMultipleViewType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMultipleViewType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMultipleViewType<br>
 * Located at: visual-2001.xsd, line 91<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 91.<br>
 */
class MP7JRS_EXPORT Mp7JrsMultipleViewType :
        public IMp7JrsMultipleViewType
{
    friend class Mp7JrsMultipleViewTypeFactory; // constructs objects

public:
    /*
     * Get fixedViewsFlag attribute.
     * @return bool
     */
    virtual bool GetfixedViewsFlag() const;

    /*
     * Set fixedViewsFlag attribute.
     * @param item bool
     */
    virtual void SetfixedViewsFlag(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get MultipleViewType_LocalType element.
     * @return Mp7JrsMultipleViewType_CollectionPtr
     */
    virtual Mp7JrsMultipleViewType_CollectionPtr GetMultipleViewType_LocalType() const;

    /*
     * Set MultipleViewType_LocalType element.
     * @param item const Mp7JrsMultipleViewType_CollectionPtr &
     */
    virtual void SetMultipleViewType_LocalType(const Mp7JrsMultipleViewType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMultipleViewType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMultipleViewType();

protected:
    Mp7JrsMultipleViewType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_fixedViewsFlag;


    Mp7JrsMultipleViewType_CollectionPtr m_MultipleViewType_LocalType;

// no includefile for extension defined 
// file Mp7JrsMultipleViewType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1443MP7JRSMULTIPLEVIEWTYPE_H

