/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1453MP7JRSNONDEPENDENCYSTRUCTUREPHRASETYPE_H
#define _1453MP7JRSNONDEPENDENCYSTRUCTUREPHRASETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNonDependencyStructurePhraseTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_ExtInclude.h


#include "Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType.h"
class IMp7JrsNonDependencyStructurePhraseType;
class IMp7JrsNonDependencyStructurePhraseType_CollectionType;
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType_CollectionType > Mp7JrsNonDependencyStructurePhraseType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType> Mp7JrsNonDependencyStructurePhrasePtr;

/** 
 * Generated interface IMp7JrsNonDependencyStructurePhraseType for class Mp7JrsNonDependencyStructurePhraseType<br>
 * Located at: mds-2001.xsd, line 1342<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsNonDependencyStructurePhraseType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsNonDependencyStructurePhraseType();
    virtual ~IMp7JrsNonDependencyStructurePhraseType();
    /**
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get equal attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getequal() const = 0;

    /**
     * Get equal attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existequal() const = 0;

    /**
     * Set equal attribute.
     * @param item XMLCh *
     */
    virtual void Setequal(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate equal attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateequal() = 0;

    /**
     * Get synthesis attribute.
     * @return Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration
     */
    virtual Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration Getsynthesis() const = 0;

    /**
     * Get synthesis attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsynthesis() const = 0;

    /**
     * Set synthesis attribute.
     * @param item Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration
     */
    virtual void Setsynthesis(Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate synthesis attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesynthesis() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get NonDependencyStructurePhraseType_LocalType element.
     * @return Mp7JrsNonDependencyStructurePhraseType_CollectionPtr
     */
    virtual Mp7JrsNonDependencyStructurePhraseType_CollectionPtr GetNonDependencyStructurePhraseType_LocalType() const = 0;

    /**
     * Set NonDependencyStructurePhraseType_LocalType element.
     * @param item const Mp7JrsNonDependencyStructurePhraseType_CollectionPtr &
     */
    virtual void SetNonDependencyStructurePhraseType_LocalType(const Mp7JrsNonDependencyStructurePhraseType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsNonDependencyStructurePhraseType<br>
 * Located at: mds-2001.xsd, line 1342<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1342.<br>
 */
class MP7JRS_EXPORT Mp7JrsNonDependencyStructurePhraseType :
        public IMp7JrsNonDependencyStructurePhraseType
{
    friend class Mp7JrsNonDependencyStructurePhraseTypeFactory; // constructs objects

public:
    /*
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get equal attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getequal() const;

    /*
     * Get equal attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existequal() const;

    /*
     * Set equal attribute.
     * @param item XMLCh *
     */
    virtual void Setequal(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate equal attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateequal();

    /*
     * Get synthesis attribute.
     * @return Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration
     */
    virtual Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration Getsynthesis() const;

    /*
     * Get synthesis attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsynthesis() const;

    /*
     * Set synthesis attribute.
     * @param item Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration
     */
    virtual void Setsynthesis(Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate synthesis attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesynthesis();

        /* @name Sequence

         */
        //@{
    /*
     * Get NonDependencyStructurePhraseType_LocalType element.
     * @return Mp7JrsNonDependencyStructurePhraseType_CollectionPtr
     */
    virtual Mp7JrsNonDependencyStructurePhraseType_CollectionPtr GetNonDependencyStructurePhraseType_LocalType() const;

    /*
     * Set NonDependencyStructurePhraseType_LocalType element.
     * @param item const Mp7JrsNonDependencyStructurePhraseType_CollectionPtr &
     */
    virtual void SetNonDependencyStructurePhraseType_LocalType(const Mp7JrsNonDependencyStructurePhraseType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsNonDependencyStructurePhraseType();

protected:
    Mp7JrsNonDependencyStructurePhraseType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_id;
    bool m_id_Exist;
    XMLCh * m_equal;
    bool m_equal_Exist;
    Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration m_synthesis;
    bool m_synthesis_Exist;
    Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType::Enumeration m_synthesis_Default;


    Mp7JrsNonDependencyStructurePhraseType_CollectionPtr m_NonDependencyStructurePhraseType_LocalType;

// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1453MP7JRSNONDEPENDENCYSTRUCTUREPHRASETYPE_H

