/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1461MP7JRSNONMIXTUREAMOUNTOFMOTIONTYPE_H
#define _1461MP7JRSNONMIXTUREAMOUNTOFMOTIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNonMixtureAmountOfMotionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtInclude.h


class IMp7JrsNonMixtureAmountOfMotionType;
class IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType;
class IMp7Jrsunsigned11;
typedef Mp7JrsPtr< IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType > Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsNonMixtureAmountOfMotionType> Mp7JrsNonMixtureAmountOfMotionPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned11 > Mp7Jrsunsigned11Ptr;

/** 
 * Generated interface IMp7JrsNonMixtureAmountOfMotionType for class Mp7JrsNonMixtureAmountOfMotionType<br>
 * Located at: visual-2001.xsd, line 914<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsNonMixtureAmountOfMotionType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsNonMixtureAmountOfMotionType();
    virtual ~IMp7JrsNonMixtureAmountOfMotionType();
        /** @name Choice

         */
        //@{
    /**
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackLeft() const = 0;

    /**
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TrackRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackRight() const = 0;

    /**
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get BoomDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomDown() const = 0;

    /**
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get BoomUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomUp() const = 0;

    /**
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DollyForward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyForward() const = 0;

    /**
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyBackward() const = 0;

    /**
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PanLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanLeft() const = 0;

    /**
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PanRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanRight() const = 0;

    /**
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TiltDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltDown() const = 0;

    /**
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TiltUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltUp() const = 0;

    /**
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollClockwise() const = 0;

    /**
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollAnticlockwise() const = 0;

    /**
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomIn() const = 0;

    /**
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomOut() const = 0;

    /**
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Fixed element.
     * @return Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr
     */
    virtual Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr GetFixed() const = 0;

    /**
     * Set Fixed element.
     * @param item const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr &
     */
    virtual void SetFixed(const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsNonMixtureAmountOfMotionType<br>
 * Located at: visual-2001.xsd, line 914<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 914.<br>
 */
class MP7JRS_EXPORT Mp7JrsNonMixtureAmountOfMotionType :
        public IMp7JrsNonMixtureAmountOfMotionType
{
    friend class Mp7JrsNonMixtureAmountOfMotionTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackLeft() const;

    /*
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TrackRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackRight() const;

    /*
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get BoomDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomDown() const;

    /*
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get BoomUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomUp() const;

    /*
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DollyForward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyForward() const;

    /*
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyBackward() const;

    /*
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PanLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanLeft() const;

    /*
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PanRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanRight() const;

    /*
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TiltDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltDown() const;

    /*
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TiltUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltUp() const;

    /*
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollClockwise() const;

    /*
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollAnticlockwise() const;

    /*
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomIn() const;

    /*
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomOut() const;

    /*
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    virtual void SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Fixed element.
     * @return Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr
     */
    virtual Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr GetFixed() const;

    /*
     * Set Fixed element.
     * @param item const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr &
     */
    virtual void SetFixed(const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsNonMixtureAmountOfMotionType();

protected:
    Mp7JrsNonMixtureAmountOfMotionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7Jrsunsigned11Ptr m_TrackLeft;
    Mp7Jrsunsigned11Ptr m_TrackRight;
    Mp7Jrsunsigned11Ptr m_BoomDown;
    Mp7Jrsunsigned11Ptr m_BoomUp;
    Mp7Jrsunsigned11Ptr m_DollyForward;
    Mp7Jrsunsigned11Ptr m_DollyBackward;
    Mp7Jrsunsigned11Ptr m_PanLeft;
    Mp7Jrsunsigned11Ptr m_PanRight;
    Mp7Jrsunsigned11Ptr m_TiltDown;
    Mp7Jrsunsigned11Ptr m_TiltUp;
    Mp7Jrsunsigned11Ptr m_RollClockwise;
    Mp7Jrsunsigned11Ptr m_RollAnticlockwise;
    Mp7Jrsunsigned11Ptr m_ZoomIn;
    Mp7Jrsunsigned11Ptr m_ZoomOut;
    Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr m_Fixed;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1461MP7JRSNONMIXTUREAMOUNTOFMOTIONTYPE_H

