/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1479MP7JRSORDEREDGROUPDATASETMASKTYPE_SUBINTERVAL_LOCALTYPE_H
#define _1479MP7JRSORDEREDGROUPDATASETMASKTYPE_SUBINTERVAL_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtInclude.h


class IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType;
typedef Mp7JrsPtr< IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType> Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalPtr;

/** 
 * Generated interface IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType for class Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType<br>
 * Located at: mds-2001.xsd, line 3051<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType();
    virtual ~IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType();
    /**
     * Get setRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetsetRef() const = 0;

    /**
     * Get setRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistsetRef() const = 0;

    /**
     * Set setRef attribute.
     * @param item XMLCh *
     */
    virtual void SetsetRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate setRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatesetRef() = 0;

    /**
     * Get startComponent attribute.
     * @return unsigned
     */
    virtual unsigned GetstartComponent() const = 0;

    /**
     * Get startComponent attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExiststartComponent() const = 0;

    /**
     * Set startComponent attribute.
     * @param item unsigned
     */
    virtual void SetstartComponent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate startComponent attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatestartComponent() = 0;

    /**
     * Get startUnit attribute.
     * @return unsigned
     */
    virtual unsigned GetstartUnit() const = 0;

    /**
     * Get startUnit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExiststartUnit() const = 0;

    /**
     * Set startUnit attribute.
     * @param item unsigned
     */
    virtual void SetstartUnit(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate startUnit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatestartUnit() = 0;

    /**
     * Get endComponent attribute.
     * @return unsigned
     */
    virtual unsigned GetendComponent() const = 0;

    /**
     * Get endComponent attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistendComponent() const = 0;

    /**
     * Set endComponent attribute.
     * @param item unsigned
     */
    virtual void SetendComponent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate endComponent attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateendComponent() = 0;

    /**
     * Get endUnit attribute.
     * @return unsigned
     */
    virtual unsigned GetendUnit() const = 0;

    /**
     * Get endUnit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistendUnit() const = 0;

    /**
     * Set endUnit attribute.
     * @param item unsigned
     */
    virtual void SetendUnit(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate endUnit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateendUnit() = 0;

// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType<br>
 * Located at: mds-2001.xsd, line 3051<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3051.<br>
 */
class MP7JRS_EXPORT Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType :
        public IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType
{
    friend class Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalTypeFactory; // constructs objects

public:
    /*
     * Get setRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetsetRef() const;

    /*
     * Get setRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistsetRef() const;

    /*
     * Set setRef attribute.
     * @param item XMLCh *
     */
    virtual void SetsetRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate setRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatesetRef();

    /*
     * Get startComponent attribute.
     * @return unsigned
     */
    virtual unsigned GetstartComponent() const;

    /*
     * Get startComponent attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExiststartComponent() const;

    /*
     * Set startComponent attribute.
     * @param item unsigned
     */
    virtual void SetstartComponent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate startComponent attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatestartComponent();

    /*
     * Get startUnit attribute.
     * @return unsigned
     */
    virtual unsigned GetstartUnit() const;

    /*
     * Get startUnit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExiststartUnit() const;

    /*
     * Set startUnit attribute.
     * @param item unsigned
     */
    virtual void SetstartUnit(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate startUnit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatestartUnit();

    /*
     * Get endComponent attribute.
     * @return unsigned
     */
    virtual unsigned GetendComponent() const;

    /*
     * Get endComponent attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistendComponent() const;

    /*
     * Set endComponent attribute.
     * @param item unsigned
     */
    virtual void SetendComponent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate endComponent attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateendComponent();

    /*
     * Get endUnit attribute.
     * @return unsigned
     */
    virtual unsigned GetendUnit() const;

    /*
     * Get endUnit attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistendUnit() const;

    /*
     * Set endUnit attribute.
     * @param item unsigned
     */
    virtual void SetendUnit(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate endUnit attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateendUnit();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType();

protected:
    Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_setRef;
    bool m_setRef_Exist;
    unsigned m_startComponent;
    bool m_startComponent_Exist;
    unsigned m_startUnit;
    bool m_startUnit_Exist;
    unsigned m_endComponent;
    bool m_endComponent_Exist;
    unsigned m_endUnit;
    bool m_endUnit_Exist;



// no includefile for extension defined 
// file Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1479MP7JRSORDEREDGROUPDATASETMASKTYPE_SUBINTERVAL_LOCALTYPE_H

