/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1481MP7JRSORDERINGKEYTYPE_H
#define _1481MP7JRSORDERINGKEYTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsOrderingKeyTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsOrderingKeyType_direction_LocalType.h"
class IMp7JrsHeaderType;
class IMp7JrsOrderingKeyType;
class IMp7JrsOrderingKeyType_Field_CollectionType;
class IMp7JrsOrderingKeyType_Selector_LocalType;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType_Field_CollectionType > Mp7JrsOrderingKeyType_Field_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType_Selector_LocalType > Mp7JrsOrderingKeyType_Selector_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType> Mp7JrsOrderingKeyPtr;

/** 
 * Generated interface IMp7JrsOrderingKeyType for class Mp7JrsOrderingKeyType<br>
 * Located at: mds-2001.xsd, line 2008<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsOrderingKeyType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsOrderingKeyType();
    virtual ~IMp7JrsOrderingKeyType();
    /**
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const = 0;

    /**
     * Get name attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existname() const = 0;

    /**
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate name attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatename() = 0;

    /**
     * Get semantics attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getsemantics() const = 0;

    /**
     * Get semantics attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsemantics() const = 0;

    /**
     * Set semantics attribute.
     * @param item XMLCh *
     */
    virtual void Setsemantics(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate semantics attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesemantics() = 0;

    /**
     * Get direction attribute.
     * @return Mp7JrsOrderingKeyType_direction_LocalType::Enumeration
     */
    virtual Mp7JrsOrderingKeyType_direction_LocalType::Enumeration Getdirection() const = 0;

    /**
     * Get direction attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdirection() const = 0;

    /**
     * Set direction attribute.
     * @param item Mp7JrsOrderingKeyType_direction_LocalType::Enumeration
     */
    virtual void Setdirection(Mp7JrsOrderingKeyType_direction_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate direction attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedirection() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Selector element.
     * @return Mp7JrsOrderingKeyType_Selector_LocalPtr
     */
    virtual Mp7JrsOrderingKeyType_Selector_LocalPtr GetSelector() const = 0;

    /**
     * Set Selector element.
     * @param item const Mp7JrsOrderingKeyType_Selector_LocalPtr &
     */
    virtual void SetSelector(const Mp7JrsOrderingKeyType_Selector_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Field element.
     * @return Mp7JrsOrderingKeyType_Field_CollectionPtr
     */
    virtual Mp7JrsOrderingKeyType_Field_CollectionPtr GetField() const = 0;

    /**
     * Set Field element.
     * @param item const Mp7JrsOrderingKeyType_Field_CollectionPtr &
     */
    virtual void SetField(const Mp7JrsOrderingKeyType_Field_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsOrderingKeyType<br>
 * Located at: mds-2001.xsd, line 2008<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in mds-2001.xsd, line 2008.<br>
 */
class MP7JRS_EXPORT Mp7JrsOrderingKeyType :
        public IMp7JrsOrderingKeyType
{
    friend class Mp7JrsOrderingKeyTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsOrderingKeyType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
    /*
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const;

    /*
     * Get name attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existname() const;

    /*
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate name attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatename();

    /*
     * Get semantics attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getsemantics() const;

    /*
     * Get semantics attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsemantics() const;

    /*
     * Set semantics attribute.
     * @param item XMLCh *
     */
    virtual void Setsemantics(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate semantics attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesemantics();

    /*
     * Get direction attribute.
     * @return Mp7JrsOrderingKeyType_direction_LocalType::Enumeration
     */
    virtual Mp7JrsOrderingKeyType_direction_LocalType::Enumeration Getdirection() const;

    /*
     * Get direction attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdirection() const;

    /*
     * Set direction attribute.
     * @param item Mp7JrsOrderingKeyType_direction_LocalType::Enumeration
     */
    virtual void Setdirection(Mp7JrsOrderingKeyType_direction_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate direction attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedirection();

        /* @name Sequence

         */
        //@{
    /*
     * Get Selector element.
     * @return Mp7JrsOrderingKeyType_Selector_LocalPtr
     */
    virtual Mp7JrsOrderingKeyType_Selector_LocalPtr GetSelector() const;

    /*
     * Set Selector element.
     * @param item const Mp7JrsOrderingKeyType_Selector_LocalPtr &
     */
    virtual void SetSelector(const Mp7JrsOrderingKeyType_Selector_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Field element.
     * @return Mp7JrsOrderingKeyType_Field_CollectionPtr
     */
    virtual Mp7JrsOrderingKeyType_Field_CollectionPtr GetField() const;

    /*
     * Set Field element.
     * @param item const Mp7JrsOrderingKeyType_Field_CollectionPtr &
     */
    virtual void SetField(const Mp7JrsOrderingKeyType_Field_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsOrderingKeyType();

protected:
    Mp7JrsOrderingKeyType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_name;
    bool m_name_Exist;
    XMLCh * m_semantics;
    bool m_semantics_Exist;
    Mp7JrsOrderingKeyType_direction_LocalType::Enumeration m_direction;
    bool m_direction_Exist;
    Mp7JrsOrderingKeyType_direction_LocalType::Enumeration m_direction_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    Mp7JrsOrderingKeyType_Selector_LocalPtr m_Selector;
    Mp7JrsOrderingKeyType_Field_CollectionPtr m_Field;

// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1481MP7JRSORDERINGKEYTYPE_H

