/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1489MP7JRSORDERINGKEYTYPE_SELECTOR_LOCALTYPE_H
#define _1489MP7JRSORDERINGKEYTYPE_SELECTOR_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsOrderingKeyType_Selector_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_Selector_LocalType_ExtInclude.h


class IMp7JrsOrderingKeyType_Selector_LocalType;
class IMp7JrsxPathSelectorType;
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType_Selector_LocalType> Mp7JrsOrderingKeyType_Selector_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsxPathSelectorType > Mp7JrsxPathSelectorPtr;

/** 
 * Generated interface IMp7JrsOrderingKeyType_Selector_LocalType for class Mp7JrsOrderingKeyType_Selector_LocalType<br>
 * Located at: mds-2001.xsd, line 2013<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsOrderingKeyType_Selector_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsOrderingKeyType_Selector_LocalType();
    virtual ~IMp7JrsOrderingKeyType_Selector_LocalType();
    /**
     * Get xpath attribute.
     * @return Mp7JrsxPathSelectorPtr
     */
    virtual Mp7JrsxPathSelectorPtr Getxpath() const = 0;

    /**
     * Get xpath attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existxpath() const = 0;

    /**
     * Set xpath attribute.
     * @param item const Mp7JrsxPathSelectorPtr &
     */
    virtual void Setxpath(const Mp7JrsxPathSelectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate xpath attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatexpath() = 0;

// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_Selector_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_Selector_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsOrderingKeyType_Selector_LocalType<br>
 * Located at: mds-2001.xsd, line 2013<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2013.<br>
 */
class MP7JRS_EXPORT Mp7JrsOrderingKeyType_Selector_LocalType :
        public IMp7JrsOrderingKeyType_Selector_LocalType
{
    friend class Mp7JrsOrderingKeyType_Selector_LocalTypeFactory; // constructs objects

public:
    /*
     * Get xpath attribute.
     * @return Mp7JrsxPathSelectorPtr
     */
    virtual Mp7JrsxPathSelectorPtr Getxpath() const;

    /*
     * Get xpath attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existxpath() const;

    /*
     * Set xpath attribute.
     * @param item const Mp7JrsxPathSelectorPtr &
     */
    virtual void Setxpath(const Mp7JrsxPathSelectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate xpath attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatexpath();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_Selector_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsOrderingKeyType_Selector_LocalType();

protected:
    Mp7JrsOrderingKeyType_Selector_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsxPathSelectorPtr m_xpath;
    bool m_xpath_Exist;



// no includefile for extension defined 
// file Mp7JrsOrderingKeyType_Selector_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1489MP7JRSORDERINGKEYTYPE_SELECTOR_LOCALTYPE_H

