/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1529MP7JRSPARAMETRICMOTIONTYPE_H
#define _1529MP7JRSPARAMETRICMOTIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsParametricMotionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsParametricMotionType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsParametricMotionType_motionModel_LocalType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsMediaIncrDurationType;
class IMp7JrsParametricMotionType;
class IMp7JrsParametricMotionType_CoordDef_LocalType;
class IMp7JrsParametricMotionType_CoordRef_LocalType;
class IMp7JrsParametricMotionType_Parameters_LocalType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsMediaIncrDurationType > Mp7JrsMediaIncrDurationPtr;
typedef Mp7JrsPtr< IMp7JrsParametricMotionType_CoordDef_LocalType > Mp7JrsParametricMotionType_CoordDef_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsParametricMotionType_CoordRef_LocalType > Mp7JrsParametricMotionType_CoordRef_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsParametricMotionType_Parameters_LocalType > Mp7JrsParametricMotionType_Parameters_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsParametricMotionType> Mp7JrsParametricMotionPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsParametricMotionType for class Mp7JrsParametricMotionType<br>
 * Located at: visual-2001.xsd, line 981<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsParametricMotionType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsParametricMotionType();
    virtual ~IMp7JrsParametricMotionType();
    /**
     * Get motionModel attribute.
     * @return Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration
     */
    virtual Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration GetmotionModel() const = 0;

    /**
     * Set motionModel attribute.
     * @param item Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration
     */
    virtual void SetmotionModel(Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get CoordRef element.
     * @return Mp7JrsParametricMotionType_CoordRef_LocalPtr
     */
    virtual Mp7JrsParametricMotionType_CoordRef_LocalPtr GetCoordRef() const = 0;

    /**
     * Set CoordRef element.
     * @param item const Mp7JrsParametricMotionType_CoordRef_LocalPtr &
     */
    virtual void SetCoordRef(const Mp7JrsParametricMotionType_CoordRef_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CoordDef element.
     * @return Mp7JrsParametricMotionType_CoordDef_LocalPtr
     */
    virtual Mp7JrsParametricMotionType_CoordDef_LocalPtr GetCoordDef() const = 0;

    /**
     * Set CoordDef element.
     * @param item const Mp7JrsParametricMotionType_CoordDef_LocalPtr &
     */
    virtual void SetCoordDef(const Mp7JrsParametricMotionType_CoordDef_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get MediaDuration element.
     * @return Mp7JrsMediaIncrDurationPtr
     */
    virtual Mp7JrsMediaIncrDurationPtr GetMediaDuration() const = 0;

    /**
     * Set MediaDuration element.
     * @param item const Mp7JrsMediaIncrDurationPtr &
     */
    virtual void SetMediaDuration(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Parameters element.
     * @return Mp7JrsParametricMotionType_Parameters_LocalPtr
     */
    virtual Mp7JrsParametricMotionType_Parameters_LocalPtr GetParameters() const = 0;

    /**
     * Set Parameters element.
     * @param item const Mp7JrsParametricMotionType_Parameters_LocalPtr &
     */
    virtual void SetParameters(const Mp7JrsParametricMotionType_Parameters_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsParametricMotionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsParametricMotionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsParametricMotionType<br>
 * Located at: visual-2001.xsd, line 981<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 981.<br>
 */
class MP7JRS_EXPORT Mp7JrsParametricMotionType :
        public IMp7JrsParametricMotionType
{
    friend class Mp7JrsParametricMotionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsParametricMotionType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
    /*
     * Get motionModel attribute.
     * @return Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration
     */
    virtual Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration GetmotionModel() const;

    /*
     * Set motionModel attribute.
     * @param item Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration
     */
    virtual void SetmotionModel(Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get CoordRef element.
     * @return Mp7JrsParametricMotionType_CoordRef_LocalPtr
     */
    virtual Mp7JrsParametricMotionType_CoordRef_LocalPtr GetCoordRef() const;

    /*
     * Set CoordRef element.
     * @param item const Mp7JrsParametricMotionType_CoordRef_LocalPtr &
     */
    virtual void SetCoordRef(const Mp7JrsParametricMotionType_CoordRef_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CoordDef element.
     * @return Mp7JrsParametricMotionType_CoordDef_LocalPtr
     */
    virtual Mp7JrsParametricMotionType_CoordDef_LocalPtr GetCoordDef() const;

    /*
     * Set CoordDef element.
     * @param item const Mp7JrsParametricMotionType_CoordDef_LocalPtr &
     */
    virtual void SetCoordDef(const Mp7JrsParametricMotionType_CoordDef_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get MediaDuration element.
     * @return Mp7JrsMediaIncrDurationPtr
     */
    virtual Mp7JrsMediaIncrDurationPtr GetMediaDuration() const;

    /*
     * Set MediaDuration element.
     * @param item const Mp7JrsMediaIncrDurationPtr &
     */
    virtual void SetMediaDuration(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Parameters element.
     * @return Mp7JrsParametricMotionType_Parameters_LocalPtr
     */
    virtual Mp7JrsParametricMotionType_Parameters_LocalPtr GetParameters() const;

    /*
     * Set Parameters element.
     * @param item const Mp7JrsParametricMotionType_Parameters_LocalPtr &
     */
    virtual void SetParameters(const Mp7JrsParametricMotionType_Parameters_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsParametricMotionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsParametricMotionType();

protected:
    Mp7JrsParametricMotionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration m_motionModel;

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

// DefinionChoice
    Mp7JrsParametricMotionType_CoordRef_LocalPtr m_CoordRef;
    Mp7JrsParametricMotionType_CoordDef_LocalPtr m_CoordDef;
// End DefinionChoice
    Mp7JrsMediaIncrDurationPtr m_MediaDuration;
    Mp7JrsParametricMotionType_Parameters_LocalPtr m_Parameters;

// no includefile for extension defined 
// file Mp7JrsParametricMotionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1529MP7JRSPARAMETRICMOTIONTYPE_H

