/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1539MP7JRSPARENTALGUIDANCETYPE_H
#define _1539MP7JRSPARENTALGUIDANCETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsParentalGuidanceTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsParentalGuidanceType_ExtInclude.h


class IMp7JrsControlledTermUseType;
class IMp7JrsParentalGuidanceType;
class IMp7JrsParentalGuidanceType_Region_CollectionType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsParentalGuidanceType_Region_CollectionType > Mp7JrsParentalGuidanceType_Region_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsParentalGuidanceType> Mp7JrsParentalGuidancePtr;

/** 
 * Generated interface IMp7JrsParentalGuidanceType for class Mp7JrsParentalGuidanceType<br>
 * Located at: mds-2001.xsd, line 2689<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsParentalGuidanceType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsParentalGuidanceType();
    virtual ~IMp7JrsParentalGuidanceType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get ParentalRating element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetParentalRating() const = 0;

    /**
     * Set ParentalRating element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetParentalRating(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MinimumAge element.
     * @return unsigned
     */
    virtual unsigned GetMinimumAge() const = 0;

    /**
     * Set MinimumAge element.
     * @param item unsigned
     */
    virtual void SetMinimumAge(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get Region element.
     * @return Mp7JrsParentalGuidanceType_Region_CollectionPtr
     */
    virtual Mp7JrsParentalGuidanceType_Region_CollectionPtr GetRegion() const = 0;

    /**
     * Set Region element.
     * @param item const Mp7JrsParentalGuidanceType_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsParentalGuidanceType_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsParentalGuidanceType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsParentalGuidanceType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsParentalGuidanceType<br>
 * Located at: mds-2001.xsd, line 2689<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2689.<br>
 */
class MP7JRS_EXPORT Mp7JrsParentalGuidanceType :
        public IMp7JrsParentalGuidanceType
{
    friend class Mp7JrsParentalGuidanceTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get ParentalRating element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetParentalRating() const;

    /*
     * Set ParentalRating element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetParentalRating(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MinimumAge element.
     * @return unsigned
     */
    virtual unsigned GetMinimumAge() const;

    /*
     * Set MinimumAge element.
     * @param item unsigned
     */
    virtual void SetMinimumAge(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get Region element.
     * @return Mp7JrsParentalGuidanceType_Region_CollectionPtr
     */
    virtual Mp7JrsParentalGuidanceType_Region_CollectionPtr GetRegion() const;

    /*
     * Set Region element.
     * @param item const Mp7JrsParentalGuidanceType_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsParentalGuidanceType_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsParentalGuidanceType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsParentalGuidanceType();

protected:
    Mp7JrsParentalGuidanceType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsControlledTermUsePtr m_ParentalRating;
    unsigned m_MinimumAge;
    bool m_MinimumAge_Valid; // For value types in unions
// End DefinionChoice
    Mp7JrsParentalGuidanceType_Region_CollectionPtr m_Region;

// no includefile for extension defined 
// file Mp7JrsParentalGuidanceType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1539MP7JRSPARENTALGUIDANCETYPE_H

