/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1549MP7JRSPERSONGROUPTYPE_H
#define _1549MP7JRSPERSONGROUPTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPersonGroupTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPersonGroupType_ExtInclude.h


#include "Mp7JrsAgentType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAgentType;
class IMp7JrsAgentType_Icon_CollectionType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsElectronicAddressType;
class IMp7JrsmediaDurationType;
class IMp7JrsPersonGroupType;
class IMp7JrsPersonGroupType_CollectionType;
class IMp7JrsPersonGroupType_Name_CollectionType;
class IMp7JrsPersonGroupType_NameTerm_CollectionType;
class IMp7JrsPlaceType;
class IMp7JrsReferenceType;
class IMp7JrsTermUseType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAgentType > Mp7JrsAgentPtr;
typedef Mp7JrsPtr< IMp7JrsAgentType_Icon_CollectionType > Mp7JrsAgentType_Icon_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType > Mp7JrsElectronicAddressPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_CollectionType > Mp7JrsPersonGroupType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_Name_CollectionType > Mp7JrsPersonGroupType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_NameTerm_CollectionType > Mp7JrsPersonGroupType_NameTerm_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonGroupType> Mp7JrsPersonGroupPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsPersonGroupType for class Mp7JrsPersonGroupType<br>
 * Located at: mds-2001.xsd, line 1704<br>
 * Classified: Class<br>
 * Derived from: AgentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPersonGroupType 
 :
        public IMp7JrsAgentType
{
public:
    // TODO: make these protected?
    IMp7JrsPersonGroupType();
    virtual ~IMp7JrsPersonGroupType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
     * @return Mp7JrsPersonGroupType_Name_CollectionPtr
     */
    virtual Mp7JrsPersonGroupType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
     * @param item const Mp7JrsPersonGroupType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsPersonGroupType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get NameTerm element.
     * @return Mp7JrsPersonGroupType_NameTerm_CollectionPtr
     */
    virtual Mp7JrsPersonGroupType_NameTerm_CollectionPtr GetNameTerm() const = 0;

    /**
     * Set NameTerm element.
     * @param item const Mp7JrsPersonGroupType_NameTerm_CollectionPtr &
     */
    virtual void SetNameTerm(const Mp7JrsPersonGroupType_NameTerm_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Kind element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetKind() const = 0;

    virtual bool IsValidKind() const = 0;

    /**
     * Set Kind element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetKind(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Kind element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateKind() = 0;

    /**
     * Get PersonGroupType_LocalType element.
     * @return Mp7JrsPersonGroupType_CollectionPtr
     */
    virtual Mp7JrsPersonGroupType_CollectionPtr GetPersonGroupType_LocalType() const = 0;

    /**
     * Set PersonGroupType_LocalType element.
     * @param item const Mp7JrsPersonGroupType_CollectionPtr &
     */
    virtual void SetPersonGroupType_LocalType(const Mp7JrsPersonGroupType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Jurisdiction element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetJurisdiction() const = 0;

    /**
     * Set Jurisdiction element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetJurisdiction(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get JurisdictionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetJurisdictionRef() const = 0;

    /**
     * Set JurisdictionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetJurisdictionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get Address element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetAddress() const = 0;

    /**
     * Set Address element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetAddress(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AddressRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAddressRef() const = 0;

    /**
     * Set AddressRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAddressRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get ElectronicAddress element.
     * @return Mp7JrsElectronicAddressPtr
     */
    virtual Mp7JrsElectronicAddressPtr GetElectronicAddress() const = 0;

    virtual bool IsValidElectronicAddress() const = 0;

    /**
     * Set ElectronicAddress element.
     * @param item const Mp7JrsElectronicAddressPtr &
     */
    virtual void SetElectronicAddress(const Mp7JrsElectronicAddressPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ElectronicAddress element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateElectronicAddress() = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @return Mp7JrsAgentType_Icon_CollectionPtr
     */
    virtual Mp7JrsAgentType_Icon_CollectionPtr GetIcon() const = 0;

    /**
     * Set Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @param item const Mp7JrsAgentType_Icon_CollectionPtr &
     */
    virtual void SetIcon(const Mp7JrsAgentType_Icon_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPersonGroupType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPersonGroupType<br>
 * Located at: mds-2001.xsd, line 1704<br>
 * Classified: Class<br>
 * Derived from: AgentType (Class)<br>
 * Defined in mds-2001.xsd, line 1704.<br>
 */
class MP7JRS_EXPORT Mp7JrsPersonGroupType :
        public IMp7JrsPersonGroupType
{
    friend class Mp7JrsPersonGroupTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPersonGroupType
     
     * @return Mp7JrsPtr< Mp7JrsAgentType >
     */
    virtual Mp7JrsPtr< Mp7JrsAgentType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
     * @return Mp7JrsPersonGroupType_Name_CollectionPtr
     */
    virtual Mp7JrsPersonGroupType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
     * @param item const Mp7JrsPersonGroupType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsPersonGroupType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get NameTerm element.
     * @return Mp7JrsPersonGroupType_NameTerm_CollectionPtr
     */
    virtual Mp7JrsPersonGroupType_NameTerm_CollectionPtr GetNameTerm() const;

    /*
     * Set NameTerm element.
     * @param item const Mp7JrsPersonGroupType_NameTerm_CollectionPtr &
     */
    virtual void SetNameTerm(const Mp7JrsPersonGroupType_NameTerm_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Kind element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetKind() const;

    virtual bool IsValidKind() const;

    /*
     * Set Kind element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetKind(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Kind element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateKind();

    /*
     * Get PersonGroupType_LocalType element.
     * @return Mp7JrsPersonGroupType_CollectionPtr
     */
    virtual Mp7JrsPersonGroupType_CollectionPtr GetPersonGroupType_LocalType() const;

    /*
     * Set PersonGroupType_LocalType element.
     * @param item const Mp7JrsPersonGroupType_CollectionPtr &
     */
    virtual void SetPersonGroupType_LocalType(const Mp7JrsPersonGroupType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Choice

         */
        //@{
    /*
     * Get Jurisdiction element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetJurisdiction() const;

    /*
     * Set Jurisdiction element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetJurisdiction(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get JurisdictionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetJurisdictionRef() const;

    /*
     * Set JurisdictionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetJurisdictionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get Address element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetAddress() const;

    /*
     * Set Address element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetAddress(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AddressRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAddressRef() const;

    /*
     * Set AddressRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAddressRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get ElectronicAddress element.
     * @return Mp7JrsElectronicAddressPtr
     */
    virtual Mp7JrsElectronicAddressPtr GetElectronicAddress() const;

    virtual bool IsValidElectronicAddress() const;

    /*
     * Set ElectronicAddress element.
     * @param item const Mp7JrsElectronicAddressPtr &
     */
    virtual void SetElectronicAddress(const Mp7JrsElectronicAddressPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ElectronicAddress element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateElectronicAddress();

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @return Mp7JrsAgentType_Icon_CollectionPtr
     */
    virtual Mp7JrsAgentType_Icon_CollectionPtr GetIcon() const;

    /*
     * Set Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @param item const Mp7JrsAgentType_Icon_CollectionPtr &
     */
    virtual void SetIcon(const Mp7JrsAgentType_Icon_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPersonGroupType();

protected:
    Mp7JrsPersonGroupType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAgentType > m_Base;

    Mp7JrsPersonGroupType_Name_CollectionPtr m_Name;
    Mp7JrsPersonGroupType_NameTerm_CollectionPtr m_NameTerm;
    Mp7JrsTermUsePtr m_Kind;
    bool m_Kind_Exist; // For optional elements 
    Mp7JrsPersonGroupType_CollectionPtr m_PersonGroupType_LocalType;
// DefinionChoice
    Mp7JrsPlacePtr m_Jurisdiction;
    Mp7JrsReferencePtr m_JurisdictionRef;
// End DefinionChoice
// DefinionChoice
    Mp7JrsPlacePtr m_Address;
    Mp7JrsReferencePtr m_AddressRef;
// End DefinionChoice
    Mp7JrsElectronicAddressPtr m_ElectronicAddress;
    bool m_ElectronicAddress_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsPersonGroupType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1549MP7JRSPERSONGROUPTYPE_H

