/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1567MP7JRSPERSONNAMETYPE_H
#define _1567MP7JRSPERSONNAMETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPersonNameTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPersonNameType_ExtInclude.h


#include "Mp7JrsPersonNameType_type_LocalType.h"
class IMp7JrsPersonNameType;
class IMp7JrsPersonNameType_CollectionType;
class IMp7JrstimePointType;
typedef Mp7JrsPtr< IMp7JrsPersonNameType_CollectionType > Mp7JrsPersonNameType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonNameType> Mp7JrsPersonNamePtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;

/** 
 * Generated interface IMp7JrsPersonNameType for class Mp7JrsPersonNameType<br>
 * Located at: mds-2001.xsd, line 1824<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsPersonNameType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPersonNameType();
    virtual ~IMp7JrsPersonNameType();
    /**
     * Get dateFrom attribute.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetdateFrom() const = 0;

    /**
     * Get dateFrom attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdateFrom() const = 0;

    /**
     * Set dateFrom attribute.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetdateFrom(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dateFrom attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedateFrom() = 0;

    /**
     * Get dateTo attribute.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetdateTo() const = 0;

    /**
     * Get dateTo attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdateTo() const = 0;

    /**
     * Set dateTo attribute.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetdateTo(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dateTo attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedateTo() = 0;

    /**
     * Get type attribute.
     * @return Mp7JrsPersonNameType_type_LocalType::Enumeration
     */
    virtual Mp7JrsPersonNameType_type_LocalType::Enumeration Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
     * @param item Mp7JrsPersonNameType_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsPersonNameType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

    /**
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get PersonNameType_LocalType element.
     * @return Mp7JrsPersonNameType_CollectionPtr
     */
    virtual Mp7JrsPersonNameType_CollectionPtr GetPersonNameType_LocalType() const = 0;

    /**
     * Set PersonNameType_LocalType element.
     * @param item const Mp7JrsPersonNameType_CollectionPtr &
     */
    virtual void SetPersonNameType_LocalType(const Mp7JrsPersonNameType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPersonNameType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPersonNameType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPersonNameType<br>
 * Located at: mds-2001.xsd, line 1824<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1824.<br>
 */
class MP7JRS_EXPORT Mp7JrsPersonNameType :
        public IMp7JrsPersonNameType
{
    friend class Mp7JrsPersonNameTypeFactory; // constructs objects

public:
    /*
     * Get dateFrom attribute.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetdateFrom() const;

    /*
     * Get dateFrom attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdateFrom() const;

    /*
     * Set dateFrom attribute.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetdateFrom(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dateFrom attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedateFrom();

    /*
     * Get dateTo attribute.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetdateTo() const;

    /*
     * Get dateTo attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdateTo() const;

    /*
     * Set dateTo attribute.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetdateTo(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dateTo attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedateTo();

    /*
     * Get type attribute.
     * @return Mp7JrsPersonNameType_type_LocalType::Enumeration
     */
    virtual Mp7JrsPersonNameType_type_LocalType::Enumeration Gettype() const;

    /*
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
     * @param item Mp7JrsPersonNameType_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsPersonNameType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();

    /*
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get PersonNameType_LocalType element.
     * @return Mp7JrsPersonNameType_CollectionPtr
     */
    virtual Mp7JrsPersonNameType_CollectionPtr GetPersonNameType_LocalType() const;

    /*
     * Set PersonNameType_LocalType element.
     * @param item const Mp7JrsPersonNameType_CollectionPtr &
     */
    virtual void SetPersonNameType_LocalType(const Mp7JrsPersonNameType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPersonNameType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPersonNameType();

protected:
    Mp7JrsPersonNameType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrstimePointPtr m_dateFrom;
    bool m_dateFrom_Exist;
    Mp7JrstimePointPtr m_dateTo;
    bool m_dateTo_Exist;
    Mp7JrsPersonNameType_type_LocalType::Enumeration m_type;
    bool m_type_Exist;
    XMLCh * m_lang;
    bool m_lang_Exist;


    Mp7JrsPersonNameType_CollectionPtr m_PersonNameType_LocalType;

// no includefile for extension defined 
// file Mp7JrsPersonNameType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1567MP7JRSPERSONNAMETYPE_H

