/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1575MP7JRSPERSONTYPE_H
#define _1575MP7JRSPERSONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPersonTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPersonType_ExtInclude.h


#include "Mp7JrsAgentType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAgentType;
class IMp7JrsAgentType_Icon_CollectionType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsPersonType;
class IMp7JrsPersonType_Affiliation_CollectionType;
class IMp7JrsPersonType_Citizenship_CollectionType;
class IMp7JrsPersonType_CollectionType;
class IMp7JrsPersonType_ElectronicAddress_CollectionType;
class IMp7JrsPlaceType;
class IMp7JrsReferenceType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAgentType > Mp7JrsAgentPtr;
typedef Mp7JrsPtr< IMp7JrsAgentType_Icon_CollectionType > Mp7JrsAgentType_Icon_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType_Affiliation_CollectionType > Mp7JrsPersonType_Affiliation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType_Citizenship_CollectionType > Mp7JrsPersonType_Citizenship_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType_CollectionType > Mp7JrsPersonType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType_ElectronicAddress_CollectionType > Mp7JrsPersonType_ElectronicAddress_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType> Mp7JrsPersonPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsPersonType for class Mp7JrsPersonType<br>
 * Located at: mds-2001.xsd, line 1672<br>
 * Classified: Class<br>
 * Derived from: AgentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPersonType 
 :
        public IMp7JrsAgentType
{
public:
    // TODO: make these protected?
    IMp7JrsPersonType();
    virtual ~IMp7JrsPersonType();
        /** @name Sequence

         */
        //@{
    /**
     * Get PersonType_LocalType element.
     * @return Mp7JrsPersonType_CollectionPtr
     */
    virtual Mp7JrsPersonType_CollectionPtr GetPersonType_LocalType() const = 0;

    /**
     * Set PersonType_LocalType element.
     * @param item const Mp7JrsPersonType_CollectionPtr &
     */
    virtual void SetPersonType_LocalType(const Mp7JrsPersonType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Affiliation element.
     * @return Mp7JrsPersonType_Affiliation_CollectionPtr
     */
    virtual Mp7JrsPersonType_Affiliation_CollectionPtr GetAffiliation() const = 0;

    /**
     * Set Affiliation element.
     * @param item const Mp7JrsPersonType_Affiliation_CollectionPtr &
     */
    virtual void SetAffiliation(const Mp7JrsPersonType_Affiliation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Citizenship element.
     * @return Mp7JrsPersonType_Citizenship_CollectionPtr
     */
    virtual Mp7JrsPersonType_Citizenship_CollectionPtr GetCitizenship() const = 0;

    /**
     * Set Citizenship element.
     * @param item const Mp7JrsPersonType_Citizenship_CollectionPtr &
     */
    virtual void SetCitizenship(const Mp7JrsPersonType_Citizenship_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Address element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetAddress() const = 0;

    /**
     * Set Address element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetAddress(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AddressRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAddressRef() const = 0;

    /**
     * Set AddressRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAddressRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get ElectronicAddress element.
     * @return Mp7JrsPersonType_ElectronicAddress_CollectionPtr
     */
    virtual Mp7JrsPersonType_ElectronicAddress_CollectionPtr GetElectronicAddress() const = 0;

    /**
     * Set ElectronicAddress element.
     * @param item const Mp7JrsPersonType_ElectronicAddress_CollectionPtr &
     */
    virtual void SetElectronicAddress(const Mp7JrsPersonType_ElectronicAddress_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @return Mp7JrsAgentType_Icon_CollectionPtr
     */
    virtual Mp7JrsAgentType_Icon_CollectionPtr GetIcon() const = 0;

    /**
     * Set Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @param item const Mp7JrsAgentType_Icon_CollectionPtr &
     */
    virtual void SetIcon(const Mp7JrsAgentType_Icon_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPersonType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPersonType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPersonType<br>
 * Located at: mds-2001.xsd, line 1672<br>
 * Classified: Class<br>
 * Derived from: AgentType (Class)<br>
 * Defined in mds-2001.xsd, line 1672.<br>
 */
class MP7JRS_EXPORT Mp7JrsPersonType :
        public IMp7JrsPersonType
{
    friend class Mp7JrsPersonTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPersonType
     
     * @return Mp7JrsPtr< Mp7JrsAgentType >
     */
    virtual Mp7JrsPtr< Mp7JrsAgentType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get PersonType_LocalType element.
     * @return Mp7JrsPersonType_CollectionPtr
     */
    virtual Mp7JrsPersonType_CollectionPtr GetPersonType_LocalType() const;

    /*
     * Set PersonType_LocalType element.
     * @param item const Mp7JrsPersonType_CollectionPtr &
     */
    virtual void SetPersonType_LocalType(const Mp7JrsPersonType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Affiliation element.
     * @return Mp7JrsPersonType_Affiliation_CollectionPtr
     */
    virtual Mp7JrsPersonType_Affiliation_CollectionPtr GetAffiliation() const;

    /*
     * Set Affiliation element.
     * @param item const Mp7JrsPersonType_Affiliation_CollectionPtr &
     */
    virtual void SetAffiliation(const Mp7JrsPersonType_Affiliation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Citizenship element.
     * @return Mp7JrsPersonType_Citizenship_CollectionPtr
     */
    virtual Mp7JrsPersonType_Citizenship_CollectionPtr GetCitizenship() const;

    /*
     * Set Citizenship element.
     * @param item const Mp7JrsPersonType_Citizenship_CollectionPtr &
     */
    virtual void SetCitizenship(const Mp7JrsPersonType_Citizenship_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Choice

         */
        //@{
    /*
     * Get Address element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetAddress() const;

    /*
     * Set Address element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetAddress(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AddressRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAddressRef() const;

    /*
     * Set AddressRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAddressRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get ElectronicAddress element.
     * @return Mp7JrsPersonType_ElectronicAddress_CollectionPtr
     */
    virtual Mp7JrsPersonType_ElectronicAddress_CollectionPtr GetElectronicAddress() const;

    /*
     * Set ElectronicAddress element.
     * @param item const Mp7JrsPersonType_ElectronicAddress_CollectionPtr &
     */
    virtual void SetElectronicAddress(const Mp7JrsPersonType_ElectronicAddress_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @return Mp7JrsAgentType_Icon_CollectionPtr
     */
    virtual Mp7JrsAgentType_Icon_CollectionPtr GetIcon() const;

    /*
     * Set Icon element.
<br>
     * (Inherited from Mp7JrsAgentType)
     * @param item const Mp7JrsAgentType_Icon_CollectionPtr &
     */
    virtual void SetIcon(const Mp7JrsAgentType_Icon_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPersonType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPersonType();

protected:
    Mp7JrsPersonType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAgentType > m_Base;

    Mp7JrsPersonType_CollectionPtr m_PersonType_LocalType;
    Mp7JrsPersonType_Affiliation_CollectionPtr m_Affiliation;
    Mp7JrsPersonType_Citizenship_CollectionPtr m_Citizenship;
// DefinionChoice
    Mp7JrsPlacePtr m_Address;
    Mp7JrsReferencePtr m_AddressRef;
// End DefinionChoice
    Mp7JrsPersonType_ElectronicAddress_CollectionPtr m_ElectronicAddress;

// no includefile for extension defined 
// file Mp7JrsPersonType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1575MP7JRSPERSONTYPE_H

