/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1579MP7JRSPERSONTYPE_AFFILIATION_LOCALTYPE_H
#define _1579MP7JRSPERSONTYPE_AFFILIATION_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPersonType_Affiliation_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtInclude.h


class IMp7JrsOrganizationType;
class IMp7JrsPersonGroupType;
class IMp7JrsPersonType_Affiliation_LocalType;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsOrganizationType > Mp7JrsOrganizationPtr;
typedef Mp7JrsPtr< IMp7JrsPersonGroupType > Mp7JrsPersonGroupPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType_Affiliation_LocalType> Mp7JrsPersonType_Affiliation_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsPersonType_Affiliation_LocalType for class Mp7JrsPersonType_Affiliation_LocalType<br>
 * Located at: mds-2001.xsd, line 1681<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsPersonType_Affiliation_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPersonType_Affiliation_LocalType();
    virtual ~IMp7JrsPersonType_Affiliation_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Organization element.
     * @return Mp7JrsOrganizationPtr
     */
    virtual Mp7JrsOrganizationPtr GetOrganization() const = 0;

    /**
     * Set Organization element.
     * @param item const Mp7JrsOrganizationPtr &
     */
    virtual void SetOrganization(const Mp7JrsOrganizationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get OrganizationRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetOrganizationRef() const = 0;

    /**
     * Set OrganizationRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetOrganizationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PersonGroup element.
     * @return Mp7JrsPersonGroupPtr
     */
    virtual Mp7JrsPersonGroupPtr GetPersonGroup() const = 0;

    /**
     * Set PersonGroup element.
     * @param item const Mp7JrsPersonGroupPtr &
     */
    virtual void SetPersonGroup(const Mp7JrsPersonGroupPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PersonGroupRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetPersonGroupRef() const = 0;

    /**
     * Set PersonGroupRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetPersonGroupRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPersonType_Affiliation_LocalType<br>
 * Located at: mds-2001.xsd, line 1681<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1681.<br>
 */
class MP7JRS_EXPORT Mp7JrsPersonType_Affiliation_LocalType :
        public IMp7JrsPersonType_Affiliation_LocalType
{
    friend class Mp7JrsPersonType_Affiliation_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Organization element.
     * @return Mp7JrsOrganizationPtr
     */
    virtual Mp7JrsOrganizationPtr GetOrganization() const;

    /*
     * Set Organization element.
     * @param item const Mp7JrsOrganizationPtr &
     */
    virtual void SetOrganization(const Mp7JrsOrganizationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get OrganizationRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetOrganizationRef() const;

    /*
     * Set OrganizationRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetOrganizationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PersonGroup element.
     * @return Mp7JrsPersonGroupPtr
     */
    virtual Mp7JrsPersonGroupPtr GetPersonGroup() const;

    /*
     * Set PersonGroup element.
     * @param item const Mp7JrsPersonGroupPtr &
     */
    virtual void SetPersonGroup(const Mp7JrsPersonGroupPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PersonGroupRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetPersonGroupRef() const;

    /*
     * Set PersonGroupRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetPersonGroupRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPersonType_Affiliation_LocalType();

protected:
    Mp7JrsPersonType_Affiliation_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsOrganizationPtr m_Organization;
    Mp7JrsReferencePtr m_OrganizationRef;
    Mp7JrsPersonGroupPtr m_PersonGroup;
    Mp7JrsReferencePtr m_PersonGroupRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1579MP7JRSPERSONTYPE_AFFILIATION_LOCALTYPE_H

