/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1591MP7JRSPHONELEXICONTYPE_H
#define _1591MP7JRSPHONELEXICONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPhoneLexiconTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPhoneLexiconType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsLexiconType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsphoneticAlphabetType.h"
class IMp7JrsLexiconType;
class IMp7JrsPhoneLexiconType;
class IMp7JrsPhoneLexiconType_Token_CollectionType;
typedef Mp7JrsPtr< IMp7JrsLexiconType > Mp7JrsLexiconPtr;
typedef Mp7JrsPtr< IMp7JrsPhoneLexiconType_Token_CollectionType > Mp7JrsPhoneLexiconType_Token_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPhoneLexiconType> Mp7JrsPhoneLexiconPtr;

/** 
 * Generated interface IMp7JrsPhoneLexiconType for class Mp7JrsPhoneLexiconType<br>
 * Located at: audio-2001.xsd, line 567<br>
 * Classified: Class<br>
 * Derived from: LexiconType (Class)<br>
 * Derived from: LexiconType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPhoneLexiconType 
 :
        public IMp7JrsLexiconType
{
public:
    // TODO: make these protected?
    IMp7JrsPhoneLexiconType();
    virtual ~IMp7JrsPhoneLexiconType();
    /**
     * Get phoneticAlphabet attribute.
     * @return Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual Mp7JrsphoneticAlphabetType::Enumeration GetphoneticAlphabet() const = 0;

    /**
     * Get phoneticAlphabet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticAlphabet() const = 0;

    /**
     * Set phoneticAlphabet attribute.
     * @param item Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual void SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate phoneticAlphabet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticAlphabet() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Token element.
     * @return Mp7JrsPhoneLexiconType_Token_CollectionPtr
     */
    virtual Mp7JrsPhoneLexiconType_Token_CollectionPtr GetToken() const = 0;

    /**
     * Set Token element.
     * @param item const Mp7JrsPhoneLexiconType_Token_CollectionPtr &
     */
    virtual void SetToken(const Mp7JrsPhoneLexiconType_Token_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get numOfOriginalEntries attribute.
<br>
     * (Inherited from Mp7JrsLexiconType)
     * @return unsigned
     */
    virtual unsigned GetnumOfOriginalEntries() const = 0;

    /**
     * Get numOfOriginalEntries attribute validity information.
     * (Inherited from Mp7JrsLexiconType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnumOfOriginalEntries() const = 0;

    /**
     * Set numOfOriginalEntries attribute.
<br>
     * (Inherited from Mp7JrsLexiconType)
     * @param item unsigned
     */
    virtual void SetnumOfOriginalEntries(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate numOfOriginalEntries attribute.
     * (Inherited from Mp7JrsLexiconType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenumOfOriginalEntries() = 0;

    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsPhoneLexiconType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPhoneLexiconType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPhoneLexiconType<br>
 * Located at: audio-2001.xsd, line 567<br>
 * Classified: Class<br>
 * Derived from: LexiconType (Class)<br>
 * Derived from: LexiconType (Class)<br>
 * Defined in audio-2001.xsd, line 567.<br>
 */
class MP7JRS_EXPORT Mp7JrsPhoneLexiconType :
        public IMp7JrsPhoneLexiconType
{
    friend class Mp7JrsPhoneLexiconTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPhoneLexiconType
     
     * @return Mp7JrsPtr< Mp7JrsLexiconType >
     */
    virtual Mp7JrsPtr< Mp7JrsLexiconType > GetBase() const;
    /*
     * Get phoneticAlphabet attribute.
     * @return Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual Mp7JrsphoneticAlphabetType::Enumeration GetphoneticAlphabet() const;

    /*
     * Get phoneticAlphabet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticAlphabet() const;

    /*
     * Set phoneticAlphabet attribute.
     * @param item Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual void SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate phoneticAlphabet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticAlphabet();

        /* @name Sequence

         */
        //@{
    /*
     * Get Token element.
     * @return Mp7JrsPhoneLexiconType_Token_CollectionPtr
     */
    virtual Mp7JrsPhoneLexiconType_Token_CollectionPtr GetToken() const;

    /*
     * Set Token element.
     * @param item const Mp7JrsPhoneLexiconType_Token_CollectionPtr &
     */
    virtual void SetToken(const Mp7JrsPhoneLexiconType_Token_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get numOfOriginalEntries attribute.
<br>
     * (Inherited from Mp7JrsLexiconType)
     * @return unsigned
     */
    virtual unsigned GetnumOfOriginalEntries() const;

    /*
     * Get numOfOriginalEntries attribute validity information.
     * (Inherited from Mp7JrsLexiconType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnumOfOriginalEntries() const;

    /*
     * Set numOfOriginalEntries attribute.
<br>
     * (Inherited from Mp7JrsLexiconType)
     * @param item unsigned
     */
    virtual void SetnumOfOriginalEntries(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate numOfOriginalEntries attribute.
     * (Inherited from Mp7JrsLexiconType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenumOfOriginalEntries();

    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPhoneLexiconType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPhoneLexiconType();

protected:
    Mp7JrsPhoneLexiconType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsphoneticAlphabetType::Enumeration m_phoneticAlphabet;
    bool m_phoneticAlphabet_Exist;
    Mp7JrsphoneticAlphabetType::Enumeration m_phoneticAlphabet_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsLexiconType > m_Base;

    Mp7JrsPhoneLexiconType_Token_CollectionPtr m_Token;

// no includefile for extension defined 
// file Mp7JrsPhoneLexiconType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1591MP7JRSPHONELEXICONTYPE_H

