/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1597MP7JRSPHONETICTRANSCRIPTIONLEXICONTYPE_H
#define _1597MP7JRSPHONETICTRANSCRIPTIONLEXICONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPhoneticTranscriptionLexiconTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsphoneticAlphabetType.h"
class IMp7JrsHeaderType;
class IMp7JrsPhoneticTranscriptionLexiconType;
class IMp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType > Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPhoneticTranscriptionLexiconType> Mp7JrsPhoneticTranscriptionLexiconPtr;

/** 
 * Generated interface IMp7JrsPhoneticTranscriptionLexiconType for class Mp7JrsPhoneticTranscriptionLexiconType<br>
 * Located at: mds-2001.xsd, line 2062<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPhoneticTranscriptionLexiconType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsPhoneticTranscriptionLexiconType();
    virtual ~IMp7JrsPhoneticTranscriptionLexiconType();
    /**
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

    /**
     * Get phoneticAlphabet attribute.
     * @return Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual Mp7JrsphoneticAlphabetType::Enumeration GetphoneticAlphabet() const = 0;

    /**
     * Get phoneticAlphabet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticAlphabet() const = 0;

    /**
     * Set phoneticAlphabet attribute.
     * @param item Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual void SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate phoneticAlphabet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticAlphabet() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Token element.
     * @return Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr
     */
    virtual Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr GetToken() const = 0;

    /**
     * Set Token element.
     * @param item const Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr &
     */
    virtual void SetToken(const Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPhoneticTranscriptionLexiconType<br>
 * Located at: mds-2001.xsd, line 2062<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in mds-2001.xsd, line 2062.<br>
 */
class MP7JRS_EXPORT Mp7JrsPhoneticTranscriptionLexiconType :
        public IMp7JrsPhoneticTranscriptionLexiconType
{
    friend class Mp7JrsPhoneticTranscriptionLexiconTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPhoneticTranscriptionLexiconType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
    /*
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

    /*
     * Get phoneticAlphabet attribute.
     * @return Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual Mp7JrsphoneticAlphabetType::Enumeration GetphoneticAlphabet() const;

    /*
     * Get phoneticAlphabet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticAlphabet() const;

    /*
     * Set phoneticAlphabet attribute.
     * @param item Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual void SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate phoneticAlphabet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticAlphabet();

        /* @name Sequence

         */
        //@{
    /*
     * Get Token element.
     * @return Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr
     */
    virtual Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr GetToken() const;

    /*
     * Set Token element.
     * @param item const Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr &
     */
    virtual void SetToken(const Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPhoneticTranscriptionLexiconType();

protected:
    Mp7JrsPhoneticTranscriptionLexiconType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_lang;
    bool m_lang_Exist;
    Mp7JrsphoneticAlphabetType::Enumeration m_phoneticAlphabet;
    bool m_phoneticAlphabet_Exist;
    Mp7JrsphoneticAlphabetType::Enumeration m_phoneticAlphabet_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr m_Token;

// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1597MP7JRSPHONETICTRANSCRIPTIONLEXICONTYPE_H

