/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1611MP7JRSPLACETYPE_ADMINISTRATIVEUNIT_LOCALTYPE_H
#define _1611MP7JRSPLACETYPE_ADMINISTRATIVEUNIT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPlaceType_AdministrativeUnit_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPlaceType_AdministrativeUnit_LocalType_ExtInclude.h


class IMp7JrsPlaceType_AdministrativeUnit_LocalType;
typedef Mp7JrsPtr< IMp7JrsPlaceType_AdministrativeUnit_LocalType> Mp7JrsPlaceType_AdministrativeUnit_LocalPtr;

/** 
 * Generated interface IMp7JrsPlaceType_AdministrativeUnit_LocalType for class Mp7JrsPlaceType_AdministrativeUnit_LocalType<br>
 * Located at: mds-2001.xsd, line 1889<br>
 * Classified: Class<br>
 * Derived from: string (String)<br>
 * Derived from: string (String)<br>
 */
class MP7JRS_EXPORT IMp7JrsPlaceType_AdministrativeUnit_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPlaceType_AdministrativeUnit_LocalType();
    virtual ~IMp7JrsPlaceType_AdministrativeUnit_LocalType();
    /**
     * Sets the content of Mp7JrsPlaceType_AdministrativeUnit_LocalType     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsPlaceType_AdministrativeUnit_LocalType 
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const = 0;

    /**
     * Get type attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
     * @param item XMLCh *
     */
    virtual void Settype(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

// no includefile for extension defined 
// file Mp7JrsPlaceType_AdministrativeUnit_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPlaceType_AdministrativeUnit_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPlaceType_AdministrativeUnit_LocalType<br>
 * Located at: mds-2001.xsd, line 1889<br>
 * Classified: Class<br>
 * Derived from: string (String)<br>
 * Derived from: string (String)<br>
 * Defined in mds-2001.xsd, line 1889.<br>
 */
class MP7JRS_EXPORT Mp7JrsPlaceType_AdministrativeUnit_LocalType :
        public IMp7JrsPlaceType_AdministrativeUnit_LocalType
{
    friend class Mp7JrsPlaceType_AdministrativeUnit_LocalTypeFactory; // constructs objects

public:
    /*
     * Sets the content of Mp7JrsPlaceType_AdministrativeUnit_LocalType     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsPlaceType_AdministrativeUnit_LocalType 
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const;

    /*
     * Get type attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Gettype() const;

    /*
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
     * @param item XMLCh *
     */
    virtual void Settype(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPlaceType_AdministrativeUnit_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPlaceType_AdministrativeUnit_LocalType();

protected:
    Mp7JrsPlaceType_AdministrativeUnit_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_type;
    bool m_type_Exist;

    // Base String
    XMLCh * m_Base;


// no includefile for extension defined 
// file Mp7JrsPlaceType_AdministrativeUnit_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1611MP7JRSPLACETYPE_ADMINISTRATIVEUNIT_LOCALTYPE_H

