/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1615MP7JRSPLACETYPE_GEOGRAPHICPOSITION_LOCALTYPE_H
#define _1615MP7JRSPLACETYPE_GEOGRAPHICPOSITION_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPlaceType_GeographicPosition_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPlaceType_GeographicPosition_LocalType_ExtInclude.h


class IMp7JrsGeographicPointType;
class IMp7JrsPlaceType_GeographicPosition_LocalType;
typedef Mp7JrsPtr< IMp7JrsGeographicPointType > Mp7JrsGeographicPointPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_GeographicPosition_LocalType> Mp7JrsPlaceType_GeographicPosition_LocalPtr;

/** 
 * Generated interface IMp7JrsPlaceType_GeographicPosition_LocalType for class Mp7JrsPlaceType_GeographicPosition_LocalType<br>
 * Located at: mds-2001.xsd, line 1879<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsPlaceType_GeographicPosition_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPlaceType_GeographicPosition_LocalType();
    virtual ~IMp7JrsPlaceType_GeographicPosition_LocalType();
    /**
     * Get datum attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getdatum() const = 0;

    /**
     * Get datum attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdatum() const = 0;

    /**
     * Set datum attribute.
     * @param item XMLCh *
     */
    virtual void Setdatum(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate datum attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedatum() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Point element.
     * @return Mp7JrsGeographicPointPtr
     */
    virtual Mp7JrsGeographicPointPtr GetPoint() const = 0;

    /**
     * Set Point element.
     * @param item const Mp7JrsGeographicPointPtr &
     */
    virtual void SetPoint(const Mp7JrsGeographicPointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPlaceType_GeographicPosition_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPlaceType_GeographicPosition_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPlaceType_GeographicPosition_LocalType<br>
 * Located at: mds-2001.xsd, line 1879<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1879.<br>
 */
class MP7JRS_EXPORT Mp7JrsPlaceType_GeographicPosition_LocalType :
        public IMp7JrsPlaceType_GeographicPosition_LocalType
{
    friend class Mp7JrsPlaceType_GeographicPosition_LocalTypeFactory; // constructs objects

public:
    /*
     * Get datum attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getdatum() const;

    /*
     * Get datum attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdatum() const;

    /*
     * Set datum attribute.
     * @param item XMLCh *
     */
    virtual void Setdatum(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate datum attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedatum();

        /* @name Sequence

         */
        //@{
    /*
     * Get Point element.
     * @return Mp7JrsGeographicPointPtr
     */
    virtual Mp7JrsGeographicPointPtr GetPoint() const;

    /*
     * Set Point element.
     * @param item const Mp7JrsGeographicPointPtr &
     */
    virtual void SetPoint(const Mp7JrsGeographicPointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPlaceType_GeographicPosition_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPlaceType_GeographicPosition_LocalType();

protected:
    Mp7JrsPlaceType_GeographicPosition_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_datum;
    bool m_datum_Exist;


    Mp7JrsGeographicPointPtr m_Point;

// no includefile for extension defined 
// file Mp7JrsPlaceType_GeographicPosition_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1615MP7JRSPLACETYPE_GEOGRAPHICPOSITION_LOCALTYPE_H

