/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1623MP7JRSPLACETYPE_POSTALADDRESS_LOCALTYPE_H
#define _1623MP7JRSPLACETYPE_POSTALADDRESS_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPlaceType_PostalAddress_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtInclude.h


class IMp7JrsPlaceType_PostalAddress_AddressLine_CollectionType;
class IMp7JrsPlaceType_PostalAddress_LocalType;
class IMp7JrsTextualType;
typedef Mp7JrsPtr< IMp7JrsPlaceType_PostalAddress_AddressLine_CollectionType > Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_PostalAddress_LocalType> Mp7JrsPlaceType_PostalAddress_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;

/** 
 * Generated interface IMp7JrsPlaceType_PostalAddress_LocalType for class Mp7JrsPlaceType_PostalAddress_LocalType<br>
 * Located at: mds-2001.xsd, line 1898<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsPlaceType_PostalAddress_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPlaceType_PostalAddress_LocalType();
    virtual ~IMp7JrsPlaceType_PostalAddress_LocalType();
    /**
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get AddressLine element.
     * @return Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr
     */
    virtual Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr GetAddressLine() const = 0;

    /**
     * Set AddressLine element.
     * @param item const Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr &
     */
    virtual void SetAddressLine(const Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PostingIdentifier element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetPostingIdentifier() const = 0;

    virtual bool IsValidPostingIdentifier() const = 0;

    /**
     * Set PostingIdentifier element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetPostingIdentifier(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PostingIdentifier element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePostingIdentifier() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPlaceType_PostalAddress_LocalType<br>
 * Located at: mds-2001.xsd, line 1898<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1898.<br>
 */
class MP7JRS_EXPORT Mp7JrsPlaceType_PostalAddress_LocalType :
        public IMp7JrsPlaceType_PostalAddress_LocalType
{
    friend class Mp7JrsPlaceType_PostalAddress_LocalTypeFactory; // constructs objects

public:
    /*
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get AddressLine element.
     * @return Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr
     */
    virtual Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr GetAddressLine() const;

    /*
     * Set AddressLine element.
     * @param item const Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr &
     */
    virtual void SetAddressLine(const Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PostingIdentifier element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetPostingIdentifier() const;

    virtual bool IsValidPostingIdentifier() const;

    /*
     * Set PostingIdentifier element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetPostingIdentifier(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PostingIdentifier element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePostingIdentifier();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPlaceType_PostalAddress_LocalType();

protected:
    Mp7JrsPlaceType_PostalAddress_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_lang;
    bool m_lang_Exist;


    Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr m_AddressLine;
    Mp7JrsTextualPtr m_PostingIdentifier;
    bool m_PostingIdentifier_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsPlaceType_PostalAddress_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1623MP7JRSPLACETYPE_POSTALADDRESS_LOCALTYPE_H

