/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1627MP7JRSPOINTOFVIEWTYPE_H
#define _1627MP7JRSPOINTOFVIEWTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPointOfViewTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPointOfViewType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDType;
class IMp7JrsPointOfViewType;
class IMp7JrsPointOfViewType_Importance_CollectionType;
class IMp7JrsTextAnnotationType;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsPointOfViewType_Importance_CollectionType > Mp7JrsPointOfViewType_Importance_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPointOfViewType> Mp7JrsPointOfViewPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;

/** 
 * Generated interface IMp7JrsPointOfViewType for class Mp7JrsPointOfViewType<br>
 * Located at: mds-2001.xsd, line 3089<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPointOfViewType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsPointOfViewType();
    virtual ~IMp7JrsPointOfViewType();
    /**
     * Get viewpoint attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getviewpoint() const = 0;

    /**
     * Set viewpoint attribute.
     * @param item XMLCh *
     */
    virtual void Setviewpoint(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get SupplementalInformation element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetSupplementalInformation() const = 0;

    virtual bool IsValidSupplementalInformation() const = 0;

    /**
     * Set SupplementalInformation element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetSupplementalInformation(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SupplementalInformation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSupplementalInformation() = 0;

    /**
     * Get Importance element.
     * @return Mp7JrsPointOfViewType_Importance_CollectionPtr
     */
    virtual Mp7JrsPointOfViewType_Importance_CollectionPtr GetImportance() const = 0;

    /**
     * Set Importance element.
     * @param item const Mp7JrsPointOfViewType_Importance_CollectionPtr &
     */
    virtual void SetImportance(const Mp7JrsPointOfViewType_Importance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPointOfViewType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPointOfViewType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPointOfViewType<br>
 * Located at: mds-2001.xsd, line 3089<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 3089.<br>
 */
class MP7JRS_EXPORT Mp7JrsPointOfViewType :
        public IMp7JrsPointOfViewType
{
    friend class Mp7JrsPointOfViewTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPointOfViewType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
    /*
     * Get viewpoint attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getviewpoint() const;

    /*
     * Set viewpoint attribute.
     * @param item XMLCh *
     */
    virtual void Setviewpoint(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get SupplementalInformation element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetSupplementalInformation() const;

    virtual bool IsValidSupplementalInformation() const;

    /*
     * Set SupplementalInformation element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetSupplementalInformation(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SupplementalInformation element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSupplementalInformation();

    /*
     * Get Importance element.
     * @return Mp7JrsPointOfViewType_Importance_CollectionPtr
     */
    virtual Mp7JrsPointOfViewType_Importance_CollectionPtr GetImportance() const;

    /*
     * Set Importance element.
     * @param item const Mp7JrsPointOfViewType_Importance_CollectionPtr &
     */
    virtual void SetImportance(const Mp7JrsPointOfViewType_Importance_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPointOfViewType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPointOfViewType();

protected:
    Mp7JrsPointOfViewType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_viewpoint;

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsTextAnnotationPtr m_SupplementalInformation;
    bool m_SupplementalInformation_Exist; // For optional elements 
    Mp7JrsPointOfViewType_Importance_CollectionPtr m_Importance;

// no includefile for extension defined 
// file Mp7JrsPointOfViewType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1627MP7JRSPOINTOFVIEWTYPE_H

