/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1633MP7JRSPOISSONDISTRIBUTIONTYPE_H
#define _1633MP7JRSPOISSONDISTRIBUTIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPoissonDistributionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPoissonDistributionType_ExtInclude.h


#include "Mp7JrsDiscreteDistributionType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsModelType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsProbabilityDistributionType.h"
#include "Mp7JrsProbabilityModelType.h"
class IMp7JrsDiscreteDistributionType;
class IMp7JrsDoubleMatrixType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsPoissonDistributionType;
class IMp7JrsProbabilityDistributionType_Cumulant_CollectionType;
class IMp7JrsProbabilityDistributionType_Moment_CollectionType;
class IMp7JrsxPathRefType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDiscreteDistributionType > Mp7JrsDiscreteDistributionPtr;
typedef Mp7JrsPtr< IMp7JrsDoubleMatrixType > Mp7JrsDoubleMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsPoissonDistributionType> Mp7JrsPoissonDistributionPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Cumulant_CollectionType > Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Moment_CollectionType > Mp7JrsProbabilityDistributionType_Moment_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsPoissonDistributionType for class Mp7JrsPoissonDistributionType<br>
 * Located at: mds-2001.xsd, line 5489<br>
 * Classified: Class<br>
 * Derived from: DiscreteDistributionType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPoissonDistributionType 
 :
        public IMp7JrsDiscreteDistributionType
{
public:
    // TODO: make these protected?
    IMp7JrsPoissonDistributionType();
    virtual ~IMp7JrsPoissonDistributionType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Lambda element.
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetLambda() const = 0;

    /**
     * Set Lambda element.
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetLambda(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return unsigned
     */
    virtual unsigned Getdim() const = 0;

    /**
     * Get dim attribute validity information.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const = 0;

    /**
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item unsigned
     */
    virtual void Setdim(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dim attribute.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Mean element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMean() const = 0;

    virtual bool IsValidMean() const = 0;

    /**
     * Set Mean element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMean(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Mean element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMean() = 0;

    /**
     * Get Variance element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetVariance() const = 0;

    virtual bool IsValidVariance() const = 0;

    /**
     * Set Variance element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetVariance(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Variance element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVariance() = 0;

    /**
     * Get Min element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMin() const = 0;

    virtual bool IsValidMin() const = 0;

    /**
     * Set Min element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMin(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Min element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMin() = 0;

    /**
     * Get Max element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMax() const = 0;

    virtual bool IsValidMax() const = 0;

    /**
     * Set Max element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMax(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Max element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMax() = 0;

    /**
     * Get Mode element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMode() const = 0;

    virtual bool IsValidMode() const = 0;

    /**
     * Set Mode element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMode(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Mode element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMode() = 0;

    /**
     * Get Median element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMedian() const = 0;

    virtual bool IsValidMedian() const = 0;

    /**
     * Set Median element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMedian(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Median element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMedian() = 0;

    /**
     * Get Moment element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsProbabilityDistributionType_Moment_CollectionPtr
     */
    virtual Mp7JrsProbabilityDistributionType_Moment_CollectionPtr GetMoment() const = 0;

    /**
     * Set Moment element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsProbabilityDistributionType_Moment_CollectionPtr &
     */
    virtual void SetMoment(const Mp7JrsProbabilityDistributionType_Moment_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Cumulant element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr
     */
    virtual Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr GetCumulant() const = 0;

    /**
     * Set Cumulant element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr &
     */
    virtual void SetCumulant(const Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const = 0;

    /**
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence() = 0;

    /**
     * Get reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const = 0;

    /**
     * Get reliability attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const = 0;

    /**
     * Set reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate reliability attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability() = 0;

    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPoissonDistributionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPoissonDistributionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPoissonDistributionType<br>
 * Located at: mds-2001.xsd, line 5489<br>
 * Classified: Class<br>
 * Derived from: DiscreteDistributionType (Class)<br>
 * Defined in mds-2001.xsd, line 5489.<br>
 */
class MP7JRS_EXPORT Mp7JrsPoissonDistributionType :
        public IMp7JrsPoissonDistributionType
{
    friend class Mp7JrsPoissonDistributionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPoissonDistributionType
     
     * @return Mp7JrsPtr< Mp7JrsDiscreteDistributionType >
     */
    virtual Mp7JrsPtr< Mp7JrsDiscreteDistributionType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Lambda element.
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetLambda() const;

    /*
     * Set Lambda element.
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetLambda(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return unsigned
     */
    virtual unsigned Getdim() const;

    /*
     * Get dim attribute validity information.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const;

    /*
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item unsigned
     */
    virtual void Setdim(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dim attribute.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim();

        /* @name Sequence

         */
        //@{
    /*
     * Get Mean element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMean() const;

    virtual bool IsValidMean() const;

    /*
     * Set Mean element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMean(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Mean element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMean();

    /*
     * Get Variance element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetVariance() const;

    virtual bool IsValidVariance() const;

    /*
     * Set Variance element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetVariance(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Variance element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVariance();

    /*
     * Get Min element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMin() const;

    virtual bool IsValidMin() const;

    /*
     * Set Min element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMin(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Min element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMin();

    /*
     * Get Max element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMax() const;

    virtual bool IsValidMax() const;

    /*
     * Set Max element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMax(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Max element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMax();

    /*
     * Get Mode element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMode() const;

    virtual bool IsValidMode() const;

    /*
     * Set Mode element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMode(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Mode element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMode();

    /*
     * Get Median element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsDoubleMatrixPtr
     */
    virtual Mp7JrsDoubleMatrixPtr GetMedian() const;

    virtual bool IsValidMedian() const;

    /*
     * Set Median element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsDoubleMatrixPtr &
     */
    virtual void SetMedian(const Mp7JrsDoubleMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Median element.
     * (Inherited from Mp7JrsProbabilityDistributionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMedian();

    /*
     * Get Moment element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsProbabilityDistributionType_Moment_CollectionPtr
     */
    virtual Mp7JrsProbabilityDistributionType_Moment_CollectionPtr GetMoment() const;

    /*
     * Set Moment element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsProbabilityDistributionType_Moment_CollectionPtr &
     */
    virtual void SetMoment(const Mp7JrsProbabilityDistributionType_Moment_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Cumulant element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @return Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr
     */
    virtual Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr GetCumulant() const;

    /*
     * Set Cumulant element.
<br>
     * (Inherited from Mp7JrsProbabilityDistributionType)
     * @param item const Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr &
     */
    virtual void SetCumulant(const Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

    /*
     * Get reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const;

    /*
     * Get reliability attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const;

    /*
     * Set reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate reliability attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability();

    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPoissonDistributionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPoissonDistributionType();

protected:
    Mp7JrsPoissonDistributionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDiscreteDistributionType > m_Base;

    Mp7JrsDoubleMatrixPtr m_Lambda;

// no includefile for extension defined 
// file Mp7JrsPoissonDistributionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1633MP7JRSPOISSONDISTRIBUTIONTYPE_H

