/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1637MP7JRSPREFERENCECONDITIONTYPE_H
#define _1637MP7JRSPREFERENCECONDITIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPreferenceConditionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDType;
class IMp7JrsPlaceType;
class IMp7JrsPreferenceConditionType;
class IMp7JrsPreferenceConditionType_Time_CollectionType;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_CollectionType > Mp7JrsPreferenceConditionType_Time_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType> Mp7JrsPreferenceConditionPtr;

/** 
 * Generated interface IMp7JrsPreferenceConditionType for class Mp7JrsPreferenceConditionType<br>
 * Located at: mds-2001.xsd, line 5807<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsPreferenceConditionType 
 :
        public IMp7JrsDType
{
public:
    // TODO: make these protected?
    IMp7JrsPreferenceConditionType();
    virtual ~IMp7JrsPreferenceConditionType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Place element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetPlace() const = 0;

    virtual bool IsValidPlace() const = 0;

    /**
     * Set Place element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetPlace(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Place element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePlace() = 0;

    /**
     * Get Time element.
     * @return Mp7JrsPreferenceConditionType_Time_CollectionPtr
     */
    virtual Mp7JrsPreferenceConditionType_Time_CollectionPtr GetTime() const = 0;

    /**
     * Set Time element.
     * @param item const Mp7JrsPreferenceConditionType_Time_CollectionPtr &
     */
    virtual void SetTime(const Mp7JrsPreferenceConditionType_Time_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPreferenceConditionType<br>
 * Located at: mds-2001.xsd, line 5807<br>
 * Classified: Class<br>
 * Derived from: DType (Class)<br>
 * Defined in mds-2001.xsd, line 5807.<br>
 */
class MP7JRS_EXPORT Mp7JrsPreferenceConditionType :
        public IMp7JrsPreferenceConditionType
{
    friend class Mp7JrsPreferenceConditionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsPreferenceConditionType
     
     * @return Mp7JrsPtr< Mp7JrsDType >
     */
    virtual Mp7JrsPtr< Mp7JrsDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Place element.
     * @return Mp7JrsPlacePtr
     */
    virtual Mp7JrsPlacePtr GetPlace() const;

    virtual bool IsValidPlace() const;

    /*
     * Set Place element.
     * @param item const Mp7JrsPlacePtr &
     */
    virtual void SetPlace(const Mp7JrsPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Place element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePlace();

    /*
     * Get Time element.
     * @return Mp7JrsPreferenceConditionType_Time_CollectionPtr
     */
    virtual Mp7JrsPreferenceConditionType_Time_CollectionPtr GetTime() const;

    /*
     * Set Time element.
     * @param item const Mp7JrsPreferenceConditionType_Time_CollectionPtr &
     */
    virtual void SetTime(const Mp7JrsPreferenceConditionType_Time_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPreferenceConditionType();

protected:
    Mp7JrsPreferenceConditionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsDType > m_Base;

    Mp7JrsPlacePtr m_Place;
    bool m_Place_Exist; // For optional elements 
    Mp7JrsPreferenceConditionType_Time_CollectionPtr m_Time;

// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1637MP7JRSPREFERENCECONDITIONTYPE_H

