/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1663MP7JRSPROBABILITYDISTRIBUTIONTYPE_CUMULANT_VALUE_LOCALTYPE_H
#define _1663MP7JRSPROBABILITYDISTRIBUTIONTYPE_CUMULANT_VALUE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType_ExtInclude.h


#include "Mp7JrsDoubleMatrixType.h"
#include "Mp7JrsdoubleVector.h"
class IMp7Jrsdim_LocalType;
class IMp7JrsDoubleMatrixType;
class IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType;
typedef Mp7JrsPtr< IMp7Jrsdim_LocalType > Mp7Jrsdim_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsDoubleMatrixType > Mp7JrsDoubleMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType> Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalPtr;

/** 
 * Generated interface IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType for class Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType<br>
 * Located at: mds-2001.xsd, line 5427<br>
 * Classified: Class<br>
 * Derived from: DoubleMatrixType (Class)<br>
 * Derived from: DoubleMatrixType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType 
 :
        public IMp7JrsDoubleMatrixType
{
public:
    // TODO: make these protected?
    IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType();
    virtual ~IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType();
    /**
     * Retrieves the base collection of Mp7JrsDoubleMatrixType
     * (Inherited from Mp7JrsDoubleMatrixType)
     
     * @return Mp7JrsPtr< Mp7JrsdoubleVector >
     */
    virtual Mp7JrsPtr< Mp7JrsdoubleVector > GetBaseCollection() const = 0;


    /**
     * Initializes the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param maxElems Number of elements for which memory is initially allocated.
     */
    virtual void Initialize(unsigned int maxElems) = 0;


    /**
     * Adds a new element to the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toAdd Element to be added. Default element type: double
     */
    virtual void addElement(const double &toAdd, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Sets the element at the given position in the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toSet New value of the element. Default element type: double
     * @param setAt Position of the element which shall be set.
     */
    virtual void setElementAt(const double &toSet, unsigned int setAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Inserts the element at the given position in the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toInsert Element to be inserted. Default element type: double
     * @param insertAt Position where the element will be inserted.
     */
    virtual void insertElementAt(const double &toInsert, unsigned int insertAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Removes all elements from the collection.
     * (Inherited from Mp7JrsdoubleVector)
     */
    virtual void removeAllElements(Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Removes the specified element from the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param removeAt Position of the element to be removed. 
     */
    virtual void removeElementAt(unsigned int removeAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;



    /**
     * Check whether the collection contains the given element.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toCheck Element to be checked for. Default element type: double
     * @return True if the element is in the collection, false otherwise.
     */
    virtual bool containsElement(const double &toCheck) = 0;


    /**
     * Get the current capacity of the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @return The number of elements for which memory has been allocated.
     */
    virtual unsigned int curCapacity() const = 0;


    /**
     * Gets a constant pointer to the element at the given position.
     * (Inherited from Mp7JrsdoubleVector)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: double.
     */
    virtual const double elementAt(unsigned int getAt) const = 0;


    /**
     * Gets a pointer to the element at the given position.
     * (Inherited from Mp7JrsdoubleVector)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: double.
     */
    virtual double elementAt(unsigned int getAt) = 0;


    /**
     * Get the size of the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @return The current number of elements in the collection.
     */
    virtual unsigned int size() const = 0;


    /**
     * Allocate additional memory for the speciifed number of elements.
     * (Inherited from Mp7JrsdoubleVector)
     * @param length Number of elements to allocate memory for.
     */
    virtual void ensureExtraCapacity(unsigned int length) = 0;


    // JRS: addition to Xerces collection
    /**
     * Get the position of the specified element. 
     * (Inherited from Mp7JrsdoubleVector)
     * @param toCheck Element to be found in the collection. Default element type: double
     * @return The position of the specified element or -1 if the element has not been found.
     */
    virtual int elementIndexOf(const double &toCheck) const = 0;


    /**
     * Get order attribute.
     * @return unsigned
     */
    virtual unsigned Getorder() const = 0;

    /**
     * Set order attribute.
     * @param item unsigned
     */
    virtual void Setorder(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsDoubleMatrixType)
     * @return Mp7Jrsdim_LocalPtr
     */
    virtual Mp7Jrsdim_LocalPtr Getdim() const = 0;

    /**
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsDoubleMatrixType)
     * @param item const Mp7Jrsdim_LocalPtr &
     */
    virtual void Setdim(const Mp7Jrsdim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

// no includefile for extension defined 
// file Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType<br>
 * Located at: mds-2001.xsd, line 5427<br>
 * Classified: Class<br>
 * Derived from: DoubleMatrixType (Class)<br>
 * Derived from: DoubleMatrixType (Class)<br>
 * Defined in mds-2001.xsd, line 5427.<br>
 */
class MP7JRS_EXPORT Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType :
        public IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType
{
    friend class Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsDoubleMatrixType >
     */
    virtual Mp7JrsPtr< Mp7JrsDoubleMatrixType > GetBase() const;
    /*
     * Retrieves the base collection of Mp7JrsDoubleMatrixType
     * (Inherited from Mp7JrsDoubleMatrixType)
     
     * @return Mp7JrsPtr< Mp7JrsdoubleVector >
     */
    virtual Mp7JrsPtr< Mp7JrsdoubleVector > GetBaseCollection() const;


    /*
     * Initializes the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param maxElems Number of elements for which memory is initially allocated.
     */
    virtual void Initialize(unsigned int maxElems);


    /*
     * Adds a new element to the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toAdd Element to be added. Default element type: double
     */
    virtual void addElement(const double &toAdd, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Sets the element at the given position in the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toSet New value of the element. Default element type: double
     * @param setAt Position of the element which shall be set.
     */
    virtual void setElementAt(const double &toSet, unsigned int setAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Inserts the element at the given position in the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toInsert Element to be inserted. Default element type: double
     * @param insertAt Position where the element will be inserted.
     */
    virtual void insertElementAt(const double &toInsert, unsigned int insertAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Removes all elements from the collection.
     * (Inherited from Mp7JrsdoubleVector)
     */
    virtual void removeAllElements(Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Removes the specified element from the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @param removeAt Position of the element to be removed. 
     */
    virtual void removeElementAt(unsigned int removeAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);



    /*
     * Check whether the collection contains the given element.
     * (Inherited from Mp7JrsdoubleVector)
     * @param toCheck Element to be checked for. Default element type: double
     * @return True if the element is in the collection, false otherwise.
     */
    virtual bool containsElement(const double &toCheck);


    /*
     * Get the current capacity of the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @return The number of elements for which memory has been allocated.
     */
    virtual unsigned int curCapacity() const;


    /*
     * Gets a constant pointer to the element at the given position.
     * (Inherited from Mp7JrsdoubleVector)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: double.
     */
    virtual const double elementAt(unsigned int getAt) const;


    /*
     * Gets a pointer to the element at the given position.
     * (Inherited from Mp7JrsdoubleVector)
     * @param Position of the element to be retrieved.
     * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: double.
     */
    virtual double elementAt(unsigned int getAt);


    /*
     * Get the size of the collection.
     * (Inherited from Mp7JrsdoubleVector)
     * @return The current number of elements in the collection.
     */
    virtual unsigned int size() const;


    /*
     * Allocate additional memory for the speciifed number of elements.
     * (Inherited from Mp7JrsdoubleVector)
     * @param length Number of elements to allocate memory for.
     */
    virtual void ensureExtraCapacity(unsigned int length);


    // JRS: addition to Xerces collection
    /*
     * Get the position of the specified element. 
     * (Inherited from Mp7JrsdoubleVector)
     * @param toCheck Element to be found in the collection. Default element type: double
     * @return The position of the specified element or -1 if the element has not been found.
     */
    virtual int elementIndexOf(const double &toCheck) const;


    /*
     * Get order attribute.
     * @return unsigned
     */
    virtual unsigned Getorder() const;

    /*
     * Set order attribute.
     * @param item unsigned
     */
    virtual void Setorder(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsDoubleMatrixType)
     * @return Mp7Jrsdim_LocalPtr
     */
    virtual Mp7Jrsdim_LocalPtr Getdim() const;

    /*
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsDoubleMatrixType)
     * @param item const Mp7Jrsdim_LocalPtr &
     */
    virtual void Setdim(const Mp7Jrsdim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType();

protected:
    Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_order;

    // Base Class
    Mp7JrsPtr< Mp7JrsDoubleMatrixType > m_Base;


// no includefile for extension defined 
// file Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1663MP7JRSPROBABILITYDISTRIBUTIONTYPE_CUMULANT_VALUE_LOCALTYPE_H

