/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1677MP7JRSPROBABILITYMODELCLASSTYPE_LOCALTYPE_H
#define _1677MP7JRSPROBABILITYMODELCLASSTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsProbabilityModelClassType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsProbabilityModelClassType_LocalType_ExtInclude.h


class IMp7JrsDescriptorModelType;
class IMp7JrsProbabilityModelClassType_LocalType;
class IMp7JrsProbabilityModelType;
typedef Mp7JrsPtr< IMp7JrsDescriptorModelType > Mp7JrsDescriptorModelPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityModelClassType_LocalType> Mp7JrsProbabilityModelClassType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityModelType > Mp7JrsProbabilityModelPtr;

/** 
 * Generated interface IMp7JrsProbabilityModelClassType_LocalType for class Mp7JrsProbabilityModelClassType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsProbabilityModelClassType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsProbabilityModelClassType_LocalType();
    virtual ~IMp7JrsProbabilityModelClassType_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get DescriptorModel element.
     * @return Mp7JrsDescriptorModelPtr
     */
    virtual Mp7JrsDescriptorModelPtr GetDescriptorModel() const = 0;

    /**
     * Set DescriptorModel element.
     * @param item const Mp7JrsDescriptorModelPtr &
     */
    virtual void SetDescriptorModel(const Mp7JrsDescriptorModelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ProbabilityModel element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetProbabilityModel() const = 0;

    /**
     * Set ProbabilityModel element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    virtual void SetProbabilityModel(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsProbabilityModelClassType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsProbabilityModelClassType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsProbabilityModelClassType_LocalType<br>
 * Defined in mds-2001.xsd, line 5733.<br>
 */
class MP7JRS_EXPORT Mp7JrsProbabilityModelClassType_LocalType :
        public IMp7JrsProbabilityModelClassType_LocalType
{
    friend class Mp7JrsProbabilityModelClassType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get DescriptorModel element.
     * @return Mp7JrsDescriptorModelPtr
     */
    virtual Mp7JrsDescriptorModelPtr GetDescriptorModel() const;

    /*
     * Set DescriptorModel element.
     * @param item const Mp7JrsDescriptorModelPtr &
     */
    virtual void SetDescriptorModel(const Mp7JrsDescriptorModelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ProbabilityModel element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetProbabilityModel() const;

    /*
     * Set ProbabilityModel element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    virtual void SetProbabilityModel(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsProbabilityModelClassType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsProbabilityModelClassType_LocalType();

protected:
    Mp7JrsProbabilityModelClassType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsDescriptorModelPtr m_DescriptorModel;
    Mp7JrsPtr< Mp7JrsNode > m_ProbabilityModel;

// no includefile for extension defined 
// file Mp7JrsProbabilityModelClassType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1677MP7JRSPROBABILITYMODELCLASSTYPE_LOCALTYPE_H

