/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1679MP7JRSPROBABILITYMODELTYPE_H
#define _1679MP7JRSPROBABILITYMODELTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsProbabilityModelTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsProbabilityModelType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsModelType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsModelType;
class IMp7JrsProbabilityModelType;
class IMp7JrsxPathRefType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsModelType > Mp7JrsModelPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityModelType> Mp7JrsProbabilityModelPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsProbabilityModelType for class Mp7JrsProbabilityModelType<br>
 * Located at: mds-2001.xsd, line 5388<br>
 * Classified: Class<br>
 * Derived from: ModelType (Class)<br>
 * Abstract class <br>
 */
class MP7JRS_EXPORT IMp7JrsProbabilityModelType 
 :
        public IMp7JrsModelType
{
public:
    // TODO: make these protected?
    IMp7JrsProbabilityModelType();
    virtual ~IMp7JrsProbabilityModelType();
    /**
     * @if Show_All_Abstract_Class_Members
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     * @endif
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool Existconfidence() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     * @endif
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void Invalidateconfidence() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     * @endif
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get reliability attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool Existreliability() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     * @endif
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate reliability attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void Invalidatereliability() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     * @endif
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool Existid() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     * @endif
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void Invalidateid() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     * @endif
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     * @endif
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     * @endif
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     * @endif
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     * @endif
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     * @endif
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     * @endif
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     * @endif
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * @if Show_All_Abstract_Class_Members
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     * @endif
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     * @endif
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsProbabilityModelType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsProbabilityModelType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsProbabilityModelType<br>
 * Located at: mds-2001.xsd, line 5388<br>
 * Classified: Class<br>
 * Derived from: ModelType (Class)<br>
 * Abstract class <br>
 * Defined in mds-2001.xsd, line 5388.<br>
 */
class MP7JRS_EXPORT Mp7JrsProbabilityModelType :
        public IMp7JrsProbabilityModelType
{
    friend class Mp7JrsProbabilityModelTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsProbabilityModelType
     
     * @return Mp7JrsPtr< Mp7JrsModelType >
     */
    virtual Mp7JrsPtr< Mp7JrsModelType > GetBase() const;
    /*
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

    /*
     * Get reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const;

    /*
     * Get reliability attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const;

    /*
     * Set reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate reliability attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability();

    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsProbabilityModelType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsProbabilityModelType();

protected:
    Mp7JrsProbabilityModelType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsModelType > m_Base;


// no includefile for extension defined 
// file Mp7JrsProbabilityModelType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1679MP7JRSPROBABILITYMODELTYPE_H

