/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1699MP7JRSREGIONLOCATORTYPE_H
#define _1699MP7JRSREGIONLOCATORTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsRegionLocatorTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_ExtInclude.h


class IMp7JrsRegionLocatorType;
class IMp7JrsRegionLocatorType_Box_CollectionType;
class IMp7JrsRegionLocatorType_CoordRef_LocalType;
class IMp7JrsRegionLocatorType_Polygon_CollectionType;
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Box_CollectionType > Mp7JrsRegionLocatorType_Box_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_CoordRef_LocalType > Mp7JrsRegionLocatorType_CoordRef_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Polygon_CollectionType > Mp7JrsRegionLocatorType_Polygon_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType> Mp7JrsRegionLocatorPtr;

/** 
 * Generated interface IMp7JrsRegionLocatorType for class Mp7JrsRegionLocatorType<br>
 * Located at: visual-2001.xsd, line 1122<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsRegionLocatorType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsRegionLocatorType();
    virtual ~IMp7JrsRegionLocatorType();
        /** @name Sequence

         */
        //@{
    /**
     * Get CoordRef element.
     * @return Mp7JrsRegionLocatorType_CoordRef_LocalPtr
     */
    virtual Mp7JrsRegionLocatorType_CoordRef_LocalPtr GetCoordRef() const = 0;

    virtual bool IsValidCoordRef() const = 0;

    /**
     * Set CoordRef element.
     * @param item const Mp7JrsRegionLocatorType_CoordRef_LocalPtr &
     */
    virtual void SetCoordRef(const Mp7JrsRegionLocatorType_CoordRef_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate CoordRef element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCoordRef() = 0;

    /**
     * Get Box element.
     * @return Mp7JrsRegionLocatorType_Box_CollectionPtr
     */
    virtual Mp7JrsRegionLocatorType_Box_CollectionPtr GetBox() const = 0;

    /**
     * Set Box element.
     * @param item const Mp7JrsRegionLocatorType_Box_CollectionPtr &
     */
    virtual void SetBox(const Mp7JrsRegionLocatorType_Box_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Polygon element.
     * @return Mp7JrsRegionLocatorType_Polygon_CollectionPtr
     */
    virtual Mp7JrsRegionLocatorType_Polygon_CollectionPtr GetPolygon() const = 0;

    /**
     * Set Polygon element.
     * @param item const Mp7JrsRegionLocatorType_Polygon_CollectionPtr &
     */
    virtual void SetPolygon(const Mp7JrsRegionLocatorType_Polygon_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsRegionLocatorType<br>
 * Located at: visual-2001.xsd, line 1122<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 1122.<br>
 */
class MP7JRS_EXPORT Mp7JrsRegionLocatorType :
        public IMp7JrsRegionLocatorType
{
    friend class Mp7JrsRegionLocatorTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get CoordRef element.
     * @return Mp7JrsRegionLocatorType_CoordRef_LocalPtr
     */
    virtual Mp7JrsRegionLocatorType_CoordRef_LocalPtr GetCoordRef() const;

    virtual bool IsValidCoordRef() const;

    /*
     * Set CoordRef element.
     * @param item const Mp7JrsRegionLocatorType_CoordRef_LocalPtr &
     */
    virtual void SetCoordRef(const Mp7JrsRegionLocatorType_CoordRef_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate CoordRef element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateCoordRef();

    /*
     * Get Box element.
     * @return Mp7JrsRegionLocatorType_Box_CollectionPtr
     */
    virtual Mp7JrsRegionLocatorType_Box_CollectionPtr GetBox() const;

    /*
     * Set Box element.
     * @param item const Mp7JrsRegionLocatorType_Box_CollectionPtr &
     */
    virtual void SetBox(const Mp7JrsRegionLocatorType_Box_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Polygon element.
     * @return Mp7JrsRegionLocatorType_Polygon_CollectionPtr
     */
    virtual Mp7JrsRegionLocatorType_Polygon_CollectionPtr GetPolygon() const;

    /*
     * Set Polygon element.
     * @param item const Mp7JrsRegionLocatorType_Polygon_CollectionPtr &
     */
    virtual void SetPolygon(const Mp7JrsRegionLocatorType_Polygon_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsRegionLocatorType();

protected:
    Mp7JrsRegionLocatorType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsRegionLocatorType_CoordRef_LocalPtr m_CoordRef;
    bool m_CoordRef_Exist; // For optional elements 
    Mp7JrsRegionLocatorType_Box_CollectionPtr m_Box;
    Mp7JrsRegionLocatorType_Polygon_CollectionPtr m_Polygon;

// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1699MP7JRSREGIONLOCATORTYPE_H

