/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1709MP7JRSREGIONLOCATORTYPE_POLYGON_LOCALTYPE_H
#define _1709MP7JRSREGIONLOCATORTYPE_POLYGON_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsRegionLocatorType_Polygon_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtInclude.h


class IMp7JrsIntegerMatrixType;
class IMp7JrsRegionLocatorType_Polygon_LocalType;
typedef Mp7JrsPtr< IMp7JrsIntegerMatrixType > Mp7JrsIntegerMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Polygon_LocalType> Mp7JrsRegionLocatorType_Polygon_LocalPtr;

/** 
 * Generated interface IMp7JrsRegionLocatorType_Polygon_LocalType for class Mp7JrsRegionLocatorType_Polygon_LocalType<br>
 * Located at: visual-2001.xsd, line 1140<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsRegionLocatorType_Polygon_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsRegionLocatorType_Polygon_LocalType();
    virtual ~IMp7JrsRegionLocatorType_Polygon_LocalType();
    /**
     * Get unlocatedRegion attribute.
     * @return bool
     */
    virtual bool GetunlocatedRegion() const = 0;

    /**
     * Get unlocatedRegion attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistunlocatedRegion() const = 0;

    /**
     * Set unlocatedRegion attribute.
     * @param item bool
     */
    virtual void SetunlocatedRegion(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate unlocatedRegion attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateunlocatedRegion() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Coords element.
     * @return Mp7JrsIntegerMatrixPtr
     */
    virtual Mp7JrsIntegerMatrixPtr GetCoords() const = 0;

    /**
     * Set Coords element.
     * @param item const Mp7JrsIntegerMatrixPtr &
     */
    virtual void SetCoords(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsRegionLocatorType_Polygon_LocalType<br>
 * Located at: visual-2001.xsd, line 1140<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 1140.<br>
 */
class MP7JRS_EXPORT Mp7JrsRegionLocatorType_Polygon_LocalType :
        public IMp7JrsRegionLocatorType_Polygon_LocalType
{
    friend class Mp7JrsRegionLocatorType_Polygon_LocalTypeFactory; // constructs objects

public:
    /*
     * Get unlocatedRegion attribute.
     * @return bool
     */
    virtual bool GetunlocatedRegion() const;

    /*
     * Get unlocatedRegion attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistunlocatedRegion() const;

    /*
     * Set unlocatedRegion attribute.
     * @param item bool
     */
    virtual void SetunlocatedRegion(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate unlocatedRegion attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateunlocatedRegion();

        /* @name Sequence

         */
        //@{
    /*
     * Get Coords element.
     * @return Mp7JrsIntegerMatrixPtr
     */
    virtual Mp7JrsIntegerMatrixPtr GetCoords() const;

    /*
     * Set Coords element.
     * @param item const Mp7JrsIntegerMatrixPtr &
     */
    virtual void SetCoords(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsRegionLocatorType_Polygon_LocalType();

protected:
    Mp7JrsRegionLocatorType_Polygon_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_unlocatedRegion;
    bool m_unlocatedRegion_Exist;
    bool m_unlocatedRegion_Default;


    Mp7JrsIntegerMatrixPtr m_Coords;

// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1709MP7JRSREGIONLOCATORTYPE_POLYGON_LOCALTYPE_H

