/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1711MP7JRSREGIONSHAPETYPE_H
#define _1711MP7JRSREGIONSHAPETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsRegionShapeTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsRegionShapeType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsRegionShapeType;
class IMp7JrsRegionShapeType_MagnitudeOfART_LocalType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsRegionShapeType_MagnitudeOfART_LocalType > Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsRegionShapeType> Mp7JrsRegionShapePtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsRegionShapeType for class Mp7JrsRegionShapeType<br>
 * Located at: visual-2001.xsd, line 754<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsRegionShapeType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsRegionShapeType();
    virtual ~IMp7JrsRegionShapeType();
        /** @name Sequence

         */
        //@{
    /**
     * Get MagnitudeOfART element.
     * @return Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr
     */
    virtual Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr GetMagnitudeOfART() const = 0;

    /**
     * Set MagnitudeOfART element.
     * @param item const Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr &
     */
    virtual void SetMagnitudeOfART(const Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsRegionShapeType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsRegionShapeType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsRegionShapeType<br>
 * Located at: visual-2001.xsd, line 754<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 754.<br>
 */
class MP7JRS_EXPORT Mp7JrsRegionShapeType :
        public IMp7JrsRegionShapeType
{
    friend class Mp7JrsRegionShapeTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsRegionShapeType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get MagnitudeOfART element.
     * @return Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr
     */
    virtual Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr GetMagnitudeOfART() const;

    /*
     * Set MagnitudeOfART element.
     * @param item const Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr &
     */
    virtual void SetMagnitudeOfART(const Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsRegionShapeType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsRegionShapeType();

protected:
    Mp7JrsRegionShapeType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr m_MagnitudeOfART;

// no includefile for extension defined 
// file Mp7JrsRegionShapeType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1711MP7JRSREGIONSHAPETYPE_H

