/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

#ifndef _1720MP7JRSREGULARVISUALTIMESERIESTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H
#define _1720MP7JRSREGULARVISUALTIMESERIESTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionTypeFactory<br>
 * for class Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionType:<br>
 * Located at: visual-2001.xsd, line 72<br>
 * Abstract item type: VisualDType<br>
 * Possible classes:<br>
 * \li CameraMotionType (Class)<br>
 * \li ColorLayoutType (Class)<br>
 * \li ColorStructureType (Class)<br>
 * \li ContourShapeType (Class)<br>
 * \li DominantColorType (Class)<br>
 * \li EdgeHistogramType (Class)<br>
 * \li FaceRecognitionType (Class)<br>
 * \li GoFGoPColorType (Class)<br>
 * \li HomogeneousTextureType (Class)<br>
 * \li MotionActivityType (Class)<br>
 * \li MotionTrajectoryType (Class)<br>
 * \li ParametricMotionType (Class)<br>
 * \li RegionShapeType (Class)<br>
 * \li ScalableColorType (Class)<br>
 * \li Shape3DType (Class)<br>
 * \li TextureBrowsingType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionTypeFactory();
    virtual ~Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1720MP7JRSREGULARVISUALTIMESERIESTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H
