/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1749MP7JRSSCALABLESERIESTYPE_SCALING_LOCALTYPE_H
#define _1749MP7JRSSCALABLESERIESTYPE_SCALING_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsScalableSeriesType_Scaling_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsScalableSeriesType_Scaling_LocalType_ExtInclude.h


class IMp7JrsScalableSeriesType_Scaling_LocalType;
typedef Mp7JrsPtr< IMp7JrsScalableSeriesType_Scaling_LocalType> Mp7JrsScalableSeriesType_Scaling_LocalPtr;

/** 
 * Generated interface IMp7JrsScalableSeriesType_Scaling_LocalType for class Mp7JrsScalableSeriesType_Scaling_LocalType<br>
 * Located at: audio-2001.xsd, line 260<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsScalableSeriesType_Scaling_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsScalableSeriesType_Scaling_LocalType();
    virtual ~IMp7JrsScalableSeriesType_Scaling_LocalType();
    /**
     * Get ratio attribute.
     * @return unsigned
     */
    virtual unsigned Getratio() const = 0;

    /**
     * Set ratio attribute.
     * @param item unsigned
     */
    virtual void Setratio(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get numOfElements attribute.
     * @return unsigned
     */
    virtual unsigned GetnumOfElements() const = 0;

    /**
     * Set numOfElements attribute.
     * @param item unsigned
     */
    virtual void SetnumOfElements(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

// no includefile for extension defined 
// file Mp7JrsScalableSeriesType_Scaling_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsScalableSeriesType_Scaling_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsScalableSeriesType_Scaling_LocalType<br>
 * Located at: audio-2001.xsd, line 260<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 260.<br>
 */
class MP7JRS_EXPORT Mp7JrsScalableSeriesType_Scaling_LocalType :
        public IMp7JrsScalableSeriesType_Scaling_LocalType
{
    friend class Mp7JrsScalableSeriesType_Scaling_LocalTypeFactory; // constructs objects

public:
    /*
     * Get ratio attribute.
     * @return unsigned
     */
    virtual unsigned Getratio() const;

    /*
     * Set ratio attribute.
     * @param item unsigned
     */
    virtual void Setratio(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get numOfElements attribute.
     * @return unsigned
     */
    virtual unsigned GetnumOfElements() const;

    /*
     * Set numOfElements attribute.
     * @param item unsigned
     */
    virtual void SetnumOfElements(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsScalableSeriesType_Scaling_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsScalableSeriesType_Scaling_LocalType();

protected:
    Mp7JrsScalableSeriesType_Scaling_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_ratio;
    unsigned m_numOfElements;



// no includefile for extension defined 
// file Mp7JrsScalableSeriesType_Scaling_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1749MP7JRSSCALABLESERIESTYPE_SCALING_LOCALTYPE_H

