/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1765MP7JRSSEGMENTCOLLECTIONTYPE_LOCALTYPE_H
#define _1765MP7JRSSEGMENTCOLLECTIONTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSegmentCollectionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType_ExtInclude.h


class IMp7JrsReferenceType;
class IMp7JrsSegmentCollectionType_LocalType;
class IMp7JrsSegmentType;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSegmentCollectionType_LocalType> Mp7JrsSegmentCollectionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType > Mp7JrsSegmentPtr;

/** 
 * Generated interface IMp7JrsSegmentCollectionType_LocalType for class Mp7JrsSegmentCollectionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSegmentCollectionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSegmentCollectionType_LocalType();
    virtual ~IMp7JrsSegmentCollectionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Segment element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetSegment() const = 0;

    /**
     * Set Segment element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual void SetSegment(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSegmentRef() const = 0;

    /**
     * Set SegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSegmentCollectionType_LocalType<br>
 * Defined in mds-2001.xsd, line 5265.<br>
 */
class MP7JRS_EXPORT Mp7JrsSegmentCollectionType_LocalType :
        public IMp7JrsSegmentCollectionType_LocalType
{
    friend class Mp7JrsSegmentCollectionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Segment element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetSegment() const;

    /*
     * Set Segment element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual void SetSegment(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSegmentRef() const;

    /*
     * Set SegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSegmentCollectionType_LocalType();

protected:
    Mp7JrsSegmentCollectionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPtr< Mp7JrsNode > m_Segment;
    Mp7JrsReferencePtr m_SegmentRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSegmentCollectionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1765MP7JRSSEGMENTCOLLECTIONTYPE_LOCALTYPE_H

