/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1785MP7JRSSEGMENTTYPE_TEXTANNOTATION_LOCALTYPE_H
#define _1785MP7JRSSEGMENTTYPE_TEXTANNOTATION_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSegmentType_TextAnnotation_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSegmentType_TextAnnotation_LocalType_ExtInclude.h


#include "Mp7JrsTextAnnotationType.h"
class IMp7JrsSegmentType_TextAnnotation_LocalType;
class IMp7JrsSegmentType_TextAnnotation_type_LocalType2;
class IMp7JrsTextAnnotationType;
class IMp7JrsTextAnnotationType_CollectionType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_LocalType> Mp7JrsSegmentType_TextAnnotation_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_type_LocalType2 > Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType_CollectionType > Mp7JrsTextAnnotationType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsSegmentType_TextAnnotation_LocalType for class Mp7JrsSegmentType_TextAnnotation_LocalType<br>
 * Located at: mds-2001.xsd, line 2887<br>
 * Classified: Class<br>
 * Derived from: TextAnnotationType (Class)<br>
 * Derived from: TextAnnotationType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSegmentType_TextAnnotation_LocalType 
 :
        public IMp7JrsTextAnnotationType
{
public:
    // TODO: make these protected?
    IMp7JrsSegmentType_TextAnnotation_LocalType();
    virtual ~IMp7JrsSegmentType_TextAnnotation_LocalType();
    /**
     * Get type attribute.
     * @return Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr
     */
    virtual Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
     * @param item const Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr &
     */
    virtual void Settype(const Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

    /**
     * Get relevance attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getrelevance() const = 0;

    /**
     * Get relevance attribute validity information.
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrelevance() const = 0;

    /**
     * Set relevance attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setrelevance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate relevance attribute.
     * (Inherited from Mp7JrsTextAnnotationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterelevance() = 0;

    /**
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const = 0;

    /**
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsTextAnnotationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence() = 0;

    /**
     * Get lang attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     * (Inherited from Mp7JrsTextAnnotationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get TextAnnotationType_LocalType element.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return Mp7JrsTextAnnotationType_CollectionPtr
     */
    virtual Mp7JrsTextAnnotationType_CollectionPtr GetTextAnnotationType_LocalType() const = 0;

    /**
     * Set TextAnnotationType_LocalType element.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item const Mp7JrsTextAnnotationType_CollectionPtr &
     */
    virtual void SetTextAnnotationType_LocalType(const Mp7JrsTextAnnotationType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSegmentType_TextAnnotation_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSegmentType_TextAnnotation_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSegmentType_TextAnnotation_LocalType<br>
 * Located at: mds-2001.xsd, line 2887<br>
 * Classified: Class<br>
 * Derived from: TextAnnotationType (Class)<br>
 * Derived from: TextAnnotationType (Class)<br>
 * Defined in mds-2001.xsd, line 2887.<br>
 */
class MP7JRS_EXPORT Mp7JrsSegmentType_TextAnnotation_LocalType :
        public IMp7JrsSegmentType_TextAnnotation_LocalType
{
    friend class Mp7JrsSegmentType_TextAnnotation_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSegmentType_TextAnnotation_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsTextAnnotationType >
     */
    virtual Mp7JrsPtr< Mp7JrsTextAnnotationType > GetBase() const;
    /*
     * Get type attribute.
     * @return Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr
     */
    virtual Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr Gettype() const;

    /*
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
     * @param item const Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr &
     */
    virtual void Settype(const Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();

    /*
     * Get relevance attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getrelevance() const;

    /*
     * Get relevance attribute validity information.
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrelevance() const;

    /*
     * Set relevance attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setrelevance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate relevance attribute.
     * (Inherited from Mp7JrsTextAnnotationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterelevance();

    /*
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsTextAnnotationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

    /*
     * Get lang attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     * (Inherited from Mp7JrsTextAnnotationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get TextAnnotationType_LocalType element.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @return Mp7JrsTextAnnotationType_CollectionPtr
     */
    virtual Mp7JrsTextAnnotationType_CollectionPtr GetTextAnnotationType_LocalType() const;

    /*
     * Set TextAnnotationType_LocalType element.
<br>
     * (Inherited from Mp7JrsTextAnnotationType)
     * @param item const Mp7JrsTextAnnotationType_CollectionPtr &
     */
    virtual void SetTextAnnotationType_LocalType(const Mp7JrsTextAnnotationType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSegmentType_TextAnnotation_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSegmentType_TextAnnotation_LocalType();

protected:
    Mp7JrsSegmentType_TextAnnotation_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr m_type;
    bool m_type_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsTextAnnotationType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSegmentType_TextAnnotation_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1785MP7JRSSEGMENTTYPE_TEXTANNOTATION_LOCALTYPE_H

