/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1841MP7JRSSEMANTICPLACETYPE_SEMANTICPLACEINTERVAL_LOCALTYPE_H
#define _1841MP7JRSSEMANTICPLACETYPE_SEMANTICPLACEINTERVAL_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType_ExtInclude.h


class IMp7JrsExtentType;
class IMp7JrsPositionType;
class IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType;
typedef Mp7JrsPtr< IMp7JrsExtentType > Mp7JrsExtentPtr;
typedef Mp7JrsPtr< IMp7JrsPositionType > Mp7JrsPositionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType> Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalPtr;

/** 
 * Generated interface IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType for class Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType<br>
 * Located at: mds-2001.xsd, line 4391<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType();
    virtual ~IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Position element.
     * @return Mp7JrsPositionPtr
     */
    virtual Mp7JrsPositionPtr GetPosition() const = 0;

    virtual bool IsValidPosition() const = 0;

    /**
     * Set Position element.
     * @param item const Mp7JrsPositionPtr &
     */
    virtual void SetPosition(const Mp7JrsPositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Position element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePosition() = 0;

    /**
     * Get Extent element.
     * @return Mp7JrsExtentPtr
     */
    virtual Mp7JrsExtentPtr GetExtent() const = 0;

    virtual bool IsValidExtent() const = 0;

    /**
     * Set Extent element.
     * @param item const Mp7JrsExtentPtr &
     */
    virtual void SetExtent(const Mp7JrsExtentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Extent element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateExtent() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType<br>
 * Located at: mds-2001.xsd, line 4391<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 4391.<br>
 */
class MP7JRS_EXPORT Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType :
        public IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType
{
    friend class Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Position element.
     * @return Mp7JrsPositionPtr
     */
    virtual Mp7JrsPositionPtr GetPosition() const;

    virtual bool IsValidPosition() const;

    /*
     * Set Position element.
     * @param item const Mp7JrsPositionPtr &
     */
    virtual void SetPosition(const Mp7JrsPositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Position element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePosition();

    /*
     * Get Extent element.
     * @return Mp7JrsExtentPtr
     */
    virtual Mp7JrsExtentPtr GetExtent() const;

    virtual bool IsValidExtent() const;

    /*
     * Set Extent element.
     * @param item const Mp7JrsExtentPtr &
     */
    virtual void SetExtent(const Mp7JrsExtentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Extent element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateExtent();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType();

protected:
    Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsPositionPtr m_Position;
    bool m_Position_Exist; // For optional elements 
    Mp7JrsExtentPtr m_Extent;
    bool m_Extent_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1841MP7JRSSEMANTICPLACETYPE_SEMANTICPLACEINTERVAL_LOCALTYPE_H

