/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1843MP7JRSSEMANTICSTATETYPE_H
#define _1843MP7JRSSEMANTICSTATETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSemanticStateTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsSemanticBaseType.h"
class IMp7JrsAbstractionLevelType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsSemanticBaseType;
class IMp7JrsSemanticBaseType_Label_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType;
class IMp7JrsSemanticBaseType_Property_CollectionType;
class IMp7JrsSemanticBaseType_Relation_CollectionType;
class IMp7JrsSemanticPlaceType;
class IMp7JrsSemanticStateType;
class IMp7JrsSemanticStateType_AttributeValuePair_CollectionType0;
class IMp7JrsSemanticTimeType;
class IMp7JrsTextAnnotationType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAbstractionLevelType > Mp7JrsAbstractionLevelPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType > Mp7JrsSemanticBasePtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Label_CollectionType > Mp7JrsSemanticBaseType_Label_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Property_CollectionType > Mp7JrsSemanticBaseType_Property_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Relation_CollectionType > Mp7JrsSemanticBaseType_Relation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticPlaceType > Mp7JrsSemanticPlacePtr;
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_CollectionType0 > Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsSemanticStateType> Mp7JrsSemanticStatePtr;
typedef Mp7JrsPtr< IMp7JrsSemanticTimeType > Mp7JrsSemanticTimePtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsSemanticStateType for class Mp7JrsSemanticStateType<br>
 * Located at: mds-2001.xsd, line 4352<br>
 * Classified: Class<br>
 * Derived from: SemanticBaseType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSemanticStateType 
 :
        public IMp7JrsSemanticBaseType
{
public:
    // TODO: make these protected?
    IMp7JrsSemanticStateType();
    virtual ~IMp7JrsSemanticStateType();
        /** @name Sequence

         */
        //@{
    /**
     * Get AttributeValuePair element.
     * @return Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr
     */
    virtual Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr GetAttributeValuePair() const = 0;

    /**
     * Set AttributeValuePair element.
     * @param item const Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr &
     */
    virtual void SetAttributeValuePair(const Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SemanticTime element.
     * @return Mp7JrsSemanticTimePtr
     */
    virtual Mp7JrsSemanticTimePtr GetSemanticTime() const = 0;

    virtual bool IsValidSemanticTime() const = 0;

    /**
     * Set SemanticTime element.
     * @param item const Mp7JrsSemanticTimePtr &
     */
    virtual void SetSemanticTime(const Mp7JrsSemanticTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SemanticTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSemanticTime() = 0;

    /**
     * Get SemanticPlace element.
     * @return Mp7JrsSemanticPlacePtr
     */
    virtual Mp7JrsSemanticPlacePtr GetSemanticPlace() const = 0;

    virtual bool IsValidSemanticPlace() const = 0;

    /**
     * Set SemanticPlace element.
     * @param item const Mp7JrsSemanticPlacePtr &
     */
    virtual void SetSemanticPlace(const Mp7JrsSemanticPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SemanticPlace element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSemanticPlace() = 0;

        //@}
        /** @name Sequence

         */
        //@{
    /**
     * Get AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsAbstractionLevelPtr
     */
    virtual Mp7JrsAbstractionLevelPtr GetAbstractionLevel() const = 0;

    virtual bool IsValidAbstractionLevel() const = 0;

    /**
     * Set AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsAbstractionLevelPtr &
     */
    virtual void SetAbstractionLevel(const Mp7JrsAbstractionLevelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate AbstractionLevel element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAbstractionLevel() = 0;

    /**
     * Get Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Label_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Label_CollectionPtr GetLabel() const = 0;

    /**
     * Set Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Label_CollectionPtr &
     */
    virtual void SetLabel(const Mp7JrsSemanticBaseType_Label_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetDefinition() const = 0;

    virtual bool IsValidDefinition() const = 0;

    /**
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetDefinition(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Definition element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDefinition() = 0;

    /**
     * Get Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Property_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Property_CollectionPtr GetProperty() const = 0;

    /**
     * Set Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Property_CollectionPtr &
     */
    virtual void SetProperty(const Mp7JrsSemanticBaseType_Property_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr GetMediaOccurrence() const = 0;

    /**
     * Set MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr &
     */
    virtual void SetMediaOccurrence(const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Relation_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Relation_CollectionPtr GetRelation() const = 0;

    /**
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Relation_CollectionPtr &
     */
    virtual void SetRelation(const Mp7JrsSemanticBaseType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSemanticStateType<br>
 * Located at: mds-2001.xsd, line 4352<br>
 * Classified: Class<br>
 * Derived from: SemanticBaseType (Class)<br>
 * Defined in mds-2001.xsd, line 4352.<br>
 */
class MP7JRS_EXPORT Mp7JrsSemanticStateType :
        public IMp7JrsSemanticStateType
{
    friend class Mp7JrsSemanticStateTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSemanticStateType
     
     * @return Mp7JrsPtr< Mp7JrsSemanticBaseType >
     */
    virtual Mp7JrsPtr< Mp7JrsSemanticBaseType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get AttributeValuePair element.
     * @return Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr
     */
    virtual Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr GetAttributeValuePair() const;

    /*
     * Set AttributeValuePair element.
     * @param item const Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr &
     */
    virtual void SetAttributeValuePair(const Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SemanticTime element.
     * @return Mp7JrsSemanticTimePtr
     */
    virtual Mp7JrsSemanticTimePtr GetSemanticTime() const;

    virtual bool IsValidSemanticTime() const;

    /*
     * Set SemanticTime element.
     * @param item const Mp7JrsSemanticTimePtr &
     */
    virtual void SetSemanticTime(const Mp7JrsSemanticTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SemanticTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSemanticTime();

    /*
     * Get SemanticPlace element.
     * @return Mp7JrsSemanticPlacePtr
     */
    virtual Mp7JrsSemanticPlacePtr GetSemanticPlace() const;

    virtual bool IsValidSemanticPlace() const;

    /*
     * Set SemanticPlace element.
     * @param item const Mp7JrsSemanticPlacePtr &
     */
    virtual void SetSemanticPlace(const Mp7JrsSemanticPlacePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SemanticPlace element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSemanticPlace();

        //@}
        /* @name Sequence

         */
        //@{
    /*
     * Get AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsAbstractionLevelPtr
     */
    virtual Mp7JrsAbstractionLevelPtr GetAbstractionLevel() const;

    virtual bool IsValidAbstractionLevel() const;

    /*
     * Set AbstractionLevel element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsAbstractionLevelPtr &
     */
    virtual void SetAbstractionLevel(const Mp7JrsAbstractionLevelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate AbstractionLevel element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAbstractionLevel();

    /*
     * Get Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Label_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Label_CollectionPtr GetLabel() const;

    /*
     * Set Label element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Label_CollectionPtr &
     */
    virtual void SetLabel(const Mp7JrsSemanticBaseType_Label_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetDefinition() const;

    virtual bool IsValidDefinition() const;

    /*
     * Set Definition element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetDefinition(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Definition element.
     * (Inherited from Mp7JrsSemanticBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDefinition();

    /*
     * Get Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Property_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Property_CollectionPtr GetProperty() const;

    /*
     * Set Property element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Property_CollectionPtr &
     */
    virtual void SetProperty(const Mp7JrsSemanticBaseType_Property_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr GetMediaOccurrence() const;

    /*
     * Set MediaOccurrence element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr &
     */
    virtual void SetMediaOccurrence(const Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @return Mp7JrsSemanticBaseType_Relation_CollectionPtr
     */
    virtual Mp7JrsSemanticBaseType_Relation_CollectionPtr GetRelation() const;

    /*
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSemanticBaseType)
     * @param item const Mp7JrsSemanticBaseType_Relation_CollectionPtr &
     */
    virtual void SetRelation(const Mp7JrsSemanticBaseType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSemanticStateType();

protected:
    Mp7JrsSemanticStateType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsSemanticBaseType > m_Base;

    Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr m_AttributeValuePair;
    Mp7JrsSemanticTimePtr m_SemanticTime;
    bool m_SemanticTime_Exist; // For optional elements 
    Mp7JrsSemanticPlacePtr m_SemanticPlace;
    bool m_SemanticPlace_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1843MP7JRSSEMANTICSTATETYPE_H

