/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1849MP7JRSSEMANTICSTATETYPE_ATTRIBUTEVALUEPAIR_LOCALTYPE_H
#define _1849MP7JRSSEMANTICSTATETYPE_ATTRIBUTEVALUEPAIR_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtInclude.h


class IMp7JrsControlledTermUseType;
class IMp7JrsDType;
class IMp7JrsFloatMatrixType;
class IMp7JrsIntegerMatrixType;
class IMp7JrsSemanticStateType_AttributeValuePair_LocalType;
class IMp7JrsTextAnnotationType;
class IMp7JrsTextualType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;
typedef Mp7JrsPtr< IMp7JrsFloatMatrixType > Mp7JrsFloatMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsIntegerMatrixType > Mp7JrsIntegerMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_LocalType> Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;

/** 
 * Generated interface IMp7JrsSemanticStateType_AttributeValuePair_LocalType for class Mp7JrsSemanticStateType_AttributeValuePair_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSemanticStateType_AttributeValuePair_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSemanticStateType_AttributeValuePair_LocalType();
    virtual ~IMp7JrsSemanticStateType_AttributeValuePair_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get BooleanValue element.
     * @return bool
     */
    virtual bool GetBooleanValue() const = 0;

    /**
     * Set BooleanValue element.
     * @param item bool
     */
    virtual void SetBooleanValue(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get IntegerValue element.
     * @return int
     */
    virtual int GetIntegerValue() const = 0;

    /**
     * Set IntegerValue element.
     * @param item int
     */
    virtual void SetIntegerValue(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get FloatValue element.
     * @return float
     */
    virtual float GetFloatValue() const = 0;

    /**
     * Set FloatValue element.
     * @param item float
     */
    virtual void SetFloatValue(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get IntegerMatrixValue element.
     * @return Mp7JrsIntegerMatrixPtr
     */
    virtual Mp7JrsIntegerMatrixPtr GetIntegerMatrixValue() const = 0;

    /**
     * Set IntegerMatrixValue element.
     * @param item const Mp7JrsIntegerMatrixPtr &
     */
    virtual void SetIntegerMatrixValue(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get FloatMatrixValue element.
     * @return Mp7JrsFloatMatrixPtr
     */
    virtual Mp7JrsFloatMatrixPtr GetFloatMatrixValue() const = 0;

    /**
     * Set FloatMatrixValue element.
     * @param item const Mp7JrsFloatMatrixPtr &
     */
    virtual void SetFloatMatrixValue(const Mp7JrsFloatMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TextValue element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetTextValue() const = 0;

    /**
     * Set TextValue element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetTextValue(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TextAnnotationValue element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetTextAnnotationValue() const = 0;

    /**
     * Set TextAnnotationValue element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetTextAnnotationValue(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ControlledTermUseValue element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetControlledTermUseValue() const = 0;

    /**
     * Set ControlledTermUseValue element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetControlledTermUseValue(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DescriptorValue element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioSummaryComponentPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorSamplingPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMatchingHintPtr</li>
     * <li>IMp7JrsMediaFormatPtr</li>
     * <li>IMp7JrsMediaIdentificationPtr</li>
     * <li>IMp7JrsMediaQualityPtr</li>
     * <li>IMp7JrsMediaSpaceMaskPtr</li>
     * <li>IMp7JrsMediaTranscodingHintsPtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsOrderedGroupDataSetMaskPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsPointOfViewPtr</li>
     * <li>IMp7JrsPreferenceConditionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsSceneGraphMaskPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSourcePreferencesType_MediaFormat_LocalPtr</li>
     * <li>IMp7JrsSpatialMaskPtr</li>
     * <li>IMp7JrsSpatioTemporalMaskPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * <li>IMp7JrsTemporalMaskPtr</li>
     * <li>IMp7JrsTextualSummaryComponentPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * <li>IMp7JrsVisualSummaryComponentPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetDescriptorValue() const = 0;

    /**
     * Set DescriptorValue element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioSummaryComponentPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorSamplingPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMatchingHintPtr</li>
     * <li>IMp7JrsMediaFormatPtr</li>
     * <li>IMp7JrsMediaIdentificationPtr</li>
     * <li>IMp7JrsMediaQualityPtr</li>
     * <li>IMp7JrsMediaSpaceMaskPtr</li>
     * <li>IMp7JrsMediaTranscodingHintsPtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsOrderedGroupDataSetMaskPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsPointOfViewPtr</li>
     * <li>IMp7JrsPreferenceConditionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsSceneGraphMaskPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSourcePreferencesType_MediaFormat_LocalPtr</li>
     * <li>IMp7JrsSpatialMaskPtr</li>
     * <li>IMp7JrsSpatioTemporalMaskPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * <li>IMp7JrsTemporalMaskPtr</li>
     * <li>IMp7JrsTextualSummaryComponentPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * <li>IMp7JrsVisualSummaryComponentPtr</li>
     * </ul>
     */
    virtual void SetDescriptorValue(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSemanticStateType_AttributeValuePair_LocalType<br>
 * Defined in mds-2001.xsd, line 4361.<br>
 */
class MP7JRS_EXPORT Mp7JrsSemanticStateType_AttributeValuePair_LocalType :
        public IMp7JrsSemanticStateType_AttributeValuePair_LocalType
{
    friend class Mp7JrsSemanticStateType_AttributeValuePair_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get BooleanValue element.
     * @return bool
     */
    virtual bool GetBooleanValue() const;

    /*
     * Set BooleanValue element.
     * @param item bool
     */
    virtual void SetBooleanValue(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get IntegerValue element.
     * @return int
     */
    virtual int GetIntegerValue() const;

    /*
     * Set IntegerValue element.
     * @param item int
     */
    virtual void SetIntegerValue(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get FloatValue element.
     * @return float
     */
    virtual float GetFloatValue() const;

    /*
     * Set FloatValue element.
     * @param item float
     */
    virtual void SetFloatValue(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get IntegerMatrixValue element.
     * @return Mp7JrsIntegerMatrixPtr
     */
    virtual Mp7JrsIntegerMatrixPtr GetIntegerMatrixValue() const;

    /*
     * Set IntegerMatrixValue element.
     * @param item const Mp7JrsIntegerMatrixPtr &
     */
    virtual void SetIntegerMatrixValue(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get FloatMatrixValue element.
     * @return Mp7JrsFloatMatrixPtr
     */
    virtual Mp7JrsFloatMatrixPtr GetFloatMatrixValue() const;

    /*
     * Set FloatMatrixValue element.
     * @param item const Mp7JrsFloatMatrixPtr &
     */
    virtual void SetFloatMatrixValue(const Mp7JrsFloatMatrixPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TextValue element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetTextValue() const;

    /*
     * Set TextValue element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetTextValue(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TextAnnotationValue element.
     * @return Mp7JrsTextAnnotationPtr
     */
    virtual Mp7JrsTextAnnotationPtr GetTextAnnotationValue() const;

    /*
     * Set TextAnnotationValue element.
     * @param item const Mp7JrsTextAnnotationPtr &
     */
    virtual void SetTextAnnotationValue(const Mp7JrsTextAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ControlledTermUseValue element.
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetControlledTermUseValue() const;

    /*
     * Set ControlledTermUseValue element.
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetControlledTermUseValue(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DescriptorValue element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioSummaryComponentPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorSamplingPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMatchingHintPtr</li>
     * <li>IMp7JrsMediaFormatPtr</li>
     * <li>IMp7JrsMediaIdentificationPtr</li>
     * <li>IMp7JrsMediaQualityPtr</li>
     * <li>IMp7JrsMediaSpaceMaskPtr</li>
     * <li>IMp7JrsMediaTranscodingHintsPtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsOrderedGroupDataSetMaskPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsPointOfViewPtr</li>
     * <li>IMp7JrsPreferenceConditionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsSceneGraphMaskPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSourcePreferencesType_MediaFormat_LocalPtr</li>
     * <li>IMp7JrsSpatialMaskPtr</li>
     * <li>IMp7JrsSpatioTemporalMaskPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * <li>IMp7JrsTemporalMaskPtr</li>
     * <li>IMp7JrsTextualSummaryComponentPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * <li>IMp7JrsVisualSummaryComponentPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetDescriptorValue() const;

    /*
     * Set DescriptorValue element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioSummaryComponentPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorSamplingPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMatchingHintPtr</li>
     * <li>IMp7JrsMediaFormatPtr</li>
     * <li>IMp7JrsMediaIdentificationPtr</li>
     * <li>IMp7JrsMediaQualityPtr</li>
     * <li>IMp7JrsMediaSpaceMaskPtr</li>
     * <li>IMp7JrsMediaTranscodingHintsPtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsOrderedGroupDataSetMaskPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsPointOfViewPtr</li>
     * <li>IMp7JrsPreferenceConditionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsSceneGraphMaskPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSourcePreferencesType_MediaFormat_LocalPtr</li>
     * <li>IMp7JrsSpatialMaskPtr</li>
     * <li>IMp7JrsSpatioTemporalMaskPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * <li>IMp7JrsTemporalMaskPtr</li>
     * <li>IMp7JrsTextualSummaryComponentPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * <li>IMp7JrsVisualSummaryComponentPtr</li>
     * </ul>
     */
    virtual void SetDescriptorValue(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSemanticStateType_AttributeValuePair_LocalType();

protected:
    Mp7JrsSemanticStateType_AttributeValuePair_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    bool m_BooleanValue;
    bool m_BooleanValue_Valid; // For value types in unions
    int m_IntegerValue;
    bool m_IntegerValue_Valid; // For value types in unions
    float m_FloatValue;
    bool m_FloatValue_Valid; // For value types in unions
    Mp7JrsIntegerMatrixPtr m_IntegerMatrixValue;
    Mp7JrsFloatMatrixPtr m_FloatMatrixValue;
    Mp7JrsTextualPtr m_TextValue;
    Mp7JrsTextAnnotationPtr m_TextAnnotationValue;
    Mp7JrsControlledTermUsePtr m_ControlledTermUseValue;
    Mp7JrsPtr< Mp7JrsNode > m_DescriptorValue;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1849MP7JRSSEMANTICSTATETYPE_ATTRIBUTEVALUEPAIR_LOCALTYPE_H

