/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1851MP7JRSSEMANTICSTATETYPE_ATTRIBUTEVALUEPAIR_LOCALTYPE0_H
#define _1851MP7JRSSEMANTICSTATETYPE_ATTRIBUTEVALUEPAIR_LOCALTYPE0_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtInclude.h


class IMp7JrsSemanticStateType_AttributeValuePair_CollectionType;
class IMp7JrsSemanticStateType_AttributeValuePair_LocalType0;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_CollectionType > Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_LocalType0> Mp7JrsSemanticStateType_AttributeValuePair_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsSemanticStateType_AttributeValuePair_LocalType0 for class Mp7JrsSemanticStateType_AttributeValuePair_LocalType0<br>
 * Located at: mds-2001.xsd, line 4357<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSemanticStateType_AttributeValuePair_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSemanticStateType_AttributeValuePair_LocalType0();
    virtual ~IMp7JrsSemanticStateType_AttributeValuePair_LocalType0();
        /** @name Sequence

         */
        //@{
    /**
     * Get Attribute element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetAttribute() const = 0;

    /**
     * Set Attribute element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetAttribute(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Unit element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetUnit() const = 0;

    virtual bool IsValidUnit() const = 0;

    /**
     * Set Unit element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetUnit(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Unit element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateUnit() = 0;

    /**
     * Get SemanticStateType_AttributeValuePair_LocalType element.
     * @return Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr
     */
    virtual Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr GetSemanticStateType_AttributeValuePair_LocalType() const = 0;

    /**
     * Set SemanticStateType_AttributeValuePair_LocalType element.
     * @param item const Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr &
     */
    virtual void SetSemanticStateType_AttributeValuePair_LocalType(const Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSemanticStateType_AttributeValuePair_LocalType0<br>
 * Located at: mds-2001.xsd, line 4357<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 4357.<br>
 */
class MP7JRS_EXPORT Mp7JrsSemanticStateType_AttributeValuePair_LocalType0 :
        public IMp7JrsSemanticStateType_AttributeValuePair_LocalType0
{
    friend class Mp7JrsSemanticStateType_AttributeValuePair_LocalType0Factory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Attribute element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetAttribute() const;

    /*
     * Set Attribute element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetAttribute(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Unit element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetUnit() const;

    virtual bool IsValidUnit() const;

    /*
     * Set Unit element.
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetUnit(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Unit element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateUnit();

    /*
     * Get SemanticStateType_AttributeValuePair_LocalType element.
     * @return Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr
     */
    virtual Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr GetSemanticStateType_AttributeValuePair_LocalType() const;

    /*
     * Set SemanticStateType_AttributeValuePair_LocalType element.
     * @param item const Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr &
     */
    virtual void SetSemanticStateType_AttributeValuePair_LocalType(const Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSemanticStateType_AttributeValuePair_LocalType0();

protected:
    Mp7JrsSemanticStateType_AttributeValuePair_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsTermUsePtr m_Attribute;
    Mp7JrsTermUsePtr m_Unit;
    bool m_Unit_Exist; // For optional elements 
    Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr m_SemanticStateType_AttributeValuePair_LocalType;

// no includefile for extension defined 
// file Mp7JrsSemanticStateType_AttributeValuePair_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1851MP7JRSSEMANTICSTATETYPE_ATTRIBUTEVALUEPAIR_LOCALTYPE0_H

