/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1857MP7JRSSEMANTICTIMETYPE_SEMANTICTIMEINTERVAL_LOCALTYPE_H
#define _1857MP7JRSSEMANTICTIMETYPE_SEMANTICTIMEINTERVAL_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtInclude.h


class IMp7JrsExtentType;
class IMp7JrsPositionType;
class IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType;
typedef Mp7JrsPtr< IMp7JrsExtentType > Mp7JrsExtentPtr;
typedef Mp7JrsPtr< IMp7JrsPositionType > Mp7JrsPositionPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType> Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalPtr;

/** 
 * Generated interface IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType for class Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType<br>
 * Located at: mds-2001.xsd, line 4412<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType();
    virtual ~IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get TimePoint element.
     * @return Mp7JrsPositionPtr
     */
    virtual Mp7JrsPositionPtr GetTimePoint() const = 0;

    virtual bool IsValidTimePoint() const = 0;

    /**
     * Set TimePoint element.
     * @param item const Mp7JrsPositionPtr &
     */
    virtual void SetTimePoint(const Mp7JrsPositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TimePoint element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTimePoint() = 0;

    /**
     * Get Duration element.
     * @return Mp7JrsExtentPtr
     */
    virtual Mp7JrsExtentPtr GetDuration() const = 0;

    virtual bool IsValidDuration() const = 0;

    /**
     * Set Duration element.
     * @param item const Mp7JrsExtentPtr &
     */
    virtual void SetDuration(const Mp7JrsExtentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Duration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDuration() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType<br>
 * Located at: mds-2001.xsd, line 4412<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 4412.<br>
 */
class MP7JRS_EXPORT Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType :
        public IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType
{
    friend class Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get TimePoint element.
     * @return Mp7JrsPositionPtr
     */
    virtual Mp7JrsPositionPtr GetTimePoint() const;

    virtual bool IsValidTimePoint() const;

    /*
     * Set TimePoint element.
     * @param item const Mp7JrsPositionPtr &
     */
    virtual void SetTimePoint(const Mp7JrsPositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TimePoint element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTimePoint();

    /*
     * Get Duration element.
     * @return Mp7JrsExtentPtr
     */
    virtual Mp7JrsExtentPtr GetDuration() const;

    virtual bool IsValidDuration() const;

    /*
     * Set Duration element.
     * @param item const Mp7JrsExtentPtr &
     */
    virtual void SetDuration(const Mp7JrsExtentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Duration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDuration();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType();

protected:
    Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsPositionPtr m_TimePoint;
    bool m_TimePoint_Exist; // For optional elements 
    Mp7JrsExtentPtr m_Duration;
    bool m_Duration_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1857MP7JRSSEMANTICTIMETYPE_SEMANTICTIMEINTERVAL_LOCALTYPE_H

