/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1875MP7JRSSERIESOFSCALARTYPE_H
#define _1875MP7JRSSERIESOFSCALARTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSeriesOfScalarTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSeriesOfScalarType_ExtInclude.h


#include "Mp7JrsScalableSeriesType.h"
class IMp7JrsfloatVector;
class IMp7JrsScalableSeriesType;
class IMp7JrsScalableSeriesType_Scaling_CollectionType;
class IMp7JrsSeriesOfScalarType;
typedef Mp7JrsPtr< IMp7JrsfloatVector > Mp7JrsfloatVectorPtr;
typedef Mp7JrsPtr< IMp7JrsScalableSeriesType > Mp7JrsScalableSeriesPtr;
typedef Mp7JrsPtr< IMp7JrsScalableSeriesType_Scaling_CollectionType > Mp7JrsScalableSeriesType_Scaling_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSeriesOfScalarType> Mp7JrsSeriesOfScalarPtr;

/** 
 * Generated interface IMp7JrsSeriesOfScalarType for class Mp7JrsSeriesOfScalarType<br>
 * Located at: audio-2001.xsd, line 271<br>
 * Classified: Class<br>
 * Derived from: ScalableSeriesType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSeriesOfScalarType 
 :
        public IMp7JrsScalableSeriesType
{
public:
    // TODO: make these protected?
    IMp7JrsSeriesOfScalarType();
    virtual ~IMp7JrsSeriesOfScalarType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Raw element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetRaw() const = 0;

    virtual bool IsValidRaw() const = 0;

    /**
     * Set Raw element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetRaw(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Raw element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRaw() = 0;

    /**
     * Get Min element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetMin() const = 0;

    virtual bool IsValidMin() const = 0;

    /**
     * Set Min element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetMin(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Min element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMin() = 0;

    /**
     * Get Max element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetMax() const = 0;

    virtual bool IsValidMax() const = 0;

    /**
     * Set Max element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetMax(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Max element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMax() = 0;

    /**
     * Get Mean element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetMean() const = 0;

    virtual bool IsValidMean() const = 0;

    /**
     * Set Mean element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetMean(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Mean element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMean() = 0;

    /**
     * Get Random element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetRandom() const = 0;

    virtual bool IsValidRandom() const = 0;

    /**
     * Set Random element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetRandom(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Random element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRandom() = 0;

    /**
     * Get First element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetFirst() const = 0;

    virtual bool IsValidFirst() const = 0;

    /**
     * Set First element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetFirst(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate First element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFirst() = 0;

    /**
     * Get Last element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetLast() const = 0;

    virtual bool IsValidLast() const = 0;

    /**
     * Set Last element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetLast(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Last element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLast() = 0;

    /**
     * Get Variance element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetVariance() const = 0;

    virtual bool IsValidVariance() const = 0;

    /**
     * Set Variance element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetVariance(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Variance element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVariance() = 0;

    /**
     * Get Weight element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetWeight() const = 0;

    virtual bool IsValidWeight() const = 0;

    /**
     * Set Weight element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetWeight(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Weight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateWeight() = 0;

        //@}
    /**
     * Get totalNumOfSamples attribute.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @return unsigned
     */
    virtual unsigned GettotalNumOfSamples() const = 0;

    /**
     * Set totalNumOfSamples attribute.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @param item unsigned
     */
    virtual void SettotalNumOfSamples(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Scaling element.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @return Mp7JrsScalableSeriesType_Scaling_CollectionPtr
     */
    virtual Mp7JrsScalableSeriesType_Scaling_CollectionPtr GetScaling() const = 0;

    /**
     * Set Scaling element.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @param item const Mp7JrsScalableSeriesType_Scaling_CollectionPtr &
     */
    virtual void SetScaling(const Mp7JrsScalableSeriesType_Scaling_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSeriesOfScalarType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSeriesOfScalarType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSeriesOfScalarType<br>
 * Located at: audio-2001.xsd, line 271<br>
 * Classified: Class<br>
 * Derived from: ScalableSeriesType (Class)<br>
 * Defined in audio-2001.xsd, line 271.<br>
 */
class MP7JRS_EXPORT Mp7JrsSeriesOfScalarType :
        public IMp7JrsSeriesOfScalarType
{
    friend class Mp7JrsSeriesOfScalarTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSeriesOfScalarType
     
     * @return Mp7JrsPtr< Mp7JrsScalableSeriesType >
     */
    virtual Mp7JrsPtr< Mp7JrsScalableSeriesType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Raw element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetRaw() const;

    virtual bool IsValidRaw() const;

    /*
     * Set Raw element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetRaw(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Raw element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRaw();

    /*
     * Get Min element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetMin() const;

    virtual bool IsValidMin() const;

    /*
     * Set Min element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetMin(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Min element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMin();

    /*
     * Get Max element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetMax() const;

    virtual bool IsValidMax() const;

    /*
     * Set Max element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetMax(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Max element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMax();

    /*
     * Get Mean element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetMean() const;

    virtual bool IsValidMean() const;

    /*
     * Set Mean element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetMean(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Mean element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMean();

    /*
     * Get Random element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetRandom() const;

    virtual bool IsValidRandom() const;

    /*
     * Set Random element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetRandom(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Random element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRandom();

    /*
     * Get First element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetFirst() const;

    virtual bool IsValidFirst() const;

    /*
     * Set First element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetFirst(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate First element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFirst();

    /*
     * Get Last element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetLast() const;

    virtual bool IsValidLast() const;

    /*
     * Set Last element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetLast(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Last element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateLast();

    /*
     * Get Variance element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetVariance() const;

    virtual bool IsValidVariance() const;

    /*
     * Set Variance element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetVariance(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Variance element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVariance();

    /*
     * Get Weight element.
     * @return Mp7JrsfloatVectorPtr
     */
    virtual Mp7JrsfloatVectorPtr GetWeight() const;

    virtual bool IsValidWeight() const;

    /*
     * Set Weight element.
     * @param item const Mp7JrsfloatVectorPtr &
     */
    virtual void SetWeight(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Weight element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateWeight();

        //@}
    /*
     * Get totalNumOfSamples attribute.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @return unsigned
     */
    virtual unsigned GettotalNumOfSamples() const;

    /*
     * Set totalNumOfSamples attribute.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @param item unsigned
     */
    virtual void SettotalNumOfSamples(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get Scaling element.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @return Mp7JrsScalableSeriesType_Scaling_CollectionPtr
     */
    virtual Mp7JrsScalableSeriesType_Scaling_CollectionPtr GetScaling() const;

    /*
     * Set Scaling element.
<br>
     * (Inherited from Mp7JrsScalableSeriesType)
     * @param item const Mp7JrsScalableSeriesType_Scaling_CollectionPtr &
     */
    virtual void SetScaling(const Mp7JrsScalableSeriesType_Scaling_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSeriesOfScalarType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSeriesOfScalarType();

protected:
    Mp7JrsSeriesOfScalarType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsScalableSeriesType > m_Base;

    Mp7JrsfloatVectorPtr m_Raw;
    bool m_Raw_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Min;
    bool m_Min_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Max;
    bool m_Max_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Mean;
    bool m_Mean_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Random;
    bool m_Random_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_First;
    bool m_First_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Last;
    bool m_Last_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Variance;
    bool m_Variance_Exist; // For optional elements 
    Mp7JrsfloatVectorPtr m_Weight;
    bool m_Weight_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSeriesOfScalarType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1875MP7JRSSERIESOFSCALARTYPE_H

