/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1881MP7JRSSHAPE3DTYPE_H
#define _1881MP7JRSSHAPE3DTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsShape3DTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsShape3DType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsShape3DType;
class IMp7JrsShape3DType_Spectrum_LocalType;
class IMp7Jrsunsigned12;
class IMp7Jrsunsigned4;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsShape3DType_Spectrum_LocalType > Mp7JrsShape3DType_Spectrum_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsShape3DType> Mp7JrsShape3DPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned12 > Mp7Jrsunsigned12Ptr;
typedef Mp7JrsPtr< IMp7Jrsunsigned4 > Mp7Jrsunsigned4Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsShape3DType for class Mp7JrsShape3DType<br>
 * Located at: visual-2001.xsd, line 805<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsShape3DType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsShape3DType();
    virtual ~IMp7JrsShape3DType();
    /**
     * Get bitsPerBin attribute.
     * @return Mp7Jrsunsigned4Ptr
     */
    virtual Mp7Jrsunsigned4Ptr GetbitsPerBin() const = 0;

    /**
     * Get bitsPerBin attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistbitsPerBin() const = 0;

    /**
     * Set bitsPerBin attribute.
     * @param item const Mp7Jrsunsigned4Ptr &
     */
    virtual void SetbitsPerBin(const Mp7Jrsunsigned4Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate bitsPerBin attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatebitsPerBin() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Spectrum element.
     * @return Mp7JrsShape3DType_Spectrum_LocalPtr
     */
    virtual Mp7JrsShape3DType_Spectrum_LocalPtr GetSpectrum() const = 0;

    /**
     * Set Spectrum element.
     * @param item const Mp7JrsShape3DType_Spectrum_LocalPtr &
     */
    virtual void SetSpectrum(const Mp7JrsShape3DType_Spectrum_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PlanarSurfaces element.
     * @return Mp7Jrsunsigned12Ptr
     */
    virtual Mp7Jrsunsigned12Ptr GetPlanarSurfaces() const = 0;

    /**
     * Set PlanarSurfaces element.
     * @param item const Mp7Jrsunsigned12Ptr &
     */
    virtual void SetPlanarSurfaces(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SingularSurfaces element.
     * @return Mp7Jrsunsigned12Ptr
     */
    virtual Mp7Jrsunsigned12Ptr GetSingularSurfaces() const = 0;

    /**
     * Set SingularSurfaces element.
     * @param item const Mp7Jrsunsigned12Ptr &
     */
    virtual void SetSingularSurfaces(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsShape3DType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsShape3DType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsShape3DType<br>
 * Located at: visual-2001.xsd, line 805<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 805.<br>
 */
class MP7JRS_EXPORT Mp7JrsShape3DType :
        public IMp7JrsShape3DType
{
    friend class Mp7JrsShape3DTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsShape3DType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
    /*
     * Get bitsPerBin attribute.
     * @return Mp7Jrsunsigned4Ptr
     */
    virtual Mp7Jrsunsigned4Ptr GetbitsPerBin() const;

    /*
     * Get bitsPerBin attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistbitsPerBin() const;

    /*
     * Set bitsPerBin attribute.
     * @param item const Mp7Jrsunsigned4Ptr &
     */
    virtual void SetbitsPerBin(const Mp7Jrsunsigned4Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate bitsPerBin attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatebitsPerBin();

        /* @name Sequence

         */
        //@{
    /*
     * Get Spectrum element.
     * @return Mp7JrsShape3DType_Spectrum_LocalPtr
     */
    virtual Mp7JrsShape3DType_Spectrum_LocalPtr GetSpectrum() const;

    /*
     * Set Spectrum element.
     * @param item const Mp7JrsShape3DType_Spectrum_LocalPtr &
     */
    virtual void SetSpectrum(const Mp7JrsShape3DType_Spectrum_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PlanarSurfaces element.
     * @return Mp7Jrsunsigned12Ptr
     */
    virtual Mp7Jrsunsigned12Ptr GetPlanarSurfaces() const;

    /*
     * Set PlanarSurfaces element.
     * @param item const Mp7Jrsunsigned12Ptr &
     */
    virtual void SetPlanarSurfaces(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SingularSurfaces element.
     * @return Mp7Jrsunsigned12Ptr
     */
    virtual Mp7Jrsunsigned12Ptr GetSingularSurfaces() const;

    /*
     * Set SingularSurfaces element.
     * @param item const Mp7Jrsunsigned12Ptr &
     */
    virtual void SetSingularSurfaces(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsShape3DType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsShape3DType();

protected:
    Mp7JrsShape3DType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7Jrsunsigned4Ptr m_bitsPerBin;
    bool m_bitsPerBin_Exist;
    Mp7Jrsunsigned4Ptr m_bitsPerBin_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsShape3DType_Spectrum_LocalPtr m_Spectrum;
    Mp7Jrsunsigned12Ptr m_PlanarSurfaces;
    Mp7Jrsunsigned12Ptr m_SingularSurfaces;

// no includefile for extension defined 
// file Mp7JrsShape3DType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1881MP7JRSSHAPE3DTYPE_H

