/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1909MP7JRSSIGNALPLANESAMPLETYPE_H
#define _1909MP7JRSSIGNALPLANESAMPLETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSignalPlaneSampleTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSignalPlaneSampleType_ExtInclude.h


#include "Mp7JrsSignalPlaneType.h"
class IMp7JrsSignalPlaneOriginType;
class IMp7JrsSignalPlaneSampleType;
class IMp7JrsSignalPlaneType;
class IMp7JrsSignalPlaneType_dim_LocalType;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneOriginType > Mp7JrsSignalPlaneOriginPtr;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneSampleType> Mp7JrsSignalPlaneSamplePtr;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneType > Mp7JrsSignalPlanePtr;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneType_dim_LocalType > Mp7JrsSignalPlaneType_dim_LocalPtr;

/** 
 * Generated interface IMp7JrsSignalPlaneSampleType for class Mp7JrsSignalPlaneSampleType<br>
 * Located at: mds-2001.xsd, line 4729<br>
 * Classified: Class<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSignalPlaneSampleType 
 :
        public IMp7JrsSignalPlaneType
{
public:
    // TODO: make these protected?
    IMp7JrsSignalPlaneSampleType();
    virtual ~IMp7JrsSignalPlaneSampleType();
    /**
     * Get x attribute.
     * @return int
     */
    virtual int Getx() const = 0;

    /**
     * Get x attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existx() const = 0;

    /**
     * Set x attribute.
     * @param item int
     */
    virtual void Setx(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate x attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatex() = 0;

    /**
     * Get y attribute.
     * @return int
     */
    virtual int Gety() const = 0;

    /**
     * Get y attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existy() const = 0;

    /**
     * Set y attribute.
     * @param item int
     */
    virtual void Sety(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate y attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatey() = 0;

    /**
     * Get z attribute.
     * @return int
     */
    virtual int Getz() const = 0;

    /**
     * Get z attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existz() const = 0;

    /**
     * Set z attribute.
     * @param item int
     */
    virtual void Setz(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate z attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatez() = 0;

    /**
     * Get t attribute.
     * @return int
     */
    virtual int Gett() const = 0;

    /**
     * Get t attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existt() const = 0;

    /**
     * Set t attribute.
     * @param item int
     */
    virtual void Sett(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate t attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatet() = 0;

    /**
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @return Mp7JrsSignalPlaneType_dim_LocalPtr
     */
    virtual Mp7JrsSignalPlaneType_dim_LocalPtr Getdim() const = 0;

    /**
     * Get dim attribute validity information.
     * (Inherited from Mp7JrsSignalPlaneType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const = 0;

    /**
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @param item const Mp7JrsSignalPlaneType_dim_LocalPtr &
     */
    virtual void Setdim(const Mp7JrsSignalPlaneType_dim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dim attribute.
     * (Inherited from Mp7JrsSignalPlaneType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Origin element.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @return Mp7JrsSignalPlaneOriginPtr
     */
    virtual Mp7JrsSignalPlaneOriginPtr GetOrigin() const = 0;

    virtual bool IsValidOrigin() const = 0;

    /**
     * Set Origin element.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @param item const Mp7JrsSignalPlaneOriginPtr &
     */
    virtual void SetOrigin(const Mp7JrsSignalPlaneOriginPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Origin element.
     * (Inherited from Mp7JrsSignalPlaneType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOrigin() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSignalPlaneSampleType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSignalPlaneSampleType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSignalPlaneSampleType<br>
 * Located at: mds-2001.xsd, line 4729<br>
 * Classified: Class<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Derived from: SignalPlaneType (Class)<br>
 * Defined in mds-2001.xsd, line 4729.<br>
 */
class MP7JRS_EXPORT Mp7JrsSignalPlaneSampleType :
        public IMp7JrsSignalPlaneSampleType
{
    friend class Mp7JrsSignalPlaneSampleTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSignalPlaneSampleType
     
     * @return Mp7JrsPtr< Mp7JrsSignalPlaneType >
     */
    virtual Mp7JrsPtr< Mp7JrsSignalPlaneType > GetBase() const;
    /*
     * Get x attribute.
     * @return int
     */
    virtual int Getx() const;

    /*
     * Get x attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existx() const;

    /*
     * Set x attribute.
     * @param item int
     */
    virtual void Setx(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate x attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatex();

    /*
     * Get y attribute.
     * @return int
     */
    virtual int Gety() const;

    /*
     * Get y attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existy() const;

    /*
     * Set y attribute.
     * @param item int
     */
    virtual void Sety(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate y attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatey();

    /*
     * Get z attribute.
     * @return int
     */
    virtual int Getz() const;

    /*
     * Get z attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existz() const;

    /*
     * Set z attribute.
     * @param item int
     */
    virtual void Setz(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate z attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatez();

    /*
     * Get t attribute.
     * @return int
     */
    virtual int Gett() const;

    /*
     * Get t attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existt() const;

    /*
     * Set t attribute.
     * @param item int
     */
    virtual void Sett(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate t attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatet();

    /*
     * Get dim attribute.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @return Mp7JrsSignalPlaneType_dim_LocalPtr
     */
    virtual Mp7JrsSignalPlaneType_dim_LocalPtr Getdim() const;

    /*
     * Get dim attribute validity information.
     * (Inherited from Mp7JrsSignalPlaneType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const;

    /*
     * Set dim attribute.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @param item const Mp7JrsSignalPlaneType_dim_LocalPtr &
     */
    virtual void Setdim(const Mp7JrsSignalPlaneType_dim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dim attribute.
     * (Inherited from Mp7JrsSignalPlaneType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim();

        /* @name Sequence

         */
        //@{
    /*
     * Get Origin element.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @return Mp7JrsSignalPlaneOriginPtr
     */
    virtual Mp7JrsSignalPlaneOriginPtr GetOrigin() const;

    virtual bool IsValidOrigin() const;

    /*
     * Set Origin element.
<br>
     * (Inherited from Mp7JrsSignalPlaneType)
     * @param item const Mp7JrsSignalPlaneOriginPtr &
     */
    virtual void SetOrigin(const Mp7JrsSignalPlaneOriginPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Origin element.
     * (Inherited from Mp7JrsSignalPlaneType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOrigin();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSignalPlaneSampleType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSignalPlaneSampleType();

protected:
    Mp7JrsSignalPlaneSampleType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    int m_x;
    bool m_x_Exist;
    int m_y;
    bool m_y_Exist;
    int m_z;
    bool m_z_Exist;
    int m_t;
    bool m_t_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsSignalPlaneType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSignalPlaneSampleType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1909MP7JRSSIGNALPLANESAMPLETYPE_H

