/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1911MP7JRSSIGNALPLANETYPE_H
#define _1911MP7JRSSIGNALPLANETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSignalPlaneTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSignalPlaneType_ExtInclude.h


class IMp7JrsSignalPlaneOriginType;
class IMp7JrsSignalPlaneType;
class IMp7JrsSignalPlaneType_dim_LocalType;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneOriginType > Mp7JrsSignalPlaneOriginPtr;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneType_dim_LocalType > Mp7JrsSignalPlaneType_dim_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSignalPlaneType> Mp7JrsSignalPlanePtr;

/** 
 * Generated interface IMp7JrsSignalPlaneType for class Mp7JrsSignalPlaneType<br>
 * Located at: mds-2001.xsd, line 4705<br>
 * Classified: Class<br>
 * Abstract class <br>
 */
class MP7JRS_EXPORT IMp7JrsSignalPlaneType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSignalPlaneType();
    virtual ~IMp7JrsSignalPlaneType();
    /**
     * Get dim attribute.
     * @return Mp7JrsSignalPlaneType_dim_LocalPtr
     */
    virtual Mp7JrsSignalPlaneType_dim_LocalPtr Getdim() const = 0;

    /**
     * Get dim attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const = 0;

    /**
     * Set dim attribute.
     * @param item const Mp7JrsSignalPlaneType_dim_LocalPtr &
     */
    virtual void Setdim(const Mp7JrsSignalPlaneType_dim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dim attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Origin element.
     * @return Mp7JrsSignalPlaneOriginPtr
     */
    virtual Mp7JrsSignalPlaneOriginPtr GetOrigin() const = 0;

    virtual bool IsValidOrigin() const = 0;

    /**
     * Set Origin element.
     * @param item const Mp7JrsSignalPlaneOriginPtr &
     */
    virtual void SetOrigin(const Mp7JrsSignalPlaneOriginPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Origin element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOrigin() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSignalPlaneType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSignalPlaneType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSignalPlaneType<br>
 * Located at: mds-2001.xsd, line 4705<br>
 * Classified: Class<br>
 * Abstract class <br>
 * Defined in mds-2001.xsd, line 4705.<br>
 */
class MP7JRS_EXPORT Mp7JrsSignalPlaneType :
        public IMp7JrsSignalPlaneType
{
    friend class Mp7JrsSignalPlaneTypeFactory; // constructs objects

public:
    /*
     * Get dim attribute.
     * @return Mp7JrsSignalPlaneType_dim_LocalPtr
     */
    virtual Mp7JrsSignalPlaneType_dim_LocalPtr Getdim() const;

    /*
     * Get dim attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdim() const;

    /*
     * Set dim attribute.
     * @param item const Mp7JrsSignalPlaneType_dim_LocalPtr &
     */
    virtual void Setdim(const Mp7JrsSignalPlaneType_dim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dim attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedim();

        /* @name Sequence

         */
        //@{
    /*
     * Get Origin element.
     * @return Mp7JrsSignalPlaneOriginPtr
     */
    virtual Mp7JrsSignalPlaneOriginPtr GetOrigin() const;

    virtual bool IsValidOrigin() const;

    /*
     * Set Origin element.
     * @param item const Mp7JrsSignalPlaneOriginPtr &
     */
    virtual void SetOrigin(const Mp7JrsSignalPlaneOriginPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Origin element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOrigin();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSignalPlaneType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSignalPlaneType();

protected:
    Mp7JrsSignalPlaneType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsSignalPlaneType_dim_LocalPtr m_dim;
    bool m_dim_Exist;


    Mp7JrsSignalPlaneOriginPtr m_Origin;
    bool m_Origin_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSignalPlaneType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1911MP7JRSSIGNALPLANETYPE_H

