/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1925MP7JRSSOUNDMODELSTATEHISTOGRAMTYPE_H
#define _1925MP7JRSSOUNDMODELSTATEHISTOGRAMTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSoundModelStateHistogramTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtInclude.h


#include "Mp7JrsAudioDType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioDType;
class IMp7JrsSoundModelStateHistogramType;
class IMp7JrsSoundModelStateHistogramType_CollectionType;
typedef Mp7JrsPtr< IMp7JrsAudioDType > Mp7JrsAudioDPtr;
typedef Mp7JrsPtr< IMp7JrsSoundModelStateHistogramType_CollectionType > Mp7JrsSoundModelStateHistogramType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSoundModelStateHistogramType> Mp7JrsSoundModelStateHistogramPtr;

/** 
 * Generated interface IMp7JrsSoundModelStateHistogramType for class Mp7JrsSoundModelStateHistogramType<br>
 * Located at: audio-2001.xsd, line 689<br>
 * Classified: Class<br>
 * Derived from: AudioDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSoundModelStateHistogramType 
 :
        public IMp7JrsAudioDType
{
public:
    // TODO: make these protected?
    IMp7JrsSoundModelStateHistogramType();
    virtual ~IMp7JrsSoundModelStateHistogramType();
        /** @name Sequence

         */
        //@{
    /**
     * Get SoundModelStateHistogramType_LocalType element.
     * @return Mp7JrsSoundModelStateHistogramType_CollectionPtr
     */
    virtual Mp7JrsSoundModelStateHistogramType_CollectionPtr GetSoundModelStateHistogramType_LocalType() const = 0;

    /**
     * Set SoundModelStateHistogramType_LocalType element.
     * @param item const Mp7JrsSoundModelStateHistogramType_CollectionPtr &
     */
    virtual void SetSoundModelStateHistogramType_LocalType(const Mp7JrsSoundModelStateHistogramType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SoundModelRef element.
     * @return XMLCh *
     */
    virtual XMLCh * GetSoundModelRef() const = 0;

    /**
     * Set SoundModelRef element.
     * @param item XMLCh *
     */
    virtual void SetSoundModelRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSoundModelStateHistogramType<br>
 * Located at: audio-2001.xsd, line 689<br>
 * Classified: Class<br>
 * Derived from: AudioDType (Class)<br>
 * Defined in audio-2001.xsd, line 689.<br>
 */
class MP7JRS_EXPORT Mp7JrsSoundModelStateHistogramType :
        public IMp7JrsSoundModelStateHistogramType
{
    friend class Mp7JrsSoundModelStateHistogramTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSoundModelStateHistogramType
     
     * @return Mp7JrsPtr< Mp7JrsAudioDType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get SoundModelStateHistogramType_LocalType element.
     * @return Mp7JrsSoundModelStateHistogramType_CollectionPtr
     */
    virtual Mp7JrsSoundModelStateHistogramType_CollectionPtr GetSoundModelStateHistogramType_LocalType() const;

    /*
     * Set SoundModelStateHistogramType_LocalType element.
     * @param item const Mp7JrsSoundModelStateHistogramType_CollectionPtr &
     */
    virtual void SetSoundModelStateHistogramType_LocalType(const Mp7JrsSoundModelStateHistogramType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SoundModelRef element.
     * @return XMLCh *
     */
    virtual XMLCh * GetSoundModelRef() const;

    /*
     * Set SoundModelRef element.
     * @param item XMLCh *
     */
    virtual void SetSoundModelRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSoundModelStateHistogramType();

protected:
    Mp7JrsSoundModelStateHistogramType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioDType > m_Base;

    Mp7JrsSoundModelStateHistogramType_CollectionPtr m_SoundModelStateHistogramType_LocalType;
    XMLCh * m_SoundModelRef;

// no includefile for extension defined 
// file Mp7JrsSoundModelStateHistogramType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1925MP7JRSSOUNDMODELSTATEHISTOGRAMTYPE_H

