/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1947MP7JRSSOURCEPREFERENCESTYPE_DISSEMINATIONLOCATION_LOCALTYPE_H
#define _1947MP7JRSSOURCEPREFERENCESTYPE_DISSEMINATIONLOCATION_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSourcePreferencesType_DisseminationLocation_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsPlaceType.h"
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsPlaceType;
class IMp7JrsPlaceType_AdministrativeUnit_CollectionType;
class IMp7JrsPlaceType_AstronomicalBody_CollectionType;
class IMp7JrsPlaceType_GeographicPosition_LocalType;
class IMp7JrsPlaceType_Name_CollectionType;
class IMp7JrsPlaceType_NameTerm_CollectionType;
class IMp7JrsPlaceType_PostalAddress_LocalType;
class IMp7JrsPlaceType_Region_CollectionType;
class IMp7JrspreferenceValueType;
class IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType;
class IMp7JrsTermUseType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_AdministrativeUnit_CollectionType > Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_AstronomicalBody_CollectionType > Mp7JrsPlaceType_AstronomicalBody_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_GeographicPosition_LocalType > Mp7JrsPlaceType_GeographicPosition_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_Name_CollectionType > Mp7JrsPlaceType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_NameTerm_CollectionType > Mp7JrsPlaceType_NameTerm_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_PostalAddress_LocalType > Mp7JrsPlaceType_PostalAddress_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsPlaceType_Region_CollectionType > Mp7JrsPlaceType_Region_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType> Mp7JrsSourcePreferencesType_DisseminationLocation_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType for class Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType<br>
 * Located at: mds-2001.xsd, line 6133<br>
 * Classified: Class<br>
 * Derived from: PlaceType (Class)<br>
 * Derived from: PlaceType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType 
 :
        public IMp7JrsPlaceType
{
public:
    // TODO: make these protected?
    IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType();
    virtual ~IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

    /**
     * Get lang attribute.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * (Inherited from Mp7JrsPlaceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_Name_CollectionPtr
     */
    virtual Mp7JrsPlaceType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsPlaceType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get NameTerm element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_NameTerm_CollectionPtr
     */
    virtual Mp7JrsPlaceType_NameTerm_CollectionPtr GetNameTerm() const = 0;

    /**
     * Set NameTerm element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_NameTerm_CollectionPtr &
     */
    virtual void SetNameTerm(const Mp7JrsPlaceType_NameTerm_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Role element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetRole() const = 0;

    virtual bool IsValidRole() const = 0;

    /**
     * Set Role element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetRole(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Role element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRole() = 0;

    /**
     * Get GeographicPosition element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_GeographicPosition_LocalPtr
     */
    virtual Mp7JrsPlaceType_GeographicPosition_LocalPtr GetGeographicPosition() const = 0;

    virtual bool IsValidGeographicPosition() const = 0;

    /**
     * Set GeographicPosition element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_GeographicPosition_LocalPtr &
     */
    virtual void SetGeographicPosition(const Mp7JrsPlaceType_GeographicPosition_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate GeographicPosition element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGeographicPosition() = 0;

    /**
     * Get AstronomicalBody element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_AstronomicalBody_CollectionPtr
     */
    virtual Mp7JrsPlaceType_AstronomicalBody_CollectionPtr GetAstronomicalBody() const = 0;

    /**
     * Set AstronomicalBody element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_AstronomicalBody_CollectionPtr &
     */
    virtual void SetAstronomicalBody(const Mp7JrsPlaceType_AstronomicalBody_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Region element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_Region_CollectionPtr
     */
    virtual Mp7JrsPlaceType_Region_CollectionPtr GetRegion() const = 0;

    /**
     * Set Region element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsPlaceType_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AdministrativeUnit element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr
     */
    virtual Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr GetAdministrativeUnit() const = 0;

    /**
     * Set AdministrativeUnit element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr &
     */
    virtual void SetAdministrativeUnit(const Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PostalAddress element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_PostalAddress_LocalPtr
     */
    virtual Mp7JrsPlaceType_PostalAddress_LocalPtr GetPostalAddress() const = 0;

    virtual bool IsValidPostalAddress() const = 0;

    /**
     * Set PostalAddress element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_PostalAddress_LocalPtr &
     */
    virtual void SetPostalAddress(const Mp7JrsPlaceType_PostalAddress_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PostalAddress element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePostalAddress() = 0;

    /**
     * Get InternalCoordinates element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return XMLCh *
     */
    virtual XMLCh * GetInternalCoordinates() const = 0;

    virtual bool IsValidInternalCoordinates() const = 0;

    /**
     * Set InternalCoordinates element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item XMLCh *
     */
    virtual void SetInternalCoordinates(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate InternalCoordinates element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateInternalCoordinates() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType<br>
 * Located at: mds-2001.xsd, line 6133<br>
 * Classified: Class<br>
 * Derived from: PlaceType (Class)<br>
 * Derived from: PlaceType (Class)<br>
 * Defined in mds-2001.xsd, line 6133.<br>
 */
class MP7JRS_EXPORT Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType :
        public IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType
{
    friend class Mp7JrsSourcePreferencesType_DisseminationLocation_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsPlaceType >
     */
    virtual Mp7JrsPtr< Mp7JrsPlaceType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

    /*
     * Get lang attribute.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * (Inherited from Mp7JrsPlaceType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_Name_CollectionPtr
     */
    virtual Mp7JrsPlaceType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsPlaceType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get NameTerm element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_NameTerm_CollectionPtr
     */
    virtual Mp7JrsPlaceType_NameTerm_CollectionPtr GetNameTerm() const;

    /*
     * Set NameTerm element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_NameTerm_CollectionPtr &
     */
    virtual void SetNameTerm(const Mp7JrsPlaceType_NameTerm_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Role element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetRole() const;

    virtual bool IsValidRole() const;

    /*
     * Set Role element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsTermUsePtr &
     */
    virtual void SetRole(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Role element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateRole();

    /*
     * Get GeographicPosition element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_GeographicPosition_LocalPtr
     */
    virtual Mp7JrsPlaceType_GeographicPosition_LocalPtr GetGeographicPosition() const;

    virtual bool IsValidGeographicPosition() const;

    /*
     * Set GeographicPosition element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_GeographicPosition_LocalPtr &
     */
    virtual void SetGeographicPosition(const Mp7JrsPlaceType_GeographicPosition_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate GeographicPosition element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGeographicPosition();

    /*
     * Get AstronomicalBody element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_AstronomicalBody_CollectionPtr
     */
    virtual Mp7JrsPlaceType_AstronomicalBody_CollectionPtr GetAstronomicalBody() const;

    /*
     * Set AstronomicalBody element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_AstronomicalBody_CollectionPtr &
     */
    virtual void SetAstronomicalBody(const Mp7JrsPlaceType_AstronomicalBody_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Region element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_Region_CollectionPtr
     */
    virtual Mp7JrsPlaceType_Region_CollectionPtr GetRegion() const;

    /*
     * Set Region element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_Region_CollectionPtr &
     */
    virtual void SetRegion(const Mp7JrsPlaceType_Region_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AdministrativeUnit element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr
     */
    virtual Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr GetAdministrativeUnit() const;

    /*
     * Set AdministrativeUnit element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr &
     */
    virtual void SetAdministrativeUnit(const Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PostalAddress element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return Mp7JrsPlaceType_PostalAddress_LocalPtr
     */
    virtual Mp7JrsPlaceType_PostalAddress_LocalPtr GetPostalAddress() const;

    virtual bool IsValidPostalAddress() const;

    /*
     * Set PostalAddress element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item const Mp7JrsPlaceType_PostalAddress_LocalPtr &
     */
    virtual void SetPostalAddress(const Mp7JrsPlaceType_PostalAddress_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PostalAddress element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePostalAddress();

    /*
     * Get InternalCoordinates element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @return XMLCh *
     */
    virtual XMLCh * GetInternalCoordinates() const;

    virtual bool IsValidInternalCoordinates() const;

    /*
     * Set InternalCoordinates element.
<br>
     * (Inherited from Mp7JrsPlaceType)
     * @param item XMLCh *
     */
    virtual void SetInternalCoordinates(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate InternalCoordinates element.
     * (Inherited from Mp7JrsPlaceType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateInternalCoordinates();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType();

protected:
    Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsPlaceType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1947MP7JRSSOURCEPREFERENCESTYPE_DISSEMINATIONLOCATION_LOCALTYPE_H

