/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1955MP7JRSSOURCEPREFERENCESTYPE_DISSEMINATOR_LOCALTYPE_H
#define _1955MP7JRSSOURCEPREFERENCESTYPE_DISSEMINATOR_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSourcePreferencesType_Disseminator_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_Disseminator_LocalType_ExtInclude.h


#include "Mp7JrsMediaAgentType.h"
class IMp7JrsAgentType;
class IMp7JrsControlledTermUseType;
class IMp7JrsMediaAgentType;
class IMp7JrspreferenceValueType;
class IMp7JrsReferenceType;
class IMp7JrsSourcePreferencesType_Disseminator_LocalType;
typedef Mp7JrsPtr< IMp7JrsAgentType > Mp7JrsAgentPtr;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsMediaAgentType > Mp7JrsMediaAgentPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_Disseminator_LocalType> Mp7JrsSourcePreferencesType_Disseminator_LocalPtr;

/** 
 * Generated interface IMp7JrsSourcePreferencesType_Disseminator_LocalType for class Mp7JrsSourcePreferencesType_Disseminator_LocalType<br>
 * Located at: mds-2001.xsd, line 6151<br>
 * Classified: Class<br>
 * Derived from: MediaAgentType (Class)<br>
 * Derived from: MediaAgentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSourcePreferencesType_Disseminator_LocalType 
 :
        public IMp7JrsMediaAgentType
{
public:
    // TODO: make these protected?
    IMp7JrsSourcePreferencesType_Disseminator_LocalType();
    virtual ~IMp7JrsSourcePreferencesType_Disseminator_LocalType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Role element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetRole() const = 0;

    /**
     * Set Role element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetRole(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Agent element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetAgent() const = 0;

    /**
     * Set Agent element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual void SetAgent(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AgentRef element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAgentRef() const = 0;

    /**
     * Set AgentRef element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAgentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_Disseminator_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_Disseminator_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSourcePreferencesType_Disseminator_LocalType<br>
 * Located at: mds-2001.xsd, line 6151<br>
 * Classified: Class<br>
 * Derived from: MediaAgentType (Class)<br>
 * Derived from: MediaAgentType (Class)<br>
 * Defined in mds-2001.xsd, line 6151.<br>
 */
class MP7JRS_EXPORT Mp7JrsSourcePreferencesType_Disseminator_LocalType :
        public IMp7JrsSourcePreferencesType_Disseminator_LocalType
{
    friend class Mp7JrsSourcePreferencesType_Disseminator_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSourcePreferencesType_Disseminator_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsMediaAgentType >
     */
    virtual Mp7JrsPtr< Mp7JrsMediaAgentType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
    /*
     * Get Role element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetRole() const;

    /*
     * Set Role element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetRole(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Choice

         */
        //@{
    /*
     * Get Agent element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetAgent() const;

    /*
     * Set Agent element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsOrganizationPtr</li>
     * <li>IMp7JrsPersonGroupPtr</li>
     * <li>IMp7JrsPersonPtr</li>
     * </ul>
     */
    virtual void SetAgent(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AgentRef element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetAgentRef() const;

    /*
     * Set AgentRef element.
<br>
     * (Inherited from Mp7JrsMediaAgentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetAgentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_Disseminator_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSourcePreferencesType_Disseminator_LocalType();

protected:
    Mp7JrsSourcePreferencesType_Disseminator_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsMediaAgentType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_Disseminator_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1955MP7JRSSOURCEPREFERENCESTYPE_DISSEMINATOR_LOCALTYPE_H

