/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1959MP7JRSSOURCEPREFERENCESTYPE_MEDIAFORMAT_LOCALTYPE_H
#define _1959MP7JRSSOURCEPREFERENCESTYPE_MEDIAFORMAT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSourcePreferencesType_MediaFormat_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMediaFormatType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsControlledTermUseType;
class IMp7JrsMediaFormatType;
class IMp7JrsMediaFormatType_AudioCoding_LocalType;
class IMp7JrsMediaFormatType_BitRate_LocalType;
class IMp7JrsMediaFormatType_ScalableCoding_LocalType2;
class IMp7JrsMediaFormatType_VisualCoding_LocalType;
class IMp7JrspreferenceValueType;
class IMp7JrsSourcePreferencesType_MediaFormat_LocalType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType > Mp7JrsMediaFormatPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_LocalType > Mp7JrsMediaFormatType_AudioCoding_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_BitRate_LocalType > Mp7JrsMediaFormatType_BitRate_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_ScalableCoding_LocalType2 > Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_LocalType > Mp7JrsMediaFormatType_VisualCoding_LocalPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_MediaFormat_LocalType> Mp7JrsSourcePreferencesType_MediaFormat_LocalPtr;

/** 
 * Generated interface IMp7JrsSourcePreferencesType_MediaFormat_LocalType for class Mp7JrsSourcePreferencesType_MediaFormat_LocalType<br>
 * Located at: mds-2001.xsd, line 6160<br>
 * Classified: Class<br>
 * Derived from: MediaFormatType (Class)<br>
 * Derived from: MediaFormatType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSourcePreferencesType_MediaFormat_LocalType 
 :
        public IMp7JrsMediaFormatType
{
public:
    // TODO: make these protected?
    IMp7JrsSourcePreferencesType_MediaFormat_LocalType();
    virtual ~IMp7JrsSourcePreferencesType_MediaFormat_LocalType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Content element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetContent() const = 0;

    /**
     * Set Content element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetContent(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Medium element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetMedium() const = 0;

    virtual bool IsValidMedium() const = 0;

    /**
     * Set Medium element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetMedium(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Medium element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMedium() = 0;

    /**
     * Get FileFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetFileFormat() const = 0;

    virtual bool IsValidFileFormat() const = 0;

    /**
     * Set FileFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetFileFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate FileFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFileFormat() = 0;

    /**
     * Get FileSize element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return unsigned
     */
    virtual unsigned GetFileSize() const = 0;

    virtual bool IsValidFileSize() const = 0;

    /**
     * Set FileSize element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item unsigned
     */
    virtual void SetFileSize(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate FileSize element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFileSize() = 0;

    /**
     * Get System element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetSystem() const = 0;

    virtual bool IsValidSystem() const = 0;

    /**
     * Set System element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetSystem(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate System element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSystem() = 0;

    /**
     * Get Bandwidth element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return float
     */
    virtual float GetBandwidth() const = 0;

    virtual bool IsValidBandwidth() const = 0;

    /**
     * Set Bandwidth element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item float
     */
    virtual void SetBandwidth(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Bandwidth element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBandwidth() = 0;

    /**
     * Get BitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_BitRate_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_BitRate_LocalPtr GetBitRate() const = 0;

    virtual bool IsValidBitRate() const = 0;

    /**
     * Set BitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_BitRate_LocalPtr &
     */
    virtual void SetBitRate(const Mp7JrsMediaFormatType_BitRate_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate BitRate element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBitRate() = 0;

    /**
     * Get TargetChannelBitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return unsigned
     */
    virtual unsigned GetTargetChannelBitRate() const = 0;

    virtual bool IsValidTargetChannelBitRate() const = 0;

    /**
     * Set TargetChannelBitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item unsigned
     */
    virtual void SetTargetChannelBitRate(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TargetChannelBitRate element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTargetChannelBitRate() = 0;

    /**
     * Get ScalableCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr
     */
    virtual Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr GetScalableCoding() const = 0;

    virtual bool IsValidScalableCoding() const = 0;

    /**
     * Set ScalableCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr &
     */
    virtual void SetScalableCoding(const Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ScalableCoding element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateScalableCoding() = 0;

    /**
     * Get VisualCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_VisualCoding_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_LocalPtr GetVisualCoding() const = 0;

    virtual bool IsValidVisualCoding() const = 0;

    /**
     * Set VisualCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_VisualCoding_LocalPtr &
     */
    virtual void SetVisualCoding(const Mp7JrsMediaFormatType_VisualCoding_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate VisualCoding element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVisualCoding() = 0;

    /**
     * Get AudioCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_AudioCoding_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_LocalPtr GetAudioCoding() const = 0;

    virtual bool IsValidAudioCoding() const = 0;

    /**
     * Set AudioCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_AudioCoding_LocalPtr &
     */
    virtual void SetAudioCoding(const Mp7JrsMediaFormatType_AudioCoding_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate AudioCoding element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioCoding() = 0;

    /**
     * Get SceneCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetSceneCodingFormat() const = 0;

    virtual bool IsValidSceneCodingFormat() const = 0;

    /**
     * Set SceneCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetSceneCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SceneCodingFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSceneCodingFormat() = 0;

    /**
     * Get GraphicsCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetGraphicsCodingFormat() const = 0;

    virtual bool IsValidGraphicsCodingFormat() const = 0;

    /**
     * Set GraphicsCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetGraphicsCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate GraphicsCodingFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGraphicsCodingFormat() = 0;

    /**
     * Get OtherCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetOtherCodingFormat() const = 0;

    virtual bool IsValidOtherCodingFormat() const = 0;

    /**
     * Set OtherCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetOtherCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate OtherCodingFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOtherCodingFormat() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSourcePreferencesType_MediaFormat_LocalType<br>
 * Located at: mds-2001.xsd, line 6160<br>
 * Classified: Class<br>
 * Derived from: MediaFormatType (Class)<br>
 * Derived from: MediaFormatType (Class)<br>
 * Defined in mds-2001.xsd, line 6160.<br>
 */
class MP7JRS_EXPORT Mp7JrsSourcePreferencesType_MediaFormat_LocalType :
        public IMp7JrsSourcePreferencesType_MediaFormat_LocalType
{
    friend class Mp7JrsSourcePreferencesType_MediaFormat_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSourcePreferencesType_MediaFormat_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsMediaFormatType >
     */
    virtual Mp7JrsPtr< Mp7JrsMediaFormatType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
    /*
     * Get Content element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetContent() const;

    /*
     * Set Content element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetContent(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Medium element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetMedium() const;

    virtual bool IsValidMedium() const;

    /*
     * Set Medium element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetMedium(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Medium element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMedium();

    /*
     * Get FileFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetFileFormat() const;

    virtual bool IsValidFileFormat() const;

    /*
     * Set FileFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetFileFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate FileFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFileFormat();

    /*
     * Get FileSize element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return unsigned
     */
    virtual unsigned GetFileSize() const;

    virtual bool IsValidFileSize() const;

    /*
     * Set FileSize element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item unsigned
     */
    virtual void SetFileSize(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate FileSize element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFileSize();

    /*
     * Get System element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetSystem() const;

    virtual bool IsValidSystem() const;

    /*
     * Set System element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetSystem(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate System element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSystem();

    /*
     * Get Bandwidth element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return float
     */
    virtual float GetBandwidth() const;

    virtual bool IsValidBandwidth() const;

    /*
     * Set Bandwidth element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item float
     */
    virtual void SetBandwidth(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Bandwidth element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBandwidth();

    /*
     * Get BitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_BitRate_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_BitRate_LocalPtr GetBitRate() const;

    virtual bool IsValidBitRate() const;

    /*
     * Set BitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_BitRate_LocalPtr &
     */
    virtual void SetBitRate(const Mp7JrsMediaFormatType_BitRate_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate BitRate element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBitRate();

    /*
     * Get TargetChannelBitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return unsigned
     */
    virtual unsigned GetTargetChannelBitRate() const;

    virtual bool IsValidTargetChannelBitRate() const;

    /*
     * Set TargetChannelBitRate element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item unsigned
     */
    virtual void SetTargetChannelBitRate(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TargetChannelBitRate element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTargetChannelBitRate();

    /*
     * Get ScalableCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr
     */
    virtual Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr GetScalableCoding() const;

    virtual bool IsValidScalableCoding() const;

    /*
     * Set ScalableCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr &
     */
    virtual void SetScalableCoding(const Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ScalableCoding element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateScalableCoding();

    /*
     * Get VisualCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_VisualCoding_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_LocalPtr GetVisualCoding() const;

    virtual bool IsValidVisualCoding() const;

    /*
     * Set VisualCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_VisualCoding_LocalPtr &
     */
    virtual void SetVisualCoding(const Mp7JrsMediaFormatType_VisualCoding_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate VisualCoding element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateVisualCoding();

    /*
     * Get AudioCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsMediaFormatType_AudioCoding_LocalPtr
     */
    virtual Mp7JrsMediaFormatType_AudioCoding_LocalPtr GetAudioCoding() const;

    virtual bool IsValidAudioCoding() const;

    /*
     * Set AudioCoding element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsMediaFormatType_AudioCoding_LocalPtr &
     */
    virtual void SetAudioCoding(const Mp7JrsMediaFormatType_AudioCoding_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate AudioCoding element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateAudioCoding();

    /*
     * Get SceneCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetSceneCodingFormat() const;

    virtual bool IsValidSceneCodingFormat() const;

    /*
     * Set SceneCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetSceneCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SceneCodingFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSceneCodingFormat();

    /*
     * Get GraphicsCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetGraphicsCodingFormat() const;

    virtual bool IsValidGraphicsCodingFormat() const;

    /*
     * Set GraphicsCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetGraphicsCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate GraphicsCodingFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGraphicsCodingFormat();

    /*
     * Get OtherCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetOtherCodingFormat() const;

    virtual bool IsValidOtherCodingFormat() const;

    /*
     * Set OtherCodingFormat element.
<br>
     * (Inherited from Mp7JrsMediaFormatType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetOtherCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate OtherCodingFormat element.
     * (Inherited from Mp7JrsMediaFormatType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOtherCodingFormat();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSourcePreferencesType_MediaFormat_LocalType();

protected:
    Mp7JrsSourcePreferencesType_MediaFormat_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsMediaFormatType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1959MP7JRSSOURCEPREFERENCESTYPE_MEDIAFORMAT_LOCALTYPE_H

