/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1993MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_INTEGRATEDCOORDINATESYSTEM_LOCALTYPE0_H
#define _1993MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_INTEGRATEDCOORDINATESYSTEM_LOCALTYPE0_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtInclude.h


#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType.h"
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0> Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr;

/** 
 * Generated interface IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 for class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0<br>
 * Located at: visual-2001.xsd, line 160<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0();
    virtual ~IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0();
    /**
     * Get modelType attribute.
     * @return Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration GetmodelType() const = 0;

    /**
     * Set modelType attribute.
     * @param item Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration
     */
    virtual void SetmodelType(Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get xOrigin attribute.
     * @return float
     */
    virtual float GetxOrigin() const = 0;

    /**
     * Set xOrigin attribute.
     * @param item float
     */
    virtual void SetxOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get yOrigin attribute.
     * @return float
     */
    virtual float GetyOrigin() const = 0;

    /**
     * Set yOrigin attribute.
     * @param item float
     */
    virtual void SetyOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType() const = 0;

    /**
     * Set Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr &
     */
    virtual void SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0<br>
 * Located at: visual-2001.xsd, line 160<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 160.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 :
        public IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0
{
    friend class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0Factory; // constructs objects

public:
    /*
     * Get modelType attribute.
     * @return Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration GetmodelType() const;

    /*
     * Set modelType attribute.
     * @param item Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration
     */
    virtual void SetmodelType(Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get xOrigin attribute.
     * @return float
     */
    virtual float GetxOrigin() const;

    /*
     * Set xOrigin attribute.
     * @param item float
     */
    virtual void SetxOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get yOrigin attribute.
     * @return float
     */
    virtual float GetyOrigin() const;

    /*
     * Set yOrigin attribute.
     * @param item float
     */
    virtual void SetyOrigin(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType() const;

    /*
     * Set Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr &
     */
    virtual void SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0();

protected:
    Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration m_modelType;
    float m_xOrigin;
    float m_yOrigin;


    Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType;

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1993MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_INTEGRATEDCOORDINATESYSTEM_LOCALTYPE0_H

