/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2011MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE1_H
#define _2011MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE1_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtInclude.h


class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0 > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1> Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr;

/** 
 * Generated interface IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 for class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1<br>
 * Located at: visual-2001.xsd, line 117<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();
    virtual ~IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();
    /**
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const = 0;

    /**
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get dataSet attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdataSet() const = 0;

    /**
     * Get dataSet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdataSet() const = 0;

    /**
     * Set dataSet attribute.
     * @param item XMLCh *
     */
    virtual void SetdataSet(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dataSet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedataSet() = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType() const = 0;

    /**
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr &
     */
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0() const = 0;

    /**
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr &
     */
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get MappingFunct element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr GetMappingFunct() const = 0;

    /**
     * Set MappingFunct element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr &
     */
    virtual void SetMappingFunct(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1<br>
 * Located at: visual-2001.xsd, line 117<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 117.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 :
        public IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1
{
    friend class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1Factory; // constructs objects

public:
    /*
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const;

    /*
     * Set name attribute.
     * @param item XMLCh *
     */
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get dataSet attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdataSet() const;

    /*
     * Get dataSet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdataSet() const;

    /*
     * Set dataSet attribute.
     * @param item XMLCh *
     */
    virtual void SetdataSet(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dataSet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedataSet();

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType() const;

    /*
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr &
     */
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0() const;

    /*
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr &
     */
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get MappingFunct element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr GetMappingFunct() const;

    /*
     * Set MappingFunct element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr &
     */
    virtual void SetMappingFunct(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();

protected:
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_name;
    XMLCh * m_dataSet;
    bool m_dataSet_Exist;


// DefinionChoice
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
// End DefinionChoice
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr m_MappingFunct;

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2011MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE1_H

