/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2021MP7JRSSPATIALMASKTYPE_H
#define _2021MP7JRSSPATIALMASKTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatialMaskTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpatialMaskType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMaskType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsMaskType;
class IMp7JrsSpatialMaskType;
class IMp7JrsSpatialMaskType_SubRegion_CollectionType;
typedef Mp7JrsPtr< IMp7JrsMaskType > Mp7JrsMaskPtr;
typedef Mp7JrsPtr< IMp7JrsSpatialMaskType_SubRegion_CollectionType > Mp7JrsSpatialMaskType_SubRegion_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpatialMaskType> Mp7JrsSpatialMaskPtr;

/** 
 * Generated interface IMp7JrsSpatialMaskType for class Mp7JrsSpatialMaskType<br>
 * Located at: mds-2001.xsd, line 2975<br>
 * Classified: Class<br>
 * Derived from: MaskType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatialMaskType 
 :
        public IMp7JrsMaskType
{
public:
    // TODO: make these protected?
    IMp7JrsSpatialMaskType();
    virtual ~IMp7JrsSpatialMaskType();
        /** @name Sequence

         */
        //@{
    /**
     * Get SubRegion element.
     * @return Mp7JrsSpatialMaskType_SubRegion_CollectionPtr
     */
    virtual Mp7JrsSpatialMaskType_SubRegion_CollectionPtr GetSubRegion() const = 0;

    /**
     * Set SubRegion element.
     * @param item const Mp7JrsSpatialMaskType_SubRegion_CollectionPtr &
     */
    virtual void SetSubRegion(const Mp7JrsSpatialMaskType_SubRegion_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatialMaskType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatialMaskType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatialMaskType<br>
 * Located at: mds-2001.xsd, line 2975<br>
 * Classified: Class<br>
 * Derived from: MaskType (Class)<br>
 * Defined in mds-2001.xsd, line 2975.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatialMaskType :
        public IMp7JrsSpatialMaskType
{
    friend class Mp7JrsSpatialMaskTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSpatialMaskType
     
     * @return Mp7JrsPtr< Mp7JrsMaskType >
     */
    virtual Mp7JrsPtr< Mp7JrsMaskType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get SubRegion element.
     * @return Mp7JrsSpatialMaskType_SubRegion_CollectionPtr
     */
    virtual Mp7JrsSpatialMaskType_SubRegion_CollectionPtr GetSubRegion() const;

    /*
     * Set SubRegion element.
     * @param item const Mp7JrsSpatialMaskType_SubRegion_CollectionPtr &
     */
    virtual void SetSubRegion(const Mp7JrsSpatialMaskType_SubRegion_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatialMaskType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatialMaskType();

protected:
    Mp7JrsSpatialMaskType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsMaskType > m_Base;

    Mp7JrsSpatialMaskType_SubRegion_CollectionPtr m_SubRegion;

// no includefile for extension defined 
// file Mp7JrsSpatialMaskType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2021MP7JRSSPATIALMASKTYPE_H

