/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2041MP7JRSSPEAKERINFOTYPE_H
#define _2041MP7JRSSPEAKERINFOTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpeakerInfoTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsSpeakerInfoType_provenance_LocalType.h"
class IMp7JrsHeaderType;
class IMp7JrsPersonType;
class IMp7JrsSpeakerInfoType;
class IMp7JrsSpeakerInfoType_PhoneIndex_LocalType;
class IMp7JrsSpeakerInfoType_WordIndex_LocalType;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType > Mp7JrsPersonPtr;
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_PhoneIndex_LocalType > Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_LocalType > Mp7JrsSpeakerInfoType_WordIndex_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType> Mp7JrsSpeakerInfoPtr;

/** 
 * Generated interface IMp7JrsSpeakerInfoType for class Mp7JrsSpeakerInfoType<br>
 * Located at: audio-2001.xsd, line 441<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSpeakerInfoType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsSpeakerInfoType();
    virtual ~IMp7JrsSpeakerInfoType();
    /**
     * Get phoneLexiconRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetphoneLexiconRef() const = 0;

    /**
     * Get phoneLexiconRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneLexiconRef() const = 0;

    /**
     * Set phoneLexiconRef attribute.
     * @param item XMLCh *
     */
    virtual void SetphoneLexiconRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate phoneLexiconRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneLexiconRef() = 0;

    /**
     * Get wordLexiconRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetwordLexiconRef() const = 0;

    /**
     * Get wordLexiconRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistwordLexiconRef() const = 0;

    /**
     * Set wordLexiconRef attribute.
     * @param item XMLCh *
     */
    virtual void SetwordLexiconRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate wordLexiconRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatewordLexiconRef() = 0;

    /**
     * Get confusionInfoRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetconfusionInfoRef() const = 0;

    /**
     * Get confusionInfoRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistconfusionInfoRef() const = 0;

    /**
     * Set confusionInfoRef attribute.
     * @param item XMLCh *
     */
    virtual void SetconfusionInfoRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confusionInfoRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateconfusionInfoRef() = 0;

    /**
     * Get descriptionMetadataRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdescriptionMetadataRef() const = 0;

    /**
     * Get descriptionMetadataRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdescriptionMetadataRef() const = 0;

    /**
     * Set descriptionMetadataRef attribute.
     * @param item XMLCh *
     */
    virtual void SetdescriptionMetadataRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate descriptionMetadataRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedescriptionMetadataRef() = 0;

    /**
     * Get provenance attribute.
     * @return Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration
     */
    virtual Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration Getprovenance() const = 0;

    /**
     * Set provenance attribute.
     * @param item Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration
     */
    virtual void Setprovenance(Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get SpokenLanguage element.
     * @return XMLCh *
     */
    virtual XMLCh * GetSpokenLanguage() const = 0;

    /**
     * Set SpokenLanguage element.
     * @param item XMLCh *
     */
    virtual void SetSpokenLanguage(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Person element.
     * @return Mp7JrsPersonPtr
     */
    virtual Mp7JrsPersonPtr GetPerson() const = 0;

    virtual bool IsValidPerson() const = 0;

    /**
     * Set Person element.
     * @param item const Mp7JrsPersonPtr &
     */
    virtual void SetPerson(const Mp7JrsPersonPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Person element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePerson() = 0;

    /**
     * Get WordIndex element.
     * @return Mp7JrsSpeakerInfoType_WordIndex_LocalPtr
     */
    virtual Mp7JrsSpeakerInfoType_WordIndex_LocalPtr GetWordIndex() const = 0;

    virtual bool IsValidWordIndex() const = 0;

    /**
     * Set WordIndex element.
     * @param item const Mp7JrsSpeakerInfoType_WordIndex_LocalPtr &
     */
    virtual void SetWordIndex(const Mp7JrsSpeakerInfoType_WordIndex_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate WordIndex element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateWordIndex() = 0;

    /**
     * Get PhoneIndex element.
     * @return Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr
     */
    virtual Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr GetPhoneIndex() const = 0;

    virtual bool IsValidPhoneIndex() const = 0;

    /**
     * Set PhoneIndex element.
     * @param item const Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr &
     */
    virtual void SetPhoneIndex(const Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate PhoneIndex element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePhoneIndex() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpeakerInfoType<br>
 * Located at: audio-2001.xsd, line 441<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in audio-2001.xsd, line 441.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpeakerInfoType :
        public IMp7JrsSpeakerInfoType
{
    friend class Mp7JrsSpeakerInfoTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSpeakerInfoType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
    /*
     * Get phoneLexiconRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetphoneLexiconRef() const;

    /*
     * Get phoneLexiconRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneLexiconRef() const;

    /*
     * Set phoneLexiconRef attribute.
     * @param item XMLCh *
     */
    virtual void SetphoneLexiconRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate phoneLexiconRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneLexiconRef();

    /*
     * Get wordLexiconRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetwordLexiconRef() const;

    /*
     * Get wordLexiconRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistwordLexiconRef() const;

    /*
     * Set wordLexiconRef attribute.
     * @param item XMLCh *
     */
    virtual void SetwordLexiconRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate wordLexiconRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatewordLexiconRef();

    /*
     * Get confusionInfoRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetconfusionInfoRef() const;

    /*
     * Get confusionInfoRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistconfusionInfoRef() const;

    /*
     * Set confusionInfoRef attribute.
     * @param item XMLCh *
     */
    virtual void SetconfusionInfoRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confusionInfoRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateconfusionInfoRef();

    /*
     * Get descriptionMetadataRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdescriptionMetadataRef() const;

    /*
     * Get descriptionMetadataRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdescriptionMetadataRef() const;

    /*
     * Set descriptionMetadataRef attribute.
     * @param item XMLCh *
     */
    virtual void SetdescriptionMetadataRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate descriptionMetadataRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedescriptionMetadataRef();

    /*
     * Get provenance attribute.
     * @return Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration
     */
    virtual Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration Getprovenance() const;

    /*
     * Set provenance attribute.
     * @param item Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration
     */
    virtual void Setprovenance(Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get SpokenLanguage element.
     * @return XMLCh *
     */
    virtual XMLCh * GetSpokenLanguage() const;

    /*
     * Set SpokenLanguage element.
     * @param item XMLCh *
     */
    virtual void SetSpokenLanguage(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Person element.
     * @return Mp7JrsPersonPtr
     */
    virtual Mp7JrsPersonPtr GetPerson() const;

    virtual bool IsValidPerson() const;

    /*
     * Set Person element.
     * @param item const Mp7JrsPersonPtr &
     */
    virtual void SetPerson(const Mp7JrsPersonPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Person element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePerson();

    /*
     * Get WordIndex element.
     * @return Mp7JrsSpeakerInfoType_WordIndex_LocalPtr
     */
    virtual Mp7JrsSpeakerInfoType_WordIndex_LocalPtr GetWordIndex() const;

    virtual bool IsValidWordIndex() const;

    /*
     * Set WordIndex element.
     * @param item const Mp7JrsSpeakerInfoType_WordIndex_LocalPtr &
     */
    virtual void SetWordIndex(const Mp7JrsSpeakerInfoType_WordIndex_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate WordIndex element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateWordIndex();

    /*
     * Get PhoneIndex element.
     * @return Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr
     */
    virtual Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr GetPhoneIndex() const;

    virtual bool IsValidPhoneIndex() const;

    /*
     * Set PhoneIndex element.
     * @param item const Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr &
     */
    virtual void SetPhoneIndex(const Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate PhoneIndex element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatePhoneIndex();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpeakerInfoType();

protected:
    Mp7JrsSpeakerInfoType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_phoneLexiconRef;
    bool m_phoneLexiconRef_Exist;
    XMLCh * m_wordLexiconRef;
    bool m_wordLexiconRef_Exist;
    XMLCh * m_confusionInfoRef;
    bool m_confusionInfoRef_Exist;
    XMLCh * m_descriptionMetadataRef;
    bool m_descriptionMetadataRef_Exist;
    Mp7JrsSpeakerInfoType_provenance_LocalType::Enumeration m_provenance;

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    XMLCh * m_SpokenLanguage;
    Mp7JrsPersonPtr m_Person;
    bool m_Person_Exist; // For optional elements 
    Mp7JrsSpeakerInfoType_WordIndex_LocalPtr m_WordIndex;
    bool m_WordIndex_Exist; // For optional elements 
    Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr m_PhoneIndex;
    bool m_PhoneIndex_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2041MP7JRSSPEAKERINFOTYPE_H

