/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2055MP7JRSSPEAKERINFOTYPE_WORDINDEX_LOCALTYPE_H
#define _2055MP7JRSSPEAKERINFOTYPE_WORDINDEX_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_WordIndex_LocalType_ExtInclude.h


class IMp7JrsSpeakerInfoType_WordIndex_LocalType;
class IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType;
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_LocalType> Mp7JrsSpeakerInfoType_WordIndex_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType > Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr;

/** 
 * Generated interface IMp7JrsSpeakerInfoType_WordIndex_LocalType for class Mp7JrsSpeakerInfoType_WordIndex_LocalType<br>
 * Located at: audio-2001.xsd, line 448<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSpeakerInfoType_WordIndex_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpeakerInfoType_WordIndex_LocalType();
    virtual ~IMp7JrsSpeakerInfoType_WordIndex_LocalType();
    /**
     * Get defaultLattice attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdefaultLattice() const = 0;

    /**
     * Set defaultLattice attribute.
     * @param item XMLCh *
     */
    virtual void SetdefaultLattice(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get WordIndexEntry element.
     * @return Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr
     */
    virtual Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr GetWordIndexEntry() const = 0;

    /**
     * Set WordIndexEntry element.
     * @param item const Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr &
     */
    virtual void SetWordIndexEntry(const Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_WordIndex_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_WordIndex_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpeakerInfoType_WordIndex_LocalType<br>
 * Located at: audio-2001.xsd, line 448<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 448.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpeakerInfoType_WordIndex_LocalType :
        public IMp7JrsSpeakerInfoType_WordIndex_LocalType
{
    friend class Mp7JrsSpeakerInfoType_WordIndex_LocalTypeFactory; // constructs objects

public:
    /*
     * Get defaultLattice attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdefaultLattice() const;

    /*
     * Set defaultLattice attribute.
     * @param item XMLCh *
     */
    virtual void SetdefaultLattice(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get WordIndexEntry element.
     * @return Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr
     */
    virtual Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr GetWordIndexEntry() const;

    /*
     * Set WordIndexEntry element.
     * @param item const Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr &
     */
    virtual void SetWordIndexEntry(const Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_WordIndex_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpeakerInfoType_WordIndex_LocalType();

protected:
    Mp7JrsSpeakerInfoType_WordIndex_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_defaultLattice;


    Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr m_WordIndexEntry;

// no includefile for extension defined 
// file Mp7JrsSpeakerInfoType_WordIndex_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2055MP7JRSSPEAKERINFOTYPE_WORDINDEX_LOCALTYPE_H

