/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2067MP7JRSSPOKENCONTENTHEADERTYPE_H
#define _2067MP7JRSSPOKENCONTENTHEADERTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpokenContentHeaderTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_ExtInclude.h


#include "Mp7JrsHeaderType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDescriptionMetadataType;
class IMp7JrsHeaderType;
class IMp7JrsSpokenContentHeaderType;
class IMp7JrsSpokenContentHeaderType_CollectionType;
class IMp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType;
class IMp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType;
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType > Mp7JrsDescriptionMetadataPtr;
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_CollectionType > Mp7JrsSpokenContentHeaderType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType > Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType > Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType> Mp7JrsSpokenContentHeaderPtr;

/** 
 * Generated interface IMp7JrsSpokenContentHeaderType for class Mp7JrsSpokenContentHeaderType<br>
 * Located at: audio-2001.xsd, line 420<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSpokenContentHeaderType 
 :
        public IMp7JrsHeaderType
{
public:
    // TODO: make these protected?
    IMp7JrsSpokenContentHeaderType();
    virtual ~IMp7JrsSpokenContentHeaderType();
        /** @name Sequence

         */
        //@{
    /**
     * Get SpokenContentHeaderType_LocalType element.
     * @return Mp7JrsSpokenContentHeaderType_CollectionPtr
     */
    virtual Mp7JrsSpokenContentHeaderType_CollectionPtr GetSpokenContentHeaderType_LocalType() const = 0;

    /**
     * Set SpokenContentHeaderType_LocalType element.
     * @param item const Mp7JrsSpokenContentHeaderType_CollectionPtr &
     */
    virtual void SetSpokenContentHeaderType_LocalType(const Mp7JrsSpokenContentHeaderType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ConfusionInfo element.
     * @return Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr
     */
    virtual Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr GetConfusionInfo() const = 0;

    /**
     * Set ConfusionInfo element.
     * @param item const Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr &
     */
    virtual void SetConfusionInfo(const Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DescriptionMetadata element.
     * @return Mp7JrsDescriptionMetadataPtr
     */
    virtual Mp7JrsDescriptionMetadataPtr GetDescriptionMetadata() const = 0;

    virtual bool IsValidDescriptionMetadata() const = 0;

    /**
     * Set DescriptionMetadata element.
     * @param item const Mp7JrsDescriptionMetadataPtr &
     */
    virtual void SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate DescriptionMetadata element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDescriptionMetadata() = 0;

    /**
     * Get SpeakerInfo element.
     * @return Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr
     */
    virtual Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr GetSpeakerInfo() const = 0;

    /**
     * Set SpeakerInfo element.
     * @param item const Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr &
     */
    virtual void SetSpeakerInfo(const Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpokenContentHeaderType<br>
 * Located at: audio-2001.xsd, line 420<br>
 * Classified: Class<br>
 * Derived from: HeaderType (Class)<br>
 * Defined in audio-2001.xsd, line 420.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpokenContentHeaderType :
        public IMp7JrsSpokenContentHeaderType
{
    friend class Mp7JrsSpokenContentHeaderTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSpokenContentHeaderType
     
     * @return Mp7JrsPtr< Mp7JrsHeaderType >
     */
    virtual Mp7JrsPtr< Mp7JrsHeaderType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get SpokenContentHeaderType_LocalType element.
     * @return Mp7JrsSpokenContentHeaderType_CollectionPtr
     */
    virtual Mp7JrsSpokenContentHeaderType_CollectionPtr GetSpokenContentHeaderType_LocalType() const;

    /*
     * Set SpokenContentHeaderType_LocalType element.
     * @param item const Mp7JrsSpokenContentHeaderType_CollectionPtr &
     */
    virtual void SetSpokenContentHeaderType_LocalType(const Mp7JrsSpokenContentHeaderType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ConfusionInfo element.
     * @return Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr
     */
    virtual Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr GetConfusionInfo() const;

    /*
     * Set ConfusionInfo element.
     * @param item const Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr &
     */
    virtual void SetConfusionInfo(const Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DescriptionMetadata element.
     * @return Mp7JrsDescriptionMetadataPtr
     */
    virtual Mp7JrsDescriptionMetadataPtr GetDescriptionMetadata() const;

    virtual bool IsValidDescriptionMetadata() const;

    /*
     * Set DescriptionMetadata element.
     * @param item const Mp7JrsDescriptionMetadataPtr &
     */
    virtual void SetDescriptionMetadata(const Mp7JrsDescriptionMetadataPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate DescriptionMetadata element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateDescriptionMetadata();

    /*
     * Get SpeakerInfo element.
     * @return Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr
     */
    virtual Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr GetSpeakerInfo() const;

    /*
     * Set SpeakerInfo element.
     * @param item const Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr &
     */
    virtual void SetSpeakerInfo(const Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsHeaderType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsHeaderType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsHeaderType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpokenContentHeaderType();

protected:
    Mp7JrsSpokenContentHeaderType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsHeaderType > m_Base;

    Mp7JrsSpokenContentHeaderType_CollectionPtr m_SpokenContentHeaderType_LocalType;
    Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr m_ConfusionInfo;
    Mp7JrsDescriptionMetadataPtr m_DescriptionMetadata;
    bool m_DescriptionMetadata_Exist; // For optional elements 
    Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr m_SpeakerInfo;

// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2067MP7JRSSPOKENCONTENTHEADERTYPE_H

