/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2073MP7JRSSPOKENCONTENTHEADERTYPE_LOCALTYPE_H
#define _2073MP7JRSSPOKENCONTENTHEADERTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpokenContentHeaderType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_LocalType_ExtInclude.h


class IMp7JrsPhoneLexiconType;
class IMp7JrsSpokenContentHeaderType_LocalType;
class IMp7JrsWordLexiconType;
typedef Mp7JrsPtr< IMp7JrsPhoneLexiconType > Mp7JrsPhoneLexiconPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_LocalType> Mp7JrsSpokenContentHeaderType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsWordLexiconType > Mp7JrsWordLexiconPtr;

/** 
 * Generated interface IMp7JrsSpokenContentHeaderType_LocalType for class Mp7JrsSpokenContentHeaderType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSpokenContentHeaderType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpokenContentHeaderType_LocalType();
    virtual ~IMp7JrsSpokenContentHeaderType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get WordLexicon element.
     * @return Mp7JrsWordLexiconPtr
     */
    virtual Mp7JrsWordLexiconPtr GetWordLexicon() const = 0;

    /**
     * Set WordLexicon element.
     * @param item const Mp7JrsWordLexiconPtr &
     */
    virtual void SetWordLexicon(const Mp7JrsWordLexiconPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PhoneLexicon element.
     * @return Mp7JrsPhoneLexiconPtr
     */
    virtual Mp7JrsPhoneLexiconPtr GetPhoneLexicon() const = 0;

    /**
     * Set PhoneLexicon element.
     * @param item const Mp7JrsPhoneLexiconPtr &
     */
    virtual void SetPhoneLexicon(const Mp7JrsPhoneLexiconPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpokenContentHeaderType_LocalType<br>
 * Defined in audio-2001.xsd, line 424.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpokenContentHeaderType_LocalType :
        public IMp7JrsSpokenContentHeaderType_LocalType
{
    friend class Mp7JrsSpokenContentHeaderType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get WordLexicon element.
     * @return Mp7JrsWordLexiconPtr
     */
    virtual Mp7JrsWordLexiconPtr GetWordLexicon() const;

    /*
     * Set WordLexicon element.
     * @param item const Mp7JrsWordLexiconPtr &
     */
    virtual void SetWordLexicon(const Mp7JrsWordLexiconPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PhoneLexicon element.
     * @return Mp7JrsPhoneLexiconPtr
     */
    virtual Mp7JrsPhoneLexiconPtr GetPhoneLexicon() const;

    /*
     * Set PhoneLexicon element.
     * @param item const Mp7JrsPhoneLexiconPtr &
     */
    virtual void SetPhoneLexicon(const Mp7JrsPhoneLexiconPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpokenContentHeaderType_LocalType();

protected:
    Mp7JrsSpokenContentHeaderType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsWordLexiconPtr m_WordLexicon;
    Mp7JrsPhoneLexiconPtr m_PhoneLexicon;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSpokenContentHeaderType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2073MP7JRSSPOKENCONTENTHEADERTYPE_LOCALTYPE_H

