/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2085MP7JRSSPOKENCONTENTLATTICETYPE_BLOCK_LOCALTYPE_H
#define _2085MP7JRSSPOKENCONTENTLATTICETYPE_BLOCK_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpokenContentLatticeType_Block_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtInclude.h


#include "Mp7JrsSpokenContentLatticeType_Block_audio_LocalType.h"
class IMp7JrsMediaTimeType;
class IMp7JrsSpokenContentLatticeType_Block_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_Node_CollectionType;
class IMp7Jrsunsigned16;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_LocalType> Mp7JrsSpokenContentLatticeType_Block_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_CollectionType > Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned16 > Mp7Jrsunsigned16Ptr;

/** 
 * Generated interface IMp7JrsSpokenContentLatticeType_Block_LocalType for class Mp7JrsSpokenContentLatticeType_Block_LocalType<br>
 * Located at: audio-2001.xsd, line 601<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSpokenContentLatticeType_Block_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpokenContentLatticeType_Block_LocalType();
    virtual ~IMp7JrsSpokenContentLatticeType_Block_LocalType();
    /**
     * Get defaultSpeakerInfoRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdefaultSpeakerInfoRef() const = 0;

    /**
     * Set defaultSpeakerInfoRef attribute.
     * @param item XMLCh *
     */
    virtual void SetdefaultSpeakerInfoRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get num attribute.
     * @return Mp7Jrsunsigned16Ptr
     */
    virtual Mp7Jrsunsigned16Ptr Getnum() const = 0;

    /**
     * Set num attribute.
     * @param item const Mp7Jrsunsigned16Ptr &
     */
    virtual void Setnum(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get audio attribute.
     * @return Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration Getaudio() const = 0;

    /**
     * Get audio attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existaudio() const = 0;

    /**
     * Set audio attribute.
     * @param item Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration
     */
    virtual void Setaudio(Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate audio attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateaudio() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const = 0;

    /**
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Node element.
     * @return Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr GetNode() const = 0;

    /**
     * Set Node element.
     * @param item const Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr &
     */
    virtual void SetNode(const Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpokenContentLatticeType_Block_LocalType<br>
 * Located at: audio-2001.xsd, line 601<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 601.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpokenContentLatticeType_Block_LocalType :
        public IMp7JrsSpokenContentLatticeType_Block_LocalType
{
    friend class Mp7JrsSpokenContentLatticeType_Block_LocalTypeFactory; // constructs objects

public:
    /*
     * Get defaultSpeakerInfoRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdefaultSpeakerInfoRef() const;

    /*
     * Set defaultSpeakerInfoRef attribute.
     * @param item XMLCh *
     */
    virtual void SetdefaultSpeakerInfoRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get num attribute.
     * @return Mp7Jrsunsigned16Ptr
     */
    virtual Mp7Jrsunsigned16Ptr Getnum() const;

    /*
     * Set num attribute.
     * @param item const Mp7Jrsunsigned16Ptr &
     */
    virtual void Setnum(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get audio attribute.
     * @return Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration Getaudio() const;

    /*
     * Get audio attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existaudio() const;

    /*
     * Set audio attribute.
     * @param item Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration
     */
    virtual void Setaudio(Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate audio attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateaudio();

        /* @name Sequence

         */
        //@{
    /*
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const;

    /*
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Node element.
     * @return Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr GetNode() const;

    /*
     * Set Node element.
     * @param item const Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr &
     */
    virtual void SetNode(const Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpokenContentLatticeType_Block_LocalType();

protected:
    Mp7JrsSpokenContentLatticeType_Block_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_defaultSpeakerInfoRef;
    Mp7Jrsunsigned16Ptr m_num;
    Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration m_audio;
    bool m_audio_Exist;
    Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration m_audio_Default;


    Mp7JrsMediaTimePtr m_MediaTime;
    Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr m_Node;

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2085MP7JRSSPOKENCONTENTLATTICETYPE_BLOCK_LOCALTYPE_H

