/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2089MP7JRSSPOKENCONTENTLATTICETYPE_BLOCK_NODE_LOCALTYPE_H
#define _2089MP7JRSSPOKENCONTENTLATTICETYPE_BLOCK_NODE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtInclude.h


class IMp7JrsSpokenContentLatticeType_Block_Node_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType;
class IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType;
class IMp7Jrsunsigned16;
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_LocalType> Mp7JrsSpokenContentLatticeType_Block_Node_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType > Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType > Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned16 > Mp7Jrsunsigned16Ptr;

/** 
 * Generated interface IMp7JrsSpokenContentLatticeType_Block_Node_LocalType for class Mp7JrsSpokenContentLatticeType_Block_Node_LocalType<br>
 * Located at: audio-2001.xsd, line 605<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSpokenContentLatticeType_Block_Node_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpokenContentLatticeType_Block_Node_LocalType();
    virtual ~IMp7JrsSpokenContentLatticeType_Block_Node_LocalType();
    /**
     * Get num attribute.
     * @return Mp7Jrsunsigned16Ptr
     */
    virtual Mp7Jrsunsigned16Ptr Getnum() const = 0;

    /**
     * Set num attribute.
     * @param item const Mp7Jrsunsigned16Ptr &
     */
    virtual void Setnum(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get timeOffset attribute.
     * @return Mp7Jrsunsigned16Ptr
     */
    virtual Mp7Jrsunsigned16Ptr GettimeOffset() const = 0;

    /**
     * Set timeOffset attribute.
     * @param item const Mp7Jrsunsigned16Ptr &
     */
    virtual void SettimeOffset(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get speakerInfoRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetspeakerInfoRef() const = 0;

    /**
     * Get speakerInfoRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistspeakerInfoRef() const = 0;

    /**
     * Set speakerInfoRef attribute.
     * @param item XMLCh *
     */
    virtual void SetspeakerInfoRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate speakerInfoRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatespeakerInfoRef() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get WordLink element.
     * @return Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr GetWordLink() const = 0;

    /**
     * Set WordLink element.
     * @param item const Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr &
     */
    virtual void SetWordLink(const Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PhoneLink element.
     * @return Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr GetPhoneLink() const = 0;

    /**
     * Set PhoneLink element.
     * @param item const Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr &
     */
    virtual void SetPhoneLink(const Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpokenContentLatticeType_Block_Node_LocalType<br>
 * Located at: audio-2001.xsd, line 605<br>
 * Classified: Class<br>
 * Defined in audio-2001.xsd, line 605.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpokenContentLatticeType_Block_Node_LocalType :
        public IMp7JrsSpokenContentLatticeType_Block_Node_LocalType
{
    friend class Mp7JrsSpokenContentLatticeType_Block_Node_LocalTypeFactory; // constructs objects

public:
    /*
     * Get num attribute.
     * @return Mp7Jrsunsigned16Ptr
     */
    virtual Mp7Jrsunsigned16Ptr Getnum() const;

    /*
     * Set num attribute.
     * @param item const Mp7Jrsunsigned16Ptr &
     */
    virtual void Setnum(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get timeOffset attribute.
     * @return Mp7Jrsunsigned16Ptr
     */
    virtual Mp7Jrsunsigned16Ptr GettimeOffset() const;

    /*
     * Set timeOffset attribute.
     * @param item const Mp7Jrsunsigned16Ptr &
     */
    virtual void SettimeOffset(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get speakerInfoRef attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetspeakerInfoRef() const;

    /*
     * Get speakerInfoRef attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistspeakerInfoRef() const;

    /*
     * Set speakerInfoRef attribute.
     * @param item XMLCh *
     */
    virtual void SetspeakerInfoRef(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate speakerInfoRef attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatespeakerInfoRef();

        /* @name Sequence

         */
        //@{
    /*
     * Get WordLink element.
     * @return Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr GetWordLink() const;

    /*
     * Set WordLink element.
     * @param item const Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr &
     */
    virtual void SetWordLink(const Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PhoneLink element.
     * @return Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr
     */
    virtual Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr GetPhoneLink() const;

    /*
     * Set PhoneLink element.
     * @param item const Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr &
     */
    virtual void SetPhoneLink(const Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpokenContentLatticeType_Block_Node_LocalType();

protected:
    Mp7JrsSpokenContentLatticeType_Block_Node_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7Jrsunsigned16Ptr m_num;
    Mp7Jrsunsigned16Ptr m_timeOffset;
    XMLCh * m_speakerInfoRef;
    bool m_speakerInfoRef_Exist;


    Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr m_WordLink;
    Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr m_PhoneLink;

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2089MP7JRSSPOKENCONTENTLATTICETYPE_BLOCK_NODE_LOCALTYPE_H

