/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2133MP7JRSSTRUCTUREDANNOTATIONTYPE_H
#define _2133MP7JRSSTRUCTUREDANNOTATIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsStructuredAnnotationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsStructuredAnnotationType_ExtInclude.h


class IMp7JrsStructuredAnnotationType;
class IMp7JrsStructuredAnnotationType_How_CollectionType;
class IMp7JrsStructuredAnnotationType_WhatAction_CollectionType;
class IMp7JrsStructuredAnnotationType_WhatObject_CollectionType;
class IMp7JrsStructuredAnnotationType_When_CollectionType;
class IMp7JrsStructuredAnnotationType_Where_CollectionType;
class IMp7JrsStructuredAnnotationType_Who_CollectionType;
class IMp7JrsStructuredAnnotationType_Why_CollectionType;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_How_CollectionType > Mp7JrsStructuredAnnotationType_How_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_WhatAction_CollectionType > Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_WhatObject_CollectionType > Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_When_CollectionType > Mp7JrsStructuredAnnotationType_When_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_Where_CollectionType > Mp7JrsStructuredAnnotationType_Where_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_Who_CollectionType > Mp7JrsStructuredAnnotationType_Who_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_Why_CollectionType > Mp7JrsStructuredAnnotationType_Why_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType> Mp7JrsStructuredAnnotationPtr;

/** 
 * Generated interface IMp7JrsStructuredAnnotationType for class Mp7JrsStructuredAnnotationType<br>
 * Located at: mds-2001.xsd, line 1195<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsStructuredAnnotationType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsStructuredAnnotationType();
    virtual ~IMp7JrsStructuredAnnotationType();
    /**
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Who element.
     * @return Mp7JrsStructuredAnnotationType_Who_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_Who_CollectionPtr GetWho() const = 0;

    /**
     * Set Who element.
     * @param item const Mp7JrsStructuredAnnotationType_Who_CollectionPtr &
     */
    virtual void SetWho(const Mp7JrsStructuredAnnotationType_Who_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get WhatObject element.
     * @return Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr GetWhatObject() const = 0;

    /**
     * Set WhatObject element.
     * @param item const Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr &
     */
    virtual void SetWhatObject(const Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get WhatAction element.
     * @return Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr GetWhatAction() const = 0;

    /**
     * Set WhatAction element.
     * @param item const Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr &
     */
    virtual void SetWhatAction(const Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Where element.
     * @return Mp7JrsStructuredAnnotationType_Where_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_Where_CollectionPtr GetWhere() const = 0;

    /**
     * Set Where element.
     * @param item const Mp7JrsStructuredAnnotationType_Where_CollectionPtr &
     */
    virtual void SetWhere(const Mp7JrsStructuredAnnotationType_Where_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get When element.
     * @return Mp7JrsStructuredAnnotationType_When_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_When_CollectionPtr GetWhen() const = 0;

    /**
     * Set When element.
     * @param item const Mp7JrsStructuredAnnotationType_When_CollectionPtr &
     */
    virtual void SetWhen(const Mp7JrsStructuredAnnotationType_When_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Why element.
     * @return Mp7JrsStructuredAnnotationType_Why_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_Why_CollectionPtr GetWhy() const = 0;

    /**
     * Set Why element.
     * @param item const Mp7JrsStructuredAnnotationType_Why_CollectionPtr &
     */
    virtual void SetWhy(const Mp7JrsStructuredAnnotationType_Why_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get How element.
     * @return Mp7JrsStructuredAnnotationType_How_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_How_CollectionPtr GetHow() const = 0;

    /**
     * Set How element.
     * @param item const Mp7JrsStructuredAnnotationType_How_CollectionPtr &
     */
    virtual void SetHow(const Mp7JrsStructuredAnnotationType_How_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsStructuredAnnotationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsStructuredAnnotationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsStructuredAnnotationType<br>
 * Located at: mds-2001.xsd, line 1195<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 1195.<br>
 */
class MP7JRS_EXPORT Mp7JrsStructuredAnnotationType :
        public IMp7JrsStructuredAnnotationType
{
    friend class Mp7JrsStructuredAnnotationTypeFactory; // constructs objects

public:
    /*
     * Get lang attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

        /* @name Sequence

         */
        //@{
    /*
     * Get Who element.
     * @return Mp7JrsStructuredAnnotationType_Who_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_Who_CollectionPtr GetWho() const;

    /*
     * Set Who element.
     * @param item const Mp7JrsStructuredAnnotationType_Who_CollectionPtr &
     */
    virtual void SetWho(const Mp7JrsStructuredAnnotationType_Who_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get WhatObject element.
     * @return Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr GetWhatObject() const;

    /*
     * Set WhatObject element.
     * @param item const Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr &
     */
    virtual void SetWhatObject(const Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get WhatAction element.
     * @return Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr GetWhatAction() const;

    /*
     * Set WhatAction element.
     * @param item const Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr &
     */
    virtual void SetWhatAction(const Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Where element.
     * @return Mp7JrsStructuredAnnotationType_Where_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_Where_CollectionPtr GetWhere() const;

    /*
     * Set Where element.
     * @param item const Mp7JrsStructuredAnnotationType_Where_CollectionPtr &
     */
    virtual void SetWhere(const Mp7JrsStructuredAnnotationType_Where_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get When element.
     * @return Mp7JrsStructuredAnnotationType_When_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_When_CollectionPtr GetWhen() const;

    /*
     * Set When element.
     * @param item const Mp7JrsStructuredAnnotationType_When_CollectionPtr &
     */
    virtual void SetWhen(const Mp7JrsStructuredAnnotationType_When_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Why element.
     * @return Mp7JrsStructuredAnnotationType_Why_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_Why_CollectionPtr GetWhy() const;

    /*
     * Set Why element.
     * @param item const Mp7JrsStructuredAnnotationType_Why_CollectionPtr &
     */
    virtual void SetWhy(const Mp7JrsStructuredAnnotationType_Why_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get How element.
     * @return Mp7JrsStructuredAnnotationType_How_CollectionPtr
     */
    virtual Mp7JrsStructuredAnnotationType_How_CollectionPtr GetHow() const;

    /*
     * Set How element.
     * @param item const Mp7JrsStructuredAnnotationType_How_CollectionPtr &
     */
    virtual void SetHow(const Mp7JrsStructuredAnnotationType_How_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsStructuredAnnotationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsStructuredAnnotationType();

protected:
    Mp7JrsStructuredAnnotationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_lang;
    bool m_lang_Exist;


    Mp7JrsStructuredAnnotationType_Who_CollectionPtr m_Who;
    Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr m_WhatObject;
    Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr m_WhatAction;
    Mp7JrsStructuredAnnotationType_Where_CollectionPtr m_Where;
    Mp7JrsStructuredAnnotationType_When_CollectionPtr m_When;
    Mp7JrsStructuredAnnotationType_Why_CollectionPtr m_Why;
    Mp7JrsStructuredAnnotationType_How_CollectionPtr m_How;

// no includefile for extension defined 
// file Mp7JrsStructuredAnnotationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2133MP7JRSSTRUCTUREDANNOTATIONTYPE_H

