/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2185MP7JRSSUMMARYPREFERENCESTYPE_H
#define _2185MP7JRSSUMMARYPREFERENCESTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSummaryPreferencesTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrspreferenceValueType;
class IMp7JrsSummaryPreferencesType;
class IMp7JrsSummaryPreferencesType_SummaryTheme_CollectionType;
class IMp7JrsSummaryPreferencesType_SummaryType_CollectionType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryTheme_CollectionType > Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryType_CollectionType > Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType> Mp7JrsSummaryPreferencesPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsSummaryPreferencesType for class Mp7JrsSummaryPreferencesType<br>
 * Located at: mds-2001.xsd, line 6206<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSummaryPreferencesType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsSummaryPreferencesType();
    virtual ~IMp7JrsSummaryPreferencesType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get SummaryType element.
     * @return Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr
     */
    virtual Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr GetSummaryType() const = 0;

    /**
     * Set SummaryType element.
     * @param item const Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr &
     */
    virtual void SetSummaryType(const Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SummaryTheme element.
     * @return Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr
     */
    virtual Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr GetSummaryTheme() const = 0;

    /**
     * Set SummaryTheme element.
     * @param item const Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr &
     */
    virtual void SetSummaryTheme(const Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SummaryDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetSummaryDuration() const = 0;

    virtual bool IsValidSummaryDuration() const = 0;

    /**
     * Set SummaryDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetSummaryDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate SummaryDuration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSummaryDuration() = 0;

    /**
     * Get MinSummaryDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetMinSummaryDuration() const = 0;

    virtual bool IsValidMinSummaryDuration() const = 0;

    /**
     * Set MinSummaryDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetMinSummaryDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MinSummaryDuration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMinSummaryDuration() = 0;

    /**
     * Get MaxSummaryDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetMaxSummaryDuration() const = 0;

    virtual bool IsValidMaxSummaryDuration() const = 0;

    /**
     * Set MaxSummaryDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetMaxSummaryDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MaxSummaryDuration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMaxSummaryDuration() = 0;

    /**
     * Get NumOfKeyFrames element.
     * @return unsigned
     */
    virtual unsigned GetNumOfKeyFrames() const = 0;

    virtual bool IsValidNumOfKeyFrames() const = 0;

    /**
     * Set NumOfKeyFrames element.
     * @param item unsigned
     */
    virtual void SetNumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate NumOfKeyFrames element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateNumOfKeyFrames() = 0;

    /**
     * Get MinNumOfKeyFrames element.
     * @return unsigned
     */
    virtual unsigned GetMinNumOfKeyFrames() const = 0;

    virtual bool IsValidMinNumOfKeyFrames() const = 0;

    /**
     * Set MinNumOfKeyFrames element.
     * @param item unsigned
     */
    virtual void SetMinNumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MinNumOfKeyFrames element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMinNumOfKeyFrames() = 0;

    /**
     * Get MaxNumOfKeyFrames element.
     * @return unsigned
     */
    virtual unsigned GetMaxNumOfKeyFrames() const = 0;

    virtual bool IsValidMaxNumOfKeyFrames() const = 0;

    /**
     * Set MaxNumOfKeyFrames element.
     * @param item unsigned
     */
    virtual void SetMaxNumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MaxNumOfKeyFrames element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMaxNumOfKeyFrames() = 0;

    /**
     * Get NumOfChars element.
     * @return unsigned
     */
    virtual unsigned GetNumOfChars() const = 0;

    virtual bool IsValidNumOfChars() const = 0;

    /**
     * Set NumOfChars element.
     * @param item unsigned
     */
    virtual void SetNumOfChars(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate NumOfChars element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateNumOfChars() = 0;

    /**
     * Get MinNumOfChars element.
     * @return unsigned
     */
    virtual unsigned GetMinNumOfChars() const = 0;

    virtual bool IsValidMinNumOfChars() const = 0;

    /**
     * Set MinNumOfChars element.
     * @param item unsigned
     */
    virtual void SetMinNumOfChars(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MinNumOfChars element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMinNumOfChars() = 0;

    /**
     * Get MaxNumOfChars element.
     * @return unsigned
     */
    virtual unsigned GetMaxNumOfChars() const = 0;

    virtual bool IsValidMaxNumOfChars() const = 0;

    /**
     * Set MaxNumOfChars element.
     * @param item unsigned
     */
    virtual void SetMaxNumOfChars(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MaxNumOfChars element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMaxNumOfChars() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSummaryPreferencesType<br>
 * Located at: mds-2001.xsd, line 6206<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 6206.<br>
 */
class MP7JRS_EXPORT Mp7JrsSummaryPreferencesType :
        public IMp7JrsSummaryPreferencesType
{
    friend class Mp7JrsSummaryPreferencesTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSummaryPreferencesType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

        /* @name Sequence

         */
        //@{
    /*
     * Get SummaryType element.
     * @return Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr
     */
    virtual Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr GetSummaryType() const;

    /*
     * Set SummaryType element.
     * @param item const Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr &
     */
    virtual void SetSummaryType(const Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SummaryTheme element.
     * @return Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr
     */
    virtual Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr GetSummaryTheme() const;

    /*
     * Set SummaryTheme element.
     * @param item const Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr &
     */
    virtual void SetSummaryTheme(const Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SummaryDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetSummaryDuration() const;

    virtual bool IsValidSummaryDuration() const;

    /*
     * Set SummaryDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetSummaryDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate SummaryDuration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSummaryDuration();

    /*
     * Get MinSummaryDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetMinSummaryDuration() const;

    virtual bool IsValidMinSummaryDuration() const;

    /*
     * Set MinSummaryDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetMinSummaryDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MinSummaryDuration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMinSummaryDuration();

    /*
     * Get MaxSummaryDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetMaxSummaryDuration() const;

    virtual bool IsValidMaxSummaryDuration() const;

    /*
     * Set MaxSummaryDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetMaxSummaryDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MaxSummaryDuration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMaxSummaryDuration();

    /*
     * Get NumOfKeyFrames element.
     * @return unsigned
     */
    virtual unsigned GetNumOfKeyFrames() const;

    virtual bool IsValidNumOfKeyFrames() const;

    /*
     * Set NumOfKeyFrames element.
     * @param item unsigned
     */
    virtual void SetNumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate NumOfKeyFrames element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateNumOfKeyFrames();

    /*
     * Get MinNumOfKeyFrames element.
     * @return unsigned
     */
    virtual unsigned GetMinNumOfKeyFrames() const;

    virtual bool IsValidMinNumOfKeyFrames() const;

    /*
     * Set MinNumOfKeyFrames element.
     * @param item unsigned
     */
    virtual void SetMinNumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MinNumOfKeyFrames element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMinNumOfKeyFrames();

    /*
     * Get MaxNumOfKeyFrames element.
     * @return unsigned
     */
    virtual unsigned GetMaxNumOfKeyFrames() const;

    virtual bool IsValidMaxNumOfKeyFrames() const;

    /*
     * Set MaxNumOfKeyFrames element.
     * @param item unsigned
     */
    virtual void SetMaxNumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MaxNumOfKeyFrames element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMaxNumOfKeyFrames();

    /*
     * Get NumOfChars element.
     * @return unsigned
     */
    virtual unsigned GetNumOfChars() const;

    virtual bool IsValidNumOfChars() const;

    /*
     * Set NumOfChars element.
     * @param item unsigned
     */
    virtual void SetNumOfChars(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate NumOfChars element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateNumOfChars();

    /*
     * Get MinNumOfChars element.
     * @return unsigned
     */
    virtual unsigned GetMinNumOfChars() const;

    virtual bool IsValidMinNumOfChars() const;

    /*
     * Set MinNumOfChars element.
     * @param item unsigned
     */
    virtual void SetMinNumOfChars(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MinNumOfChars element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMinNumOfChars();

    /*
     * Get MaxNumOfChars element.
     * @return unsigned
     */
    virtual unsigned GetMaxNumOfChars() const;

    virtual bool IsValidMaxNumOfChars() const;

    /*
     * Set MaxNumOfChars element.
     * @param item unsigned
     */
    virtual void SetMaxNumOfChars(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MaxNumOfChars element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMaxNumOfChars();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSummaryPreferencesType();

protected:
    Mp7JrsSummaryPreferencesType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr m_SummaryType;
    Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr m_SummaryTheme;
    Mp7JrsmediaDurationPtr m_SummaryDuration;
    bool m_SummaryDuration_Exist; // For optional elements 
    Mp7JrsmediaDurationPtr m_MinSummaryDuration;
    bool m_MinSummaryDuration_Exist; // For optional elements 
    Mp7JrsmediaDurationPtr m_MaxSummaryDuration;
    bool m_MaxSummaryDuration_Exist; // For optional elements 
    unsigned m_NumOfKeyFrames;
    bool m_NumOfKeyFrames_Exist; // For optional elements 
    unsigned m_MinNumOfKeyFrames;
    bool m_MinNumOfKeyFrames_Exist; // For optional elements 
    unsigned m_MaxNumOfKeyFrames;
    bool m_MaxNumOfKeyFrames_Exist; // For optional elements 
    unsigned m_NumOfChars;
    bool m_NumOfChars_Exist; // For optional elements 
    unsigned m_MinNumOfChars;
    bool m_MinNumOfChars_Exist; // For optional elements 
    unsigned m_MaxNumOfChars;
    bool m_MaxNumOfChars_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2185MP7JRSSUMMARYPREFERENCESTYPE_H

