/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2193MP7JRSSUMMARYPREFERENCESTYPE_SUMMARYTYPE_LOCALTYPE_H
#define _2193MP7JRSSUMMARYPREFERENCESTYPE_SUMMARYTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSummaryPreferencesType_SummaryType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryType_LocalType_ExtInclude.h


#include "Mp7JrssummaryComponentType.h"
#include "Mp7JrssummaryComponentType_LocalType.h"
class IMp7JrspreferenceValueType;
class IMp7JrssummaryComponentType;
class IMp7JrssummaryComponentType_LocalType0;
class IMp7JrssummaryComponentType_LocalType1;
class IMp7JrsSummaryPreferencesType_SummaryType_LocalType;
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;
typedef Mp7JrsPtr< IMp7JrssummaryComponentType > Mp7JrssummaryComponentPtr;
typedef Mp7JrsPtr< IMp7JrssummaryComponentType_LocalType0 > Mp7JrssummaryComponentType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrssummaryComponentType_LocalType1 > Mp7JrssummaryComponentType_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryType_LocalType> Mp7JrsSummaryPreferencesType_SummaryType_LocalPtr;

/** 
 * Generated interface IMp7JrsSummaryPreferencesType_SummaryType_LocalType for class Mp7JrsSummaryPreferencesType_SummaryType_LocalType<br>
 * Located at: mds-2001.xsd, line 6211<br>
 * Classified: Class<br>
 * Derived from: summaryComponentType (Class)<br>
 * Derived from: summaryComponentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSummaryPreferencesType_SummaryType_LocalType 
 :
        public IMp7JrssummaryComponentType
{
public:
    // TODO: make these protected?
    IMp7JrsSummaryPreferencesType_SummaryType_LocalType();
    virtual ~IMp7JrsSummaryPreferencesType_SummaryType_LocalType();
    /**
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const = 0;

    /**
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const = 0;

    /**
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue() = 0;

    /** @name Union

     */
    //@{
    /**
     * Get Mp7JrssummaryComponentType_LocalType element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @return Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual Mp7JrssummaryComponentType_LocalType::Enumeration GetsummaryComponentType_LocalType() const = 0;

    /**
     * Set Mp7JrssummaryComponentType_LocalType element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @param item Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual void SetsummaryComponentType_LocalType(Mp7JrssummaryComponentType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrssummaryComponentType_LocalType0 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @return Mp7JrssummaryComponentType_Local0Ptr
     */
    virtual Mp7JrssummaryComponentType_Local0Ptr GetsummaryComponentType_LocalType0() const = 0;

    /**
     * Set Mp7JrssummaryComponentType_LocalType0 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @param item const Mp7JrssummaryComponentType_Local0Ptr &
     */
    virtual void SetsummaryComponentType_LocalType0(const Mp7JrssummaryComponentType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrssummaryComponentType_LocalType1 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @return Mp7JrssummaryComponentType_Local1Ptr
     */
    virtual Mp7JrssummaryComponentType_Local1Ptr GetsummaryComponentType_LocalType1() const = 0;

    /**
     * Set Mp7JrssummaryComponentType_LocalType1 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @param item const Mp7JrssummaryComponentType_Local1Ptr &
     */
    virtual void SetsummaryComponentType_LocalType1(const Mp7JrssummaryComponentType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    //@}
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSummaryPreferencesType_SummaryType_LocalType<br>
 * Located at: mds-2001.xsd, line 6211<br>
 * Classified: Class<br>
 * Derived from: summaryComponentType (Class)<br>
 * Derived from: summaryComponentType (Class)<br>
 * Defined in mds-2001.xsd, line 6211.<br>
 */
class MP7JRS_EXPORT Mp7JrsSummaryPreferencesType_SummaryType_LocalType :
        public IMp7JrsSummaryPreferencesType_SummaryType_LocalType
{
    friend class Mp7JrsSummaryPreferencesType_SummaryType_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSummaryPreferencesType_SummaryType_LocalType
     
     * @return Mp7JrsPtr< Mp7JrssummaryComponentType >
     */
    virtual Mp7JrsPtr< Mp7JrssummaryComponentType > GetBase() const;
    /*
     * Get preferenceValue attribute.
     * @return Mp7JrspreferenceValuePtr
     */
    virtual Mp7JrspreferenceValuePtr GetpreferenceValue() const;

    /*
     * Get preferenceValue attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistpreferenceValue() const;

    /*
     * Set preferenceValue attribute.
     * @param item const Mp7JrspreferenceValuePtr &
     */
    virtual void SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate preferenceValue attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatepreferenceValue();

    /* @name Union

     */
    //@{
    /*
     * Get Mp7JrssummaryComponentType_LocalType element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @return Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual Mp7JrssummaryComponentType_LocalType::Enumeration GetsummaryComponentType_LocalType() const;

    /*
     * Set Mp7JrssummaryComponentType_LocalType element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @param item Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual void SetsummaryComponentType_LocalType(Mp7JrssummaryComponentType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrssummaryComponentType_LocalType0 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @return Mp7JrssummaryComponentType_Local0Ptr
     */
    virtual Mp7JrssummaryComponentType_Local0Ptr GetsummaryComponentType_LocalType0() const;

    /*
     * Set Mp7JrssummaryComponentType_LocalType0 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @param item const Mp7JrssummaryComponentType_Local0Ptr &
     */
    virtual void SetsummaryComponentType_LocalType0(const Mp7JrssummaryComponentType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrssummaryComponentType_LocalType1 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @return Mp7JrssummaryComponentType_Local1Ptr
     */
    virtual Mp7JrssummaryComponentType_Local1Ptr GetsummaryComponentType_LocalType1() const;

    /*
     * Set Mp7JrssummaryComponentType_LocalType1 element.
<br>
     * (Inherited from Mp7JrssummaryComponentType)
     * @param item const Mp7JrssummaryComponentType_Local1Ptr &
     */
    virtual void SetsummaryComponentType_LocalType1(const Mp7JrssummaryComponentType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSummaryPreferencesType_SummaryType_LocalType();

protected:
    Mp7JrsSummaryPreferencesType_SummaryType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrspreferenceValuePtr m_preferenceValue;
    bool m_preferenceValue_Exist;
    Mp7JrspreferenceValuePtr m_preferenceValue_Default;

    // Base Class
    Mp7JrsPtr< Mp7JrssummaryComponentType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSummaryPreferencesType_SummaryType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2193MP7JRSSUMMARYPREFERENCESTYPE_SUMMARYTYPE_LOCALTYPE_H

