/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2195MP7JRSSUMMARYSEGMENTGROUPTYPE_H
#define _2195MP7JRSSUMMARYSEGMENTGROUPTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSummarySegmentGroupTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// begin extension included
// file Mp7JrsSummarySegmentGroupType_ExtInclude.h
class Mp7JrsSummarySegmentType;
class Mp7JrsTextualType;
// end extension included


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsIDREFS;
class IMp7JrsmediaDurationType;
class IMp7JrsSummarySegmentGroupType;
class IMp7JrsSummarySegmentGroupType_Caption_CollectionType;
class IMp7JrsSummarySegmentGroupType_CollectionType;
class IMp7JrsSummarySegmentGroupType_CollectionType0;
class IMp7JrsSummarySegmentGroupType_Name_CollectionType;
class IMp7JrsxPathRefType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsIDREFS > Mp7JrsIDREFSPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_Caption_CollectionType > Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_CollectionType > Mp7JrsSummarySegmentGroupType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_CollectionType0 > Mp7JrsSummarySegmentGroupType_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_Name_CollectionType > Mp7JrsSummarySegmentGroupType_Name_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType> Mp7JrsSummarySegmentGroupPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsSummarySegmentGroupType for class Mp7JrsSummarySegmentGroupType<br>
 * Located at: mds-2001.xsd, line 4546<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSummarySegmentGroupType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsSummarySegmentGroupType();
    virtual ~IMp7JrsSummarySegmentGroupType();
    /**
     * Get level attribute.
     * @return int
     */
    virtual int Getlevel() const = 0;

    /**
     * Get level attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlevel() const = 0;

    /**
     * Set level attribute.
     * @param item int
     */
    virtual void Setlevel(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate level attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelevel() = 0;

    /**
     * Get duration attribute.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr Getduration() const = 0;

    /**
     * Get duration attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existduration() const = 0;

    /**
     * Set duration attribute.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void Setduration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate duration attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateduration() = 0;

    /**
     * Get numOfKeyFrames attribute.
     * @return unsigned
     */
    virtual unsigned GetnumOfKeyFrames() const = 0;

    /**
     * Get numOfKeyFrames attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnumOfKeyFrames() const = 0;

    /**
     * Set numOfKeyFrames attribute.
     * @param item unsigned
     */
    virtual void SetnumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate numOfKeyFrames attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenumOfKeyFrames() = 0;

    /**
     * Get fidelity attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getfidelity() const = 0;

    /**
     * Get fidelity attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existfidelity() const = 0;

    /**
     * Set fidelity attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setfidelity(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate fidelity attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatefidelity() = 0;

    /**
     * Get themeIDs attribute.
     * @return Mp7JrsIDREFSPtr
     */
    virtual Mp7JrsIDREFSPtr GetthemeIDs() const = 0;

    /**
     * Get themeIDs attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistthemeIDs() const = 0;

    /**
     * Set themeIDs attribute.
     * @param item const Mp7JrsIDREFSPtr &
     */
    virtual void SetthemeIDs(const Mp7JrsIDREFSPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate themeIDs attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatethemeIDs() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
     * @return Mp7JrsSummarySegmentGroupType_Name_CollectionPtr
     */
    virtual Mp7JrsSummarySegmentGroupType_Name_CollectionPtr GetName() const = 0;

    /**
     * Set Name element.
     * @param item const Mp7JrsSummarySegmentGroupType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsSummarySegmentGroupType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Caption element.
     * @return Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr
     */
    virtual Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr GetCaption() const = 0;

    /**
     * Set Caption element.
     * @param item const Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr &
     */
    virtual void SetCaption(const Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SummarySegmentGroupType_LocalType element.
     * @return Mp7JrsSummarySegmentGroupType_CollectionPtr
     */
    virtual Mp7JrsSummarySegmentGroupType_CollectionPtr GetSummarySegmentGroupType_LocalType() const = 0;

    /**
     * Set SummarySegmentGroupType_LocalType element.
     * @param item const Mp7JrsSummarySegmentGroupType_CollectionPtr &
     */
    virtual void SetSummarySegmentGroupType_LocalType(const Mp7JrsSummarySegmentGroupType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SummarySegmentGroupType_LocalType0 element.
     * @return Mp7JrsSummarySegmentGroupType_Collection0Ptr
     */
    virtual Mp7JrsSummarySegmentGroupType_Collection0Ptr GetSummarySegmentGroupType_LocalType0() const = 0;

    /**
     * Set SummarySegmentGroupType_LocalType0 element.
     * @param item const Mp7JrsSummarySegmentGroupType_Collection0Ptr &
     */
    virtual void SetSummarySegmentGroupType_LocalType0(const Mp7JrsSummarySegmentGroupType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// begin extension included
// file Mp7JrsSummarySegmentGroupType_ExtMethodDef.h


public:

	/** Add a summary segment */
	virtual void AddSegment(Mp7JrsSummarySegmentPtr segment, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get number of summary segments */
	virtual int GetNrSegments();


	/** Add a summary segment group */
	virtual void AddSegmentGroup(Mp7JrsSummarySegmentGroupPtr segment, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get number of summary segment groups */
	virtual int GetNrSegmentGroups();


	// name and caption

	/** Add a name */
	virtual void AddName(XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Add a caption */
	virtual void AddCaption(XMLCh* caption, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	// fidelity

	/** Set the fidelity. */
	virtual void Setfidelity(float fid, Mp7JrsClientID client);

// end extension included


// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSummarySegmentGroupType<br>
 * Located at: mds-2001.xsd, line 4546<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 4546.<br>
 */
class MP7JRS_EXPORT Mp7JrsSummarySegmentGroupType :
        public IMp7JrsSummarySegmentGroupType
{
    friend class Mp7JrsSummarySegmentGroupTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSummarySegmentGroupType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get level attribute.
     * @return int
     */
    virtual int Getlevel() const;

    /*
     * Get level attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlevel() const;

    /*
     * Set level attribute.
     * @param item int
     */
    virtual void Setlevel(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate level attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelevel();

    /*
     * Get duration attribute.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr Getduration() const;

    /*
     * Get duration attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existduration() const;

    /*
     * Set duration attribute.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void Setduration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate duration attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateduration();

    /*
     * Get numOfKeyFrames attribute.
     * @return unsigned
     */
    virtual unsigned GetnumOfKeyFrames() const;

    /*
     * Get numOfKeyFrames attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnumOfKeyFrames() const;

    /*
     * Set numOfKeyFrames attribute.
     * @param item unsigned
     */
    virtual void SetnumOfKeyFrames(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate numOfKeyFrames attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenumOfKeyFrames();

    /*
     * Get fidelity attribute.
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getfidelity() const;

    /*
     * Get fidelity attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existfidelity() const;

    /*
     * Set fidelity attribute.
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setfidelity(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate fidelity attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatefidelity();

    /*
     * Get themeIDs attribute.
     * @return Mp7JrsIDREFSPtr
     */
    virtual Mp7JrsIDREFSPtr GetthemeIDs() const;

    /*
     * Get themeIDs attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistthemeIDs() const;

    /*
     * Set themeIDs attribute.
     * @param item const Mp7JrsIDREFSPtr &
     */
    virtual void SetthemeIDs(const Mp7JrsIDREFSPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate themeIDs attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatethemeIDs();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
     * @return Mp7JrsSummarySegmentGroupType_Name_CollectionPtr
     */
    virtual Mp7JrsSummarySegmentGroupType_Name_CollectionPtr GetName() const;

    /*
     * Set Name element.
     * @param item const Mp7JrsSummarySegmentGroupType_Name_CollectionPtr &
     */
    virtual void SetName(const Mp7JrsSummarySegmentGroupType_Name_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Caption element.
     * @return Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr
     */
    virtual Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr GetCaption() const;

    /*
     * Set Caption element.
     * @param item const Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr &
     */
    virtual void SetCaption(const Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SummarySegmentGroupType_LocalType element.
     * @return Mp7JrsSummarySegmentGroupType_CollectionPtr
     */
    virtual Mp7JrsSummarySegmentGroupType_CollectionPtr GetSummarySegmentGroupType_LocalType() const;

    /*
     * Set SummarySegmentGroupType_LocalType element.
     * @param item const Mp7JrsSummarySegmentGroupType_CollectionPtr &
     */
    virtual void SetSummarySegmentGroupType_LocalType(const Mp7JrsSummarySegmentGroupType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SummarySegmentGroupType_LocalType0 element.
     * @return Mp7JrsSummarySegmentGroupType_Collection0Ptr
     */
    virtual Mp7JrsSummarySegmentGroupType_Collection0Ptr GetSummarySegmentGroupType_LocalType0() const;

    /*
     * Set SummarySegmentGroupType_LocalType0 element.
     * @param item const Mp7JrsSummarySegmentGroupType_Collection0Ptr &
     */
    virtual void SetSummarySegmentGroupType_LocalType0(const Mp7JrsSummarySegmentGroupType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSummarySegmentGroupType();

protected:
    Mp7JrsSummarySegmentGroupType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    int m_level;
    bool m_level_Exist;
    Mp7JrsmediaDurationPtr m_duration;
    bool m_duration_Exist;
    unsigned m_numOfKeyFrames;
    bool m_numOfKeyFrames_Exist;
    Mp7JrszeroToOnePtr m_fidelity;
    bool m_fidelity_Exist;
    Mp7JrsIDREFSPtr m_themeIDs;
    bool m_themeIDs_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsSummarySegmentGroupType_Name_CollectionPtr m_Name;
    Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr m_Caption;
    Mp7JrsSummarySegmentGroupType_CollectionPtr m_SummarySegmentGroupType_LocalType;
    Mp7JrsSummarySegmentGroupType_Collection0Ptr m_SummarySegmentGroupType_LocalType0;

// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2195MP7JRSSUMMARYSEGMENTGROUPTYPE_H

