/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2229MP7JRSTEMPORALINTERPOLATIONTYPE_H
#define _2229MP7JRSTEMPORALINTERPOLATIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTemporalInterpolationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_ExtInclude.h


class IMp7JrsTemporalInterpolationType;
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType;
class IMp7JrsTemporalInterpolationType_WholeInterval_LocalType;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType > Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType > Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_WholeInterval_LocalType > Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType> Mp7JrsTemporalInterpolationPtr;

/** 
 * Generated interface IMp7JrsTemporalInterpolationType for class Mp7JrsTemporalInterpolationType<br>
 * Located at: visual-2001.xsd, line 191<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsTemporalInterpolationType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTemporalInterpolationType();
    virtual ~IMp7JrsTemporalInterpolationType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get WholeInterval element.
     * @return Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr
     */
    virtual Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr GetWholeInterval() const = 0;

    /**
     * Set WholeInterval element.
     * @param item const Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr &
     */
    virtual void SetWholeInterval(const Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get KeyTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr GetKeyTimePoint() const = 0;

    /**
     * Set KeyTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr &
     */
    virtual void SetKeyTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get InterpolationFunctions element.
     * @return Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr GetInterpolationFunctions() const = 0;

    /**
     * Set InterpolationFunctions element.
     * @param item const Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr &
     */
    virtual void SetInterpolationFunctions(const Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTemporalInterpolationType<br>
 * Located at: visual-2001.xsd, line 191<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 191.<br>
 */
class MP7JRS_EXPORT Mp7JrsTemporalInterpolationType :
        public IMp7JrsTemporalInterpolationType
{
    friend class Mp7JrsTemporalInterpolationTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get WholeInterval element.
     * @return Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr
     */
    virtual Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr GetWholeInterval() const;

    /*
     * Set WholeInterval element.
     * @param item const Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr &
     */
    virtual void SetWholeInterval(const Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get KeyTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr GetKeyTimePoint() const;

    /*
     * Set KeyTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr &
     */
    virtual void SetKeyTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get InterpolationFunctions element.
     * @return Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr GetInterpolationFunctions() const;

    /*
     * Set InterpolationFunctions element.
     * @param item const Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr &
     */
    virtual void SetInterpolationFunctions(const Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTemporalInterpolationType();

protected:
    Mp7JrsTemporalInterpolationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr m_WholeInterval;
    Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr m_KeyTimePoint;
// End DefinionChoice
    Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr m_InterpolationFunctions;

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2229MP7JRSTEMPORALINTERPOLATIONTYPE_H

