/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2241MP7JRSTEMPORALINTERPOLATIONTYPE_KEYTIMEPOINT_LOCALTYPE_H
#define _2241MP7JRSTEMPORALINTERPOLATIONTYPE_KEYTIMEPOINT_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtInclude.h


class IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType> Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType > Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType > Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType > Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr;

/** 
 * Generated interface IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType for class Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType<br>
 * Located at: visual-2001.xsd, line 203<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType();
    virtual ~IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get MediaTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr GetMediaTimePoint() const = 0;

    /**
     * Set MediaTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr &
     */
    virtual void SetMediaTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaRelTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr GetMediaRelTimePoint() const = 0;

    /**
     * Set MediaRelTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr &
     */
    virtual void SetMediaRelTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaRelIncrTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr GetMediaRelIncrTimePoint() const = 0;

    /**
     * Set MediaRelIncrTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr &
     */
    virtual void SetMediaRelIncrTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType<br>
 * Located at: visual-2001.xsd, line 203<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 203.<br>
 */
class MP7JRS_EXPORT Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType :
        public IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType
{
    friend class Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get MediaTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr GetMediaTimePoint() const;

    /*
     * Set MediaTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr &
     */
    virtual void SetMediaTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaRelTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr GetMediaRelTimePoint() const;

    /*
     * Set MediaRelTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr &
     */
    virtual void SetMediaRelTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaRelIncrTimePoint element.
     * @return Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr
     */
    virtual Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr GetMediaRelIncrTimePoint() const;

    /*
     * Set MediaRelIncrTimePoint element.
     * @param item const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr &
     */
    virtual void SetMediaRelIncrTimePoint(const Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType();

protected:
    Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr m_MediaTimePoint;
    Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr m_MediaRelTimePoint;
    Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr m_MediaRelIncrTimePoint;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2241MP7JRSTEMPORALINTERPOLATIONTYPE_KEYTIMEPOINT_LOCALTYPE_H

