/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2249MP7JRSTEMPORALINTERPOLATIONTYPE_WHOLEINTERVAL_LOCALTYPE_H
#define _2249MP7JRSTEMPORALINTERPOLATIONTYPE_WHOLEINTERVAL_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTemporalInterpolationType_WholeInterval_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtInclude.h


class IMp7JrsmediaDurationType;
class IMp7JrsMediaIncrDurationType;
class IMp7JrsTemporalInterpolationType_WholeInterval_LocalType;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsMediaIncrDurationType > Mp7JrsMediaIncrDurationPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_WholeInterval_LocalType> Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr;

/** 
 * Generated interface IMp7JrsTemporalInterpolationType_WholeInterval_LocalType for class Mp7JrsTemporalInterpolationType_WholeInterval_LocalType<br>
 * Located at: visual-2001.xsd, line 195<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsTemporalInterpolationType_WholeInterval_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTemporalInterpolationType_WholeInterval_LocalType();
    virtual ~IMp7JrsTemporalInterpolationType_WholeInterval_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get MediaDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetMediaDuration() const = 0;

    /**
     * Set MediaDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetMediaDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaIncrDuration element.
     * @return Mp7JrsMediaIncrDurationPtr
     */
    virtual Mp7JrsMediaIncrDurationPtr GetMediaIncrDuration() const = 0;

    /**
     * Set MediaIncrDuration element.
     * @param item const Mp7JrsMediaIncrDurationPtr &
     */
    virtual void SetMediaIncrDuration(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTemporalInterpolationType_WholeInterval_LocalType<br>
 * Located at: visual-2001.xsd, line 195<br>
 * Classified: Class<br>
 * Defined in visual-2001.xsd, line 195.<br>
 */
class MP7JRS_EXPORT Mp7JrsTemporalInterpolationType_WholeInterval_LocalType :
        public IMp7JrsTemporalInterpolationType_WholeInterval_LocalType
{
    friend class Mp7JrsTemporalInterpolationType_WholeInterval_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get MediaDuration element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetMediaDuration() const;

    /*
     * Set MediaDuration element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetMediaDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaIncrDuration element.
     * @return Mp7JrsMediaIncrDurationPtr
     */
    virtual Mp7JrsMediaIncrDurationPtr GetMediaIncrDuration() const;

    /*
     * Set MediaIncrDuration element.
     * @param item const Mp7JrsMediaIncrDurationPtr &
     */
    virtual void SetMediaIncrDuration(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTemporalInterpolationType_WholeInterval_LocalType();

protected:
    Mp7JrsTemporalInterpolationType_WholeInterval_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsmediaDurationPtr m_MediaDuration;
    Mp7JrsMediaIncrDurationPtr m_MediaIncrDuration;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2249MP7JRSTEMPORALINTERPOLATIONTYPE_WHOLEINTERVAL_LOCALTYPE_H

