/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2307MP7JRSTEXTUREBROWSINGTYPE_H
#define _2307MP7JRSTEXTUREBROWSINGTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTextureBrowsingTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsTextureBrowsingType_Regularity_LocalType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsTextureBrowsingType;
class IMp7JrsTextureBrowsingType_CollectionType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsTextureBrowsingType_CollectionType > Mp7JrsTextureBrowsingType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTextureBrowsingType> Mp7JrsTextureBrowsingPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsTextureBrowsingType for class Mp7JrsTextureBrowsingType<br>
 * Located at: visual-2001.xsd, line 687<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsTextureBrowsingType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsTextureBrowsingType();
    virtual ~IMp7JrsTextureBrowsingType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Regularity element.
     * @return Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration
     */
    virtual Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration GetRegularity() const = 0;

    /**
     * Set Regularity element.
     * @param item Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration
     */
    virtual void SetRegularity(Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TextureBrowsingType_LocalType element.
     * @return Mp7JrsTextureBrowsingType_CollectionPtr
     */
    virtual Mp7JrsTextureBrowsingType_CollectionPtr GetTextureBrowsingType_LocalType() const = 0;

    /**
     * Set TextureBrowsingType_LocalType element.
     * @param item const Mp7JrsTextureBrowsingType_CollectionPtr &
     */
    virtual void SetTextureBrowsingType_LocalType(const Mp7JrsTextureBrowsingType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTextureBrowsingType<br>
 * Located at: visual-2001.xsd, line 687<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.xsd, line 687.<br>
 */
class MP7JRS_EXPORT Mp7JrsTextureBrowsingType :
        public IMp7JrsTextureBrowsingType
{
    friend class Mp7JrsTextureBrowsingTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsTextureBrowsingType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get Regularity element.
     * @return Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration
     */
    virtual Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration GetRegularity() const;

    /*
     * Set Regularity element.
     * @param item Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration
     */
    virtual void SetRegularity(Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TextureBrowsingType_LocalType element.
     * @return Mp7JrsTextureBrowsingType_CollectionPtr
     */
    virtual Mp7JrsTextureBrowsingType_CollectionPtr GetTextureBrowsingType_LocalType() const;

    /*
     * Set TextureBrowsingType_LocalType element.
     * @param item const Mp7JrsTextureBrowsingType_CollectionPtr &
     */
    virtual void SetTextureBrowsingType_LocalType(const Mp7JrsTextureBrowsingType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTextureBrowsingType();

protected:
    Mp7JrsTextureBrowsingType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration m_Regularity;
    Mp7JrsTextureBrowsingType_CollectionPtr m_TextureBrowsingType_LocalType;

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2307MP7JRSTEXTUREBROWSINGTYPE_H

