/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2313MP7JRSTEXTUREBROWSINGTYPE_LOCALTYPE_H
#define _2313MP7JRSTEXTUREBROWSINGTYPE_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTextureBrowsingType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtInclude.h


#include "Mp7JrsTextureBrowsingType_Direction_LocalType.h"
#include "Mp7JrsTextureBrowsingType_Scale_LocalType.h"
class IMp7JrsTextureBrowsingType_LocalType;
typedef Mp7JrsPtr< IMp7JrsTextureBrowsingType_LocalType> Mp7JrsTextureBrowsingType_LocalPtr;

/** 
 * Generated interface IMp7JrsTextureBrowsingType_LocalType for class Mp7JrsTextureBrowsingType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsTextureBrowsingType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTextureBrowsingType_LocalType();
    virtual ~IMp7JrsTextureBrowsingType_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Direction element.
     * @return Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration
     */
    virtual Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration GetDirection() const = 0;

    /**
     * Set Direction element.
     * @param item Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration
     */
    virtual void SetDirection(Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Scale element.
     * @return Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration
     */
    virtual Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration GetScale() const = 0;

    /**
     * Set Scale element.
     * @param item Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration
     */
    virtual void SetScale(Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTextureBrowsingType_LocalType<br>
 * Defined in visual-2001.xsd, line 701.<br>
 */
class MP7JRS_EXPORT Mp7JrsTextureBrowsingType_LocalType :
        public IMp7JrsTextureBrowsingType_LocalType
{
    friend class Mp7JrsTextureBrowsingType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Direction element.
     * @return Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration
     */
    virtual Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration GetDirection() const;

    /*
     * Set Direction element.
     * @param item Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration
     */
    virtual void SetDirection(Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Scale element.
     * @return Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration
     */
    virtual Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration GetScale() const;

    /*
     * Set Scale element.
     * @param item Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration
     */
    virtual void SetScale(Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTextureBrowsingType_LocalType();

protected:
    Mp7JrsTextureBrowsingType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration m_Direction;
    Mp7JrsTextureBrowsingType_Scale_LocalType::Enumeration m_Scale;

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2313MP7JRSTEXTUREBROWSINGTYPE_LOCALTYPE_H

