/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2327MP7JRSTIMETYPE_H
#define _2327MP7JRSTIMETYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTimeTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsTimeType_ExtInclude.h


class IMp7JrsdurationType;
class IMp7JrsIncrDurationType;
class IMp7JrsRelIncrTimePointType;
class IMp7JrsRelTimePointType;
class IMp7JrstimePointType;
class IMp7JrsTimeType;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsIncrDurationType > Mp7JrsIncrDurationPtr;
typedef Mp7JrsPtr< IMp7JrsRelIncrTimePointType > Mp7JrsRelIncrTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsRelTimePointType > Mp7JrsRelTimePointPtr;
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;
typedef Mp7JrsPtr< IMp7JrsTimeType> Mp7JrsTimePtr;

/** 
 * Generated interface IMp7JrsTimeType for class Mp7JrsTimeType<br>
 * Located at: mds-2001.xsd, line 927<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsTimeType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTimeType();
    virtual ~IMp7JrsTimeType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get TimePoint element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetTimePoint() const = 0;

    /**
     * Set TimePoint element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetTimePoint(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RelTimePoint element.
     * @return Mp7JrsRelTimePointPtr
     */
    virtual Mp7JrsRelTimePointPtr GetRelTimePoint() const = 0;

    /**
     * Set RelTimePoint element.
     * @param item const Mp7JrsRelTimePointPtr &
     */
    virtual void SetRelTimePoint(const Mp7JrsRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RelIncrTimePoint element.
     * @return Mp7JrsRelIncrTimePointPtr
     */
    virtual Mp7JrsRelIncrTimePointPtr GetRelIncrTimePoint() const = 0;

    /**
     * Set RelIncrTimePoint element.
     * @param item const Mp7JrsRelIncrTimePointPtr &
     */
    virtual void SetRelIncrTimePoint(const Mp7JrsRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get Duration element.
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GetDuration() const = 0;

    /**
     * Set Duration element.
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SetDuration(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get IncrDuration element.
     * @return Mp7JrsIncrDurationPtr
     */
    virtual Mp7JrsIncrDurationPtr GetIncrDuration() const = 0;

    /**
     * Set IncrDuration element.
     * @param item const Mp7JrsIncrDurationPtr &
     */
    virtual void SetIncrDuration(const Mp7JrsIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsTimeType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTimeType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTimeType<br>
 * Located at: mds-2001.xsd, line 927<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 927.<br>
 */
class MP7JRS_EXPORT Mp7JrsTimeType :
        public IMp7JrsTimeType
{
    friend class Mp7JrsTimeTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get TimePoint element.
     * @return Mp7JrstimePointPtr
     */
    virtual Mp7JrstimePointPtr GetTimePoint() const;

    /*
     * Set TimePoint element.
     * @param item const Mp7JrstimePointPtr &
     */
    virtual void SetTimePoint(const Mp7JrstimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RelTimePoint element.
     * @return Mp7JrsRelTimePointPtr
     */
    virtual Mp7JrsRelTimePointPtr GetRelTimePoint() const;

    /*
     * Set RelTimePoint element.
     * @param item const Mp7JrsRelTimePointPtr &
     */
    virtual void SetRelTimePoint(const Mp7JrsRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RelIncrTimePoint element.
     * @return Mp7JrsRelIncrTimePointPtr
     */
    virtual Mp7JrsRelIncrTimePointPtr GetRelIncrTimePoint() const;

    /*
     * Set RelIncrTimePoint element.
     * @param item const Mp7JrsRelIncrTimePointPtr &
     */
    virtual void SetRelIncrTimePoint(const Mp7JrsRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get Duration element.
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GetDuration() const;

    /*
     * Set Duration element.
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SetDuration(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get IncrDuration element.
     * @return Mp7JrsIncrDurationPtr
     */
    virtual Mp7JrsIncrDurationPtr GetIncrDuration() const;

    /*
     * Set IncrDuration element.
     * @param item const Mp7JrsIncrDurationPtr &
     */
    virtual void SetIncrDuration(const Mp7JrsIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTimeType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTimeType();

protected:
    Mp7JrsTimeType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrstimePointPtr m_TimePoint;
    Mp7JrsRelTimePointPtr m_RelTimePoint;
    Mp7JrsRelIncrTimePointPtr m_RelIncrTimePoint;
// End DefinionChoice
// DefinionChoice
    Mp7JrsdurationPtr m_Duration;
    Mp7JrsIncrDurationPtr m_IncrDuration;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsTimeType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2327MP7JRSTIMETYPE_H

