/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2439MP7JRSUSERACTIONTYPE_ACTIONTIME_LOCALTYPE_H
#define _2439MP7JRSUSERACTIONTYPE_ACTIONTIME_LOCALTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsUserActionType_ActionTime_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsUserActionType_ActionTime_LocalType_ExtInclude.h


class IMp7JrsMediaTimeType;
class IMp7JrsTimeType;
class IMp7JrsUserActionType_ActionTime_LocalType;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsTimeType > Mp7JrsTimePtr;
typedef Mp7JrsPtr< IMp7JrsUserActionType_ActionTime_LocalType> Mp7JrsUserActionType_ActionTime_LocalPtr;

/** 
 * Generated interface IMp7JrsUserActionType_ActionTime_LocalType for class Mp7JrsUserActionType_ActionTime_LocalType<br>
 * Located at: mds-2001.xsd, line 6327<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsUserActionType_ActionTime_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsUserActionType_ActionTime_LocalType();
    virtual ~IMp7JrsUserActionType_ActionTime_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const = 0;

    virtual bool IsValidMediaTime() const = 0;

    /**
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MediaTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaTime() = 0;

    /**
     * Get GeneralTime element.
     * @return Mp7JrsTimePtr
     */
    virtual Mp7JrsTimePtr GetGeneralTime() const = 0;

    virtual bool IsValidGeneralTime() const = 0;

    /**
     * Set GeneralTime element.
     * @param item const Mp7JrsTimePtr &
     */
    virtual void SetGeneralTime(const Mp7JrsTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate GeneralTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGeneralTime() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsUserActionType_ActionTime_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsUserActionType_ActionTime_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsUserActionType_ActionTime_LocalType<br>
 * Located at: mds-2001.xsd, line 6327<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 6327.<br>
 */
class MP7JRS_EXPORT Mp7JrsUserActionType_ActionTime_LocalType :
        public IMp7JrsUserActionType_ActionTime_LocalType
{
    friend class Mp7JrsUserActionType_ActionTime_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const;

    virtual bool IsValidMediaTime() const;

    /*
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MediaTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMediaTime();

    /*
     * Get GeneralTime element.
     * @return Mp7JrsTimePtr
     */
    virtual Mp7JrsTimePtr GetGeneralTime() const;

    virtual bool IsValidGeneralTime() const;

    /*
     * Set GeneralTime element.
     * @param item const Mp7JrsTimePtr &
     */
    virtual void SetGeneralTime(const Mp7JrsTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate GeneralTime element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateGeneralTime();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsUserActionType_ActionTime_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsUserActionType_ActionTime_LocalType();

protected:
    Mp7JrsUserActionType_ActionTime_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsMediaTimePtr m_MediaTime;
    bool m_MediaTime_Exist; // For optional elements 
    Mp7JrsTimePtr m_GeneralTime;
    bool m_GeneralTime_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsUserActionType_ActionTime_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2439MP7JRSUSERACTIONTYPE_ACTIONTIME_LOCALTYPE_H

