/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2449MP7JRSUSERIDENTIFIERTYPE_H
#define _2449MP7JRSUSERIDENTIFIERTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsUserIdentifierTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsUserIdentifierType_ExtInclude.h


#include "Mp7JrsuserChoiceType.h"
class IMp7JrsTextualType;
class IMp7JrsUserIdentifierType;
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;
typedef Mp7JrsPtr< IMp7JrsUserIdentifierType> Mp7JrsUserIdentifierPtr;

/** 
 * Generated interface IMp7JrsUserIdentifierType for class Mp7JrsUserIdentifierType<br>
 * Located at: mds-2001.xsd, line 5886<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsUserIdentifierType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsUserIdentifierType();
    virtual ~IMp7JrsUserIdentifierType();
    /**
     * Get protected attribute.
     * @return Mp7JrsuserChoiceType::Enumeration
     */
    virtual Mp7JrsuserChoiceType::Enumeration Getprotected() const = 0;

    /**
     * Get protected attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existprotected() const = 0;

    /**
     * Set protected attribute.
     * @param item Mp7JrsuserChoiceType::Enumeration
     */
    virtual void Setprotected(Mp7JrsuserChoiceType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate protected attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateprotected() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Name element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetName() const = 0;

    /**
     * Set Name element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetName(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsUserIdentifierType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsUserIdentifierType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsUserIdentifierType<br>
 * Located at: mds-2001.xsd, line 5886<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 5886.<br>
 */
class MP7JRS_EXPORT Mp7JrsUserIdentifierType :
        public IMp7JrsUserIdentifierType
{
    friend class Mp7JrsUserIdentifierTypeFactory; // constructs objects

public:
    /*
     * Get protected attribute.
     * @return Mp7JrsuserChoiceType::Enumeration
     */
    virtual Mp7JrsuserChoiceType::Enumeration Getprotected() const;

    /*
     * Get protected attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existprotected() const;

    /*
     * Set protected attribute.
     * @param item Mp7JrsuserChoiceType::Enumeration
     */
    virtual void Setprotected(Mp7JrsuserChoiceType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate protected attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateprotected();

        /* @name Sequence

         */
        //@{
    /*
     * Get Name element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetName() const;

    /*
     * Set Name element.
     * @param item const Mp7JrsTextualPtr &
     */
    virtual void SetName(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsUserIdentifierType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsUserIdentifierType();

protected:
    Mp7JrsUserIdentifierType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsuserChoiceType::Enumeration m_protected;
    bool m_protected_Exist;
    Mp7JrsuserChoiceType::Enumeration m_protected_Default;


    Mp7JrsTextualPtr m_Name;

// no includefile for extension defined 
// file Mp7JrsUserIdentifierType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2449MP7JRSUSERIDENTIFIERTYPE_H

