/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2477MP7JRSVARIATIONTYPE_VARIATIONRELATIONSHIP_LOCALTYPE2_H
#define _2477MP7JRSVARIATIONTYPE_VARIATIONRELATIONSHIP_LOCALTYPE2_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType2Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType2_ExtInclude.h


#include "Mp7JrsVariationType_VariationRelationship_LocalType.h"
class IMp7JrsVariationType_VariationRelationship_LocalType0;
class IMp7JrsVariationType_VariationRelationship_LocalType1;
class IMp7JrsVariationType_VariationRelationship_LocalType2;
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_LocalType0 > Mp7JrsVariationType_VariationRelationship_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_LocalType1 > Mp7JrsVariationType_VariationRelationship_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_LocalType2> Mp7JrsVariationType_VariationRelationship_Local2Ptr;

/** 
 * Generated interface IMp7JrsVariationType_VariationRelationship_LocalType2 for class Mp7JrsVariationType_VariationRelationship_LocalType2<br>
 * Located at: mds-2001.xsd, line 5165<br>
 */
class MP7JRS_EXPORT IMp7JrsVariationType_VariationRelationship_LocalType2 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsVariationType_VariationRelationship_LocalType2();
    virtual ~IMp7JrsVariationType_VariationRelationship_LocalType2();
    /** @name Union

     */
    //@{
    /**
     * Get Mp7JrsVariationType_VariationRelationship_LocalType element.
     * @return Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration
     */
    virtual Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration GetVariationType_VariationRelationship_LocalType() const = 0;

    /**
     * Set Mp7JrsVariationType_VariationRelationship_LocalType element.
     * @param item Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration
     */
    virtual void SetVariationType_VariationRelationship_LocalType(Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrsVariationType_VariationRelationship_LocalType0 element.
     * @return Mp7JrsVariationType_VariationRelationship_Local0Ptr
     */
    virtual Mp7JrsVariationType_VariationRelationship_Local0Ptr GetVariationType_VariationRelationship_LocalType0() const = 0;

    /**
     * Set Mp7JrsVariationType_VariationRelationship_LocalType0 element.
     * @param item const Mp7JrsVariationType_VariationRelationship_Local0Ptr &
     */
    virtual void SetVariationType_VariationRelationship_LocalType0(const Mp7JrsVariationType_VariationRelationship_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrsVariationType_VariationRelationship_LocalType1 element.
     * @return Mp7JrsVariationType_VariationRelationship_Local1Ptr
     */
    virtual Mp7JrsVariationType_VariationRelationship_Local1Ptr GetVariationType_VariationRelationship_LocalType1() const = 0;

    /**
     * Set Mp7JrsVariationType_VariationRelationship_LocalType1 element.
     * @param item const Mp7JrsVariationType_VariationRelationship_Local1Ptr &
     */
    virtual void SetVariationType_VariationRelationship_LocalType1(const Mp7JrsVariationType_VariationRelationship_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    //@}
// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType2_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType2_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVariationType_VariationRelationship_LocalType2<br>
 * Located at: mds-2001.xsd, line 5165<br>
 * Defined in mds-2001.xsd, line 5165.<br>
 */
class MP7JRS_EXPORT Mp7JrsVariationType_VariationRelationship_LocalType2 :
        public IMp7JrsVariationType_VariationRelationship_LocalType2
{
    friend class Mp7JrsVariationType_VariationRelationship_LocalType2Factory; // constructs objects

public:
    /* @name Union

     */
    //@{
    /*
     * Get Mp7JrsVariationType_VariationRelationship_LocalType element.
     * @return Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration
     */
    virtual Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration GetVariationType_VariationRelationship_LocalType() const;

    /*
     * Set Mp7JrsVariationType_VariationRelationship_LocalType element.
     * @param item Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration
     */
    virtual void SetVariationType_VariationRelationship_LocalType(Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrsVariationType_VariationRelationship_LocalType0 element.
     * @return Mp7JrsVariationType_VariationRelationship_Local0Ptr
     */
    virtual Mp7JrsVariationType_VariationRelationship_Local0Ptr GetVariationType_VariationRelationship_LocalType0() const;

    /*
     * Set Mp7JrsVariationType_VariationRelationship_LocalType0 element.
     * @param item const Mp7JrsVariationType_VariationRelationship_Local0Ptr &
     */
    virtual void SetVariationType_VariationRelationship_LocalType0(const Mp7JrsVariationType_VariationRelationship_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrsVariationType_VariationRelationship_LocalType1 element.
     * @return Mp7JrsVariationType_VariationRelationship_Local1Ptr
     */
    virtual Mp7JrsVariationType_VariationRelationship_Local1Ptr GetVariationType_VariationRelationship_LocalType1() const;

    /*
     * Set Mp7JrsVariationType_VariationRelationship_LocalType1 element.
     * @param item const Mp7JrsVariationType_VariationRelationship_Local1Ptr &
     */
    virtual void SetVariationType_VariationRelationship_LocalType1(const Mp7JrsVariationType_VariationRelationship_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType2_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVariationType_VariationRelationship_LocalType2();

protected:
    Mp7JrsVariationType_VariationRelationship_LocalType2();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionUnion
    Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration m_VariationType_VariationRelationship_LocalType;
    Mp7JrsVariationType_VariationRelationship_Local0Ptr m_VariationType_VariationRelationship_LocalType0;
    Mp7JrsVariationType_VariationRelationship_Local1Ptr m_VariationType_VariationRelationship_LocalType1;
// End DefinionUnion

// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType2_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2477MP7JRSVARIATIONTYPE_VARIATIONRELATIONSHIP_LOCALTYPE2_H

