/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2503MP7JRSVIDEOSEGMENTTYPE_H
#define _2503MP7JRSVIDEOSEGMENTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVideoSegmentTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// begin extension included
// file Mp7JrsVideoSegmentType_ExtInclude.h

class Mp7JrsmediaTimePointType;
class Mp7JrsVideoSegmentTemporalDecompositionType;
class Mp7JrsControlledTermUseType;

// end extension included


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsSegmentType.h"
class IMp7JrsControlledTermUseType;
class IMp7JrsCreationInformationType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsMediaInformationType;
class IMp7JrsMediaLocatorType;
class IMp7JrsMediaTimeType;
class IMp7JrsMultipleViewType;
class IMp7JrsReferenceType;
class IMp7JrsSegmentType;
class IMp7JrsSegmentType_CollectionType;
class IMp7JrsSegmentType_MatchingHint_CollectionType;
class IMp7JrsSegmentType_PointOfView_CollectionType;
class IMp7JrsSegmentType_Relation_CollectionType;
class IMp7JrsSegmentType_TextAnnotation_CollectionType;
class IMp7JrsTemporalMaskType;
class IMp7JrsUsageInformationType;
class IMp7JrsVideoSegmentType;
class IMp7JrsVideoSegmentType_CollectionType;
class IMp7JrsVideoSegmentType_CollectionType0;
class IMp7JrsVideoSegmentType_Mosaic_CollectionType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;
typedef Mp7JrsPtr< IMp7JrsCreationInformationType > Mp7JrsCreationInformationPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsMediaInformationType > Mp7JrsMediaInformationPtr;
typedef Mp7JrsPtr< IMp7JrsMediaLocatorType > Mp7JrsMediaLocatorPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsMultipleViewType > Mp7JrsMultipleViewPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType > Mp7JrsSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_CollectionType > Mp7JrsSegmentType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_MatchingHint_CollectionType > Mp7JrsSegmentType_MatchingHint_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_PointOfView_CollectionType > Mp7JrsSegmentType_PointOfView_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_Relation_CollectionType > Mp7JrsSegmentType_Relation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_CollectionType > Mp7JrsSegmentType_TextAnnotation_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalMaskType > Mp7JrsTemporalMaskPtr;
typedef Mp7JrsPtr< IMp7JrsUsageInformationType > Mp7JrsUsageInformationPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_CollectionType > Mp7JrsVideoSegmentType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_CollectionType0 > Mp7JrsVideoSegmentType_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_Mosaic_CollectionType > Mp7JrsVideoSegmentType_Mosaic_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType> Mp7JrsVideoSegmentPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsVideoSegmentType for class Mp7JrsVideoSegmentType<br>
 * Located at: mds-2001.xsd, line 3281<br>
 * Classified: Class<br>
 * Derived from: SegmentType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsVideoSegmentType 
 :
        public IMp7JrsSegmentType
{
public:
    // TODO: make these protected?
    IMp7JrsVideoSegmentType();
    virtual ~IMp7JrsVideoSegmentType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const = 0;

    /**
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TemporalMask element.
     * @return Mp7JrsTemporalMaskPtr
     */
    virtual Mp7JrsTemporalMaskPtr GetTemporalMask() const = 0;

    /**
     * Set TemporalMask element.
     * @param item const Mp7JrsTemporalMaskPtr &
     */
    virtual void SetTemporalMask(const Mp7JrsTemporalMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get VideoSegmentType_LocalType element.
     * @return Mp7JrsVideoSegmentType_CollectionPtr
     */
    virtual Mp7JrsVideoSegmentType_CollectionPtr GetVideoSegmentType_LocalType() const = 0;

    /**
     * Set VideoSegmentType_LocalType element.
     * @param item const Mp7JrsVideoSegmentType_CollectionPtr &
     */
    virtual void SetVideoSegmentType_LocalType(const Mp7JrsVideoSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MultipleView element.
     * @return Mp7JrsMultipleViewPtr
     */
    virtual Mp7JrsMultipleViewPtr GetMultipleView() const = 0;

    virtual bool IsValidMultipleView() const = 0;

    /**
     * Set MultipleView element.
     * @param item const Mp7JrsMultipleViewPtr &
     */
    virtual void SetMultipleView(const Mp7JrsMultipleViewPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate MultipleView element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMultipleView() = 0;

    /**
     * Get Mosaic element.
     * @return Mp7JrsVideoSegmentType_Mosaic_CollectionPtr
     */
    virtual Mp7JrsVideoSegmentType_Mosaic_CollectionPtr GetMosaic() const = 0;

    /**
     * Set Mosaic element.
     * @param item const Mp7JrsVideoSegmentType_Mosaic_CollectionPtr &
     */
    virtual void SetMosaic(const Mp7JrsVideoSegmentType_Mosaic_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get VideoSegmentType_LocalType0 element.
     * @return Mp7JrsVideoSegmentType_Collection0Ptr
     */
    virtual Mp7JrsVideoSegmentType_Collection0Ptr GetVideoSegmentType_LocalType0() const = 0;

    /**
     * Set VideoSegmentType_LocalType0 element.
     * @param item const Mp7JrsVideoSegmentType_Collection0Ptr &
     */
    virtual void SetVideoSegmentType_LocalType0(const Mp7JrsVideoSegmentType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaInformationPtr
     */
    virtual Mp7JrsMediaInformationPtr GetMediaInformation() const = 0;

    /**
     * Set MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaInformationPtr &
     */
    virtual void SetMediaInformation(const Mp7JrsMediaInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMediaInformationRef() const = 0;

    /**
     * Set MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMediaInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetMediaLocator() const = 0;

    /**
     * Set MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetStructuralUnit() const = 0;

    virtual bool IsValidStructuralUnit() const = 0;

    /**
     * Set StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetStructuralUnit(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate StructuralUnit element.
     * (Inherited from Mp7JrsSegmentType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStructuralUnit() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsCreationInformationPtr
     */
    virtual Mp7JrsCreationInformationPtr GetCreationInformation() const = 0;

    /**
     * Set CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsCreationInformationPtr &
     */
    virtual void SetCreationInformation(const Mp7JrsCreationInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCreationInformationRef() const = 0;

    /**
     * Set CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetCreationInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsUsageInformationPtr
     */
    virtual Mp7JrsUsageInformationPtr GetUsageInformation() const = 0;

    /**
     * Set UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsUsageInformationPtr &
     */
    virtual void SetUsageInformation(const Mp7JrsUsageInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetUsageInformationRef() const = 0;

    /**
     * Set UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetUsageInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_TextAnnotation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_TextAnnotation_CollectionPtr GetTextAnnotation() const = 0;

    /**
     * Set TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_TextAnnotation_CollectionPtr &
     */
    virtual void SetTextAnnotation(const Mp7JrsSegmentType_TextAnnotation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_CollectionPtr
     */
    virtual Mp7JrsSegmentType_CollectionPtr GetSegmentType_LocalType() const = 0;

    /**
     * Set SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_CollectionPtr &
     */
    virtual void SetSegmentType_LocalType(const Mp7JrsSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_MatchingHint_CollectionPtr
     */
    virtual Mp7JrsSegmentType_MatchingHint_CollectionPtr GetMatchingHint() const = 0;

    /**
     * Set MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_MatchingHint_CollectionPtr &
     */
    virtual void SetMatchingHint(const Mp7JrsSegmentType_MatchingHint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_PointOfView_CollectionPtr
     */
    virtual Mp7JrsSegmentType_PointOfView_CollectionPtr GetPointOfView() const = 0;

    /**
     * Set PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_PointOfView_CollectionPtr &
     */
    virtual void SetPointOfView(const Mp7JrsSegmentType_PointOfView_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_Relation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_Relation_CollectionPtr GetRelation() const = 0;

    /**
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_Relation_CollectionPtr &
     */
    virtual void SetRelation(const Mp7JrsSegmentType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// begin extension included
// file Mp7JrsVideoSegmentType_ExtMethodDef.h

public:

	/** Get the begin time.
	  * @return Pointer to begin time.
	  */
	virtual Mp7JrsmediaTimePointPtr GetBeginTime();

	/** Set begin time.
	  *	@param beginTime Begin time to be set (will be copied).
	  */
	virtual void SetBeginTime(Mp7JrsmediaTimePointPtr beginTime, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get the end time.
	  * @return Pointer to end time.
	  */
	virtual Mp7JrsmediaTimePointPtr GetEndTime();

	/** Set end time.
	  *	@param endTime End time to be set (will be copied).
	  */
	virtual void SetEndTime(Mp7JrsmediaTimePointPtr endTime, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT); 

	/** Get begin and end time. */
	virtual void GetTime(Mp7JrsmediaTimePointPtr& beginTime, Mp7JrsmediaTimePointPtr& endTime);

	/** Set begin and end time. The time points will be copied. */
	virtual void SetTime(Mp7JrsmediaTimePointPtr beginTime, Mp7JrsmediaTimePointPtr endTime, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);
// end extension included


// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVideoSegmentType<br>
 * Located at: mds-2001.xsd, line 3281<br>
 * Classified: Class<br>
 * Derived from: SegmentType (Class)<br>
 * Defined in mds-2001.xsd, line 3281.<br>
 */
class MP7JRS_EXPORT Mp7JrsVideoSegmentType :
        public IMp7JrsVideoSegmentType
{
    friend class Mp7JrsVideoSegmentTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsVideoSegmentType
     
     * @return Mp7JrsPtr< Mp7JrsSegmentType >
     */
    virtual Mp7JrsPtr< Mp7JrsSegmentType > GetBase() const;
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const;

    /*
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TemporalMask element.
     * @return Mp7JrsTemporalMaskPtr
     */
    virtual Mp7JrsTemporalMaskPtr GetTemporalMask() const;

    /*
     * Set TemporalMask element.
     * @param item const Mp7JrsTemporalMaskPtr &
     */
    virtual void SetTemporalMask(const Mp7JrsTemporalMaskPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get VideoSegmentType_LocalType element.
     * @return Mp7JrsVideoSegmentType_CollectionPtr
     */
    virtual Mp7JrsVideoSegmentType_CollectionPtr GetVideoSegmentType_LocalType() const;

    /*
     * Set VideoSegmentType_LocalType element.
     * @param item const Mp7JrsVideoSegmentType_CollectionPtr &
     */
    virtual void SetVideoSegmentType_LocalType(const Mp7JrsVideoSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MultipleView element.
     * @return Mp7JrsMultipleViewPtr
     */
    virtual Mp7JrsMultipleViewPtr GetMultipleView() const;

    virtual bool IsValidMultipleView() const;

    /*
     * Set MultipleView element.
     * @param item const Mp7JrsMultipleViewPtr &
     */
    virtual void SetMultipleView(const Mp7JrsMultipleViewPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate MultipleView element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateMultipleView();

    /*
     * Get Mosaic element.
     * @return Mp7JrsVideoSegmentType_Mosaic_CollectionPtr
     */
    virtual Mp7JrsVideoSegmentType_Mosaic_CollectionPtr GetMosaic() const;

    /*
     * Set Mosaic element.
     * @param item const Mp7JrsVideoSegmentType_Mosaic_CollectionPtr &
     */
    virtual void SetMosaic(const Mp7JrsVideoSegmentType_Mosaic_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get VideoSegmentType_LocalType0 element.
     * @return Mp7JrsVideoSegmentType_Collection0Ptr
     */
    virtual Mp7JrsVideoSegmentType_Collection0Ptr GetVideoSegmentType_LocalType0() const;

    /*
     * Set VideoSegmentType_LocalType0 element.
     * @param item const Mp7JrsVideoSegmentType_Collection0Ptr &
     */
    virtual void SetVideoSegmentType_LocalType0(const Mp7JrsVideoSegmentType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaInformationPtr
     */
    virtual Mp7JrsMediaInformationPtr GetMediaInformation() const;

    /*
     * Set MediaInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaInformationPtr &
     */
    virtual void SetMediaInformation(const Mp7JrsMediaInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMediaInformationRef() const;

    /*
     * Set MediaInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMediaInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsMediaLocatorPtr
     */
    virtual Mp7JrsMediaLocatorPtr GetMediaLocator() const;

    /*
     * Set MediaLocator element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsMediaLocatorPtr &
     */
    virtual void SetMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsControlledTermUsePtr
     */
    virtual Mp7JrsControlledTermUsePtr GetStructuralUnit() const;

    virtual bool IsValidStructuralUnit() const;

    /*
     * Set StructuralUnit element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsControlledTermUsePtr &
     */
    virtual void SetStructuralUnit(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate StructuralUnit element.
     * (Inherited from Mp7JrsSegmentType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateStructuralUnit();

        /* @name Choice

         */
        //@{
    /*
     * Get CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsCreationInformationPtr
     */
    virtual Mp7JrsCreationInformationPtr GetCreationInformation() const;

    /*
     * Set CreationInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsCreationInformationPtr &
     */
    virtual void SetCreationInformation(const Mp7JrsCreationInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCreationInformationRef() const;

    /*
     * Set CreationInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetCreationInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsUsageInformationPtr
     */
    virtual Mp7JrsUsageInformationPtr GetUsageInformation() const;

    /*
     * Set UsageInformation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsUsageInformationPtr &
     */
    virtual void SetUsageInformation(const Mp7JrsUsageInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetUsageInformationRef() const;

    /*
     * Set UsageInformationRef element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetUsageInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_TextAnnotation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_TextAnnotation_CollectionPtr GetTextAnnotation() const;

    /*
     * Set TextAnnotation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_TextAnnotation_CollectionPtr &
     */
    virtual void SetTextAnnotation(const Mp7JrsSegmentType_TextAnnotation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_CollectionPtr
     */
    virtual Mp7JrsSegmentType_CollectionPtr GetSegmentType_LocalType() const;

    /*
     * Set SegmentType_LocalType element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_CollectionPtr &
     */
    virtual void SetSegmentType_LocalType(const Mp7JrsSegmentType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_MatchingHint_CollectionPtr
     */
    virtual Mp7JrsSegmentType_MatchingHint_CollectionPtr GetMatchingHint() const;

    /*
     * Set MatchingHint element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_MatchingHint_CollectionPtr &
     */
    virtual void SetMatchingHint(const Mp7JrsSegmentType_MatchingHint_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_PointOfView_CollectionPtr
     */
    virtual Mp7JrsSegmentType_PointOfView_CollectionPtr GetPointOfView() const;

    /*
     * Set PointOfView element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_PointOfView_CollectionPtr &
     */
    virtual void SetPointOfView(const Mp7JrsSegmentType_PointOfView_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @return Mp7JrsSegmentType_Relation_CollectionPtr
     */
    virtual Mp7JrsSegmentType_Relation_CollectionPtr GetRelation() const;

    /*
     * Set Relation element.
<br>
     * (Inherited from Mp7JrsSegmentType)
     * @param item const Mp7JrsSegmentType_Relation_CollectionPtr &
     */
    virtual void SetRelation(const Mp7JrsSegmentType_Relation_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVideoSegmentType();

protected:
    Mp7JrsVideoSegmentType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsSegmentType > m_Base;

// DefinionChoice
    Mp7JrsMediaTimePtr m_MediaTime;
    Mp7JrsTemporalMaskPtr m_TemporalMask;
// End DefinionChoice
    Mp7JrsVideoSegmentType_CollectionPtr m_VideoSegmentType_LocalType;
    Mp7JrsMultipleViewPtr m_MultipleView;
    bool m_MultipleView_Exist; // For optional elements 
    Mp7JrsVideoSegmentType_Mosaic_CollectionPtr m_Mosaic;
    Mp7JrsVideoSegmentType_Collection0Ptr m_VideoSegmentType_LocalType0;

// no includefile for extension defined 
// file Mp7JrsVideoSegmentType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2503MP7JRSVIDEOSEGMENTTYPE_H

