/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2537MP7JRSVIEWDECOMPOSITIONTYPE_H
#define _2537MP7JRSVIEWDECOMPOSITIONTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsViewDecompositionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsViewDecompositionType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsSignalType;
class IMp7JrsViewDecompositionType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSignalType > Mp7JrsSignalPtr;
typedef Mp7JrsPtr< IMp7JrsViewDecompositionType> Mp7JrsViewDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsViewDecompositionType for class Mp7JrsViewDecompositionType<br>
 * Located at: mds-2001.xsd, line 4979<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Abstract class <br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsViewDecompositionType 
 :
        public IMp7JrsDSType
{
public:
    // TODO: make these protected?
    IMp7JrsViewDecompositionType();
    virtual ~IMp7JrsViewDecompositionType();
    /**
     * Get complete attribute.
     * @return bool
     */
    virtual bool Getcomplete() const = 0;

    /**
     * Get complete attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existcomplete() const = 0;

    /**
     * Set complete attribute.
     * @param item bool
     */
    virtual void Setcomplete(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate complete attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatecomplete() = 0;

    /**
     * Get nonRedundant attribute.
     * @return bool
     */
    virtual bool GetnonRedundant() const = 0;

    /**
     * Get nonRedundant attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnonRedundant() const = 0;

    /**
     * Set nonRedundant attribute.
     * @param item bool
     */
    virtual void SetnonRedundant(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate nonRedundant attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenonRedundant() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Source element.
     * @return Mp7JrsSignalPtr
     */
    virtual Mp7JrsSignalPtr GetSource() const = 0;

    virtual bool IsValidSource() const = 0;

    /**
     * Set Source element.
     * @param item const Mp7JrsSignalPtr &
     */
    virtual void SetSource(const Mp7JrsSignalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Source element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSource() = 0;

        //@}
    /**
     * @if Show_All_Abstract_Class_Members
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     * @endif
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool Existid() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     * @endif
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void Invalidateid() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     * @endif
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     * @endif
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     * @endif
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     * @endif
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     * @endif
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     * @endif
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     * @endif
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     * @endif
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     * @endif
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * @if Show_All_Abstract_Class_Members
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     * @endif
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * @if Show_All_Abstract_Class_Members
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     * @endif
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * @if Show_All_Abstract_Class_Members
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     * @endif
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsViewDecompositionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsViewDecompositionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsViewDecompositionType<br>
 * Located at: mds-2001.xsd, line 4979<br>
 * Classified: Class<br>
 * Derived from: DSType (Class)<br>
 * Abstract class <br>
 * Derived from: DSType (Class)<br>
 * Derived from: DSType (Class)<br>
 * Defined in mds-2001.xsd, line 4979.<br>
 */
class MP7JRS_EXPORT Mp7JrsViewDecompositionType :
        public IMp7JrsViewDecompositionType
{
    friend class Mp7JrsViewDecompositionTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsViewDecompositionType
     
     * @return Mp7JrsPtr< Mp7JrsDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsDSType > GetBase() const;
    /*
     * Get complete attribute.
     * @return bool
     */
    virtual bool Getcomplete() const;

    /*
     * Get complete attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existcomplete() const;

    /*
     * Set complete attribute.
     * @param item bool
     */
    virtual void Setcomplete(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate complete attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatecomplete();

    /*
     * Get nonRedundant attribute.
     * @return bool
     */
    virtual bool GetnonRedundant() const;

    /*
     * Get nonRedundant attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnonRedundant() const;

    /*
     * Set nonRedundant attribute.
     * @param item bool
     */
    virtual void SetnonRedundant(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate nonRedundant attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenonRedundant();

        /* @name Sequence

         */
        //@{
    /*
     * Get Source element.
     * @return Mp7JrsSignalPtr
     */
    virtual Mp7JrsSignalPtr GetSource() const;

    virtual bool IsValidSource() const;

    /*
     * Set Source element.
     * @param item const Mp7JrsSignalPtr &
     */
    virtual void SetSource(const Mp7JrsSignalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Source element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSource();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsViewDecompositionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsViewDecompositionType();

protected:
    Mp7JrsViewDecompositionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_complete;
    bool m_complete_Exist;
    bool m_nonRedundant;
    bool m_nonRedundant_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsDSType > m_Base;

    Mp7JrsSignalPtr m_Source;
    bool m_Source_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsViewDecompositionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2537MP7JRSVIEWDECOMPOSITIONTYPE_H

