/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2547MP7JRSVIEWSETTYPE_H
#define _2547MP7JRSVIEWSETTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsViewSetTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsViewSetType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsViewDecompositionType.h"
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsSignalType;
class IMp7JrsViewDecompositionType;
class IMp7JrsViewSetType;
class IMp7JrsViewSetType_CollectionType;
class IMp7JrsViewSetType_setProperty_LocalType2;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSignalType > Mp7JrsSignalPtr;
typedef Mp7JrsPtr< IMp7JrsViewDecompositionType > Mp7JrsViewDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsViewSetType_CollectionType > Mp7JrsViewSetType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsViewSetType_setProperty_LocalType2 > Mp7JrsViewSetType_setProperty_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsViewSetType> Mp7JrsViewSetPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsViewSetType for class Mp7JrsViewSetType<br>
 * Located at: mds-2001.xsd, line 4994<br>
 * Classified: Class<br>
 * Derived from: ViewDecompositionType (Class)<br>
 * Derived from: ViewDecompositionType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsViewSetType 
 :
        public IMp7JrsViewDecompositionType
{
public:
    // TODO: make these protected?
    IMp7JrsViewSetType();
    virtual ~IMp7JrsViewSetType();
    /**
     * Get setProperty attribute.
     * @return Mp7JrsViewSetType_setProperty_Local2Ptr
     */
    virtual Mp7JrsViewSetType_setProperty_Local2Ptr GetsetProperty() const = 0;

    /**
     * Get setProperty attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistsetProperty() const = 0;

    /**
     * Set setProperty attribute.
     * @param item const Mp7JrsViewSetType_setProperty_Local2Ptr &
     */
    virtual void SetsetProperty(const Mp7JrsViewSetType_setProperty_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate setProperty attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatesetProperty() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get ViewSetType_LocalType element.
     * @return Mp7JrsViewSetType_CollectionPtr
     */
    virtual Mp7JrsViewSetType_CollectionPtr GetViewSetType_LocalType() const = 0;

    /**
     * Set ViewSetType_LocalType element.
     * @param item const Mp7JrsViewSetType_CollectionPtr &
     */
    virtual void SetViewSetType_LocalType(const Mp7JrsViewSetType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get complete attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return bool
     */
    virtual bool Getcomplete() const = 0;

    /**
     * Get complete attribute validity information.
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existcomplete() const = 0;

    /**
     * Set complete attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @param item bool
     */
    virtual void Setcomplete(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate complete attribute.
     * (Inherited from Mp7JrsViewDecompositionType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatecomplete() = 0;

    /**
     * Get nonRedundant attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return bool
     */
    virtual bool GetnonRedundant() const = 0;

    /**
     * Get nonRedundant attribute validity information.
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnonRedundant() const = 0;

    /**
     * Set nonRedundant attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @param item bool
     */
    virtual void SetnonRedundant(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate nonRedundant attribute.
     * (Inherited from Mp7JrsViewDecompositionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenonRedundant() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Source element.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return Mp7JrsSignalPtr
     */
    virtual Mp7JrsSignalPtr GetSource() const = 0;

    virtual bool IsValidSource() const = 0;

    /**
     * Set Source element.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @param item const Mp7JrsSignalPtr &
     */
    virtual void SetSource(const Mp7JrsSignalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Source element.
     * (Inherited from Mp7JrsViewDecompositionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSource() = 0;

        //@}
    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsViewSetType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsViewSetType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsViewSetType<br>
 * Located at: mds-2001.xsd, line 4994<br>
 * Classified: Class<br>
 * Derived from: ViewDecompositionType (Class)<br>
 * Derived from: ViewDecompositionType (Class)<br>
 * Defined in mds-2001.xsd, line 4994.<br>
 */
class MP7JRS_EXPORT Mp7JrsViewSetType :
        public IMp7JrsViewSetType
{
    friend class Mp7JrsViewSetTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsViewSetType
     
     * @return Mp7JrsPtr< Mp7JrsViewDecompositionType >
     */
    virtual Mp7JrsPtr< Mp7JrsViewDecompositionType > GetBase() const;
    /*
     * Get setProperty attribute.
     * @return Mp7JrsViewSetType_setProperty_Local2Ptr
     */
    virtual Mp7JrsViewSetType_setProperty_Local2Ptr GetsetProperty() const;

    /*
     * Get setProperty attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistsetProperty() const;

    /*
     * Set setProperty attribute.
     * @param item const Mp7JrsViewSetType_setProperty_Local2Ptr &
     */
    virtual void SetsetProperty(const Mp7JrsViewSetType_setProperty_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate setProperty attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatesetProperty();

        /* @name Sequence

         */
        //@{
    /*
     * Get ViewSetType_LocalType element.
     * @return Mp7JrsViewSetType_CollectionPtr
     */
    virtual Mp7JrsViewSetType_CollectionPtr GetViewSetType_LocalType() const;

    /*
     * Set ViewSetType_LocalType element.
     * @param item const Mp7JrsViewSetType_CollectionPtr &
     */
    virtual void SetViewSetType_LocalType(const Mp7JrsViewSetType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get complete attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return bool
     */
    virtual bool Getcomplete() const;

    /*
     * Get complete attribute validity information.
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existcomplete() const;

    /*
     * Set complete attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @param item bool
     */
    virtual void Setcomplete(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate complete attribute.
     * (Inherited from Mp7JrsViewDecompositionType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatecomplete();

    /*
     * Get nonRedundant attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return bool
     */
    virtual bool GetnonRedundant() const;

    /*
     * Get nonRedundant attribute validity information.
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnonRedundant() const;

    /*
     * Set nonRedundant attribute.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @param item bool
     */
    virtual void SetnonRedundant(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate nonRedundant attribute.
     * (Inherited from Mp7JrsViewDecompositionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenonRedundant();

        /* @name Sequence

         */
        //@{
    /*
     * Get Source element.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @return Mp7JrsSignalPtr
     */
    virtual Mp7JrsSignalPtr GetSource() const;

    virtual bool IsValidSource() const;

    /*
     * Set Source element.
<br>
     * (Inherited from Mp7JrsViewDecompositionType)
     * @param item const Mp7JrsSignalPtr &
     */
    virtual void SetSource(const Mp7JrsSignalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Source element.
     * (Inherited from Mp7JrsViewDecompositionType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateSource();

        //@}
    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsViewSetType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsViewSetType();

protected:
    Mp7JrsViewSetType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsViewSetType_setProperty_Local2Ptr m_setProperty;
    bool m_setProperty_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsViewDecompositionType > m_Base;

    Mp7JrsViewSetType_CollectionPtr m_ViewSetType_LocalType;

// no includefile for extension defined 
// file Mp7JrsViewSetType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2547MP7JRSVIEWSETTYPE_H

