/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2569MP7JRSVISUALTIMESERIESTYPE_H
#define _2569MP7JRSVISUALTIMESERIESTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVisualTimeSeriesTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrsVisualTimeSeriesType_ExtInclude.h


class IMp7JrsmediaDurationType;
class IMp7JrsVisualTimeSeriesType;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsVisualTimeSeriesType> Mp7JrsVisualTimeSeriesPtr;

/** 
 * Generated interface IMp7JrsVisualTimeSeriesType for class Mp7JrsVisualTimeSeriesType<br>
 * Located at: visual-2001.xsd, line 61<br>
 * Classified: Class<br>
 * Abstract class <br>
 */
class MP7JRS_EXPORT IMp7JrsVisualTimeSeriesType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsVisualTimeSeriesType();
    virtual ~IMp7JrsVisualTimeSeriesType();
    /**
     * Get offset attribute.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr Getoffset() const = 0;

    /**
     * Get offset attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existoffset() const = 0;

    /**
     * Set offset attribute.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void Setoffset(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate offset attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateoffset() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get TimeIncr element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetTimeIncr() const = 0;

    /**
     * Set TimeIncr element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetTimeIncr(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsVisualTimeSeriesType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsVisualTimeSeriesType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVisualTimeSeriesType<br>
 * Located at: visual-2001.xsd, line 61<br>
 * Classified: Class<br>
 * Abstract class <br>
 * Defined in visual-2001.xsd, line 61.<br>
 */
class MP7JRS_EXPORT Mp7JrsVisualTimeSeriesType :
        public IMp7JrsVisualTimeSeriesType
{
    friend class Mp7JrsVisualTimeSeriesTypeFactory; // constructs objects

public:
    /*
     * Get offset attribute.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr Getoffset() const;

    /*
     * Get offset attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existoffset() const;

    /*
     * Set offset attribute.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void Setoffset(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate offset attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateoffset();

        /* @name Sequence

         */
        //@{
    /*
     * Get TimeIncr element.
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetTimeIncr() const;

    /*
     * Set TimeIncr element.
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetTimeIncr(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVisualTimeSeriesType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVisualTimeSeriesType();

protected:
    Mp7JrsVisualTimeSeriesType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsmediaDurationPtr m_offset;
    bool m_offset_Exist;
    Mp7JrsmediaDurationPtr m_offset_Default;


    Mp7JrsmediaDurationPtr m_TimeIncr;

// no includefile for extension defined 
// file Mp7JrsVisualTimeSeriesType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2569MP7JRSVISUALTIMESERIESTYPE_H

