/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2173MP7JRSSUMMARYCOMPONENTTYPE_H
#define _2173MP7JRSSUMMARYCOMPONENTTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrssummaryComponentTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrssummaryComponentType_ExtInclude.h


#include "Mp7JrssummaryComponentType_LocalType.h"
class IMp7JrssummaryComponentType;
class IMp7JrssummaryComponentType_LocalType0;
class IMp7JrssummaryComponentType_LocalType1;
typedef Mp7JrsPtr< IMp7JrssummaryComponentType_LocalType0 > Mp7JrssummaryComponentType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrssummaryComponentType_LocalType1 > Mp7JrssummaryComponentType_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrssummaryComponentType> Mp7JrssummaryComponentPtr;

/** 
 * Generated interface IMp7JrssummaryComponentType for class Mp7JrssummaryComponentType<br>
 * Located at: mds-2001.xsd, line 6243<br>
 */
class MP7JRS_EXPORT IMp7JrssummaryComponentType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrssummaryComponentType();
    virtual ~IMp7JrssummaryComponentType();
    /** @name Union

     */
    //@{
    /**
     * Get Mp7JrssummaryComponentType_LocalType element.
     * @return Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual Mp7JrssummaryComponentType_LocalType::Enumeration GetsummaryComponentType_LocalType() const = 0;

    /**
     * Set Mp7JrssummaryComponentType_LocalType element.
     * @param item Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual void SetsummaryComponentType_LocalType(Mp7JrssummaryComponentType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrssummaryComponentType_LocalType0 element.
     * @return Mp7JrssummaryComponentType_Local0Ptr
     */
    virtual Mp7JrssummaryComponentType_Local0Ptr GetsummaryComponentType_LocalType0() const = 0;

    /**
     * Set Mp7JrssummaryComponentType_LocalType0 element.
     * @param item const Mp7JrssummaryComponentType_Local0Ptr &
     */
    virtual void SetsummaryComponentType_LocalType0(const Mp7JrssummaryComponentType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrssummaryComponentType_LocalType1 element.
     * @return Mp7JrssummaryComponentType_Local1Ptr
     */
    virtual Mp7JrssummaryComponentType_Local1Ptr GetsummaryComponentType_LocalType1() const = 0;

    /**
     * Set Mp7JrssummaryComponentType_LocalType1 element.
     * @param item const Mp7JrssummaryComponentType_Local1Ptr &
     */
    virtual void SetsummaryComponentType_LocalType1(const Mp7JrssummaryComponentType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    //@}
// no includefile for extension defined 
// file Mp7JrssummaryComponentType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrssummaryComponentType_ExtPropDef.h

};




/*
 * Generated class Mp7JrssummaryComponentType<br>
 * Located at: mds-2001.xsd, line 6243<br>
 * Defined in mds-2001.xsd, line 6243.<br>
 */
class MP7JRS_EXPORT Mp7JrssummaryComponentType :
        public IMp7JrssummaryComponentType
{
    friend class Mp7JrssummaryComponentTypeFactory; // constructs objects

public:
    /* @name Union

     */
    //@{
    /*
     * Get Mp7JrssummaryComponentType_LocalType element.
     * @return Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual Mp7JrssummaryComponentType_LocalType::Enumeration GetsummaryComponentType_LocalType() const;

    /*
     * Set Mp7JrssummaryComponentType_LocalType element.
     * @param item Mp7JrssummaryComponentType_LocalType::Enumeration
     */
    virtual void SetsummaryComponentType_LocalType(Mp7JrssummaryComponentType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrssummaryComponentType_LocalType0 element.
     * @return Mp7JrssummaryComponentType_Local0Ptr
     */
    virtual Mp7JrssummaryComponentType_Local0Ptr GetsummaryComponentType_LocalType0() const;

    /*
     * Set Mp7JrssummaryComponentType_LocalType0 element.
     * @param item const Mp7JrssummaryComponentType_Local0Ptr &
     */
    virtual void SetsummaryComponentType_LocalType0(const Mp7JrssummaryComponentType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrssummaryComponentType_LocalType1 element.
     * @return Mp7JrssummaryComponentType_Local1Ptr
     */
    virtual Mp7JrssummaryComponentType_Local1Ptr GetsummaryComponentType_LocalType1() const;

    /*
     * Set Mp7JrssummaryComponentType_LocalType1 element.
     * @param item const Mp7JrssummaryComponentType_Local1Ptr &
     */
    virtual void SetsummaryComponentType_LocalType1(const Mp7JrssummaryComponentType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrssummaryComponentType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrssummaryComponentType();

protected:
    Mp7JrssummaryComponentType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionUnion
    Mp7JrssummaryComponentType_LocalType::Enumeration m_summaryComponentType_LocalType;
    Mp7JrssummaryComponentType_Local0Ptr m_summaryComponentType_LocalType0;
    Mp7JrssummaryComponentType_Local1Ptr m_summaryComponentType_LocalType1;
// End DefinionUnion

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2173MP7JRSSUMMARYCOMPONENTTYPE_H

