/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/


#ifndef _2175MP7JRSSUMMARYCOMPONENTTYPE_LOCALTYPE_H
#define _2175MP7JRSSUMMARYCOMPONENTTYPE_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrssummaryComponentType_LocalType<br>
 * Located at: mds-2001.xsd, line 6245<br>
 * Enumerations: <br>
 * audio (mapped to XML audio) <br>
 * visual (mapped to XML visual) <br>
 * audioVisual (mapped to XML audioVisual) <br>
 * textual (mapped to XML textual) <br>
 * keyAudioClips (mapped to XML keyAudioClips) <br>
 * keyVideoClips (mapped to XML keyVideoClips) <br>
 * keyAudioVisualClips (mapped to XML keyAudioVisualClips) <br>
 * keyFrames (mapped to XML keyFrames) <br>
 * keySounds (mapped to XML keySounds) <br>
 * keyThemes (mapped to XML keyThemes) <br>
 */
class MP7JRS_EXPORT Mp7JrssummaryComponentType_LocalType
{
public:
	/** Mp7JrssummaryComponentType_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		audio, // Mapped to audio
		visual, // Mapped to visual
		audioVisual, // Mapped to audioVisual
		textual, // Mapped to textual
		keyAudioClips, // Mapped to keyAudioClips
		keyVideoClips, // Mapped to keyVideoClips
		keyAudioVisualClips, // Mapped to keyAudioVisualClips
		keyFrames, // Mapped to keyFrames
		keySounds, // Mapped to keySounds
		keyThemes, // Mapped to keyThemes
	};
	

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrssummaryComponentType_LocalType::Enumeration item);
	static Mp7JrssummaryComponentType_LocalType::Enumeration Parse(const XMLCh * const txt);

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtPropDef.h


};
#endif // _2175MP7JRSSUMMARYCOMPONENTTYPE_LOCALTYPE_H
