/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2281MP7JRSTERMRELATIONQUALIFIERTYPE_H
#define _2281MP7JRSTERMRELATIONQUALIFIERTYPE_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrstermRelationQualifierTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7JrstermRelationQualifierType_ExtInclude.h


#include "Mp7JrstermRelationQualifierType_LocalType.h"
class IMp7JrstermRelationQualifierType;
class IMp7JrstermRelationQualifierType_LocalType0;
class IMp7JrstermRelationQualifierType_LocalType1;
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType_LocalType0 > Mp7JrstermRelationQualifierType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType_LocalType1 > Mp7JrstermRelationQualifierType_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType> Mp7JrstermRelationQualifierPtr;

/** 
 * Generated interface IMp7JrstermRelationQualifierType for class Mp7JrstermRelationQualifierType<br>
 * Located at: mds-2001.xsd, line 1446<br>
 */
class MP7JRS_EXPORT IMp7JrstermRelationQualifierType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrstermRelationQualifierType();
    virtual ~IMp7JrstermRelationQualifierType();
    /** @name Union

     */
    //@{
    /**
     * Get Mp7JrstermRelationQualifierType_LocalType element.
     * @return Mp7JrstermRelationQualifierType_LocalType::Enumeration
     */
    virtual Mp7JrstermRelationQualifierType_LocalType::Enumeration GettermRelationQualifierType_LocalType() const = 0;

    /**
     * Set Mp7JrstermRelationQualifierType_LocalType element.
     * @param item Mp7JrstermRelationQualifierType_LocalType::Enumeration
     */
    virtual void SettermRelationQualifierType_LocalType(Mp7JrstermRelationQualifierType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrstermRelationQualifierType_LocalType0 element.
     * @return Mp7JrstermRelationQualifierType_Local0Ptr
     */
    virtual Mp7JrstermRelationQualifierType_Local0Ptr GettermRelationQualifierType_LocalType0() const = 0;

    /**
     * Set Mp7JrstermRelationQualifierType_LocalType0 element.
     * @param item const Mp7JrstermRelationQualifierType_Local0Ptr &
     */
    virtual void SettermRelationQualifierType_LocalType0(const Mp7JrstermRelationQualifierType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrstermRelationQualifierType_LocalType1 element.
     * @return Mp7JrstermRelationQualifierType_Local1Ptr
     */
    virtual Mp7JrstermRelationQualifierType_Local1Ptr GettermRelationQualifierType_LocalType1() const = 0;

    /**
     * Set Mp7JrstermRelationQualifierType_LocalType1 element.
     * @param item const Mp7JrstermRelationQualifierType_Local1Ptr &
     */
    virtual void SettermRelationQualifierType_LocalType1(const Mp7JrstermRelationQualifierType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    //@}
// no includefile for extension defined 
// file Mp7JrstermRelationQualifierType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrstermRelationQualifierType_ExtPropDef.h

};




/*
 * Generated class Mp7JrstermRelationQualifierType<br>
 * Located at: mds-2001.xsd, line 1446<br>
 * Defined in mds-2001.xsd, line 1446.<br>
 */
class MP7JRS_EXPORT Mp7JrstermRelationQualifierType :
        public IMp7JrstermRelationQualifierType
{
    friend class Mp7JrstermRelationQualifierTypeFactory; // constructs objects

public:
    /* @name Union

     */
    //@{
    /*
     * Get Mp7JrstermRelationQualifierType_LocalType element.
     * @return Mp7JrstermRelationQualifierType_LocalType::Enumeration
     */
    virtual Mp7JrstermRelationQualifierType_LocalType::Enumeration GettermRelationQualifierType_LocalType() const;

    /*
     * Set Mp7JrstermRelationQualifierType_LocalType element.
     * @param item Mp7JrstermRelationQualifierType_LocalType::Enumeration
     */
    virtual void SettermRelationQualifierType_LocalType(Mp7JrstermRelationQualifierType_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrstermRelationQualifierType_LocalType0 element.
     * @return Mp7JrstermRelationQualifierType_Local0Ptr
     */
    virtual Mp7JrstermRelationQualifierType_Local0Ptr GettermRelationQualifierType_LocalType0() const;

    /*
     * Set Mp7JrstermRelationQualifierType_LocalType0 element.
     * @param item const Mp7JrstermRelationQualifierType_Local0Ptr &
     */
    virtual void SettermRelationQualifierType_LocalType0(const Mp7JrstermRelationQualifierType_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrstermRelationQualifierType_LocalType1 element.
     * @return Mp7JrstermRelationQualifierType_Local1Ptr
     */
    virtual Mp7JrstermRelationQualifierType_Local1Ptr GettermRelationQualifierType_LocalType1() const;

    /*
     * Set Mp7JrstermRelationQualifierType_LocalType1 element.
     * @param item const Mp7JrstermRelationQualifierType_Local1Ptr &
     */
    virtual void SettermRelationQualifierType_LocalType1(const Mp7JrstermRelationQualifierType_Local1Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrstermRelationQualifierType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrstermRelationQualifierType();

protected:
    Mp7JrstermRelationQualifierType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionUnion
    Mp7JrstermRelationQualifierType_LocalType::Enumeration m_termRelationQualifierType_LocalType;
    Mp7JrstermRelationQualifierType_Local0Ptr m_termRelationQualifierType_LocalType0;
    Mp7JrstermRelationQualifierType_Local1Ptr m_termRelationQualifierType_LocalType1;
// End DefinionUnion

// no includefile for extension defined 
// file Mp7JrstermRelationQualifierType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2281MP7JRSTERMRELATIONQUALIFIERTYPE_H

