/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2389MP7JRSUNSIGNED3_H
#define _2389MP7JRSUNSIGNED3_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7Jrsunsigned3Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>


// no includefile for extension defined 
// file Mp7Jrsunsigned3_ExtInclude.h


class IMp7Jrsunsigned3;
typedef Mp7JrsPtr< IMp7Jrsunsigned3> Mp7Jrsunsigned3Ptr;

/** 
 * Generated interface IMp7Jrsunsigned3 for class Mp7Jrsunsigned3<br>
 * Located at: mds-2001.xsd, line 453<br>
 * Derived from: nonNegativeInteger (Value)<br>
 */
class MP7JRS_EXPORT IMp7Jrsunsigned3 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7Jrsunsigned3();
    virtual ~IMp7Jrsunsigned3();
    /**
     * Sets the content of Mp7Jrsunsigned3     * @param item unsigned
     */
    virtual void SetContent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7Jrsunsigned3 
     * @return unsigned
     */
    virtual unsigned GetContent() const = 0;

// no includefile for extension defined 
// file Mp7Jrsunsigned3_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7Jrsunsigned3_ExtPropDef.h

};




/*
 * Generated class Mp7Jrsunsigned3<br>
 * Located at: mds-2001.xsd, line 453<br>
 * Derived from: nonNegativeInteger (Value)<br>
 * Defined in mds-2001.xsd, line 453.<br>
 */
class MP7JRS_EXPORT Mp7Jrsunsigned3 :
        public IMp7Jrsunsigned3
{
    friend class Mp7Jrsunsigned3Factory; // constructs objects

public:
    /*
     * Sets the content of Mp7Jrsunsigned3     * @param item unsigned
     */
    virtual void SetContent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7Jrsunsigned3 
     * @return unsigned
     */
    virtual unsigned GetContent() const;


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const type, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7Jrsunsigned3_ExtMyMethodDef.h


public:

    virtual ~Mp7Jrsunsigned3();

protected:
    Mp7Jrsunsigned3();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Value
    unsigned m_Base;


// no includefile for extension defined 
// file Mp7Jrsunsigned3_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2389MP7JRSUNSIGNED3_H

