/*****************************************************************************/
/* Copyright (C) 2003-2005, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

#ifndef MP7JRSFACTORYDEFINES_H
#define MP7JRSFACTORYDEFINES_H

// FTT TODO to remove #include "Mp7JrsClass.h"
#include "Mp7JrsPtr.h"

// Generated creation defines for core classes

// Note: for destruction use Factory::DeleteObject(Node * item);
// Note: Refcounting pointers don't need to be deleted explicitly

// IDREFS found
#define TypeOfIDREFS (Mp7JrsFactory::GetTypeIndex(X("IDREFS")))
#define CreateIDREFS (Mp7JrsFactory::CreateObject(TypeOfIDREFS))
class Mp7JrsIDREFS;
class IMp7JrsIDREFS;

/** Smart pointer to instance of IMp7JrsIDREFS */
typedef Mp7JrsPtr< IMp7JrsIDREFS > Mp7JrsIDREFSPtr;

#define TypeOfspace_LocalType (Mp7JrsFactory::GetTypeIndex(X("space_LocalType")))
#define Createspace_LocalType (Mp7JrsFactory::CreateObject(TypeOfspace_LocalType))
class Mp7Jrsspace_LocalType;
class IMp7Jrsspace_LocalType;

#define TypeOfAbstractionLevelType (Mp7JrsFactory::GetTypeIndex(X("AbstractionLevelType")))
#define CreateAbstractionLevelType (Mp7JrsFactory::CreateObject(TypeOfAbstractionLevelType))
class Mp7JrsAbstractionLevelType;
class IMp7JrsAbstractionLevelType;
/** Smart pointer to instance of IMp7JrsAbstractionLevelType */
typedef Mp7JrsPtr< IMp7JrsAbstractionLevelType > Mp7JrsAbstractionLevelPtr;

#define TypeOfAffectiveType (Mp7JrsFactory::GetTypeIndex(X("AffectiveType")))
#define CreateAffectiveType (Mp7JrsFactory::CreateObject(TypeOfAffectiveType))
class Mp7JrsAffectiveType;
class IMp7JrsAffectiveType;
/** Smart pointer to instance of IMp7JrsAffectiveType */
typedef Mp7JrsPtr< IMp7JrsAffectiveType > Mp7JrsAffectivePtr;

#define TypeOfAffectiveType_Score_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AffectiveType_Score_CollectionType")))
#define CreateAffectiveType_Score_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAffectiveType_Score_CollectionType))
class Mp7JrsAffectiveType_Score_CollectionType;
class IMp7JrsAffectiveType_Score_CollectionType;
/** Smart pointer to instance of IMp7JrsAffectiveType_Score_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAffectiveType_Score_CollectionType > Mp7JrsAffectiveType_Score_CollectionPtr;

#define TypeOfAffectiveType_Score_LocalType (Mp7JrsFactory::GetTypeIndex(X("AffectiveType_Score_LocalType")))
#define CreateAffectiveType_Score_LocalType (Mp7JrsFactory::CreateObject(TypeOfAffectiveType_Score_LocalType))
class Mp7JrsAffectiveType_Score_LocalType;
class IMp7JrsAffectiveType_Score_LocalType;
/** Smart pointer to instance of IMp7JrsAffectiveType_Score_LocalType */
typedef Mp7JrsPtr< IMp7JrsAffectiveType_Score_LocalType > Mp7JrsAffectiveType_Score_LocalPtr;

#define TypeOfAgentObjectType (Mp7JrsFactory::GetTypeIndex(X("AgentObjectType")))
#define CreateAgentObjectType (Mp7JrsFactory::CreateObject(TypeOfAgentObjectType))
class Mp7JrsAgentObjectType;
class IMp7JrsAgentObjectType;
/** Smart pointer to instance of IMp7JrsAgentObjectType */
typedef Mp7JrsPtr< IMp7JrsAgentObjectType > Mp7JrsAgentObjectPtr;

#define TypeOfAgentType (Mp7JrsFactory::GetTypeIndex(X("AgentType")))
#define CreateAgentType (Mp7JrsFactory::CreateObject(TypeOfAgentType))
class Mp7JrsAgentType;
class IMp7JrsAgentType;
/** Smart pointer to instance of IMp7JrsAgentType */
typedef Mp7JrsPtr< IMp7JrsAgentType > Mp7JrsAgentPtr;

#define TypeOfAgentType_Icon_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AgentType_Icon_CollectionType")))
#define CreateAgentType_Icon_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAgentType_Icon_CollectionType))
class Mp7JrsAgentType_Icon_CollectionType;
class IMp7JrsAgentType_Icon_CollectionType;
/** Smart pointer to instance of IMp7JrsAgentType_Icon_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAgentType_Icon_CollectionType > Mp7JrsAgentType_Icon_CollectionPtr;

#define TypeOfAnalyticClipType (Mp7JrsFactory::GetTypeIndex(X("AnalyticClipType")))
#define CreateAnalyticClipType (Mp7JrsFactory::CreateObject(TypeOfAnalyticClipType))
class Mp7JrsAnalyticClipType;
class IMp7JrsAnalyticClipType;
/** Smart pointer to instance of IMp7JrsAnalyticClipType */
typedef Mp7JrsPtr< IMp7JrsAnalyticClipType > Mp7JrsAnalyticClipPtr;

#define TypeOfAnalyticEditedVideoSegmentSpatioTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoSegmentSpatioTemporalDecompositionType")))
#define CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoSegmentSpatioTemporalDecompositionType))
class Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType;
class IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType > Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionPtr;

#define TypeOfAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType")))
#define CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType))
class Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType;
class IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType > Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr;

#define TypeOfAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType")))
#define CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType))
class Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType;
class IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType > Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr;

#define TypeOfAnalyticEditedVideoSegmentType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoSegmentType")))
#define CreateAnalyticEditedVideoSegmentType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoSegmentType))
class Mp7JrsAnalyticEditedVideoSegmentType;
class IMp7JrsAnalyticEditedVideoSegmentType;
/** Smart pointer to instance of IMp7JrsAnalyticEditedVideoSegmentType */
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoSegmentType > Mp7JrsAnalyticEditedVideoSegmentPtr;

#define TypeOfAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType")))
#define CreateAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType))
class Mp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType;
class IMp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType > Mp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionPtr;

#define TypeOfAnalyticEditedVideoSegmentType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoSegmentType_type_LocalType")))
#define CreateAnalyticEditedVideoSegmentType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoSegmentType_type_LocalType))
class Mp7JrsAnalyticEditedVideoSegmentType_type_LocalType;
class IMp7JrsAnalyticEditedVideoSegmentType_type_LocalType;

#define TypeOfAnalyticEditedVideoType (Mp7JrsFactory::GetTypeIndex(X("AnalyticEditedVideoType")))
#define CreateAnalyticEditedVideoType (Mp7JrsFactory::CreateObject(TypeOfAnalyticEditedVideoType))
class Mp7JrsAnalyticEditedVideoType;
class IMp7JrsAnalyticEditedVideoType;
/** Smart pointer to instance of IMp7JrsAnalyticEditedVideoType */
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoType > Mp7JrsAnalyticEditedVideoPtr;

#define TypeOfAnalyticModelType (Mp7JrsFactory::GetTypeIndex(X("AnalyticModelType")))
#define CreateAnalyticModelType (Mp7JrsFactory::CreateObject(TypeOfAnalyticModelType))
class Mp7JrsAnalyticModelType;
class IMp7JrsAnalyticModelType;
/** Smart pointer to instance of IMp7JrsAnalyticModelType */
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType > Mp7JrsAnalyticModelPtr;

#define TypeOfAnalyticModelType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AnalyticModelType_CollectionType")))
#define CreateAnalyticModelType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAnalyticModelType_CollectionType))
class Mp7JrsAnalyticModelType_CollectionType;
class IMp7JrsAnalyticModelType_CollectionType;
/** Smart pointer to instance of IMp7JrsAnalyticModelType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType_CollectionType > Mp7JrsAnalyticModelType_CollectionPtr;

#define TypeOfAnalyticModelType_function_LocalType (Mp7JrsFactory::GetTypeIndex(X("AnalyticModelType_function_LocalType")))
#define CreateAnalyticModelType_function_LocalType (Mp7JrsFactory::CreateObject(TypeOfAnalyticModelType_function_LocalType))
class Mp7JrsAnalyticModelType_function_LocalType;
class IMp7JrsAnalyticModelType_function_LocalType;

#define TypeOfAnalyticModelType_Label_LocalType (Mp7JrsFactory::GetTypeIndex(X("AnalyticModelType_Label_LocalType")))
#define CreateAnalyticModelType_Label_LocalType (Mp7JrsFactory::CreateObject(TypeOfAnalyticModelType_Label_LocalType))
class Mp7JrsAnalyticModelType_Label_LocalType;
class IMp7JrsAnalyticModelType_Label_LocalType;
/** Smart pointer to instance of IMp7JrsAnalyticModelType_Label_LocalType */
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType_Label_LocalType > Mp7JrsAnalyticModelType_Label_LocalPtr;

#define TypeOfAnalyticModelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AnalyticModelType_LocalType")))
#define CreateAnalyticModelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAnalyticModelType_LocalType))
class Mp7JrsAnalyticModelType_LocalType;
class IMp7JrsAnalyticModelType_LocalType;
/** Smart pointer to instance of IMp7JrsAnalyticModelType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType_LocalType > Mp7JrsAnalyticModelType_LocalPtr;

#define TypeOfAnalyticModelType_Semantics_LocalType (Mp7JrsFactory::GetTypeIndex(X("AnalyticModelType_Semantics_LocalType")))
#define CreateAnalyticModelType_Semantics_LocalType (Mp7JrsFactory::CreateObject(TypeOfAnalyticModelType_Semantics_LocalType))
class Mp7JrsAnalyticModelType_Semantics_LocalType;
class IMp7JrsAnalyticModelType_Semantics_LocalType;
/** Smart pointer to instance of IMp7JrsAnalyticModelType_Semantics_LocalType */
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType_Semantics_LocalType > Mp7JrsAnalyticModelType_Semantics_LocalPtr;

#define TypeOfAnalyticTransitionType (Mp7JrsFactory::GetTypeIndex(X("AnalyticTransitionType")))
#define CreateAnalyticTransitionType (Mp7JrsFactory::CreateObject(TypeOfAnalyticTransitionType))
class Mp7JrsAnalyticTransitionType;
class IMp7JrsAnalyticTransitionType;
/** Smart pointer to instance of IMp7JrsAnalyticTransitionType */
typedef Mp7JrsPtr< IMp7JrsAnalyticTransitionType > Mp7JrsAnalyticTransitionPtr;

#define TypeOfAudioDSType (Mp7JrsFactory::GetTypeIndex(X("AudioDSType")))
#define CreateAudioDSType (Mp7JrsFactory::CreateObject(TypeOfAudioDSType))
class Mp7JrsAudioDSType;
class IMp7JrsAudioDSType;
/** Smart pointer to instance of IMp7JrsAudioDSType */
typedef Mp7JrsPtr< IMp7JrsAudioDSType > Mp7JrsAudioDSPtr;

#define TypeOfAudioDType (Mp7JrsFactory::GetTypeIndex(X("AudioDType")))
#define CreateAudioDType (Mp7JrsFactory::CreateObject(TypeOfAudioDType))
class Mp7JrsAudioDType;
class IMp7JrsAudioDType;
/** Smart pointer to instance of IMp7JrsAudioDType */
typedef Mp7JrsPtr< IMp7JrsAudioDType > Mp7JrsAudioDPtr;

#define TypeOfAudioFundamentalFrequencyType (Mp7JrsFactory::GetTypeIndex(X("AudioFundamentalFrequencyType")))
#define CreateAudioFundamentalFrequencyType (Mp7JrsFactory::CreateObject(TypeOfAudioFundamentalFrequencyType))
class Mp7JrsAudioFundamentalFrequencyType;
class IMp7JrsAudioFundamentalFrequencyType;
/** Smart pointer to instance of IMp7JrsAudioFundamentalFrequencyType */
typedef Mp7JrsPtr< IMp7JrsAudioFundamentalFrequencyType > Mp7JrsAudioFundamentalFrequencyPtr;

#define TypeOfAudioHarmonicityType (Mp7JrsFactory::GetTypeIndex(X("AudioHarmonicityType")))
#define CreateAudioHarmonicityType (Mp7JrsFactory::CreateObject(TypeOfAudioHarmonicityType))
class Mp7JrsAudioHarmonicityType;
class IMp7JrsAudioHarmonicityType;
/** Smart pointer to instance of IMp7JrsAudioHarmonicityType */
typedef Mp7JrsPtr< IMp7JrsAudioHarmonicityType > Mp7JrsAudioHarmonicityPtr;

#define TypeOfAudioLLDScalarType (Mp7JrsFactory::GetTypeIndex(X("AudioLLDScalarType")))
#define CreateAudioLLDScalarType (Mp7JrsFactory::CreateObject(TypeOfAudioLLDScalarType))
class Mp7JrsAudioLLDScalarType;
class IMp7JrsAudioLLDScalarType;
/** Smart pointer to instance of IMp7JrsAudioLLDScalarType */
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType > Mp7JrsAudioLLDScalarPtr;

#define TypeOfAudioLLDScalarType_SeriesOfScalar_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioLLDScalarType_SeriesOfScalar_CollectionType")))
#define CreateAudioLLDScalarType_SeriesOfScalar_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioLLDScalarType_SeriesOfScalar_CollectionType))
class Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType;
class IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType > Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr;

#define TypeOfAudioLLDScalarType_SeriesOfScalar_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioLLDScalarType_SeriesOfScalar_LocalType")))
#define CreateAudioLLDScalarType_SeriesOfScalar_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioLLDScalarType_SeriesOfScalar_LocalType))
class Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType;
class IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType;
/** Smart pointer to instance of IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType > Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalPtr;

#define TypeOfAudioLLDVectorType (Mp7JrsFactory::GetTypeIndex(X("AudioLLDVectorType")))
#define CreateAudioLLDVectorType (Mp7JrsFactory::CreateObject(TypeOfAudioLLDVectorType))
class Mp7JrsAudioLLDVectorType;
class IMp7JrsAudioLLDVectorType;
/** Smart pointer to instance of IMp7JrsAudioLLDVectorType */
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType > Mp7JrsAudioLLDVectorPtr;

#define TypeOfAudioLLDVectorType_SeriesOfVector_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioLLDVectorType_SeriesOfVector_CollectionType")))
#define CreateAudioLLDVectorType_SeriesOfVector_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioLLDVectorType_SeriesOfVector_CollectionType))
class Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType;
class IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType > Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionPtr;

#define TypeOfAudioLLDVectorType_SeriesOfVector_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioLLDVectorType_SeriesOfVector_LocalType")))
#define CreateAudioLLDVectorType_SeriesOfVector_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioLLDVectorType_SeriesOfVector_LocalType))
class Mp7JrsAudioLLDVectorType_SeriesOfVector_LocalType;
class IMp7JrsAudioLLDVectorType_SeriesOfVector_LocalType;
/** Smart pointer to instance of IMp7JrsAudioLLDVectorType_SeriesOfVector_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioLLDVectorType_SeriesOfVector_LocalType > Mp7JrsAudioLLDVectorType_SeriesOfVector_LocalPtr;

#define TypeOfAudioPowerType (Mp7JrsFactory::GetTypeIndex(X("AudioPowerType")))
#define CreateAudioPowerType (Mp7JrsFactory::CreateObject(TypeOfAudioPowerType))
class Mp7JrsAudioPowerType;
class IMp7JrsAudioPowerType;
/** Smart pointer to instance of IMp7JrsAudioPowerType */
typedef Mp7JrsPtr< IMp7JrsAudioPowerType > Mp7JrsAudioPowerPtr;

#define TypeOfAudioSegmentMediaSourceDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentMediaSourceDecompositionType")))
#define CreateAudioSegmentMediaSourceDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentMediaSourceDecompositionType))
class Mp7JrsAudioSegmentMediaSourceDecompositionType;
class IMp7JrsAudioSegmentMediaSourceDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioSegmentMediaSourceDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentMediaSourceDecompositionType > Mp7JrsAudioSegmentMediaSourceDecompositionPtr;

#define TypeOfAudioSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentMediaSourceDecompositionType_CollectionType")))
#define CreateAudioSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentMediaSourceDecompositionType_CollectionType))
class Mp7JrsAudioSegmentMediaSourceDecompositionType_CollectionType;
class IMp7JrsAudioSegmentMediaSourceDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioSegmentMediaSourceDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentMediaSourceDecompositionType_CollectionType > Mp7JrsAudioSegmentMediaSourceDecompositionType_CollectionPtr;

#define TypeOfAudioSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentMediaSourceDecompositionType_LocalType")))
#define CreateAudioSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentMediaSourceDecompositionType_LocalType))
class Mp7JrsAudioSegmentMediaSourceDecompositionType_LocalType;
class IMp7JrsAudioSegmentMediaSourceDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioSegmentMediaSourceDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentMediaSourceDecompositionType_LocalType > Mp7JrsAudioSegmentMediaSourceDecompositionType_LocalPtr;

#define TypeOfAudioSegmentTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentTemporalDecompositionType")))
#define CreateAudioSegmentTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentTemporalDecompositionType))
class Mp7JrsAudioSegmentTemporalDecompositionType;
class IMp7JrsAudioSegmentTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioSegmentTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentTemporalDecompositionType > Mp7JrsAudioSegmentTemporalDecompositionPtr;

#define TypeOfAudioSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentTemporalDecompositionType_CollectionType")))
#define CreateAudioSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentTemporalDecompositionType_CollectionType))
class Mp7JrsAudioSegmentTemporalDecompositionType_CollectionType;
class IMp7JrsAudioSegmentTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioSegmentTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentTemporalDecompositionType_CollectionType > Mp7JrsAudioSegmentTemporalDecompositionType_CollectionPtr;

#define TypeOfAudioSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentTemporalDecompositionType_LocalType")))
#define CreateAudioSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentTemporalDecompositionType_LocalType))
class Mp7JrsAudioSegmentTemporalDecompositionType_LocalType;
class IMp7JrsAudioSegmentTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioSegmentTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentTemporalDecompositionType_LocalType > Mp7JrsAudioSegmentTemporalDecompositionType_LocalPtr;

#define TypeOfAudioSegmentType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentType")))
#define CreateAudioSegmentType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentType))
class Mp7JrsAudioSegmentType;
class IMp7JrsAudioSegmentType;
/** Smart pointer to instance of IMp7JrsAudioSegmentType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType > Mp7JrsAudioSegmentPtr;

#define TypeOfAudioSegmentType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentType_CollectionType")))
#define CreateAudioSegmentType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentType_CollectionType))
class Mp7JrsAudioSegmentType_CollectionType;
class IMp7JrsAudioSegmentType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioSegmentType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType_CollectionType > Mp7JrsAudioSegmentType_CollectionPtr;

#define TypeOfAudioSegmentType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentType_CollectionType0")))
#define CreateAudioSegmentType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentType_CollectionType0))
class Mp7JrsAudioSegmentType_CollectionType0;
class IMp7JrsAudioSegmentType_CollectionType0;
/** Smart pointer to instance of IMp7JrsAudioSegmentType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType_CollectionType0 > Mp7JrsAudioSegmentType_Collection0Ptr;

#define TypeOfAudioSegmentType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentType_LocalType")))
#define CreateAudioSegmentType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentType_LocalType))
class Mp7JrsAudioSegmentType_LocalType;
class IMp7JrsAudioSegmentType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioSegmentType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType_LocalType > Mp7JrsAudioSegmentType_LocalPtr;

#define TypeOfAudioSegmentType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("AudioSegmentType_LocalType0")))
#define CreateAudioSegmentType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfAudioSegmentType_LocalType0))
class Mp7JrsAudioSegmentType_LocalType0;
class IMp7JrsAudioSegmentType_LocalType0;
/** Smart pointer to instance of IMp7JrsAudioSegmentType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType_LocalType0 > Mp7JrsAudioSegmentType_Local0Ptr;

#define TypeOfAudioSignatureType (Mp7JrsFactory::GetTypeIndex(X("AudioSignatureType")))
#define CreateAudioSignatureType (Mp7JrsFactory::CreateObject(TypeOfAudioSignatureType))
class Mp7JrsAudioSignatureType;
class IMp7JrsAudioSignatureType;
/** Smart pointer to instance of IMp7JrsAudioSignatureType */
typedef Mp7JrsPtr< IMp7JrsAudioSignatureType > Mp7JrsAudioSignaturePtr;

#define TypeOfaudioSpectrumAttributeGrp_octaveResolution_LocalType (Mp7JrsFactory::GetTypeIndex(X("audioSpectrumAttributeGrp_octaveResolution_LocalType")))
#define CreateaudioSpectrumAttributeGrp_octaveResolution_LocalType (Mp7JrsFactory::CreateObject(TypeOfaudioSpectrumAttributeGrp_octaveResolution_LocalType))
class Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType;
class IMp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType;

#define TypeOfAudioSpectrumBasisType (Mp7JrsFactory::GetTypeIndex(X("AudioSpectrumBasisType")))
#define CreateAudioSpectrumBasisType (Mp7JrsFactory::CreateObject(TypeOfAudioSpectrumBasisType))
class Mp7JrsAudioSpectrumBasisType;
class IMp7JrsAudioSpectrumBasisType;
/** Smart pointer to instance of IMp7JrsAudioSpectrumBasisType */
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumBasisType > Mp7JrsAudioSpectrumBasisPtr;

#define TypeOfAudioSpectrumCentroidType (Mp7JrsFactory::GetTypeIndex(X("AudioSpectrumCentroidType")))
#define CreateAudioSpectrumCentroidType (Mp7JrsFactory::CreateObject(TypeOfAudioSpectrumCentroidType))
class Mp7JrsAudioSpectrumCentroidType;
class IMp7JrsAudioSpectrumCentroidType;
/** Smart pointer to instance of IMp7JrsAudioSpectrumCentroidType */
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumCentroidType > Mp7JrsAudioSpectrumCentroidPtr;

#define TypeOfAudioSpectrumEnvelopeType (Mp7JrsFactory::GetTypeIndex(X("AudioSpectrumEnvelopeType")))
#define CreateAudioSpectrumEnvelopeType (Mp7JrsFactory::CreateObject(TypeOfAudioSpectrumEnvelopeType))
class Mp7JrsAudioSpectrumEnvelopeType;
class IMp7JrsAudioSpectrumEnvelopeType;
/** Smart pointer to instance of IMp7JrsAudioSpectrumEnvelopeType */
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumEnvelopeType > Mp7JrsAudioSpectrumEnvelopePtr;

#define TypeOfAudioSpectrumFlatnessType (Mp7JrsFactory::GetTypeIndex(X("AudioSpectrumFlatnessType")))
#define CreateAudioSpectrumFlatnessType (Mp7JrsFactory::CreateObject(TypeOfAudioSpectrumFlatnessType))
class Mp7JrsAudioSpectrumFlatnessType;
class IMp7JrsAudioSpectrumFlatnessType;
/** Smart pointer to instance of IMp7JrsAudioSpectrumFlatnessType */
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumFlatnessType > Mp7JrsAudioSpectrumFlatnessPtr;

#define TypeOfAudioSpectrumProjectionType (Mp7JrsFactory::GetTypeIndex(X("AudioSpectrumProjectionType")))
#define CreateAudioSpectrumProjectionType (Mp7JrsFactory::CreateObject(TypeOfAudioSpectrumProjectionType))
class Mp7JrsAudioSpectrumProjectionType;
class IMp7JrsAudioSpectrumProjectionType;
/** Smart pointer to instance of IMp7JrsAudioSpectrumProjectionType */
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumProjectionType > Mp7JrsAudioSpectrumProjectionPtr;

#define TypeOfAudioSpectrumSpreadType (Mp7JrsFactory::GetTypeIndex(X("AudioSpectrumSpreadType")))
#define CreateAudioSpectrumSpreadType (Mp7JrsFactory::CreateObject(TypeOfAudioSpectrumSpreadType))
class Mp7JrsAudioSpectrumSpreadType;
class IMp7JrsAudioSpectrumSpreadType;
/** Smart pointer to instance of IMp7JrsAudioSpectrumSpreadType */
typedef Mp7JrsPtr< IMp7JrsAudioSpectrumSpreadType > Mp7JrsAudioSpectrumSpreadPtr;

#define TypeOfAudioSummaryComponentType (Mp7JrsFactory::GetTypeIndex(X("AudioSummaryComponentType")))
#define CreateAudioSummaryComponentType (Mp7JrsFactory::CreateObject(TypeOfAudioSummaryComponentType))
class Mp7JrsAudioSummaryComponentType;
class IMp7JrsAudioSummaryComponentType;
/** Smart pointer to instance of IMp7JrsAudioSummaryComponentType */
typedef Mp7JrsPtr< IMp7JrsAudioSummaryComponentType > Mp7JrsAudioSummaryComponentPtr;

#define TypeOfAudioSummaryComponentType_Title_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioSummaryComponentType_Title_CollectionType")))
#define CreateAudioSummaryComponentType_Title_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioSummaryComponentType_Title_CollectionType))
class Mp7JrsAudioSummaryComponentType_Title_CollectionType;
class IMp7JrsAudioSummaryComponentType_Title_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioSummaryComponentType_Title_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioSummaryComponentType_Title_CollectionType > Mp7JrsAudioSummaryComponentType_Title_CollectionPtr;

#define TypeOfAudioType (Mp7JrsFactory::GetTypeIndex(X("AudioType")))
#define CreateAudioType (Mp7JrsFactory::CreateObject(TypeOfAudioType))
class Mp7JrsAudioType;
class IMp7JrsAudioType;
/** Smart pointer to instance of IMp7JrsAudioType */
typedef Mp7JrsPtr< IMp7JrsAudioType > Mp7JrsAudioPtr;

#define TypeOfAudioVisualRegionMediaSourceDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionMediaSourceDecompositionType")))
#define CreateAudioVisualRegionMediaSourceDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionMediaSourceDecompositionType))
class Mp7JrsAudioVisualRegionMediaSourceDecompositionType;
class IMp7JrsAudioVisualRegionMediaSourceDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionMediaSourceDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionMediaSourceDecompositionType > Mp7JrsAudioVisualRegionMediaSourceDecompositionPtr;

#define TypeOfAudioVisualRegionMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionMediaSourceDecompositionType_CollectionType")))
#define CreateAudioVisualRegionMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionMediaSourceDecompositionType_CollectionType))
class Mp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionType;
class IMp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionType > Mp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionPtr;

#define TypeOfAudioVisualRegionMediaSourceDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionMediaSourceDecompositionType_LocalType")))
#define CreateAudioVisualRegionMediaSourceDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionMediaSourceDecompositionType_LocalType))
class Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType;
class IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType > Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalPtr;

#define TypeOfAudioVisualRegionSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionSpatialDecompositionType")))
#define CreateAudioVisualRegionSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionSpatialDecompositionType))
class Mp7JrsAudioVisualRegionSpatialDecompositionType;
class IMp7JrsAudioVisualRegionSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatialDecompositionType > Mp7JrsAudioVisualRegionSpatialDecompositionPtr;

#define TypeOfAudioVisualRegionSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionSpatialDecompositionType_CollectionType")))
#define CreateAudioVisualRegionSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionSpatialDecompositionType_CollectionType))
class Mp7JrsAudioVisualRegionSpatialDecompositionType_CollectionType;
class IMp7JrsAudioVisualRegionSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatialDecompositionType_CollectionType > Mp7JrsAudioVisualRegionSpatialDecompositionType_CollectionPtr;

#define TypeOfAudioVisualRegionSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionSpatialDecompositionType_LocalType")))
#define CreateAudioVisualRegionSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionSpatialDecompositionType_LocalType))
class Mp7JrsAudioVisualRegionSpatialDecompositionType_LocalType;
class IMp7JrsAudioVisualRegionSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatialDecompositionType_LocalType > Mp7JrsAudioVisualRegionSpatialDecompositionType_LocalPtr;

#define TypeOfAudioVisualRegionSpatioTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionSpatioTemporalDecompositionType")))
#define CreateAudioVisualRegionSpatioTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionSpatioTemporalDecompositionType))
class Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType;
class IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType > Mp7JrsAudioVisualRegionSpatioTemporalDecompositionPtr;

#define TypeOfAudioVisualRegionSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionSpatioTemporalDecompositionType_CollectionType")))
#define CreateAudioVisualRegionSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionSpatioTemporalDecompositionType_CollectionType))
class Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionType;
class IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionType > Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionPtr;

#define TypeOfAudioVisualRegionSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionSpatioTemporalDecompositionType_LocalType")))
#define CreateAudioVisualRegionSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionSpatioTemporalDecompositionType_LocalType))
class Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalType;
class IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalType > Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalPtr;

#define TypeOfAudioVisualRegionTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionTemporalDecompositionType")))
#define CreateAudioVisualRegionTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionTemporalDecompositionType))
class Mp7JrsAudioVisualRegionTemporalDecompositionType;
class IMp7JrsAudioVisualRegionTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionTemporalDecompositionType > Mp7JrsAudioVisualRegionTemporalDecompositionPtr;

#define TypeOfAudioVisualRegionTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionTemporalDecompositionType_CollectionType")))
#define CreateAudioVisualRegionTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionTemporalDecompositionType_CollectionType))
class Mp7JrsAudioVisualRegionTemporalDecompositionType_CollectionType;
class IMp7JrsAudioVisualRegionTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionTemporalDecompositionType_CollectionType > Mp7JrsAudioVisualRegionTemporalDecompositionType_CollectionPtr;

#define TypeOfAudioVisualRegionTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionTemporalDecompositionType_LocalType")))
#define CreateAudioVisualRegionTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionTemporalDecompositionType_LocalType))
class Mp7JrsAudioVisualRegionTemporalDecompositionType_LocalType;
class IMp7JrsAudioVisualRegionTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionTemporalDecompositionType_LocalType > Mp7JrsAudioVisualRegionTemporalDecompositionType_LocalPtr;

#define TypeOfAudioVisualRegionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionType")))
#define CreateAudioVisualRegionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionType))
class Mp7JrsAudioVisualRegionType;
class IMp7JrsAudioVisualRegionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionType > Mp7JrsAudioVisualRegionPtr;

#define TypeOfAudioVisualRegionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionType_CollectionType")))
#define CreateAudioVisualRegionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionType_CollectionType))
class Mp7JrsAudioVisualRegionType_CollectionType;
class IMp7JrsAudioVisualRegionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionType_CollectionType > Mp7JrsAudioVisualRegionType_CollectionPtr;

#define TypeOfAudioVisualRegionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualRegionType_LocalType")))
#define CreateAudioVisualRegionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualRegionType_LocalType))
class Mp7JrsAudioVisualRegionType_LocalType;
class IMp7JrsAudioVisualRegionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualRegionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualRegionType_LocalType > Mp7JrsAudioVisualRegionType_LocalPtr;

#define TypeOfAudioVisualSegmentMediaSourceDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentMediaSourceDecompositionType")))
#define CreateAudioVisualSegmentMediaSourceDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentMediaSourceDecompositionType))
class Mp7JrsAudioVisualSegmentMediaSourceDecompositionType;
class IMp7JrsAudioVisualSegmentMediaSourceDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentMediaSourceDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentMediaSourceDecompositionType > Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr;

#define TypeOfAudioVisualSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentMediaSourceDecompositionType_CollectionType")))
#define CreateAudioVisualSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentMediaSourceDecompositionType_CollectionType))
class Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionType;
class IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionType > Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionPtr;

#define TypeOfAudioVisualSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentMediaSourceDecompositionType_LocalType")))
#define CreateAudioVisualSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentMediaSourceDecompositionType_LocalType))
class Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType;
class IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType > Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalPtr;

#define TypeOfAudioVisualSegmentSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentSpatialDecompositionType")))
#define CreateAudioVisualSegmentSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentSpatialDecompositionType))
class Mp7JrsAudioVisualSegmentSpatialDecompositionType;
class IMp7JrsAudioVisualSegmentSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatialDecompositionType > Mp7JrsAudioVisualSegmentSpatialDecompositionPtr;

#define TypeOfAudioVisualSegmentSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentSpatialDecompositionType_CollectionType")))
#define CreateAudioVisualSegmentSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentSpatialDecompositionType_CollectionType))
class Mp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionType;
class IMp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionType > Mp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionPtr;

#define TypeOfAudioVisualSegmentSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentSpatialDecompositionType_LocalType")))
#define CreateAudioVisualSegmentSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentSpatialDecompositionType_LocalType))
class Mp7JrsAudioVisualSegmentSpatialDecompositionType_LocalType;
class IMp7JrsAudioVisualSegmentSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatialDecompositionType_LocalType > Mp7JrsAudioVisualSegmentSpatialDecompositionType_LocalPtr;

#define TypeOfAudioVisualSegmentSpatioTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentSpatioTemporalDecompositionType")))
#define CreateAudioVisualSegmentSpatioTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentSpatioTemporalDecompositionType))
class Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType;
class IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType > Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr;

#define TypeOfAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentSpatioTemporalDecompositionType_CollectionType")))
#define CreateAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType))
class Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType;
class IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType > Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionPtr;

#define TypeOfAudioVisualSegmentSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentSpatioTemporalDecompositionType_LocalType")))
#define CreateAudioVisualSegmentSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentSpatioTemporalDecompositionType_LocalType))
class Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalType;
class IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalType > Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalPtr;

#define TypeOfAudioVisualSegmentTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentTemporalDecompositionType")))
#define CreateAudioVisualSegmentTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentTemporalDecompositionType))
class Mp7JrsAudioVisualSegmentTemporalDecompositionType;
class IMp7JrsAudioVisualSegmentTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentTemporalDecompositionType > Mp7JrsAudioVisualSegmentTemporalDecompositionPtr;

#define TypeOfAudioVisualSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentTemporalDecompositionType_CollectionType")))
#define CreateAudioVisualSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentTemporalDecompositionType_CollectionType))
class Mp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionType;
class IMp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionType > Mp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionPtr;

#define TypeOfAudioVisualSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentTemporalDecompositionType_LocalType")))
#define CreateAudioVisualSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentTemporalDecompositionType_LocalType))
class Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType;
class IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType > Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalPtr;

#define TypeOfAudioVisualSegmentType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentType")))
#define CreateAudioVisualSegmentType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentType))
class Mp7JrsAudioVisualSegmentType;
class IMp7JrsAudioVisualSegmentType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentType > Mp7JrsAudioVisualSegmentPtr;

#define TypeOfAudioVisualSegmentType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentType_CollectionType")))
#define CreateAudioVisualSegmentType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentType_CollectionType))
class Mp7JrsAudioVisualSegmentType_CollectionType;
class IMp7JrsAudioVisualSegmentType_CollectionType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentType_CollectionType > Mp7JrsAudioVisualSegmentType_CollectionPtr;

#define TypeOfAudioVisualSegmentType_LocalType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualSegmentType_LocalType")))
#define CreateAudioVisualSegmentType_LocalType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualSegmentType_LocalType))
class Mp7JrsAudioVisualSegmentType_LocalType;
class IMp7JrsAudioVisualSegmentType_LocalType;
/** Smart pointer to instance of IMp7JrsAudioVisualSegmentType_LocalType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentType_LocalType > Mp7JrsAudioVisualSegmentType_LocalPtr;

#define TypeOfAudioVisualType (Mp7JrsFactory::GetTypeIndex(X("AudioVisualType")))
#define CreateAudioVisualType (Mp7JrsFactory::CreateObject(TypeOfAudioVisualType))
class Mp7JrsAudioVisualType;
class IMp7JrsAudioVisualType;
/** Smart pointer to instance of IMp7JrsAudioVisualType */
typedef Mp7JrsPtr< IMp7JrsAudioVisualType > Mp7JrsAudioVisualPtr;

#define TypeOfAudioWaveformType (Mp7JrsFactory::GetTypeIndex(X("AudioWaveformType")))
#define CreateAudioWaveformType (Mp7JrsFactory::CreateObject(TypeOfAudioWaveformType))
class Mp7JrsAudioWaveformType;
class IMp7JrsAudioWaveformType;
/** Smart pointer to instance of IMp7JrsAudioWaveformType */
typedef Mp7JrsPtr< IMp7JrsAudioWaveformType > Mp7JrsAudioWaveformPtr;

#define TypeOfauxiliaryLanguageType (Mp7JrsFactory::GetTypeIndex(X("auxiliaryLanguageType")))
#define CreateauxiliaryLanguageType (Mp7JrsFactory::CreateObject(TypeOfauxiliaryLanguageType))
class Mp7JrsauxiliaryLanguageType;
class IMp7JrsauxiliaryLanguageType;
/** Smart pointer to instance of IMp7JrsauxiliaryLanguageType */
typedef Mp7JrsPtr< IMp7JrsauxiliaryLanguageType > Mp7JrsauxiliaryLanguagePtr;

#define TypeOfauxiliaryLanguageType_LocalType (Mp7JrsFactory::GetTypeIndex(X("auxiliaryLanguageType_LocalType")))
#define CreateauxiliaryLanguageType_LocalType (Mp7JrsFactory::CreateObject(TypeOfauxiliaryLanguageType_LocalType))
class Mp7JrsauxiliaryLanguageType_LocalType;
class IMp7JrsauxiliaryLanguageType_LocalType;

#define TypeOfauxiliaryLanguageType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("auxiliaryLanguageType_LocalType0")))
#define CreateauxiliaryLanguageType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfauxiliaryLanguageType_LocalType0))
class Mp7JrsauxiliaryLanguageType_LocalType0;
class IMp7JrsauxiliaryLanguageType_LocalType0;
/** Smart pointer to instance of IMp7JrsauxiliaryLanguageType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsauxiliaryLanguageType_LocalType0 > Mp7JrsauxiliaryLanguageType_Local0Ptr;

#define TypeOfauxiliaryLanguageType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("auxiliaryLanguageType_LocalType1")))
#define CreateauxiliaryLanguageType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfauxiliaryLanguageType_LocalType1))
class Mp7JrsauxiliaryLanguageType_LocalType1;
class IMp7JrsauxiliaryLanguageType_LocalType1;
/** Smart pointer to instance of IMp7JrsauxiliaryLanguageType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsauxiliaryLanguageType_LocalType1 > Mp7JrsauxiliaryLanguageType_Local1Ptr;

#define TypeOfAvailabilityType (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType")))
#define CreateAvailabilityType (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType))
class Mp7JrsAvailabilityType;
class IMp7JrsAvailabilityType;
/** Smart pointer to instance of IMp7JrsAvailabilityType */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType > Mp7JrsAvailabilityPtr;

#define TypeOfAvailabilityType_AvailabilityPeriod_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_CollectionType")))
#define CreateAvailabilityType_AvailabilityPeriod_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_CollectionType))
class Mp7JrsAvailabilityType_AvailabilityPeriod_CollectionType;
class IMp7JrsAvailabilityType_AvailabilityPeriod_CollectionType;
/** Smart pointer to instance of IMp7JrsAvailabilityType_AvailabilityPeriod_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_CollectionType > Mp7JrsAvailabilityType_AvailabilityPeriod_CollectionPtr;

#define TypeOfAvailabilityType_AvailabilityPeriod_LocalType (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_LocalType")))
#define CreateAvailabilityType_AvailabilityPeriod_LocalType (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_LocalType))
class Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType;
class IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType;
/** Smart pointer to instance of IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType > Mp7JrsAvailabilityType_AvailabilityPeriod_LocalPtr;

#define TypeOfAvailabilityType_AvailabilityPeriod_type_CollectionType (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_type_CollectionType")))
#define CreateAvailabilityType_AvailabilityPeriod_type_CollectionType (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_type_CollectionType))
class Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType;
class IMp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType;
/** Smart pointer to instance of IMp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType > Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr;

#define TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_type_LocalType")))
#define CreateAvailabilityType_AvailabilityPeriod_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType))
class Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType;
class IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType;

#define TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_type_LocalType0")))
#define CreateAvailabilityType_AvailabilityPeriod_type_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType0))
class Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType0;
class IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType0;
/** Smart pointer to instance of IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType0 > Mp7JrsAvailabilityType_AvailabilityPeriod_type_Local0Ptr;

#define TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_type_LocalType1")))
#define CreateAvailabilityType_AvailabilityPeriod_type_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType1))
class Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType1;
class IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType1;
/** Smart pointer to instance of IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType1 > Mp7JrsAvailabilityType_AvailabilityPeriod_type_Local1Ptr;

#define TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("AvailabilityType_AvailabilityPeriod_type_LocalType2")))
#define CreateAvailabilityType_AvailabilityPeriod_type_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfAvailabilityType_AvailabilityPeriod_type_LocalType2))
class Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType2;
class IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType2;
/** Smart pointer to instance of IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType2 > Mp7JrsAvailabilityType_AvailabilityPeriod_type_Local2Ptr;

#define TypeOfbasicDurationType (Mp7JrsFactory::GetTypeIndex(X("basicDurationType")))
#define CreatebasicDurationType (Mp7JrsFactory::CreateObject(TypeOfbasicDurationType))
class Mp7JrsbasicDurationType;
class IMp7JrsbasicDurationType;
/** Smart pointer to instance of IMp7JrsbasicDurationType */
typedef Mp7JrsPtr< IMp7JrsbasicDurationType > Mp7JrsbasicDurationPtr;

#define TypeOfbasicTimePointType (Mp7JrsFactory::GetTypeIndex(X("basicTimePointType")))
#define CreatebasicTimePointType (Mp7JrsFactory::CreateObject(TypeOfbasicTimePointType))
class Mp7JrsbasicTimePointType;
class IMp7JrsbasicTimePointType;
/** Smart pointer to instance of IMp7JrsbasicTimePointType */
typedef Mp7JrsPtr< IMp7JrsbasicTimePointType > Mp7JrsbasicTimePointPtr;

#define TypeOfbeatType (Mp7JrsFactory::GetTypeIndex(X("beatType")))
#define CreatebeatType (Mp7JrsFactory::CreateObject(TypeOfbeatType))
class Mp7JrsbeatType;
class IMp7JrsbeatType;
/** Smart pointer to instance of IMp7JrsbeatType */
typedef Mp7JrsPtr< IMp7JrsbeatType > Mp7JrsbeatPtr;

#define TypeOfBinomialDistributionType (Mp7JrsFactory::GetTypeIndex(X("BinomialDistributionType")))
#define CreateBinomialDistributionType (Mp7JrsFactory::CreateObject(TypeOfBinomialDistributionType))
class Mp7JrsBinomialDistributionType;
class IMp7JrsBinomialDistributionType;
/** Smart pointer to instance of IMp7JrsBinomialDistributionType */
typedef Mp7JrsPtr< IMp7JrsBinomialDistributionType > Mp7JrsBinomialDistributionPtr;

#define TypeOfBoxListType (Mp7JrsFactory::GetTypeIndex(X("BoxListType")))
#define CreateBoxListType (Mp7JrsFactory::CreateObject(TypeOfBoxListType))
class Mp7JrsBoxListType;
class IMp7JrsBoxListType;
/** Smart pointer to instance of IMp7JrsBoxListType */
typedef Mp7JrsPtr< IMp7JrsBoxListType > Mp7JrsBoxListPtr;

#define TypeOfBrowsingPreferencesType (Mp7JrsFactory::GetTypeIndex(X("BrowsingPreferencesType")))
#define CreateBrowsingPreferencesType (Mp7JrsFactory::CreateObject(TypeOfBrowsingPreferencesType))
class Mp7JrsBrowsingPreferencesType;
class IMp7JrsBrowsingPreferencesType;
/** Smart pointer to instance of IMp7JrsBrowsingPreferencesType */
typedef Mp7JrsPtr< IMp7JrsBrowsingPreferencesType > Mp7JrsBrowsingPreferencesPtr;

#define TypeOfBrowsingPreferencesType_PreferenceCondition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("BrowsingPreferencesType_PreferenceCondition_CollectionType")))
#define CreateBrowsingPreferencesType_PreferenceCondition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfBrowsingPreferencesType_PreferenceCondition_CollectionType))
class Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionType;
class IMp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionType;
/** Smart pointer to instance of IMp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionType > Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr;

#define TypeOfBrowsingPreferencesType_PreferenceCondition_LocalType (Mp7JrsFactory::GetTypeIndex(X("BrowsingPreferencesType_PreferenceCondition_LocalType")))
#define CreateBrowsingPreferencesType_PreferenceCondition_LocalType (Mp7JrsFactory::CreateObject(TypeOfBrowsingPreferencesType_PreferenceCondition_LocalType))
class Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType;
class IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType;
/** Smart pointer to instance of IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType */
typedef Mp7JrsPtr< IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType > Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr;

#define TypeOfBrowsingPreferencesType_SummaryPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("BrowsingPreferencesType_SummaryPreferences_CollectionType")))
#define CreateBrowsingPreferencesType_SummaryPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfBrowsingPreferencesType_SummaryPreferences_CollectionType))
class Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionType;
class IMp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionType > Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr;

#define TypeOfCameraMotionSegmentType (Mp7JrsFactory::GetTypeIndex(X("CameraMotionSegmentType")))
#define CreateCameraMotionSegmentType (Mp7JrsFactory::CreateObject(TypeOfCameraMotionSegmentType))
class Mp7JrsCameraMotionSegmentType;
class IMp7JrsCameraMotionSegmentType;
/** Smart pointer to instance of IMp7JrsCameraMotionSegmentType */
typedef Mp7JrsPtr< IMp7JrsCameraMotionSegmentType > Mp7JrsCameraMotionSegmentPtr;

#define TypeOfCameraMotionType (Mp7JrsFactory::GetTypeIndex(X("CameraMotionType")))
#define CreateCameraMotionType (Mp7JrsFactory::CreateObject(TypeOfCameraMotionType))
class Mp7JrsCameraMotionType;
class IMp7JrsCameraMotionType;
/** Smart pointer to instance of IMp7JrsCameraMotionType */
typedef Mp7JrsPtr< IMp7JrsCameraMotionType > Mp7JrsCameraMotionPtr;

#define TypeOfCameraMotionType_Segment_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CameraMotionType_Segment_CollectionType")))
#define CreateCameraMotionType_Segment_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCameraMotionType_Segment_CollectionType))
class Mp7JrsCameraMotionType_Segment_CollectionType;
class IMp7JrsCameraMotionType_Segment_CollectionType;
/** Smart pointer to instance of IMp7JrsCameraMotionType_Segment_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCameraMotionType_Segment_CollectionType > Mp7JrsCameraMotionType_Segment_CollectionPtr;

#define TypeOfcharacterSetCode (Mp7JrsFactory::GetTypeIndex(X("characterSetCode")))
#define CreatecharacterSetCode (Mp7JrsFactory::CreateObject(TypeOfcharacterSetCode))
class Mp7JrscharacterSetCode;
class IMp7JrscharacterSetCode;
/** Smart pointer to instance of IMp7JrscharacterSetCode */
typedef Mp7JrsPtr< IMp7JrscharacterSetCode > Mp7JrscharacterSetCodePtr;

#define TypeOfClassificationModelType (Mp7JrsFactory::GetTypeIndex(X("ClassificationModelType")))
#define CreateClassificationModelType (Mp7JrsFactory::CreateObject(TypeOfClassificationModelType))
class Mp7JrsClassificationModelType;
class IMp7JrsClassificationModelType;
/** Smart pointer to instance of IMp7JrsClassificationModelType */
typedef Mp7JrsPtr< IMp7JrsClassificationModelType > Mp7JrsClassificationModelPtr;

#define TypeOfClassificationPreferencesType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType")))
#define CreateClassificationPreferencesType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType))
class Mp7JrsClassificationPreferencesType;
class IMp7JrsClassificationPreferencesType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType > Mp7JrsClassificationPreferencesPtr;

#define TypeOfClassificationPreferencesType_CaptionLanguage_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_CaptionLanguage_CollectionType")))
#define CreateClassificationPreferencesType_CaptionLanguage_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_CaptionLanguage_CollectionType))
class Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType;
class IMp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType > Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionPtr;

#define TypeOfClassificationPreferencesType_CaptionLanguage_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_CaptionLanguage_LocalType")))
#define CreateClassificationPreferencesType_CaptionLanguage_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_CaptionLanguage_LocalType))
class Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType;
class IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_CaptionLanguage_LocalType > Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalPtr;

#define TypeOfClassificationPreferencesType_Country_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Country_CollectionType")))
#define CreateClassificationPreferencesType_Country_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Country_CollectionType))
class Mp7JrsClassificationPreferencesType_Country_CollectionType;
class IMp7JrsClassificationPreferencesType_Country_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Country_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Country_CollectionType > Mp7JrsClassificationPreferencesType_Country_CollectionPtr;

#define TypeOfClassificationPreferencesType_Country_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Country_LocalType")))
#define CreateClassificationPreferencesType_Country_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Country_LocalType))
class Mp7JrsClassificationPreferencesType_Country_LocalType;
class IMp7JrsClassificationPreferencesType_Country_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Country_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Country_LocalType > Mp7JrsClassificationPreferencesType_Country_LocalPtr;

#define TypeOfClassificationPreferencesType_DatePeriod_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_DatePeriod_CollectionType")))
#define CreateClassificationPreferencesType_DatePeriod_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_DatePeriod_CollectionType))
class Mp7JrsClassificationPreferencesType_DatePeriod_CollectionType;
class IMp7JrsClassificationPreferencesType_DatePeriod_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_DatePeriod_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_DatePeriod_CollectionType > Mp7JrsClassificationPreferencesType_DatePeriod_CollectionPtr;

#define TypeOfClassificationPreferencesType_DatePeriod_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_DatePeriod_LocalType")))
#define CreateClassificationPreferencesType_DatePeriod_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_DatePeriod_LocalType))
class Mp7JrsClassificationPreferencesType_DatePeriod_LocalType;
class IMp7JrsClassificationPreferencesType_DatePeriod_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_DatePeriod_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_DatePeriod_LocalType > Mp7JrsClassificationPreferencesType_DatePeriod_LocalPtr;

#define TypeOfClassificationPreferencesType_Form_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Form_CollectionType")))
#define CreateClassificationPreferencesType_Form_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Form_CollectionType))
class Mp7JrsClassificationPreferencesType_Form_CollectionType;
class IMp7JrsClassificationPreferencesType_Form_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Form_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Form_CollectionType > Mp7JrsClassificationPreferencesType_Form_CollectionPtr;

#define TypeOfClassificationPreferencesType_Form_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Form_LocalType")))
#define CreateClassificationPreferencesType_Form_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Form_LocalType))
class Mp7JrsClassificationPreferencesType_Form_LocalType;
class IMp7JrsClassificationPreferencesType_Form_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Form_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Form_LocalType > Mp7JrsClassificationPreferencesType_Form_LocalPtr;

#define TypeOfClassificationPreferencesType_Genre_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Genre_CollectionType")))
#define CreateClassificationPreferencesType_Genre_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Genre_CollectionType))
class Mp7JrsClassificationPreferencesType_Genre_CollectionType;
class IMp7JrsClassificationPreferencesType_Genre_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Genre_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Genre_CollectionType > Mp7JrsClassificationPreferencesType_Genre_CollectionPtr;

#define TypeOfClassificationPreferencesType_Genre_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Genre_LocalType")))
#define CreateClassificationPreferencesType_Genre_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Genre_LocalType))
class Mp7JrsClassificationPreferencesType_Genre_LocalType;
class IMp7JrsClassificationPreferencesType_Genre_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Genre_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Genre_LocalType > Mp7JrsClassificationPreferencesType_Genre_LocalPtr;

#define TypeOfClassificationPreferencesType_Language_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Language_CollectionType")))
#define CreateClassificationPreferencesType_Language_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Language_CollectionType))
class Mp7JrsClassificationPreferencesType_Language_CollectionType;
class IMp7JrsClassificationPreferencesType_Language_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Language_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Language_CollectionType > Mp7JrsClassificationPreferencesType_Language_CollectionPtr;

#define TypeOfClassificationPreferencesType_Language_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Language_LocalType")))
#define CreateClassificationPreferencesType_Language_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Language_LocalType))
class Mp7JrsClassificationPreferencesType_Language_LocalType;
class IMp7JrsClassificationPreferencesType_Language_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Language_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Language_LocalType > Mp7JrsClassificationPreferencesType_Language_LocalPtr;

#define TypeOfClassificationPreferencesType_LanguageFormat_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_LanguageFormat_CollectionType")))
#define CreateClassificationPreferencesType_LanguageFormat_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_LanguageFormat_CollectionType))
class Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionType;
class IMp7JrsClassificationPreferencesType_LanguageFormat_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_LanguageFormat_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_LanguageFormat_CollectionType > Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionPtr;

#define TypeOfClassificationPreferencesType_LanguageFormat_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_LanguageFormat_LocalType")))
#define CreateClassificationPreferencesType_LanguageFormat_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_LanguageFormat_LocalType))
class Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType;
class IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_LanguageFormat_LocalType > Mp7JrsClassificationPreferencesType_LanguageFormat_LocalPtr;

#define TypeOfClassificationPreferencesType_ParentalGuidance_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_ParentalGuidance_CollectionType")))
#define CreateClassificationPreferencesType_ParentalGuidance_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_ParentalGuidance_CollectionType))
class Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType;
class IMp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType > Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionPtr;

#define TypeOfClassificationPreferencesType_ParentalGuidance_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_ParentalGuidance_LocalType")))
#define CreateClassificationPreferencesType_ParentalGuidance_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_ParentalGuidance_LocalType))
class Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType;
class IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_ParentalGuidance_LocalType > Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalPtr;

#define TypeOfClassificationPreferencesType_Review_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Review_CollectionType")))
#define CreateClassificationPreferencesType_Review_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Review_CollectionType))
class Mp7JrsClassificationPreferencesType_Review_CollectionType;
class IMp7JrsClassificationPreferencesType_Review_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Review_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Review_CollectionType > Mp7JrsClassificationPreferencesType_Review_CollectionPtr;

#define TypeOfClassificationPreferencesType_Review_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Review_LocalType")))
#define CreateClassificationPreferencesType_Review_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Review_LocalType))
class Mp7JrsClassificationPreferencesType_Review_LocalType;
class IMp7JrsClassificationPreferencesType_Review_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Review_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Review_LocalType > Mp7JrsClassificationPreferencesType_Review_LocalPtr;

#define TypeOfClassificationPreferencesType_Subject_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Subject_CollectionType")))
#define CreateClassificationPreferencesType_Subject_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Subject_CollectionType))
class Mp7JrsClassificationPreferencesType_Subject_CollectionType;
class IMp7JrsClassificationPreferencesType_Subject_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Subject_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Subject_CollectionType > Mp7JrsClassificationPreferencesType_Subject_CollectionPtr;

#define TypeOfClassificationPreferencesType_Subject_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationPreferencesType_Subject_LocalType")))
#define CreateClassificationPreferencesType_Subject_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationPreferencesType_Subject_LocalType))
class Mp7JrsClassificationPreferencesType_Subject_LocalType;
class IMp7JrsClassificationPreferencesType_Subject_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationPreferencesType_Subject_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationPreferencesType_Subject_LocalType > Mp7JrsClassificationPreferencesType_Subject_LocalPtr;

#define TypeOfClassificationSchemeAliasType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeAliasType")))
#define CreateClassificationSchemeAliasType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeAliasType))
class Mp7JrsClassificationSchemeAliasType;
class IMp7JrsClassificationSchemeAliasType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeAliasType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeAliasType > Mp7JrsClassificationSchemeAliasPtr;

#define TypeOfClassificationSchemeBaseType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeBaseType")))
#define CreateClassificationSchemeBaseType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeBaseType))
class Mp7JrsClassificationSchemeBaseType;
class IMp7JrsClassificationSchemeBaseType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeBaseType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeBaseType > Mp7JrsClassificationSchemeBasePtr;

#define TypeOfClassificationSchemeBaseType_domain_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeBaseType_domain_CollectionType")))
#define CreateClassificationSchemeBaseType_domain_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeBaseType_domain_CollectionType))
class Mp7JrsClassificationSchemeBaseType_domain_CollectionType;
class IMp7JrsClassificationSchemeBaseType_domain_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeBaseType_domain_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeBaseType_domain_CollectionType > Mp7JrsClassificationSchemeBaseType_domain_CollectionPtr;

#define TypeOfClassificationSchemeBaseType_Import_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeBaseType_Import_CollectionType")))
#define CreateClassificationSchemeBaseType_Import_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeBaseType_Import_CollectionType))
class Mp7JrsClassificationSchemeBaseType_Import_CollectionType;
class IMp7JrsClassificationSchemeBaseType_Import_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeBaseType_Import_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeBaseType_Import_CollectionType > Mp7JrsClassificationSchemeBaseType_Import_CollectionPtr;

#define TypeOfClassificationSchemeDescriptionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeDescriptionType")))
#define CreateClassificationSchemeDescriptionType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeDescriptionType))
class Mp7JrsClassificationSchemeDescriptionType;
class IMp7JrsClassificationSchemeDescriptionType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeDescriptionType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeDescriptionType > Mp7JrsClassificationSchemeDescriptionPtr;

#define TypeOfClassificationSchemeDescriptionType_ClassificationScheme_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeDescriptionType_ClassificationScheme_CollectionType")))
#define CreateClassificationSchemeDescriptionType_ClassificationScheme_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeDescriptionType_ClassificationScheme_CollectionType))
class Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType;
class IMp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType > Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionPtr;

#define TypeOfClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType")))
#define CreateClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType))
class Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType;
class IMp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType > Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionPtr;

#define TypeOfClassificationSchemeType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeType")))
#define CreateClassificationSchemeType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeType))
class Mp7JrsClassificationSchemeType;
class IMp7JrsClassificationSchemeType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeType > Mp7JrsClassificationSchemePtr;

#define TypeOfClassificationSchemeType_Term_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationSchemeType_Term_CollectionType")))
#define CreateClassificationSchemeType_Term_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationSchemeType_Term_CollectionType))
class Mp7JrsClassificationSchemeType_Term_CollectionType;
class IMp7JrsClassificationSchemeType_Term_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationSchemeType_Term_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationSchemeType_Term_CollectionType > Mp7JrsClassificationSchemeType_Term_CollectionPtr;

#define TypeOfClassificationType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType")))
#define CreateClassificationType (Mp7JrsFactory::CreateObject(TypeOfClassificationType))
class Mp7JrsClassificationType;
class IMp7JrsClassificationType;
/** Smart pointer to instance of IMp7JrsClassificationType */
typedef Mp7JrsPtr< IMp7JrsClassificationType > Mp7JrsClassificationPtr;

#define TypeOfClassificationType_CaptionLanguage_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_CaptionLanguage_CollectionType")))
#define CreateClassificationType_CaptionLanguage_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_CaptionLanguage_CollectionType))
class Mp7JrsClassificationType_CaptionLanguage_CollectionType;
class IMp7JrsClassificationType_CaptionLanguage_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_CaptionLanguage_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_CaptionLanguage_CollectionType > Mp7JrsClassificationType_CaptionLanguage_CollectionPtr;

#define TypeOfClassificationType_CaptionLanguage_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_CaptionLanguage_LocalType")))
#define CreateClassificationType_CaptionLanguage_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_CaptionLanguage_LocalType))
class Mp7JrsClassificationType_CaptionLanguage_LocalType;
class IMp7JrsClassificationType_CaptionLanguage_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationType_CaptionLanguage_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_CaptionLanguage_LocalType > Mp7JrsClassificationType_CaptionLanguage_LocalPtr;

#define TypeOfClassificationType_Genre_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Genre_CollectionType")))
#define CreateClassificationType_Genre_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Genre_CollectionType))
class Mp7JrsClassificationType_Genre_CollectionType;
class IMp7JrsClassificationType_Genre_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_Genre_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Genre_CollectionType > Mp7JrsClassificationType_Genre_CollectionPtr;

#define TypeOfClassificationType_Genre_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Genre_LocalType")))
#define CreateClassificationType_Genre_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Genre_LocalType))
class Mp7JrsClassificationType_Genre_LocalType;
class IMp7JrsClassificationType_Genre_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationType_Genre_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Genre_LocalType > Mp7JrsClassificationType_Genre_LocalPtr;

#define TypeOfClassificationType_Genre_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Genre_type_LocalType")))
#define CreateClassificationType_Genre_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Genre_type_LocalType))
class Mp7JrsClassificationType_Genre_type_LocalType;
class IMp7JrsClassificationType_Genre_type_LocalType;

#define TypeOfClassificationType_Language_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Language_CollectionType")))
#define CreateClassificationType_Language_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Language_CollectionType))
class Mp7JrsClassificationType_Language_CollectionType;
class IMp7JrsClassificationType_Language_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_Language_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Language_CollectionType > Mp7JrsClassificationType_Language_CollectionPtr;

#define TypeOfClassificationType_MediaReview_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_MediaReview_CollectionType")))
#define CreateClassificationType_MediaReview_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_MediaReview_CollectionType))
class Mp7JrsClassificationType_MediaReview_CollectionType;
class IMp7JrsClassificationType_MediaReview_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_MediaReview_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_MediaReview_CollectionType > Mp7JrsClassificationType_MediaReview_CollectionPtr;

#define TypeOfClassificationType_ParentalGuidance_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_ParentalGuidance_CollectionType")))
#define CreateClassificationType_ParentalGuidance_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_ParentalGuidance_CollectionType))
class Mp7JrsClassificationType_ParentalGuidance_CollectionType;
class IMp7JrsClassificationType_ParentalGuidance_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_ParentalGuidance_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_ParentalGuidance_CollectionType > Mp7JrsClassificationType_ParentalGuidance_CollectionPtr;

#define TypeOfClassificationType_Purpose_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Purpose_CollectionType")))
#define CreateClassificationType_Purpose_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Purpose_CollectionType))
class Mp7JrsClassificationType_Purpose_CollectionType;
class IMp7JrsClassificationType_Purpose_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_Purpose_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Purpose_CollectionType > Mp7JrsClassificationType_Purpose_CollectionPtr;

#define TypeOfClassificationType_Release_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Release_LocalType")))
#define CreateClassificationType_Release_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Release_LocalType))
class Mp7JrsClassificationType_Release_LocalType;
class IMp7JrsClassificationType_Release_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationType_Release_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Release_LocalType > Mp7JrsClassificationType_Release_LocalPtr;

#define TypeOfClassificationType_Release_Region_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Release_Region_CollectionType")))
#define CreateClassificationType_Release_Region_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Release_Region_CollectionType))
class Mp7JrsClassificationType_Release_Region_CollectionType;
class IMp7JrsClassificationType_Release_Region_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_Release_Region_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Release_Region_CollectionType > Mp7JrsClassificationType_Release_Region_CollectionPtr;

#define TypeOfClassificationType_SignLanguage_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_SignLanguage_CollectionType")))
#define CreateClassificationType_SignLanguage_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_SignLanguage_CollectionType))
class Mp7JrsClassificationType_SignLanguage_CollectionType;
class IMp7JrsClassificationType_SignLanguage_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_SignLanguage_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_SignLanguage_CollectionType > Mp7JrsClassificationType_SignLanguage_CollectionPtr;

#define TypeOfClassificationType_SignLanguage_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_SignLanguage_LocalType")))
#define CreateClassificationType_SignLanguage_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_SignLanguage_LocalType))
class Mp7JrsClassificationType_SignLanguage_LocalType;
class IMp7JrsClassificationType_SignLanguage_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationType_SignLanguage_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_SignLanguage_LocalType > Mp7JrsClassificationType_SignLanguage_LocalPtr;

#define TypeOfClassificationType_Target_Age_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Target_Age_LocalType")))
#define CreateClassificationType_Target_Age_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Target_Age_LocalType))
class Mp7JrsClassificationType_Target_Age_LocalType;
class IMp7JrsClassificationType_Target_Age_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationType_Target_Age_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_Age_LocalType > Mp7JrsClassificationType_Target_Age_LocalPtr;

#define TypeOfClassificationType_Target_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Target_LocalType")))
#define CreateClassificationType_Target_LocalType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Target_LocalType))
class Mp7JrsClassificationType_Target_LocalType;
class IMp7JrsClassificationType_Target_LocalType;
/** Smart pointer to instance of IMp7JrsClassificationType_Target_LocalType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_LocalType > Mp7JrsClassificationType_Target_LocalPtr;

#define TypeOfClassificationType_Target_Market_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Target_Market_CollectionType")))
#define CreateClassificationType_Target_Market_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Target_Market_CollectionType))
class Mp7JrsClassificationType_Target_Market_CollectionType;
class IMp7JrsClassificationType_Target_Market_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_Target_Market_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_Market_CollectionType > Mp7JrsClassificationType_Target_Market_CollectionPtr;

#define TypeOfClassificationType_Target_Region_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClassificationType_Target_Region_CollectionType")))
#define CreateClassificationType_Target_Region_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClassificationType_Target_Region_CollectionType))
class Mp7JrsClassificationType_Target_Region_CollectionType;
class IMp7JrsClassificationType_Target_Region_CollectionType;
/** Smart pointer to instance of IMp7JrsClassificationType_Target_Region_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClassificationType_Target_Region_CollectionType > Mp7JrsClassificationType_Target_Region_CollectionPtr;

#define TypeOfClusterClassificationModelType (Mp7JrsFactory::GetTypeIndex(X("ClusterClassificationModelType")))
#define CreateClusterClassificationModelType (Mp7JrsFactory::CreateObject(TypeOfClusterClassificationModelType))
class Mp7JrsClusterClassificationModelType;
class IMp7JrsClusterClassificationModelType;
/** Smart pointer to instance of IMp7JrsClusterClassificationModelType */
typedef Mp7JrsPtr< IMp7JrsClusterClassificationModelType > Mp7JrsClusterClassificationModelPtr;

#define TypeOfClusterClassificationModelType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClusterClassificationModelType_CollectionType")))
#define CreateClusterClassificationModelType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClusterClassificationModelType_CollectionType))
class Mp7JrsClusterClassificationModelType_CollectionType;
class IMp7JrsClusterClassificationModelType_CollectionType;
/** Smart pointer to instance of IMp7JrsClusterClassificationModelType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClusterClassificationModelType_CollectionType > Mp7JrsClusterClassificationModelType_CollectionPtr;

#define TypeOfClusterClassificationModelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClusterClassificationModelType_LocalType")))
#define CreateClusterClassificationModelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfClusterClassificationModelType_LocalType))
class Mp7JrsClusterClassificationModelType_LocalType;
class IMp7JrsClusterClassificationModelType_LocalType;
/** Smart pointer to instance of IMp7JrsClusterClassificationModelType_LocalType */
typedef Mp7JrsPtr< IMp7JrsClusterClassificationModelType_LocalType > Mp7JrsClusterClassificationModelType_LocalPtr;

#define TypeOfClusterModelType (Mp7JrsFactory::GetTypeIndex(X("ClusterModelType")))
#define CreateClusterModelType (Mp7JrsFactory::CreateObject(TypeOfClusterModelType))
class Mp7JrsClusterModelType;
class IMp7JrsClusterModelType;
/** Smart pointer to instance of IMp7JrsClusterModelType */
typedef Mp7JrsPtr< IMp7JrsClusterModelType > Mp7JrsClusterModelPtr;

#define TypeOfClusterModelType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ClusterModelType_CollectionType")))
#define CreateClusterModelType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfClusterModelType_CollectionType))
class Mp7JrsClusterModelType_CollectionType;
class IMp7JrsClusterModelType_CollectionType;
/** Smart pointer to instance of IMp7JrsClusterModelType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsClusterModelType_CollectionType > Mp7JrsClusterModelType_CollectionPtr;

#define TypeOfClusterModelType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("ClusterModelType_CollectionType0")))
#define CreateClusterModelType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfClusterModelType_CollectionType0))
class Mp7JrsClusterModelType_CollectionType0;
class IMp7JrsClusterModelType_CollectionType0;
/** Smart pointer to instance of IMp7JrsClusterModelType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsClusterModelType_CollectionType0 > Mp7JrsClusterModelType_Collection0Ptr;

#define TypeOfClusterModelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ClusterModelType_LocalType")))
#define CreateClusterModelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfClusterModelType_LocalType))
class Mp7JrsClusterModelType_LocalType;
class IMp7JrsClusterModelType_LocalType;
/** Smart pointer to instance of IMp7JrsClusterModelType_LocalType */
typedef Mp7JrsPtr< IMp7JrsClusterModelType_LocalType > Mp7JrsClusterModelType_LocalPtr;

#define TypeOfClusterModelType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("ClusterModelType_LocalType0")))
#define CreateClusterModelType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfClusterModelType_LocalType0))
class Mp7JrsClusterModelType_LocalType0;
class IMp7JrsClusterModelType_LocalType0;
/** Smart pointer to instance of IMp7JrsClusterModelType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsClusterModelType_LocalType0 > Mp7JrsClusterModelType_Local0Ptr;

#define TypeOfCollectionModelType (Mp7JrsFactory::GetTypeIndex(X("CollectionModelType")))
#define CreateCollectionModelType (Mp7JrsFactory::CreateObject(TypeOfCollectionModelType))
class Mp7JrsCollectionModelType;
class IMp7JrsCollectionModelType;
/** Smart pointer to instance of IMp7JrsCollectionModelType */
typedef Mp7JrsPtr< IMp7JrsCollectionModelType > Mp7JrsCollectionModelPtr;

#define TypeOfCollectionModelType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CollectionModelType_CollectionType")))
#define CreateCollectionModelType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCollectionModelType_CollectionType))
class Mp7JrsCollectionModelType_CollectionType;
class IMp7JrsCollectionModelType_CollectionType;
/** Smart pointer to instance of IMp7JrsCollectionModelType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCollectionModelType_CollectionType > Mp7JrsCollectionModelType_CollectionPtr;

#define TypeOfCollectionModelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("CollectionModelType_LocalType")))
#define CreateCollectionModelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfCollectionModelType_LocalType))
class Mp7JrsCollectionModelType_LocalType;
class IMp7JrsCollectionModelType_LocalType;
/** Smart pointer to instance of IMp7JrsCollectionModelType_LocalType */
typedef Mp7JrsPtr< IMp7JrsCollectionModelType_LocalType > Mp7JrsCollectionModelType_LocalPtr;

#define TypeOfCollectionType (Mp7JrsFactory::GetTypeIndex(X("CollectionType")))
#define CreateCollectionType (Mp7JrsFactory::CreateObject(TypeOfCollectionType))
class Mp7JrsCollectionType;
class IMp7JrsCollectionType;
/** Smart pointer to instance of IMp7JrsCollectionType */
typedef Mp7JrsPtr< IMp7JrsCollectionType > Mp7JrsCollectionPtr;

#define TypeOfCollectionType_TextAnnotation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CollectionType_TextAnnotation_CollectionType")))
#define CreateCollectionType_TextAnnotation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCollectionType_TextAnnotation_CollectionType))
class Mp7JrsCollectionType_TextAnnotation_CollectionType;
class IMp7JrsCollectionType_TextAnnotation_CollectionType;
/** Smart pointer to instance of IMp7JrsCollectionType_TextAnnotation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCollectionType_TextAnnotation_CollectionType > Mp7JrsCollectionType_TextAnnotation_CollectionPtr;

#define TypeOfColorLayoutType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType")))
#define CreateColorLayoutType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType))
class Mp7JrsColorLayoutType;
class IMp7JrsColorLayoutType;
/** Smart pointer to instance of IMp7JrsColorLayoutType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType > Mp7JrsColorLayoutPtr;

#define TypeOfColorLayoutType_CbACCoeff14_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff14_CollectionType")))
#define CreateColorLayoutType_CbACCoeff14_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff14_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff14_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff14_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff14_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff14_CollectionType > Mp7JrsColorLayoutType_CbACCoeff14_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff14_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff14_LocalType")))
#define CreateColorLayoutType_CbACCoeff14_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff14_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff14_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff14_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff14_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff14_LocalType > Mp7JrsColorLayoutType_CbACCoeff14_LocalPtr;

#define TypeOfColorLayoutType_CbACCoeff2_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff2_CollectionType")))
#define CreateColorLayoutType_CbACCoeff2_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff2_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff2_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff2_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff2_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff2_CollectionType > Mp7JrsColorLayoutType_CbACCoeff2_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff2_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff2_LocalType")))
#define CreateColorLayoutType_CbACCoeff2_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff2_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff2_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff2_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff2_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff2_LocalType > Mp7JrsColorLayoutType_CbACCoeff2_LocalPtr;

#define TypeOfColorLayoutType_CbACCoeff20_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff20_CollectionType")))
#define CreateColorLayoutType_CbACCoeff20_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff20_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff20_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff20_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff20_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff20_CollectionType > Mp7JrsColorLayoutType_CbACCoeff20_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff20_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff20_LocalType")))
#define CreateColorLayoutType_CbACCoeff20_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff20_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff20_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff20_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff20_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff20_LocalType > Mp7JrsColorLayoutType_CbACCoeff20_LocalPtr;

#define TypeOfColorLayoutType_CbACCoeff27_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff27_CollectionType")))
#define CreateColorLayoutType_CbACCoeff27_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff27_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff27_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff27_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff27_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff27_CollectionType > Mp7JrsColorLayoutType_CbACCoeff27_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff27_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff27_LocalType")))
#define CreateColorLayoutType_CbACCoeff27_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff27_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff27_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff27_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff27_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff27_LocalType > Mp7JrsColorLayoutType_CbACCoeff27_LocalPtr;

#define TypeOfColorLayoutType_CbACCoeff5_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff5_CollectionType")))
#define CreateColorLayoutType_CbACCoeff5_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff5_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff5_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff5_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff5_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff5_CollectionType > Mp7JrsColorLayoutType_CbACCoeff5_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff5_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff5_LocalType")))
#define CreateColorLayoutType_CbACCoeff5_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff5_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff5_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff5_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff5_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff5_LocalType > Mp7JrsColorLayoutType_CbACCoeff5_LocalPtr;

#define TypeOfColorLayoutType_CbACCoeff63_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff63_CollectionType")))
#define CreateColorLayoutType_CbACCoeff63_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff63_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff63_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff63_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff63_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff63_CollectionType > Mp7JrsColorLayoutType_CbACCoeff63_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff63_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff63_LocalType")))
#define CreateColorLayoutType_CbACCoeff63_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff63_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff63_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff63_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff63_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff63_LocalType > Mp7JrsColorLayoutType_CbACCoeff63_LocalPtr;

#define TypeOfColorLayoutType_CbACCoeff9_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff9_CollectionType")))
#define CreateColorLayoutType_CbACCoeff9_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff9_CollectionType))
class Mp7JrsColorLayoutType_CbACCoeff9_CollectionType;
class IMp7JrsColorLayoutType_CbACCoeff9_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff9_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff9_CollectionType > Mp7JrsColorLayoutType_CbACCoeff9_CollectionPtr;

#define TypeOfColorLayoutType_CbACCoeff9_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CbACCoeff9_LocalType")))
#define CreateColorLayoutType_CbACCoeff9_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CbACCoeff9_LocalType))
class Mp7JrsColorLayoutType_CbACCoeff9_LocalType;
class IMp7JrsColorLayoutType_CbACCoeff9_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CbACCoeff9_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CbACCoeff9_LocalType > Mp7JrsColorLayoutType_CbACCoeff9_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff14_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff14_CollectionType")))
#define CreateColorLayoutType_CrACCoeff14_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff14_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff14_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff14_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff14_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff14_CollectionType > Mp7JrsColorLayoutType_CrACCoeff14_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff14_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff14_LocalType")))
#define CreateColorLayoutType_CrACCoeff14_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff14_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff14_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff14_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff14_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff14_LocalType > Mp7JrsColorLayoutType_CrACCoeff14_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff2_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff2_CollectionType")))
#define CreateColorLayoutType_CrACCoeff2_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff2_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff2_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff2_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff2_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff2_CollectionType > Mp7JrsColorLayoutType_CrACCoeff2_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff2_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff2_LocalType")))
#define CreateColorLayoutType_CrACCoeff2_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff2_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff2_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff2_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff2_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff2_LocalType > Mp7JrsColorLayoutType_CrACCoeff2_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff20_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff20_CollectionType")))
#define CreateColorLayoutType_CrACCoeff20_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff20_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff20_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff20_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff20_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff20_CollectionType > Mp7JrsColorLayoutType_CrACCoeff20_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff20_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff20_LocalType")))
#define CreateColorLayoutType_CrACCoeff20_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff20_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff20_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff20_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff20_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff20_LocalType > Mp7JrsColorLayoutType_CrACCoeff20_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff27_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff27_CollectionType")))
#define CreateColorLayoutType_CrACCoeff27_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff27_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff27_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff27_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff27_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff27_CollectionType > Mp7JrsColorLayoutType_CrACCoeff27_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff27_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff27_LocalType")))
#define CreateColorLayoutType_CrACCoeff27_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff27_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff27_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff27_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff27_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff27_LocalType > Mp7JrsColorLayoutType_CrACCoeff27_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff5_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff5_CollectionType")))
#define CreateColorLayoutType_CrACCoeff5_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff5_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff5_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff5_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff5_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff5_CollectionType > Mp7JrsColorLayoutType_CrACCoeff5_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff5_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff5_LocalType")))
#define CreateColorLayoutType_CrACCoeff5_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff5_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff5_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff5_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff5_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff5_LocalType > Mp7JrsColorLayoutType_CrACCoeff5_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff63_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff63_CollectionType")))
#define CreateColorLayoutType_CrACCoeff63_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff63_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff63_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff63_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff63_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff63_CollectionType > Mp7JrsColorLayoutType_CrACCoeff63_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff63_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff63_LocalType")))
#define CreateColorLayoutType_CrACCoeff63_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff63_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff63_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff63_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff63_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff63_LocalType > Mp7JrsColorLayoutType_CrACCoeff63_LocalPtr;

#define TypeOfColorLayoutType_CrACCoeff9_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff9_CollectionType")))
#define CreateColorLayoutType_CrACCoeff9_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff9_CollectionType))
class Mp7JrsColorLayoutType_CrACCoeff9_CollectionType;
class IMp7JrsColorLayoutType_CrACCoeff9_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff9_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff9_CollectionType > Mp7JrsColorLayoutType_CrACCoeff9_CollectionPtr;

#define TypeOfColorLayoutType_CrACCoeff9_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_CrACCoeff9_LocalType")))
#define CreateColorLayoutType_CrACCoeff9_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_CrACCoeff9_LocalType))
class Mp7JrsColorLayoutType_CrACCoeff9_LocalType;
class IMp7JrsColorLayoutType_CrACCoeff9_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_CrACCoeff9_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_CrACCoeff9_LocalType > Mp7JrsColorLayoutType_CrACCoeff9_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff14_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff14_CollectionType")))
#define CreateColorLayoutType_YACCoeff14_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff14_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff14_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff14_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff14_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff14_CollectionType > Mp7JrsColorLayoutType_YACCoeff14_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff14_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff14_LocalType")))
#define CreateColorLayoutType_YACCoeff14_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff14_LocalType))
class Mp7JrsColorLayoutType_YACCoeff14_LocalType;
class IMp7JrsColorLayoutType_YACCoeff14_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff14_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff14_LocalType > Mp7JrsColorLayoutType_YACCoeff14_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff2_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff2_CollectionType")))
#define CreateColorLayoutType_YACCoeff2_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff2_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff2_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff2_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff2_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff2_CollectionType > Mp7JrsColorLayoutType_YACCoeff2_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff2_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff2_LocalType")))
#define CreateColorLayoutType_YACCoeff2_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff2_LocalType))
class Mp7JrsColorLayoutType_YACCoeff2_LocalType;
class IMp7JrsColorLayoutType_YACCoeff2_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff2_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff2_LocalType > Mp7JrsColorLayoutType_YACCoeff2_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff20_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff20_CollectionType")))
#define CreateColorLayoutType_YACCoeff20_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff20_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff20_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff20_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff20_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff20_CollectionType > Mp7JrsColorLayoutType_YACCoeff20_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff20_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff20_LocalType")))
#define CreateColorLayoutType_YACCoeff20_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff20_LocalType))
class Mp7JrsColorLayoutType_YACCoeff20_LocalType;
class IMp7JrsColorLayoutType_YACCoeff20_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff20_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff20_LocalType > Mp7JrsColorLayoutType_YACCoeff20_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff27_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff27_CollectionType")))
#define CreateColorLayoutType_YACCoeff27_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff27_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff27_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff27_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff27_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff27_CollectionType > Mp7JrsColorLayoutType_YACCoeff27_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff27_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff27_LocalType")))
#define CreateColorLayoutType_YACCoeff27_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff27_LocalType))
class Mp7JrsColorLayoutType_YACCoeff27_LocalType;
class IMp7JrsColorLayoutType_YACCoeff27_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff27_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff27_LocalType > Mp7JrsColorLayoutType_YACCoeff27_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff5_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff5_CollectionType")))
#define CreateColorLayoutType_YACCoeff5_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff5_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff5_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff5_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff5_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff5_CollectionType > Mp7JrsColorLayoutType_YACCoeff5_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff5_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff5_LocalType")))
#define CreateColorLayoutType_YACCoeff5_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff5_LocalType))
class Mp7JrsColorLayoutType_YACCoeff5_LocalType;
class IMp7JrsColorLayoutType_YACCoeff5_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff5_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff5_LocalType > Mp7JrsColorLayoutType_YACCoeff5_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff63_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff63_CollectionType")))
#define CreateColorLayoutType_YACCoeff63_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff63_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff63_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff63_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff63_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff63_CollectionType > Mp7JrsColorLayoutType_YACCoeff63_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff63_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff63_LocalType")))
#define CreateColorLayoutType_YACCoeff63_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff63_LocalType))
class Mp7JrsColorLayoutType_YACCoeff63_LocalType;
class IMp7JrsColorLayoutType_YACCoeff63_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff63_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff63_LocalType > Mp7JrsColorLayoutType_YACCoeff63_LocalPtr;

#define TypeOfColorLayoutType_YACCoeff9_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff9_CollectionType")))
#define CreateColorLayoutType_YACCoeff9_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff9_CollectionType))
class Mp7JrsColorLayoutType_YACCoeff9_CollectionType;
class IMp7JrsColorLayoutType_YACCoeff9_CollectionType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff9_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff9_CollectionType > Mp7JrsColorLayoutType_YACCoeff9_CollectionPtr;

#define TypeOfColorLayoutType_YACCoeff9_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorLayoutType_YACCoeff9_LocalType")))
#define CreateColorLayoutType_YACCoeff9_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorLayoutType_YACCoeff9_LocalType))
class Mp7JrsColorLayoutType_YACCoeff9_LocalType;
class IMp7JrsColorLayoutType_YACCoeff9_LocalType;
/** Smart pointer to instance of IMp7JrsColorLayoutType_YACCoeff9_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorLayoutType_YACCoeff9_LocalType > Mp7JrsColorLayoutType_YACCoeff9_LocalPtr;

#define TypeOfColorQuantizationType (Mp7JrsFactory::GetTypeIndex(X("ColorQuantizationType")))
#define CreateColorQuantizationType (Mp7JrsFactory::CreateObject(TypeOfColorQuantizationType))
class Mp7JrsColorQuantizationType;
class IMp7JrsColorQuantizationType;
/** Smart pointer to instance of IMp7JrsColorQuantizationType */
typedef Mp7JrsPtr< IMp7JrsColorQuantizationType > Mp7JrsColorQuantizationPtr;

#define TypeOfColorQuantizationType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorQuantizationType_CollectionType")))
#define CreateColorQuantizationType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorQuantizationType_CollectionType))
class Mp7JrsColorQuantizationType_CollectionType;
class IMp7JrsColorQuantizationType_CollectionType;
/** Smart pointer to instance of IMp7JrsColorQuantizationType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorQuantizationType_CollectionType > Mp7JrsColorQuantizationType_CollectionPtr;

#define TypeOfColorQuantizationType_Component_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorQuantizationType_Component_LocalType")))
#define CreateColorQuantizationType_Component_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorQuantizationType_Component_LocalType))
class Mp7JrsColorQuantizationType_Component_LocalType;
class IMp7JrsColorQuantizationType_Component_LocalType;

#define TypeOfColorQuantizationType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorQuantizationType_LocalType")))
#define CreateColorQuantizationType_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorQuantizationType_LocalType))
class Mp7JrsColorQuantizationType_LocalType;
class IMp7JrsColorQuantizationType_LocalType;
/** Smart pointer to instance of IMp7JrsColorQuantizationType_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorQuantizationType_LocalType > Mp7JrsColorQuantizationType_LocalPtr;

#define TypeOfColorSamplingType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType")))
#define CreateColorSamplingType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType))
class Mp7JrsColorSamplingType;
class IMp7JrsColorSamplingType;
/** Smart pointer to instance of IMp7JrsColorSamplingType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType > Mp7JrsColorSamplingPtr;

#define TypeOfColorSamplingType_Field_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Field_CollectionType")))
#define CreateColorSamplingType_Field_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Field_CollectionType))
class Mp7JrsColorSamplingType_Field_CollectionType;
class IMp7JrsColorSamplingType_Field_CollectionType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Field_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_CollectionType > Mp7JrsColorSamplingType_Field_CollectionPtr;

#define TypeOfColorSamplingType_Field_Component_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Field_Component_CollectionType")))
#define CreateColorSamplingType_Field_Component_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Field_Component_CollectionType))
class Mp7JrsColorSamplingType_Field_Component_CollectionType;
class IMp7JrsColorSamplingType_Field_Component_CollectionType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Field_Component_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_CollectionType > Mp7JrsColorSamplingType_Field_Component_CollectionPtr;

#define TypeOfColorSamplingType_Field_Component_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Field_Component_LocalType")))
#define CreateColorSamplingType_Field_Component_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Field_Component_LocalType))
class Mp7JrsColorSamplingType_Field_Component_LocalType;
class IMp7JrsColorSamplingType_Field_Component_LocalType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Field_Component_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_LocalType > Mp7JrsColorSamplingType_Field_Component_LocalPtr;

#define TypeOfColorSamplingType_Field_Component_Offset_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Field_Component_Offset_LocalType")))
#define CreateColorSamplingType_Field_Component_Offset_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Field_Component_Offset_LocalType))
class Mp7JrsColorSamplingType_Field_Component_Offset_LocalType;
class IMp7JrsColorSamplingType_Field_Component_Offset_LocalType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Field_Component_Offset_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_Offset_LocalType > Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr;

#define TypeOfColorSamplingType_Field_Component_Period_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Field_Component_Period_LocalType")))
#define CreateColorSamplingType_Field_Component_Period_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Field_Component_Period_LocalType))
class Mp7JrsColorSamplingType_Field_Component_Period_LocalType;
class IMp7JrsColorSamplingType_Field_Component_Period_LocalType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Field_Component_Period_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_Component_Period_LocalType > Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr;

#define TypeOfColorSamplingType_Field_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Field_LocalType")))
#define CreateColorSamplingType_Field_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Field_LocalType))
class Mp7JrsColorSamplingType_Field_LocalType;
class IMp7JrsColorSamplingType_Field_LocalType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Field_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Field_LocalType > Mp7JrsColorSamplingType_Field_LocalPtr;

#define TypeOfColorSamplingType_Lattice_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSamplingType_Lattice_LocalType")))
#define CreateColorSamplingType_Lattice_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSamplingType_Lattice_LocalType))
class Mp7JrsColorSamplingType_Lattice_LocalType;
class IMp7JrsColorSamplingType_Lattice_LocalType;
/** Smart pointer to instance of IMp7JrsColorSamplingType_Lattice_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorSamplingType_Lattice_LocalType > Mp7JrsColorSamplingType_Lattice_LocalPtr;

#define TypeOfColorSpaceType (Mp7JrsFactory::GetTypeIndex(X("ColorSpaceType")))
#define CreateColorSpaceType (Mp7JrsFactory::CreateObject(TypeOfColorSpaceType))
class Mp7JrsColorSpaceType;
class IMp7JrsColorSpaceType;
/** Smart pointer to instance of IMp7JrsColorSpaceType */
typedef Mp7JrsPtr< IMp7JrsColorSpaceType > Mp7JrsColorSpacePtr;

#define TypeOfColorSpaceType_ColorTransMat_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorSpaceType_ColorTransMat_CollectionType")))
#define CreateColorSpaceType_ColorTransMat_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorSpaceType_ColorTransMat_CollectionType))
class Mp7JrsColorSpaceType_ColorTransMat_CollectionType;
class IMp7JrsColorSpaceType_ColorTransMat_CollectionType;
/** Smart pointer to instance of IMp7JrsColorSpaceType_ColorTransMat_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorSpaceType_ColorTransMat_CollectionType > Mp7JrsColorSpaceType_ColorTransMat_CollectionPtr;

#define TypeOfColorSpaceType_ColorTransMat_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSpaceType_ColorTransMat_LocalType")))
#define CreateColorSpaceType_ColorTransMat_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSpaceType_ColorTransMat_LocalType))
class Mp7JrsColorSpaceType_ColorTransMat_LocalType;
class IMp7JrsColorSpaceType_ColorTransMat_LocalType;
/** Smart pointer to instance of IMp7JrsColorSpaceType_ColorTransMat_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorSpaceType_ColorTransMat_LocalType > Mp7JrsColorSpaceType_ColorTransMat_LocalPtr;

#define TypeOfColorSpaceType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorSpaceType_type_LocalType")))
#define CreateColorSpaceType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorSpaceType_type_LocalType))
class Mp7JrsColorSpaceType_type_LocalType;
class IMp7JrsColorSpaceType_type_LocalType;

#define TypeOfColorStructureType (Mp7JrsFactory::GetTypeIndex(X("ColorStructureType")))
#define CreateColorStructureType (Mp7JrsFactory::CreateObject(TypeOfColorStructureType))
class Mp7JrsColorStructureType;
class IMp7JrsColorStructureType;
/** Smart pointer to instance of IMp7JrsColorStructureType */
typedef Mp7JrsPtr< IMp7JrsColorStructureType > Mp7JrsColorStructurePtr;

#define TypeOfColorStructureType_Values_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ColorStructureType_Values_CollectionType")))
#define CreateColorStructureType_Values_CollectionType (Mp7JrsFactory::CreateObject(TypeOfColorStructureType_Values_CollectionType))
class Mp7JrsColorStructureType_Values_CollectionType;
class IMp7JrsColorStructureType_Values_CollectionType;
/** Smart pointer to instance of IMp7JrsColorStructureType_Values_CollectionType */
typedef Mp7JrsPtr< IMp7JrsColorStructureType_Values_CollectionType > Mp7JrsColorStructureType_Values_CollectionPtr;

#define TypeOfColorStructureType_Values_LocalType (Mp7JrsFactory::GetTypeIndex(X("ColorStructureType_Values_LocalType")))
#define CreateColorStructureType_Values_LocalType (Mp7JrsFactory::CreateObject(TypeOfColorStructureType_Values_LocalType))
class Mp7JrsColorStructureType_Values_LocalType;
class IMp7JrsColorStructureType_Values_LocalType;
/** Smart pointer to instance of IMp7JrsColorStructureType_Values_LocalType */
typedef Mp7JrsPtr< IMp7JrsColorStructureType_Values_LocalType > Mp7JrsColorStructureType_Values_LocalPtr;

#define TypeOfCompleteDescriptionType (Mp7JrsFactory::GetTypeIndex(X("CompleteDescriptionType")))
#define CreateCompleteDescriptionType (Mp7JrsFactory::CreateObject(TypeOfCompleteDescriptionType))
class Mp7JrsCompleteDescriptionType;
class IMp7JrsCompleteDescriptionType;
/** Smart pointer to instance of IMp7JrsCompleteDescriptionType */
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType > Mp7JrsCompleteDescriptionPtr;

#define TypeOfCompleteDescriptionType_OrderingKey_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CompleteDescriptionType_OrderingKey_CollectionType")))
#define CreateCompleteDescriptionType_OrderingKey_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCompleteDescriptionType_OrderingKey_CollectionType))
class Mp7JrsCompleteDescriptionType_OrderingKey_CollectionType;
class IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType;
/** Smart pointer to instance of IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType_OrderingKey_CollectionType > Mp7JrsCompleteDescriptionType_OrderingKey_CollectionPtr;

#define TypeOfCompleteDescriptionType_Relationships_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CompleteDescriptionType_Relationships_CollectionType")))
#define CreateCompleteDescriptionType_Relationships_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCompleteDescriptionType_Relationships_CollectionType))
class Mp7JrsCompleteDescriptionType_Relationships_CollectionType;
class IMp7JrsCompleteDescriptionType_Relationships_CollectionType;
/** Smart pointer to instance of IMp7JrsCompleteDescriptionType_Relationships_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCompleteDescriptionType_Relationships_CollectionType > Mp7JrsCompleteDescriptionType_Relationships_CollectionPtr;

#define TypeOfCompositionShotEditingTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("CompositionShotEditingTemporalDecompositionType")))
#define CreateCompositionShotEditingTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfCompositionShotEditingTemporalDecompositionType))
class Mp7JrsCompositionShotEditingTemporalDecompositionType;
class IMp7JrsCompositionShotEditingTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsCompositionShotEditingTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsCompositionShotEditingTemporalDecompositionType > Mp7JrsCompositionShotEditingTemporalDecompositionPtr;

#define TypeOfCompositionShotEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CompositionShotEditingTemporalDecompositionType_CollectionType")))
#define CreateCompositionShotEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCompositionShotEditingTemporalDecompositionType_CollectionType))
class Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionType;
class IMp7JrsCompositionShotEditingTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsCompositionShotEditingTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCompositionShotEditingTemporalDecompositionType_CollectionType > Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr;

#define TypeOfCompositionShotEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("CompositionShotEditingTemporalDecompositionType_LocalType")))
#define CreateCompositionShotEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfCompositionShotEditingTemporalDecompositionType_LocalType))
class Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType;
class IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType > Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr;

#define TypeOfCompositionShotType (Mp7JrsFactory::GetTypeIndex(X("CompositionShotType")))
#define CreateCompositionShotType (Mp7JrsFactory::CreateObject(TypeOfCompositionShotType))
class Mp7JrsCompositionShotType;
class IMp7JrsCompositionShotType;
/** Smart pointer to instance of IMp7JrsCompositionShotType */
typedef Mp7JrsPtr< IMp7JrsCompositionShotType > Mp7JrsCompositionShotPtr;

#define TypeOfCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType")))
#define CreateCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType))
class Mp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType;
class IMp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType > Mp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionPtr;

#define TypeOfCompositionTransitionType (Mp7JrsFactory::GetTypeIndex(X("CompositionTransitionType")))
#define CreateCompositionTransitionType (Mp7JrsFactory::CreateObject(TypeOfCompositionTransitionType))
class Mp7JrsCompositionTransitionType;
class IMp7JrsCompositionTransitionType;
/** Smart pointer to instance of IMp7JrsCompositionTransitionType */
typedef Mp7JrsPtr< IMp7JrsCompositionTransitionType > Mp7JrsCompositionTransitionPtr;

#define TypeOfCompositionTransitionType_compositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("CompositionTransitionType_compositionType_LocalType")))
#define CreateCompositionTransitionType_compositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfCompositionTransitionType_compositionType_LocalType))
class Mp7JrsCompositionTransitionType_compositionType_LocalType;
class IMp7JrsCompositionTransitionType_compositionType_LocalType;

#define TypeOfCompositionTransitionType_compositionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("CompositionTransitionType_compositionType_LocalType0")))
#define CreateCompositionTransitionType_compositionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfCompositionTransitionType_compositionType_LocalType0))
class Mp7JrsCompositionTransitionType_compositionType_LocalType0;
class IMp7JrsCompositionTransitionType_compositionType_LocalType0;
/** Smart pointer to instance of IMp7JrsCompositionTransitionType_compositionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsCompositionTransitionType_compositionType_LocalType0 > Mp7JrsCompositionTransitionType_compositionType_Local0Ptr;

#define TypeOfCompositionTransitionType_compositionType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("CompositionTransitionType_compositionType_LocalType1")))
#define CreateCompositionTransitionType_compositionType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfCompositionTransitionType_compositionType_LocalType1))
class Mp7JrsCompositionTransitionType_compositionType_LocalType1;
class IMp7JrsCompositionTransitionType_compositionType_LocalType1;
/** Smart pointer to instance of IMp7JrsCompositionTransitionType_compositionType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsCompositionTransitionType_compositionType_LocalType1 > Mp7JrsCompositionTransitionType_compositionType_Local1Ptr;

#define TypeOfCompositionTransitionType_compositionType_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("CompositionTransitionType_compositionType_LocalType2")))
#define CreateCompositionTransitionType_compositionType_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfCompositionTransitionType_compositionType_LocalType2))
class Mp7JrsCompositionTransitionType_compositionType_LocalType2;
class IMp7JrsCompositionTransitionType_compositionType_LocalType2;
/** Smart pointer to instance of IMp7JrsCompositionTransitionType_compositionType_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsCompositionTransitionType_compositionType_LocalType2 > Mp7JrsCompositionTransitionType_compositionType_Local2Ptr;

#define TypeOfConceptCollectionType (Mp7JrsFactory::GetTypeIndex(X("ConceptCollectionType")))
#define CreateConceptCollectionType (Mp7JrsFactory::CreateObject(TypeOfConceptCollectionType))
class Mp7JrsConceptCollectionType;
class IMp7JrsConceptCollectionType;
/** Smart pointer to instance of IMp7JrsConceptCollectionType */
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType > Mp7JrsConceptCollectionPtr;

#define TypeOfConceptCollectionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ConceptCollectionType_CollectionType")))
#define CreateConceptCollectionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfConceptCollectionType_CollectionType))
class Mp7JrsConceptCollectionType_CollectionType;
class IMp7JrsConceptCollectionType_CollectionType;
/** Smart pointer to instance of IMp7JrsConceptCollectionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType_CollectionType > Mp7JrsConceptCollectionType_CollectionPtr;

#define TypeOfConceptCollectionType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("ConceptCollectionType_CollectionType0")))
#define CreateConceptCollectionType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfConceptCollectionType_CollectionType0))
class Mp7JrsConceptCollectionType_CollectionType0;
class IMp7JrsConceptCollectionType_CollectionType0;
/** Smart pointer to instance of IMp7JrsConceptCollectionType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType_CollectionType0 > Mp7JrsConceptCollectionType_Collection0Ptr;

#define TypeOfConceptCollectionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ConceptCollectionType_LocalType")))
#define CreateConceptCollectionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfConceptCollectionType_LocalType))
class Mp7JrsConceptCollectionType_LocalType;
class IMp7JrsConceptCollectionType_LocalType;
/** Smart pointer to instance of IMp7JrsConceptCollectionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType_LocalType > Mp7JrsConceptCollectionType_LocalPtr;

#define TypeOfConceptCollectionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("ConceptCollectionType_LocalType0")))
#define CreateConceptCollectionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfConceptCollectionType_LocalType0))
class Mp7JrsConceptCollectionType_LocalType0;
class IMp7JrsConceptCollectionType_LocalType0;
/** Smart pointer to instance of IMp7JrsConceptCollectionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType_LocalType0 > Mp7JrsConceptCollectionType_Local0Ptr;

#define TypeOfConceptType (Mp7JrsFactory::GetTypeIndex(X("ConceptType")))
#define CreateConceptType (Mp7JrsFactory::CreateObject(TypeOfConceptType))
class Mp7JrsConceptType;
class IMp7JrsConceptType;
/** Smart pointer to instance of IMp7JrsConceptType */
typedef Mp7JrsPtr< IMp7JrsConceptType > Mp7JrsConceptPtr;

#define TypeOfConfusionCountType (Mp7JrsFactory::GetTypeIndex(X("ConfusionCountType")))
#define CreateConfusionCountType (Mp7JrsFactory::CreateObject(TypeOfConfusionCountType))
class Mp7JrsConfusionCountType;
class IMp7JrsConfusionCountType;
/** Smart pointer to instance of IMp7JrsConfusionCountType */
typedef Mp7JrsPtr< IMp7JrsConfusionCountType > Mp7JrsConfusionCountPtr;

#define TypeOfContentAbstractionType (Mp7JrsFactory::GetTypeIndex(X("ContentAbstractionType")))
#define CreateContentAbstractionType (Mp7JrsFactory::CreateObject(TypeOfContentAbstractionType))
class Mp7JrsContentAbstractionType;
class IMp7JrsContentAbstractionType;
/** Smart pointer to instance of IMp7JrsContentAbstractionType */
typedef Mp7JrsPtr< IMp7JrsContentAbstractionType > Mp7JrsContentAbstractionPtr;

#define TypeOfContentCollectionType (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType")))
#define CreateContentCollectionType (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType))
class Mp7JrsContentCollectionType;
class IMp7JrsContentCollectionType;
/** Smart pointer to instance of IMp7JrsContentCollectionType */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType > Mp7JrsContentCollectionPtr;

#define TypeOfContentCollectionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType_CollectionType")))
#define CreateContentCollectionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType_CollectionType))
class Mp7JrsContentCollectionType_CollectionType;
class IMp7JrsContentCollectionType_CollectionType;
/** Smart pointer to instance of IMp7JrsContentCollectionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_CollectionType > Mp7JrsContentCollectionType_CollectionPtr;

#define TypeOfContentCollectionType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType_CollectionType0")))
#define CreateContentCollectionType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType_CollectionType0))
class Mp7JrsContentCollectionType_CollectionType0;
class IMp7JrsContentCollectionType_CollectionType0;
/** Smart pointer to instance of IMp7JrsContentCollectionType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_CollectionType0 > Mp7JrsContentCollectionType_Collection0Ptr;

#define TypeOfContentCollectionType_CollectionType1 (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType_CollectionType1")))
#define CreateContentCollectionType_CollectionType1 (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType_CollectionType1))
class Mp7JrsContentCollectionType_CollectionType1;
class IMp7JrsContentCollectionType_CollectionType1;
/** Smart pointer to instance of IMp7JrsContentCollectionType_CollectionType1 */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_CollectionType1 > Mp7JrsContentCollectionType_Collection1Ptr;

#define TypeOfContentCollectionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType_LocalType")))
#define CreateContentCollectionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType_LocalType))
class Mp7JrsContentCollectionType_LocalType;
class IMp7JrsContentCollectionType_LocalType;
/** Smart pointer to instance of IMp7JrsContentCollectionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_LocalType > Mp7JrsContentCollectionType_LocalPtr;

#define TypeOfContentCollectionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType_LocalType0")))
#define CreateContentCollectionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType_LocalType0))
class Mp7JrsContentCollectionType_LocalType0;
class IMp7JrsContentCollectionType_LocalType0;
/** Smart pointer to instance of IMp7JrsContentCollectionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_LocalType0 > Mp7JrsContentCollectionType_Local0Ptr;

#define TypeOfContentCollectionType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("ContentCollectionType_LocalType1")))
#define CreateContentCollectionType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfContentCollectionType_LocalType1))
class Mp7JrsContentCollectionType_LocalType1;
class IMp7JrsContentCollectionType_LocalType1;
/** Smart pointer to instance of IMp7JrsContentCollectionType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_LocalType1 > Mp7JrsContentCollectionType_Local1Ptr;

#define TypeOfContentDescriptionType (Mp7JrsFactory::GetTypeIndex(X("ContentDescriptionType")))
#define CreateContentDescriptionType (Mp7JrsFactory::CreateObject(TypeOfContentDescriptionType))
class Mp7JrsContentDescriptionType;
class IMp7JrsContentDescriptionType;
/** Smart pointer to instance of IMp7JrsContentDescriptionType */
typedef Mp7JrsPtr< IMp7JrsContentDescriptionType > Mp7JrsContentDescriptionPtr;

#define TypeOfContentDescriptionType_Affective_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ContentDescriptionType_Affective_CollectionType")))
#define CreateContentDescriptionType_Affective_CollectionType (Mp7JrsFactory::CreateObject(TypeOfContentDescriptionType_Affective_CollectionType))
class Mp7JrsContentDescriptionType_Affective_CollectionType;
class IMp7JrsContentDescriptionType_Affective_CollectionType;
/** Smart pointer to instance of IMp7JrsContentDescriptionType_Affective_CollectionType */
typedef Mp7JrsPtr< IMp7JrsContentDescriptionType_Affective_CollectionType > Mp7JrsContentDescriptionType_Affective_CollectionPtr;

#define TypeOfContentEntityType (Mp7JrsFactory::GetTypeIndex(X("ContentEntityType")))
#define CreateContentEntityType (Mp7JrsFactory::CreateObject(TypeOfContentEntityType))
class Mp7JrsContentEntityType;
class IMp7JrsContentEntityType;
/** Smart pointer to instance of IMp7JrsContentEntityType */
typedef Mp7JrsPtr< IMp7JrsContentEntityType > Mp7JrsContentEntityPtr;

#define TypeOfContentEntityType_MultimediaContent_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ContentEntityType_MultimediaContent_CollectionType")))
#define CreateContentEntityType_MultimediaContent_CollectionType (Mp7JrsFactory::CreateObject(TypeOfContentEntityType_MultimediaContent_CollectionType))
class Mp7JrsContentEntityType_MultimediaContent_CollectionType;
class IMp7JrsContentEntityType_MultimediaContent_CollectionType;
/** Smart pointer to instance of IMp7JrsContentEntityType_MultimediaContent_CollectionType */
typedef Mp7JrsPtr< IMp7JrsContentEntityType_MultimediaContent_CollectionType > Mp7JrsContentEntityType_MultimediaContent_CollectionPtr;

#define TypeOfContentManagementType (Mp7JrsFactory::GetTypeIndex(X("ContentManagementType")))
#define CreateContentManagementType (Mp7JrsFactory::CreateObject(TypeOfContentManagementType))
class Mp7JrsContentManagementType;
class IMp7JrsContentManagementType;
/** Smart pointer to instance of IMp7JrsContentManagementType */
typedef Mp7JrsPtr< IMp7JrsContentManagementType > Mp7JrsContentManagementPtr;

#define TypeOfContinuousDistributionType (Mp7JrsFactory::GetTypeIndex(X("ContinuousDistributionType")))
#define CreateContinuousDistributionType (Mp7JrsFactory::CreateObject(TypeOfContinuousDistributionType))
class Mp7JrsContinuousDistributionType;
class IMp7JrsContinuousDistributionType;
/** Smart pointer to instance of IMp7JrsContinuousDistributionType */
typedef Mp7JrsPtr< IMp7JrsContinuousDistributionType > Mp7JrsContinuousDistributionPtr;

#define TypeOfContinuousHiddenMarkovModelType (Mp7JrsFactory::GetTypeIndex(X("ContinuousHiddenMarkovModelType")))
#define CreateContinuousHiddenMarkovModelType (Mp7JrsFactory::CreateObject(TypeOfContinuousHiddenMarkovModelType))
class Mp7JrsContinuousHiddenMarkovModelType;
class IMp7JrsContinuousHiddenMarkovModelType;
/** Smart pointer to instance of IMp7JrsContinuousHiddenMarkovModelType */
typedef Mp7JrsPtr< IMp7JrsContinuousHiddenMarkovModelType > Mp7JrsContinuousHiddenMarkovModelPtr;

#define TypeOfContinuousHiddenMarkovModelType_DescriptorModel_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ContinuousHiddenMarkovModelType_DescriptorModel_CollectionType")))
#define CreateContinuousHiddenMarkovModelType_DescriptorModel_CollectionType (Mp7JrsFactory::CreateObject(TypeOfContinuousHiddenMarkovModelType_DescriptorModel_CollectionType))
class Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionType;
class IMp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionType;
/** Smart pointer to instance of IMp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionType */
typedef Mp7JrsPtr< IMp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionType > Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionPtr;

#define TypeOfContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType")))
#define CreateContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType (Mp7JrsFactory::CreateObject(TypeOfContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType))
class Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType;
class IMp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType;
/** Smart pointer to instance of IMp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType */
typedef Mp7JrsPtr< IMp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType > Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionPtr;

#define TypeOfContinuousUniformDistributionType (Mp7JrsFactory::GetTypeIndex(X("ContinuousUniformDistributionType")))
#define CreateContinuousUniformDistributionType (Mp7JrsFactory::CreateObject(TypeOfContinuousUniformDistributionType))
class Mp7JrsContinuousUniformDistributionType;
class IMp7JrsContinuousUniformDistributionType;
/** Smart pointer to instance of IMp7JrsContinuousUniformDistributionType */
typedef Mp7JrsPtr< IMp7JrsContinuousUniformDistributionType > Mp7JrsContinuousUniformDistributionPtr;

#define TypeOfContourShapeType (Mp7JrsFactory::GetTypeIndex(X("ContourShapeType")))
#define CreateContourShapeType (Mp7JrsFactory::CreateObject(TypeOfContourShapeType))
class Mp7JrsContourShapeType;
class IMp7JrsContourShapeType;
/** Smart pointer to instance of IMp7JrsContourShapeType */
typedef Mp7JrsPtr< IMp7JrsContourShapeType > Mp7JrsContourShapePtr;

#define TypeOfContourShapeType_Peak_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ContourShapeType_Peak_CollectionType")))
#define CreateContourShapeType_Peak_CollectionType (Mp7JrsFactory::CreateObject(TypeOfContourShapeType_Peak_CollectionType))
class Mp7JrsContourShapeType_Peak_CollectionType;
class IMp7JrsContourShapeType_Peak_CollectionType;
/** Smart pointer to instance of IMp7JrsContourShapeType_Peak_CollectionType */
typedef Mp7JrsPtr< IMp7JrsContourShapeType_Peak_CollectionType > Mp7JrsContourShapeType_Peak_CollectionPtr;

#define TypeOfContourShapeType_Peak_LocalType (Mp7JrsFactory::GetTypeIndex(X("ContourShapeType_Peak_LocalType")))
#define CreateContourShapeType_Peak_LocalType (Mp7JrsFactory::CreateObject(TypeOfContourShapeType_Peak_LocalType))
class Mp7JrsContourShapeType_Peak_LocalType;
class IMp7JrsContourShapeType_Peak_LocalType;
/** Smart pointer to instance of IMp7JrsContourShapeType_Peak_LocalType */
typedef Mp7JrsPtr< IMp7JrsContourShapeType_Peak_LocalType > Mp7JrsContourShapeType_Peak_LocalPtr;

#define TypeOfcontourType (Mp7JrsFactory::GetTypeIndex(X("contourType")))
#define CreatecontourType (Mp7JrsFactory::CreateObject(TypeOfcontourType))
class Mp7JrscontourType;
class IMp7JrscontourType;
/** Smart pointer to instance of IMp7JrscontourType */
typedef Mp7JrsPtr< IMp7JrscontourType > Mp7JrscontourPtr;

#define TypeOfcontourType_LocalType (Mp7JrsFactory::GetTypeIndex(X("contourType_LocalType")))
#define CreatecontourType_LocalType (Mp7JrsFactory::CreateObject(TypeOfcontourType_LocalType))
class Mp7JrscontourType_LocalType;
class IMp7JrscontourType_LocalType;
/** Smart pointer to instance of IMp7JrscontourType_LocalType */
typedef Mp7JrsPtr< IMp7JrscontourType_LocalType > Mp7JrscontourType_LocalPtr;

#define TypeOfControlledTermUseType (Mp7JrsFactory::GetTypeIndex(X("ControlledTermUseType")))
#define CreateControlledTermUseType (Mp7JrsFactory::CreateObject(TypeOfControlledTermUseType))
class Mp7JrsControlledTermUseType;
class IMp7JrsControlledTermUseType;
/** Smart pointer to instance of IMp7JrsControlledTermUseType */
typedef Mp7JrsPtr< IMp7JrsControlledTermUseType > Mp7JrsControlledTermUsePtr;

#define TypeOfcountryCode (Mp7JrsFactory::GetTypeIndex(X("countryCode")))
#define CreatecountryCode (Mp7JrsFactory::CreateObject(TypeOfcountryCode))
class Mp7JrscountryCode;
class IMp7JrscountryCode;
/** Smart pointer to instance of IMp7JrscountryCode */
typedef Mp7JrsPtr< IMp7JrscountryCode > Mp7JrscountryCodePtr;

#define TypeOfCreationDescriptionType (Mp7JrsFactory::GetTypeIndex(X("CreationDescriptionType")))
#define CreateCreationDescriptionType (Mp7JrsFactory::CreateObject(TypeOfCreationDescriptionType))
class Mp7JrsCreationDescriptionType;
class IMp7JrsCreationDescriptionType;
/** Smart pointer to instance of IMp7JrsCreationDescriptionType */
typedef Mp7JrsPtr< IMp7JrsCreationDescriptionType > Mp7JrsCreationDescriptionPtr;

#define TypeOfCreationDescriptionType_CreationInformation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationDescriptionType_CreationInformation_CollectionType")))
#define CreateCreationDescriptionType_CreationInformation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationDescriptionType_CreationInformation_CollectionType))
class Mp7JrsCreationDescriptionType_CreationInformation_CollectionType;
class IMp7JrsCreationDescriptionType_CreationInformation_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationDescriptionType_CreationInformation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationDescriptionType_CreationInformation_CollectionType > Mp7JrsCreationDescriptionType_CreationInformation_CollectionPtr;

#define TypeOfCreationInformationType (Mp7JrsFactory::GetTypeIndex(X("CreationInformationType")))
#define CreateCreationInformationType (Mp7JrsFactory::CreateObject(TypeOfCreationInformationType))
class Mp7JrsCreationInformationType;
class IMp7JrsCreationInformationType;
/** Smart pointer to instance of IMp7JrsCreationInformationType */
typedef Mp7JrsPtr< IMp7JrsCreationInformationType > Mp7JrsCreationInformationPtr;

#define TypeOfCreationInformationType_RelatedMaterial_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationInformationType_RelatedMaterial_CollectionType")))
#define CreateCreationInformationType_RelatedMaterial_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationInformationType_RelatedMaterial_CollectionType))
class Mp7JrsCreationInformationType_RelatedMaterial_CollectionType;
class IMp7JrsCreationInformationType_RelatedMaterial_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationInformationType_RelatedMaterial_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationInformationType_RelatedMaterial_CollectionType > Mp7JrsCreationInformationType_RelatedMaterial_CollectionPtr;

#define TypeOfCreationPreferencesType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType")))
#define CreateCreationPreferencesType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType))
class Mp7JrsCreationPreferencesType;
class IMp7JrsCreationPreferencesType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType > Mp7JrsCreationPreferencesPtr;

#define TypeOfCreationPreferencesType_Creator_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Creator_CollectionType")))
#define CreateCreationPreferencesType_Creator_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Creator_CollectionType))
class Mp7JrsCreationPreferencesType_Creator_CollectionType;
class IMp7JrsCreationPreferencesType_Creator_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Creator_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Creator_CollectionType > Mp7JrsCreationPreferencesType_Creator_CollectionPtr;

#define TypeOfCreationPreferencesType_Creator_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Creator_LocalType")))
#define CreateCreationPreferencesType_Creator_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Creator_LocalType))
class Mp7JrsCreationPreferencesType_Creator_LocalType;
class IMp7JrsCreationPreferencesType_Creator_LocalType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Creator_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Creator_LocalType > Mp7JrsCreationPreferencesType_Creator_LocalPtr;

#define TypeOfCreationPreferencesType_DatePeriod_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_DatePeriod_CollectionType")))
#define CreateCreationPreferencesType_DatePeriod_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_DatePeriod_CollectionType))
class Mp7JrsCreationPreferencesType_DatePeriod_CollectionType;
class IMp7JrsCreationPreferencesType_DatePeriod_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_DatePeriod_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_DatePeriod_CollectionType > Mp7JrsCreationPreferencesType_DatePeriod_CollectionPtr;

#define TypeOfCreationPreferencesType_DatePeriod_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_DatePeriod_LocalType")))
#define CreateCreationPreferencesType_DatePeriod_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_DatePeriod_LocalType))
class Mp7JrsCreationPreferencesType_DatePeriod_LocalType;
class IMp7JrsCreationPreferencesType_DatePeriod_LocalType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_DatePeriod_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_DatePeriod_LocalType > Mp7JrsCreationPreferencesType_DatePeriod_LocalPtr;

#define TypeOfCreationPreferencesType_Keyword_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Keyword_CollectionType")))
#define CreateCreationPreferencesType_Keyword_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Keyword_CollectionType))
class Mp7JrsCreationPreferencesType_Keyword_CollectionType;
class IMp7JrsCreationPreferencesType_Keyword_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Keyword_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Keyword_CollectionType > Mp7JrsCreationPreferencesType_Keyword_CollectionPtr;

#define TypeOfCreationPreferencesType_Keyword_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Keyword_LocalType")))
#define CreateCreationPreferencesType_Keyword_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Keyword_LocalType))
class Mp7JrsCreationPreferencesType_Keyword_LocalType;
class IMp7JrsCreationPreferencesType_Keyword_LocalType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Keyword_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Keyword_LocalType > Mp7JrsCreationPreferencesType_Keyword_LocalPtr;

#define TypeOfCreationPreferencesType_Location_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Location_CollectionType")))
#define CreateCreationPreferencesType_Location_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Location_CollectionType))
class Mp7JrsCreationPreferencesType_Location_CollectionType;
class IMp7JrsCreationPreferencesType_Location_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Location_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Location_CollectionType > Mp7JrsCreationPreferencesType_Location_CollectionPtr;

#define TypeOfCreationPreferencesType_Location_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Location_LocalType")))
#define CreateCreationPreferencesType_Location_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Location_LocalType))
class Mp7JrsCreationPreferencesType_Location_LocalType;
class IMp7JrsCreationPreferencesType_Location_LocalType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Location_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Location_LocalType > Mp7JrsCreationPreferencesType_Location_LocalPtr;

#define TypeOfCreationPreferencesType_Title_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Title_CollectionType")))
#define CreateCreationPreferencesType_Title_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Title_CollectionType))
class Mp7JrsCreationPreferencesType_Title_CollectionType;
class IMp7JrsCreationPreferencesType_Title_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Title_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Title_CollectionType > Mp7JrsCreationPreferencesType_Title_CollectionPtr;

#define TypeOfCreationPreferencesType_Title_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Title_LocalType")))
#define CreateCreationPreferencesType_Title_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Title_LocalType))
class Mp7JrsCreationPreferencesType_Title_LocalType;
class IMp7JrsCreationPreferencesType_Title_LocalType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Title_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Title_LocalType > Mp7JrsCreationPreferencesType_Title_LocalPtr;

#define TypeOfCreationPreferencesType_Tool_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Tool_CollectionType")))
#define CreateCreationPreferencesType_Tool_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Tool_CollectionType))
class Mp7JrsCreationPreferencesType_Tool_CollectionType;
class IMp7JrsCreationPreferencesType_Tool_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Tool_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Tool_CollectionType > Mp7JrsCreationPreferencesType_Tool_CollectionPtr;

#define TypeOfCreationPreferencesType_Tool_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationPreferencesType_Tool_LocalType")))
#define CreateCreationPreferencesType_Tool_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationPreferencesType_Tool_LocalType))
class Mp7JrsCreationPreferencesType_Tool_LocalType;
class IMp7JrsCreationPreferencesType_Tool_LocalType;
/** Smart pointer to instance of IMp7JrsCreationPreferencesType_Tool_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationPreferencesType_Tool_LocalType > Mp7JrsCreationPreferencesType_Tool_LocalPtr;

#define TypeOfCreationToolType (Mp7JrsFactory::GetTypeIndex(X("CreationToolType")))
#define CreateCreationToolType (Mp7JrsFactory::CreateObject(TypeOfCreationToolType))
class Mp7JrsCreationToolType;
class IMp7JrsCreationToolType;
/** Smart pointer to instance of IMp7JrsCreationToolType */
typedef Mp7JrsPtr< IMp7JrsCreationToolType > Mp7JrsCreationToolPtr;

#define TypeOfCreationToolType_Setting_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationToolType_Setting_CollectionType")))
#define CreateCreationToolType_Setting_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationToolType_Setting_CollectionType))
class Mp7JrsCreationToolType_Setting_CollectionType;
class IMp7JrsCreationToolType_Setting_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationToolType_Setting_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationToolType_Setting_CollectionType > Mp7JrsCreationToolType_Setting_CollectionPtr;

#define TypeOfCreationToolType_Setting_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationToolType_Setting_LocalType")))
#define CreateCreationToolType_Setting_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationToolType_Setting_LocalType))
class Mp7JrsCreationToolType_Setting_LocalType;
class IMp7JrsCreationToolType_Setting_LocalType;
/** Smart pointer to instance of IMp7JrsCreationToolType_Setting_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationToolType_Setting_LocalType > Mp7JrsCreationToolType_Setting_LocalPtr;

#define TypeOfCreationType (Mp7JrsFactory::GetTypeIndex(X("CreationType")))
#define CreateCreationType (Mp7JrsFactory::CreateObject(TypeOfCreationType))
class Mp7JrsCreationType;
class IMp7JrsCreationType;
/** Smart pointer to instance of IMp7JrsCreationType */
typedef Mp7JrsPtr< IMp7JrsCreationType > Mp7JrsCreationPtr;

#define TypeOfCreationType_Abstract_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationType_Abstract_CollectionType")))
#define CreateCreationType_Abstract_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationType_Abstract_CollectionType))
class Mp7JrsCreationType_Abstract_CollectionType;
class IMp7JrsCreationType_Abstract_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationType_Abstract_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationType_Abstract_CollectionType > Mp7JrsCreationType_Abstract_CollectionPtr;

#define TypeOfCreationType_CopyrightString_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationType_CopyrightString_CollectionType")))
#define CreateCreationType_CopyrightString_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationType_CopyrightString_CollectionType))
class Mp7JrsCreationType_CopyrightString_CollectionType;
class IMp7JrsCreationType_CopyrightString_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationType_CopyrightString_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationType_CopyrightString_CollectionType > Mp7JrsCreationType_CopyrightString_CollectionPtr;

#define TypeOfCreationType_CreationCoordinates_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationType_CreationCoordinates_CollectionType")))
#define CreateCreationType_CreationCoordinates_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationType_CreationCoordinates_CollectionType))
class Mp7JrsCreationType_CreationCoordinates_CollectionType;
class IMp7JrsCreationType_CreationCoordinates_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationType_CreationCoordinates_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationType_CreationCoordinates_CollectionType > Mp7JrsCreationType_CreationCoordinates_CollectionPtr;

#define TypeOfCreationType_CreationCoordinates_LocalType (Mp7JrsFactory::GetTypeIndex(X("CreationType_CreationCoordinates_LocalType")))
#define CreateCreationType_CreationCoordinates_LocalType (Mp7JrsFactory::CreateObject(TypeOfCreationType_CreationCoordinates_LocalType))
class Mp7JrsCreationType_CreationCoordinates_LocalType;
class IMp7JrsCreationType_CreationCoordinates_LocalType;
/** Smart pointer to instance of IMp7JrsCreationType_CreationCoordinates_LocalType */
typedef Mp7JrsPtr< IMp7JrsCreationType_CreationCoordinates_LocalType > Mp7JrsCreationType_CreationCoordinates_LocalPtr;

#define TypeOfCreationType_CreationTool_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationType_CreationTool_CollectionType")))
#define CreateCreationType_CreationTool_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationType_CreationTool_CollectionType))
class Mp7JrsCreationType_CreationTool_CollectionType;
class IMp7JrsCreationType_CreationTool_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationType_CreationTool_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationType_CreationTool_CollectionType > Mp7JrsCreationType_CreationTool_CollectionPtr;

#define TypeOfCreationType_Creator_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationType_Creator_CollectionType")))
#define CreateCreationType_Creator_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationType_Creator_CollectionType))
class Mp7JrsCreationType_Creator_CollectionType;
class IMp7JrsCreationType_Creator_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationType_Creator_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationType_Creator_CollectionType > Mp7JrsCreationType_Creator_CollectionPtr;

#define TypeOfCreationType_Title_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreationType_Title_CollectionType")))
#define CreateCreationType_Title_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreationType_Title_CollectionType))
class Mp7JrsCreationType_Title_CollectionType;
class IMp7JrsCreationType_Title_CollectionType;
/** Smart pointer to instance of IMp7JrsCreationType_Title_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreationType_Title_CollectionType > Mp7JrsCreationType_Title_CollectionPtr;

#define TypeOfCreatorType (Mp7JrsFactory::GetTypeIndex(X("CreatorType")))
#define CreateCreatorType (Mp7JrsFactory::CreateObject(TypeOfCreatorType))
class Mp7JrsCreatorType;
class IMp7JrsCreatorType;
/** Smart pointer to instance of IMp7JrsCreatorType */
typedef Mp7JrsPtr< IMp7JrsCreatorType > Mp7JrsCreatorPtr;

#define TypeOfCreatorType_Character_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreatorType_Character_CollectionType")))
#define CreateCreatorType_Character_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreatorType_Character_CollectionType))
class Mp7JrsCreatorType_Character_CollectionType;
class IMp7JrsCreatorType_Character_CollectionType;
/** Smart pointer to instance of IMp7JrsCreatorType_Character_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreatorType_Character_CollectionType > Mp7JrsCreatorType_Character_CollectionPtr;

#define TypeOfCreatorType_Instrument_CollectionType (Mp7JrsFactory::GetTypeIndex(X("CreatorType_Instrument_CollectionType")))
#define CreateCreatorType_Instrument_CollectionType (Mp7JrsFactory::CreateObject(TypeOfCreatorType_Instrument_CollectionType))
class Mp7JrsCreatorType_Instrument_CollectionType;
class IMp7JrsCreatorType_Instrument_CollectionType;
/** Smart pointer to instance of IMp7JrsCreatorType_Instrument_CollectionType */
typedef Mp7JrsPtr< IMp7JrsCreatorType_Instrument_CollectionType > Mp7JrsCreatorType_Instrument_CollectionPtr;

#define TypeOfcurrencyCode (Mp7JrsFactory::GetTypeIndex(X("currencyCode")))
#define CreatecurrencyCode (Mp7JrsFactory::CreateObject(TypeOfcurrencyCode))
class Mp7JrscurrencyCode;
class IMp7JrscurrencyCode;
/** Smart pointer to instance of IMp7JrscurrencyCode */
typedef Mp7JrsPtr< IMp7JrscurrencyCode > Mp7JrscurrencyCodePtr;

#define TypeOfcurvatureType (Mp7JrsFactory::GetTypeIndex(X("curvatureType")))
#define CreatecurvatureType (Mp7JrsFactory::CreateObject(TypeOfcurvatureType))
class Mp7JrscurvatureType;
class IMp7JrscurvatureType;
/** Smart pointer to instance of IMp7JrscurvatureType */
typedef Mp7JrsPtr< IMp7JrscurvatureType > Mp7JrscurvaturePtr;

#define TypeOfcurvatureType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("curvatureType_CollectionType")))
#define CreatecurvatureType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfcurvatureType_CollectionType))
class Mp7JrscurvatureType_CollectionType;
class IMp7JrscurvatureType_CollectionType;
/** Smart pointer to instance of IMp7JrscurvatureType_CollectionType */
typedef Mp7JrsPtr< IMp7JrscurvatureType_CollectionType > Mp7JrscurvatureType_CollectionPtr;

#define TypeOfdegreeAccidentalType (Mp7JrsFactory::GetTypeIndex(X("degreeAccidentalType")))
#define CreatedegreeAccidentalType (Mp7JrsFactory::CreateObject(TypeOfdegreeAccidentalType))
class Mp7JrsdegreeAccidentalType;
class IMp7JrsdegreeAccidentalType;

#define TypeOfdegreeNoteType (Mp7JrsFactory::GetTypeIndex(X("degreeNoteType")))
#define CreatedegreeNoteType (Mp7JrsFactory::CreateObject(TypeOfdegreeNoteType))
class Mp7JrsdegreeNoteType;
class IMp7JrsdegreeNoteType;

#define TypeOfdependencyOperatorType (Mp7JrsFactory::GetTypeIndex(X("dependencyOperatorType")))
#define CreatedependencyOperatorType (Mp7JrsFactory::CreateObject(TypeOfdependencyOperatorType))
class Mp7JrsdependencyOperatorType;
class IMp7JrsdependencyOperatorType;
/** Smart pointer to instance of IMp7JrsdependencyOperatorType */
typedef Mp7JrsPtr< IMp7JrsdependencyOperatorType > Mp7JrsdependencyOperatorPtr;

#define TypeOfdependencyOperatorType_LocalType (Mp7JrsFactory::GetTypeIndex(X("dependencyOperatorType_LocalType")))
#define CreatedependencyOperatorType_LocalType (Mp7JrsFactory::CreateObject(TypeOfdependencyOperatorType_LocalType))
class Mp7JrsdependencyOperatorType_LocalType;
class IMp7JrsdependencyOperatorType_LocalType;

#define TypeOfDependencyStructurePhraseType (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType")))
#define CreateDependencyStructurePhraseType (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType))
class Mp7JrsDependencyStructurePhraseType;
class IMp7JrsDependencyStructurePhraseType;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType > Mp7JrsDependencyStructurePhrasePtr;

#define TypeOfDependencyStructurePhraseType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_CollectionType")))
#define CreateDependencyStructurePhraseType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_CollectionType))
class Mp7JrsDependencyStructurePhraseType_CollectionType;
class IMp7JrsDependencyStructurePhraseType_CollectionType;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_CollectionType > Mp7JrsDependencyStructurePhraseType_CollectionPtr;

#define TypeOfDependencyStructurePhraseType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_CollectionType0")))
#define CreateDependencyStructurePhraseType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_CollectionType0))
class Mp7JrsDependencyStructurePhraseType_CollectionType0;
class IMp7JrsDependencyStructurePhraseType_CollectionType0;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_CollectionType0 > Mp7JrsDependencyStructurePhraseType_Collection0Ptr;

#define TypeOfDependencyStructurePhraseType_LocalType (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_LocalType")))
#define CreateDependencyStructurePhraseType_LocalType (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_LocalType))
class Mp7JrsDependencyStructurePhraseType_LocalType;
class IMp7JrsDependencyStructurePhraseType_LocalType;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_LocalType */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_LocalType > Mp7JrsDependencyStructurePhraseType_LocalPtr;

#define TypeOfDependencyStructurePhraseType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_LocalType0")))
#define CreateDependencyStructurePhraseType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_LocalType0))
class Mp7JrsDependencyStructurePhraseType_LocalType0;
class IMp7JrsDependencyStructurePhraseType_LocalType0;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_LocalType0 > Mp7JrsDependencyStructurePhraseType_Local0Ptr;

#define TypeOfDependencyStructurePhraseType_operator_LocalType (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_operator_LocalType")))
#define CreateDependencyStructurePhraseType_operator_LocalType (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_operator_LocalType))
class Mp7JrsDependencyStructurePhraseType_operator_LocalType;
class IMp7JrsDependencyStructurePhraseType_operator_LocalType;

#define TypeOfDependencyStructurePhraseType_operator_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_operator_LocalType0")))
#define CreateDependencyStructurePhraseType_operator_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_operator_LocalType0))
class Mp7JrsDependencyStructurePhraseType_operator_LocalType0;
class IMp7JrsDependencyStructurePhraseType_operator_LocalType0;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_operator_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_operator_LocalType0 > Mp7JrsDependencyStructurePhraseType_operator_Local0Ptr;

#define TypeOfDependencyStructurePhraseType_operator_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_operator_LocalType1")))
#define CreateDependencyStructurePhraseType_operator_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_operator_LocalType1))
class Mp7JrsDependencyStructurePhraseType_operator_LocalType1;
class IMp7JrsDependencyStructurePhraseType_operator_LocalType1;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_operator_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_operator_LocalType1 > Mp7JrsDependencyStructurePhraseType_operator_Local1Ptr;

#define TypeOfDependencyStructurePhraseType_operator_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("DependencyStructurePhraseType_operator_LocalType2")))
#define CreateDependencyStructurePhraseType_operator_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfDependencyStructurePhraseType_operator_LocalType2))
class Mp7JrsDependencyStructurePhraseType_operator_LocalType2;
class IMp7JrsDependencyStructurePhraseType_operator_LocalType2;
/** Smart pointer to instance of IMp7JrsDependencyStructurePhraseType_operator_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_operator_LocalType2 > Mp7JrsDependencyStructurePhraseType_operator_Local2Ptr;

#define TypeOfDependencyStructureType (Mp7JrsFactory::GetTypeIndex(X("DependencyStructureType")))
#define CreateDependencyStructureType (Mp7JrsFactory::CreateObject(TypeOfDependencyStructureType))
class Mp7JrsDependencyStructureType;
class IMp7JrsDependencyStructureType;
/** Smart pointer to instance of IMp7JrsDependencyStructureType */
typedef Mp7JrsPtr< IMp7JrsDependencyStructureType > Mp7JrsDependencyStructurePtr;

#define TypeOfDependencyStructureType_Sentence_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DependencyStructureType_Sentence_CollectionType")))
#define CreateDependencyStructureType_Sentence_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDependencyStructureType_Sentence_CollectionType))
class Mp7JrsDependencyStructureType_Sentence_CollectionType;
class IMp7JrsDependencyStructureType_Sentence_CollectionType;
/** Smart pointer to instance of IMp7JrsDependencyStructureType_Sentence_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDependencyStructureType_Sentence_CollectionType > Mp7JrsDependencyStructureType_Sentence_CollectionPtr;

#define TypeOfDescriptionMetadataType (Mp7JrsFactory::GetTypeIndex(X("DescriptionMetadataType")))
#define CreateDescriptionMetadataType (Mp7JrsFactory::CreateObject(TypeOfDescriptionMetadataType))
class Mp7JrsDescriptionMetadataType;
class IMp7JrsDescriptionMetadataType;
/** Smart pointer to instance of IMp7JrsDescriptionMetadataType */
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType > Mp7JrsDescriptionMetadataPtr;

#define TypeOfDescriptionMetadataType_Creator_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptionMetadataType_Creator_CollectionType")))
#define CreateDescriptionMetadataType_Creator_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptionMetadataType_Creator_CollectionType))
class Mp7JrsDescriptionMetadataType_Creator_CollectionType;
class IMp7JrsDescriptionMetadataType_Creator_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptionMetadataType_Creator_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_Creator_CollectionType > Mp7JrsDescriptionMetadataType_Creator_CollectionPtr;

#define TypeOfDescriptionMetadataType_Instrument_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptionMetadataType_Instrument_CollectionType")))
#define CreateDescriptionMetadataType_Instrument_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptionMetadataType_Instrument_CollectionType))
class Mp7JrsDescriptionMetadataType_Instrument_CollectionType;
class IMp7JrsDescriptionMetadataType_Instrument_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptionMetadataType_Instrument_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_Instrument_CollectionType > Mp7JrsDescriptionMetadataType_Instrument_CollectionPtr;

#define TypeOfDescriptionMetadataType_PrivateIdentifier_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptionMetadataType_PrivateIdentifier_CollectionType")))
#define CreateDescriptionMetadataType_PrivateIdentifier_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptionMetadataType_PrivateIdentifier_CollectionType))
class Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType;
class IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType > Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionPtr;

#define TypeOfDescriptionMetadataType_PublicIdentifier_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptionMetadataType_PublicIdentifier_CollectionType")))
#define CreateDescriptionMetadataType_PublicIdentifier_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptionMetadataType_PublicIdentifier_CollectionType))
class Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType;
class IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType > Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionPtr;

#define TypeOfDescriptorCollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptorCollectionType")))
#define CreateDescriptorCollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptorCollectionType))
class Mp7JrsDescriptorCollectionType;
class IMp7JrsDescriptorCollectionType;
/** Smart pointer to instance of IMp7JrsDescriptorCollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptorCollectionType > Mp7JrsDescriptorCollectionPtr;

#define TypeOfDescriptorCollectionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptorCollectionType_CollectionType")))
#define CreateDescriptorCollectionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptorCollectionType_CollectionType))
class Mp7JrsDescriptorCollectionType_CollectionType;
class IMp7JrsDescriptorCollectionType_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptorCollectionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptorCollectionType_CollectionType > Mp7JrsDescriptorCollectionType_CollectionPtr;

#define TypeOfDescriptorCollectionType_Descriptor_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptorCollectionType_Descriptor_CollectionType")))
#define CreateDescriptorCollectionType_Descriptor_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptorCollectionType_Descriptor_CollectionType))
class Mp7JrsDescriptorCollectionType_Descriptor_CollectionType;
class IMp7JrsDescriptorCollectionType_Descriptor_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptorCollectionType_Descriptor_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptorCollectionType_Descriptor_CollectionType > Mp7JrsDescriptorCollectionType_Descriptor_CollectionPtr;

#define TypeOfDescriptorCollectionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("DescriptorCollectionType_LocalType")))
#define CreateDescriptorCollectionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfDescriptorCollectionType_LocalType))
class Mp7JrsDescriptorCollectionType_LocalType;
class IMp7JrsDescriptorCollectionType_LocalType;
/** Smart pointer to instance of IMp7JrsDescriptorCollectionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsDescriptorCollectionType_LocalType > Mp7JrsDescriptorCollectionType_LocalPtr;

#define TypeOfDescriptorModelType (Mp7JrsFactory::GetTypeIndex(X("DescriptorModelType")))
#define CreateDescriptorModelType (Mp7JrsFactory::CreateObject(TypeOfDescriptorModelType))
class Mp7JrsDescriptorModelType;
class IMp7JrsDescriptorModelType;
/** Smart pointer to instance of IMp7JrsDescriptorModelType */
typedef Mp7JrsPtr< IMp7JrsDescriptorModelType > Mp7JrsDescriptorModelPtr;

#define TypeOfDescriptorModelType_Field_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DescriptorModelType_Field_CollectionType")))
#define CreateDescriptorModelType_Field_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDescriptorModelType_Field_CollectionType))
class Mp7JrsDescriptorModelType_Field_CollectionType;
class IMp7JrsDescriptorModelType_Field_CollectionType;
/** Smart pointer to instance of IMp7JrsDescriptorModelType_Field_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDescriptorModelType_Field_CollectionType > Mp7JrsDescriptorModelType_Field_CollectionPtr;

#define TypeOfdim_LocalType (Mp7JrsFactory::GetTypeIndex(X("dim_LocalType")))
#define Createdim_LocalType (Mp7JrsFactory::CreateObject(TypeOfdim_LocalType))
class Mp7Jrsdim_LocalType;
class IMp7Jrsdim_LocalType;
/** Smart pointer to instance of IMp7Jrsdim_LocalType */
typedef Mp7JrsPtr< IMp7Jrsdim_LocalType > Mp7Jrsdim_LocalPtr;

#define TypeOfDiscreteDistributionType (Mp7JrsFactory::GetTypeIndex(X("DiscreteDistributionType")))
#define CreateDiscreteDistributionType (Mp7JrsFactory::CreateObject(TypeOfDiscreteDistributionType))
class Mp7JrsDiscreteDistributionType;
class IMp7JrsDiscreteDistributionType;
/** Smart pointer to instance of IMp7JrsDiscreteDistributionType */
typedef Mp7JrsPtr< IMp7JrsDiscreteDistributionType > Mp7JrsDiscreteDistributionPtr;

#define TypeOfDiscreteHiddenMarkovModelType (Mp7JrsFactory::GetTypeIndex(X("DiscreteHiddenMarkovModelType")))
#define CreateDiscreteHiddenMarkovModelType (Mp7JrsFactory::CreateObject(TypeOfDiscreteHiddenMarkovModelType))
class Mp7JrsDiscreteHiddenMarkovModelType;
class IMp7JrsDiscreteHiddenMarkovModelType;
/** Smart pointer to instance of IMp7JrsDiscreteHiddenMarkovModelType */
typedef Mp7JrsPtr< IMp7JrsDiscreteHiddenMarkovModelType > Mp7JrsDiscreteHiddenMarkovModelPtr;

#define TypeOfDiscreteHiddenMarkovModelType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DiscreteHiddenMarkovModelType_CollectionType")))
#define CreateDiscreteHiddenMarkovModelType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDiscreteHiddenMarkovModelType_CollectionType))
class Mp7JrsDiscreteHiddenMarkovModelType_CollectionType;
class IMp7JrsDiscreteHiddenMarkovModelType_CollectionType;
/** Smart pointer to instance of IMp7JrsDiscreteHiddenMarkovModelType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDiscreteHiddenMarkovModelType_CollectionType > Mp7JrsDiscreteHiddenMarkovModelType_CollectionPtr;

#define TypeOfDiscreteHiddenMarkovModelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("DiscreteHiddenMarkovModelType_LocalType")))
#define CreateDiscreteHiddenMarkovModelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfDiscreteHiddenMarkovModelType_LocalType))
class Mp7JrsDiscreteHiddenMarkovModelType_LocalType;
class IMp7JrsDiscreteHiddenMarkovModelType_LocalType;
/** Smart pointer to instance of IMp7JrsDiscreteHiddenMarkovModelType_LocalType */
typedef Mp7JrsPtr< IMp7JrsDiscreteHiddenMarkovModelType_LocalType > Mp7JrsDiscreteHiddenMarkovModelType_LocalPtr;

#define TypeOfDiscreteHiddenMarkovModelType_Observation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DiscreteHiddenMarkovModelType_Observation_CollectionType")))
#define CreateDiscreteHiddenMarkovModelType_Observation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDiscreteHiddenMarkovModelType_Observation_CollectionType))
class Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType;
class IMp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType;
/** Smart pointer to instance of IMp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType > Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionPtr;

#define TypeOfDiscreteUniformDistributionType (Mp7JrsFactory::GetTypeIndex(X("DiscreteUniformDistributionType")))
#define CreateDiscreteUniformDistributionType (Mp7JrsFactory::CreateObject(TypeOfDiscreteUniformDistributionType))
class Mp7JrsDiscreteUniformDistributionType;
class IMp7JrsDiscreteUniformDistributionType;
/** Smart pointer to instance of IMp7JrsDiscreteUniformDistributionType */
typedef Mp7JrsPtr< IMp7JrsDiscreteUniformDistributionType > Mp7JrsDiscreteUniformDistributionPtr;

#define TypeOfDisseminationType (Mp7JrsFactory::GetTypeIndex(X("DisseminationType")))
#define CreateDisseminationType (Mp7JrsFactory::CreateObject(TypeOfDisseminationType))
class Mp7JrsDisseminationType;
class IMp7JrsDisseminationType;
/** Smart pointer to instance of IMp7JrsDisseminationType */
typedef Mp7JrsPtr< IMp7JrsDisseminationType > Mp7JrsDisseminationPtr;

#define TypeOfDominantColorType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType")))
#define CreateDominantColorType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType))
class Mp7JrsDominantColorType;
class IMp7JrsDominantColorType;
/** Smart pointer to instance of IMp7JrsDominantColorType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType > Mp7JrsDominantColorPtr;

#define TypeOfDominantColorType_Value_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType_Value_CollectionType")))
#define CreateDominantColorType_Value_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType_Value_CollectionType))
class Mp7JrsDominantColorType_Value_CollectionType;
class IMp7JrsDominantColorType_Value_CollectionType;
/** Smart pointer to instance of IMp7JrsDominantColorType_Value_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_CollectionType > Mp7JrsDominantColorType_Value_CollectionPtr;

#define TypeOfDominantColorType_Value_ColorVariance_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType_Value_ColorVariance_CollectionType")))
#define CreateDominantColorType_Value_ColorVariance_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType_Value_ColorVariance_CollectionType))
class Mp7JrsDominantColorType_Value_ColorVariance_CollectionType;
class IMp7JrsDominantColorType_Value_ColorVariance_CollectionType;
/** Smart pointer to instance of IMp7JrsDominantColorType_Value_ColorVariance_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_ColorVariance_CollectionType > Mp7JrsDominantColorType_Value_ColorVariance_CollectionPtr;

#define TypeOfDominantColorType_Value_ColorVariance_LocalType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType_Value_ColorVariance_LocalType")))
#define CreateDominantColorType_Value_ColorVariance_LocalType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType_Value_ColorVariance_LocalType))
class Mp7JrsDominantColorType_Value_ColorVariance_LocalType;
class IMp7JrsDominantColorType_Value_ColorVariance_LocalType;
/** Smart pointer to instance of IMp7JrsDominantColorType_Value_ColorVariance_LocalType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_ColorVariance_LocalType > Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr;

#define TypeOfDominantColorType_Value_Index_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType_Value_Index_CollectionType")))
#define CreateDominantColorType_Value_Index_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType_Value_Index_CollectionType))
class Mp7JrsDominantColorType_Value_Index_CollectionType;
class IMp7JrsDominantColorType_Value_Index_CollectionType;
/** Smart pointer to instance of IMp7JrsDominantColorType_Value_Index_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_Index_CollectionType > Mp7JrsDominantColorType_Value_Index_CollectionPtr;

#define TypeOfDominantColorType_Value_Index_LocalType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType_Value_Index_LocalType")))
#define CreateDominantColorType_Value_Index_LocalType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType_Value_Index_LocalType))
class Mp7JrsDominantColorType_Value_Index_LocalType;
class IMp7JrsDominantColorType_Value_Index_LocalType;
/** Smart pointer to instance of IMp7JrsDominantColorType_Value_Index_LocalType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_Index_LocalType > Mp7JrsDominantColorType_Value_Index_LocalPtr;

#define TypeOfDominantColorType_Value_LocalType (Mp7JrsFactory::GetTypeIndex(X("DominantColorType_Value_LocalType")))
#define CreateDominantColorType_Value_LocalType (Mp7JrsFactory::CreateObject(TypeOfDominantColorType_Value_LocalType))
class Mp7JrsDominantColorType_Value_LocalType;
class IMp7JrsDominantColorType_Value_LocalType;
/** Smart pointer to instance of IMp7JrsDominantColorType_Value_LocalType */
typedef Mp7JrsPtr< IMp7JrsDominantColorType_Value_LocalType > Mp7JrsDominantColorType_Value_LocalPtr;

#define TypeOfDoubleDiagonalMatrixType (Mp7JrsFactory::GetTypeIndex(X("DoubleDiagonalMatrixType")))
#define CreateDoubleDiagonalMatrixType (Mp7JrsFactory::CreateObject(TypeOfDoubleDiagonalMatrixType))
class Mp7JrsDoubleDiagonalMatrixType;
class IMp7JrsDoubleDiagonalMatrixType;
/** Smart pointer to instance of IMp7JrsDoubleDiagonalMatrixType */
typedef Mp7JrsPtr< IMp7JrsDoubleDiagonalMatrixType > Mp7JrsDoubleDiagonalMatrixPtr;

#define TypeOfDoubleMatrixType (Mp7JrsFactory::GetTypeIndex(X("DoubleMatrixType")))
#define CreateDoubleMatrixType (Mp7JrsFactory::CreateObject(TypeOfDoubleMatrixType))
class Mp7JrsDoubleMatrixType;
class IMp7JrsDoubleMatrixType;
/** Smart pointer to instance of IMp7JrsDoubleMatrixType */
typedef Mp7JrsPtr< IMp7JrsDoubleMatrixType > Mp7JrsDoubleMatrixPtr;

#define TypeOfDoublePullbackDefinitionType (Mp7JrsFactory::GetTypeIndex(X("DoublePullbackDefinitionType")))
#define CreateDoublePullbackDefinitionType (Mp7JrsFactory::CreateObject(TypeOfDoublePullbackDefinitionType))
class Mp7JrsDoublePullbackDefinitionType;
class IMp7JrsDoublePullbackDefinitionType;
/** Smart pointer to instance of IMp7JrsDoublePullbackDefinitionType */
typedef Mp7JrsPtr< IMp7JrsDoublePullbackDefinitionType > Mp7JrsDoublePullbackDefinitionPtr;

#define TypeOfDoublePullbackDefinitionType_MorphismGraph_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DoublePullbackDefinitionType_MorphismGraph_CollectionType")))
#define CreateDoublePullbackDefinitionType_MorphismGraph_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDoublePullbackDefinitionType_MorphismGraph_CollectionType))
class Mp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionType;
class IMp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionType;
/** Smart pointer to instance of IMp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionType > Mp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionPtr;

#define TypeOfDoublePullbackDefinitionType_RuleGraph_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DoublePullbackDefinitionType_RuleGraph_CollectionType")))
#define CreateDoublePullbackDefinitionType_RuleGraph_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDoublePullbackDefinitionType_RuleGraph_CollectionType))
class Mp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionType;
class IMp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionType;
/** Smart pointer to instance of IMp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionType > Mp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionPtr;

#define TypeOfDoublePushoutDefinitionType (Mp7JrsFactory::GetTypeIndex(X("DoublePushoutDefinitionType")))
#define CreateDoublePushoutDefinitionType (Mp7JrsFactory::CreateObject(TypeOfDoublePushoutDefinitionType))
class Mp7JrsDoublePushoutDefinitionType;
class IMp7JrsDoublePushoutDefinitionType;
/** Smart pointer to instance of IMp7JrsDoublePushoutDefinitionType */
typedef Mp7JrsPtr< IMp7JrsDoublePushoutDefinitionType > Mp7JrsDoublePushoutDefinitionPtr;

#define TypeOfDoublePushoutDefinitionType_MorphismGraph_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DoublePushoutDefinitionType_MorphismGraph_CollectionType")))
#define CreateDoublePushoutDefinitionType_MorphismGraph_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDoublePushoutDefinitionType_MorphismGraph_CollectionType))
class Mp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionType;
class IMp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionType;
/** Smart pointer to instance of IMp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionType > Mp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionPtr;

#define TypeOfdoubleVector (Mp7JrsFactory::GetTypeIndex(X("doubleVector")))
#define CreatedoubleVector (Mp7JrsFactory::CreateObject(TypeOfdoubleVector))
class Mp7JrsdoubleVector;
class IMp7JrsdoubleVector;
/** Smart pointer to instance of IMp7JrsdoubleVector */
typedef Mp7JrsPtr< IMp7JrsdoubleVector > Mp7JrsdoubleVectorPtr;

#define TypeOfDSType (Mp7JrsFactory::GetTypeIndex(X("DSType")))
#define CreateDSType (Mp7JrsFactory::CreateObject(TypeOfDSType))
class Mp7JrsDSType;
class IMp7JrsDSType;
/** Smart pointer to instance of IMp7JrsDSType */
typedef Mp7JrsPtr< IMp7JrsDSType > Mp7JrsDSPtr;

#define TypeOfDSType_Header_CollectionType (Mp7JrsFactory::GetTypeIndex(X("DSType_Header_CollectionType")))
#define CreateDSType_Header_CollectionType (Mp7JrsFactory::CreateObject(TypeOfDSType_Header_CollectionType))
class Mp7JrsDSType_Header_CollectionType;
class IMp7JrsDSType_Header_CollectionType;
/** Smart pointer to instance of IMp7JrsDSType_Header_CollectionType */
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;

#define TypeOfDType (Mp7JrsFactory::GetTypeIndex(X("DType")))
#define CreateDType (Mp7JrsFactory::CreateObject(TypeOfDType))
class Mp7JrsDType;
class IMp7JrsDType;
/** Smart pointer to instance of IMp7JrsDType */
typedef Mp7JrsPtr< IMp7JrsDType > Mp7JrsDPtr;

#define TypeOfdurationType (Mp7JrsFactory::GetTypeIndex(X("durationType")))
#define CreatedurationType (Mp7JrsFactory::CreateObject(TypeOfdurationType))
class Mp7JrsdurationType;
class IMp7JrsdurationType;
/** Smart pointer to instance of IMp7JrsdurationType */
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;

#define TypeOfEdgeHistogramType (Mp7JrsFactory::GetTypeIndex(X("EdgeHistogramType")))
#define CreateEdgeHistogramType (Mp7JrsFactory::CreateObject(TypeOfEdgeHistogramType))
class Mp7JrsEdgeHistogramType;
class IMp7JrsEdgeHistogramType;
/** Smart pointer to instance of IMp7JrsEdgeHistogramType */
typedef Mp7JrsPtr< IMp7JrsEdgeHistogramType > Mp7JrsEdgeHistogramPtr;

#define TypeOfEdgeHistogramType_BinCounts_CollectionType (Mp7JrsFactory::GetTypeIndex(X("EdgeHistogramType_BinCounts_CollectionType")))
#define CreateEdgeHistogramType_BinCounts_CollectionType (Mp7JrsFactory::CreateObject(TypeOfEdgeHistogramType_BinCounts_CollectionType))
class Mp7JrsEdgeHistogramType_BinCounts_CollectionType;
class IMp7JrsEdgeHistogramType_BinCounts_CollectionType;
/** Smart pointer to instance of IMp7JrsEdgeHistogramType_BinCounts_CollectionType */
typedef Mp7JrsPtr< IMp7JrsEdgeHistogramType_BinCounts_CollectionType > Mp7JrsEdgeHistogramType_BinCounts_CollectionPtr;

#define TypeOfEdgeHistogramType_BinCounts_LocalType (Mp7JrsFactory::GetTypeIndex(X("EdgeHistogramType_BinCounts_LocalType")))
#define CreateEdgeHistogramType_BinCounts_LocalType (Mp7JrsFactory::CreateObject(TypeOfEdgeHistogramType_BinCounts_LocalType))
class Mp7JrsEdgeHistogramType_BinCounts_LocalType;
class IMp7JrsEdgeHistogramType_BinCounts_LocalType;
/** Smart pointer to instance of IMp7JrsEdgeHistogramType_BinCounts_LocalType */
typedef Mp7JrsPtr< IMp7JrsEdgeHistogramType_BinCounts_LocalType > Mp7JrsEdgeHistogramType_BinCounts_LocalPtr;

#define TypeOfEditedMovingRegionType (Mp7JrsFactory::GetTypeIndex(X("EditedMovingRegionType")))
#define CreateEditedMovingRegionType (Mp7JrsFactory::CreateObject(TypeOfEditedMovingRegionType))
class Mp7JrsEditedMovingRegionType;
class IMp7JrsEditedMovingRegionType;
/** Smart pointer to instance of IMp7JrsEditedMovingRegionType */
typedef Mp7JrsPtr< IMp7JrsEditedMovingRegionType > Mp7JrsEditedMovingRegionPtr;

#define TypeOfEditedVideoEditingTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("EditedVideoEditingTemporalDecompositionType")))
#define CreateEditedVideoEditingTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfEditedVideoEditingTemporalDecompositionType))
class Mp7JrsEditedVideoEditingTemporalDecompositionType;
class IMp7JrsEditedVideoEditingTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsEditedVideoEditingTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsEditedVideoEditingTemporalDecompositionType > Mp7JrsEditedVideoEditingTemporalDecompositionPtr;

#define TypeOfEditedVideoEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("EditedVideoEditingTemporalDecompositionType_CollectionType")))
#define CreateEditedVideoEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfEditedVideoEditingTemporalDecompositionType_CollectionType))
class Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionType;
class IMp7JrsEditedVideoEditingTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsEditedVideoEditingTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsEditedVideoEditingTemporalDecompositionType_CollectionType > Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionPtr;

#define TypeOfEditedVideoEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("EditedVideoEditingTemporalDecompositionType_LocalType")))
#define CreateEditedVideoEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfEditedVideoEditingTemporalDecompositionType_LocalType))
class Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType;
class IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType > Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr;

#define TypeOfEditedVideoType (Mp7JrsFactory::GetTypeIndex(X("EditedVideoType")))
#define CreateEditedVideoType (Mp7JrsFactory::CreateObject(TypeOfEditedVideoType))
class Mp7JrsEditedVideoType;
class IMp7JrsEditedVideoType;
/** Smart pointer to instance of IMp7JrsEditedVideoType */
typedef Mp7JrsPtr< IMp7JrsEditedVideoType > Mp7JrsEditedVideoPtr;

#define TypeOfEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("EditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType")))
#define CreateEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType))
class Mp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType;
class IMp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType > Mp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionPtr;

#define TypeOfElectronicAddressType (Mp7JrsFactory::GetTypeIndex(X("ElectronicAddressType")))
#define CreateElectronicAddressType (Mp7JrsFactory::CreateObject(TypeOfElectronicAddressType))
class Mp7JrsElectronicAddressType;
class IMp7JrsElectronicAddressType;
/** Smart pointer to instance of IMp7JrsElectronicAddressType */
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType > Mp7JrsElectronicAddressPtr;

#define TypeOfElectronicAddressType_Email_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ElectronicAddressType_Email_CollectionType")))
#define CreateElectronicAddressType_Email_CollectionType (Mp7JrsFactory::CreateObject(TypeOfElectronicAddressType_Email_CollectionType))
class Mp7JrsElectronicAddressType_Email_CollectionType;
class IMp7JrsElectronicAddressType_Email_CollectionType;
/** Smart pointer to instance of IMp7JrsElectronicAddressType_Email_CollectionType */
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Email_CollectionType > Mp7JrsElectronicAddressType_Email_CollectionPtr;

#define TypeOfElectronicAddressType_Fax_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ElectronicAddressType_Fax_CollectionType")))
#define CreateElectronicAddressType_Fax_CollectionType (Mp7JrsFactory::CreateObject(TypeOfElectronicAddressType_Fax_CollectionType))
class Mp7JrsElectronicAddressType_Fax_CollectionType;
class IMp7JrsElectronicAddressType_Fax_CollectionType;
/** Smart pointer to instance of IMp7JrsElectronicAddressType_Fax_CollectionType */
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Fax_CollectionType > Mp7JrsElectronicAddressType_Fax_CollectionPtr;

#define TypeOfElectronicAddressType_Telephone_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ElectronicAddressType_Telephone_CollectionType")))
#define CreateElectronicAddressType_Telephone_CollectionType (Mp7JrsFactory::CreateObject(TypeOfElectronicAddressType_Telephone_CollectionType))
class Mp7JrsElectronicAddressType_Telephone_CollectionType;
class IMp7JrsElectronicAddressType_Telephone_CollectionType;
/** Smart pointer to instance of IMp7JrsElectronicAddressType_Telephone_CollectionType */
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Telephone_CollectionType > Mp7JrsElectronicAddressType_Telephone_CollectionPtr;

#define TypeOfElectronicAddressType_Url_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ElectronicAddressType_Url_CollectionType")))
#define CreateElectronicAddressType_Url_CollectionType (Mp7JrsFactory::CreateObject(TypeOfElectronicAddressType_Url_CollectionType))
class Mp7JrsElectronicAddressType_Url_CollectionType;
class IMp7JrsElectronicAddressType_Url_CollectionType;
/** Smart pointer to instance of IMp7JrsElectronicAddressType_Url_CollectionType */
typedef Mp7JrsPtr< IMp7JrsElectronicAddressType_Url_CollectionType > Mp7JrsElectronicAddressType_Url_CollectionPtr;

#define TypeOfEventType (Mp7JrsFactory::GetTypeIndex(X("EventType")))
#define CreateEventType (Mp7JrsFactory::CreateObject(TypeOfEventType))
class Mp7JrsEventType;
class IMp7JrsEventType;
/** Smart pointer to instance of IMp7JrsEventType */
typedef Mp7JrsPtr< IMp7JrsEventType > Mp7JrsEventPtr;

#define TypeOfEventType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("EventType_CollectionType")))
#define CreateEventType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfEventType_CollectionType))
class Mp7JrsEventType_CollectionType;
class IMp7JrsEventType_CollectionType;
/** Smart pointer to instance of IMp7JrsEventType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsEventType_CollectionType > Mp7JrsEventType_CollectionPtr;

#define TypeOfEventType_LocalType (Mp7JrsFactory::GetTypeIndex(X("EventType_LocalType")))
#define CreateEventType_LocalType (Mp7JrsFactory::CreateObject(TypeOfEventType_LocalType))
class Mp7JrsEventType_LocalType;
class IMp7JrsEventType_LocalType;
/** Smart pointer to instance of IMp7JrsEventType_LocalType */
typedef Mp7JrsPtr< IMp7JrsEventType_LocalType > Mp7JrsEventType_LocalPtr;

#define TypeOfEventType_SemanticPlace_CollectionType (Mp7JrsFactory::GetTypeIndex(X("EventType_SemanticPlace_CollectionType")))
#define CreateEventType_SemanticPlace_CollectionType (Mp7JrsFactory::CreateObject(TypeOfEventType_SemanticPlace_CollectionType))
class Mp7JrsEventType_SemanticPlace_CollectionType;
class IMp7JrsEventType_SemanticPlace_CollectionType;
/** Smart pointer to instance of IMp7JrsEventType_SemanticPlace_CollectionType */
typedef Mp7JrsPtr< IMp7JrsEventType_SemanticPlace_CollectionType > Mp7JrsEventType_SemanticPlace_CollectionPtr;

#define TypeOfEventType_SemanticTime_CollectionType (Mp7JrsFactory::GetTypeIndex(X("EventType_SemanticTime_CollectionType")))
#define CreateEventType_SemanticTime_CollectionType (Mp7JrsFactory::CreateObject(TypeOfEventType_SemanticTime_CollectionType))
class Mp7JrsEventType_SemanticTime_CollectionType;
class IMp7JrsEventType_SemanticTime_CollectionType;
/** Smart pointer to instance of IMp7JrsEventType_SemanticTime_CollectionType */
typedef Mp7JrsPtr< IMp7JrsEventType_SemanticTime_CollectionType > Mp7JrsEventType_SemanticTime_CollectionPtr;

#define TypeOfExponentialDistributionType (Mp7JrsFactory::GetTypeIndex(X("ExponentialDistributionType")))
#define CreateExponentialDistributionType (Mp7JrsFactory::CreateObject(TypeOfExponentialDistributionType))
class Mp7JrsExponentialDistributionType;
class IMp7JrsExponentialDistributionType;
/** Smart pointer to instance of IMp7JrsExponentialDistributionType */
typedef Mp7JrsPtr< IMp7JrsExponentialDistributionType > Mp7JrsExponentialDistributionPtr;

#define TypeOfExtendedLanguageType (Mp7JrsFactory::GetTypeIndex(X("ExtendedLanguageType")))
#define CreateExtendedLanguageType (Mp7JrsFactory::CreateObject(TypeOfExtendedLanguageType))
class Mp7JrsExtendedLanguageType;
class IMp7JrsExtendedLanguageType;
/** Smart pointer to instance of IMp7JrsExtendedLanguageType */
typedef Mp7JrsPtr< IMp7JrsExtendedLanguageType > Mp7JrsExtendedLanguagePtr;

#define TypeOfExtendedLanguageType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("ExtendedLanguageType_type_LocalType")))
#define CreateExtendedLanguageType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfExtendedLanguageType_type_LocalType))
class Mp7JrsExtendedLanguageType_type_LocalType;
class IMp7JrsExtendedLanguageType_type_LocalType;

#define TypeOfExtentType (Mp7JrsFactory::GetTypeIndex(X("ExtentType")))
#define CreateExtentType (Mp7JrsFactory::CreateObject(TypeOfExtentType))
class Mp7JrsExtentType;
class IMp7JrsExtentType;
/** Smart pointer to instance of IMp7JrsExtentType */
typedef Mp7JrsPtr< IMp7JrsExtentType > Mp7JrsExtentPtr;

#define TypeOfFaceRecognitionType (Mp7JrsFactory::GetTypeIndex(X("FaceRecognitionType")))
#define CreateFaceRecognitionType (Mp7JrsFactory::CreateObject(TypeOfFaceRecognitionType))
class Mp7JrsFaceRecognitionType;
class IMp7JrsFaceRecognitionType;
/** Smart pointer to instance of IMp7JrsFaceRecognitionType */
typedef Mp7JrsPtr< IMp7JrsFaceRecognitionType > Mp7JrsFaceRecognitionPtr;

#define TypeOfFaceRecognitionType_Feature_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FaceRecognitionType_Feature_CollectionType")))
#define CreateFaceRecognitionType_Feature_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFaceRecognitionType_Feature_CollectionType))
class Mp7JrsFaceRecognitionType_Feature_CollectionType;
class IMp7JrsFaceRecognitionType_Feature_CollectionType;
/** Smart pointer to instance of IMp7JrsFaceRecognitionType_Feature_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFaceRecognitionType_Feature_CollectionType > Mp7JrsFaceRecognitionType_Feature_CollectionPtr;

#define TypeOfFaceRecognitionType_Feature_LocalType (Mp7JrsFactory::GetTypeIndex(X("FaceRecognitionType_Feature_LocalType")))
#define CreateFaceRecognitionType_Feature_LocalType (Mp7JrsFactory::CreateObject(TypeOfFaceRecognitionType_Feature_LocalType))
class Mp7JrsFaceRecognitionType_Feature_LocalType;
class IMp7JrsFaceRecognitionType_Feature_LocalType;
/** Smart pointer to instance of IMp7JrsFaceRecognitionType_Feature_LocalType */
typedef Mp7JrsPtr< IMp7JrsFaceRecognitionType_Feature_LocalType > Mp7JrsFaceRecognitionType_Feature_LocalPtr;

#define TypeOfFigureTrajectoryType (Mp7JrsFactory::GetTypeIndex(X("FigureTrajectoryType")))
#define CreateFigureTrajectoryType (Mp7JrsFactory::CreateObject(TypeOfFigureTrajectoryType))
class Mp7JrsFigureTrajectoryType;
class IMp7JrsFigureTrajectoryType;
/** Smart pointer to instance of IMp7JrsFigureTrajectoryType */
typedef Mp7JrsPtr< IMp7JrsFigureTrajectoryType > Mp7JrsFigureTrajectoryPtr;

#define TypeOfFigureTrajectoryType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("FigureTrajectoryType_type_LocalType")))
#define CreateFigureTrajectoryType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfFigureTrajectoryType_type_LocalType))
class Mp7JrsFigureTrajectoryType_type_LocalType;
class IMp7JrsFigureTrajectoryType_type_LocalType;

#define TypeOfFigureTrajectoryType_Vertex_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FigureTrajectoryType_Vertex_CollectionType")))
#define CreateFigureTrajectoryType_Vertex_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFigureTrajectoryType_Vertex_CollectionType))
class Mp7JrsFigureTrajectoryType_Vertex_CollectionType;
class IMp7JrsFigureTrajectoryType_Vertex_CollectionType;
/** Smart pointer to instance of IMp7JrsFigureTrajectoryType_Vertex_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFigureTrajectoryType_Vertex_CollectionType > Mp7JrsFigureTrajectoryType_Vertex_CollectionPtr;

#define TypeOfFilter1DType (Mp7JrsFactory::GetTypeIndex(X("Filter1DType")))
#define CreateFilter1DType (Mp7JrsFactory::CreateObject(TypeOfFilter1DType))
class Mp7JrsFilter1DType;
class IMp7JrsFilter1DType;
/** Smart pointer to instance of IMp7JrsFilter1DType */
typedef Mp7JrsPtr< IMp7JrsFilter1DType > Mp7JrsFilter1DPtr;

#define TypeOfFilter2DType (Mp7JrsFactory::GetTypeIndex(X("Filter2DType")))
#define CreateFilter2DType (Mp7JrsFactory::CreateObject(TypeOfFilter2DType))
class Mp7JrsFilter2DType;
class IMp7JrsFilter2DType;
/** Smart pointer to instance of IMp7JrsFilter2DType */
typedef Mp7JrsPtr< IMp7JrsFilter2DType > Mp7JrsFilter2DPtr;

#define TypeOfFilteringAndSearchPreferencesType (Mp7JrsFactory::GetTypeIndex(X("FilteringAndSearchPreferencesType")))
#define CreateFilteringAndSearchPreferencesType (Mp7JrsFactory::CreateObject(TypeOfFilteringAndSearchPreferencesType))
class Mp7JrsFilteringAndSearchPreferencesType;
class IMp7JrsFilteringAndSearchPreferencesType;
/** Smart pointer to instance of IMp7JrsFilteringAndSearchPreferencesType */
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType > Mp7JrsFilteringAndSearchPreferencesPtr;

#define TypeOfFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType")))
#define CreateFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType))
class Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionPtr;

#define TypeOfFilteringAndSearchPreferencesType_CreationPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FilteringAndSearchPreferencesType_CreationPreferences_CollectionType")))
#define CreateFilteringAndSearchPreferencesType_CreationPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFilteringAndSearchPreferencesType_CreationPreferences_CollectionType))
class Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionPtr;

#define TypeOfFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType")))
#define CreateFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType))
class Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionPtr;

#define TypeOfFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FilteringAndSearchPreferencesType_PreferenceCondition_CollectionType")))
#define CreateFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType))
class Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType;
/** Smart pointer to instance of IMp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionPtr;

#define TypeOfFilteringAndSearchPreferencesType_SourcePreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FilteringAndSearchPreferencesType_SourcePreferences_CollectionType")))
#define CreateFilteringAndSearchPreferencesType_SourcePreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFilteringAndSearchPreferencesType_SourcePreferences_CollectionType))
class Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType;
class IMp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType > Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionPtr;

#define TypeOfFilteringType (Mp7JrsFactory::GetTypeIndex(X("FilteringType")))
#define CreateFilteringType (Mp7JrsFactory::CreateObject(TypeOfFilteringType))
class Mp7JrsFilteringType;
class IMp7JrsFilteringType;
/** Smart pointer to instance of IMp7JrsFilteringType */
typedef Mp7JrsPtr< IMp7JrsFilteringType > Mp7JrsFilteringPtr;

#define TypeOfFilterSeparableType (Mp7JrsFactory::GetTypeIndex(X("FilterSeparableType")))
#define CreateFilterSeparableType (Mp7JrsFactory::CreateObject(TypeOfFilterSeparableType))
class Mp7JrsFilterSeparableType;
class IMp7JrsFilterSeparableType;
/** Smart pointer to instance of IMp7JrsFilterSeparableType */
typedef Mp7JrsPtr< IMp7JrsFilterSeparableType > Mp7JrsFilterSeparablePtr;

#define TypeOfFilterSeparableType_Filter1D_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FilterSeparableType_Filter1D_CollectionType")))
#define CreateFilterSeparableType_Filter1D_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFilterSeparableType_Filter1D_CollectionType))
class Mp7JrsFilterSeparableType_Filter1D_CollectionType;
class IMp7JrsFilterSeparableType_Filter1D_CollectionType;
/** Smart pointer to instance of IMp7JrsFilterSeparableType_Filter1D_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFilterSeparableType_Filter1D_CollectionType > Mp7JrsFilterSeparableType_Filter1D_CollectionPtr;

#define TypeOfFilterType (Mp7JrsFactory::GetTypeIndex(X("FilterType")))
#define CreateFilterType (Mp7JrsFactory::CreateObject(TypeOfFilterType))
class Mp7JrsFilterType;
class IMp7JrsFilterType;
/** Smart pointer to instance of IMp7JrsFilterType */
typedef Mp7JrsPtr< IMp7JrsFilterType > Mp7JrsFilterPtr;

#define TypeOfFinancialType (Mp7JrsFactory::GetTypeIndex(X("FinancialType")))
#define CreateFinancialType (Mp7JrsFactory::CreateObject(TypeOfFinancialType))
class Mp7JrsFinancialType;
class IMp7JrsFinancialType;
/** Smart pointer to instance of IMp7JrsFinancialType */
typedef Mp7JrsPtr< IMp7JrsFinancialType > Mp7JrsFinancialPtr;

#define TypeOfFinancialType_AccountItem_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FinancialType_AccountItem_CollectionType")))
#define CreateFinancialType_AccountItem_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFinancialType_AccountItem_CollectionType))
class Mp7JrsFinancialType_AccountItem_CollectionType;
class IMp7JrsFinancialType_AccountItem_CollectionType;
/** Smart pointer to instance of IMp7JrsFinancialType_AccountItem_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFinancialType_AccountItem_CollectionType > Mp7JrsFinancialType_AccountItem_CollectionPtr;

#define TypeOfFinancialType_AccountItem_LocalType (Mp7JrsFactory::GetTypeIndex(X("FinancialType_AccountItem_LocalType")))
#define CreateFinancialType_AccountItem_LocalType (Mp7JrsFactory::CreateObject(TypeOfFinancialType_AccountItem_LocalType))
class Mp7JrsFinancialType_AccountItem_LocalType;
class IMp7JrsFinancialType_AccountItem_LocalType;
/** Smart pointer to instance of IMp7JrsFinancialType_AccountItem_LocalType */
typedef Mp7JrsPtr< IMp7JrsFinancialType_AccountItem_LocalType > Mp7JrsFinancialType_AccountItem_LocalPtr;

#define TypeOfFiniteStateModelType (Mp7JrsFactory::GetTypeIndex(X("FiniteStateModelType")))
#define CreateFiniteStateModelType (Mp7JrsFactory::CreateObject(TypeOfFiniteStateModelType))
class Mp7JrsFiniteStateModelType;
class IMp7JrsFiniteStateModelType;
/** Smart pointer to instance of IMp7JrsFiniteStateModelType */
typedef Mp7JrsPtr< IMp7JrsFiniteStateModelType > Mp7JrsFiniteStateModelPtr;

#define TypeOfFloatDiagonalMatrixType (Mp7JrsFactory::GetTypeIndex(X("FloatDiagonalMatrixType")))
#define CreateFloatDiagonalMatrixType (Mp7JrsFactory::CreateObject(TypeOfFloatDiagonalMatrixType))
class Mp7JrsFloatDiagonalMatrixType;
class IMp7JrsFloatDiagonalMatrixType;
/** Smart pointer to instance of IMp7JrsFloatDiagonalMatrixType */
typedef Mp7JrsPtr< IMp7JrsFloatDiagonalMatrixType > Mp7JrsFloatDiagonalMatrixPtr;

#define TypeOfFloatMatrixType (Mp7JrsFactory::GetTypeIndex(X("FloatMatrixType")))
#define CreateFloatMatrixType (Mp7JrsFactory::CreateObject(TypeOfFloatMatrixType))
class Mp7JrsFloatMatrixType;
class IMp7JrsFloatMatrixType;
/** Smart pointer to instance of IMp7JrsFloatMatrixType */
typedef Mp7JrsPtr< IMp7JrsFloatMatrixType > Mp7JrsFloatMatrixPtr;

#define TypeOffloatVector (Mp7JrsFactory::GetTypeIndex(X("floatVector")))
#define CreatefloatVector (Mp7JrsFactory::CreateObject(TypeOffloatVector))
class Mp7JrsfloatVector;
class IMp7JrsfloatVector;
/** Smart pointer to instance of IMp7JrsfloatVector */
typedef Mp7JrsPtr< IMp7JrsfloatVector > Mp7JrsfloatVectorPtr;

#define TypeOfFocusOfExpansionType (Mp7JrsFactory::GetTypeIndex(X("FocusOfExpansionType")))
#define CreateFocusOfExpansionType (Mp7JrsFactory::CreateObject(TypeOfFocusOfExpansionType))
class Mp7JrsFocusOfExpansionType;
class IMp7JrsFocusOfExpansionType;
/** Smart pointer to instance of IMp7JrsFocusOfExpansionType */
typedef Mp7JrsPtr< IMp7JrsFocusOfExpansionType > Mp7JrsFocusOfExpansionPtr;

#define TypeOfFractionalPresenceType (Mp7JrsFactory::GetTypeIndex(X("FractionalPresenceType")))
#define CreateFractionalPresenceType (Mp7JrsFactory::CreateObject(TypeOfFractionalPresenceType))
class Mp7JrsFractionalPresenceType;
class IMp7JrsFractionalPresenceType;
/** Smart pointer to instance of IMp7JrsFractionalPresenceType */
typedef Mp7JrsPtr< IMp7JrsFractionalPresenceType > Mp7JrsFractionalPresencePtr;

#define TypeOfFrequencyTreeType (Mp7JrsFactory::GetTypeIndex(X("FrequencyTreeType")))
#define CreateFrequencyTreeType (Mp7JrsFactory::CreateObject(TypeOfFrequencyTreeType))
class Mp7JrsFrequencyTreeType;
class IMp7JrsFrequencyTreeType;
/** Smart pointer to instance of IMp7JrsFrequencyTreeType */
typedef Mp7JrsPtr< IMp7JrsFrequencyTreeType > Mp7JrsFrequencyTreePtr;

#define TypeOfFrequencyTreeType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("FrequencyTreeType_CollectionType")))
#define CreateFrequencyTreeType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfFrequencyTreeType_CollectionType))
class Mp7JrsFrequencyTreeType_CollectionType;
class IMp7JrsFrequencyTreeType_CollectionType;
/** Smart pointer to instance of IMp7JrsFrequencyTreeType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsFrequencyTreeType_CollectionType > Mp7JrsFrequencyTreeType_CollectionPtr;

#define TypeOfFrequencyTreeType_LocalType (Mp7JrsFactory::GetTypeIndex(X("FrequencyTreeType_LocalType")))
#define CreateFrequencyTreeType_LocalType (Mp7JrsFactory::CreateObject(TypeOfFrequencyTreeType_LocalType))
class Mp7JrsFrequencyTreeType_LocalType;
class IMp7JrsFrequencyTreeType_LocalType;
/** Smart pointer to instance of IMp7JrsFrequencyTreeType_LocalType */
typedef Mp7JrsPtr< IMp7JrsFrequencyTreeType_LocalType > Mp7JrsFrequencyTreeType_LocalPtr;

#define TypeOfFrequencyViewType (Mp7JrsFactory::GetTypeIndex(X("FrequencyViewType")))
#define CreateFrequencyViewType (Mp7JrsFactory::CreateObject(TypeOfFrequencyViewType))
class Mp7JrsFrequencyViewType;
class IMp7JrsFrequencyViewType;
/** Smart pointer to instance of IMp7JrsFrequencyViewType */
typedef Mp7JrsPtr< IMp7JrsFrequencyViewType > Mp7JrsFrequencyViewPtr;

#define TypeOfGammaDistributionType (Mp7JrsFactory::GetTypeIndex(X("GammaDistributionType")))
#define CreateGammaDistributionType (Mp7JrsFactory::CreateObject(TypeOfGammaDistributionType))
class Mp7JrsGammaDistributionType;
class IMp7JrsGammaDistributionType;
/** Smart pointer to instance of IMp7JrsGammaDistributionType */
typedef Mp7JrsPtr< IMp7JrsGammaDistributionType > Mp7JrsGammaDistributionPtr;

#define TypeOfGaussianDistributionType (Mp7JrsFactory::GetTypeIndex(X("GaussianDistributionType")))
#define CreateGaussianDistributionType (Mp7JrsFactory::CreateObject(TypeOfGaussianDistributionType))
class Mp7JrsGaussianDistributionType;
class IMp7JrsGaussianDistributionType;
/** Smart pointer to instance of IMp7JrsGaussianDistributionType */
typedef Mp7JrsPtr< IMp7JrsGaussianDistributionType > Mp7JrsGaussianDistributionPtr;

#define TypeOfGaussianMixtureModelType (Mp7JrsFactory::GetTypeIndex(X("GaussianMixtureModelType")))
#define CreateGaussianMixtureModelType (Mp7JrsFactory::CreateObject(TypeOfGaussianMixtureModelType))
class Mp7JrsGaussianMixtureModelType;
class IMp7JrsGaussianMixtureModelType;
/** Smart pointer to instance of IMp7JrsGaussianMixtureModelType */
typedef Mp7JrsPtr< IMp7JrsGaussianMixtureModelType > Mp7JrsGaussianMixtureModelPtr;

#define TypeOfGaussianMixtureModelType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("GaussianMixtureModelType_CollectionType")))
#define CreateGaussianMixtureModelType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfGaussianMixtureModelType_CollectionType))
class Mp7JrsGaussianMixtureModelType_CollectionType;
class IMp7JrsGaussianMixtureModelType_CollectionType;
/** Smart pointer to instance of IMp7JrsGaussianMixtureModelType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsGaussianMixtureModelType_CollectionType > Mp7JrsGaussianMixtureModelType_CollectionPtr;

#define TypeOfGaussianMixtureModelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("GaussianMixtureModelType_LocalType")))
#define CreateGaussianMixtureModelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfGaussianMixtureModelType_LocalType))
class Mp7JrsGaussianMixtureModelType_LocalType;
class IMp7JrsGaussianMixtureModelType_LocalType;
/** Smart pointer to instance of IMp7JrsGaussianMixtureModelType_LocalType */
typedef Mp7JrsPtr< IMp7JrsGaussianMixtureModelType_LocalType > Mp7JrsGaussianMixtureModelType_LocalPtr;

#define TypeOfGeneralizedGaussianDistributionType (Mp7JrsFactory::GetTypeIndex(X("GeneralizedGaussianDistributionType")))
#define CreateGeneralizedGaussianDistributionType (Mp7JrsFactory::CreateObject(TypeOfGeneralizedGaussianDistributionType))
class Mp7JrsGeneralizedGaussianDistributionType;
class IMp7JrsGeneralizedGaussianDistributionType;
/** Smart pointer to instance of IMp7JrsGeneralizedGaussianDistributionType */
typedef Mp7JrsPtr< IMp7JrsGeneralizedGaussianDistributionType > Mp7JrsGeneralizedGaussianDistributionPtr;

#define TypeOfGeographicPointType (Mp7JrsFactory::GetTypeIndex(X("GeographicPointType")))
#define CreateGeographicPointType (Mp7JrsFactory::CreateObject(TypeOfGeographicPointType))
class Mp7JrsGeographicPointType;
class IMp7JrsGeographicPointType;
/** Smart pointer to instance of IMp7JrsGeographicPointType */
typedef Mp7JrsPtr< IMp7JrsGeographicPointType > Mp7JrsGeographicPointPtr;

#define TypeOfGeographicPointType_latitude_LocalType (Mp7JrsFactory::GetTypeIndex(X("GeographicPointType_latitude_LocalType")))
#define CreateGeographicPointType_latitude_LocalType (Mp7JrsFactory::CreateObject(TypeOfGeographicPointType_latitude_LocalType))
class Mp7JrsGeographicPointType_latitude_LocalType;
class IMp7JrsGeographicPointType_latitude_LocalType;
/** Smart pointer to instance of IMp7JrsGeographicPointType_latitude_LocalType */
typedef Mp7JrsPtr< IMp7JrsGeographicPointType_latitude_LocalType > Mp7JrsGeographicPointType_latitude_LocalPtr;

#define TypeOfGeographicPointType_longitude_LocalType (Mp7JrsFactory::GetTypeIndex(X("GeographicPointType_longitude_LocalType")))
#define CreateGeographicPointType_longitude_LocalType (Mp7JrsFactory::CreateObject(TypeOfGeographicPointType_longitude_LocalType))
class Mp7JrsGeographicPointType_longitude_LocalType;
class IMp7JrsGeographicPointType_longitude_LocalType;
/** Smart pointer to instance of IMp7JrsGeographicPointType_longitude_LocalType */
typedef Mp7JrsPtr< IMp7JrsGeographicPointType_longitude_LocalType > Mp7JrsGeographicPointType_longitude_LocalPtr;

#define TypeOfGeometricDistributionType (Mp7JrsFactory::GetTypeIndex(X("GeometricDistributionType")))
#define CreateGeometricDistributionType (Mp7JrsFactory::CreateObject(TypeOfGeometricDistributionType))
class Mp7JrsGeometricDistributionType;
class IMp7JrsGeometricDistributionType;
/** Smart pointer to instance of IMp7JrsGeometricDistributionType */
typedef Mp7JrsPtr< IMp7JrsGeometricDistributionType > Mp7JrsGeometricDistributionPtr;

#define TypeOfGlobalTransitionType (Mp7JrsFactory::GetTypeIndex(X("GlobalTransitionType")))
#define CreateGlobalTransitionType (Mp7JrsFactory::CreateObject(TypeOfGlobalTransitionType))
class Mp7JrsGlobalTransitionType;
class IMp7JrsGlobalTransitionType;
/** Smart pointer to instance of IMp7JrsGlobalTransitionType */
typedef Mp7JrsPtr< IMp7JrsGlobalTransitionType > Mp7JrsGlobalTransitionPtr;

#define TypeOfGoFGoPColorType (Mp7JrsFactory::GetTypeIndex(X("GoFGoPColorType")))
#define CreateGoFGoPColorType (Mp7JrsFactory::CreateObject(TypeOfGoFGoPColorType))
class Mp7JrsGoFGoPColorType;
class IMp7JrsGoFGoPColorType;
/** Smart pointer to instance of IMp7JrsGoFGoPColorType */
typedef Mp7JrsPtr< IMp7JrsGoFGoPColorType > Mp7JrsGoFGoPColorPtr;

#define TypeOfGoFGoPColorType_aggregation_LocalType (Mp7JrsFactory::GetTypeIndex(X("GoFGoPColorType_aggregation_LocalType")))
#define CreateGoFGoPColorType_aggregation_LocalType (Mp7JrsFactory::CreateObject(TypeOfGoFGoPColorType_aggregation_LocalType))
class Mp7JrsGoFGoPColorType_aggregation_LocalType;
class IMp7JrsGoFGoPColorType_aggregation_LocalType;

#define TypeOfGraphicalClassificationSchemeType (Mp7JrsFactory::GetTypeIndex(X("GraphicalClassificationSchemeType")))
#define CreateGraphicalClassificationSchemeType (Mp7JrsFactory::CreateObject(TypeOfGraphicalClassificationSchemeType))
class Mp7JrsGraphicalClassificationSchemeType;
class IMp7JrsGraphicalClassificationSchemeType;
/** Smart pointer to instance of IMp7JrsGraphicalClassificationSchemeType */
typedef Mp7JrsPtr< IMp7JrsGraphicalClassificationSchemeType > Mp7JrsGraphicalClassificationSchemePtr;

#define TypeOfGraphicalClassificationSchemeType_GraphicalTerm_CollectionType (Mp7JrsFactory::GetTypeIndex(X("GraphicalClassificationSchemeType_GraphicalTerm_CollectionType")))
#define CreateGraphicalClassificationSchemeType_GraphicalTerm_CollectionType (Mp7JrsFactory::CreateObject(TypeOfGraphicalClassificationSchemeType_GraphicalTerm_CollectionType))
class Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType;
class IMp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType;
/** Smart pointer to instance of IMp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType */
typedef Mp7JrsPtr< IMp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType > Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionPtr;

#define TypeOfGraphicalRuleDefinitionType (Mp7JrsFactory::GetTypeIndex(X("GraphicalRuleDefinitionType")))
#define CreateGraphicalRuleDefinitionType (Mp7JrsFactory::CreateObject(TypeOfGraphicalRuleDefinitionType))
class Mp7JrsGraphicalRuleDefinitionType;
class IMp7JrsGraphicalRuleDefinitionType;
/** Smart pointer to instance of IMp7JrsGraphicalRuleDefinitionType */
typedef Mp7JrsPtr< IMp7JrsGraphicalRuleDefinitionType > Mp7JrsGraphicalRuleDefinitionPtr;

#define TypeOfGraphicalTermDefinitionType (Mp7JrsFactory::GetTypeIndex(X("GraphicalTermDefinitionType")))
#define CreateGraphicalTermDefinitionType (Mp7JrsFactory::CreateObject(TypeOfGraphicalTermDefinitionType))
class Mp7JrsGraphicalTermDefinitionType;
class IMp7JrsGraphicalTermDefinitionType;
/** Smart pointer to instance of IMp7JrsGraphicalTermDefinitionType */
typedef Mp7JrsPtr< IMp7JrsGraphicalTermDefinitionType > Mp7JrsGraphicalTermDefinitionPtr;

#define TypeOfGraphType (Mp7JrsFactory::GetTypeIndex(X("GraphType")))
#define CreateGraphType (Mp7JrsFactory::CreateObject(TypeOfGraphType))
class Mp7JrsGraphType;
class IMp7JrsGraphType;
/** Smart pointer to instance of IMp7JrsGraphType */
typedef Mp7JrsPtr< IMp7JrsGraphType > Mp7JrsGraphPtr;

#define TypeOfGraphType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("GraphType_CollectionType")))
#define CreateGraphType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfGraphType_CollectionType))
class Mp7JrsGraphType_CollectionType;
class IMp7JrsGraphType_CollectionType;
/** Smart pointer to instance of IMp7JrsGraphType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsGraphType_CollectionType > Mp7JrsGraphType_CollectionPtr;

#define TypeOfGraphType_LocalType (Mp7JrsFactory::GetTypeIndex(X("GraphType_LocalType")))
#define CreateGraphType_LocalType (Mp7JrsFactory::CreateObject(TypeOfGraphType_LocalType))
class Mp7JrsGraphType_LocalType;
class IMp7JrsGraphType_LocalType;
/** Smart pointer to instance of IMp7JrsGraphType_LocalType */
typedef Mp7JrsPtr< IMp7JrsGraphType_LocalType > Mp7JrsGraphType_LocalPtr;

#define TypeOfGraphType_Node_LocalType (Mp7JrsFactory::GetTypeIndex(X("GraphType_Node_LocalType")))
#define CreateGraphType_Node_LocalType (Mp7JrsFactory::CreateObject(TypeOfGraphType_Node_LocalType))
class Mp7JrsGraphType_Node_LocalType;
class IMp7JrsGraphType_Node_LocalType;
/** Smart pointer to instance of IMp7JrsGraphType_Node_LocalType */
typedef Mp7JrsPtr< IMp7JrsGraphType_Node_LocalType > Mp7JrsGraphType_Node_LocalPtr;

#define TypeOfGridLayoutType (Mp7JrsFactory::GetTypeIndex(X("GridLayoutType")))
#define CreateGridLayoutType (Mp7JrsFactory::CreateObject(TypeOfGridLayoutType))
class Mp7JrsGridLayoutType;
class IMp7JrsGridLayoutType;
/** Smart pointer to instance of IMp7JrsGridLayoutType */
typedef Mp7JrsPtr< IMp7JrsGridLayoutType > Mp7JrsGridLayoutPtr;

#define TypeOfGridLayoutType_Descriptor_CollectionType (Mp7JrsFactory::GetTypeIndex(X("GridLayoutType_Descriptor_CollectionType")))
#define CreateGridLayoutType_Descriptor_CollectionType (Mp7JrsFactory::CreateObject(TypeOfGridLayoutType_Descriptor_CollectionType))
class Mp7JrsGridLayoutType_Descriptor_CollectionType;
class IMp7JrsGridLayoutType_Descriptor_CollectionType;
/** Smart pointer to instance of IMp7JrsGridLayoutType_Descriptor_CollectionType */
typedef Mp7JrsPtr< IMp7JrsGridLayoutType_Descriptor_CollectionType > Mp7JrsGridLayoutType_Descriptor_CollectionPtr;

#define TypeOfGridLayoutType_descriptorMask_LocalType (Mp7JrsFactory::GetTypeIndex(X("GridLayoutType_descriptorMask_LocalType")))
#define CreateGridLayoutType_descriptorMask_LocalType (Mp7JrsFactory::CreateObject(TypeOfGridLayoutType_descriptorMask_LocalType))
class Mp7JrsGridLayoutType_descriptorMask_LocalType;
class IMp7JrsGridLayoutType_descriptorMask_LocalType;
/** Smart pointer to instance of IMp7JrsGridLayoutType_descriptorMask_LocalType */
typedef Mp7JrsPtr< IMp7JrsGridLayoutType_descriptorMask_LocalType > Mp7JrsGridLayoutType_descriptorMask_LocalPtr;

#define TypeOfHandWritingRecogInformationType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogInformationType")))
#define CreateHandWritingRecogInformationType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogInformationType))
class Mp7JrsHandWritingRecogInformationType;
class IMp7JrsHandWritingRecogInformationType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogInformationType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType > Mp7JrsHandWritingRecogInformationPtr;

#define TypeOfHandWritingRecogInformationType_InkLexicon_Entry_CollectionType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogInformationType_InkLexicon_Entry_CollectionType")))
#define CreateHandWritingRecogInformationType_InkLexicon_Entry_CollectionType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogInformationType_InkLexicon_Entry_CollectionType))
class Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType;
class IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType > Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionPtr;

#define TypeOfHandWritingRecogInformationType_InkLexicon_Entry_LocalType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogInformationType_InkLexicon_Entry_LocalType")))
#define CreateHandWritingRecogInformationType_InkLexicon_Entry_LocalType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogInformationType_InkLexicon_Entry_LocalType))
class Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType;
class IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType > Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalPtr;

#define TypeOfHandWritingRecogInformationType_InkLexicon_LocalType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogInformationType_InkLexicon_LocalType")))
#define CreateHandWritingRecogInformationType_InkLexicon_LocalType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogInformationType_InkLexicon_LocalType))
class Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType;
class IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_InkLexicon_LocalType > Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalPtr;

#define TypeOfHandWritingRecogInformationType_Recognizer_LocalType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogInformationType_Recognizer_LocalType")))
#define CreateHandWritingRecogInformationType_Recognizer_LocalType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogInformationType_Recognizer_LocalType))
class Mp7JrsHandWritingRecogInformationType_Recognizer_LocalType;
class IMp7JrsHandWritingRecogInformationType_Recognizer_LocalType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogInformationType_Recognizer_LocalType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType_Recognizer_LocalType > Mp7JrsHandWritingRecogInformationType_Recognizer_LocalPtr;

#define TypeOfHandWritingRecogResultType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogResultType")))
#define CreateHandWritingRecogResultType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogResultType))
class Mp7JrsHandWritingRecogResultType;
class IMp7JrsHandWritingRecogResultType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogResultType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogResultType > Mp7JrsHandWritingRecogResultPtr;

#define TypeOfHandWritingRecogResultType_Result_CollectionType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogResultType_Result_CollectionType")))
#define CreateHandWritingRecogResultType_Result_CollectionType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogResultType_Result_CollectionType))
class Mp7JrsHandWritingRecogResultType_Result_CollectionType;
class IMp7JrsHandWritingRecogResultType_Result_CollectionType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogResultType_Result_CollectionType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogResultType_Result_CollectionType > Mp7JrsHandWritingRecogResultType_Result_CollectionPtr;

#define TypeOfHandWritingRecogResultType_Result_LocalType (Mp7JrsFactory::GetTypeIndex(X("HandWritingRecogResultType_Result_LocalType")))
#define CreateHandWritingRecogResultType_Result_LocalType (Mp7JrsFactory::CreateObject(TypeOfHandWritingRecogResultType_Result_LocalType))
class Mp7JrsHandWritingRecogResultType_Result_LocalType;
class IMp7JrsHandWritingRecogResultType_Result_LocalType;
/** Smart pointer to instance of IMp7JrsHandWritingRecogResultType_Result_LocalType */
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogResultType_Result_LocalType > Mp7JrsHandWritingRecogResultType_Result_LocalPtr;

#define TypeOfHarmonicInstrumentTimbreType (Mp7JrsFactory::GetTypeIndex(X("HarmonicInstrumentTimbreType")))
#define CreateHarmonicInstrumentTimbreType (Mp7JrsFactory::CreateObject(TypeOfHarmonicInstrumentTimbreType))
class Mp7JrsHarmonicInstrumentTimbreType;
class IMp7JrsHarmonicInstrumentTimbreType;
/** Smart pointer to instance of IMp7JrsHarmonicInstrumentTimbreType */
typedef Mp7JrsPtr< IMp7JrsHarmonicInstrumentTimbreType > Mp7JrsHarmonicInstrumentTimbrePtr;

#define TypeOfHarmonicSpectralCentroidType (Mp7JrsFactory::GetTypeIndex(X("HarmonicSpectralCentroidType")))
#define CreateHarmonicSpectralCentroidType (Mp7JrsFactory::CreateObject(TypeOfHarmonicSpectralCentroidType))
class Mp7JrsHarmonicSpectralCentroidType;
class IMp7JrsHarmonicSpectralCentroidType;
/** Smart pointer to instance of IMp7JrsHarmonicSpectralCentroidType */
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralCentroidType > Mp7JrsHarmonicSpectralCentroidPtr;

#define TypeOfHarmonicSpectralDeviationType (Mp7JrsFactory::GetTypeIndex(X("HarmonicSpectralDeviationType")))
#define CreateHarmonicSpectralDeviationType (Mp7JrsFactory::CreateObject(TypeOfHarmonicSpectralDeviationType))
class Mp7JrsHarmonicSpectralDeviationType;
class IMp7JrsHarmonicSpectralDeviationType;
/** Smart pointer to instance of IMp7JrsHarmonicSpectralDeviationType */
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralDeviationType > Mp7JrsHarmonicSpectralDeviationPtr;

#define TypeOfHarmonicSpectralSpreadType (Mp7JrsFactory::GetTypeIndex(X("HarmonicSpectralSpreadType")))
#define CreateHarmonicSpectralSpreadType (Mp7JrsFactory::CreateObject(TypeOfHarmonicSpectralSpreadType))
class Mp7JrsHarmonicSpectralSpreadType;
class IMp7JrsHarmonicSpectralSpreadType;
/** Smart pointer to instance of IMp7JrsHarmonicSpectralSpreadType */
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralSpreadType > Mp7JrsHarmonicSpectralSpreadPtr;

#define TypeOfHarmonicSpectralVariationType (Mp7JrsFactory::GetTypeIndex(X("HarmonicSpectralVariationType")))
#define CreateHarmonicSpectralVariationType (Mp7JrsFactory::CreateObject(TypeOfHarmonicSpectralVariationType))
class Mp7JrsHarmonicSpectralVariationType;
class IMp7JrsHarmonicSpectralVariationType;
/** Smart pointer to instance of IMp7JrsHarmonicSpectralVariationType */
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralVariationType > Mp7JrsHarmonicSpectralVariationPtr;

#define TypeOfHeaderType (Mp7JrsFactory::GetTypeIndex(X("HeaderType")))
#define CreateHeaderType (Mp7JrsFactory::CreateObject(TypeOfHeaderType))
class Mp7JrsHeaderType;
class IMp7JrsHeaderType;
/** Smart pointer to instance of IMp7JrsHeaderType */
typedef Mp7JrsPtr< IMp7JrsHeaderType > Mp7JrsHeaderPtr;

#define TypeOfHierarchicalSummaryType (Mp7JrsFactory::GetTypeIndex(X("HierarchicalSummaryType")))
#define CreateHierarchicalSummaryType (Mp7JrsFactory::CreateObject(TypeOfHierarchicalSummaryType))
class Mp7JrsHierarchicalSummaryType;
class IMp7JrsHierarchicalSummaryType;
/** Smart pointer to instance of IMp7JrsHierarchicalSummaryType */
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType > Mp7JrsHierarchicalSummaryPtr;

#define TypeOfHierarchicalSummaryType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("HierarchicalSummaryType_CollectionType")))
#define CreateHierarchicalSummaryType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfHierarchicalSummaryType_CollectionType))
class Mp7JrsHierarchicalSummaryType_CollectionType;
class IMp7JrsHierarchicalSummaryType_CollectionType;
/** Smart pointer to instance of IMp7JrsHierarchicalSummaryType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType_CollectionType > Mp7JrsHierarchicalSummaryType_CollectionPtr;

#define TypeOfHierarchicalSummaryType_components_CollectionType (Mp7JrsFactory::GetTypeIndex(X("HierarchicalSummaryType_components_CollectionType")))
#define CreateHierarchicalSummaryType_components_CollectionType (Mp7JrsFactory::CreateObject(TypeOfHierarchicalSummaryType_components_CollectionType))
class Mp7JrsHierarchicalSummaryType_components_CollectionType;
class IMp7JrsHierarchicalSummaryType_components_CollectionType;
/** Smart pointer to instance of IMp7JrsHierarchicalSummaryType_components_CollectionType */
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType_components_CollectionType > Mp7JrsHierarchicalSummaryType_components_CollectionPtr;

#define TypeOfHierarchicalSummaryType_components_LocalType (Mp7JrsFactory::GetTypeIndex(X("HierarchicalSummaryType_components_LocalType")))
#define CreateHierarchicalSummaryType_components_LocalType (Mp7JrsFactory::CreateObject(TypeOfHierarchicalSummaryType_components_LocalType))
class Mp7JrsHierarchicalSummaryType_components_LocalType;
class IMp7JrsHierarchicalSummaryType_components_LocalType;

#define TypeOfHierarchicalSummaryType_hierarchy_LocalType (Mp7JrsFactory::GetTypeIndex(X("HierarchicalSummaryType_hierarchy_LocalType")))
#define CreateHierarchicalSummaryType_hierarchy_LocalType (Mp7JrsFactory::CreateObject(TypeOfHierarchicalSummaryType_hierarchy_LocalType))
class Mp7JrsHierarchicalSummaryType_hierarchy_LocalType;
class IMp7JrsHierarchicalSummaryType_hierarchy_LocalType;

#define TypeOfHierarchicalSummaryType_LocalType (Mp7JrsFactory::GetTypeIndex(X("HierarchicalSummaryType_LocalType")))
#define CreateHierarchicalSummaryType_LocalType (Mp7JrsFactory::CreateObject(TypeOfHierarchicalSummaryType_LocalType))
class Mp7JrsHierarchicalSummaryType_LocalType;
class IMp7JrsHierarchicalSummaryType_LocalType;
/** Smart pointer to instance of IMp7JrsHierarchicalSummaryType_LocalType */
typedef Mp7JrsPtr< IMp7JrsHierarchicalSummaryType_LocalType > Mp7JrsHierarchicalSummaryType_LocalPtr;

#define TypeOfHistogramProbabilityType (Mp7JrsFactory::GetTypeIndex(X("HistogramProbabilityType")))
#define CreateHistogramProbabilityType (Mp7JrsFactory::CreateObject(TypeOfHistogramProbabilityType))
class Mp7JrsHistogramProbabilityType;
class IMp7JrsHistogramProbabilityType;
/** Smart pointer to instance of IMp7JrsHistogramProbabilityType */
typedef Mp7JrsPtr< IMp7JrsHistogramProbabilityType > Mp7JrsHistogramProbabilityPtr;

#define TypeOfHomogeneousTextureType (Mp7JrsFactory::GetTypeIndex(X("HomogeneousTextureType")))
#define CreateHomogeneousTextureType (Mp7JrsFactory::CreateObject(TypeOfHomogeneousTextureType))
class Mp7JrsHomogeneousTextureType;
class IMp7JrsHomogeneousTextureType;
/** Smart pointer to instance of IMp7JrsHomogeneousTextureType */
typedef Mp7JrsPtr< IMp7JrsHomogeneousTextureType > Mp7JrsHomogeneousTexturePtr;

#define TypeOfHyperGeometricDistributionType (Mp7JrsFactory::GetTypeIndex(X("HyperGeometricDistributionType")))
#define CreateHyperGeometricDistributionType (Mp7JrsFactory::CreateObject(TypeOfHyperGeometricDistributionType))
class Mp7JrsHyperGeometricDistributionType;
class IMp7JrsHyperGeometricDistributionType;
/** Smart pointer to instance of IMp7JrsHyperGeometricDistributionType */
typedef Mp7JrsPtr< IMp7JrsHyperGeometricDistributionType > Mp7JrsHyperGeometricDistributionPtr;

#define TypeOfImageLocatorType (Mp7JrsFactory::GetTypeIndex(X("ImageLocatorType")))
#define CreateImageLocatorType (Mp7JrsFactory::CreateObject(TypeOfImageLocatorType))
class Mp7JrsImageLocatorType;
class IMp7JrsImageLocatorType;
/** Smart pointer to instance of IMp7JrsImageLocatorType */
typedef Mp7JrsPtr< IMp7JrsImageLocatorType > Mp7JrsImageLocatorPtr;

#define TypeOfImageLocatorType_BytePosition_LocalType (Mp7JrsFactory::GetTypeIndex(X("ImageLocatorType_BytePosition_LocalType")))
#define CreateImageLocatorType_BytePosition_LocalType (Mp7JrsFactory::CreateObject(TypeOfImageLocatorType_BytePosition_LocalType))
class Mp7JrsImageLocatorType_BytePosition_LocalType;
class IMp7JrsImageLocatorType_BytePosition_LocalType;
/** Smart pointer to instance of IMp7JrsImageLocatorType_BytePosition_LocalType */
typedef Mp7JrsPtr< IMp7JrsImageLocatorType_BytePosition_LocalType > Mp7JrsImageLocatorType_BytePosition_LocalPtr;

#define TypeOfImageTextType (Mp7JrsFactory::GetTypeIndex(X("ImageTextType")))
#define CreateImageTextType (Mp7JrsFactory::CreateObject(TypeOfImageTextType))
class Mp7JrsImageTextType;
class IMp7JrsImageTextType;
/** Smart pointer to instance of IMp7JrsImageTextType */
typedef Mp7JrsPtr< IMp7JrsImageTextType > Mp7JrsImageTextPtr;

#define TypeOfImageTextType_textType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ImageTextType_textType_LocalType")))
#define CreateImageTextType_textType_LocalType (Mp7JrsFactory::CreateObject(TypeOfImageTextType_textType_LocalType))
class Mp7JrsImageTextType_textType_LocalType;
class IMp7JrsImageTextType_textType_LocalType;

#define TypeOfImageTextType_textType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("ImageTextType_textType_LocalType0")))
#define CreateImageTextType_textType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfImageTextType_textType_LocalType0))
class Mp7JrsImageTextType_textType_LocalType0;
class IMp7JrsImageTextType_textType_LocalType0;
/** Smart pointer to instance of IMp7JrsImageTextType_textType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsImageTextType_textType_LocalType0 > Mp7JrsImageTextType_textType_Local0Ptr;

#define TypeOfImageTextType_textType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("ImageTextType_textType_LocalType1")))
#define CreateImageTextType_textType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfImageTextType_textType_LocalType1))
class Mp7JrsImageTextType_textType_LocalType1;
class IMp7JrsImageTextType_textType_LocalType1;
/** Smart pointer to instance of IMp7JrsImageTextType_textType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsImageTextType_textType_LocalType1 > Mp7JrsImageTextType_textType_Local1Ptr;

#define TypeOfImageTextType_textType_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("ImageTextType_textType_LocalType2")))
#define CreateImageTextType_textType_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfImageTextType_textType_LocalType2))
class Mp7JrsImageTextType_textType_LocalType2;
class IMp7JrsImageTextType_textType_LocalType2;
/** Smart pointer to instance of IMp7JrsImageTextType_textType_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsImageTextType_textType_LocalType2 > Mp7JrsImageTextType_textType_Local2Ptr;

#define TypeOfImageType (Mp7JrsFactory::GetTypeIndex(X("ImageType")))
#define CreateImageType (Mp7JrsFactory::CreateObject(TypeOfImageType))
class Mp7JrsImageType;
class IMp7JrsImageType;
/** Smart pointer to instance of IMp7JrsImageType */
typedef Mp7JrsPtr< IMp7JrsImageType > Mp7JrsImagePtr;

#define TypeOfIncrDurationType (Mp7JrsFactory::GetTypeIndex(X("IncrDurationType")))
#define CreateIncrDurationType (Mp7JrsFactory::CreateObject(TypeOfIncrDurationType))
class Mp7JrsIncrDurationType;
class IMp7JrsIncrDurationType;
/** Smart pointer to instance of IMp7JrsIncrDurationType */
typedef Mp7JrsPtr< IMp7JrsIncrDurationType > Mp7JrsIncrDurationPtr;

#define TypeOfInkContentType (Mp7JrsFactory::GetTypeIndex(X("InkContentType")))
#define CreateInkContentType (Mp7JrsFactory::CreateObject(TypeOfInkContentType))
class Mp7JrsInkContentType;
class IMp7JrsInkContentType;
/** Smart pointer to instance of IMp7JrsInkContentType */
typedef Mp7JrsPtr< IMp7JrsInkContentType > Mp7JrsInkContentPtr;

#define TypeOfInkMediaInformationType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType")))
#define CreateInkMediaInformationType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType))
class Mp7JrsInkMediaInformationType;
class IMp7JrsInkMediaInformationType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType > Mp7JrsInkMediaInformationPtr;

#define TypeOfInkMediaInformationType_Brush_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Brush_CollectionType")))
#define CreateInkMediaInformationType_Brush_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Brush_CollectionType))
class Mp7JrsInkMediaInformationType_Brush_CollectionType;
class IMp7JrsInkMediaInformationType_Brush_CollectionType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Brush_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Brush_CollectionType > Mp7JrsInkMediaInformationType_Brush_CollectionPtr;

#define TypeOfInkMediaInformationType_Brush_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Brush_LocalType")))
#define CreateInkMediaInformationType_Brush_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Brush_LocalType))
class Mp7JrsInkMediaInformationType_Brush_LocalType;
class IMp7JrsInkMediaInformationType_Brush_LocalType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Brush_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Brush_LocalType > Mp7JrsInkMediaInformationType_Brush_LocalPtr;

#define TypeOfInkMediaInformationType_Handedness_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Handedness_LocalType")))
#define CreateInkMediaInformationType_Handedness_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Handedness_LocalType))
class Mp7JrsInkMediaInformationType_Handedness_LocalType;
class IMp7JrsInkMediaInformationType_Handedness_LocalType;

#define TypeOfInkMediaInformationType_InputDevice_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_InputDevice_LocalType")))
#define CreateInkMediaInformationType_InputDevice_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_InputDevice_LocalType))
class Mp7JrsInkMediaInformationType_InputDevice_LocalType;
class IMp7JrsInkMediaInformationType_InputDevice_LocalType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_InputDevice_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_InputDevice_LocalType > Mp7JrsInkMediaInformationType_InputDevice_LocalPtr;

#define TypeOfInkMediaInformationType_OverlaidMedia_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_OverlaidMedia_CollectionType")))
#define CreateInkMediaInformationType_OverlaidMedia_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_OverlaidMedia_CollectionType))
class Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionType;
class IMp7JrsInkMediaInformationType_OverlaidMedia_CollectionType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_OverlaidMedia_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_OverlaidMedia_CollectionType > Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionPtr;

#define TypeOfInkMediaInformationType_OverlaidMedia_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_OverlaidMedia_LocalType")))
#define CreateInkMediaInformationType_OverlaidMedia_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_OverlaidMedia_LocalType))
class Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType;
class IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_OverlaidMedia_LocalType > Mp7JrsInkMediaInformationType_OverlaidMedia_LocalPtr;

#define TypeOfInkMediaInformationType_Param_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Param_CollectionType")))
#define CreateInkMediaInformationType_Param_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Param_CollectionType))
class Mp7JrsInkMediaInformationType_Param_CollectionType;
class IMp7JrsInkMediaInformationType_Param_CollectionType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Param_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Param_CollectionType > Mp7JrsInkMediaInformationType_Param_CollectionPtr;

#define TypeOfInkMediaInformationType_Param_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Param_LocalType")))
#define CreateInkMediaInformationType_Param_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Param_LocalType))
class Mp7JrsInkMediaInformationType_Param_LocalType;
class IMp7JrsInkMediaInformationType_Param_LocalType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Param_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Param_LocalType > Mp7JrsInkMediaInformationType_Param_LocalPtr;

#define TypeOfInkMediaInformationType_Style_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Style_LocalType")))
#define CreateInkMediaInformationType_Style_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Style_LocalType))
class Mp7JrsInkMediaInformationType_Style_LocalType;
class IMp7JrsInkMediaInformationType_Style_LocalType;

#define TypeOfInkMediaInformationType_Style_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Style_LocalType0")))
#define CreateInkMediaInformationType_Style_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Style_LocalType0))
class Mp7JrsInkMediaInformationType_Style_LocalType0;
class IMp7JrsInkMediaInformationType_Style_LocalType0;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Style_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Style_LocalType0 > Mp7JrsInkMediaInformationType_Style_Local0Ptr;

#define TypeOfInkMediaInformationType_Style_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Style_LocalType1")))
#define CreateInkMediaInformationType_Style_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Style_LocalType1))
class Mp7JrsInkMediaInformationType_Style_LocalType1;
class IMp7JrsInkMediaInformationType_Style_LocalType1;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Style_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Style_LocalType1 > Mp7JrsInkMediaInformationType_Style_Local1Ptr;

#define TypeOfInkMediaInformationType_Style_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_Style_LocalType2")))
#define CreateInkMediaInformationType_Style_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_Style_LocalType2))
class Mp7JrsInkMediaInformationType_Style_LocalType2;
class IMp7JrsInkMediaInformationType_Style_LocalType2;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_Style_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_Style_LocalType2 > Mp7JrsInkMediaInformationType_Style_Local2Ptr;

#define TypeOfInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType")))
#define CreateInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType))
class Mp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType;
class IMp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType > Mp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionPtr;

#define TypeOfInkMediaInformationType_WritingFieldLayout_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkMediaInformationType_WritingFieldLayout_LocalType")))
#define CreateInkMediaInformationType_WritingFieldLayout_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkMediaInformationType_WritingFieldLayout_LocalType))
class Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalType;
class IMp7JrsInkMediaInformationType_WritingFieldLayout_LocalType;
/** Smart pointer to instance of IMp7JrsInkMediaInformationType_WritingFieldLayout_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_WritingFieldLayout_LocalType > Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalPtr;

#define TypeOfInkSegmentSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentSpatialDecompositionType")))
#define CreateInkSegmentSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentSpatialDecompositionType))
class Mp7JrsInkSegmentSpatialDecompositionType;
class IMp7JrsInkSegmentSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsInkSegmentSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentSpatialDecompositionType > Mp7JrsInkSegmentSpatialDecompositionPtr;

#define TypeOfInkSegmentSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentSpatialDecompositionType_CollectionType")))
#define CreateInkSegmentSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentSpatialDecompositionType_CollectionType))
class Mp7JrsInkSegmentSpatialDecompositionType_CollectionType;
class IMp7JrsInkSegmentSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsInkSegmentSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentSpatialDecompositionType_CollectionType > Mp7JrsInkSegmentSpatialDecompositionType_CollectionPtr;

#define TypeOfInkSegmentSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentSpatialDecompositionType_LocalType")))
#define CreateInkSegmentSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentSpatialDecompositionType_LocalType))
class Mp7JrsInkSegmentSpatialDecompositionType_LocalType;
class IMp7JrsInkSegmentSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsInkSegmentSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentSpatialDecompositionType_LocalType > Mp7JrsInkSegmentSpatialDecompositionType_LocalPtr;

#define TypeOfInkSegmentTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentTemporalDecompositionType")))
#define CreateInkSegmentTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentTemporalDecompositionType))
class Mp7JrsInkSegmentTemporalDecompositionType;
class IMp7JrsInkSegmentTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsInkSegmentTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentTemporalDecompositionType > Mp7JrsInkSegmentTemporalDecompositionPtr;

#define TypeOfInkSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentTemporalDecompositionType_CollectionType")))
#define CreateInkSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentTemporalDecompositionType_CollectionType))
class Mp7JrsInkSegmentTemporalDecompositionType_CollectionType;
class IMp7JrsInkSegmentTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsInkSegmentTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentTemporalDecompositionType_CollectionType > Mp7JrsInkSegmentTemporalDecompositionType_CollectionPtr;

#define TypeOfInkSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentTemporalDecompositionType_LocalType")))
#define CreateInkSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentTemporalDecompositionType_LocalType))
class Mp7JrsInkSegmentTemporalDecompositionType_LocalType;
class IMp7JrsInkSegmentTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsInkSegmentTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentTemporalDecompositionType_LocalType > Mp7JrsInkSegmentTemporalDecompositionType_LocalPtr;

#define TypeOfInkSegmentType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType")))
#define CreateInkSegmentType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType))
class Mp7JrsInkSegmentType;
class IMp7JrsInkSegmentType;
/** Smart pointer to instance of IMp7JrsInkSegmentType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType > Mp7JrsInkSegmentPtr;

#define TypeOfInkSegmentType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_CollectionType")))
#define CreateInkSegmentType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_CollectionType))
class Mp7JrsInkSegmentType_CollectionType;
class IMp7JrsInkSegmentType_CollectionType;
/** Smart pointer to instance of IMp7JrsInkSegmentType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_CollectionType > Mp7JrsInkSegmentType_CollectionPtr;

#define TypeOfInkSegmentType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_CollectionType0")))
#define CreateInkSegmentType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_CollectionType0))
class Mp7JrsInkSegmentType_CollectionType0;
class IMp7JrsInkSegmentType_CollectionType0;
/** Smart pointer to instance of IMp7JrsInkSegmentType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_CollectionType0 > Mp7JrsInkSegmentType_Collection0Ptr;

#define TypeOfInkSegmentType_CollectionType1 (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_CollectionType1")))
#define CreateInkSegmentType_CollectionType1 (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_CollectionType1))
class Mp7JrsInkSegmentType_CollectionType1;
class IMp7JrsInkSegmentType_CollectionType1;
/** Smart pointer to instance of IMp7JrsInkSegmentType_CollectionType1 */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_CollectionType1 > Mp7JrsInkSegmentType_Collection1Ptr;

#define TypeOfInkSegmentType_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_LocalType")))
#define CreateInkSegmentType_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_LocalType))
class Mp7JrsInkSegmentType_LocalType;
class IMp7JrsInkSegmentType_LocalType;
/** Smart pointer to instance of IMp7JrsInkSegmentType_LocalType */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_LocalType > Mp7JrsInkSegmentType_LocalPtr;

#define TypeOfInkSegmentType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_LocalType0")))
#define CreateInkSegmentType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_LocalType0))
class Mp7JrsInkSegmentType_LocalType0;
class IMp7JrsInkSegmentType_LocalType0;
/** Smart pointer to instance of IMp7JrsInkSegmentType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_LocalType0 > Mp7JrsInkSegmentType_Local0Ptr;

#define TypeOfInkSegmentType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_LocalType1")))
#define CreateInkSegmentType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_LocalType1))
class Mp7JrsInkSegmentType_LocalType1;
class IMp7JrsInkSegmentType_LocalType1;
/** Smart pointer to instance of IMp7JrsInkSegmentType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_LocalType1 > Mp7JrsInkSegmentType_Local1Ptr;

#define TypeOfInkSegmentType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("InkSegmentType_type_LocalType")))
#define CreateInkSegmentType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfInkSegmentType_type_LocalType))
class Mp7JrsInkSegmentType_type_LocalType;
class IMp7JrsInkSegmentType_type_LocalType;

#define TypeOfInlineMediaType (Mp7JrsFactory::GetTypeIndex(X("InlineMediaType")))
#define CreateInlineMediaType (Mp7JrsFactory::CreateObject(TypeOfInlineMediaType))
class Mp7JrsInlineMediaType;
class IMp7JrsInlineMediaType;
/** Smart pointer to instance of IMp7JrsInlineMediaType */
typedef Mp7JrsPtr< IMp7JrsInlineMediaType > Mp7JrsInlineMediaPtr;

#define TypeOfInlineTermDefinitionType (Mp7JrsFactory::GetTypeIndex(X("InlineTermDefinitionType")))
#define CreateInlineTermDefinitionType (Mp7JrsFactory::CreateObject(TypeOfInlineTermDefinitionType))
class Mp7JrsInlineTermDefinitionType;
class IMp7JrsInlineTermDefinitionType;
/** Smart pointer to instance of IMp7JrsInlineTermDefinitionType */
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType > Mp7JrsInlineTermDefinitionPtr;

#define TypeOfInlineTermDefinitionType_Definition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InlineTermDefinitionType_Definition_CollectionType")))
#define CreateInlineTermDefinitionType_Definition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInlineTermDefinitionType_Definition_CollectionType))
class Mp7JrsInlineTermDefinitionType_Definition_CollectionType;
class IMp7JrsInlineTermDefinitionType_Definition_CollectionType;
/** Smart pointer to instance of IMp7JrsInlineTermDefinitionType_Definition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Definition_CollectionType > Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr;

#define TypeOfInlineTermDefinitionType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InlineTermDefinitionType_Name_CollectionType")))
#define CreateInlineTermDefinitionType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInlineTermDefinitionType_Name_CollectionType))
class Mp7JrsInlineTermDefinitionType_Name_CollectionType;
class IMp7JrsInlineTermDefinitionType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsInlineTermDefinitionType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Name_CollectionType > Mp7JrsInlineTermDefinitionType_Name_CollectionPtr;

#define TypeOfInlineTermDefinitionType_Name_LocalType (Mp7JrsFactory::GetTypeIndex(X("InlineTermDefinitionType_Name_LocalType")))
#define CreateInlineTermDefinitionType_Name_LocalType (Mp7JrsFactory::CreateObject(TypeOfInlineTermDefinitionType_Name_LocalType))
class Mp7JrsInlineTermDefinitionType_Name_LocalType;
class IMp7JrsInlineTermDefinitionType_Name_LocalType;
/** Smart pointer to instance of IMp7JrsInlineTermDefinitionType_Name_LocalType */
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Name_LocalType > Mp7JrsInlineTermDefinitionType_Name_LocalPtr;

#define TypeOfInlineTermDefinitionType_Term_CollectionType (Mp7JrsFactory::GetTypeIndex(X("InlineTermDefinitionType_Term_CollectionType")))
#define CreateInlineTermDefinitionType_Term_CollectionType (Mp7JrsFactory::CreateObject(TypeOfInlineTermDefinitionType_Term_CollectionType))
class Mp7JrsInlineTermDefinitionType_Term_CollectionType;
class IMp7JrsInlineTermDefinitionType_Term_CollectionType;
/** Smart pointer to instance of IMp7JrsInlineTermDefinitionType_Term_CollectionType */
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Term_CollectionType > Mp7JrsInlineTermDefinitionType_Term_CollectionPtr;

#define TypeOfInlineTermDefinitionType_Term_LocalType (Mp7JrsFactory::GetTypeIndex(X("InlineTermDefinitionType_Term_LocalType")))
#define CreateInlineTermDefinitionType_Term_LocalType (Mp7JrsFactory::CreateObject(TypeOfInlineTermDefinitionType_Term_LocalType))
class Mp7JrsInlineTermDefinitionType_Term_LocalType;
class IMp7JrsInlineTermDefinitionType_Term_LocalType;
/** Smart pointer to instance of IMp7JrsInlineTermDefinitionType_Term_LocalType */
typedef Mp7JrsPtr< IMp7JrsInlineTermDefinitionType_Term_LocalType > Mp7JrsInlineTermDefinitionType_Term_LocalPtr;

#define TypeOfInstrumentTimbreType (Mp7JrsFactory::GetTypeIndex(X("InstrumentTimbreType")))
#define CreateInstrumentTimbreType (Mp7JrsFactory::CreateObject(TypeOfInstrumentTimbreType))
class Mp7JrsInstrumentTimbreType;
class IMp7JrsInstrumentTimbreType;
/** Smart pointer to instance of IMp7JrsInstrumentTimbreType */
typedef Mp7JrsPtr< IMp7JrsInstrumentTimbreType > Mp7JrsInstrumentTimbrePtr;

#define TypeOfIntegerDiagonalMatrixType (Mp7JrsFactory::GetTypeIndex(X("IntegerDiagonalMatrixType")))
#define CreateIntegerDiagonalMatrixType (Mp7JrsFactory::CreateObject(TypeOfIntegerDiagonalMatrixType))
class Mp7JrsIntegerDiagonalMatrixType;
class IMp7JrsIntegerDiagonalMatrixType;
/** Smart pointer to instance of IMp7JrsIntegerDiagonalMatrixType */
typedef Mp7JrsPtr< IMp7JrsIntegerDiagonalMatrixType > Mp7JrsIntegerDiagonalMatrixPtr;

#define TypeOfIntegerMatrixType (Mp7JrsFactory::GetTypeIndex(X("IntegerMatrixType")))
#define CreateIntegerMatrixType (Mp7JrsFactory::CreateObject(TypeOfIntegerMatrixType))
class Mp7JrsIntegerMatrixType;
class IMp7JrsIntegerMatrixType;
/** Smart pointer to instance of IMp7JrsIntegerMatrixType */
typedef Mp7JrsPtr< IMp7JrsIntegerMatrixType > Mp7JrsIntegerMatrixPtr;

#define TypeOfintegerVector (Mp7JrsFactory::GetTypeIndex(X("integerVector")))
#define CreateintegerVector (Mp7JrsFactory::CreateObject(TypeOfintegerVector))
class Mp7JrsintegerVector;
class IMp7JrsintegerVector;
/** Smart pointer to instance of IMp7JrsintegerVector */
typedef Mp7JrsPtr< IMp7JrsintegerVector > Mp7JrsintegerVectorPtr;

#define TypeOfInternalTransitionType (Mp7JrsFactory::GetTypeIndex(X("InternalTransitionType")))
#define CreateInternalTransitionType (Mp7JrsFactory::CreateObject(TypeOfInternalTransitionType))
class Mp7JrsInternalTransitionType;
class IMp7JrsInternalTransitionType;
/** Smart pointer to instance of IMp7JrsInternalTransitionType */
typedef Mp7JrsPtr< IMp7JrsInternalTransitionType > Mp7JrsInternalTransitionPtr;

#define TypeOfIntraCompositionShotEditingTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("IntraCompositionShotEditingTemporalDecompositionType")))
#define CreateIntraCompositionShotEditingTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfIntraCompositionShotEditingTemporalDecompositionType))
class Mp7JrsIntraCompositionShotEditingTemporalDecompositionType;
class IMp7JrsIntraCompositionShotEditingTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsIntraCompositionShotEditingTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotEditingTemporalDecompositionType > Mp7JrsIntraCompositionShotEditingTemporalDecompositionPtr;

#define TypeOfIntraCompositionShotEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("IntraCompositionShotEditingTemporalDecompositionType_CollectionType")))
#define CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfIntraCompositionShotEditingTemporalDecompositionType_CollectionType))
class Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
class IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionType > Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr;

#define TypeOfIntraCompositionShotEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("IntraCompositionShotEditingTemporalDecompositionType_LocalType")))
#define CreateIntraCompositionShotEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfIntraCompositionShotEditingTemporalDecompositionType_LocalType))
class Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType;
class IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType > Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr;

#define TypeOfIntraCompositionShotType (Mp7JrsFactory::GetTypeIndex(X("IntraCompositionShotType")))
#define CreateIntraCompositionShotType (Mp7JrsFactory::CreateObject(TypeOfIntraCompositionShotType))
class Mp7JrsIntraCompositionShotType;
class IMp7JrsIntraCompositionShotType;
/** Smart pointer to instance of IMp7JrsIntraCompositionShotType */
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotType > Mp7JrsIntraCompositionShotPtr;

#define TypeOfIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("IntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType")))
#define CreateIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType))
class Mp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType;
class IMp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType > Mp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionPtr;

#define TypeOfIrregularVisualTimeSeriesType (Mp7JrsFactory::GetTypeIndex(X("IrregularVisualTimeSeriesType")))
#define CreateIrregularVisualTimeSeriesType (Mp7JrsFactory::CreateObject(TypeOfIrregularVisualTimeSeriesType))
class Mp7JrsIrregularVisualTimeSeriesType;
class IMp7JrsIrregularVisualTimeSeriesType;
/** Smart pointer to instance of IMp7JrsIrregularVisualTimeSeriesType */
typedef Mp7JrsPtr< IMp7JrsIrregularVisualTimeSeriesType > Mp7JrsIrregularVisualTimeSeriesPtr;

#define TypeOfIrregularVisualTimeSeriesType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("IrregularVisualTimeSeriesType_CollectionType")))
#define CreateIrregularVisualTimeSeriesType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfIrregularVisualTimeSeriesType_CollectionType))
class Mp7JrsIrregularVisualTimeSeriesType_CollectionType;
class IMp7JrsIrregularVisualTimeSeriesType_CollectionType;
/** Smart pointer to instance of IMp7JrsIrregularVisualTimeSeriesType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsIrregularVisualTimeSeriesType_CollectionType > Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr;

#define TypeOfIrregularVisualTimeSeriesType_LocalType (Mp7JrsFactory::GetTypeIndex(X("IrregularVisualTimeSeriesType_LocalType")))
#define CreateIrregularVisualTimeSeriesType_LocalType (Mp7JrsFactory::CreateObject(TypeOfIrregularVisualTimeSeriesType_LocalType))
class Mp7JrsIrregularVisualTimeSeriesType_LocalType;
class IMp7JrsIrregularVisualTimeSeriesType_LocalType;
/** Smart pointer to instance of IMp7JrsIrregularVisualTimeSeriesType_LocalType */
typedef Mp7JrsPtr< IMp7JrsIrregularVisualTimeSeriesType_LocalType > Mp7JrsIrregularVisualTimeSeriesType_LocalPtr;

#define TypeOfKeyType (Mp7JrsFactory::GetTypeIndex(X("KeyType")))
#define CreateKeyType (Mp7JrsFactory::CreateObject(TypeOfKeyType))
class Mp7JrsKeyType;
class IMp7JrsKeyType;
/** Smart pointer to instance of IMp7JrsKeyType */
typedef Mp7JrsPtr< IMp7JrsKeyType > Mp7JrsKeyPtr;

#define TypeOfKeyType_KeyNote_LocalType (Mp7JrsFactory::GetTypeIndex(X("KeyType_KeyNote_LocalType")))
#define CreateKeyType_KeyNote_LocalType (Mp7JrsFactory::CreateObject(TypeOfKeyType_KeyNote_LocalType))
class Mp7JrsKeyType_KeyNote_LocalType;
class IMp7JrsKeyType_KeyNote_LocalType;
/** Smart pointer to instance of IMp7JrsKeyType_KeyNote_LocalType */
typedef Mp7JrsPtr< IMp7JrsKeyType_KeyNote_LocalType > Mp7JrsKeyType_KeyNote_LocalPtr;

#define TypeOfKeywordAnnotationType (Mp7JrsFactory::GetTypeIndex(X("KeywordAnnotationType")))
#define CreateKeywordAnnotationType (Mp7JrsFactory::CreateObject(TypeOfKeywordAnnotationType))
class Mp7JrsKeywordAnnotationType;
class IMp7JrsKeywordAnnotationType;
/** Smart pointer to instance of IMp7JrsKeywordAnnotationType */
typedef Mp7JrsPtr< IMp7JrsKeywordAnnotationType > Mp7JrsKeywordAnnotationPtr;

#define TypeOfKeywordAnnotationType_Keyword_CollectionType (Mp7JrsFactory::GetTypeIndex(X("KeywordAnnotationType_Keyword_CollectionType")))
#define CreateKeywordAnnotationType_Keyword_CollectionType (Mp7JrsFactory::CreateObject(TypeOfKeywordAnnotationType_Keyword_CollectionType))
class Mp7JrsKeywordAnnotationType_Keyword_CollectionType;
class IMp7JrsKeywordAnnotationType_Keyword_CollectionType;
/** Smart pointer to instance of IMp7JrsKeywordAnnotationType_Keyword_CollectionType */
typedef Mp7JrsPtr< IMp7JrsKeywordAnnotationType_Keyword_CollectionType > Mp7JrsKeywordAnnotationType_Keyword_CollectionPtr;

#define TypeOfKeywordAnnotationType_Keyword_LocalType (Mp7JrsFactory::GetTypeIndex(X("KeywordAnnotationType_Keyword_LocalType")))
#define CreateKeywordAnnotationType_Keyword_LocalType (Mp7JrsFactory::CreateObject(TypeOfKeywordAnnotationType_Keyword_LocalType))
class Mp7JrsKeywordAnnotationType_Keyword_LocalType;
class IMp7JrsKeywordAnnotationType_Keyword_LocalType;
/** Smart pointer to instance of IMp7JrsKeywordAnnotationType_Keyword_LocalType */
typedef Mp7JrsPtr< IMp7JrsKeywordAnnotationType_Keyword_LocalType > Mp7JrsKeywordAnnotationType_Keyword_LocalPtr;

#define TypeOfKeywordAnnotationType_Keyword_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("KeywordAnnotationType_Keyword_type_LocalType")))
#define CreateKeywordAnnotationType_Keyword_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfKeywordAnnotationType_Keyword_type_LocalType))
class Mp7JrsKeywordAnnotationType_Keyword_type_LocalType;
class IMp7JrsKeywordAnnotationType_Keyword_type_LocalType;

#define TypeOfLexiconType (Mp7JrsFactory::GetTypeIndex(X("LexiconType")))
#define CreateLexiconType (Mp7JrsFactory::CreateObject(TypeOfLexiconType))
class Mp7JrsLexiconType;
class IMp7JrsLexiconType;
/** Smart pointer to instance of IMp7JrsLexiconType */
typedef Mp7JrsPtr< IMp7JrsLexiconType > Mp7JrsLexiconPtr;

#define TypeOflistOfPositiveIntegerForDim (Mp7JrsFactory::GetTypeIndex(X("listOfPositiveIntegerForDim")))
#define CreatelistOfPositiveIntegerForDim (Mp7JrsFactory::CreateObject(TypeOflistOfPositiveIntegerForDim))
class Mp7JrslistOfPositiveIntegerForDim;
class IMp7JrslistOfPositiveIntegerForDim;
/** Smart pointer to instance of IMp7JrslistOfPositiveIntegerForDim */
typedef Mp7JrsPtr< IMp7JrslistOfPositiveIntegerForDim > Mp7JrslistOfPositiveIntegerForDimPtr;

#define TypeOfLogAttackTimeType (Mp7JrsFactory::GetTypeIndex(X("LogAttackTimeType")))
#define CreateLogAttackTimeType (Mp7JrsFactory::CreateObject(TypeOfLogAttackTimeType))
class Mp7JrsLogAttackTimeType;
class IMp7JrsLogAttackTimeType;
/** Smart pointer to instance of IMp7JrsLogAttackTimeType */
typedef Mp7JrsPtr< IMp7JrsLogAttackTimeType > Mp7JrsLogAttackTimePtr;

#define TypeOfLognormalDistributionType (Mp7JrsFactory::GetTypeIndex(X("LognormalDistributionType")))
#define CreateLognormalDistributionType (Mp7JrsFactory::CreateObject(TypeOfLognormalDistributionType))
class Mp7JrsLognormalDistributionType;
class IMp7JrsLognormalDistributionType;
/** Smart pointer to instance of IMp7JrsLognormalDistributionType */
typedef Mp7JrsPtr< IMp7JrsLognormalDistributionType > Mp7JrsLognormalDistributionPtr;

#define TypeOfMaskType (Mp7JrsFactory::GetTypeIndex(X("MaskType")))
#define CreateMaskType (Mp7JrsFactory::CreateObject(TypeOfMaskType))
class Mp7JrsMaskType;
class IMp7JrsMaskType;
/** Smart pointer to instance of IMp7JrsMaskType */
typedef Mp7JrsPtr< IMp7JrsMaskType > Mp7JrsMaskPtr;

#define TypeOfMatchingHintType (Mp7JrsFactory::GetTypeIndex(X("MatchingHintType")))
#define CreateMatchingHintType (Mp7JrsFactory::CreateObject(TypeOfMatchingHintType))
class Mp7JrsMatchingHintType;
class IMp7JrsMatchingHintType;
/** Smart pointer to instance of IMp7JrsMatchingHintType */
typedef Mp7JrsPtr< IMp7JrsMatchingHintType > Mp7JrsMatchingHintPtr;

#define TypeOfMatchingHintType_Hint_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MatchingHintType_Hint_CollectionType")))
#define CreateMatchingHintType_Hint_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMatchingHintType_Hint_CollectionType))
class Mp7JrsMatchingHintType_Hint_CollectionType;
class IMp7JrsMatchingHintType_Hint_CollectionType;
/** Smart pointer to instance of IMp7JrsMatchingHintType_Hint_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMatchingHintType_Hint_CollectionType > Mp7JrsMatchingHintType_Hint_CollectionPtr;

#define TypeOfMatchingHintType_Hint_LocalType (Mp7JrsFactory::GetTypeIndex(X("MatchingHintType_Hint_LocalType")))
#define CreateMatchingHintType_Hint_LocalType (Mp7JrsFactory::CreateObject(TypeOfMatchingHintType_Hint_LocalType))
class Mp7JrsMatchingHintType_Hint_LocalType;
class IMp7JrsMatchingHintType_Hint_LocalType;
/** Smart pointer to instance of IMp7JrsMatchingHintType_Hint_LocalType */
typedef Mp7JrsPtr< IMp7JrsMatchingHintType_Hint_LocalType > Mp7JrsMatchingHintType_Hint_LocalPtr;

#define TypeOfMediaAgentType (Mp7JrsFactory::GetTypeIndex(X("MediaAgentType")))
#define CreateMediaAgentType (Mp7JrsFactory::CreateObject(TypeOfMediaAgentType))
class Mp7JrsMediaAgentType;
class IMp7JrsMediaAgentType;
/** Smart pointer to instance of IMp7JrsMediaAgentType */
typedef Mp7JrsPtr< IMp7JrsMediaAgentType > Mp7JrsMediaAgentPtr;

#define TypeOfMediaDescriptionType (Mp7JrsFactory::GetTypeIndex(X("MediaDescriptionType")))
#define CreateMediaDescriptionType (Mp7JrsFactory::CreateObject(TypeOfMediaDescriptionType))
class Mp7JrsMediaDescriptionType;
class IMp7JrsMediaDescriptionType;
/** Smart pointer to instance of IMp7JrsMediaDescriptionType */
typedef Mp7JrsPtr< IMp7JrsMediaDescriptionType > Mp7JrsMediaDescriptionPtr;

#define TypeOfMediaDescriptionType_MediaInformation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaDescriptionType_MediaInformation_CollectionType")))
#define CreateMediaDescriptionType_MediaInformation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaDescriptionType_MediaInformation_CollectionType))
class Mp7JrsMediaDescriptionType_MediaInformation_CollectionType;
class IMp7JrsMediaDescriptionType_MediaInformation_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaDescriptionType_MediaInformation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaDescriptionType_MediaInformation_CollectionType > Mp7JrsMediaDescriptionType_MediaInformation_CollectionPtr;

#define TypeOfmediaDurationType (Mp7JrsFactory::GetTypeIndex(X("mediaDurationType")))
#define CreatemediaDurationType (Mp7JrsFactory::CreateObject(TypeOfmediaDurationType))
class Mp7JrsmediaDurationType;
class IMp7JrsmediaDurationType;
/** Smart pointer to instance of IMp7JrsmediaDurationType */
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;

#define TypeOfMediaFormatType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType")))
#define CreateMediaFormatType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType))
class Mp7JrsMediaFormatType;
class IMp7JrsMediaFormatType;
/** Smart pointer to instance of IMp7JrsMediaFormatType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType > Mp7JrsMediaFormatPtr;

#define TypeOfMediaFormatType_AudioCoding_AudioChannels_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_AudioChannels_LocalType")))
#define CreateMediaFormatType_AudioCoding_AudioChannels_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_AudioChannels_LocalType))
class Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType;
class IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType > Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr;

#define TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_Emphasis_LocalType")))
#define CreateMediaFormatType_AudioCoding_Emphasis_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType))
class Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType;
class IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType;

#define TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_Emphasis_LocalType0")))
#define CreateMediaFormatType_AudioCoding_Emphasis_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType0))
class Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType0;
class IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType0;
/** Smart pointer to instance of IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType0 > Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local0Ptr;

#define TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_Emphasis_LocalType1")))
#define CreateMediaFormatType_AudioCoding_Emphasis_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType1))
class Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType1;
class IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType1;
/** Smart pointer to instance of IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType1 > Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local1Ptr;

#define TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_Emphasis_LocalType2")))
#define CreateMediaFormatType_AudioCoding_Emphasis_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_Emphasis_LocalType2))
class Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2;
class IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2;
/** Smart pointer to instance of IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2 > Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr;

#define TypeOfMediaFormatType_AudioCoding_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_LocalType")))
#define CreateMediaFormatType_AudioCoding_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_LocalType))
class Mp7JrsMediaFormatType_AudioCoding_LocalType;
class IMp7JrsMediaFormatType_AudioCoding_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_AudioCoding_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_LocalType > Mp7JrsMediaFormatType_AudioCoding_LocalPtr;

#define TypeOfMediaFormatType_AudioCoding_Sample_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_AudioCoding_Sample_LocalType")))
#define CreateMediaFormatType_AudioCoding_Sample_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_AudioCoding_Sample_LocalType))
class Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType;
class IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType > Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr;

#define TypeOfMediaFormatType_BitRate_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_BitRate_LocalType")))
#define CreateMediaFormatType_BitRate_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_BitRate_LocalType))
class Mp7JrsMediaFormatType_BitRate_LocalType;
class IMp7JrsMediaFormatType_BitRate_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_BitRate_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_BitRate_LocalType > Mp7JrsMediaFormatType_BitRate_LocalPtr;

#define TypeOfMediaFormatType_ScalableCoding_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_ScalableCoding_LocalType")))
#define CreateMediaFormatType_ScalableCoding_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_ScalableCoding_LocalType))
class Mp7JrsMediaFormatType_ScalableCoding_LocalType;
class IMp7JrsMediaFormatType_ScalableCoding_LocalType;

#define TypeOfMediaFormatType_ScalableCoding_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_ScalableCoding_LocalType0")))
#define CreateMediaFormatType_ScalableCoding_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_ScalableCoding_LocalType0))
class Mp7JrsMediaFormatType_ScalableCoding_LocalType0;
class IMp7JrsMediaFormatType_ScalableCoding_LocalType0;
/** Smart pointer to instance of IMp7JrsMediaFormatType_ScalableCoding_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_ScalableCoding_LocalType0 > Mp7JrsMediaFormatType_ScalableCoding_Local0Ptr;

#define TypeOfMediaFormatType_ScalableCoding_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_ScalableCoding_LocalType1")))
#define CreateMediaFormatType_ScalableCoding_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_ScalableCoding_LocalType1))
class Mp7JrsMediaFormatType_ScalableCoding_LocalType1;
class IMp7JrsMediaFormatType_ScalableCoding_LocalType1;
/** Smart pointer to instance of IMp7JrsMediaFormatType_ScalableCoding_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_ScalableCoding_LocalType1 > Mp7JrsMediaFormatType_ScalableCoding_Local1Ptr;

#define TypeOfMediaFormatType_ScalableCoding_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_ScalableCoding_LocalType2")))
#define CreateMediaFormatType_ScalableCoding_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_ScalableCoding_LocalType2))
class Mp7JrsMediaFormatType_ScalableCoding_LocalType2;
class IMp7JrsMediaFormatType_ScalableCoding_LocalType2;
/** Smart pointer to instance of IMp7JrsMediaFormatType_ScalableCoding_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_ScalableCoding_LocalType2 > Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr;

#define TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Format_colorDomain_LocalType")))
#define CreateMediaFormatType_VisualCoding_Format_colorDomain_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType))
class Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType;

#define TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Format_colorDomain_LocalType0")))
#define CreateMediaFormatType_VisualCoding_Format_colorDomain_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType0))
class Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType0;
class IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType0;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType0 > Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local0Ptr;

#define TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Format_colorDomain_LocalType1")))
#define CreateMediaFormatType_VisualCoding_Format_colorDomain_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType1))
class Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType1;
class IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType1;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType1 > Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local1Ptr;

#define TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Format_colorDomain_LocalType2")))
#define CreateMediaFormatType_VisualCoding_Format_colorDomain_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Format_colorDomain_LocalType2))
class Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2;
class IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2 > Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_Local2Ptr;

#define TypeOfMediaFormatType_VisualCoding_Format_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Format_LocalType")))
#define CreateMediaFormatType_VisualCoding_Format_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Format_LocalType))
class Mp7JrsMediaFormatType_VisualCoding_Format_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Format_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_Format_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Format_LocalType > Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr;

#define TypeOfMediaFormatType_VisualCoding_Frame_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Frame_LocalType")))
#define CreateMediaFormatType_VisualCoding_Frame_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Frame_LocalType))
class Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType > Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr;

#define TypeOfMediaFormatType_VisualCoding_Frame_structure_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Frame_structure_LocalType")))
#define CreateMediaFormatType_VisualCoding_Frame_structure_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Frame_structure_LocalType))
class Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType;

#define TypeOfMediaFormatType_VisualCoding_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_LocalType")))
#define CreateMediaFormatType_VisualCoding_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_LocalType))
class Mp7JrsMediaFormatType_VisualCoding_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_LocalType > Mp7JrsMediaFormatType_VisualCoding_LocalPtr;

#define TypeOfMediaFormatType_VisualCoding_Pixel_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaFormatType_VisualCoding_Pixel_LocalType")))
#define CreateMediaFormatType_VisualCoding_Pixel_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaFormatType_VisualCoding_Pixel_LocalType))
class Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalType;
class IMp7JrsMediaFormatType_VisualCoding_Pixel_LocalType;
/** Smart pointer to instance of IMp7JrsMediaFormatType_VisualCoding_Pixel_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Pixel_LocalType > Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr;

#define TypeOfMediaIdentificationType (Mp7JrsFactory::GetTypeIndex(X("MediaIdentificationType")))
#define CreateMediaIdentificationType (Mp7JrsFactory::CreateObject(TypeOfMediaIdentificationType))
class Mp7JrsMediaIdentificationType;
class IMp7JrsMediaIdentificationType;
/** Smart pointer to instance of IMp7JrsMediaIdentificationType */
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType > Mp7JrsMediaIdentificationPtr;

#define TypeOfMediaIdentificationType_AudioDomain_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaIdentificationType_AudioDomain_CollectionType")))
#define CreateMediaIdentificationType_AudioDomain_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaIdentificationType_AudioDomain_CollectionType))
class Mp7JrsMediaIdentificationType_AudioDomain_CollectionType;
class IMp7JrsMediaIdentificationType_AudioDomain_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaIdentificationType_AudioDomain_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType_AudioDomain_CollectionType > Mp7JrsMediaIdentificationType_AudioDomain_CollectionPtr;

#define TypeOfMediaIdentificationType_ImageDomain_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaIdentificationType_ImageDomain_CollectionType")))
#define CreateMediaIdentificationType_ImageDomain_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaIdentificationType_ImageDomain_CollectionType))
class Mp7JrsMediaIdentificationType_ImageDomain_CollectionType;
class IMp7JrsMediaIdentificationType_ImageDomain_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaIdentificationType_ImageDomain_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType_ImageDomain_CollectionType > Mp7JrsMediaIdentificationType_ImageDomain_CollectionPtr;

#define TypeOfMediaIdentificationType_VideoDomain_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaIdentificationType_VideoDomain_CollectionType")))
#define CreateMediaIdentificationType_VideoDomain_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaIdentificationType_VideoDomain_CollectionType))
class Mp7JrsMediaIdentificationType_VideoDomain_CollectionType;
class IMp7JrsMediaIdentificationType_VideoDomain_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaIdentificationType_VideoDomain_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaIdentificationType_VideoDomain_CollectionType > Mp7JrsMediaIdentificationType_VideoDomain_CollectionPtr;

#define TypeOfMediaIncrDurationType (Mp7JrsFactory::GetTypeIndex(X("MediaIncrDurationType")))
#define CreateMediaIncrDurationType (Mp7JrsFactory::CreateObject(TypeOfMediaIncrDurationType))
class Mp7JrsMediaIncrDurationType;
class IMp7JrsMediaIncrDurationType;
/** Smart pointer to instance of IMp7JrsMediaIncrDurationType */
typedef Mp7JrsPtr< IMp7JrsMediaIncrDurationType > Mp7JrsMediaIncrDurationPtr;

#define TypeOfMediaInformationType (Mp7JrsFactory::GetTypeIndex(X("MediaInformationType")))
#define CreateMediaInformationType (Mp7JrsFactory::CreateObject(TypeOfMediaInformationType))
class Mp7JrsMediaInformationType;
class IMp7JrsMediaInformationType;
/** Smart pointer to instance of IMp7JrsMediaInformationType */
typedef Mp7JrsPtr< IMp7JrsMediaInformationType > Mp7JrsMediaInformationPtr;

#define TypeOfMediaInformationType_MediaProfile_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaInformationType_MediaProfile_CollectionType")))
#define CreateMediaInformationType_MediaProfile_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaInformationType_MediaProfile_CollectionType))
class Mp7JrsMediaInformationType_MediaProfile_CollectionType;
class IMp7JrsMediaInformationType_MediaProfile_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaInformationType_MediaProfile_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaInformationType_MediaProfile_CollectionType > Mp7JrsMediaInformationType_MediaProfile_CollectionPtr;

#define TypeOfMediaInstanceType (Mp7JrsFactory::GetTypeIndex(X("MediaInstanceType")))
#define CreateMediaInstanceType (Mp7JrsFactory::CreateObject(TypeOfMediaInstanceType))
class Mp7JrsMediaInstanceType;
class IMp7JrsMediaInstanceType;
/** Smart pointer to instance of IMp7JrsMediaInstanceType */
typedef Mp7JrsPtr< IMp7JrsMediaInstanceType > Mp7JrsMediaInstancePtr;

#define TypeOfMediaLocatorType (Mp7JrsFactory::GetTypeIndex(X("MediaLocatorType")))
#define CreateMediaLocatorType (Mp7JrsFactory::CreateObject(TypeOfMediaLocatorType))
class Mp7JrsMediaLocatorType;
class IMp7JrsMediaLocatorType;
/** Smart pointer to instance of IMp7JrsMediaLocatorType */
typedef Mp7JrsPtr< IMp7JrsMediaLocatorType > Mp7JrsMediaLocatorPtr;

#define TypeOfMediaProfileType (Mp7JrsFactory::GetTypeIndex(X("MediaProfileType")))
#define CreateMediaProfileType (Mp7JrsFactory::CreateObject(TypeOfMediaProfileType))
class Mp7JrsMediaProfileType;
class IMp7JrsMediaProfileType;
/** Smart pointer to instance of IMp7JrsMediaProfileType */
typedef Mp7JrsPtr< IMp7JrsMediaProfileType > Mp7JrsMediaProfilePtr;

#define TypeOfMediaProfileType_ComponentMediaProfile_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaProfileType_ComponentMediaProfile_CollectionType")))
#define CreateMediaProfileType_ComponentMediaProfile_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaProfileType_ComponentMediaProfile_CollectionType))
class Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionType;
class IMp7JrsMediaProfileType_ComponentMediaProfile_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaProfileType_ComponentMediaProfile_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaProfileType_ComponentMediaProfile_CollectionType > Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionPtr;

#define TypeOfMediaProfileType_MediaInstance_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaProfileType_MediaInstance_CollectionType")))
#define CreateMediaProfileType_MediaInstance_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaProfileType_MediaInstance_CollectionType))
class Mp7JrsMediaProfileType_MediaInstance_CollectionType;
class IMp7JrsMediaProfileType_MediaInstance_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaProfileType_MediaInstance_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaProfileType_MediaInstance_CollectionType > Mp7JrsMediaProfileType_MediaInstance_CollectionPtr;

#define TypeOfMediaQualityType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType")))
#define CreateMediaQualityType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType))
class Mp7JrsMediaQualityType;
class IMp7JrsMediaQualityType;
/** Smart pointer to instance of IMp7JrsMediaQualityType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType > Mp7JrsMediaQualityPtr;

#define TypeOfMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_PerceptibleDefects_AudioDefects_CollectionType")))
#define CreateMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType))
class Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType;
class IMp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType > Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionPtr;

#define TypeOfMediaQualityType_PerceptibleDefects_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_PerceptibleDefects_LocalType")))
#define CreateMediaQualityType_PerceptibleDefects_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_PerceptibleDefects_LocalType))
class Mp7JrsMediaQualityType_PerceptibleDefects_LocalType;
class IMp7JrsMediaQualityType_PerceptibleDefects_LocalType;
/** Smart pointer to instance of IMp7JrsMediaQualityType_PerceptibleDefects_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_LocalType > Mp7JrsMediaQualityType_PerceptibleDefects_LocalPtr;

#define TypeOfMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_PerceptibleDefects_VisualDefects_CollectionType")))
#define CreateMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType))
class Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType;
class IMp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType > Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionPtr;

#define TypeOfMediaQualityType_QualityRating_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_QualityRating_CollectionType")))
#define CreateMediaQualityType_QualityRating_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_QualityRating_CollectionType))
class Mp7JrsMediaQualityType_QualityRating_CollectionType;
class IMp7JrsMediaQualityType_QualityRating_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaQualityType_QualityRating_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_QualityRating_CollectionType > Mp7JrsMediaQualityType_QualityRating_CollectionPtr;

#define TypeOfMediaQualityType_QualityRating_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_QualityRating_LocalType")))
#define CreateMediaQualityType_QualityRating_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_QualityRating_LocalType))
class Mp7JrsMediaQualityType_QualityRating_LocalType;
class IMp7JrsMediaQualityType_QualityRating_LocalType;
/** Smart pointer to instance of IMp7JrsMediaQualityType_QualityRating_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_QualityRating_LocalType > Mp7JrsMediaQualityType_QualityRating_LocalPtr;

#define TypeOfMediaQualityType_QualityRating_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_QualityRating_type_LocalType")))
#define CreateMediaQualityType_QualityRating_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_QualityRating_type_LocalType))
class Mp7JrsMediaQualityType_QualityRating_type_LocalType;
class IMp7JrsMediaQualityType_QualityRating_type_LocalType;

#define TypeOfMediaQualityType_RatingInformationLocator_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaQualityType_RatingInformationLocator_CollectionType")))
#define CreateMediaQualityType_RatingInformationLocator_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaQualityType_RatingInformationLocator_CollectionType))
class Mp7JrsMediaQualityType_RatingInformationLocator_CollectionType;
class IMp7JrsMediaQualityType_RatingInformationLocator_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaQualityType_RatingInformationLocator_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaQualityType_RatingInformationLocator_CollectionType > Mp7JrsMediaQualityType_RatingInformationLocator_CollectionPtr;

#define TypeOfMediaRelIncrTimePointType (Mp7JrsFactory::GetTypeIndex(X("MediaRelIncrTimePointType")))
#define CreateMediaRelIncrTimePointType (Mp7JrsFactory::CreateObject(TypeOfMediaRelIncrTimePointType))
class Mp7JrsMediaRelIncrTimePointType;
class IMp7JrsMediaRelIncrTimePointType;
/** Smart pointer to instance of IMp7JrsMediaRelIncrTimePointType */
typedef Mp7JrsPtr< IMp7JrsMediaRelIncrTimePointType > Mp7JrsMediaRelIncrTimePointPtr;

#define TypeOfMediaRelTimePointType (Mp7JrsFactory::GetTypeIndex(X("MediaRelTimePointType")))
#define CreateMediaRelTimePointType (Mp7JrsFactory::CreateObject(TypeOfMediaRelTimePointType))
class Mp7JrsMediaRelTimePointType;
class IMp7JrsMediaRelTimePointType;
/** Smart pointer to instance of IMp7JrsMediaRelTimePointType */
typedef Mp7JrsPtr< IMp7JrsMediaRelTimePointType > Mp7JrsMediaRelTimePointPtr;

#define TypeOfMediaReviewType (Mp7JrsFactory::GetTypeIndex(X("MediaReviewType")))
#define CreateMediaReviewType (Mp7JrsFactory::CreateObject(TypeOfMediaReviewType))
class Mp7JrsMediaReviewType;
class IMp7JrsMediaReviewType;
/** Smart pointer to instance of IMp7JrsMediaReviewType */
typedef Mp7JrsPtr< IMp7JrsMediaReviewType > Mp7JrsMediaReviewPtr;

#define TypeOfMediaReviewType_FreeTextReview_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaReviewType_FreeTextReview_CollectionType")))
#define CreateMediaReviewType_FreeTextReview_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaReviewType_FreeTextReview_CollectionType))
class Mp7JrsMediaReviewType_FreeTextReview_CollectionType;
class IMp7JrsMediaReviewType_FreeTextReview_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaReviewType_FreeTextReview_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaReviewType_FreeTextReview_CollectionType > Mp7JrsMediaReviewType_FreeTextReview_CollectionPtr;

#define TypeOfMediaSourceSegmentDecompositionType (Mp7JrsFactory::GetTypeIndex(X("MediaSourceSegmentDecompositionType")))
#define CreateMediaSourceSegmentDecompositionType (Mp7JrsFactory::CreateObject(TypeOfMediaSourceSegmentDecompositionType))
class Mp7JrsMediaSourceSegmentDecompositionType;
class IMp7JrsMediaSourceSegmentDecompositionType;
/** Smart pointer to instance of IMp7JrsMediaSourceSegmentDecompositionType */
typedef Mp7JrsPtr< IMp7JrsMediaSourceSegmentDecompositionType > Mp7JrsMediaSourceSegmentDecompositionPtr;

#define TypeOfMediaSpaceMaskType (Mp7JrsFactory::GetTypeIndex(X("MediaSpaceMaskType")))
#define CreateMediaSpaceMaskType (Mp7JrsFactory::CreateObject(TypeOfMediaSpaceMaskType))
class Mp7JrsMediaSpaceMaskType;
class IMp7JrsMediaSpaceMaskType;
/** Smart pointer to instance of IMp7JrsMediaSpaceMaskType */
typedef Mp7JrsPtr< IMp7JrsMediaSpaceMaskType > Mp7JrsMediaSpaceMaskPtr;

#define TypeOfMediaSpaceMaskType_SubInterval_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MediaSpaceMaskType_SubInterval_CollectionType")))
#define CreateMediaSpaceMaskType_SubInterval_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMediaSpaceMaskType_SubInterval_CollectionType))
class Mp7JrsMediaSpaceMaskType_SubInterval_CollectionType;
class IMp7JrsMediaSpaceMaskType_SubInterval_CollectionType;
/** Smart pointer to instance of IMp7JrsMediaSpaceMaskType_SubInterval_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMediaSpaceMaskType_SubInterval_CollectionType > Mp7JrsMediaSpaceMaskType_SubInterval_CollectionPtr;

#define TypeOfMediaSpaceMaskType_SubInterval_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaSpaceMaskType_SubInterval_LocalType")))
#define CreateMediaSpaceMaskType_SubInterval_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaSpaceMaskType_SubInterval_LocalType))
class Mp7JrsMediaSpaceMaskType_SubInterval_LocalType;
class IMp7JrsMediaSpaceMaskType_SubInterval_LocalType;
/** Smart pointer to instance of IMp7JrsMediaSpaceMaskType_SubInterval_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaSpaceMaskType_SubInterval_LocalType > Mp7JrsMediaSpaceMaskType_SubInterval_LocalPtr;

#define TypeOfmediaTimeOffsetType (Mp7JrsFactory::GetTypeIndex(X("mediaTimeOffsetType")))
#define CreatemediaTimeOffsetType (Mp7JrsFactory::CreateObject(TypeOfmediaTimeOffsetType))
class Mp7JrsmediaTimeOffsetType;
class IMp7JrsmediaTimeOffsetType;
/** Smart pointer to instance of IMp7JrsmediaTimeOffsetType */
typedef Mp7JrsPtr< IMp7JrsmediaTimeOffsetType > Mp7JrsmediaTimeOffsetPtr;

#define TypeOfmediaTimePointType (Mp7JrsFactory::GetTypeIndex(X("mediaTimePointType")))
#define CreatemediaTimePointType (Mp7JrsFactory::CreateObject(TypeOfmediaTimePointType))
class Mp7JrsmediaTimePointType;
class IMp7JrsmediaTimePointType;
/** Smart pointer to instance of IMp7JrsmediaTimePointType */
typedef Mp7JrsPtr< IMp7JrsmediaTimePointType > Mp7JrsmediaTimePointPtr;

#define TypeOfMediaTimeType (Mp7JrsFactory::GetTypeIndex(X("MediaTimeType")))
#define CreateMediaTimeType (Mp7JrsFactory::CreateObject(TypeOfMediaTimeType))
class Mp7JrsMediaTimeType;
class IMp7JrsMediaTimeType;
/** Smart pointer to instance of IMp7JrsMediaTimeType */
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;

#define TypeOfMediaTranscodingHintsType (Mp7JrsFactory::GetTypeIndex(X("MediaTranscodingHintsType")))
#define CreateMediaTranscodingHintsType (Mp7JrsFactory::CreateObject(TypeOfMediaTranscodingHintsType))
class Mp7JrsMediaTranscodingHintsType;
class IMp7JrsMediaTranscodingHintsType;
/** Smart pointer to instance of IMp7JrsMediaTranscodingHintsType */
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType > Mp7JrsMediaTranscodingHintsPtr;

#define TypeOfMediaTranscodingHintsType_CodingHints_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaTranscodingHintsType_CodingHints_LocalType")))
#define CreateMediaTranscodingHintsType_CodingHints_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaTranscodingHintsType_CodingHints_LocalType))
class Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType;
class IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType;
/** Smart pointer to instance of IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType > Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr;

#define TypeOfMediaTranscodingHintsType_MotionHint_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaTranscodingHintsType_MotionHint_LocalType")))
#define CreateMediaTranscodingHintsType_MotionHint_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaTranscodingHintsType_MotionHint_LocalType))
class Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType;
class IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType;
/** Smart pointer to instance of IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_MotionHint_LocalType > Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr;

#define TypeOfMediaTranscodingHintsType_MotionHint_MotionRange_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaTranscodingHintsType_MotionHint_MotionRange_LocalType")))
#define CreateMediaTranscodingHintsType_MotionHint_MotionRange_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaTranscodingHintsType_MotionHint_MotionRange_LocalType))
class Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType;
class IMp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType;
/** Smart pointer to instance of IMp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType > Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalPtr;

#define TypeOfMediaTranscodingHintsType_ShapeHint_LocalType (Mp7JrsFactory::GetTypeIndex(X("MediaTranscodingHintsType_ShapeHint_LocalType")))
#define CreateMediaTranscodingHintsType_ShapeHint_LocalType (Mp7JrsFactory::CreateObject(TypeOfMediaTranscodingHintsType_ShapeHint_LocalType))
class Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType;
class IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType;
/** Smart pointer to instance of IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType */
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType > Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr;

#define TypeOfMelodyContourType (Mp7JrsFactory::GetTypeIndex(X("MelodyContourType")))
#define CreateMelodyContourType (Mp7JrsFactory::CreateObject(TypeOfMelodyContourType))
class Mp7JrsMelodyContourType;
class IMp7JrsMelodyContourType;
/** Smart pointer to instance of IMp7JrsMelodyContourType */
typedef Mp7JrsPtr< IMp7JrsMelodyContourType > Mp7JrsMelodyContourPtr;

#define TypeOfMelodySequenceType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType")))
#define CreateMelodySequenceType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType))
class Mp7JrsMelodySequenceType;
class IMp7JrsMelodySequenceType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType > Mp7JrsMelodySequencePtr;

#define TypeOfMelodySequenceType_NoteArray_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_NoteArray_CollectionType")))
#define CreateMelodySequenceType_NoteArray_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_NoteArray_CollectionType))
class Mp7JrsMelodySequenceType_NoteArray_CollectionType;
class IMp7JrsMelodySequenceType_NoteArray_CollectionType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_NoteArray_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_NoteArray_CollectionType > Mp7JrsMelodySequenceType_NoteArray_CollectionPtr;

#define TypeOfMelodySequenceType_NoteArray_LocalType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_NoteArray_LocalType")))
#define CreateMelodySequenceType_NoteArray_LocalType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_NoteArray_LocalType))
class Mp7JrsMelodySequenceType_NoteArray_LocalType;
class IMp7JrsMelodySequenceType_NoteArray_LocalType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_NoteArray_LocalType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_NoteArray_LocalType > Mp7JrsMelodySequenceType_NoteArray_LocalPtr;

#define TypeOfMelodySequenceType_NoteArray_Note_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_NoteArray_Note_CollectionType")))
#define CreateMelodySequenceType_NoteArray_Note_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_NoteArray_Note_CollectionType))
class Mp7JrsMelodySequenceType_NoteArray_Note_CollectionType;
class IMp7JrsMelodySequenceType_NoteArray_Note_CollectionType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_NoteArray_Note_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_NoteArray_Note_CollectionType > Mp7JrsMelodySequenceType_NoteArray_Note_CollectionPtr;

#define TypeOfMelodySequenceType_NoteArray_Note_LocalType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_NoteArray_Note_LocalType")))
#define CreateMelodySequenceType_NoteArray_Note_LocalType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_NoteArray_Note_LocalType))
class Mp7JrsMelodySequenceType_NoteArray_Note_LocalType;
class IMp7JrsMelodySequenceType_NoteArray_Note_LocalType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_NoteArray_Note_LocalType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_NoteArray_Note_LocalType > Mp7JrsMelodySequenceType_NoteArray_Note_LocalPtr;

#define TypeOfMelodySequenceType_StartingNote_LocalType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_StartingNote_LocalType")))
#define CreateMelodySequenceType_StartingNote_LocalType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_StartingNote_LocalType))
class Mp7JrsMelodySequenceType_StartingNote_LocalType;
class IMp7JrsMelodySequenceType_StartingNote_LocalType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_StartingNote_LocalType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_LocalType > Mp7JrsMelodySequenceType_StartingNote_LocalPtr;

#define TypeOfMelodySequenceType_StartingNote_StartingPitch_LocalType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_StartingNote_StartingPitch_LocalType")))
#define CreateMelodySequenceType_StartingNote_StartingPitch_LocalType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_StartingNote_StartingPitch_LocalType))
class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType;
class IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType > Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr;

#define TypeOfMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType (Mp7JrsFactory::GetTypeIndex(X("MelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType")))
#define CreateMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType (Mp7JrsFactory::CreateObject(TypeOfMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType))
class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType;
class IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType;
/** Smart pointer to instance of IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType */
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType > Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr;

#define TypeOfMelodyType (Mp7JrsFactory::GetTypeIndex(X("MelodyType")))
#define CreateMelodyType (Mp7JrsFactory::CreateObject(TypeOfMelodyType))
class Mp7JrsMelodyType;
class IMp7JrsMelodyType;
/** Smart pointer to instance of IMp7JrsMelodyType */
typedef Mp7JrsPtr< IMp7JrsMelodyType > Mp7JrsMelodyPtr;

#define TypeOfMelodyType_MelodySequence_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MelodyType_MelodySequence_CollectionType")))
#define CreateMelodyType_MelodySequence_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMelodyType_MelodySequence_CollectionType))
class Mp7JrsMelodyType_MelodySequence_CollectionType;
class IMp7JrsMelodyType_MelodySequence_CollectionType;
/** Smart pointer to instance of IMp7JrsMelodyType_MelodySequence_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMelodyType_MelodySequence_CollectionType > Mp7JrsMelodyType_MelodySequence_CollectionPtr;

#define TypeOfMeterType (Mp7JrsFactory::GetTypeIndex(X("MeterType")))
#define CreateMeterType (Mp7JrsFactory::CreateObject(TypeOfMeterType))
class Mp7JrsMeterType;
class IMp7JrsMeterType;
/** Smart pointer to instance of IMp7JrsMeterType */
typedef Mp7JrsPtr< IMp7JrsMeterType > Mp7JrsMeterPtr;

#define TypeOfMeterType_Denominator_LocalType (Mp7JrsFactory::GetTypeIndex(X("MeterType_Denominator_LocalType")))
#define CreateMeterType_Denominator_LocalType (Mp7JrsFactory::CreateObject(TypeOfMeterType_Denominator_LocalType))
class Mp7JrsMeterType_Denominator_LocalType;
class IMp7JrsMeterType_Denominator_LocalType;

#define TypeOfMeterType_Numerator_LocalType (Mp7JrsFactory::GetTypeIndex(X("MeterType_Numerator_LocalType")))
#define CreateMeterType_Numerator_LocalType (Mp7JrsFactory::CreateObject(TypeOfMeterType_Numerator_LocalType))
class Mp7JrsMeterType_Numerator_LocalType;
class IMp7JrsMeterType_Numerator_LocalType;
/** Smart pointer to instance of IMp7JrsMeterType_Numerator_LocalType */
typedef Mp7JrsPtr< IMp7JrsMeterType_Numerator_LocalType > Mp7JrsMeterType_Numerator_LocalPtr;

#define TypeOfmimeType (Mp7JrsFactory::GetTypeIndex(X("mimeType")))
#define CreatemimeType (Mp7JrsFactory::CreateObject(TypeOfmimeType))
class Mp7JrsmimeType;
class IMp7JrsmimeType;
/** Smart pointer to instance of IMp7JrsmimeType */
typedef Mp7JrsPtr< IMp7JrsmimeType > Mp7JrsmimePtr;

#define TypeOfMinusOneToOneMatrixType (Mp7JrsFactory::GetTypeIndex(X("MinusOneToOneMatrixType")))
#define CreateMinusOneToOneMatrixType (Mp7JrsFactory::CreateObject(TypeOfMinusOneToOneMatrixType))
class Mp7JrsMinusOneToOneMatrixType;
class IMp7JrsMinusOneToOneMatrixType;
/** Smart pointer to instance of IMp7JrsMinusOneToOneMatrixType */
typedef Mp7JrsPtr< IMp7JrsMinusOneToOneMatrixType > Mp7JrsMinusOneToOneMatrixPtr;

#define TypeOfminusOneToOneType (Mp7JrsFactory::GetTypeIndex(X("minusOneToOneType")))
#define CreateminusOneToOneType (Mp7JrsFactory::CreateObject(TypeOfminusOneToOneType))
class Mp7JrsminusOneToOneType;
class IMp7JrsminusOneToOneType;
/** Smart pointer to instance of IMp7JrsminusOneToOneType */
typedef Mp7JrsPtr< IMp7JrsminusOneToOneType > Mp7JrsminusOneToOnePtr;

#define TypeOfminusOneToOneVector (Mp7JrsFactory::GetTypeIndex(X("minusOneToOneVector")))
#define CreateminusOneToOneVector (Mp7JrsFactory::CreateObject(TypeOfminusOneToOneVector))
class Mp7JrsminusOneToOneVector;
class IMp7JrsminusOneToOneVector;
/** Smart pointer to instance of IMp7JrsminusOneToOneVector */
typedef Mp7JrsPtr< IMp7JrsminusOneToOneVector > Mp7JrsminusOneToOneVectorPtr;

#define TypeOfminusOneToOneVector_LocalType (Mp7JrsFactory::GetTypeIndex(X("minusOneToOneVector_LocalType")))
#define CreateminusOneToOneVector_LocalType (Mp7JrsFactory::CreateObject(TypeOfminusOneToOneVector_LocalType))
class Mp7JrsminusOneToOneVector_LocalType;
class IMp7JrsminusOneToOneVector_LocalType;
/** Smart pointer to instance of IMp7JrsminusOneToOneVector_LocalType */
typedef Mp7JrsPtr< IMp7JrsminusOneToOneVector_LocalType > Mp7JrsminusOneToOneVector_LocalPtr;

#define TypeOfMixedCollectionType (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType")))
#define CreateMixedCollectionType (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType))
class Mp7JrsMixedCollectionType;
class IMp7JrsMixedCollectionType;
/** Smart pointer to instance of IMp7JrsMixedCollectionType */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType > Mp7JrsMixedCollectionPtr;

#define TypeOfMixedCollectionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_CollectionType")))
#define CreateMixedCollectionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_CollectionType))
class Mp7JrsMixedCollectionType_CollectionType;
class IMp7JrsMixedCollectionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_CollectionType > Mp7JrsMixedCollectionType_CollectionPtr;

#define TypeOfMixedCollectionType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_CollectionType0")))
#define CreateMixedCollectionType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_CollectionType0))
class Mp7JrsMixedCollectionType_CollectionType0;
class IMp7JrsMixedCollectionType_CollectionType0;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_CollectionType0 > Mp7JrsMixedCollectionType_Collection0Ptr;

#define TypeOfMixedCollectionType_CollectionType1 (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_CollectionType1")))
#define CreateMixedCollectionType_CollectionType1 (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_CollectionType1))
class Mp7JrsMixedCollectionType_CollectionType1;
class IMp7JrsMixedCollectionType_CollectionType1;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_CollectionType1 */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_CollectionType1 > Mp7JrsMixedCollectionType_Collection1Ptr;

#define TypeOfMixedCollectionType_CollectionType2 (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_CollectionType2")))
#define CreateMixedCollectionType_CollectionType2 (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_CollectionType2))
class Mp7JrsMixedCollectionType_CollectionType2;
class IMp7JrsMixedCollectionType_CollectionType2;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_CollectionType2 */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_CollectionType2 > Mp7JrsMixedCollectionType_Collection2Ptr;

#define TypeOfMixedCollectionType_Descriptor_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_Descriptor_CollectionType")))
#define CreateMixedCollectionType_Descriptor_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_Descriptor_CollectionType))
class Mp7JrsMixedCollectionType_Descriptor_CollectionType;
class IMp7JrsMixedCollectionType_Descriptor_CollectionType;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_Descriptor_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_Descriptor_CollectionType > Mp7JrsMixedCollectionType_Descriptor_CollectionPtr;

#define TypeOfMixedCollectionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_LocalType")))
#define CreateMixedCollectionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_LocalType))
class Mp7JrsMixedCollectionType_LocalType;
class IMp7JrsMixedCollectionType_LocalType;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_LocalType > Mp7JrsMixedCollectionType_LocalPtr;

#define TypeOfMixedCollectionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_LocalType0")))
#define CreateMixedCollectionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_LocalType0))
class Mp7JrsMixedCollectionType_LocalType0;
class IMp7JrsMixedCollectionType_LocalType0;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_LocalType0 > Mp7JrsMixedCollectionType_Local0Ptr;

#define TypeOfMixedCollectionType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_LocalType1")))
#define CreateMixedCollectionType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_LocalType1))
class Mp7JrsMixedCollectionType_LocalType1;
class IMp7JrsMixedCollectionType_LocalType1;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_LocalType1 > Mp7JrsMixedCollectionType_Local1Ptr;

#define TypeOfMixedCollectionType_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("MixedCollectionType_LocalType2")))
#define CreateMixedCollectionType_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfMixedCollectionType_LocalType2))
class Mp7JrsMixedCollectionType_LocalType2;
class IMp7JrsMixedCollectionType_LocalType2;
/** Smart pointer to instance of IMp7JrsMixedCollectionType_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_LocalType2 > Mp7JrsMixedCollectionType_Local2Ptr;

#define TypeOfMixtureAmountOfMotionType (Mp7JrsFactory::GetTypeIndex(X("MixtureAmountOfMotionType")))
#define CreateMixtureAmountOfMotionType (Mp7JrsFactory::CreateObject(TypeOfMixtureAmountOfMotionType))
class Mp7JrsMixtureAmountOfMotionType;
class IMp7JrsMixtureAmountOfMotionType;
/** Smart pointer to instance of IMp7JrsMixtureAmountOfMotionType */
typedef Mp7JrsPtr< IMp7JrsMixtureAmountOfMotionType > Mp7JrsMixtureAmountOfMotionPtr;

#define TypeOfMixtureCameraMotionSegmentType (Mp7JrsFactory::GetTypeIndex(X("MixtureCameraMotionSegmentType")))
#define CreateMixtureCameraMotionSegmentType (Mp7JrsFactory::CreateObject(TypeOfMixtureCameraMotionSegmentType))
class Mp7JrsMixtureCameraMotionSegmentType;
class IMp7JrsMixtureCameraMotionSegmentType;
/** Smart pointer to instance of IMp7JrsMixtureCameraMotionSegmentType */
typedef Mp7JrsPtr< IMp7JrsMixtureCameraMotionSegmentType > Mp7JrsMixtureCameraMotionSegmentPtr;

#define TypeOfModelDescriptionType (Mp7JrsFactory::GetTypeIndex(X("ModelDescriptionType")))
#define CreateModelDescriptionType (Mp7JrsFactory::CreateObject(TypeOfModelDescriptionType))
class Mp7JrsModelDescriptionType;
class IMp7JrsModelDescriptionType;
/** Smart pointer to instance of IMp7JrsModelDescriptionType */
typedef Mp7JrsPtr< IMp7JrsModelDescriptionType > Mp7JrsModelDescriptionPtr;

#define TypeOfModelDescriptionType_Model_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ModelDescriptionType_Model_CollectionType")))
#define CreateModelDescriptionType_Model_CollectionType (Mp7JrsFactory::CreateObject(TypeOfModelDescriptionType_Model_CollectionType))
class Mp7JrsModelDescriptionType_Model_CollectionType;
class IMp7JrsModelDescriptionType_Model_CollectionType;
/** Smart pointer to instance of IMp7JrsModelDescriptionType_Model_CollectionType */
typedef Mp7JrsPtr< IMp7JrsModelDescriptionType_Model_CollectionType > Mp7JrsModelDescriptionType_Model_CollectionPtr;

#define TypeOfModelStateType (Mp7JrsFactory::GetTypeIndex(X("ModelStateType")))
#define CreateModelStateType (Mp7JrsFactory::CreateObject(TypeOfModelStateType))
class Mp7JrsModelStateType;
class IMp7JrsModelStateType;
/** Smart pointer to instance of IMp7JrsModelStateType */
typedef Mp7JrsPtr< IMp7JrsModelStateType > Mp7JrsModelStatePtr;

#define TypeOfModelType (Mp7JrsFactory::GetTypeIndex(X("ModelType")))
#define CreateModelType (Mp7JrsFactory::CreateObject(TypeOfModelType))
class Mp7JrsModelType;
class IMp7JrsModelType;
/** Smart pointer to instance of IMp7JrsModelType */
typedef Mp7JrsPtr< IMp7JrsModelType > Mp7JrsModelPtr;

#define TypeOfMorphismGraphType (Mp7JrsFactory::GetTypeIndex(X("MorphismGraphType")))
#define CreateMorphismGraphType (Mp7JrsFactory::CreateObject(TypeOfMorphismGraphType))
class Mp7JrsMorphismGraphType;
class IMp7JrsMorphismGraphType;
/** Smart pointer to instance of IMp7JrsMorphismGraphType */
typedef Mp7JrsPtr< IMp7JrsMorphismGraphType > Mp7JrsMorphismGraphPtr;

#define TypeOfMosaicType (Mp7JrsFactory::GetTypeIndex(X("MosaicType")))
#define CreateMosaicType (Mp7JrsFactory::CreateObject(TypeOfMosaicType))
class Mp7JrsMosaicType;
class IMp7JrsMosaicType;
/** Smart pointer to instance of IMp7JrsMosaicType */
typedef Mp7JrsPtr< IMp7JrsMosaicType > Mp7JrsMosaicPtr;

#define TypeOfMosaicType_WarpingParam_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_CollectionType")))
#define CreateMosaicType_WarpingParam_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_CollectionType))
class Mp7JrsMosaicType_WarpingParam_CollectionType;
class IMp7JrsMosaicType_WarpingParam_CollectionType;
/** Smart pointer to instance of IMp7JrsMosaicType_WarpingParam_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_CollectionType > Mp7JrsMosaicType_WarpingParam_CollectionPtr;

#define TypeOfMosaicType_WarpingParam_LocalType (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_LocalType")))
#define CreateMosaicType_WarpingParam_LocalType (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_LocalType))
class Mp7JrsMosaicType_WarpingParam_LocalType;
class IMp7JrsMosaicType_WarpingParam_LocalType;
/** Smart pointer to instance of IMp7JrsMosaicType_WarpingParam_LocalType */
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_LocalType > Mp7JrsMosaicType_WarpingParam_LocalPtr;

#define TypeOfMosaicType_WarpingParam_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_LocalType0")))
#define CreateMosaicType_WarpingParam_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_LocalType0))
class Mp7JrsMosaicType_WarpingParam_LocalType0;
class IMp7JrsMosaicType_WarpingParam_LocalType0;
/** Smart pointer to instance of IMp7JrsMosaicType_WarpingParam_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_LocalType0 > Mp7JrsMosaicType_WarpingParam_Local0Ptr;

#define TypeOfMosaicType_WarpingParam_modelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_modelType_LocalType")))
#define CreateMosaicType_WarpingParam_modelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_modelType_LocalType))
class Mp7JrsMosaicType_WarpingParam_modelType_LocalType;
class IMp7JrsMosaicType_WarpingParam_modelType_LocalType;

#define TypeOfMosaicType_WarpingParam_modelType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_modelType_LocalType0")))
#define CreateMosaicType_WarpingParam_modelType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_modelType_LocalType0))
class Mp7JrsMosaicType_WarpingParam_modelType_LocalType0;
class IMp7JrsMosaicType_WarpingParam_modelType_LocalType0;
/** Smart pointer to instance of IMp7JrsMosaicType_WarpingParam_modelType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_modelType_LocalType0 > Mp7JrsMosaicType_WarpingParam_modelType_Local0Ptr;

#define TypeOfMosaicType_WarpingParam_modelType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_modelType_LocalType1")))
#define CreateMosaicType_WarpingParam_modelType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_modelType_LocalType1))
class Mp7JrsMosaicType_WarpingParam_modelType_LocalType1;
class IMp7JrsMosaicType_WarpingParam_modelType_LocalType1;
/** Smart pointer to instance of IMp7JrsMosaicType_WarpingParam_modelType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_modelType_LocalType1 > Mp7JrsMosaicType_WarpingParam_modelType_Local1Ptr;

#define TypeOfMosaicType_WarpingParam_modelType_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("MosaicType_WarpingParam_modelType_LocalType2")))
#define CreateMosaicType_WarpingParam_modelType_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfMosaicType_WarpingParam_modelType_LocalType2))
class Mp7JrsMosaicType_WarpingParam_modelType_LocalType2;
class IMp7JrsMosaicType_WarpingParam_modelType_LocalType2;
/** Smart pointer to instance of IMp7JrsMosaicType_WarpingParam_modelType_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_modelType_LocalType2 > Mp7JrsMosaicType_WarpingParam_modelType_Local2Ptr;

#define TypeOfMotionActivityType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType")))
#define CreateMotionActivityType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType))
class Mp7JrsMotionActivityType;
class IMp7JrsMotionActivityType;
/** Smart pointer to instance of IMp7JrsMotionActivityType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType > Mp7JrsMotionActivityPtr;

#define TypeOfMotionActivityType_Intensity_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_Intensity_LocalType")))
#define CreateMotionActivityType_Intensity_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_Intensity_LocalType))
class Mp7JrsMotionActivityType_Intensity_LocalType;
class IMp7JrsMotionActivityType_Intensity_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_Intensity_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_Intensity_LocalType > Mp7JrsMotionActivityType_Intensity_LocalPtr;

#define TypeOfMotionActivityType_SpatialDistributionParams_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialDistributionParams_LocalType")))
#define CreateMotionActivityType_SpatialDistributionParams_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialDistributionParams_LocalType))
class Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType;
class IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType > Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_LocalType")))
#define CreateMotionActivityType_SpatialLocalizationParams_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_LocalType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector16_CollectionType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector16_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector16_LocalType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector16_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector16_LocalType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector256_CollectionType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector256_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector256_LocalType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector256_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector256_LocalType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector4_CollectionType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector4_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector4_LocalType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector4_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector4_LocalType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector64_CollectionType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionPtr;

#define TypeOfMotionActivityType_SpatialLocalizationParams_Vector64_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_SpatialLocalizationParams_Vector64_LocalType")))
#define CreateMotionActivityType_SpatialLocalizationParams_Vector64_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_SpatialLocalizationParams_Vector64_LocalType))
class Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType;
class IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType > Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalPtr;

#define TypeOfMotionActivityType_TemporalParams_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_TemporalParams_CollectionType")))
#define CreateMotionActivityType_TemporalParams_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_TemporalParams_CollectionType))
class Mp7JrsMotionActivityType_TemporalParams_CollectionType;
class IMp7JrsMotionActivityType_TemporalParams_CollectionType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_TemporalParams_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_TemporalParams_CollectionType > Mp7JrsMotionActivityType_TemporalParams_CollectionPtr;

#define TypeOfMotionActivityType_TemporalParams_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionActivityType_TemporalParams_LocalType")))
#define CreateMotionActivityType_TemporalParams_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionActivityType_TemporalParams_LocalType))
class Mp7JrsMotionActivityType_TemporalParams_LocalType;
class IMp7JrsMotionActivityType_TemporalParams_LocalType;
/** Smart pointer to instance of IMp7JrsMotionActivityType_TemporalParams_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_TemporalParams_LocalType > Mp7JrsMotionActivityType_TemporalParams_LocalPtr;

#define TypeOfMotionTrajectoryType (Mp7JrsFactory::GetTypeIndex(X("MotionTrajectoryType")))
#define CreateMotionTrajectoryType (Mp7JrsFactory::CreateObject(TypeOfMotionTrajectoryType))
class Mp7JrsMotionTrajectoryType;
class IMp7JrsMotionTrajectoryType;
/** Smart pointer to instance of IMp7JrsMotionTrajectoryType */
typedef Mp7JrsPtr< IMp7JrsMotionTrajectoryType > Mp7JrsMotionTrajectoryPtr;

#define TypeOfMotionTrajectoryType_CoordDef_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionTrajectoryType_CoordDef_LocalType")))
#define CreateMotionTrajectoryType_CoordDef_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionTrajectoryType_CoordDef_LocalType))
class Mp7JrsMotionTrajectoryType_CoordDef_LocalType;
class IMp7JrsMotionTrajectoryType_CoordDef_LocalType;
/** Smart pointer to instance of IMp7JrsMotionTrajectoryType_CoordDef_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionTrajectoryType_CoordDef_LocalType > Mp7JrsMotionTrajectoryType_CoordDef_LocalPtr;

#define TypeOfMotionTrajectoryType_CoordDef_Repr_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionTrajectoryType_CoordDef_Repr_LocalType")))
#define CreateMotionTrajectoryType_CoordDef_Repr_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionTrajectoryType_CoordDef_Repr_LocalType))
class Mp7JrsMotionTrajectoryType_CoordDef_Repr_LocalType;
class IMp7JrsMotionTrajectoryType_CoordDef_Repr_LocalType;
/** Smart pointer to instance of IMp7JrsMotionTrajectoryType_CoordDef_Repr_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionTrajectoryType_CoordDef_Repr_LocalType > Mp7JrsMotionTrajectoryType_CoordDef_Repr_LocalPtr;

#define TypeOfMotionTrajectoryType_CoordDef_units_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionTrajectoryType_CoordDef_units_LocalType")))
#define CreateMotionTrajectoryType_CoordDef_units_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionTrajectoryType_CoordDef_units_LocalType))
class Mp7JrsMotionTrajectoryType_CoordDef_units_LocalType;
class IMp7JrsMotionTrajectoryType_CoordDef_units_LocalType;

#define TypeOfMotionTrajectoryType_CoordRef_LocalType (Mp7JrsFactory::GetTypeIndex(X("MotionTrajectoryType_CoordRef_LocalType")))
#define CreateMotionTrajectoryType_CoordRef_LocalType (Mp7JrsFactory::CreateObject(TypeOfMotionTrajectoryType_CoordRef_LocalType))
class Mp7JrsMotionTrajectoryType_CoordRef_LocalType;
class IMp7JrsMotionTrajectoryType_CoordRef_LocalType;
/** Smart pointer to instance of IMp7JrsMotionTrajectoryType_CoordRef_LocalType */
typedef Mp7JrsPtr< IMp7JrsMotionTrajectoryType_CoordRef_LocalType > Mp7JrsMotionTrajectoryType_CoordRef_LocalPtr;

#define TypeOfMovingRegionMediaSourceDecompositionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionMediaSourceDecompositionType")))
#define CreateMovingRegionMediaSourceDecompositionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionMediaSourceDecompositionType))
class Mp7JrsMovingRegionMediaSourceDecompositionType;
class IMp7JrsMovingRegionMediaSourceDecompositionType;
/** Smart pointer to instance of IMp7JrsMovingRegionMediaSourceDecompositionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionMediaSourceDecompositionType > Mp7JrsMovingRegionMediaSourceDecompositionPtr;

#define TypeOfMovingRegionMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionMediaSourceDecompositionType_CollectionType")))
#define CreateMovingRegionMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionMediaSourceDecompositionType_CollectionType))
class Mp7JrsMovingRegionMediaSourceDecompositionType_CollectionType;
class IMp7JrsMovingRegionMediaSourceDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMovingRegionMediaSourceDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionMediaSourceDecompositionType_CollectionType > Mp7JrsMovingRegionMediaSourceDecompositionType_CollectionPtr;

#define TypeOfMovingRegionMediaSourceDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionMediaSourceDecompositionType_LocalType")))
#define CreateMovingRegionMediaSourceDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionMediaSourceDecompositionType_LocalType))
class Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType;
class IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionMediaSourceDecompositionType_LocalType > Mp7JrsMovingRegionMediaSourceDecompositionType_LocalPtr;

#define TypeOfMovingRegionSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionSpatialDecompositionType")))
#define CreateMovingRegionSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionSpatialDecompositionType))
class Mp7JrsMovingRegionSpatialDecompositionType;
class IMp7JrsMovingRegionSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsMovingRegionSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatialDecompositionType > Mp7JrsMovingRegionSpatialDecompositionPtr;

#define TypeOfMovingRegionSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionSpatialDecompositionType_CollectionType")))
#define CreateMovingRegionSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionSpatialDecompositionType_CollectionType))
class Mp7JrsMovingRegionSpatialDecompositionType_CollectionType;
class IMp7JrsMovingRegionSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMovingRegionSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatialDecompositionType_CollectionType > Mp7JrsMovingRegionSpatialDecompositionType_CollectionPtr;

#define TypeOfMovingRegionSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionSpatialDecompositionType_LocalType")))
#define CreateMovingRegionSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionSpatialDecompositionType_LocalType))
class Mp7JrsMovingRegionSpatialDecompositionType_LocalType;
class IMp7JrsMovingRegionSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsMovingRegionSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatialDecompositionType_LocalType > Mp7JrsMovingRegionSpatialDecompositionType_LocalPtr;

#define TypeOfMovingRegionSpatioTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionSpatioTemporalDecompositionType")))
#define CreateMovingRegionSpatioTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionSpatioTemporalDecompositionType))
class Mp7JrsMovingRegionSpatioTemporalDecompositionType;
class IMp7JrsMovingRegionSpatioTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsMovingRegionSpatioTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatioTemporalDecompositionType > Mp7JrsMovingRegionSpatioTemporalDecompositionPtr;

#define TypeOfMovingRegionSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionSpatioTemporalDecompositionType_CollectionType")))
#define CreateMovingRegionSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionSpatioTemporalDecompositionType_CollectionType))
class Mp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionType;
class IMp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionType > Mp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionPtr;

#define TypeOfMovingRegionSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionSpatioTemporalDecompositionType_LocalType")))
#define CreateMovingRegionSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionSpatioTemporalDecompositionType_LocalType))
class Mp7JrsMovingRegionSpatioTemporalDecompositionType_LocalType;
class IMp7JrsMovingRegionSpatioTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsMovingRegionSpatioTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionSpatioTemporalDecompositionType_LocalType > Mp7JrsMovingRegionSpatioTemporalDecompositionType_LocalPtr;

#define TypeOfMovingRegionTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionTemporalDecompositionType")))
#define CreateMovingRegionTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionTemporalDecompositionType))
class Mp7JrsMovingRegionTemporalDecompositionType;
class IMp7JrsMovingRegionTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsMovingRegionTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionTemporalDecompositionType > Mp7JrsMovingRegionTemporalDecompositionPtr;

#define TypeOfMovingRegionTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionTemporalDecompositionType_CollectionType")))
#define CreateMovingRegionTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionTemporalDecompositionType_CollectionType))
class Mp7JrsMovingRegionTemporalDecompositionType_CollectionType;
class IMp7JrsMovingRegionTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMovingRegionTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionTemporalDecompositionType_CollectionType > Mp7JrsMovingRegionTemporalDecompositionType_CollectionPtr;

#define TypeOfMovingRegionTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionTemporalDecompositionType_LocalType")))
#define CreateMovingRegionTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionTemporalDecompositionType_LocalType))
class Mp7JrsMovingRegionTemporalDecompositionType_LocalType;
class IMp7JrsMovingRegionTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsMovingRegionTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionTemporalDecompositionType_LocalType > Mp7JrsMovingRegionTemporalDecompositionType_LocalPtr;

#define TypeOfMovingRegionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionType")))
#define CreateMovingRegionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionType))
class Mp7JrsMovingRegionType;
class IMp7JrsMovingRegionType;
/** Smart pointer to instance of IMp7JrsMovingRegionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionType > Mp7JrsMovingRegionPtr;

#define TypeOfMovingRegionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionType_CollectionType")))
#define CreateMovingRegionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionType_CollectionType))
class Mp7JrsMovingRegionType_CollectionType;
class IMp7JrsMovingRegionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMovingRegionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionType_CollectionType > Mp7JrsMovingRegionType_CollectionPtr;

#define TypeOfMovingRegionType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("MovingRegionType_CollectionType0")))
#define CreateMovingRegionType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfMovingRegionType_CollectionType0))
class Mp7JrsMovingRegionType_CollectionType0;
class IMp7JrsMovingRegionType_CollectionType0;
/** Smart pointer to instance of IMp7JrsMovingRegionType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsMovingRegionType_CollectionType0 > Mp7JrsMovingRegionType_Collection0Ptr;

#define TypeOfMovingRegionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MovingRegionType_LocalType")))
#define CreateMovingRegionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMovingRegionType_LocalType))
class Mp7JrsMovingRegionType_LocalType;
class IMp7JrsMovingRegionType_LocalType;
/** Smart pointer to instance of IMp7JrsMovingRegionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMovingRegionType_LocalType > Mp7JrsMovingRegionType_LocalPtr;

#define TypeOfMovingRegionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("MovingRegionType_LocalType0")))
#define CreateMovingRegionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfMovingRegionType_LocalType0))
class Mp7JrsMovingRegionType_LocalType0;
class IMp7JrsMovingRegionType_LocalType0;
/** Smart pointer to instance of IMp7JrsMovingRegionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsMovingRegionType_LocalType0 > Mp7JrsMovingRegionType_Local0Ptr;

#define TypeOfMpeg7_Description_CollectionType (Mp7JrsFactory::GetTypeIndex(X("Mpeg7_Description_CollectionType")))
#define CreateMpeg7_Description_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMpeg7_Description_CollectionType))
class Mp7JrsMpeg7_Description_CollectionType;
class IMp7JrsMpeg7_Description_CollectionType;
/** Smart pointer to instance of IMp7JrsMpeg7_Description_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMpeg7_Description_CollectionType > Mp7JrsMpeg7_Description_CollectionPtr;

#define TypeOfMpeg7_LocalType (Mp7JrsFactory::GetTypeIndex(X("Mpeg7_LocalType")))
#define CreateMpeg7_LocalType (Mp7JrsFactory::CreateObject(TypeOfMpeg7_LocalType))
class Mp7JrsMpeg7_LocalType;
class IMp7JrsMpeg7_LocalType;
/** Smart pointer to instance of IMp7JrsMpeg7_LocalType */
typedef Mp7JrsPtr< IMp7JrsMpeg7_LocalType > Mp7JrsMpeg7_LocalPtr;

#define TypeOfMpeg7BaseType (Mp7JrsFactory::GetTypeIndex(X("Mpeg7BaseType")))
#define CreateMpeg7BaseType (Mp7JrsFactory::CreateObject(TypeOfMpeg7BaseType))
class Mp7JrsMpeg7BaseType;
class IMp7JrsMpeg7BaseType;
/** Smart pointer to instance of IMp7JrsMpeg7BaseType */
typedef Mp7JrsPtr< IMp7JrsMpeg7BaseType > Mp7JrsMpeg7BasePtr;

#define TypeOfMpeg7Type (Mp7JrsFactory::GetTypeIndex(X("Mpeg7Type")))
#define CreateMpeg7Type (Mp7JrsFactory::CreateObject(TypeOfMpeg7Type))
class Mp7JrsMpeg7Type;
class IMp7JrsMpeg7Type;
/** Smart pointer to instance of IMp7JrsMpeg7Type */
typedef Mp7JrsPtr< IMp7JrsMpeg7Type > Mp7JrsMpeg7Ptr;

#define TypeOfMultimediaCollectionType (Mp7JrsFactory::GetTypeIndex(X("MultimediaCollectionType")))
#define CreateMultimediaCollectionType (Mp7JrsFactory::CreateObject(TypeOfMultimediaCollectionType))
class Mp7JrsMultimediaCollectionType;
class IMp7JrsMultimediaCollectionType;
/** Smart pointer to instance of IMp7JrsMultimediaCollectionType */
typedef Mp7JrsPtr< IMp7JrsMultimediaCollectionType > Mp7JrsMultimediaCollectionPtr;

#define TypeOfMultimediaCollectionType_Collection_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MultimediaCollectionType_Collection_CollectionType")))
#define CreateMultimediaCollectionType_Collection_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMultimediaCollectionType_Collection_CollectionType))
class Mp7JrsMultimediaCollectionType_Collection_CollectionType;
class IMp7JrsMultimediaCollectionType_Collection_CollectionType;
/** Smart pointer to instance of IMp7JrsMultimediaCollectionType_Collection_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMultimediaCollectionType_Collection_CollectionType > Mp7JrsMultimediaCollectionType_Collection_CollectionPtr;

#define TypeOfMultimediaCollectionType_StructuredCollection_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MultimediaCollectionType_StructuredCollection_CollectionType")))
#define CreateMultimediaCollectionType_StructuredCollection_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMultimediaCollectionType_StructuredCollection_CollectionType))
class Mp7JrsMultimediaCollectionType_StructuredCollection_CollectionType;
class IMp7JrsMultimediaCollectionType_StructuredCollection_CollectionType;
/** Smart pointer to instance of IMp7JrsMultimediaCollectionType_StructuredCollection_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMultimediaCollectionType_StructuredCollection_CollectionType > Mp7JrsMultimediaCollectionType_StructuredCollection_CollectionPtr;

#define TypeOfMultimediaContentType (Mp7JrsFactory::GetTypeIndex(X("MultimediaContentType")))
#define CreateMultimediaContentType (Mp7JrsFactory::CreateObject(TypeOfMultimediaContentType))
class Mp7JrsMultimediaContentType;
class IMp7JrsMultimediaContentType;
/** Smart pointer to instance of IMp7JrsMultimediaContentType */
typedef Mp7JrsPtr< IMp7JrsMultimediaContentType > Mp7JrsMultimediaContentPtr;

#define TypeOfMultimediaSegmentMediaSourceDecompositionType (Mp7JrsFactory::GetTypeIndex(X("MultimediaSegmentMediaSourceDecompositionType")))
#define CreateMultimediaSegmentMediaSourceDecompositionType (Mp7JrsFactory::CreateObject(TypeOfMultimediaSegmentMediaSourceDecompositionType))
class Mp7JrsMultimediaSegmentMediaSourceDecompositionType;
class IMp7JrsMultimediaSegmentMediaSourceDecompositionType;
/** Smart pointer to instance of IMp7JrsMultimediaSegmentMediaSourceDecompositionType */
typedef Mp7JrsPtr< IMp7JrsMultimediaSegmentMediaSourceDecompositionType > Mp7JrsMultimediaSegmentMediaSourceDecompositionPtr;

#define TypeOfMultimediaSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MultimediaSegmentMediaSourceDecompositionType_CollectionType")))
#define CreateMultimediaSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMultimediaSegmentMediaSourceDecompositionType_CollectionType))
class Mp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionType;
class IMp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionType > Mp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionPtr;

#define TypeOfMultimediaSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MultimediaSegmentMediaSourceDecompositionType_LocalType")))
#define CreateMultimediaSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMultimediaSegmentMediaSourceDecompositionType_LocalType))
class Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType;
class IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType > Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalPtr;

#define TypeOfMultimediaSegmentType (Mp7JrsFactory::GetTypeIndex(X("MultimediaSegmentType")))
#define CreateMultimediaSegmentType (Mp7JrsFactory::CreateObject(TypeOfMultimediaSegmentType))
class Mp7JrsMultimediaSegmentType;
class IMp7JrsMultimediaSegmentType;
/** Smart pointer to instance of IMp7JrsMultimediaSegmentType */
typedef Mp7JrsPtr< IMp7JrsMultimediaSegmentType > Mp7JrsMultimediaSegmentPtr;

#define TypeOfMultimediaSegmentType_MediaSourceDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MultimediaSegmentType_MediaSourceDecomposition_CollectionType")))
#define CreateMultimediaSegmentType_MediaSourceDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMultimediaSegmentType_MediaSourceDecomposition_CollectionType))
class Mp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionType;
class IMp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionType > Mp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionPtr;

#define TypeOfMultimediaType (Mp7JrsFactory::GetTypeIndex(X("MultimediaType")))
#define CreateMultimediaType (Mp7JrsFactory::CreateObject(TypeOfMultimediaType))
class Mp7JrsMultimediaType;
class IMp7JrsMultimediaType;
/** Smart pointer to instance of IMp7JrsMultimediaType */
typedef Mp7JrsPtr< IMp7JrsMultimediaType > Mp7JrsMultimediaPtr;

#define TypeOfMultipleViewType (Mp7JrsFactory::GetTypeIndex(X("MultipleViewType")))
#define CreateMultipleViewType (Mp7JrsFactory::CreateObject(TypeOfMultipleViewType))
class Mp7JrsMultipleViewType;
class IMp7JrsMultipleViewType;
/** Smart pointer to instance of IMp7JrsMultipleViewType */
typedef Mp7JrsPtr< IMp7JrsMultipleViewType > Mp7JrsMultipleViewPtr;

#define TypeOfMultipleViewType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("MultipleViewType_CollectionType")))
#define CreateMultipleViewType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfMultipleViewType_CollectionType))
class Mp7JrsMultipleViewType_CollectionType;
class IMp7JrsMultipleViewType_CollectionType;
/** Smart pointer to instance of IMp7JrsMultipleViewType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsMultipleViewType_CollectionType > Mp7JrsMultipleViewType_CollectionPtr;

#define TypeOfMultipleViewType_LocalType (Mp7JrsFactory::GetTypeIndex(X("MultipleViewType_LocalType")))
#define CreateMultipleViewType_LocalType (Mp7JrsFactory::CreateObject(TypeOfMultipleViewType_LocalType))
class Mp7JrsMultipleViewType_LocalType;
class IMp7JrsMultipleViewType_LocalType;
/** Smart pointer to instance of IMp7JrsMultipleViewType_LocalType */
typedef Mp7JrsPtr< IMp7JrsMultipleViewType_LocalType > Mp7JrsMultipleViewType_LocalPtr;

#define TypeOfMultiResolutionPyramidType (Mp7JrsFactory::GetTypeIndex(X("MultiResolutionPyramidType")))
#define CreateMultiResolutionPyramidType (Mp7JrsFactory::CreateObject(TypeOfMultiResolutionPyramidType))
class Mp7JrsMultiResolutionPyramidType;
class IMp7JrsMultiResolutionPyramidType;
/** Smart pointer to instance of IMp7JrsMultiResolutionPyramidType */
typedef Mp7JrsPtr< IMp7JrsMultiResolutionPyramidType > Mp7JrsMultiResolutionPyramidPtr;

#define TypeOfNameComponentType (Mp7JrsFactory::GetTypeIndex(X("NameComponentType")))
#define CreateNameComponentType (Mp7JrsFactory::CreateObject(TypeOfNameComponentType))
class Mp7JrsNameComponentType;
class IMp7JrsNameComponentType;
/** Smart pointer to instance of IMp7JrsNameComponentType */
typedef Mp7JrsPtr< IMp7JrsNameComponentType > Mp7JrsNameComponentPtr;

#define TypeOfNonDependencyStructurePhraseType (Mp7JrsFactory::GetTypeIndex(X("NonDependencyStructurePhraseType")))
#define CreateNonDependencyStructurePhraseType (Mp7JrsFactory::CreateObject(TypeOfNonDependencyStructurePhraseType))
class Mp7JrsNonDependencyStructurePhraseType;
class IMp7JrsNonDependencyStructurePhraseType;
/** Smart pointer to instance of IMp7JrsNonDependencyStructurePhraseType */
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType > Mp7JrsNonDependencyStructurePhrasePtr;

#define TypeOfNonDependencyStructurePhraseType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("NonDependencyStructurePhraseType_CollectionType")))
#define CreateNonDependencyStructurePhraseType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfNonDependencyStructurePhraseType_CollectionType))
class Mp7JrsNonDependencyStructurePhraseType_CollectionType;
class IMp7JrsNonDependencyStructurePhraseType_CollectionType;
/** Smart pointer to instance of IMp7JrsNonDependencyStructurePhraseType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType_CollectionType > Mp7JrsNonDependencyStructurePhraseType_CollectionPtr;

#define TypeOfNonDependencyStructurePhraseType_LocalType (Mp7JrsFactory::GetTypeIndex(X("NonDependencyStructurePhraseType_LocalType")))
#define CreateNonDependencyStructurePhraseType_LocalType (Mp7JrsFactory::CreateObject(TypeOfNonDependencyStructurePhraseType_LocalType))
class Mp7JrsNonDependencyStructurePhraseType_LocalType;
class IMp7JrsNonDependencyStructurePhraseType_LocalType;
/** Smart pointer to instance of IMp7JrsNonDependencyStructurePhraseType_LocalType */
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType_LocalType > Mp7JrsNonDependencyStructurePhraseType_LocalPtr;

#define TypeOfNonDependencyStructurePhraseType_synthesis_LocalType (Mp7JrsFactory::GetTypeIndex(X("NonDependencyStructurePhraseType_synthesis_LocalType")))
#define CreateNonDependencyStructurePhraseType_synthesis_LocalType (Mp7JrsFactory::CreateObject(TypeOfNonDependencyStructurePhraseType_synthesis_LocalType))
class Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType;
class IMp7JrsNonDependencyStructurePhraseType_synthesis_LocalType;

#define TypeOfNonMixtureAmountOfMotionType (Mp7JrsFactory::GetTypeIndex(X("NonMixtureAmountOfMotionType")))
#define CreateNonMixtureAmountOfMotionType (Mp7JrsFactory::CreateObject(TypeOfNonMixtureAmountOfMotionType))
class Mp7JrsNonMixtureAmountOfMotionType;
class IMp7JrsNonMixtureAmountOfMotionType;
/** Smart pointer to instance of IMp7JrsNonMixtureAmountOfMotionType */
typedef Mp7JrsPtr< IMp7JrsNonMixtureAmountOfMotionType > Mp7JrsNonMixtureAmountOfMotionPtr;

#define TypeOfNonMixtureAmountOfMotionType_Fixed_LocalType (Mp7JrsFactory::GetTypeIndex(X("NonMixtureAmountOfMotionType_Fixed_LocalType")))
#define CreateNonMixtureAmountOfMotionType_Fixed_LocalType (Mp7JrsFactory::CreateObject(TypeOfNonMixtureAmountOfMotionType_Fixed_LocalType))
class Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType;
class IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType;
/** Smart pointer to instance of IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType */
typedef Mp7JrsPtr< IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType > Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr;

#define TypeOfNonMixtureCameraMotionSegmentType (Mp7JrsFactory::GetTypeIndex(X("NonMixtureCameraMotionSegmentType")))
#define CreateNonMixtureCameraMotionSegmentType (Mp7JrsFactory::CreateObject(TypeOfNonMixtureCameraMotionSegmentType))
class Mp7JrsNonMixtureCameraMotionSegmentType;
class IMp7JrsNonMixtureCameraMotionSegmentType;
/** Smart pointer to instance of IMp7JrsNonMixtureCameraMotionSegmentType */
typedef Mp7JrsPtr< IMp7JrsNonMixtureCameraMotionSegmentType > Mp7JrsNonMixtureCameraMotionSegmentPtr;

#define TypeOfnonNegativeReal (Mp7JrsFactory::GetTypeIndex(X("nonNegativeReal")))
#define CreatenonNegativeReal (Mp7JrsFactory::CreateObject(TypeOfnonNegativeReal))
class Mp7JrsnonNegativeReal;
class IMp7JrsnonNegativeReal;
/** Smart pointer to instance of IMp7JrsnonNegativeReal */
typedef Mp7JrsPtr< IMp7JrsnonNegativeReal > Mp7JrsnonNegativeRealPtr;

#define TypeOfObjectType (Mp7JrsFactory::GetTypeIndex(X("ObjectType")))
#define CreateObjectType (Mp7JrsFactory::CreateObject(TypeOfObjectType))
class Mp7JrsObjectType;
class IMp7JrsObjectType;
/** Smart pointer to instance of IMp7JrsObjectType */
typedef Mp7JrsPtr< IMp7JrsObjectType > Mp7JrsObjectPtr;

#define TypeOfObjectType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ObjectType_CollectionType")))
#define CreateObjectType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfObjectType_CollectionType))
class Mp7JrsObjectType_CollectionType;
class IMp7JrsObjectType_CollectionType;
/** Smart pointer to instance of IMp7JrsObjectType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsObjectType_CollectionType > Mp7JrsObjectType_CollectionPtr;

#define TypeOfObjectType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ObjectType_LocalType")))
#define CreateObjectType_LocalType (Mp7JrsFactory::CreateObject(TypeOfObjectType_LocalType))
class Mp7JrsObjectType_LocalType;
class IMp7JrsObjectType_LocalType;
/** Smart pointer to instance of IMp7JrsObjectType_LocalType */
typedef Mp7JrsPtr< IMp7JrsObjectType_LocalType > Mp7JrsObjectType_LocalPtr;

#define TypeOfOrderedGroupDataSetMaskType (Mp7JrsFactory::GetTypeIndex(X("OrderedGroupDataSetMaskType")))
#define CreateOrderedGroupDataSetMaskType (Mp7JrsFactory::CreateObject(TypeOfOrderedGroupDataSetMaskType))
class Mp7JrsOrderedGroupDataSetMaskType;
class IMp7JrsOrderedGroupDataSetMaskType;
/** Smart pointer to instance of IMp7JrsOrderedGroupDataSetMaskType */
typedef Mp7JrsPtr< IMp7JrsOrderedGroupDataSetMaskType > Mp7JrsOrderedGroupDataSetMaskPtr;

#define TypeOfOrderedGroupDataSetMaskType_SubInterval_CollectionType (Mp7JrsFactory::GetTypeIndex(X("OrderedGroupDataSetMaskType_SubInterval_CollectionType")))
#define CreateOrderedGroupDataSetMaskType_SubInterval_CollectionType (Mp7JrsFactory::CreateObject(TypeOfOrderedGroupDataSetMaskType_SubInterval_CollectionType))
class Mp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionType;
class IMp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionType;
/** Smart pointer to instance of IMp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionType */
typedef Mp7JrsPtr< IMp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionType > Mp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionPtr;

#define TypeOfOrderedGroupDataSetMaskType_SubInterval_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrderedGroupDataSetMaskType_SubInterval_LocalType")))
#define CreateOrderedGroupDataSetMaskType_SubInterval_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrderedGroupDataSetMaskType_SubInterval_LocalType))
class Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType;
class IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType;
/** Smart pointer to instance of IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType */
typedef Mp7JrsPtr< IMp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType > Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalPtr;

#define TypeOfOrderingKeyType (Mp7JrsFactory::GetTypeIndex(X("OrderingKeyType")))
#define CreateOrderingKeyType (Mp7JrsFactory::CreateObject(TypeOfOrderingKeyType))
class Mp7JrsOrderingKeyType;
class IMp7JrsOrderingKeyType;
/** Smart pointer to instance of IMp7JrsOrderingKeyType */
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType > Mp7JrsOrderingKeyPtr;

#define TypeOfOrderingKeyType_direction_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrderingKeyType_direction_LocalType")))
#define CreateOrderingKeyType_direction_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrderingKeyType_direction_LocalType))
class Mp7JrsOrderingKeyType_direction_LocalType;
class IMp7JrsOrderingKeyType_direction_LocalType;

#define TypeOfOrderingKeyType_Field_CollectionType (Mp7JrsFactory::GetTypeIndex(X("OrderingKeyType_Field_CollectionType")))
#define CreateOrderingKeyType_Field_CollectionType (Mp7JrsFactory::CreateObject(TypeOfOrderingKeyType_Field_CollectionType))
class Mp7JrsOrderingKeyType_Field_CollectionType;
class IMp7JrsOrderingKeyType_Field_CollectionType;
/** Smart pointer to instance of IMp7JrsOrderingKeyType_Field_CollectionType */
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType_Field_CollectionType > Mp7JrsOrderingKeyType_Field_CollectionPtr;

#define TypeOfOrderingKeyType_Field_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrderingKeyType_Field_LocalType")))
#define CreateOrderingKeyType_Field_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrderingKeyType_Field_LocalType))
class Mp7JrsOrderingKeyType_Field_LocalType;
class IMp7JrsOrderingKeyType_Field_LocalType;
/** Smart pointer to instance of IMp7JrsOrderingKeyType_Field_LocalType */
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType_Field_LocalType > Mp7JrsOrderingKeyType_Field_LocalPtr;

#define TypeOfOrderingKeyType_Selector_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrderingKeyType_Selector_LocalType")))
#define CreateOrderingKeyType_Selector_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrderingKeyType_Selector_LocalType))
class Mp7JrsOrderingKeyType_Selector_LocalType;
class IMp7JrsOrderingKeyType_Selector_LocalType;
/** Smart pointer to instance of IMp7JrsOrderingKeyType_Selector_LocalType */
typedef Mp7JrsPtr< IMp7JrsOrderingKeyType_Selector_LocalType > Mp7JrsOrderingKeyType_Selector_LocalPtr;

#define TypeOfOrganizationType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType")))
#define CreateOrganizationType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType))
class Mp7JrsOrganizationType;
class IMp7JrsOrganizationType;
/** Smart pointer to instance of IMp7JrsOrganizationType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType > Mp7JrsOrganizationPtr;

#define TypeOfOrganizationType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_CollectionType")))
#define CreateOrganizationType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_CollectionType))
class Mp7JrsOrganizationType_CollectionType;
class IMp7JrsOrganizationType_CollectionType;
/** Smart pointer to instance of IMp7JrsOrganizationType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType_CollectionType > Mp7JrsOrganizationType_CollectionPtr;

#define TypeOfOrganizationType_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_LocalType")))
#define CreateOrganizationType_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_LocalType))
class Mp7JrsOrganizationType_LocalType;
class IMp7JrsOrganizationType_LocalType;
/** Smart pointer to instance of IMp7JrsOrganizationType_LocalType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType_LocalType > Mp7JrsOrganizationType_LocalPtr;

#define TypeOfOrganizationType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_Name_CollectionType")))
#define CreateOrganizationType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_Name_CollectionType))
class Mp7JrsOrganizationType_Name_CollectionType;
class IMp7JrsOrganizationType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsOrganizationType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType_Name_CollectionType > Mp7JrsOrganizationType_Name_CollectionPtr;

#define TypeOfOrganizationType_Name_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_Name_LocalType")))
#define CreateOrganizationType_Name_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_Name_LocalType))
class Mp7JrsOrganizationType_Name_LocalType;
class IMp7JrsOrganizationType_Name_LocalType;
/** Smart pointer to instance of IMp7JrsOrganizationType_Name_LocalType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType_Name_LocalType > Mp7JrsOrganizationType_Name_LocalPtr;

#define TypeOfOrganizationType_Name_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_Name_type_LocalType")))
#define CreateOrganizationType_Name_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_Name_type_LocalType))
class Mp7JrsOrganizationType_Name_type_LocalType;
class IMp7JrsOrganizationType_Name_type_LocalType;

#define TypeOfOrganizationType_NameTerm_CollectionType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_NameTerm_CollectionType")))
#define CreateOrganizationType_NameTerm_CollectionType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_NameTerm_CollectionType))
class Mp7JrsOrganizationType_NameTerm_CollectionType;
class IMp7JrsOrganizationType_NameTerm_CollectionType;
/** Smart pointer to instance of IMp7JrsOrganizationType_NameTerm_CollectionType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType_NameTerm_CollectionType > Mp7JrsOrganizationType_NameTerm_CollectionPtr;

#define TypeOfOrganizationType_NameTerm_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_NameTerm_LocalType")))
#define CreateOrganizationType_NameTerm_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_NameTerm_LocalType))
class Mp7JrsOrganizationType_NameTerm_LocalType;
class IMp7JrsOrganizationType_NameTerm_LocalType;
/** Smart pointer to instance of IMp7JrsOrganizationType_NameTerm_LocalType */
typedef Mp7JrsPtr< IMp7JrsOrganizationType_NameTerm_LocalType > Mp7JrsOrganizationType_NameTerm_LocalPtr;

#define TypeOfOrganizationType_NameTerm_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("OrganizationType_NameTerm_type_LocalType")))
#define CreateOrganizationType_NameTerm_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfOrganizationType_NameTerm_type_LocalType))
class Mp7JrsOrganizationType_NameTerm_type_LocalType;
class IMp7JrsOrganizationType_NameTerm_type_LocalType;

#define TypeOfPackageType (Mp7JrsFactory::GetTypeIndex(X("PackageType")))
#define CreatePackageType (Mp7JrsFactory::CreateObject(TypeOfPackageType))
class Mp7JrsPackageType;
class IMp7JrsPackageType;
/** Smart pointer to instance of IMp7JrsPackageType */
typedef Mp7JrsPtr< IMp7JrsPackageType > Mp7JrsPackagePtr;

#define TypeOfPackageType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PackageType_CollectionType")))
#define CreatePackageType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPackageType_CollectionType))
class Mp7JrsPackageType_CollectionType;
class IMp7JrsPackageType_CollectionType;
/** Smart pointer to instance of IMp7JrsPackageType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPackageType_CollectionType > Mp7JrsPackageType_CollectionPtr;

#define TypeOfPackageType_LocalType (Mp7JrsFactory::GetTypeIndex(X("PackageType_LocalType")))
#define CreatePackageType_LocalType (Mp7JrsFactory::CreateObject(TypeOfPackageType_LocalType))
class Mp7JrsPackageType_LocalType;
class IMp7JrsPackageType_LocalType;
/** Smart pointer to instance of IMp7JrsPackageType_LocalType */
typedef Mp7JrsPtr< IMp7JrsPackageType_LocalType > Mp7JrsPackageType_LocalPtr;

#define TypeOfPackageType_Scheme_LocalType (Mp7JrsFactory::GetTypeIndex(X("PackageType_Scheme_LocalType")))
#define CreatePackageType_Scheme_LocalType (Mp7JrsFactory::CreateObject(TypeOfPackageType_Scheme_LocalType))
class Mp7JrsPackageType_Scheme_LocalType;
class IMp7JrsPackageType_Scheme_LocalType;
/** Smart pointer to instance of IMp7JrsPackageType_Scheme_LocalType */
typedef Mp7JrsPtr< IMp7JrsPackageType_Scheme_LocalType > Mp7JrsPackageType_Scheme_LocalPtr;

#define TypeOfpaddingType (Mp7JrsFactory::GetTypeIndex(X("paddingType")))
#define CreatepaddingType (Mp7JrsFactory::CreateObject(TypeOfpaddingType))
class Mp7JrspaddingType;
class IMp7JrspaddingType;
/** Smart pointer to instance of IMp7JrspaddingType */
typedef Mp7JrsPtr< IMp7JrspaddingType > Mp7JrspaddingPtr;

#define TypeOfpaddingType_LocalType (Mp7JrsFactory::GetTypeIndex(X("paddingType_LocalType")))
#define CreatepaddingType_LocalType (Mp7JrsFactory::CreateObject(TypeOfpaddingType_LocalType))
class Mp7JrspaddingType_LocalType;
class IMp7JrspaddingType_LocalType;

#define TypeOfpaddingType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("paddingType_LocalType0")))
#define CreatepaddingType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfpaddingType_LocalType0))
class Mp7JrspaddingType_LocalType0;
class IMp7JrspaddingType_LocalType0;
/** Smart pointer to instance of IMp7JrspaddingType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrspaddingType_LocalType0 > Mp7JrspaddingType_Local0Ptr;

#define TypeOfpaddingType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("paddingType_LocalType1")))
#define CreatepaddingType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfpaddingType_LocalType1))
class Mp7JrspaddingType_LocalType1;
class IMp7JrspaddingType_LocalType1;
/** Smart pointer to instance of IMp7JrspaddingType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrspaddingType_LocalType1 > Mp7JrspaddingType_Local1Ptr;

#define TypeOfParameterTrajectoryType (Mp7JrsFactory::GetTypeIndex(X("ParameterTrajectoryType")))
#define CreateParameterTrajectoryType (Mp7JrsFactory::CreateObject(TypeOfParameterTrajectoryType))
class Mp7JrsParameterTrajectoryType;
class IMp7JrsParameterTrajectoryType;
/** Smart pointer to instance of IMp7JrsParameterTrajectoryType */
typedef Mp7JrsPtr< IMp7JrsParameterTrajectoryType > Mp7JrsParameterTrajectoryPtr;

#define TypeOfParameterTrajectoryType_motionModel_LocalType (Mp7JrsFactory::GetTypeIndex(X("ParameterTrajectoryType_motionModel_LocalType")))
#define CreateParameterTrajectoryType_motionModel_LocalType (Mp7JrsFactory::CreateObject(TypeOfParameterTrajectoryType_motionModel_LocalType))
class Mp7JrsParameterTrajectoryType_motionModel_LocalType;
class IMp7JrsParameterTrajectoryType_motionModel_LocalType;

#define TypeOfParametricMotionType (Mp7JrsFactory::GetTypeIndex(X("ParametricMotionType")))
#define CreateParametricMotionType (Mp7JrsFactory::CreateObject(TypeOfParametricMotionType))
class Mp7JrsParametricMotionType;
class IMp7JrsParametricMotionType;
/** Smart pointer to instance of IMp7JrsParametricMotionType */
typedef Mp7JrsPtr< IMp7JrsParametricMotionType > Mp7JrsParametricMotionPtr;

#define TypeOfParametricMotionType_CoordDef_LocalType (Mp7JrsFactory::GetTypeIndex(X("ParametricMotionType_CoordDef_LocalType")))
#define CreateParametricMotionType_CoordDef_LocalType (Mp7JrsFactory::CreateObject(TypeOfParametricMotionType_CoordDef_LocalType))
class Mp7JrsParametricMotionType_CoordDef_LocalType;
class IMp7JrsParametricMotionType_CoordDef_LocalType;
/** Smart pointer to instance of IMp7JrsParametricMotionType_CoordDef_LocalType */
typedef Mp7JrsPtr< IMp7JrsParametricMotionType_CoordDef_LocalType > Mp7JrsParametricMotionType_CoordDef_LocalPtr;

#define TypeOfParametricMotionType_CoordRef_LocalType (Mp7JrsFactory::GetTypeIndex(X("ParametricMotionType_CoordRef_LocalType")))
#define CreateParametricMotionType_CoordRef_LocalType (Mp7JrsFactory::CreateObject(TypeOfParametricMotionType_CoordRef_LocalType))
class Mp7JrsParametricMotionType_CoordRef_LocalType;
class IMp7JrsParametricMotionType_CoordRef_LocalType;
/** Smart pointer to instance of IMp7JrsParametricMotionType_CoordRef_LocalType */
typedef Mp7JrsPtr< IMp7JrsParametricMotionType_CoordRef_LocalType > Mp7JrsParametricMotionType_CoordRef_LocalPtr;

#define TypeOfParametricMotionType_motionModel_LocalType (Mp7JrsFactory::GetTypeIndex(X("ParametricMotionType_motionModel_LocalType")))
#define CreateParametricMotionType_motionModel_LocalType (Mp7JrsFactory::CreateObject(TypeOfParametricMotionType_motionModel_LocalType))
class Mp7JrsParametricMotionType_motionModel_LocalType;
class IMp7JrsParametricMotionType_motionModel_LocalType;

#define TypeOfParametricMotionType_Parameters_LocalType (Mp7JrsFactory::GetTypeIndex(X("ParametricMotionType_Parameters_LocalType")))
#define CreateParametricMotionType_Parameters_LocalType (Mp7JrsFactory::CreateObject(TypeOfParametricMotionType_Parameters_LocalType))
class Mp7JrsParametricMotionType_Parameters_LocalType;
class IMp7JrsParametricMotionType_Parameters_LocalType;
/** Smart pointer to instance of IMp7JrsParametricMotionType_Parameters_LocalType */
typedef Mp7JrsPtr< IMp7JrsParametricMotionType_Parameters_LocalType > Mp7JrsParametricMotionType_Parameters_LocalPtr;

#define TypeOfParentalGuidanceType (Mp7JrsFactory::GetTypeIndex(X("ParentalGuidanceType")))
#define CreateParentalGuidanceType (Mp7JrsFactory::CreateObject(TypeOfParentalGuidanceType))
class Mp7JrsParentalGuidanceType;
class IMp7JrsParentalGuidanceType;
/** Smart pointer to instance of IMp7JrsParentalGuidanceType */
typedef Mp7JrsPtr< IMp7JrsParentalGuidanceType > Mp7JrsParentalGuidancePtr;

#define TypeOfParentalGuidanceType_Region_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ParentalGuidanceType_Region_CollectionType")))
#define CreateParentalGuidanceType_Region_CollectionType (Mp7JrsFactory::CreateObject(TypeOfParentalGuidanceType_Region_CollectionType))
class Mp7JrsParentalGuidanceType_Region_CollectionType;
class IMp7JrsParentalGuidanceType_Region_CollectionType;
/** Smart pointer to instance of IMp7JrsParentalGuidanceType_Region_CollectionType */
typedef Mp7JrsPtr< IMp7JrsParentalGuidanceType_Region_CollectionType > Mp7JrsParentalGuidanceType_Region_CollectionPtr;

#define TypeOfPartitionType (Mp7JrsFactory::GetTypeIndex(X("PartitionType")))
#define CreatePartitionType (Mp7JrsFactory::CreateObject(TypeOfPartitionType))
class Mp7JrsPartitionType;
class IMp7JrsPartitionType;
/** Smart pointer to instance of IMp7JrsPartitionType */
typedef Mp7JrsPtr< IMp7JrsPartitionType > Mp7JrsPartitionPtr;

#define TypeOfPartitionType_dim_LocalType (Mp7JrsFactory::GetTypeIndex(X("PartitionType_dim_LocalType")))
#define CreatePartitionType_dim_LocalType (Mp7JrsFactory::CreateObject(TypeOfPartitionType_dim_LocalType))
class Mp7JrsPartitionType_dim_LocalType;
class IMp7JrsPartitionType_dim_LocalType;
/** Smart pointer to instance of IMp7JrsPartitionType_dim_LocalType */
typedef Mp7JrsPtr< IMp7JrsPartitionType_dim_LocalType > Mp7JrsPartitionType_dim_LocalPtr;

#define TypeOfPercussiveInstrumentTimbreType (Mp7JrsFactory::GetTypeIndex(X("PercussiveInstrumentTimbreType")))
#define CreatePercussiveInstrumentTimbreType (Mp7JrsFactory::CreateObject(TypeOfPercussiveInstrumentTimbreType))
class Mp7JrsPercussiveInstrumentTimbreType;
class IMp7JrsPercussiveInstrumentTimbreType;
/** Smart pointer to instance of IMp7JrsPercussiveInstrumentTimbreType */
typedef Mp7JrsPtr< IMp7JrsPercussiveInstrumentTimbreType > Mp7JrsPercussiveInstrumentTimbrePtr;

#define TypeOfPersonGroupType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType")))
#define CreatePersonGroupType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType))
class Mp7JrsPersonGroupType;
class IMp7JrsPersonGroupType;
/** Smart pointer to instance of IMp7JrsPersonGroupType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType > Mp7JrsPersonGroupPtr;

#define TypeOfPersonGroupType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_CollectionType")))
#define CreatePersonGroupType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_CollectionType))
class Mp7JrsPersonGroupType_CollectionType;
class IMp7JrsPersonGroupType_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonGroupType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_CollectionType > Mp7JrsPersonGroupType_CollectionPtr;

#define TypeOfPersonGroupType_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_LocalType")))
#define CreatePersonGroupType_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_LocalType))
class Mp7JrsPersonGroupType_LocalType;
class IMp7JrsPersonGroupType_LocalType;
/** Smart pointer to instance of IMp7JrsPersonGroupType_LocalType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_LocalType > Mp7JrsPersonGroupType_LocalPtr;

#define TypeOfPersonGroupType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_Name_CollectionType")))
#define CreatePersonGroupType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_Name_CollectionType))
class Mp7JrsPersonGroupType_Name_CollectionType;
class IMp7JrsPersonGroupType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonGroupType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_Name_CollectionType > Mp7JrsPersonGroupType_Name_CollectionPtr;

#define TypeOfPersonGroupType_Name_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_Name_LocalType")))
#define CreatePersonGroupType_Name_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_Name_LocalType))
class Mp7JrsPersonGroupType_Name_LocalType;
class IMp7JrsPersonGroupType_Name_LocalType;
/** Smart pointer to instance of IMp7JrsPersonGroupType_Name_LocalType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_Name_LocalType > Mp7JrsPersonGroupType_Name_LocalPtr;

#define TypeOfPersonGroupType_Name_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_Name_type_LocalType")))
#define CreatePersonGroupType_Name_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_Name_type_LocalType))
class Mp7JrsPersonGroupType_Name_type_LocalType;
class IMp7JrsPersonGroupType_Name_type_LocalType;

#define TypeOfPersonGroupType_NameTerm_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_NameTerm_CollectionType")))
#define CreatePersonGroupType_NameTerm_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_NameTerm_CollectionType))
class Mp7JrsPersonGroupType_NameTerm_CollectionType;
class IMp7JrsPersonGroupType_NameTerm_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonGroupType_NameTerm_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_NameTerm_CollectionType > Mp7JrsPersonGroupType_NameTerm_CollectionPtr;

#define TypeOfPersonGroupType_NameTerm_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_NameTerm_LocalType")))
#define CreatePersonGroupType_NameTerm_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_NameTerm_LocalType))
class Mp7JrsPersonGroupType_NameTerm_LocalType;
class IMp7JrsPersonGroupType_NameTerm_LocalType;
/** Smart pointer to instance of IMp7JrsPersonGroupType_NameTerm_LocalType */
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_NameTerm_LocalType > Mp7JrsPersonGroupType_NameTerm_LocalPtr;

#define TypeOfPersonGroupType_NameTerm_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonGroupType_NameTerm_type_LocalType")))
#define CreatePersonGroupType_NameTerm_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonGroupType_NameTerm_type_LocalType))
class Mp7JrsPersonGroupType_NameTerm_type_LocalType;
class IMp7JrsPersonGroupType_NameTerm_type_LocalType;

#define TypeOfPersonNameType (Mp7JrsFactory::GetTypeIndex(X("PersonNameType")))
#define CreatePersonNameType (Mp7JrsFactory::CreateObject(TypeOfPersonNameType))
class Mp7JrsPersonNameType;
class IMp7JrsPersonNameType;
/** Smart pointer to instance of IMp7JrsPersonNameType */
typedef Mp7JrsPtr< IMp7JrsPersonNameType > Mp7JrsPersonNamePtr;

#define TypeOfPersonNameType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonNameType_CollectionType")))
#define CreatePersonNameType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonNameType_CollectionType))
class Mp7JrsPersonNameType_CollectionType;
class IMp7JrsPersonNameType_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonNameType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonNameType_CollectionType > Mp7JrsPersonNameType_CollectionPtr;

#define TypeOfPersonNameType_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonNameType_LocalType")))
#define CreatePersonNameType_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonNameType_LocalType))
class Mp7JrsPersonNameType_LocalType;
class IMp7JrsPersonNameType_LocalType;
/** Smart pointer to instance of IMp7JrsPersonNameType_LocalType */
typedef Mp7JrsPtr< IMp7JrsPersonNameType_LocalType > Mp7JrsPersonNameType_LocalPtr;

#define TypeOfPersonNameType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonNameType_type_LocalType")))
#define CreatePersonNameType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonNameType_type_LocalType))
class Mp7JrsPersonNameType_type_LocalType;
class IMp7JrsPersonNameType_type_LocalType;

#define TypeOfPersonType (Mp7JrsFactory::GetTypeIndex(X("PersonType")))
#define CreatePersonType (Mp7JrsFactory::CreateObject(TypeOfPersonType))
class Mp7JrsPersonType;
class IMp7JrsPersonType;
/** Smart pointer to instance of IMp7JrsPersonType */
typedef Mp7JrsPtr< IMp7JrsPersonType > Mp7JrsPersonPtr;

#define TypeOfPersonType_Affiliation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonType_Affiliation_CollectionType")))
#define CreatePersonType_Affiliation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonType_Affiliation_CollectionType))
class Mp7JrsPersonType_Affiliation_CollectionType;
class IMp7JrsPersonType_Affiliation_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonType_Affiliation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonType_Affiliation_CollectionType > Mp7JrsPersonType_Affiliation_CollectionPtr;

#define TypeOfPersonType_Affiliation_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonType_Affiliation_LocalType")))
#define CreatePersonType_Affiliation_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonType_Affiliation_LocalType))
class Mp7JrsPersonType_Affiliation_LocalType;
class IMp7JrsPersonType_Affiliation_LocalType;
/** Smart pointer to instance of IMp7JrsPersonType_Affiliation_LocalType */
typedef Mp7JrsPtr< IMp7JrsPersonType_Affiliation_LocalType > Mp7JrsPersonType_Affiliation_LocalPtr;

#define TypeOfPersonType_Citizenship_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonType_Citizenship_CollectionType")))
#define CreatePersonType_Citizenship_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonType_Citizenship_CollectionType))
class Mp7JrsPersonType_Citizenship_CollectionType;
class IMp7JrsPersonType_Citizenship_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonType_Citizenship_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonType_Citizenship_CollectionType > Mp7JrsPersonType_Citizenship_CollectionPtr;

#define TypeOfPersonType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonType_CollectionType")))
#define CreatePersonType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonType_CollectionType))
class Mp7JrsPersonType_CollectionType;
class IMp7JrsPersonType_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonType_CollectionType > Mp7JrsPersonType_CollectionPtr;

#define TypeOfPersonType_ElectronicAddress_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PersonType_ElectronicAddress_CollectionType")))
#define CreatePersonType_ElectronicAddress_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPersonType_ElectronicAddress_CollectionType))
class Mp7JrsPersonType_ElectronicAddress_CollectionType;
class IMp7JrsPersonType_ElectronicAddress_CollectionType;
/** Smart pointer to instance of IMp7JrsPersonType_ElectronicAddress_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPersonType_ElectronicAddress_CollectionType > Mp7JrsPersonType_ElectronicAddress_CollectionPtr;

#define TypeOfPersonType_LocalType (Mp7JrsFactory::GetTypeIndex(X("PersonType_LocalType")))
#define CreatePersonType_LocalType (Mp7JrsFactory::CreateObject(TypeOfPersonType_LocalType))
class Mp7JrsPersonType_LocalType;
class IMp7JrsPersonType_LocalType;
/** Smart pointer to instance of IMp7JrsPersonType_LocalType */
typedef Mp7JrsPtr< IMp7JrsPersonType_LocalType > Mp7JrsPersonType_LocalPtr;

#define TypeOfPhoneLexiconIndexType (Mp7JrsFactory::GetTypeIndex(X("PhoneLexiconIndexType")))
#define CreatePhoneLexiconIndexType (Mp7JrsFactory::CreateObject(TypeOfPhoneLexiconIndexType))
class Mp7JrsPhoneLexiconIndexType;
class IMp7JrsPhoneLexiconIndexType;
/** Smart pointer to instance of IMp7JrsPhoneLexiconIndexType */
typedef Mp7JrsPtr< IMp7JrsPhoneLexiconIndexType > Mp7JrsPhoneLexiconIndexPtr;

#define TypeOfPhoneLexiconType (Mp7JrsFactory::GetTypeIndex(X("PhoneLexiconType")))
#define CreatePhoneLexiconType (Mp7JrsFactory::CreateObject(TypeOfPhoneLexiconType))
class Mp7JrsPhoneLexiconType;
class IMp7JrsPhoneLexiconType;
/** Smart pointer to instance of IMp7JrsPhoneLexiconType */
typedef Mp7JrsPtr< IMp7JrsPhoneLexiconType > Mp7JrsPhoneLexiconPtr;

#define TypeOfPhoneLexiconType_Token_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PhoneLexiconType_Token_CollectionType")))
#define CreatePhoneLexiconType_Token_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPhoneLexiconType_Token_CollectionType))
class Mp7JrsPhoneLexiconType_Token_CollectionType;
class IMp7JrsPhoneLexiconType_Token_CollectionType;
/** Smart pointer to instance of IMp7JrsPhoneLexiconType_Token_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPhoneLexiconType_Token_CollectionType > Mp7JrsPhoneLexiconType_Token_CollectionPtr;

#define TypeOfphoneticAlphabetType (Mp7JrsFactory::GetTypeIndex(X("phoneticAlphabetType")))
#define CreatephoneticAlphabetType (Mp7JrsFactory::CreateObject(TypeOfphoneticAlphabetType))
class Mp7JrsphoneticAlphabetType;
class IMp7JrsphoneticAlphabetType;

#define TypeOfPhoneticTranscriptionLexiconType (Mp7JrsFactory::GetTypeIndex(X("PhoneticTranscriptionLexiconType")))
#define CreatePhoneticTranscriptionLexiconType (Mp7JrsFactory::CreateObject(TypeOfPhoneticTranscriptionLexiconType))
class Mp7JrsPhoneticTranscriptionLexiconType;
class IMp7JrsPhoneticTranscriptionLexiconType;
/** Smart pointer to instance of IMp7JrsPhoneticTranscriptionLexiconType */
typedef Mp7JrsPtr< IMp7JrsPhoneticTranscriptionLexiconType > Mp7JrsPhoneticTranscriptionLexiconPtr;

#define TypeOfPhoneticTranscriptionLexiconType_Token_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PhoneticTranscriptionLexiconType_Token_CollectionType")))
#define CreatePhoneticTranscriptionLexiconType_Token_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPhoneticTranscriptionLexiconType_Token_CollectionType))
class Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType;
class IMp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType;
/** Smart pointer to instance of IMp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType > Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr;

#define TypeOfPhoneticTranscriptionLexiconType_Token_LocalType (Mp7JrsFactory::GetTypeIndex(X("PhoneticTranscriptionLexiconType_Token_LocalType")))
#define CreatePhoneticTranscriptionLexiconType_Token_LocalType (Mp7JrsFactory::CreateObject(TypeOfPhoneticTranscriptionLexiconType_Token_LocalType))
class Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType;
class IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType;
/** Smart pointer to instance of IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType */
typedef Mp7JrsPtr< IMp7JrsPhoneticTranscriptionLexiconType_Token_LocalType > Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalPtr;

#define TypeOfPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType")))
#define CreatePhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType))
class Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType;
class IMp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType;
/** Smart pointer to instance of IMp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType > Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionPtr;

#define TypeOfPhoneType (Mp7JrsFactory::GetTypeIndex(X("PhoneType")))
#define CreatePhoneType (Mp7JrsFactory::CreateObject(TypeOfPhoneType))
class Mp7JrsPhoneType;
class IMp7JrsPhoneType;
/** Smart pointer to instance of IMp7JrsPhoneType */
typedef Mp7JrsPtr< IMp7JrsPhoneType > Mp7JrsPhonePtr;

#define TypeOfPlaceType (Mp7JrsFactory::GetTypeIndex(X("PlaceType")))
#define CreatePlaceType (Mp7JrsFactory::CreateObject(TypeOfPlaceType))
class Mp7JrsPlaceType;
class IMp7JrsPlaceType;
/** Smart pointer to instance of IMp7JrsPlaceType */
typedef Mp7JrsPtr< IMp7JrsPlaceType > Mp7JrsPlacePtr;

#define TypeOfPlaceType_AdministrativeUnit_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_AdministrativeUnit_CollectionType")))
#define CreatePlaceType_AdministrativeUnit_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_AdministrativeUnit_CollectionType))
class Mp7JrsPlaceType_AdministrativeUnit_CollectionType;
class IMp7JrsPlaceType_AdministrativeUnit_CollectionType;
/** Smart pointer to instance of IMp7JrsPlaceType_AdministrativeUnit_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_AdministrativeUnit_CollectionType > Mp7JrsPlaceType_AdministrativeUnit_CollectionPtr;

#define TypeOfPlaceType_AdministrativeUnit_LocalType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_AdministrativeUnit_LocalType")))
#define CreatePlaceType_AdministrativeUnit_LocalType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_AdministrativeUnit_LocalType))
class Mp7JrsPlaceType_AdministrativeUnit_LocalType;
class IMp7JrsPlaceType_AdministrativeUnit_LocalType;
/** Smart pointer to instance of IMp7JrsPlaceType_AdministrativeUnit_LocalType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_AdministrativeUnit_LocalType > Mp7JrsPlaceType_AdministrativeUnit_LocalPtr;

#define TypeOfPlaceType_AstronomicalBody_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_AstronomicalBody_CollectionType")))
#define CreatePlaceType_AstronomicalBody_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_AstronomicalBody_CollectionType))
class Mp7JrsPlaceType_AstronomicalBody_CollectionType;
class IMp7JrsPlaceType_AstronomicalBody_CollectionType;
/** Smart pointer to instance of IMp7JrsPlaceType_AstronomicalBody_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_AstronomicalBody_CollectionType > Mp7JrsPlaceType_AstronomicalBody_CollectionPtr;

#define TypeOfPlaceType_GeographicPosition_LocalType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_GeographicPosition_LocalType")))
#define CreatePlaceType_GeographicPosition_LocalType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_GeographicPosition_LocalType))
class Mp7JrsPlaceType_GeographicPosition_LocalType;
class IMp7JrsPlaceType_GeographicPosition_LocalType;
/** Smart pointer to instance of IMp7JrsPlaceType_GeographicPosition_LocalType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_GeographicPosition_LocalType > Mp7JrsPlaceType_GeographicPosition_LocalPtr;

#define TypeOfPlaceType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_Name_CollectionType")))
#define CreatePlaceType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_Name_CollectionType))
class Mp7JrsPlaceType_Name_CollectionType;
class IMp7JrsPlaceType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsPlaceType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_Name_CollectionType > Mp7JrsPlaceType_Name_CollectionPtr;

#define TypeOfPlaceType_NameTerm_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_NameTerm_CollectionType")))
#define CreatePlaceType_NameTerm_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_NameTerm_CollectionType))
class Mp7JrsPlaceType_NameTerm_CollectionType;
class IMp7JrsPlaceType_NameTerm_CollectionType;
/** Smart pointer to instance of IMp7JrsPlaceType_NameTerm_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_NameTerm_CollectionType > Mp7JrsPlaceType_NameTerm_CollectionPtr;

#define TypeOfPlaceType_PostalAddress_AddressLine_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_PostalAddress_AddressLine_CollectionType")))
#define CreatePlaceType_PostalAddress_AddressLine_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_PostalAddress_AddressLine_CollectionType))
class Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionType;
class IMp7JrsPlaceType_PostalAddress_AddressLine_CollectionType;
/** Smart pointer to instance of IMp7JrsPlaceType_PostalAddress_AddressLine_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_PostalAddress_AddressLine_CollectionType > Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionPtr;

#define TypeOfPlaceType_PostalAddress_LocalType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_PostalAddress_LocalType")))
#define CreatePlaceType_PostalAddress_LocalType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_PostalAddress_LocalType))
class Mp7JrsPlaceType_PostalAddress_LocalType;
class IMp7JrsPlaceType_PostalAddress_LocalType;
/** Smart pointer to instance of IMp7JrsPlaceType_PostalAddress_LocalType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_PostalAddress_LocalType > Mp7JrsPlaceType_PostalAddress_LocalPtr;

#define TypeOfPlaceType_Region_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PlaceType_Region_CollectionType")))
#define CreatePlaceType_Region_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPlaceType_Region_CollectionType))
class Mp7JrsPlaceType_Region_CollectionType;
class IMp7JrsPlaceType_Region_CollectionType;
/** Smart pointer to instance of IMp7JrsPlaceType_Region_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPlaceType_Region_CollectionType > Mp7JrsPlaceType_Region_CollectionPtr;

#define TypeOfPointOfViewType (Mp7JrsFactory::GetTypeIndex(X("PointOfViewType")))
#define CreatePointOfViewType (Mp7JrsFactory::CreateObject(TypeOfPointOfViewType))
class Mp7JrsPointOfViewType;
class IMp7JrsPointOfViewType;
/** Smart pointer to instance of IMp7JrsPointOfViewType */
typedef Mp7JrsPtr< IMp7JrsPointOfViewType > Mp7JrsPointOfViewPtr;

#define TypeOfPointOfViewType_Importance_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PointOfViewType_Importance_CollectionType")))
#define CreatePointOfViewType_Importance_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPointOfViewType_Importance_CollectionType))
class Mp7JrsPointOfViewType_Importance_CollectionType;
class IMp7JrsPointOfViewType_Importance_CollectionType;
/** Smart pointer to instance of IMp7JrsPointOfViewType_Importance_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPointOfViewType_Importance_CollectionType > Mp7JrsPointOfViewType_Importance_CollectionPtr;

#define TypeOfPointOfViewType_Importance_LocalType (Mp7JrsFactory::GetTypeIndex(X("PointOfViewType_Importance_LocalType")))
#define CreatePointOfViewType_Importance_LocalType (Mp7JrsFactory::CreateObject(TypeOfPointOfViewType_Importance_LocalType))
class Mp7JrsPointOfViewType_Importance_LocalType;
class IMp7JrsPointOfViewType_Importance_LocalType;
/** Smart pointer to instance of IMp7JrsPointOfViewType_Importance_LocalType */
typedef Mp7JrsPtr< IMp7JrsPointOfViewType_Importance_LocalType > Mp7JrsPointOfViewType_Importance_LocalPtr;

#define TypeOfPoissonDistributionType (Mp7JrsFactory::GetTypeIndex(X("PoissonDistributionType")))
#define CreatePoissonDistributionType (Mp7JrsFactory::CreateObject(TypeOfPoissonDistributionType))
class Mp7JrsPoissonDistributionType;
class IMp7JrsPoissonDistributionType;
/** Smart pointer to instance of IMp7JrsPoissonDistributionType */
typedef Mp7JrsPtr< IMp7JrsPoissonDistributionType > Mp7JrsPoissonDistributionPtr;

#define TypeOfPositionType (Mp7JrsFactory::GetTypeIndex(X("PositionType")))
#define CreatePositionType (Mp7JrsFactory::CreateObject(TypeOfPositionType))
class Mp7JrsPositionType;
class IMp7JrsPositionType;
/** Smart pointer to instance of IMp7JrsPositionType */
typedef Mp7JrsPtr< IMp7JrsPositionType > Mp7JrsPositionPtr;

#define TypeOfPreferenceConditionType (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType")))
#define CreatePreferenceConditionType (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType))
class Mp7JrsPreferenceConditionType;
class IMp7JrsPreferenceConditionType;
/** Smart pointer to instance of IMp7JrsPreferenceConditionType */
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType > Mp7JrsPreferenceConditionPtr;

#define TypeOfPreferenceConditionType_Time_CollectionType (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType_Time_CollectionType")))
#define CreatePreferenceConditionType_Time_CollectionType (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType_Time_CollectionType))
class Mp7JrsPreferenceConditionType_Time_CollectionType;
class IMp7JrsPreferenceConditionType_Time_CollectionType;
/** Smart pointer to instance of IMp7JrsPreferenceConditionType_Time_CollectionType */
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_CollectionType > Mp7JrsPreferenceConditionType_Time_CollectionPtr;

#define TypeOfPreferenceConditionType_Time_LocalType (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType_Time_LocalType")))
#define CreatePreferenceConditionType_Time_LocalType (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType_Time_LocalType))
class Mp7JrsPreferenceConditionType_Time_LocalType;
class IMp7JrsPreferenceConditionType_Time_LocalType;
/** Smart pointer to instance of IMp7JrsPreferenceConditionType_Time_LocalType */
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_LocalType > Mp7JrsPreferenceConditionType_Time_LocalPtr;

#define TypeOfPreferenceConditionType_Time_recurrence_LocalType (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType_Time_recurrence_LocalType")))
#define CreatePreferenceConditionType_Time_recurrence_LocalType (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType_Time_recurrence_LocalType))
class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType;
class IMp7JrsPreferenceConditionType_Time_recurrence_LocalType;

#define TypeOfPreferenceConditionType_Time_recurrence_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType_Time_recurrence_LocalType0")))
#define CreatePreferenceConditionType_Time_recurrence_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType_Time_recurrence_LocalType0))
class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType0;
class IMp7JrsPreferenceConditionType_Time_recurrence_LocalType0;
/** Smart pointer to instance of IMp7JrsPreferenceConditionType_Time_recurrence_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_recurrence_LocalType0 > Mp7JrsPreferenceConditionType_Time_recurrence_Local0Ptr;

#define TypeOfPreferenceConditionType_Time_recurrence_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType_Time_recurrence_LocalType1")))
#define CreatePreferenceConditionType_Time_recurrence_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType_Time_recurrence_LocalType1))
class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1;
class IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1;
/** Smart pointer to instance of IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1 > Mp7JrsPreferenceConditionType_Time_recurrence_Local1Ptr;

#define TypeOfPreferenceConditionType_Time_recurrence_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("PreferenceConditionType_Time_recurrence_LocalType2")))
#define CreatePreferenceConditionType_Time_recurrence_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfPreferenceConditionType_Time_recurrence_LocalType2))
class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType2;
class IMp7JrsPreferenceConditionType_Time_recurrence_LocalType2;
/** Smart pointer to instance of IMp7JrsPreferenceConditionType_Time_recurrence_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_recurrence_LocalType2 > Mp7JrsPreferenceConditionType_Time_recurrence_Local2Ptr;

#define TypeOfpreferenceValueType (Mp7JrsFactory::GetTypeIndex(X("preferenceValueType")))
#define CreatepreferenceValueType (Mp7JrsFactory::CreateObject(TypeOfpreferenceValueType))
class Mp7JrspreferenceValueType;
class IMp7JrspreferenceValueType;
/** Smart pointer to instance of IMp7JrspreferenceValueType */
typedef Mp7JrsPtr< IMp7JrspreferenceValueType > Mp7JrspreferenceValuePtr;

#define TypeOfProbabilityClassificationModelType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityClassificationModelType")))
#define CreateProbabilityClassificationModelType (Mp7JrsFactory::CreateObject(TypeOfProbabilityClassificationModelType))
class Mp7JrsProbabilityClassificationModelType;
class IMp7JrsProbabilityClassificationModelType;
/** Smart pointer to instance of IMp7JrsProbabilityClassificationModelType */
typedef Mp7JrsPtr< IMp7JrsProbabilityClassificationModelType > Mp7JrsProbabilityClassificationModelPtr;

#define TypeOfProbabilityClassificationModelType_ProbabilityModelClass_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityClassificationModelType_ProbabilityModelClass_CollectionType")))
#define CreateProbabilityClassificationModelType_ProbabilityModelClass_CollectionType (Mp7JrsFactory::CreateObject(TypeOfProbabilityClassificationModelType_ProbabilityModelClass_CollectionType))
class Mp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionType;
class IMp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionType;
/** Smart pointer to instance of IMp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionType */
typedef Mp7JrsPtr< IMp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionType > Mp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionPtr;

#define TypeOfProbabilityDistributionType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType")))
#define CreateProbabilityDistributionType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType))
class Mp7JrsProbabilityDistributionType;
class IMp7JrsProbabilityDistributionType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType > Mp7JrsProbabilityDistributionPtr;

#define TypeOfProbabilityDistributionType_Cumulant_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType_Cumulant_CollectionType")))
#define CreateProbabilityDistributionType_Cumulant_CollectionType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType_Cumulant_CollectionType))
class Mp7JrsProbabilityDistributionType_Cumulant_CollectionType;
class IMp7JrsProbabilityDistributionType_Cumulant_CollectionType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType_Cumulant_CollectionType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Cumulant_CollectionType > Mp7JrsProbabilityDistributionType_Cumulant_CollectionPtr;

#define TypeOfProbabilityDistributionType_Cumulant_LocalType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType_Cumulant_LocalType")))
#define CreateProbabilityDistributionType_Cumulant_LocalType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType_Cumulant_LocalType))
class Mp7JrsProbabilityDistributionType_Cumulant_LocalType;
class IMp7JrsProbabilityDistributionType_Cumulant_LocalType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType_Cumulant_LocalType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Cumulant_LocalType > Mp7JrsProbabilityDistributionType_Cumulant_LocalPtr;

#define TypeOfProbabilityDistributionType_Cumulant_Value_LocalType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType_Cumulant_Value_LocalType")))
#define CreateProbabilityDistributionType_Cumulant_Value_LocalType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType_Cumulant_Value_LocalType))
class Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType;
class IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Cumulant_Value_LocalType > Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalPtr;

#define TypeOfProbabilityDistributionType_Moment_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType_Moment_CollectionType")))
#define CreateProbabilityDistributionType_Moment_CollectionType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType_Moment_CollectionType))
class Mp7JrsProbabilityDistributionType_Moment_CollectionType;
class IMp7JrsProbabilityDistributionType_Moment_CollectionType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType_Moment_CollectionType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Moment_CollectionType > Mp7JrsProbabilityDistributionType_Moment_CollectionPtr;

#define TypeOfProbabilityDistributionType_Moment_LocalType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType_Moment_LocalType")))
#define CreateProbabilityDistributionType_Moment_LocalType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType_Moment_LocalType))
class Mp7JrsProbabilityDistributionType_Moment_LocalType;
class IMp7JrsProbabilityDistributionType_Moment_LocalType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType_Moment_LocalType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Moment_LocalType > Mp7JrsProbabilityDistributionType_Moment_LocalPtr;

#define TypeOfProbabilityDistributionType_Moment_Value_LocalType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityDistributionType_Moment_Value_LocalType")))
#define CreateProbabilityDistributionType_Moment_Value_LocalType (Mp7JrsFactory::CreateObject(TypeOfProbabilityDistributionType_Moment_Value_LocalType))
class Mp7JrsProbabilityDistributionType_Moment_Value_LocalType;
class IMp7JrsProbabilityDistributionType_Moment_Value_LocalType;
/** Smart pointer to instance of IMp7JrsProbabilityDistributionType_Moment_Value_LocalType */
typedef Mp7JrsPtr< IMp7JrsProbabilityDistributionType_Moment_Value_LocalType > Mp7JrsProbabilityDistributionType_Moment_Value_LocalPtr;

#define TypeOfProbabilityMatrixType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityMatrixType")))
#define CreateProbabilityMatrixType (Mp7JrsFactory::CreateObject(TypeOfProbabilityMatrixType))
class Mp7JrsProbabilityMatrixType;
class IMp7JrsProbabilityMatrixType;
/** Smart pointer to instance of IMp7JrsProbabilityMatrixType */
typedef Mp7JrsPtr< IMp7JrsProbabilityMatrixType > Mp7JrsProbabilityMatrixPtr;

#define TypeOfProbabilityModelClassType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityModelClassType")))
#define CreateProbabilityModelClassType (Mp7JrsFactory::CreateObject(TypeOfProbabilityModelClassType))
class Mp7JrsProbabilityModelClassType;
class IMp7JrsProbabilityModelClassType;
/** Smart pointer to instance of IMp7JrsProbabilityModelClassType */
typedef Mp7JrsPtr< IMp7JrsProbabilityModelClassType > Mp7JrsProbabilityModelClassPtr;

#define TypeOfProbabilityModelClassType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityModelClassType_CollectionType")))
#define CreateProbabilityModelClassType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfProbabilityModelClassType_CollectionType))
class Mp7JrsProbabilityModelClassType_CollectionType;
class IMp7JrsProbabilityModelClassType_CollectionType;
/** Smart pointer to instance of IMp7JrsProbabilityModelClassType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsProbabilityModelClassType_CollectionType > Mp7JrsProbabilityModelClassType_CollectionPtr;

#define TypeOfProbabilityModelClassType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityModelClassType_LocalType")))
#define CreateProbabilityModelClassType_LocalType (Mp7JrsFactory::CreateObject(TypeOfProbabilityModelClassType_LocalType))
class Mp7JrsProbabilityModelClassType_LocalType;
class IMp7JrsProbabilityModelClassType_LocalType;
/** Smart pointer to instance of IMp7JrsProbabilityModelClassType_LocalType */
typedef Mp7JrsPtr< IMp7JrsProbabilityModelClassType_LocalType > Mp7JrsProbabilityModelClassType_LocalPtr;

#define TypeOfProbabilityModelType (Mp7JrsFactory::GetTypeIndex(X("ProbabilityModelType")))
#define CreateProbabilityModelType (Mp7JrsFactory::CreateObject(TypeOfProbabilityModelType))
class Mp7JrsProbabilityModelType;
class IMp7JrsProbabilityModelType;
/** Smart pointer to instance of IMp7JrsProbabilityModelType */
typedef Mp7JrsPtr< IMp7JrsProbabilityModelType > Mp7JrsProbabilityModelPtr;

#define TypeOfprobabilityVector (Mp7JrsFactory::GetTypeIndex(X("probabilityVector")))
#define CreateprobabilityVector (Mp7JrsFactory::CreateObject(TypeOfprobabilityVector))
class Mp7JrsprobabilityVector;
class IMp7JrsprobabilityVector;
/** Smart pointer to instance of IMp7JrsprobabilityVector */
typedef Mp7JrsPtr< IMp7JrsprobabilityVector > Mp7JrsprobabilityVectorPtr;

#define TypeOfprobabilityVector_LocalType (Mp7JrsFactory::GetTypeIndex(X("probabilityVector_LocalType")))
#define CreateprobabilityVector_LocalType (Mp7JrsFactory::CreateObject(TypeOfprobabilityVector_LocalType))
class Mp7JrsprobabilityVector_LocalType;
class IMp7JrsprobabilityVector_LocalType;
/** Smart pointer to instance of IMp7JrsprobabilityVector_LocalType */
typedef Mp7JrsPtr< IMp7JrsprobabilityVector_LocalType > Mp7JrsprobabilityVector_LocalPtr;

#define TypeOfPullbackDefinitionType (Mp7JrsFactory::GetTypeIndex(X("PullbackDefinitionType")))
#define CreatePullbackDefinitionType (Mp7JrsFactory::CreateObject(TypeOfPullbackDefinitionType))
class Mp7JrsPullbackDefinitionType;
class IMp7JrsPullbackDefinitionType;
/** Smart pointer to instance of IMp7JrsPullbackDefinitionType */
typedef Mp7JrsPtr< IMp7JrsPullbackDefinitionType > Mp7JrsPullbackDefinitionPtr;

#define TypeOfPushoutDefinitionType (Mp7JrsFactory::GetTypeIndex(X("PushoutDefinitionType")))
#define CreatePushoutDefinitionType (Mp7JrsFactory::CreateObject(TypeOfPushoutDefinitionType))
class Mp7JrsPushoutDefinitionType;
class IMp7JrsPushoutDefinitionType;
/** Smart pointer to instance of IMp7JrsPushoutDefinitionType */
typedef Mp7JrsPtr< IMp7JrsPushoutDefinitionType > Mp7JrsPushoutDefinitionPtr;

#define TypeOfRatingType (Mp7JrsFactory::GetTypeIndex(X("RatingType")))
#define CreateRatingType (Mp7JrsFactory::CreateObject(TypeOfRatingType))
class Mp7JrsRatingType;
class IMp7JrsRatingType;
/** Smart pointer to instance of IMp7JrsRatingType */
typedef Mp7JrsPtr< IMp7JrsRatingType > Mp7JrsRatingPtr;

#define TypeOfRatingType_RatingScheme_LocalType (Mp7JrsFactory::GetTypeIndex(X("RatingType_RatingScheme_LocalType")))
#define CreateRatingType_RatingScheme_LocalType (Mp7JrsFactory::CreateObject(TypeOfRatingType_RatingScheme_LocalType))
class Mp7JrsRatingType_RatingScheme_LocalType;
class IMp7JrsRatingType_RatingScheme_LocalType;
/** Smart pointer to instance of IMp7JrsRatingType_RatingScheme_LocalType */
typedef Mp7JrsPtr< IMp7JrsRatingType_RatingScheme_LocalType > Mp7JrsRatingType_RatingScheme_LocalPtr;

#define TypeOfRatingType_RatingScheme_style_LocalType (Mp7JrsFactory::GetTypeIndex(X("RatingType_RatingScheme_style_LocalType")))
#define CreateRatingType_RatingScheme_style_LocalType (Mp7JrsFactory::CreateObject(TypeOfRatingType_RatingScheme_style_LocalType))
class Mp7JrsRatingType_RatingScheme_style_LocalType;
class IMp7JrsRatingType_RatingScheme_style_LocalType;

#define TypeOfReferenceType (Mp7JrsFactory::GetTypeIndex(X("ReferenceType")))
#define CreateReferenceType (Mp7JrsFactory::CreateObject(TypeOfReferenceType))
class Mp7JrsReferenceType;
class IMp7JrsReferenceType;
/** Smart pointer to instance of IMp7JrsReferenceType */
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

#define TypeOfregionCode (Mp7JrsFactory::GetTypeIndex(X("regionCode")))
#define CreateregionCode (Mp7JrsFactory::CreateObject(TypeOfregionCode))
class Mp7JrsregionCode;
class IMp7JrsregionCode;
/** Smart pointer to instance of IMp7JrsregionCode */
typedef Mp7JrsPtr< IMp7JrsregionCode > Mp7JrsregionCodePtr;

#define TypeOfRegionLocatorType (Mp7JrsFactory::GetTypeIndex(X("RegionLocatorType")))
#define CreateRegionLocatorType (Mp7JrsFactory::CreateObject(TypeOfRegionLocatorType))
class Mp7JrsRegionLocatorType;
class IMp7JrsRegionLocatorType;
/** Smart pointer to instance of IMp7JrsRegionLocatorType */
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType > Mp7JrsRegionLocatorPtr;

#define TypeOfRegionLocatorType_Box_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RegionLocatorType_Box_CollectionType")))
#define CreateRegionLocatorType_Box_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRegionLocatorType_Box_CollectionType))
class Mp7JrsRegionLocatorType_Box_CollectionType;
class IMp7JrsRegionLocatorType_Box_CollectionType;
/** Smart pointer to instance of IMp7JrsRegionLocatorType_Box_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Box_CollectionType > Mp7JrsRegionLocatorType_Box_CollectionPtr;

#define TypeOfRegionLocatorType_Box_LocalType (Mp7JrsFactory::GetTypeIndex(X("RegionLocatorType_Box_LocalType")))
#define CreateRegionLocatorType_Box_LocalType (Mp7JrsFactory::CreateObject(TypeOfRegionLocatorType_Box_LocalType))
class Mp7JrsRegionLocatorType_Box_LocalType;
class IMp7JrsRegionLocatorType_Box_LocalType;
/** Smart pointer to instance of IMp7JrsRegionLocatorType_Box_LocalType */
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Box_LocalType > Mp7JrsRegionLocatorType_Box_LocalPtr;

#define TypeOfRegionLocatorType_CoordRef_LocalType (Mp7JrsFactory::GetTypeIndex(X("RegionLocatorType_CoordRef_LocalType")))
#define CreateRegionLocatorType_CoordRef_LocalType (Mp7JrsFactory::CreateObject(TypeOfRegionLocatorType_CoordRef_LocalType))
class Mp7JrsRegionLocatorType_CoordRef_LocalType;
class IMp7JrsRegionLocatorType_CoordRef_LocalType;
/** Smart pointer to instance of IMp7JrsRegionLocatorType_CoordRef_LocalType */
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_CoordRef_LocalType > Mp7JrsRegionLocatorType_CoordRef_LocalPtr;

#define TypeOfRegionLocatorType_Polygon_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RegionLocatorType_Polygon_CollectionType")))
#define CreateRegionLocatorType_Polygon_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRegionLocatorType_Polygon_CollectionType))
class Mp7JrsRegionLocatorType_Polygon_CollectionType;
class IMp7JrsRegionLocatorType_Polygon_CollectionType;
/** Smart pointer to instance of IMp7JrsRegionLocatorType_Polygon_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Polygon_CollectionType > Mp7JrsRegionLocatorType_Polygon_CollectionPtr;

#define TypeOfRegionLocatorType_Polygon_LocalType (Mp7JrsFactory::GetTypeIndex(X("RegionLocatorType_Polygon_LocalType")))
#define CreateRegionLocatorType_Polygon_LocalType (Mp7JrsFactory::CreateObject(TypeOfRegionLocatorType_Polygon_LocalType))
class Mp7JrsRegionLocatorType_Polygon_LocalType;
class IMp7JrsRegionLocatorType_Polygon_LocalType;
/** Smart pointer to instance of IMp7JrsRegionLocatorType_Polygon_LocalType */
typedef Mp7JrsPtr< IMp7JrsRegionLocatorType_Polygon_LocalType > Mp7JrsRegionLocatorType_Polygon_LocalPtr;

#define TypeOfRegionShapeType (Mp7JrsFactory::GetTypeIndex(X("RegionShapeType")))
#define CreateRegionShapeType (Mp7JrsFactory::CreateObject(TypeOfRegionShapeType))
class Mp7JrsRegionShapeType;
class IMp7JrsRegionShapeType;
/** Smart pointer to instance of IMp7JrsRegionShapeType */
typedef Mp7JrsPtr< IMp7JrsRegionShapeType > Mp7JrsRegionShapePtr;

#define TypeOfRegionShapeType_MagnitudeOfART_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RegionShapeType_MagnitudeOfART_CollectionType")))
#define CreateRegionShapeType_MagnitudeOfART_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRegionShapeType_MagnitudeOfART_CollectionType))
class Mp7JrsRegionShapeType_MagnitudeOfART_CollectionType;
class IMp7JrsRegionShapeType_MagnitudeOfART_CollectionType;
/** Smart pointer to instance of IMp7JrsRegionShapeType_MagnitudeOfART_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRegionShapeType_MagnitudeOfART_CollectionType > Mp7JrsRegionShapeType_MagnitudeOfART_CollectionPtr;

#define TypeOfRegionShapeType_MagnitudeOfART_LocalType (Mp7JrsFactory::GetTypeIndex(X("RegionShapeType_MagnitudeOfART_LocalType")))
#define CreateRegionShapeType_MagnitudeOfART_LocalType (Mp7JrsFactory::CreateObject(TypeOfRegionShapeType_MagnitudeOfART_LocalType))
class Mp7JrsRegionShapeType_MagnitudeOfART_LocalType;
class IMp7JrsRegionShapeType_MagnitudeOfART_LocalType;
/** Smart pointer to instance of IMp7JrsRegionShapeType_MagnitudeOfART_LocalType */
typedef Mp7JrsPtr< IMp7JrsRegionShapeType_MagnitudeOfART_LocalType > Mp7JrsRegionShapeType_MagnitudeOfART_LocalPtr;

#define TypeOfRegularVisualTimeSeriesType (Mp7JrsFactory::GetTypeIndex(X("RegularVisualTimeSeriesType")))
#define CreateRegularVisualTimeSeriesType (Mp7JrsFactory::CreateObject(TypeOfRegularVisualTimeSeriesType))
class Mp7JrsRegularVisualTimeSeriesType;
class IMp7JrsRegularVisualTimeSeriesType;
/** Smart pointer to instance of IMp7JrsRegularVisualTimeSeriesType */
typedef Mp7JrsPtr< IMp7JrsRegularVisualTimeSeriesType > Mp7JrsRegularVisualTimeSeriesPtr;

#define TypeOfRegularVisualTimeSeriesType_Descriptor_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RegularVisualTimeSeriesType_Descriptor_CollectionType")))
#define CreateRegularVisualTimeSeriesType_Descriptor_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRegularVisualTimeSeriesType_Descriptor_CollectionType))
class Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionType;
class IMp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionType;
/** Smart pointer to instance of IMp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionType > Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionPtr;

#define TypeOfRelatedMaterialType (Mp7JrsFactory::GetTypeIndex(X("RelatedMaterialType")))
#define CreateRelatedMaterialType (Mp7JrsFactory::CreateObject(TypeOfRelatedMaterialType))
class Mp7JrsRelatedMaterialType;
class IMp7JrsRelatedMaterialType;
/** Smart pointer to instance of IMp7JrsRelatedMaterialType */
typedef Mp7JrsPtr< IMp7JrsRelatedMaterialType > Mp7JrsRelatedMaterialPtr;

#define TypeOfRelationType (Mp7JrsFactory::GetTypeIndex(X("RelationType")))
#define CreateRelationType (Mp7JrsFactory::CreateObject(TypeOfRelationType))
class Mp7JrsRelationType;
class IMp7JrsRelationType;
/** Smart pointer to instance of IMp7JrsRelationType */
typedef Mp7JrsPtr< IMp7JrsRelationType > Mp7JrsRelationPtr;

#define TypeOfRelationType_source_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RelationType_source_CollectionType")))
#define CreateRelationType_source_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRelationType_source_CollectionType))
class Mp7JrsRelationType_source_CollectionType;
class IMp7JrsRelationType_source_CollectionType;
/** Smart pointer to instance of IMp7JrsRelationType_source_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRelationType_source_CollectionType > Mp7JrsRelationType_source_CollectionPtr;

#define TypeOfRelationType_target_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RelationType_target_CollectionType")))
#define CreateRelationType_target_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRelationType_target_CollectionType))
class Mp7JrsRelationType_target_CollectionType;
class IMp7JrsRelationType_target_CollectionType;
/** Smart pointer to instance of IMp7JrsRelationType_target_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRelationType_target_CollectionType > Mp7JrsRelationType_target_CollectionPtr;

#define TypeOfRelIncrTimePointType (Mp7JrsFactory::GetTypeIndex(X("RelIncrTimePointType")))
#define CreateRelIncrTimePointType (Mp7JrsFactory::CreateObject(TypeOfRelIncrTimePointType))
class Mp7JrsRelIncrTimePointType;
class IMp7JrsRelIncrTimePointType;
/** Smart pointer to instance of IMp7JrsRelIncrTimePointType */
typedef Mp7JrsPtr< IMp7JrsRelIncrTimePointType > Mp7JrsRelIncrTimePointPtr;

#define TypeOfRelTimePointType (Mp7JrsFactory::GetTypeIndex(X("RelTimePointType")))
#define CreateRelTimePointType (Mp7JrsFactory::CreateObject(TypeOfRelTimePointType))
class Mp7JrsRelTimePointType;
class IMp7JrsRelTimePointType;
/** Smart pointer to instance of IMp7JrsRelTimePointType */
typedef Mp7JrsPtr< IMp7JrsRelTimePointType > Mp7JrsRelTimePointPtr;

#define TypeOfResolutionViewType (Mp7JrsFactory::GetTypeIndex(X("ResolutionViewType")))
#define CreateResolutionViewType (Mp7JrsFactory::CreateObject(TypeOfResolutionViewType))
class Mp7JrsResolutionViewType;
class IMp7JrsResolutionViewType;
/** Smart pointer to instance of IMp7JrsResolutionViewType */
typedef Mp7JrsPtr< IMp7JrsResolutionViewType > Mp7JrsResolutionViewPtr;

#define TypeOfRightsType (Mp7JrsFactory::GetTypeIndex(X("RightsType")))
#define CreateRightsType (Mp7JrsFactory::CreateObject(TypeOfRightsType))
class Mp7JrsRightsType;
class IMp7JrsRightsType;
/** Smart pointer to instance of IMp7JrsRightsType */
typedef Mp7JrsPtr< IMp7JrsRightsType > Mp7JrsRightsPtr;

#define TypeOfRightsType_RightsID_CollectionType (Mp7JrsFactory::GetTypeIndex(X("RightsType_RightsID_CollectionType")))
#define CreateRightsType_RightsID_CollectionType (Mp7JrsFactory::CreateObject(TypeOfRightsType_RightsID_CollectionType))
class Mp7JrsRightsType_RightsID_CollectionType;
class IMp7JrsRightsType_RightsID_CollectionType;
/** Smart pointer to instance of IMp7JrsRightsType_RightsID_CollectionType */
typedef Mp7JrsPtr< IMp7JrsRightsType_RightsID_CollectionType > Mp7JrsRightsType_RightsID_CollectionPtr;

#define TypeOfScalableColorType (Mp7JrsFactory::GetTypeIndex(X("ScalableColorType")))
#define CreateScalableColorType (Mp7JrsFactory::CreateObject(TypeOfScalableColorType))
class Mp7JrsScalableColorType;
class IMp7JrsScalableColorType;
/** Smart pointer to instance of IMp7JrsScalableColorType */
typedef Mp7JrsPtr< IMp7JrsScalableColorType > Mp7JrsScalableColorPtr;

#define TypeOfScalableColorType_numOfBitplanesDiscarded_LocalType (Mp7JrsFactory::GetTypeIndex(X("ScalableColorType_numOfBitplanesDiscarded_LocalType")))
#define CreateScalableColorType_numOfBitplanesDiscarded_LocalType (Mp7JrsFactory::CreateObject(TypeOfScalableColorType_numOfBitplanesDiscarded_LocalType))
class Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType;
class IMp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType;

#define TypeOfScalableColorType_numOfCoeff_LocalType (Mp7JrsFactory::GetTypeIndex(X("ScalableColorType_numOfCoeff_LocalType")))
#define CreateScalableColorType_numOfCoeff_LocalType (Mp7JrsFactory::CreateObject(TypeOfScalableColorType_numOfCoeff_LocalType))
class Mp7JrsScalableColorType_numOfCoeff_LocalType;
class IMp7JrsScalableColorType_numOfCoeff_LocalType;

#define TypeOfScalableSeriesType (Mp7JrsFactory::GetTypeIndex(X("ScalableSeriesType")))
#define CreateScalableSeriesType (Mp7JrsFactory::CreateObject(TypeOfScalableSeriesType))
class Mp7JrsScalableSeriesType;
class IMp7JrsScalableSeriesType;
/** Smart pointer to instance of IMp7JrsScalableSeriesType */
typedef Mp7JrsPtr< IMp7JrsScalableSeriesType > Mp7JrsScalableSeriesPtr;

#define TypeOfScalableSeriesType_Scaling_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ScalableSeriesType_Scaling_CollectionType")))
#define CreateScalableSeriesType_Scaling_CollectionType (Mp7JrsFactory::CreateObject(TypeOfScalableSeriesType_Scaling_CollectionType))
class Mp7JrsScalableSeriesType_Scaling_CollectionType;
class IMp7JrsScalableSeriesType_Scaling_CollectionType;
/** Smart pointer to instance of IMp7JrsScalableSeriesType_Scaling_CollectionType */
typedef Mp7JrsPtr< IMp7JrsScalableSeriesType_Scaling_CollectionType > Mp7JrsScalableSeriesType_Scaling_CollectionPtr;

#define TypeOfScalableSeriesType_Scaling_LocalType (Mp7JrsFactory::GetTypeIndex(X("ScalableSeriesType_Scaling_LocalType")))
#define CreateScalableSeriesType_Scaling_LocalType (Mp7JrsFactory::CreateObject(TypeOfScalableSeriesType_Scaling_LocalType))
class Mp7JrsScalableSeriesType_Scaling_LocalType;
class IMp7JrsScalableSeriesType_Scaling_LocalType;
/** Smart pointer to instance of IMp7JrsScalableSeriesType_Scaling_LocalType */
typedef Mp7JrsPtr< IMp7JrsScalableSeriesType_Scaling_LocalType > Mp7JrsScalableSeriesType_Scaling_LocalPtr;

#define TypeOfscaleType (Mp7JrsFactory::GetTypeIndex(X("scaleType")))
#define CreatescaleType (Mp7JrsFactory::CreateObject(TypeOfscaleType))
class Mp7JrsscaleType;
class IMp7JrsscaleType;
/** Smart pointer to instance of IMp7JrsscaleType */
typedef Mp7JrsPtr< IMp7JrsscaleType > Mp7JrsscalePtr;

#define TypeOfSceneGraphMaskType (Mp7JrsFactory::GetTypeIndex(X("SceneGraphMaskType")))
#define CreateSceneGraphMaskType (Mp7JrsFactory::CreateObject(TypeOfSceneGraphMaskType))
class Mp7JrsSceneGraphMaskType;
class IMp7JrsSceneGraphMaskType;
/** Smart pointer to instance of IMp7JrsSceneGraphMaskType */
typedef Mp7JrsPtr< IMp7JrsSceneGraphMaskType > Mp7JrsSceneGraphMaskPtr;

#define TypeOfSceneGraphMaskType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SceneGraphMaskType_CollectionType")))
#define CreateSceneGraphMaskType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSceneGraphMaskType_CollectionType))
class Mp7JrsSceneGraphMaskType_CollectionType;
class IMp7JrsSceneGraphMaskType_CollectionType;
/** Smart pointer to instance of IMp7JrsSceneGraphMaskType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSceneGraphMaskType_CollectionType > Mp7JrsSceneGraphMaskType_CollectionPtr;

#define TypeOfSceneGraphMaskType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SceneGraphMaskType_LocalType")))
#define CreateSceneGraphMaskType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSceneGraphMaskType_LocalType))
class Mp7JrsSceneGraphMaskType_LocalType;
class IMp7JrsSceneGraphMaskType_LocalType;
/** Smart pointer to instance of IMp7JrsSceneGraphMaskType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSceneGraphMaskType_LocalType > Mp7JrsSceneGraphMaskType_LocalPtr;

#define TypeOfSegmentCollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentCollectionType")))
#define CreateSegmentCollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentCollectionType))
class Mp7JrsSegmentCollectionType;
class IMp7JrsSegmentCollectionType;
/** Smart pointer to instance of IMp7JrsSegmentCollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentCollectionType > Mp7JrsSegmentCollectionPtr;

#define TypeOfSegmentCollectionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentCollectionType_CollectionType")))
#define CreateSegmentCollectionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentCollectionType_CollectionType))
class Mp7JrsSegmentCollectionType_CollectionType;
class IMp7JrsSegmentCollectionType_CollectionType;
/** Smart pointer to instance of IMp7JrsSegmentCollectionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentCollectionType_CollectionType > Mp7JrsSegmentCollectionType_CollectionPtr;

#define TypeOfSegmentCollectionType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("SegmentCollectionType_CollectionType0")))
#define CreateSegmentCollectionType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfSegmentCollectionType_CollectionType0))
class Mp7JrsSegmentCollectionType_CollectionType0;
class IMp7JrsSegmentCollectionType_CollectionType0;
/** Smart pointer to instance of IMp7JrsSegmentCollectionType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsSegmentCollectionType_CollectionType0 > Mp7JrsSegmentCollectionType_Collection0Ptr;

#define TypeOfSegmentCollectionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SegmentCollectionType_LocalType")))
#define CreateSegmentCollectionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSegmentCollectionType_LocalType))
class Mp7JrsSegmentCollectionType_LocalType;
class IMp7JrsSegmentCollectionType_LocalType;
/** Smart pointer to instance of IMp7JrsSegmentCollectionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSegmentCollectionType_LocalType > Mp7JrsSegmentCollectionType_LocalPtr;

#define TypeOfSegmentCollectionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("SegmentCollectionType_LocalType0")))
#define CreateSegmentCollectionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSegmentCollectionType_LocalType0))
class Mp7JrsSegmentCollectionType_LocalType0;
class IMp7JrsSegmentCollectionType_LocalType0;
/** Smart pointer to instance of IMp7JrsSegmentCollectionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSegmentCollectionType_LocalType0 > Mp7JrsSegmentCollectionType_Local0Ptr;

#define TypeOfSegmentDecompositionType (Mp7JrsFactory::GetTypeIndex(X("SegmentDecompositionType")))
#define CreateSegmentDecompositionType (Mp7JrsFactory::CreateObject(TypeOfSegmentDecompositionType))
class Mp7JrsSegmentDecompositionType;
class IMp7JrsSegmentDecompositionType;
/** Smart pointer to instance of IMp7JrsSegmentDecompositionType */
typedef Mp7JrsPtr< IMp7JrsSegmentDecompositionType > Mp7JrsSegmentDecompositionPtr;

#define TypeOfSegmentType (Mp7JrsFactory::GetTypeIndex(X("SegmentType")))
#define CreateSegmentType (Mp7JrsFactory::CreateObject(TypeOfSegmentType))
class Mp7JrsSegmentType;
class IMp7JrsSegmentType;
/** Smart pointer to instance of IMp7JrsSegmentType */
typedef Mp7JrsPtr< IMp7JrsSegmentType > Mp7JrsSegmentPtr;

#define TypeOfSegmentType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_CollectionType")))
#define CreateSegmentType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_CollectionType))
class Mp7JrsSegmentType_CollectionType;
class IMp7JrsSegmentType_CollectionType;
/** Smart pointer to instance of IMp7JrsSegmentType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_CollectionType > Mp7JrsSegmentType_CollectionPtr;

#define TypeOfSegmentType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_LocalType")))
#define CreateSegmentType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_LocalType))
class Mp7JrsSegmentType_LocalType;
class IMp7JrsSegmentType_LocalType;
/** Smart pointer to instance of IMp7JrsSegmentType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_LocalType > Mp7JrsSegmentType_LocalPtr;

#define TypeOfSegmentType_MatchingHint_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_MatchingHint_CollectionType")))
#define CreateSegmentType_MatchingHint_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_MatchingHint_CollectionType))
class Mp7JrsSegmentType_MatchingHint_CollectionType;
class IMp7JrsSegmentType_MatchingHint_CollectionType;
/** Smart pointer to instance of IMp7JrsSegmentType_MatchingHint_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_MatchingHint_CollectionType > Mp7JrsSegmentType_MatchingHint_CollectionPtr;

#define TypeOfSegmentType_PointOfView_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_PointOfView_CollectionType")))
#define CreateSegmentType_PointOfView_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_PointOfView_CollectionType))
class Mp7JrsSegmentType_PointOfView_CollectionType;
class IMp7JrsSegmentType_PointOfView_CollectionType;
/** Smart pointer to instance of IMp7JrsSegmentType_PointOfView_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_PointOfView_CollectionType > Mp7JrsSegmentType_PointOfView_CollectionPtr;

#define TypeOfSegmentType_Relation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_Relation_CollectionType")))
#define CreateSegmentType_Relation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_Relation_CollectionType))
class Mp7JrsSegmentType_Relation_CollectionType;
class IMp7JrsSegmentType_Relation_CollectionType;
/** Smart pointer to instance of IMp7JrsSegmentType_Relation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_Relation_CollectionType > Mp7JrsSegmentType_Relation_CollectionPtr;

#define TypeOfSegmentType_TextAnnotation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_TextAnnotation_CollectionType")))
#define CreateSegmentType_TextAnnotation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_TextAnnotation_CollectionType))
class Mp7JrsSegmentType_TextAnnotation_CollectionType;
class IMp7JrsSegmentType_TextAnnotation_CollectionType;
/** Smart pointer to instance of IMp7JrsSegmentType_TextAnnotation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_CollectionType > Mp7JrsSegmentType_TextAnnotation_CollectionPtr;

#define TypeOfSegmentType_TextAnnotation_LocalType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_TextAnnotation_LocalType")))
#define CreateSegmentType_TextAnnotation_LocalType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_TextAnnotation_LocalType))
class Mp7JrsSegmentType_TextAnnotation_LocalType;
class IMp7JrsSegmentType_TextAnnotation_LocalType;
/** Smart pointer to instance of IMp7JrsSegmentType_TextAnnotation_LocalType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_LocalType > Mp7JrsSegmentType_TextAnnotation_LocalPtr;

#define TypeOfSegmentType_TextAnnotation_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("SegmentType_TextAnnotation_type_LocalType")))
#define CreateSegmentType_TextAnnotation_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfSegmentType_TextAnnotation_type_LocalType))
class Mp7JrsSegmentType_TextAnnotation_type_LocalType;
class IMp7JrsSegmentType_TextAnnotation_type_LocalType;
/** Smart pointer to instance of IMp7JrsSegmentType_TextAnnotation_type_LocalType */
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_type_LocalType > Mp7JrsSegmentType_TextAnnotation_type_LocalPtr;

#define TypeOfSegmentType_TextAnnotation_type_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("SegmentType_TextAnnotation_type_LocalType0")))
#define CreateSegmentType_TextAnnotation_type_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSegmentType_TextAnnotation_type_LocalType0))
class Mp7JrsSegmentType_TextAnnotation_type_LocalType0;
class IMp7JrsSegmentType_TextAnnotation_type_LocalType0;
/** Smart pointer to instance of IMp7JrsSegmentType_TextAnnotation_type_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_type_LocalType0 > Mp7JrsSegmentType_TextAnnotation_type_Local0Ptr;

#define TypeOfSegmentType_TextAnnotation_type_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("SegmentType_TextAnnotation_type_LocalType1")))
#define CreateSegmentType_TextAnnotation_type_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfSegmentType_TextAnnotation_type_LocalType1))
class Mp7JrsSegmentType_TextAnnotation_type_LocalType1;
class IMp7JrsSegmentType_TextAnnotation_type_LocalType1;
/** Smart pointer to instance of IMp7JrsSegmentType_TextAnnotation_type_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_type_LocalType1 > Mp7JrsSegmentType_TextAnnotation_type_Local1Ptr;

#define TypeOfSegmentType_TextAnnotation_type_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("SegmentType_TextAnnotation_type_LocalType2")))
#define CreateSegmentType_TextAnnotation_type_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfSegmentType_TextAnnotation_type_LocalType2))
class Mp7JrsSegmentType_TextAnnotation_type_LocalType2;
class IMp7JrsSegmentType_TextAnnotation_type_LocalType2;
/** Smart pointer to instance of IMp7JrsSegmentType_TextAnnotation_type_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsSegmentType_TextAnnotation_type_LocalType2 > Mp7JrsSegmentType_TextAnnotation_type_Local2Ptr;

#define TypeOfSemanticBagType (Mp7JrsFactory::GetTypeIndex(X("SemanticBagType")))
#define CreateSemanticBagType (Mp7JrsFactory::CreateObject(TypeOfSemanticBagType))
class Mp7JrsSemanticBagType;
class IMp7JrsSemanticBagType;
/** Smart pointer to instance of IMp7JrsSemanticBagType */
typedef Mp7JrsPtr< IMp7JrsSemanticBagType > Mp7JrsSemanticBagPtr;

#define TypeOfSemanticBagType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBagType_CollectionType")))
#define CreateSemanticBagType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBagType_CollectionType))
class Mp7JrsSemanticBagType_CollectionType;
class IMp7JrsSemanticBagType_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBagType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBagType_CollectionType > Mp7JrsSemanticBagType_CollectionPtr;

#define TypeOfSemanticBagType_Graph_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBagType_Graph_CollectionType")))
#define CreateSemanticBagType_Graph_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBagType_Graph_CollectionType))
class Mp7JrsSemanticBagType_Graph_CollectionType;
class IMp7JrsSemanticBagType_Graph_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBagType_Graph_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBagType_Graph_CollectionType > Mp7JrsSemanticBagType_Graph_CollectionPtr;

#define TypeOfSemanticBagType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SemanticBagType_LocalType")))
#define CreateSemanticBagType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSemanticBagType_LocalType))
class Mp7JrsSemanticBagType_LocalType;
class IMp7JrsSemanticBagType_LocalType;
/** Smart pointer to instance of IMp7JrsSemanticBagType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSemanticBagType_LocalType > Mp7JrsSemanticBagType_LocalPtr;

#define TypeOfSemanticBaseType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType")))
#define CreateSemanticBaseType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType))
class Mp7JrsSemanticBaseType;
class IMp7JrsSemanticBaseType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType > Mp7JrsSemanticBasePtr;

#define TypeOfSemanticBaseType_Label_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_Label_CollectionType")))
#define CreateSemanticBaseType_Label_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_Label_CollectionType))
class Mp7JrsSemanticBaseType_Label_CollectionType;
class IMp7JrsSemanticBaseType_Label_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_Label_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Label_CollectionType > Mp7JrsSemanticBaseType_Label_CollectionPtr;

#define TypeOfSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType")))
#define CreateSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType))
class Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr;

#define TypeOfSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType")))
#define CreateSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType))
class Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr;

#define TypeOfSemanticBaseType_MediaOccurrence_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_CollectionType")))
#define CreateSemanticBaseType_MediaOccurrence_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_CollectionType))
class Mp7JrsSemanticBaseType_MediaOccurrence_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_CollectionPtr;

#define TypeOfSemanticBaseType_MediaOccurrence_LocalType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_LocalType")))
#define CreateSemanticBaseType_MediaOccurrence_LocalType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_LocalType))
class Mp7JrsSemanticBaseType_MediaOccurrence_LocalType;
class IMp7JrsSemanticBaseType_MediaOccurrence_LocalType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_LocalType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_LocalType > Mp7JrsSemanticBaseType_MediaOccurrence_LocalPtr;

#define TypeOfSemanticBaseType_MediaOccurrence_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_type_LocalType")))
#define CreateSemanticBaseType_MediaOccurrence_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_type_LocalType))
class Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType;
class IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType;

#define TypeOfSemanticBaseType_MediaOccurrence_type_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_type_LocalType0")))
#define CreateSemanticBaseType_MediaOccurrence_type_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_type_LocalType0))
class Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType0;
class IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType0;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType0 > Mp7JrsSemanticBaseType_MediaOccurrence_type_Local0Ptr;

#define TypeOfSemanticBaseType_MediaOccurrence_type_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_type_LocalType1")))
#define CreateSemanticBaseType_MediaOccurrence_type_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_type_LocalType1))
class Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType1;
class IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType1;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType1 > Mp7JrsSemanticBaseType_MediaOccurrence_type_Local1Ptr;

#define TypeOfSemanticBaseType_MediaOccurrence_type_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_type_LocalType2")))
#define CreateSemanticBaseType_MediaOccurrence_type_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_type_LocalType2))
class Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2;
class IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2 > Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr;

#define TypeOfSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType")))
#define CreateSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType))
class Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr;

#define TypeOfSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType")))
#define CreateSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType))
class Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType;
class IMp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType > Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr;

#define TypeOfSemanticBaseType_Property_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_Property_CollectionType")))
#define CreateSemanticBaseType_Property_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_Property_CollectionType))
class Mp7JrsSemanticBaseType_Property_CollectionType;
class IMp7JrsSemanticBaseType_Property_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_Property_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Property_CollectionType > Mp7JrsSemanticBaseType_Property_CollectionPtr;

#define TypeOfSemanticBaseType_Relation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticBaseType_Relation_CollectionType")))
#define CreateSemanticBaseType_Relation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticBaseType_Relation_CollectionType))
class Mp7JrsSemanticBaseType_Relation_CollectionType;
class IMp7JrsSemanticBaseType_Relation_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticBaseType_Relation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType_Relation_CollectionType > Mp7JrsSemanticBaseType_Relation_CollectionPtr;

#define TypeOfSemanticDescriptionType (Mp7JrsFactory::GetTypeIndex(X("SemanticDescriptionType")))
#define CreateSemanticDescriptionType (Mp7JrsFactory::CreateObject(TypeOfSemanticDescriptionType))
class Mp7JrsSemanticDescriptionType;
class IMp7JrsSemanticDescriptionType;
/** Smart pointer to instance of IMp7JrsSemanticDescriptionType */
typedef Mp7JrsPtr< IMp7JrsSemanticDescriptionType > Mp7JrsSemanticDescriptionPtr;

#define TypeOfSemanticDescriptionType_ConceptCollection_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticDescriptionType_ConceptCollection_CollectionType")))
#define CreateSemanticDescriptionType_ConceptCollection_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticDescriptionType_ConceptCollection_CollectionType))
class Mp7JrsSemanticDescriptionType_ConceptCollection_CollectionType;
class IMp7JrsSemanticDescriptionType_ConceptCollection_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticDescriptionType_ConceptCollection_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticDescriptionType_ConceptCollection_CollectionType > Mp7JrsSemanticDescriptionType_ConceptCollection_CollectionPtr;

#define TypeOfSemanticDescriptionType_Semantics_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticDescriptionType_Semantics_CollectionType")))
#define CreateSemanticDescriptionType_Semantics_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticDescriptionType_Semantics_CollectionType))
class Mp7JrsSemanticDescriptionType_Semantics_CollectionType;
class IMp7JrsSemanticDescriptionType_Semantics_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticDescriptionType_Semantics_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticDescriptionType_Semantics_CollectionType > Mp7JrsSemanticDescriptionType_Semantics_CollectionPtr;

#define TypeOfSemanticPlaceType (Mp7JrsFactory::GetTypeIndex(X("SemanticPlaceType")))
#define CreateSemanticPlaceType (Mp7JrsFactory::CreateObject(TypeOfSemanticPlaceType))
class Mp7JrsSemanticPlaceType;
class IMp7JrsSemanticPlaceType;
/** Smart pointer to instance of IMp7JrsSemanticPlaceType */
typedef Mp7JrsPtr< IMp7JrsSemanticPlaceType > Mp7JrsSemanticPlacePtr;

#define TypeOfSemanticPlaceType_SemanticPlaceInterval_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticPlaceType_SemanticPlaceInterval_CollectionType")))
#define CreateSemanticPlaceType_SemanticPlaceInterval_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticPlaceType_SemanticPlaceInterval_CollectionType))
class Mp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionType;
class IMp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionType > Mp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionPtr;

#define TypeOfSemanticPlaceType_SemanticPlaceInterval_LocalType (Mp7JrsFactory::GetTypeIndex(X("SemanticPlaceType_SemanticPlaceInterval_LocalType")))
#define CreateSemanticPlaceType_SemanticPlaceInterval_LocalType (Mp7JrsFactory::CreateObject(TypeOfSemanticPlaceType_SemanticPlaceInterval_LocalType))
class Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType;
class IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType;
/** Smart pointer to instance of IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType */
typedef Mp7JrsPtr< IMp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType > Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalPtr;

#define TypeOfSemanticStateType (Mp7JrsFactory::GetTypeIndex(X("SemanticStateType")))
#define CreateSemanticStateType (Mp7JrsFactory::CreateObject(TypeOfSemanticStateType))
class Mp7JrsSemanticStateType;
class IMp7JrsSemanticStateType;
/** Smart pointer to instance of IMp7JrsSemanticStateType */
typedef Mp7JrsPtr< IMp7JrsSemanticStateType > Mp7JrsSemanticStatePtr;

#define TypeOfSemanticStateType_AttributeValuePair_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticStateType_AttributeValuePair_CollectionType")))
#define CreateSemanticStateType_AttributeValuePair_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticStateType_AttributeValuePair_CollectionType))
class Mp7JrsSemanticStateType_AttributeValuePair_CollectionType;
class IMp7JrsSemanticStateType_AttributeValuePair_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticStateType_AttributeValuePair_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_CollectionType > Mp7JrsSemanticStateType_AttributeValuePair_CollectionPtr;

#define TypeOfSemanticStateType_AttributeValuePair_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("SemanticStateType_AttributeValuePair_CollectionType0")))
#define CreateSemanticStateType_AttributeValuePair_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfSemanticStateType_AttributeValuePair_CollectionType0))
class Mp7JrsSemanticStateType_AttributeValuePair_CollectionType0;
class IMp7JrsSemanticStateType_AttributeValuePair_CollectionType0;
/** Smart pointer to instance of IMp7JrsSemanticStateType_AttributeValuePair_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_CollectionType0 > Mp7JrsSemanticStateType_AttributeValuePair_Collection0Ptr;

#define TypeOfSemanticStateType_AttributeValuePair_LocalType (Mp7JrsFactory::GetTypeIndex(X("SemanticStateType_AttributeValuePair_LocalType")))
#define CreateSemanticStateType_AttributeValuePair_LocalType (Mp7JrsFactory::CreateObject(TypeOfSemanticStateType_AttributeValuePair_LocalType))
class Mp7JrsSemanticStateType_AttributeValuePair_LocalType;
class IMp7JrsSemanticStateType_AttributeValuePair_LocalType;
/** Smart pointer to instance of IMp7JrsSemanticStateType_AttributeValuePair_LocalType */
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_LocalType > Mp7JrsSemanticStateType_AttributeValuePair_LocalPtr;

#define TypeOfSemanticStateType_AttributeValuePair_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("SemanticStateType_AttributeValuePair_LocalType0")))
#define CreateSemanticStateType_AttributeValuePair_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSemanticStateType_AttributeValuePair_LocalType0))
class Mp7JrsSemanticStateType_AttributeValuePair_LocalType0;
class IMp7JrsSemanticStateType_AttributeValuePair_LocalType0;
/** Smart pointer to instance of IMp7JrsSemanticStateType_AttributeValuePair_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSemanticStateType_AttributeValuePair_LocalType0 > Mp7JrsSemanticStateType_AttributeValuePair_Local0Ptr;

#define TypeOfSemanticTimeType (Mp7JrsFactory::GetTypeIndex(X("SemanticTimeType")))
#define CreateSemanticTimeType (Mp7JrsFactory::CreateObject(TypeOfSemanticTimeType))
class Mp7JrsSemanticTimeType;
class IMp7JrsSemanticTimeType;
/** Smart pointer to instance of IMp7JrsSemanticTimeType */
typedef Mp7JrsPtr< IMp7JrsSemanticTimeType > Mp7JrsSemanticTimePtr;

#define TypeOfSemanticTimeType_SemanticTimeInterval_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SemanticTimeType_SemanticTimeInterval_CollectionType")))
#define CreateSemanticTimeType_SemanticTimeInterval_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSemanticTimeType_SemanticTimeInterval_CollectionType))
class Mp7JrsSemanticTimeType_SemanticTimeInterval_CollectionType;
class IMp7JrsSemanticTimeType_SemanticTimeInterval_CollectionType;
/** Smart pointer to instance of IMp7JrsSemanticTimeType_SemanticTimeInterval_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSemanticTimeType_SemanticTimeInterval_CollectionType > Mp7JrsSemanticTimeType_SemanticTimeInterval_CollectionPtr;

#define TypeOfSemanticTimeType_SemanticTimeInterval_LocalType (Mp7JrsFactory::GetTypeIndex(X("SemanticTimeType_SemanticTimeInterval_LocalType")))
#define CreateSemanticTimeType_SemanticTimeInterval_LocalType (Mp7JrsFactory::CreateObject(TypeOfSemanticTimeType_SemanticTimeInterval_LocalType))
class Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType;
class IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType;
/** Smart pointer to instance of IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType */
typedef Mp7JrsPtr< IMp7JrsSemanticTimeType_SemanticTimeInterval_LocalType > Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalPtr;

#define TypeOfSemanticType (Mp7JrsFactory::GetTypeIndex(X("SemanticType")))
#define CreateSemanticType (Mp7JrsFactory::CreateObject(TypeOfSemanticType))
class Mp7JrsSemanticType;
class IMp7JrsSemanticType;
/** Smart pointer to instance of IMp7JrsSemanticType */
typedef Mp7JrsPtr< IMp7JrsSemanticType > Mp7JrsSemanticPtr;

#define TypeOfSequentialSummaryType (Mp7JrsFactory::GetTypeIndex(X("SequentialSummaryType")))
#define CreateSequentialSummaryType (Mp7JrsFactory::CreateObject(TypeOfSequentialSummaryType))
class Mp7JrsSequentialSummaryType;
class IMp7JrsSequentialSummaryType;
/** Smart pointer to instance of IMp7JrsSequentialSummaryType */
typedef Mp7JrsPtr< IMp7JrsSequentialSummaryType > Mp7JrsSequentialSummaryPtr;

#define TypeOfSequentialSummaryType_AudioSummaryComponent_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SequentialSummaryType_AudioSummaryComponent_CollectionType")))
#define CreateSequentialSummaryType_AudioSummaryComponent_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSequentialSummaryType_AudioSummaryComponent_CollectionType))
class Mp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionType;
class IMp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionType;
/** Smart pointer to instance of IMp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionType > Mp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionPtr;

#define TypeOfSequentialSummaryType_components_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SequentialSummaryType_components_CollectionType")))
#define CreateSequentialSummaryType_components_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSequentialSummaryType_components_CollectionType))
class Mp7JrsSequentialSummaryType_components_CollectionType;
class IMp7JrsSequentialSummaryType_components_CollectionType;
/** Smart pointer to instance of IMp7JrsSequentialSummaryType_components_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSequentialSummaryType_components_CollectionType > Mp7JrsSequentialSummaryType_components_CollectionPtr;

#define TypeOfSequentialSummaryType_components_LocalType (Mp7JrsFactory::GetTypeIndex(X("SequentialSummaryType_components_LocalType")))
#define CreateSequentialSummaryType_components_LocalType (Mp7JrsFactory::CreateObject(TypeOfSequentialSummaryType_components_LocalType))
class Mp7JrsSequentialSummaryType_components_LocalType;
class IMp7JrsSequentialSummaryType_components_LocalType;

#define TypeOfSequentialSummaryType_TextualSummaryComponent_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SequentialSummaryType_TextualSummaryComponent_CollectionType")))
#define CreateSequentialSummaryType_TextualSummaryComponent_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSequentialSummaryType_TextualSummaryComponent_CollectionType))
class Mp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionType;
class IMp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionType;
/** Smart pointer to instance of IMp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionType > Mp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionPtr;

#define TypeOfSequentialSummaryType_VisualSummaryComponent_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SequentialSummaryType_VisualSummaryComponent_CollectionType")))
#define CreateSequentialSummaryType_VisualSummaryComponent_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSequentialSummaryType_VisualSummaryComponent_CollectionType))
class Mp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionType;
class IMp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionType;
/** Smart pointer to instance of IMp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionType > Mp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionPtr;

#define TypeOfSeriesOfScalarBinaryType (Mp7JrsFactory::GetTypeIndex(X("SeriesOfScalarBinaryType")))
#define CreateSeriesOfScalarBinaryType (Mp7JrsFactory::CreateObject(TypeOfSeriesOfScalarBinaryType))
class Mp7JrsSeriesOfScalarBinaryType;
class IMp7JrsSeriesOfScalarBinaryType;
/** Smart pointer to instance of IMp7JrsSeriesOfScalarBinaryType */
typedef Mp7JrsPtr< IMp7JrsSeriesOfScalarBinaryType > Mp7JrsSeriesOfScalarBinaryPtr;

#define TypeOfSeriesOfScalarType (Mp7JrsFactory::GetTypeIndex(X("SeriesOfScalarType")))
#define CreateSeriesOfScalarType (Mp7JrsFactory::CreateObject(TypeOfSeriesOfScalarType))
class Mp7JrsSeriesOfScalarType;
class IMp7JrsSeriesOfScalarType;
/** Smart pointer to instance of IMp7JrsSeriesOfScalarType */
typedef Mp7JrsPtr< IMp7JrsSeriesOfScalarType > Mp7JrsSeriesOfScalarPtr;

#define TypeOfSeriesOfVectorBinaryType (Mp7JrsFactory::GetTypeIndex(X("SeriesOfVectorBinaryType")))
#define CreateSeriesOfVectorBinaryType (Mp7JrsFactory::CreateObject(TypeOfSeriesOfVectorBinaryType))
class Mp7JrsSeriesOfVectorBinaryType;
class IMp7JrsSeriesOfVectorBinaryType;
/** Smart pointer to instance of IMp7JrsSeriesOfVectorBinaryType */
typedef Mp7JrsPtr< IMp7JrsSeriesOfVectorBinaryType > Mp7JrsSeriesOfVectorBinaryPtr;

#define TypeOfSeriesOfVectorType (Mp7JrsFactory::GetTypeIndex(X("SeriesOfVectorType")))
#define CreateSeriesOfVectorType (Mp7JrsFactory::CreateObject(TypeOfSeriesOfVectorType))
class Mp7JrsSeriesOfVectorType;
class IMp7JrsSeriesOfVectorType;
/** Smart pointer to instance of IMp7JrsSeriesOfVectorType */
typedef Mp7JrsPtr< IMp7JrsSeriesOfVectorType > Mp7JrsSeriesOfVectorPtr;

#define TypeOfShape3DType (Mp7JrsFactory::GetTypeIndex(X("Shape3DType")))
#define CreateShape3DType (Mp7JrsFactory::CreateObject(TypeOfShape3DType))
class Mp7JrsShape3DType;
class IMp7JrsShape3DType;
/** Smart pointer to instance of IMp7JrsShape3DType */
typedef Mp7JrsPtr< IMp7JrsShape3DType > Mp7JrsShape3DPtr;

#define TypeOfShape3DType_Spectrum_CollectionType (Mp7JrsFactory::GetTypeIndex(X("Shape3DType_Spectrum_CollectionType")))
#define CreateShape3DType_Spectrum_CollectionType (Mp7JrsFactory::CreateObject(TypeOfShape3DType_Spectrum_CollectionType))
class Mp7JrsShape3DType_Spectrum_CollectionType;
class IMp7JrsShape3DType_Spectrum_CollectionType;
/** Smart pointer to instance of IMp7JrsShape3DType_Spectrum_CollectionType */
typedef Mp7JrsPtr< IMp7JrsShape3DType_Spectrum_CollectionType > Mp7JrsShape3DType_Spectrum_CollectionPtr;

#define TypeOfShape3DType_Spectrum_LocalType (Mp7JrsFactory::GetTypeIndex(X("Shape3DType_Spectrum_LocalType")))
#define CreateShape3DType_Spectrum_LocalType (Mp7JrsFactory::CreateObject(TypeOfShape3DType_Spectrum_LocalType))
class Mp7JrsShape3DType_Spectrum_LocalType;
class IMp7JrsShape3DType_Spectrum_LocalType;
/** Smart pointer to instance of IMp7JrsShape3DType_Spectrum_LocalType */
typedef Mp7JrsPtr< IMp7JrsShape3DType_Spectrum_LocalType > Mp7JrsShape3DType_Spectrum_LocalPtr;

#define TypeOfShotEditingTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("ShotEditingTemporalDecompositionType")))
#define CreateShotEditingTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfShotEditingTemporalDecompositionType))
class Mp7JrsShotEditingTemporalDecompositionType;
class IMp7JrsShotEditingTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsShotEditingTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsShotEditingTemporalDecompositionType > Mp7JrsShotEditingTemporalDecompositionPtr;

#define TypeOfShotEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ShotEditingTemporalDecompositionType_CollectionType")))
#define CreateShotEditingTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfShotEditingTemporalDecompositionType_CollectionType))
class Mp7JrsShotEditingTemporalDecompositionType_CollectionType;
class IMp7JrsShotEditingTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsShotEditingTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsShotEditingTemporalDecompositionType_CollectionType > Mp7JrsShotEditingTemporalDecompositionType_CollectionPtr;

#define TypeOfShotEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ShotEditingTemporalDecompositionType_LocalType")))
#define CreateShotEditingTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfShotEditingTemporalDecompositionType_LocalType))
class Mp7JrsShotEditingTemporalDecompositionType_LocalType;
class IMp7JrsShotEditingTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsShotEditingTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsShotEditingTemporalDecompositionType_LocalType > Mp7JrsShotEditingTemporalDecompositionType_LocalPtr;

#define TypeOfShotType (Mp7JrsFactory::GetTypeIndex(X("ShotType")))
#define CreateShotType (Mp7JrsFactory::CreateObject(TypeOfShotType))
class Mp7JrsShotType;
class IMp7JrsShotType;
/** Smart pointer to instance of IMp7JrsShotType */
typedef Mp7JrsPtr< IMp7JrsShotType > Mp7JrsShotPtr;

#define TypeOfShotType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ShotType_AnalyticEditingTemporalDecomposition_CollectionType")))
#define CreateShotType_AnalyticEditingTemporalDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfShotType_AnalyticEditingTemporalDecomposition_CollectionType))
class Mp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionType;
class IMp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionType > Mp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionPtr;

#define TypeOfSignalPlaneFractionType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneFractionType")))
#define CreateSignalPlaneFractionType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneFractionType))
class Mp7JrsSignalPlaneFractionType;
class IMp7JrsSignalPlaneFractionType;
/** Smart pointer to instance of IMp7JrsSignalPlaneFractionType */
typedef Mp7JrsPtr< IMp7JrsSignalPlaneFractionType > Mp7JrsSignalPlaneFractionPtr;

#define TypeOfSignalPlaneOriginType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneOriginType")))
#define CreateSignalPlaneOriginType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneOriginType))
class Mp7JrsSignalPlaneOriginType;
class IMp7JrsSignalPlaneOriginType;
/** Smart pointer to instance of IMp7JrsSignalPlaneOriginType */
typedef Mp7JrsPtr< IMp7JrsSignalPlaneOriginType > Mp7JrsSignalPlaneOriginPtr;

#define TypeOfSignalPlaneOriginType_timeOrigin_LocalType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneOriginType_timeOrigin_LocalType")))
#define CreateSignalPlaneOriginType_timeOrigin_LocalType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneOriginType_timeOrigin_LocalType))
class Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType;
class IMp7JrsSignalPlaneOriginType_timeOrigin_LocalType;

#define TypeOfSignalPlaneOriginType_xOrigin_LocalType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneOriginType_xOrigin_LocalType")))
#define CreateSignalPlaneOriginType_xOrigin_LocalType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneOriginType_xOrigin_LocalType))
class Mp7JrsSignalPlaneOriginType_xOrigin_LocalType;
class IMp7JrsSignalPlaneOriginType_xOrigin_LocalType;

#define TypeOfSignalPlaneOriginType_yOrigin_LocalType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneOriginType_yOrigin_LocalType")))
#define CreateSignalPlaneOriginType_yOrigin_LocalType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneOriginType_yOrigin_LocalType))
class Mp7JrsSignalPlaneOriginType_yOrigin_LocalType;
class IMp7JrsSignalPlaneOriginType_yOrigin_LocalType;

#define TypeOfSignalPlaneOriginType_zOrigin_LocalType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneOriginType_zOrigin_LocalType")))
#define CreateSignalPlaneOriginType_zOrigin_LocalType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneOriginType_zOrigin_LocalType))
class Mp7JrsSignalPlaneOriginType_zOrigin_LocalType;
class IMp7JrsSignalPlaneOriginType_zOrigin_LocalType;

#define TypeOfSignalPlaneSampleType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneSampleType")))
#define CreateSignalPlaneSampleType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneSampleType))
class Mp7JrsSignalPlaneSampleType;
class IMp7JrsSignalPlaneSampleType;
/** Smart pointer to instance of IMp7JrsSignalPlaneSampleType */
typedef Mp7JrsPtr< IMp7JrsSignalPlaneSampleType > Mp7JrsSignalPlaneSamplePtr;

#define TypeOfSignalPlaneType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneType")))
#define CreateSignalPlaneType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneType))
class Mp7JrsSignalPlaneType;
class IMp7JrsSignalPlaneType;
/** Smart pointer to instance of IMp7JrsSignalPlaneType */
typedef Mp7JrsPtr< IMp7JrsSignalPlaneType > Mp7JrsSignalPlanePtr;

#define TypeOfSignalPlaneType_dim_LocalType (Mp7JrsFactory::GetTypeIndex(X("SignalPlaneType_dim_LocalType")))
#define CreateSignalPlaneType_dim_LocalType (Mp7JrsFactory::CreateObject(TypeOfSignalPlaneType_dim_LocalType))
class Mp7JrsSignalPlaneType_dim_LocalType;
class IMp7JrsSignalPlaneType_dim_LocalType;
/** Smart pointer to instance of IMp7JrsSignalPlaneType_dim_LocalType */
typedef Mp7JrsPtr< IMp7JrsSignalPlaneType_dim_LocalType > Mp7JrsSignalPlaneType_dim_LocalPtr;

#define TypeOfSignalType (Mp7JrsFactory::GetTypeIndex(X("SignalType")))
#define CreateSignalType (Mp7JrsFactory::CreateObject(TypeOfSignalType))
class Mp7JrsSignalType;
class IMp7JrsSignalType;
/** Smart pointer to instance of IMp7JrsSignalType */
typedef Mp7JrsPtr< IMp7JrsSignalType > Mp7JrsSignalPtr;

#define TypeOfSilenceHeaderType (Mp7JrsFactory::GetTypeIndex(X("SilenceHeaderType")))
#define CreateSilenceHeaderType (Mp7JrsFactory::CreateObject(TypeOfSilenceHeaderType))
class Mp7JrsSilenceHeaderType;
class IMp7JrsSilenceHeaderType;
/** Smart pointer to instance of IMp7JrsSilenceHeaderType */
typedef Mp7JrsPtr< IMp7JrsSilenceHeaderType > Mp7JrsSilenceHeaderPtr;

#define TypeOfSilenceType (Mp7JrsFactory::GetTypeIndex(X("SilenceType")))
#define CreateSilenceType (Mp7JrsFactory::CreateObject(TypeOfSilenceType))
class Mp7JrsSilenceType;
class IMp7JrsSilenceType;
/** Smart pointer to instance of IMp7JrsSilenceType */
typedef Mp7JrsPtr< IMp7JrsSilenceType > Mp7JrsSilencePtr;

#define TypeOfSoundClassificationModelType (Mp7JrsFactory::GetTypeIndex(X("SoundClassificationModelType")))
#define CreateSoundClassificationModelType (Mp7JrsFactory::CreateObject(TypeOfSoundClassificationModelType))
class Mp7JrsSoundClassificationModelType;
class IMp7JrsSoundClassificationModelType;
/** Smart pointer to instance of IMp7JrsSoundClassificationModelType */
typedef Mp7JrsPtr< IMp7JrsSoundClassificationModelType > Mp7JrsSoundClassificationModelPtr;

#define TypeOfSoundClassificationModelType_SoundModel_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SoundClassificationModelType_SoundModel_CollectionType")))
#define CreateSoundClassificationModelType_SoundModel_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSoundClassificationModelType_SoundModel_CollectionType))
class Mp7JrsSoundClassificationModelType_SoundModel_CollectionType;
class IMp7JrsSoundClassificationModelType_SoundModel_CollectionType;
/** Smart pointer to instance of IMp7JrsSoundClassificationModelType_SoundModel_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSoundClassificationModelType_SoundModel_CollectionType > Mp7JrsSoundClassificationModelType_SoundModel_CollectionPtr;

#define TypeOfSoundModelStateHistogramType (Mp7JrsFactory::GetTypeIndex(X("SoundModelStateHistogramType")))
#define CreateSoundModelStateHistogramType (Mp7JrsFactory::CreateObject(TypeOfSoundModelStateHistogramType))
class Mp7JrsSoundModelStateHistogramType;
class IMp7JrsSoundModelStateHistogramType;
/** Smart pointer to instance of IMp7JrsSoundModelStateHistogramType */
typedef Mp7JrsPtr< IMp7JrsSoundModelStateHistogramType > Mp7JrsSoundModelStateHistogramPtr;

#define TypeOfSoundModelStateHistogramType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SoundModelStateHistogramType_CollectionType")))
#define CreateSoundModelStateHistogramType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSoundModelStateHistogramType_CollectionType))
class Mp7JrsSoundModelStateHistogramType_CollectionType;
class IMp7JrsSoundModelStateHistogramType_CollectionType;
/** Smart pointer to instance of IMp7JrsSoundModelStateHistogramType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSoundModelStateHistogramType_CollectionType > Mp7JrsSoundModelStateHistogramType_CollectionPtr;

#define TypeOfSoundModelStateHistogramType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SoundModelStateHistogramType_LocalType")))
#define CreateSoundModelStateHistogramType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSoundModelStateHistogramType_LocalType))
class Mp7JrsSoundModelStateHistogramType_LocalType;
class IMp7JrsSoundModelStateHistogramType_LocalType;
/** Smart pointer to instance of IMp7JrsSoundModelStateHistogramType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSoundModelStateHistogramType_LocalType > Mp7JrsSoundModelStateHistogramType_LocalPtr;

#define TypeOfSoundModelStatePathType (Mp7JrsFactory::GetTypeIndex(X("SoundModelStatePathType")))
#define CreateSoundModelStatePathType (Mp7JrsFactory::CreateObject(TypeOfSoundModelStatePathType))
class Mp7JrsSoundModelStatePathType;
class IMp7JrsSoundModelStatePathType;
/** Smart pointer to instance of IMp7JrsSoundModelStatePathType */
typedef Mp7JrsPtr< IMp7JrsSoundModelStatePathType > Mp7JrsSoundModelStatePathPtr;

#define TypeOfSoundModelType (Mp7JrsFactory::GetTypeIndex(X("SoundModelType")))
#define CreateSoundModelType (Mp7JrsFactory::CreateObject(TypeOfSoundModelType))
class Mp7JrsSoundModelType;
class IMp7JrsSoundModelType;
/** Smart pointer to instance of IMp7JrsSoundModelType */
typedef Mp7JrsPtr< IMp7JrsSoundModelType > Mp7JrsSoundModelPtr;

#define TypeOfSourcePreferencesType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType")))
#define CreateSourcePreferencesType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType))
class Mp7JrsSourcePreferencesType;
class IMp7JrsSourcePreferencesType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType > Mp7JrsSourcePreferencesPtr;

#define TypeOfSourcePreferencesType_DisseminationDate_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationDate_CollectionType")))
#define CreateSourcePreferencesType_DisseminationDate_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationDate_CollectionType))
class Mp7JrsSourcePreferencesType_DisseminationDate_CollectionType;
class IMp7JrsSourcePreferencesType_DisseminationDate_CollectionType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationDate_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationDate_CollectionType > Mp7JrsSourcePreferencesType_DisseminationDate_CollectionPtr;

#define TypeOfSourcePreferencesType_DisseminationDate_LocalType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationDate_LocalType")))
#define CreateSourcePreferencesType_DisseminationDate_LocalType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationDate_LocalType))
class Mp7JrsSourcePreferencesType_DisseminationDate_LocalType;
class IMp7JrsSourcePreferencesType_DisseminationDate_LocalType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationDate_LocalType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationDate_LocalType > Mp7JrsSourcePreferencesType_DisseminationDate_LocalPtr;

#define TypeOfSourcePreferencesType_DisseminationFormat_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationFormat_CollectionType")))
#define CreateSourcePreferencesType_DisseminationFormat_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationFormat_CollectionType))
class Mp7JrsSourcePreferencesType_DisseminationFormat_CollectionType;
class IMp7JrsSourcePreferencesType_DisseminationFormat_CollectionType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationFormat_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationFormat_CollectionType > Mp7JrsSourcePreferencesType_DisseminationFormat_CollectionPtr;

#define TypeOfSourcePreferencesType_DisseminationFormat_LocalType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationFormat_LocalType")))
#define CreateSourcePreferencesType_DisseminationFormat_LocalType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationFormat_LocalType))
class Mp7JrsSourcePreferencesType_DisseminationFormat_LocalType;
class IMp7JrsSourcePreferencesType_DisseminationFormat_LocalType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationFormat_LocalType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationFormat_LocalType > Mp7JrsSourcePreferencesType_DisseminationFormat_LocalPtr;

#define TypeOfSourcePreferencesType_DisseminationLocation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationLocation_CollectionType")))
#define CreateSourcePreferencesType_DisseminationLocation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationLocation_CollectionType))
class Mp7JrsSourcePreferencesType_DisseminationLocation_CollectionType;
class IMp7JrsSourcePreferencesType_DisseminationLocation_CollectionType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationLocation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationLocation_CollectionType > Mp7JrsSourcePreferencesType_DisseminationLocation_CollectionPtr;

#define TypeOfSourcePreferencesType_DisseminationLocation_LocalType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationLocation_LocalType")))
#define CreateSourcePreferencesType_DisseminationLocation_LocalType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationLocation_LocalType))
class Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType;
class IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationLocation_LocalType > Mp7JrsSourcePreferencesType_DisseminationLocation_LocalPtr;

#define TypeOfSourcePreferencesType_DisseminationSource_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationSource_CollectionType")))
#define CreateSourcePreferencesType_DisseminationSource_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationSource_CollectionType))
class Mp7JrsSourcePreferencesType_DisseminationSource_CollectionType;
class IMp7JrsSourcePreferencesType_DisseminationSource_CollectionType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationSource_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationSource_CollectionType > Mp7JrsSourcePreferencesType_DisseminationSource_CollectionPtr;

#define TypeOfSourcePreferencesType_DisseminationSource_LocalType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_DisseminationSource_LocalType")))
#define CreateSourcePreferencesType_DisseminationSource_LocalType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_DisseminationSource_LocalType))
class Mp7JrsSourcePreferencesType_DisseminationSource_LocalType;
class IMp7JrsSourcePreferencesType_DisseminationSource_LocalType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_DisseminationSource_LocalType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_DisseminationSource_LocalType > Mp7JrsSourcePreferencesType_DisseminationSource_LocalPtr;

#define TypeOfSourcePreferencesType_Disseminator_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_Disseminator_CollectionType")))
#define CreateSourcePreferencesType_Disseminator_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_Disseminator_CollectionType))
class Mp7JrsSourcePreferencesType_Disseminator_CollectionType;
class IMp7JrsSourcePreferencesType_Disseminator_CollectionType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_Disseminator_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_Disseminator_CollectionType > Mp7JrsSourcePreferencesType_Disseminator_CollectionPtr;

#define TypeOfSourcePreferencesType_Disseminator_LocalType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_Disseminator_LocalType")))
#define CreateSourcePreferencesType_Disseminator_LocalType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_Disseminator_LocalType))
class Mp7JrsSourcePreferencesType_Disseminator_LocalType;
class IMp7JrsSourcePreferencesType_Disseminator_LocalType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_Disseminator_LocalType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_Disseminator_LocalType > Mp7JrsSourcePreferencesType_Disseminator_LocalPtr;

#define TypeOfSourcePreferencesType_MediaFormat_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_MediaFormat_CollectionType")))
#define CreateSourcePreferencesType_MediaFormat_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_MediaFormat_CollectionType))
class Mp7JrsSourcePreferencesType_MediaFormat_CollectionType;
class IMp7JrsSourcePreferencesType_MediaFormat_CollectionType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_MediaFormat_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_MediaFormat_CollectionType > Mp7JrsSourcePreferencesType_MediaFormat_CollectionPtr;

#define TypeOfSourcePreferencesType_MediaFormat_LocalType (Mp7JrsFactory::GetTypeIndex(X("SourcePreferencesType_MediaFormat_LocalType")))
#define CreateSourcePreferencesType_MediaFormat_LocalType (Mp7JrsFactory::CreateObject(TypeOfSourcePreferencesType_MediaFormat_LocalType))
class Mp7JrsSourcePreferencesType_MediaFormat_LocalType;
class IMp7JrsSourcePreferencesType_MediaFormat_LocalType;
/** Smart pointer to instance of IMp7JrsSourcePreferencesType_MediaFormat_LocalType */
typedef Mp7JrsPtr< IMp7JrsSourcePreferencesType_MediaFormat_LocalType > Mp7JrsSourcePreferencesType_MediaFormat_LocalPtr;

#define TypeOfSpaceFrequencyGraphType (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyGraphType")))
#define CreateSpaceFrequencyGraphType (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyGraphType))
class Mp7JrsSpaceFrequencyGraphType;
class IMp7JrsSpaceFrequencyGraphType;
/** Smart pointer to instance of IMp7JrsSpaceFrequencyGraphType */
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType > Mp7JrsSpaceFrequencyGraphPtr;

#define TypeOfSpaceFrequencyGraphType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyGraphType_CollectionType")))
#define CreateSpaceFrequencyGraphType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyGraphType_CollectionType))
class Mp7JrsSpaceFrequencyGraphType_CollectionType;
class IMp7JrsSpaceFrequencyGraphType_CollectionType;
/** Smart pointer to instance of IMp7JrsSpaceFrequencyGraphType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType_CollectionType > Mp7JrsSpaceFrequencyGraphType_CollectionPtr;

#define TypeOfSpaceFrequencyGraphType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyGraphType_CollectionType0")))
#define CreateSpaceFrequencyGraphType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyGraphType_CollectionType0))
class Mp7JrsSpaceFrequencyGraphType_CollectionType0;
class IMp7JrsSpaceFrequencyGraphType_CollectionType0;
/** Smart pointer to instance of IMp7JrsSpaceFrequencyGraphType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType_CollectionType0 > Mp7JrsSpaceFrequencyGraphType_Collection0Ptr;

#define TypeOfSpaceFrequencyGraphType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyGraphType_LocalType")))
#define CreateSpaceFrequencyGraphType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyGraphType_LocalType))
class Mp7JrsSpaceFrequencyGraphType_LocalType;
class IMp7JrsSpaceFrequencyGraphType_LocalType;
/** Smart pointer to instance of IMp7JrsSpaceFrequencyGraphType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType_LocalType > Mp7JrsSpaceFrequencyGraphType_LocalPtr;

#define TypeOfSpaceFrequencyGraphType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyGraphType_LocalType0")))
#define CreateSpaceFrequencyGraphType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyGraphType_LocalType0))
class Mp7JrsSpaceFrequencyGraphType_LocalType0;
class IMp7JrsSpaceFrequencyGraphType_LocalType0;
/** Smart pointer to instance of IMp7JrsSpaceFrequencyGraphType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType_LocalType0 > Mp7JrsSpaceFrequencyGraphType_Local0Ptr;

#define TypeOfSpaceFrequencyViewType (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyViewType")))
#define CreateSpaceFrequencyViewType (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyViewType))
class Mp7JrsSpaceFrequencyViewType;
class IMp7JrsSpaceFrequencyViewType;
/** Smart pointer to instance of IMp7JrsSpaceFrequencyViewType */
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyViewType > Mp7JrsSpaceFrequencyViewPtr;

#define TypeOfSpaceFrequencyViewType_order_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpaceFrequencyViewType_order_LocalType")))
#define CreateSpaceFrequencyViewType_order_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpaceFrequencyViewType_order_LocalType))
class Mp7JrsSpaceFrequencyViewType_order_LocalType;
class IMp7JrsSpaceFrequencyViewType_order_LocalType;

#define TypeOfSpaceResolutionViewType (Mp7JrsFactory::GetTypeIndex(X("SpaceResolutionViewType")))
#define CreateSpaceResolutionViewType (Mp7JrsFactory::CreateObject(TypeOfSpaceResolutionViewType))
class Mp7JrsSpaceResolutionViewType;
class IMp7JrsSpaceResolutionViewType;
/** Smart pointer to instance of IMp7JrsSpaceResolutionViewType */
typedef Mp7JrsPtr< IMp7JrsSpaceResolutionViewType > Mp7JrsSpaceResolutionViewPtr;

#define TypeOfSpaceResolutionViewType_order_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpaceResolutionViewType_order_LocalType")))
#define CreateSpaceResolutionViewType_order_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpaceResolutionViewType_order_LocalType))
class Mp7JrsSpaceResolutionViewType_order_LocalType;
class IMp7JrsSpaceResolutionViewType_order_LocalType;

#define TypeOfSpaceTreeType (Mp7JrsFactory::GetTypeIndex(X("SpaceTreeType")))
#define CreateSpaceTreeType (Mp7JrsFactory::CreateObject(TypeOfSpaceTreeType))
class Mp7JrsSpaceTreeType;
class IMp7JrsSpaceTreeType;
/** Smart pointer to instance of IMp7JrsSpaceTreeType */
typedef Mp7JrsPtr< IMp7JrsSpaceTreeType > Mp7JrsSpaceTreePtr;

#define TypeOfSpaceTreeType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpaceTreeType_CollectionType")))
#define CreateSpaceTreeType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpaceTreeType_CollectionType))
class Mp7JrsSpaceTreeType_CollectionType;
class IMp7JrsSpaceTreeType_CollectionType;
/** Smart pointer to instance of IMp7JrsSpaceTreeType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpaceTreeType_CollectionType > Mp7JrsSpaceTreeType_CollectionPtr;

#define TypeOfSpaceTreeType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpaceTreeType_LocalType")))
#define CreateSpaceTreeType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpaceTreeType_LocalType))
class Mp7JrsSpaceTreeType_LocalType;
class IMp7JrsSpaceTreeType_LocalType;
/** Smart pointer to instance of IMp7JrsSpaceTreeType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpaceTreeType_LocalType > Mp7JrsSpaceTreeType_LocalPtr;

#define TypeOfSpaceViewType (Mp7JrsFactory::GetTypeIndex(X("SpaceViewType")))
#define CreateSpaceViewType (Mp7JrsFactory::CreateObject(TypeOfSpaceViewType))
class Mp7JrsSpaceViewType;
class IMp7JrsSpaceViewType;
/** Smart pointer to instance of IMp7JrsSpaceViewType */
typedef Mp7JrsPtr< IMp7JrsSpaceViewType > Mp7JrsSpaceViewPtr;

#define TypeOfSpatial2DCoordinateSystemType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType")))
#define CreateSpatial2DCoordinateSystemType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType))
class Mp7JrsSpatial2DCoordinateSystemType;
class IMp7JrsSpatial2DCoordinateSystemType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType > Mp7JrsSpatial2DCoordinateSystemPtr;

#define TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType")))
#define CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType))
class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr;

#define TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType")))
#define CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType > Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr;

#define TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0")))
#define CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0))
class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 > Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_Local0Ptr;

#define TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType")))
#define CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType;

#define TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType")))
#define CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType))
class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0 > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr;

#define TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType")))
#define CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType;
/** Smart pointer to instance of IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr;

#define TypeOfSpatial2DCoordinateSystemType_Unit_LocalType (Mp7JrsFactory::GetTypeIndex(X("Spatial2DCoordinateSystemType_Unit_LocalType")))
#define CreateSpatial2DCoordinateSystemType_Unit_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatial2DCoordinateSystemType_Unit_LocalType))
class Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_Unit_LocalType;

#define TypeOfSpatialMaskType (Mp7JrsFactory::GetTypeIndex(X("SpatialMaskType")))
#define CreateSpatialMaskType (Mp7JrsFactory::CreateObject(TypeOfSpatialMaskType))
class Mp7JrsSpatialMaskType;
class IMp7JrsSpatialMaskType;
/** Smart pointer to instance of IMp7JrsSpatialMaskType */
typedef Mp7JrsPtr< IMp7JrsSpatialMaskType > Mp7JrsSpatialMaskPtr;

#define TypeOfSpatialMaskType_SubRegion_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpatialMaskType_SubRegion_CollectionType")))
#define CreateSpatialMaskType_SubRegion_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatialMaskType_SubRegion_CollectionType))
class Mp7JrsSpatialMaskType_SubRegion_CollectionType;
class IMp7JrsSpatialMaskType_SubRegion_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatialMaskType_SubRegion_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatialMaskType_SubRegion_CollectionType > Mp7JrsSpatialMaskType_SubRegion_CollectionPtr;

#define TypeOfSpatialSegmentDecompositionType (Mp7JrsFactory::GetTypeIndex(X("SpatialSegmentDecompositionType")))
#define CreateSpatialSegmentDecompositionType (Mp7JrsFactory::CreateObject(TypeOfSpatialSegmentDecompositionType))
class Mp7JrsSpatialSegmentDecompositionType;
class IMp7JrsSpatialSegmentDecompositionType;
/** Smart pointer to instance of IMp7JrsSpatialSegmentDecompositionType */
typedef Mp7JrsPtr< IMp7JrsSpatialSegmentDecompositionType > Mp7JrsSpatialSegmentDecompositionPtr;

#define TypeOfSpatioTemporalLocatorType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalLocatorType")))
#define CreateSpatioTemporalLocatorType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalLocatorType))
class Mp7JrsSpatioTemporalLocatorType;
class IMp7JrsSpatioTemporalLocatorType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalLocatorType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalLocatorType > Mp7JrsSpatioTemporalLocatorPtr;

#define TypeOfSpatioTemporalLocatorType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalLocatorType_CollectionType")))
#define CreateSpatioTemporalLocatorType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalLocatorType_CollectionType))
class Mp7JrsSpatioTemporalLocatorType_CollectionType;
class IMp7JrsSpatioTemporalLocatorType_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalLocatorType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalLocatorType_CollectionType > Mp7JrsSpatioTemporalLocatorType_CollectionPtr;

#define TypeOfSpatioTemporalLocatorType_CoordRef_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalLocatorType_CoordRef_LocalType")))
#define CreateSpatioTemporalLocatorType_CoordRef_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalLocatorType_CoordRef_LocalType))
class Mp7JrsSpatioTemporalLocatorType_CoordRef_LocalType;
class IMp7JrsSpatioTemporalLocatorType_CoordRef_LocalType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalLocatorType_CoordRef_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalLocatorType_CoordRef_LocalType > Mp7JrsSpatioTemporalLocatorType_CoordRef_LocalPtr;

#define TypeOfSpatioTemporalLocatorType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalLocatorType_LocalType")))
#define CreateSpatioTemporalLocatorType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalLocatorType_LocalType))
class Mp7JrsSpatioTemporalLocatorType_LocalType;
class IMp7JrsSpatioTemporalLocatorType_LocalType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalLocatorType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalLocatorType_LocalType > Mp7JrsSpatioTemporalLocatorType_LocalPtr;

#define TypeOfSpatioTemporalMaskType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalMaskType")))
#define CreateSpatioTemporalMaskType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalMaskType))
class Mp7JrsSpatioTemporalMaskType;
class IMp7JrsSpatioTemporalMaskType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalMaskType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalMaskType > Mp7JrsSpatioTemporalMaskPtr;

#define TypeOfSpatioTemporalMaskType_SubRegion_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalMaskType_SubRegion_CollectionType")))
#define CreateSpatioTemporalMaskType_SubRegion_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalMaskType_SubRegion_CollectionType))
class Mp7JrsSpatioTemporalMaskType_SubRegion_CollectionType;
class IMp7JrsSpatioTemporalMaskType_SubRegion_CollectionType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalMaskType_SubRegion_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalMaskType_SubRegion_CollectionType > Mp7JrsSpatioTemporalMaskType_SubRegion_CollectionPtr;

#define TypeOfSpatioTemporalSegmentDecompositionType (Mp7JrsFactory::GetTypeIndex(X("SpatioTemporalSegmentDecompositionType")))
#define CreateSpatioTemporalSegmentDecompositionType (Mp7JrsFactory::CreateObject(TypeOfSpatioTemporalSegmentDecompositionType))
class Mp7JrsSpatioTemporalSegmentDecompositionType;
class IMp7JrsSpatioTemporalSegmentDecompositionType;
/** Smart pointer to instance of IMp7JrsSpatioTemporalSegmentDecompositionType */
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalSegmentDecompositionType > Mp7JrsSpatioTemporalSegmentDecompositionPtr;

#define TypeOfSpeakerInfoType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType")))
#define CreateSpeakerInfoType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType))
class Mp7JrsSpeakerInfoType;
class IMp7JrsSpeakerInfoType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType > Mp7JrsSpeakerInfoPtr;

#define TypeOfSpeakerInfoType_PhoneIndex_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_PhoneIndex_LocalType")))
#define CreateSpeakerInfoType_PhoneIndex_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_PhoneIndex_LocalType))
class Mp7JrsSpeakerInfoType_PhoneIndex_LocalType;
class IMp7JrsSpeakerInfoType_PhoneIndex_LocalType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_PhoneIndex_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_PhoneIndex_LocalType > Mp7JrsSpeakerInfoType_PhoneIndex_LocalPtr;

#define TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType")))
#define CreateSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType))
class Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType;
class IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType > Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionPtr;

#define TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType")))
#define CreateSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType))
class Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType;
class IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType > Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionPtr;

#define TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType")))
#define CreateSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType))
class Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType;
class IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType > Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionPtr;

#define TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType")))
#define CreateSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType))
class Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType;
class IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType > Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalPtr;

#define TypeOfSpeakerInfoType_provenance_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_provenance_LocalType")))
#define CreateSpeakerInfoType_provenance_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_provenance_LocalType))
class Mp7JrsSpeakerInfoType_provenance_LocalType;
class IMp7JrsSpeakerInfoType_provenance_LocalType;

#define TypeOfSpeakerInfoType_WordIndex_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_WordIndex_LocalType")))
#define CreateSpeakerInfoType_WordIndex_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_WordIndex_LocalType))
class Mp7JrsSpeakerInfoType_WordIndex_LocalType;
class IMp7JrsSpeakerInfoType_WordIndex_LocalType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_WordIndex_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_LocalType > Mp7JrsSpeakerInfoType_WordIndex_LocalPtr;

#define TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_WordIndex_WordIndexEntry_CollectionType")))
#define CreateSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType))
class Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType;
class IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType > Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionPtr;

#define TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType")))
#define CreateSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType))
class Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType;
class IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType > Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionPtr;

#define TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType")))
#define CreateSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType))
class Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType;
class IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType > Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionPtr;

#define TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpeakerInfoType_WordIndex_WordIndexEntry_LocalType")))
#define CreateSpeakerInfoType_WordIndex_WordIndexEntry_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpeakerInfoType_WordIndex_WordIndexEntry_LocalType))
class Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalType;
class IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalType;
/** Smart pointer to instance of IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalType > Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalPtr;

#define TypeOfSpectralCentroidType (Mp7JrsFactory::GetTypeIndex(X("SpectralCentroidType")))
#define CreateSpectralCentroidType (Mp7JrsFactory::CreateObject(TypeOfSpectralCentroidType))
class Mp7JrsSpectralCentroidType;
class IMp7JrsSpectralCentroidType;
/** Smart pointer to instance of IMp7JrsSpectralCentroidType */
typedef Mp7JrsPtr< IMp7JrsSpectralCentroidType > Mp7JrsSpectralCentroidPtr;

#define TypeOfSpokenContentHeaderType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentHeaderType")))
#define CreateSpokenContentHeaderType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentHeaderType))
class Mp7JrsSpokenContentHeaderType;
class IMp7JrsSpokenContentHeaderType;
/** Smart pointer to instance of IMp7JrsSpokenContentHeaderType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType > Mp7JrsSpokenContentHeaderPtr;

#define TypeOfSpokenContentHeaderType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentHeaderType_CollectionType")))
#define CreateSpokenContentHeaderType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentHeaderType_CollectionType))
class Mp7JrsSpokenContentHeaderType_CollectionType;
class IMp7JrsSpokenContentHeaderType_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentHeaderType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_CollectionType > Mp7JrsSpokenContentHeaderType_CollectionPtr;

#define TypeOfSpokenContentHeaderType_ConfusionInfo_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentHeaderType_ConfusionInfo_CollectionType")))
#define CreateSpokenContentHeaderType_ConfusionInfo_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentHeaderType_ConfusionInfo_CollectionType))
class Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType;
class IMp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType > Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionPtr;

#define TypeOfSpokenContentHeaderType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentHeaderType_LocalType")))
#define CreateSpokenContentHeaderType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentHeaderType_LocalType))
class Mp7JrsSpokenContentHeaderType_LocalType;
class IMp7JrsSpokenContentHeaderType_LocalType;
/** Smart pointer to instance of IMp7JrsSpokenContentHeaderType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_LocalType > Mp7JrsSpokenContentHeaderType_LocalPtr;

#define TypeOfSpokenContentHeaderType_SpeakerInfo_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentHeaderType_SpeakerInfo_CollectionType")))
#define CreateSpokenContentHeaderType_SpeakerInfo_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentHeaderType_SpeakerInfo_CollectionType))
class Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType;
class IMp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType > Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionPtr;

#define TypeOfSpokenContentIndexEntryType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentIndexEntryType")))
#define CreateSpokenContentIndexEntryType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentIndexEntryType))
class Mp7JrsSpokenContentIndexEntryType;
class IMp7JrsSpokenContentIndexEntryType;
/** Smart pointer to instance of IMp7JrsSpokenContentIndexEntryType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentIndexEntryType > Mp7JrsSpokenContentIndexEntryPtr;

#define TypeOfSpokenContentLatticeType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType")))
#define CreateSpokenContentLatticeType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType))
class Mp7JrsSpokenContentLatticeType;
class IMp7JrsSpokenContentLatticeType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType > Mp7JrsSpokenContentLatticePtr;

#define TypeOfSpokenContentLatticeType_Block_audio_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_audio_LocalType")))
#define CreateSpokenContentLatticeType_Block_audio_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_audio_LocalType))
class Mp7JrsSpokenContentLatticeType_Block_audio_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_audio_LocalType;

#define TypeOfSpokenContentLatticeType_Block_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_CollectionType")))
#define CreateSpokenContentLatticeType_Block_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_CollectionType))
class Mp7JrsSpokenContentLatticeType_Block_CollectionType;
class IMp7JrsSpokenContentLatticeType_Block_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_CollectionType > Mp7JrsSpokenContentLatticeType_Block_CollectionPtr;

#define TypeOfSpokenContentLatticeType_Block_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_LocalType")))
#define CreateSpokenContentLatticeType_Block_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_LocalType))
class Mp7JrsSpokenContentLatticeType_Block_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_LocalType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_LocalType > Mp7JrsSpokenContentLatticeType_Block_LocalPtr;

#define TypeOfSpokenContentLatticeType_Block_Node_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_Node_CollectionType")))
#define CreateSpokenContentLatticeType_Block_Node_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_Node_CollectionType))
class Mp7JrsSpokenContentLatticeType_Block_Node_CollectionType;
class IMp7JrsSpokenContentLatticeType_Block_Node_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_Node_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_CollectionType > Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr;

#define TypeOfSpokenContentLatticeType_Block_Node_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_Node_LocalType")))
#define CreateSpokenContentLatticeType_Block_Node_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_Node_LocalType))
class Mp7JrsSpokenContentLatticeType_Block_Node_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_Node_LocalType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_Node_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_LocalType > Mp7JrsSpokenContentLatticeType_Block_Node_LocalPtr;

#define TypeOfSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_Node_PhoneLink_CollectionType")))
#define CreateSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType))
class Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType;
class IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType > Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionPtr;

#define TypeOfSpokenContentLatticeType_Block_Node_PhoneLink_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_Node_PhoneLink_LocalType")))
#define CreateSpokenContentLatticeType_Block_Node_PhoneLink_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_Node_PhoneLink_LocalType))
class Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType > Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalPtr;

#define TypeOfSpokenContentLatticeType_Block_Node_WordLink_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_Node_WordLink_CollectionType")))
#define CreateSpokenContentLatticeType_Block_Node_WordLink_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_Node_WordLink_CollectionType))
class Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType;
class IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType > Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionPtr;

#define TypeOfSpokenContentLatticeType_Block_Node_WordLink_LocalType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLatticeType_Block_Node_WordLink_LocalType")))
#define CreateSpokenContentLatticeType_Block_Node_WordLink_LocalType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLatticeType_Block_Node_WordLink_LocalType))
class Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalType;
class IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalType;
/** Smart pointer to instance of IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalType > Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalPtr;

#define TypeOfSpokenContentLinkType (Mp7JrsFactory::GetTypeIndex(X("SpokenContentLinkType")))
#define CreateSpokenContentLinkType (Mp7JrsFactory::CreateObject(TypeOfSpokenContentLinkType))
class Mp7JrsSpokenContentLinkType;
class IMp7JrsSpokenContentLinkType;
/** Smart pointer to instance of IMp7JrsSpokenContentLinkType */
typedef Mp7JrsPtr< IMp7JrsSpokenContentLinkType > Mp7JrsSpokenContentLinkPtr;

#define TypeOfStateTransitionModelType (Mp7JrsFactory::GetTypeIndex(X("StateTransitionModelType")))
#define CreateStateTransitionModelType (Mp7JrsFactory::CreateObject(TypeOfStateTransitionModelType))
class Mp7JrsStateTransitionModelType;
class IMp7JrsStateTransitionModelType;
/** Smart pointer to instance of IMp7JrsStateTransitionModelType */
typedef Mp7JrsPtr< IMp7JrsStateTransitionModelType > Mp7JrsStateTransitionModelPtr;

#define TypeOfStateTransitionModelType_State_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StateTransitionModelType_State_CollectionType")))
#define CreateStateTransitionModelType_State_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStateTransitionModelType_State_CollectionType))
class Mp7JrsStateTransitionModelType_State_CollectionType;
class IMp7JrsStateTransitionModelType_State_CollectionType;
/** Smart pointer to instance of IMp7JrsStateTransitionModelType_State_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStateTransitionModelType_State_CollectionType > Mp7JrsStateTransitionModelType_State_CollectionPtr;

#define TypeOfStillRegion3DSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DSpatialDecompositionType")))
#define CreateStillRegion3DSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DSpatialDecompositionType))
class Mp7JrsStillRegion3DSpatialDecompositionType;
class IMp7JrsStillRegion3DSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsStillRegion3DSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DSpatialDecompositionType > Mp7JrsStillRegion3DSpatialDecompositionPtr;

#define TypeOfStillRegion3DSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DSpatialDecompositionType_CollectionType")))
#define CreateStillRegion3DSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DSpatialDecompositionType_CollectionType))
class Mp7JrsStillRegion3DSpatialDecompositionType_CollectionType;
class IMp7JrsStillRegion3DSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsStillRegion3DSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DSpatialDecompositionType_CollectionType > Mp7JrsStillRegion3DSpatialDecompositionType_CollectionPtr;

#define TypeOfStillRegion3DSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DSpatialDecompositionType_LocalType")))
#define CreateStillRegion3DSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DSpatialDecompositionType_LocalType))
class Mp7JrsStillRegion3DSpatialDecompositionType_LocalType;
class IMp7JrsStillRegion3DSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsStillRegion3DSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DSpatialDecompositionType_LocalType > Mp7JrsStillRegion3DSpatialDecompositionType_LocalPtr;

#define TypeOfStillRegion3DType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DType")))
#define CreateStillRegion3DType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DType))
class Mp7JrsStillRegion3DType;
class IMp7JrsStillRegion3DType;
/** Smart pointer to instance of IMp7JrsStillRegion3DType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DType > Mp7JrsStillRegion3DPtr;

#define TypeOfStillRegion3DType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DType_CollectionType")))
#define CreateStillRegion3DType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DType_CollectionType))
class Mp7JrsStillRegion3DType_CollectionType;
class IMp7JrsStillRegion3DType_CollectionType;
/** Smart pointer to instance of IMp7JrsStillRegion3DType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DType_CollectionType > Mp7JrsStillRegion3DType_CollectionPtr;

#define TypeOfStillRegion3DType_LocalType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DType_LocalType")))
#define CreateStillRegion3DType_LocalType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DType_LocalType))
class Mp7JrsStillRegion3DType_LocalType;
class IMp7JrsStillRegion3DType_LocalType;
/** Smart pointer to instance of IMp7JrsStillRegion3DType_LocalType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DType_LocalType > Mp7JrsStillRegion3DType_LocalPtr;

#define TypeOfStillRegion3DType_SpatialDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StillRegion3DType_SpatialDecomposition_CollectionType")))
#define CreateStillRegion3DType_SpatialDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStillRegion3DType_SpatialDecomposition_CollectionType))
class Mp7JrsStillRegion3DType_SpatialDecomposition_CollectionType;
class IMp7JrsStillRegion3DType_SpatialDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsStillRegion3DType_SpatialDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStillRegion3DType_SpatialDecomposition_CollectionType > Mp7JrsStillRegion3DType_SpatialDecomposition_CollectionPtr;

#define TypeOfStillRegionSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("StillRegionSpatialDecompositionType")))
#define CreateStillRegionSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfStillRegionSpatialDecompositionType))
class Mp7JrsStillRegionSpatialDecompositionType;
class IMp7JrsStillRegionSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsStillRegionSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsStillRegionSpatialDecompositionType > Mp7JrsStillRegionSpatialDecompositionPtr;

#define TypeOfStillRegionSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StillRegionSpatialDecompositionType_CollectionType")))
#define CreateStillRegionSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStillRegionSpatialDecompositionType_CollectionType))
class Mp7JrsStillRegionSpatialDecompositionType_CollectionType;
class IMp7JrsStillRegionSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsStillRegionSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStillRegionSpatialDecompositionType_CollectionType > Mp7JrsStillRegionSpatialDecompositionType_CollectionPtr;

#define TypeOfStillRegionSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("StillRegionSpatialDecompositionType_LocalType")))
#define CreateStillRegionSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfStillRegionSpatialDecompositionType_LocalType))
class Mp7JrsStillRegionSpatialDecompositionType_LocalType;
class IMp7JrsStillRegionSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsStillRegionSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsStillRegionSpatialDecompositionType_LocalType > Mp7JrsStillRegionSpatialDecompositionType_LocalPtr;

#define TypeOfStillRegionType (Mp7JrsFactory::GetTypeIndex(X("StillRegionType")))
#define CreateStillRegionType (Mp7JrsFactory::CreateObject(TypeOfStillRegionType))
class Mp7JrsStillRegionType;
class IMp7JrsStillRegionType;
/** Smart pointer to instance of IMp7JrsStillRegionType */
typedef Mp7JrsPtr< IMp7JrsStillRegionType > Mp7JrsStillRegionPtr;

#define TypeOfStillRegionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StillRegionType_CollectionType")))
#define CreateStillRegionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStillRegionType_CollectionType))
class Mp7JrsStillRegionType_CollectionType;
class IMp7JrsStillRegionType_CollectionType;
/** Smart pointer to instance of IMp7JrsStillRegionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStillRegionType_CollectionType > Mp7JrsStillRegionType_CollectionPtr;

#define TypeOfStillRegionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("StillRegionType_LocalType")))
#define CreateStillRegionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfStillRegionType_LocalType))
class Mp7JrsStillRegionType_LocalType;
class IMp7JrsStillRegionType_LocalType;
/** Smart pointer to instance of IMp7JrsStillRegionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsStillRegionType_LocalType > Mp7JrsStillRegionType_LocalPtr;

#define TypeOfStillRegionType_SpatialDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StillRegionType_SpatialDecomposition_CollectionType")))
#define CreateStillRegionType_SpatialDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStillRegionType_SpatialDecomposition_CollectionType))
class Mp7JrsStillRegionType_SpatialDecomposition_CollectionType;
class IMp7JrsStillRegionType_SpatialDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsStillRegionType_SpatialDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStillRegionType_SpatialDecomposition_CollectionType > Mp7JrsStillRegionType_SpatialDecomposition_CollectionPtr;

#define TypeOfStructuredAnnotationType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType")))
#define CreateStructuredAnnotationType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType))
class Mp7JrsStructuredAnnotationType;
class IMp7JrsStructuredAnnotationType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType > Mp7JrsStructuredAnnotationPtr;

#define TypeOfStructuredAnnotationType_How_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_How_CollectionType")))
#define CreateStructuredAnnotationType_How_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_How_CollectionType))
class Mp7JrsStructuredAnnotationType_How_CollectionType;
class IMp7JrsStructuredAnnotationType_How_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_How_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_How_CollectionType > Mp7JrsStructuredAnnotationType_How_CollectionPtr;

#define TypeOfStructuredAnnotationType_WhatAction_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_WhatAction_CollectionType")))
#define CreateStructuredAnnotationType_WhatAction_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_WhatAction_CollectionType))
class Mp7JrsStructuredAnnotationType_WhatAction_CollectionType;
class IMp7JrsStructuredAnnotationType_WhatAction_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_WhatAction_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_WhatAction_CollectionType > Mp7JrsStructuredAnnotationType_WhatAction_CollectionPtr;

#define TypeOfStructuredAnnotationType_WhatObject_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_WhatObject_CollectionType")))
#define CreateStructuredAnnotationType_WhatObject_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_WhatObject_CollectionType))
class Mp7JrsStructuredAnnotationType_WhatObject_CollectionType;
class IMp7JrsStructuredAnnotationType_WhatObject_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_WhatObject_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_WhatObject_CollectionType > Mp7JrsStructuredAnnotationType_WhatObject_CollectionPtr;

#define TypeOfStructuredAnnotationType_When_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_When_CollectionType")))
#define CreateStructuredAnnotationType_When_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_When_CollectionType))
class Mp7JrsStructuredAnnotationType_When_CollectionType;
class IMp7JrsStructuredAnnotationType_When_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_When_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_When_CollectionType > Mp7JrsStructuredAnnotationType_When_CollectionPtr;

#define TypeOfStructuredAnnotationType_Where_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_Where_CollectionType")))
#define CreateStructuredAnnotationType_Where_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_Where_CollectionType))
class Mp7JrsStructuredAnnotationType_Where_CollectionType;
class IMp7JrsStructuredAnnotationType_Where_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_Where_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_Where_CollectionType > Mp7JrsStructuredAnnotationType_Where_CollectionPtr;

#define TypeOfStructuredAnnotationType_Who_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_Who_CollectionType")))
#define CreateStructuredAnnotationType_Who_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_Who_CollectionType))
class Mp7JrsStructuredAnnotationType_Who_CollectionType;
class IMp7JrsStructuredAnnotationType_Who_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_Who_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_Who_CollectionType > Mp7JrsStructuredAnnotationType_Who_CollectionPtr;

#define TypeOfStructuredAnnotationType_Why_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredAnnotationType_Why_CollectionType")))
#define CreateStructuredAnnotationType_Why_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredAnnotationType_Why_CollectionType))
class Mp7JrsStructuredAnnotationType_Why_CollectionType;
class IMp7JrsStructuredAnnotationType_Why_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredAnnotationType_Why_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType_Why_CollectionType > Mp7JrsStructuredAnnotationType_Why_CollectionPtr;

#define TypeOfStructuredCollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType")))
#define CreateStructuredCollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType))
class Mp7JrsStructuredCollectionType;
class IMp7JrsStructuredCollectionType;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType > Mp7JrsStructuredCollectionPtr;

#define TypeOfStructuredCollectionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_CollectionType")))
#define CreateStructuredCollectionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_CollectionType))
class Mp7JrsStructuredCollectionType_CollectionType;
class IMp7JrsStructuredCollectionType_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_CollectionType > Mp7JrsStructuredCollectionType_CollectionPtr;

#define TypeOfStructuredCollectionType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_CollectionType0")))
#define CreateStructuredCollectionType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_CollectionType0))
class Mp7JrsStructuredCollectionType_CollectionType0;
class IMp7JrsStructuredCollectionType_CollectionType0;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_CollectionType0 > Mp7JrsStructuredCollectionType_Collection0Ptr;

#define TypeOfStructuredCollectionType_CollectionType1 (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_CollectionType1")))
#define CreateStructuredCollectionType_CollectionType1 (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_CollectionType1))
class Mp7JrsStructuredCollectionType_CollectionType1;
class IMp7JrsStructuredCollectionType_CollectionType1;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_CollectionType1 */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_CollectionType1 > Mp7JrsStructuredCollectionType_Collection1Ptr;

#define TypeOfStructuredCollectionType_CollectionType2 (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_CollectionType2")))
#define CreateStructuredCollectionType_CollectionType2 (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_CollectionType2))
class Mp7JrsStructuredCollectionType_CollectionType2;
class IMp7JrsStructuredCollectionType_CollectionType2;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_CollectionType2 */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_CollectionType2 > Mp7JrsStructuredCollectionType_Collection2Ptr;

#define TypeOfStructuredCollectionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_LocalType")))
#define CreateStructuredCollectionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_LocalType))
class Mp7JrsStructuredCollectionType_LocalType;
class IMp7JrsStructuredCollectionType_LocalType;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_LocalType > Mp7JrsStructuredCollectionType_LocalPtr;

#define TypeOfStructuredCollectionType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_LocalType0")))
#define CreateStructuredCollectionType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_LocalType0))
class Mp7JrsStructuredCollectionType_LocalType0;
class IMp7JrsStructuredCollectionType_LocalType0;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_LocalType0 > Mp7JrsStructuredCollectionType_Local0Ptr;

#define TypeOfStructuredCollectionType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_LocalType1")))
#define CreateStructuredCollectionType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_LocalType1))
class Mp7JrsStructuredCollectionType_LocalType1;
class IMp7JrsStructuredCollectionType_LocalType1;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_LocalType1 > Mp7JrsStructuredCollectionType_Local1Ptr;

#define TypeOfStructuredCollectionType_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_LocalType2")))
#define CreateStructuredCollectionType_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_LocalType2))
class Mp7JrsStructuredCollectionType_LocalType2;
class IMp7JrsStructuredCollectionType_LocalType2;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_LocalType2 > Mp7JrsStructuredCollectionType_Local2Ptr;

#define TypeOfStructuredCollectionType_Relationships_CollectionType (Mp7JrsFactory::GetTypeIndex(X("StructuredCollectionType_Relationships_CollectionType")))
#define CreateStructuredCollectionType_Relationships_CollectionType (Mp7JrsFactory::CreateObject(TypeOfStructuredCollectionType_Relationships_CollectionType))
class Mp7JrsStructuredCollectionType_Relationships_CollectionType;
class IMp7JrsStructuredCollectionType_Relationships_CollectionType;
/** Smart pointer to instance of IMp7JrsStructuredCollectionType_Relationships_CollectionType */
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_Relationships_CollectionType > Mp7JrsStructuredCollectionType_Relationships_CollectionPtr;

#define TypeOfSummarizationType (Mp7JrsFactory::GetTypeIndex(X("SummarizationType")))
#define CreateSummarizationType (Mp7JrsFactory::CreateObject(TypeOfSummarizationType))
class Mp7JrsSummarizationType;
class IMp7JrsSummarizationType;
/** Smart pointer to instance of IMp7JrsSummarizationType */
typedef Mp7JrsPtr< IMp7JrsSummarizationType > Mp7JrsSummarizationPtr;

#define TypeOfSummarizationType_Summary_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarizationType_Summary_CollectionType")))
#define CreateSummarizationType_Summary_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarizationType_Summary_CollectionType))
class Mp7JrsSummarizationType_Summary_CollectionType;
class IMp7JrsSummarizationType_Summary_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarizationType_Summary_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarizationType_Summary_CollectionType > Mp7JrsSummarizationType_Summary_CollectionPtr;

#define TypeOfsummaryComponentType (Mp7JrsFactory::GetTypeIndex(X("summaryComponentType")))
#define CreatesummaryComponentType (Mp7JrsFactory::CreateObject(TypeOfsummaryComponentType))
class Mp7JrssummaryComponentType;
class IMp7JrssummaryComponentType;
/** Smart pointer to instance of IMp7JrssummaryComponentType */
typedef Mp7JrsPtr< IMp7JrssummaryComponentType > Mp7JrssummaryComponentPtr;

#define TypeOfsummaryComponentType_LocalType (Mp7JrsFactory::GetTypeIndex(X("summaryComponentType_LocalType")))
#define CreatesummaryComponentType_LocalType (Mp7JrsFactory::CreateObject(TypeOfsummaryComponentType_LocalType))
class Mp7JrssummaryComponentType_LocalType;
class IMp7JrssummaryComponentType_LocalType;

#define TypeOfsummaryComponentType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("summaryComponentType_LocalType0")))
#define CreatesummaryComponentType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfsummaryComponentType_LocalType0))
class Mp7JrssummaryComponentType_LocalType0;
class IMp7JrssummaryComponentType_LocalType0;
/** Smart pointer to instance of IMp7JrssummaryComponentType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrssummaryComponentType_LocalType0 > Mp7JrssummaryComponentType_Local0Ptr;

#define TypeOfsummaryComponentType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("summaryComponentType_LocalType1")))
#define CreatesummaryComponentType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfsummaryComponentType_LocalType1))
class Mp7JrssummaryComponentType_LocalType1;
class IMp7JrssummaryComponentType_LocalType1;
/** Smart pointer to instance of IMp7JrssummaryComponentType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrssummaryComponentType_LocalType1 > Mp7JrssummaryComponentType_Local1Ptr;

#define TypeOfSummaryDescriptionType (Mp7JrsFactory::GetTypeIndex(X("SummaryDescriptionType")))
#define CreateSummaryDescriptionType (Mp7JrsFactory::CreateObject(TypeOfSummaryDescriptionType))
class Mp7JrsSummaryDescriptionType;
class IMp7JrsSummaryDescriptionType;
/** Smart pointer to instance of IMp7JrsSummaryDescriptionType */
typedef Mp7JrsPtr< IMp7JrsSummaryDescriptionType > Mp7JrsSummaryDescriptionPtr;

#define TypeOfSummaryDescriptionType_Summarization_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummaryDescriptionType_Summarization_CollectionType")))
#define CreateSummaryDescriptionType_Summarization_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummaryDescriptionType_Summarization_CollectionType))
class Mp7JrsSummaryDescriptionType_Summarization_CollectionType;
class IMp7JrsSummaryDescriptionType_Summarization_CollectionType;
/** Smart pointer to instance of IMp7JrsSummaryDescriptionType_Summarization_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummaryDescriptionType_Summarization_CollectionType > Mp7JrsSummaryDescriptionType_Summarization_CollectionPtr;

#define TypeOfSummaryPreferencesType (Mp7JrsFactory::GetTypeIndex(X("SummaryPreferencesType")))
#define CreateSummaryPreferencesType (Mp7JrsFactory::CreateObject(TypeOfSummaryPreferencesType))
class Mp7JrsSummaryPreferencesType;
class IMp7JrsSummaryPreferencesType;
/** Smart pointer to instance of IMp7JrsSummaryPreferencesType */
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType > Mp7JrsSummaryPreferencesPtr;

#define TypeOfSummaryPreferencesType_SummaryTheme_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummaryPreferencesType_SummaryTheme_CollectionType")))
#define CreateSummaryPreferencesType_SummaryTheme_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummaryPreferencesType_SummaryTheme_CollectionType))
class Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionType;
class IMp7JrsSummaryPreferencesType_SummaryTheme_CollectionType;
/** Smart pointer to instance of IMp7JrsSummaryPreferencesType_SummaryTheme_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryTheme_CollectionType > Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionPtr;

#define TypeOfSummaryPreferencesType_SummaryTheme_LocalType (Mp7JrsFactory::GetTypeIndex(X("SummaryPreferencesType_SummaryTheme_LocalType")))
#define CreateSummaryPreferencesType_SummaryTheme_LocalType (Mp7JrsFactory::CreateObject(TypeOfSummaryPreferencesType_SummaryTheme_LocalType))
class Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType;
class IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType;
/** Smart pointer to instance of IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType */
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryTheme_LocalType > Mp7JrsSummaryPreferencesType_SummaryTheme_LocalPtr;

#define TypeOfSummaryPreferencesType_SummaryType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummaryPreferencesType_SummaryType_CollectionType")))
#define CreateSummaryPreferencesType_SummaryType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummaryPreferencesType_SummaryType_CollectionType))
class Mp7JrsSummaryPreferencesType_SummaryType_CollectionType;
class IMp7JrsSummaryPreferencesType_SummaryType_CollectionType;
/** Smart pointer to instance of IMp7JrsSummaryPreferencesType_SummaryType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryType_CollectionType > Mp7JrsSummaryPreferencesType_SummaryType_CollectionPtr;

#define TypeOfSummaryPreferencesType_SummaryType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SummaryPreferencesType_SummaryType_LocalType")))
#define CreateSummaryPreferencesType_SummaryType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSummaryPreferencesType_SummaryType_LocalType))
class Mp7JrsSummaryPreferencesType_SummaryType_LocalType;
class IMp7JrsSummaryPreferencesType_SummaryType_LocalType;
/** Smart pointer to instance of IMp7JrsSummaryPreferencesType_SummaryType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSummaryPreferencesType_SummaryType_LocalType > Mp7JrsSummaryPreferencesType_SummaryType_LocalPtr;

#define TypeOfSummarySegmentGroupType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType")))
#define CreateSummarySegmentGroupType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType))
class Mp7JrsSummarySegmentGroupType;
class IMp7JrsSummarySegmentGroupType;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType > Mp7JrsSummarySegmentGroupPtr;

#define TypeOfSummarySegmentGroupType_Caption_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType_Caption_CollectionType")))
#define CreateSummarySegmentGroupType_Caption_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType_Caption_CollectionType))
class Mp7JrsSummarySegmentGroupType_Caption_CollectionType;
class IMp7JrsSummarySegmentGroupType_Caption_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType_Caption_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_Caption_CollectionType > Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr;

#define TypeOfSummarySegmentGroupType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType_CollectionType")))
#define CreateSummarySegmentGroupType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType_CollectionType))
class Mp7JrsSummarySegmentGroupType_CollectionType;
class IMp7JrsSummarySegmentGroupType_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_CollectionType > Mp7JrsSummarySegmentGroupType_CollectionPtr;

#define TypeOfSummarySegmentGroupType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType_CollectionType0")))
#define CreateSummarySegmentGroupType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType_CollectionType0))
class Mp7JrsSummarySegmentGroupType_CollectionType0;
class IMp7JrsSummarySegmentGroupType_CollectionType0;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_CollectionType0 > Mp7JrsSummarySegmentGroupType_Collection0Ptr;

#define TypeOfSummarySegmentGroupType_LocalType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType_LocalType")))
#define CreateSummarySegmentGroupType_LocalType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType_LocalType))
class Mp7JrsSummarySegmentGroupType_LocalType;
class IMp7JrsSummarySegmentGroupType_LocalType;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType_LocalType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_LocalType > Mp7JrsSummarySegmentGroupType_LocalPtr;

#define TypeOfSummarySegmentGroupType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType_LocalType0")))
#define CreateSummarySegmentGroupType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType_LocalType0))
class Mp7JrsSummarySegmentGroupType_LocalType0;
class IMp7JrsSummarySegmentGroupType_LocalType0;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_LocalType0 > Mp7JrsSummarySegmentGroupType_Local0Ptr;

#define TypeOfSummarySegmentGroupType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentGroupType_Name_CollectionType")))
#define CreateSummarySegmentGroupType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentGroupType_Name_CollectionType))
class Mp7JrsSummarySegmentGroupType_Name_CollectionType;
class IMp7JrsSummarySegmentGroupType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarySegmentGroupType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentGroupType_Name_CollectionType > Mp7JrsSummarySegmentGroupType_Name_CollectionPtr;

#define TypeOfSummarySegmentType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentType")))
#define CreateSummarySegmentType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentType))
class Mp7JrsSummarySegmentType;
class IMp7JrsSummarySegmentType;
/** Smart pointer to instance of IMp7JrsSummarySegmentType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentType > Mp7JrsSummarySegmentPtr;

#define TypeOfSummarySegmentType_KeyFrame_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentType_KeyFrame_CollectionType")))
#define CreateSummarySegmentType_KeyFrame_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentType_KeyFrame_CollectionType))
class Mp7JrsSummarySegmentType_KeyFrame_CollectionType;
class IMp7JrsSummarySegmentType_KeyFrame_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarySegmentType_KeyFrame_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentType_KeyFrame_CollectionType > Mp7JrsSummarySegmentType_KeyFrame_CollectionPtr;

#define TypeOfSummarySegmentType_KeySound_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentType_KeySound_CollectionType")))
#define CreateSummarySegmentType_KeySound_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentType_KeySound_CollectionType))
class Mp7JrsSummarySegmentType_KeySound_CollectionType;
class IMp7JrsSummarySegmentType_KeySound_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarySegmentType_KeySound_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentType_KeySound_CollectionType > Mp7JrsSummarySegmentType_KeySound_CollectionPtr;

#define TypeOfSummarySegmentType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummarySegmentType_Name_CollectionType")))
#define CreateSummarySegmentType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummarySegmentType_Name_CollectionType))
class Mp7JrsSummarySegmentType_Name_CollectionType;
class IMp7JrsSummarySegmentType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsSummarySegmentType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummarySegmentType_Name_CollectionType > Mp7JrsSummarySegmentType_Name_CollectionPtr;

#define TypeOfSummaryThemeListType (Mp7JrsFactory::GetTypeIndex(X("SummaryThemeListType")))
#define CreateSummaryThemeListType (Mp7JrsFactory::CreateObject(TypeOfSummaryThemeListType))
class Mp7JrsSummaryThemeListType;
class IMp7JrsSummaryThemeListType;
/** Smart pointer to instance of IMp7JrsSummaryThemeListType */
typedef Mp7JrsPtr< IMp7JrsSummaryThemeListType > Mp7JrsSummaryThemeListPtr;

#define TypeOfSummaryThemeListType_SummaryTheme_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummaryThemeListType_SummaryTheme_CollectionType")))
#define CreateSummaryThemeListType_SummaryTheme_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummaryThemeListType_SummaryTheme_CollectionType))
class Mp7JrsSummaryThemeListType_SummaryTheme_CollectionType;
class IMp7JrsSummaryThemeListType_SummaryTheme_CollectionType;
/** Smart pointer to instance of IMp7JrsSummaryThemeListType_SummaryTheme_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummaryThemeListType_SummaryTheme_CollectionType > Mp7JrsSummaryThemeListType_SummaryTheme_CollectionPtr;

#define TypeOfSummaryThemeListType_SummaryTheme_LocalType (Mp7JrsFactory::GetTypeIndex(X("SummaryThemeListType_SummaryTheme_LocalType")))
#define CreateSummaryThemeListType_SummaryTheme_LocalType (Mp7JrsFactory::CreateObject(TypeOfSummaryThemeListType_SummaryTheme_LocalType))
class Mp7JrsSummaryThemeListType_SummaryTheme_LocalType;
class IMp7JrsSummaryThemeListType_SummaryTheme_LocalType;
/** Smart pointer to instance of IMp7JrsSummaryThemeListType_SummaryTheme_LocalType */
typedef Mp7JrsPtr< IMp7JrsSummaryThemeListType_SummaryTheme_LocalType > Mp7JrsSummaryThemeListType_SummaryTheme_LocalPtr;

#define TypeOfSummaryType (Mp7JrsFactory::GetTypeIndex(X("SummaryType")))
#define CreateSummaryType (Mp7JrsFactory::CreateObject(TypeOfSummaryType))
class Mp7JrsSummaryType;
class IMp7JrsSummaryType;
/** Smart pointer to instance of IMp7JrsSummaryType */
typedef Mp7JrsPtr< IMp7JrsSummaryType > Mp7JrsSummaryPtr;

#define TypeOfSummaryType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("SummaryType_Name_CollectionType")))
#define CreateSummaryType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfSummaryType_Name_CollectionType))
class Mp7JrsSummaryType_Name_CollectionType;
class IMp7JrsSummaryType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsSummaryType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsSummaryType_Name_CollectionType > Mp7JrsSummaryType_Name_CollectionPtr;

#define TypeOfTemporalCentroidType (Mp7JrsFactory::GetTypeIndex(X("TemporalCentroidType")))
#define CreateTemporalCentroidType (Mp7JrsFactory::CreateObject(TypeOfTemporalCentroidType))
class Mp7JrsTemporalCentroidType;
class IMp7JrsTemporalCentroidType;
/** Smart pointer to instance of IMp7JrsTemporalCentroidType */
typedef Mp7JrsPtr< IMp7JrsTemporalCentroidType > Mp7JrsTemporalCentroidPtr;

#define TypeOfTemporalInterpolationType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType")))
#define CreateTemporalInterpolationType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType))
class Mp7JrsTemporalInterpolationType;
class IMp7JrsTemporalInterpolationType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType > Mp7JrsTemporalInterpolationPtr;

#define TypeOfTemporalInterpolationType_InterpolationFunctions_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_InterpolationFunctions_CollectionType")))
#define CreateTemporalInterpolationType_InterpolationFunctions_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_InterpolationFunctions_CollectionType))
class Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType;
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType > Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionPtr;

#define TypeOfTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType")))
#define CreateTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType))
class Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType;
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType > Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionPtr;

#define TypeOfTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType")))
#define CreateTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType))
class Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType;
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType > Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalPtr;

#define TypeOfTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType")))
#define CreateTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType))
class Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType;
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType;

#define TypeOfTemporalInterpolationType_InterpolationFunctions_LocalType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_InterpolationFunctions_LocalType")))
#define CreateTemporalInterpolationType_InterpolationFunctions_LocalType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_InterpolationFunctions_LocalType))
class Mp7JrsTemporalInterpolationType_InterpolationFunctions_LocalType;
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_LocalType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_InterpolationFunctions_LocalType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_InterpolationFunctions_LocalType > Mp7JrsTemporalInterpolationType_InterpolationFunctions_LocalPtr;

#define TypeOfTemporalInterpolationType_KeyTimePoint_LocalType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_KeyTimePoint_LocalType")))
#define CreateTemporalInterpolationType_KeyTimePoint_LocalType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_KeyTimePoint_LocalType))
class Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_LocalType > Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalPtr;

#define TypeOfTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType")))
#define CreateTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType))
class Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType > Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionPtr;

#define TypeOfTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType")))
#define CreateTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType))
class Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType > Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionPtr;

#define TypeOfTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType")))
#define CreateTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType))
class Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType;
class IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType > Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionPtr;

#define TypeOfTemporalInterpolationType_WholeInterval_LocalType (Mp7JrsFactory::GetTypeIndex(X("TemporalInterpolationType_WholeInterval_LocalType")))
#define CreateTemporalInterpolationType_WholeInterval_LocalType (Mp7JrsFactory::CreateObject(TypeOfTemporalInterpolationType_WholeInterval_LocalType))
class Mp7JrsTemporalInterpolationType_WholeInterval_LocalType;
class IMp7JrsTemporalInterpolationType_WholeInterval_LocalType;
/** Smart pointer to instance of IMp7JrsTemporalInterpolationType_WholeInterval_LocalType */
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_WholeInterval_LocalType > Mp7JrsTemporalInterpolationType_WholeInterval_LocalPtr;

#define TypeOfTemporalMaskType (Mp7JrsFactory::GetTypeIndex(X("TemporalMaskType")))
#define CreateTemporalMaskType (Mp7JrsFactory::CreateObject(TypeOfTemporalMaskType))
class Mp7JrsTemporalMaskType;
class IMp7JrsTemporalMaskType;
/** Smart pointer to instance of IMp7JrsTemporalMaskType */
typedef Mp7JrsPtr< IMp7JrsTemporalMaskType > Mp7JrsTemporalMaskPtr;

#define TypeOfTemporalMaskType_SubInterval_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TemporalMaskType_SubInterval_CollectionType")))
#define CreateTemporalMaskType_SubInterval_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTemporalMaskType_SubInterval_CollectionType))
class Mp7JrsTemporalMaskType_SubInterval_CollectionType;
class IMp7JrsTemporalMaskType_SubInterval_CollectionType;
/** Smart pointer to instance of IMp7JrsTemporalMaskType_SubInterval_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTemporalMaskType_SubInterval_CollectionType > Mp7JrsTemporalMaskType_SubInterval_CollectionPtr;

#define TypeOfTemporalSegmentDecompositionType (Mp7JrsFactory::GetTypeIndex(X("TemporalSegmentDecompositionType")))
#define CreateTemporalSegmentDecompositionType (Mp7JrsFactory::CreateObject(TypeOfTemporalSegmentDecompositionType))
class Mp7JrsTemporalSegmentDecompositionType;
class IMp7JrsTemporalSegmentDecompositionType;
/** Smart pointer to instance of IMp7JrsTemporalSegmentDecompositionType */
typedef Mp7JrsPtr< IMp7JrsTemporalSegmentDecompositionType > Mp7JrsTemporalSegmentDecompositionPtr;

#define TypeOfTemporalSegmentLocatorType (Mp7JrsFactory::GetTypeIndex(X("TemporalSegmentLocatorType")))
#define CreateTemporalSegmentLocatorType (Mp7JrsFactory::CreateObject(TypeOfTemporalSegmentLocatorType))
class Mp7JrsTemporalSegmentLocatorType;
class IMp7JrsTemporalSegmentLocatorType;
/** Smart pointer to instance of IMp7JrsTemporalSegmentLocatorType */
typedef Mp7JrsPtr< IMp7JrsTemporalSegmentLocatorType > Mp7JrsTemporalSegmentLocatorPtr;

#define TypeOfTemporalSegmentLocatorType_BytePosition_LocalType (Mp7JrsFactory::GetTypeIndex(X("TemporalSegmentLocatorType_BytePosition_LocalType")))
#define CreateTemporalSegmentLocatorType_BytePosition_LocalType (Mp7JrsFactory::CreateObject(TypeOfTemporalSegmentLocatorType_BytePosition_LocalType))
class Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType;
class IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType;
/** Smart pointer to instance of IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType */
typedef Mp7JrsPtr< IMp7JrsTemporalSegmentLocatorType_BytePosition_LocalType > Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalPtr;

#define TypeOfTermDefinitionBaseType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionBaseType")))
#define CreateTermDefinitionBaseType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionBaseType))
class Mp7JrsTermDefinitionBaseType;
class IMp7JrsTermDefinitionBaseType;
/** Smart pointer to instance of IMp7JrsTermDefinitionBaseType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType > Mp7JrsTermDefinitionBasePtr;

#define TypeOfTermDefinitionBaseType_Definition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionBaseType_Definition_CollectionType")))
#define CreateTermDefinitionBaseType_Definition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionBaseType_Definition_CollectionType))
class Mp7JrsTermDefinitionBaseType_Definition_CollectionType;
class IMp7JrsTermDefinitionBaseType_Definition_CollectionType;
/** Smart pointer to instance of IMp7JrsTermDefinitionBaseType_Definition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType_Definition_CollectionType > Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr;

#define TypeOfTermDefinitionBaseType_Name_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionBaseType_Name_CollectionType")))
#define CreateTermDefinitionBaseType_Name_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionBaseType_Name_CollectionType))
class Mp7JrsTermDefinitionBaseType_Name_CollectionType;
class IMp7JrsTermDefinitionBaseType_Name_CollectionType;
/** Smart pointer to instance of IMp7JrsTermDefinitionBaseType_Name_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType_Name_CollectionType > Mp7JrsTermDefinitionBaseType_Name_CollectionPtr;

#define TypeOfTermDefinitionBaseType_Name_LocalType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionBaseType_Name_LocalType")))
#define CreateTermDefinitionBaseType_Name_LocalType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionBaseType_Name_LocalType))
class Mp7JrsTermDefinitionBaseType_Name_LocalType;
class IMp7JrsTermDefinitionBaseType_Name_LocalType;
/** Smart pointer to instance of IMp7JrsTermDefinitionBaseType_Name_LocalType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionBaseType_Name_LocalType > Mp7JrsTermDefinitionBaseType_Name_LocalPtr;

#define TypeOfTermDefinitionType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionType")))
#define CreateTermDefinitionType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionType))
class Mp7JrsTermDefinitionType;
class IMp7JrsTermDefinitionType;
/** Smart pointer to instance of IMp7JrsTermDefinitionType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionType > Mp7JrsTermDefinitionPtr;

#define TypeOfTermDefinitionType_Term_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionType_Term_CollectionType")))
#define CreateTermDefinitionType_Term_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionType_Term_CollectionType))
class Mp7JrsTermDefinitionType_Term_CollectionType;
class IMp7JrsTermDefinitionType_Term_CollectionType;
/** Smart pointer to instance of IMp7JrsTermDefinitionType_Term_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionType_Term_CollectionType > Mp7JrsTermDefinitionType_Term_CollectionPtr;

#define TypeOfTermDefinitionType_Term_LocalType (Mp7JrsFactory::GetTypeIndex(X("TermDefinitionType_Term_LocalType")))
#define CreateTermDefinitionType_Term_LocalType (Mp7JrsFactory::CreateObject(TypeOfTermDefinitionType_Term_LocalType))
class Mp7JrsTermDefinitionType_Term_LocalType;
class IMp7JrsTermDefinitionType_Term_LocalType;
/** Smart pointer to instance of IMp7JrsTermDefinitionType_Term_LocalType */
typedef Mp7JrsPtr< IMp7JrsTermDefinitionType_Term_LocalType > Mp7JrsTermDefinitionType_Term_LocalPtr;

#define TypeOftermReferenceType (Mp7JrsFactory::GetTypeIndex(X("termReferenceType")))
#define CreatetermReferenceType (Mp7JrsFactory::CreateObject(TypeOftermReferenceType))
class Mp7JrstermReferenceType;
class IMp7JrstermReferenceType;
/** Smart pointer to instance of IMp7JrstermReferenceType */
typedef Mp7JrsPtr< IMp7JrstermReferenceType > Mp7JrstermReferencePtr;

#define TypeOftermReferenceType_LocalType (Mp7JrsFactory::GetTypeIndex(X("termReferenceType_LocalType")))
#define CreatetermReferenceType_LocalType (Mp7JrsFactory::CreateObject(TypeOftermReferenceType_LocalType))
class Mp7JrstermReferenceType_LocalType;
class IMp7JrstermReferenceType_LocalType;
/** Smart pointer to instance of IMp7JrstermReferenceType_LocalType */
typedef Mp7JrsPtr< IMp7JrstermReferenceType_LocalType > Mp7JrstermReferenceType_LocalPtr;

#define TypeOftermReferenceType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("termReferenceType_LocalType0")))
#define CreatetermReferenceType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOftermReferenceType_LocalType0))
class Mp7JrstermReferenceType_LocalType0;
class IMp7JrstermReferenceType_LocalType0;
/** Smart pointer to instance of IMp7JrstermReferenceType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrstermReferenceType_LocalType0 > Mp7JrstermReferenceType_Local0Ptr;

#define TypeOftermRelationQualifierType (Mp7JrsFactory::GetTypeIndex(X("termRelationQualifierType")))
#define CreatetermRelationQualifierType (Mp7JrsFactory::CreateObject(TypeOftermRelationQualifierType))
class Mp7JrstermRelationQualifierType;
class IMp7JrstermRelationQualifierType;
/** Smart pointer to instance of IMp7JrstermRelationQualifierType */
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType > Mp7JrstermRelationQualifierPtr;

#define TypeOftermRelationQualifierType_LocalType (Mp7JrsFactory::GetTypeIndex(X("termRelationQualifierType_LocalType")))
#define CreatetermRelationQualifierType_LocalType (Mp7JrsFactory::CreateObject(TypeOftermRelationQualifierType_LocalType))
class Mp7JrstermRelationQualifierType_LocalType;
class IMp7JrstermRelationQualifierType_LocalType;

#define TypeOftermRelationQualifierType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("termRelationQualifierType_LocalType0")))
#define CreatetermRelationQualifierType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOftermRelationQualifierType_LocalType0))
class Mp7JrstermRelationQualifierType_LocalType0;
class IMp7JrstermRelationQualifierType_LocalType0;
/** Smart pointer to instance of IMp7JrstermRelationQualifierType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType_LocalType0 > Mp7JrstermRelationQualifierType_Local0Ptr;

#define TypeOftermRelationQualifierType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("termRelationQualifierType_LocalType1")))
#define CreatetermRelationQualifierType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOftermRelationQualifierType_LocalType1))
class Mp7JrstermRelationQualifierType_LocalType1;
class IMp7JrstermRelationQualifierType_LocalType1;
/** Smart pointer to instance of IMp7JrstermRelationQualifierType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrstermRelationQualifierType_LocalType1 > Mp7JrstermRelationQualifierType_Local1Ptr;

#define TypeOfTermUseType (Mp7JrsFactory::GetTypeIndex(X("TermUseType")))
#define CreateTermUseType (Mp7JrsFactory::CreateObject(TypeOfTermUseType))
class Mp7JrsTermUseType;
class IMp7JrsTermUseType;
/** Smart pointer to instance of IMp7JrsTermUseType */
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

#define TypeOfTextAnnotationType (Mp7JrsFactory::GetTypeIndex(X("TextAnnotationType")))
#define CreateTextAnnotationType (Mp7JrsFactory::CreateObject(TypeOfTextAnnotationType))
class Mp7JrsTextAnnotationType;
class IMp7JrsTextAnnotationType;
/** Smart pointer to instance of IMp7JrsTextAnnotationType */
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType > Mp7JrsTextAnnotationPtr;

#define TypeOfTextAnnotationType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TextAnnotationType_CollectionType")))
#define CreateTextAnnotationType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTextAnnotationType_CollectionType))
class Mp7JrsTextAnnotationType_CollectionType;
class IMp7JrsTextAnnotationType_CollectionType;
/** Smart pointer to instance of IMp7JrsTextAnnotationType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType_CollectionType > Mp7JrsTextAnnotationType_CollectionPtr;

#define TypeOfTextAnnotationType_LocalType (Mp7JrsFactory::GetTypeIndex(X("TextAnnotationType_LocalType")))
#define CreateTextAnnotationType_LocalType (Mp7JrsFactory::CreateObject(TypeOfTextAnnotationType_LocalType))
class Mp7JrsTextAnnotationType_LocalType;
class IMp7JrsTextAnnotationType_LocalType;
/** Smart pointer to instance of IMp7JrsTextAnnotationType_LocalType */
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType_LocalType > Mp7JrsTextAnnotationType_LocalPtr;

#define TypeOfTextualBaseType (Mp7JrsFactory::GetTypeIndex(X("TextualBaseType")))
#define CreateTextualBaseType (Mp7JrsFactory::CreateObject(TypeOfTextualBaseType))
class Mp7JrsTextualBaseType;
class IMp7JrsTextualBaseType;
/** Smart pointer to instance of IMp7JrsTextualBaseType */
typedef Mp7JrsPtr< IMp7JrsTextualBaseType > Mp7JrsTextualBasePtr;

#define TypeOfTextualBaseType_phoneticTranscription_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TextualBaseType_phoneticTranscription_CollectionType")))
#define CreateTextualBaseType_phoneticTranscription_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTextualBaseType_phoneticTranscription_CollectionType))
class Mp7JrsTextualBaseType_phoneticTranscription_CollectionType;
class IMp7JrsTextualBaseType_phoneticTranscription_CollectionType;
/** Smart pointer to instance of IMp7JrsTextualBaseType_phoneticTranscription_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTextualBaseType_phoneticTranscription_CollectionType > Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr;

#define TypeOfTextualSummaryComponentType (Mp7JrsFactory::GetTypeIndex(X("TextualSummaryComponentType")))
#define CreateTextualSummaryComponentType (Mp7JrsFactory::CreateObject(TypeOfTextualSummaryComponentType))
class Mp7JrsTextualSummaryComponentType;
class IMp7JrsTextualSummaryComponentType;
/** Smart pointer to instance of IMp7JrsTextualSummaryComponentType */
typedef Mp7JrsPtr< IMp7JrsTextualSummaryComponentType > Mp7JrsTextualSummaryComponentPtr;

#define TypeOfTextualSummaryComponentType_FreeText_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TextualSummaryComponentType_FreeText_CollectionType")))
#define CreateTextualSummaryComponentType_FreeText_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTextualSummaryComponentType_FreeText_CollectionType))
class Mp7JrsTextualSummaryComponentType_FreeText_CollectionType;
class IMp7JrsTextualSummaryComponentType_FreeText_CollectionType;
/** Smart pointer to instance of IMp7JrsTextualSummaryComponentType_FreeText_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTextualSummaryComponentType_FreeText_CollectionType > Mp7JrsTextualSummaryComponentType_FreeText_CollectionPtr;

#define TypeOfTextualType (Mp7JrsFactory::GetTypeIndex(X("TextualType")))
#define CreateTextualType (Mp7JrsFactory::CreateObject(TypeOfTextualType))
class Mp7JrsTextualType;
class IMp7JrsTextualType;
/** Smart pointer to instance of IMp7JrsTextualType */
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;

#define TypeOfTextureBrowsingType (Mp7JrsFactory::GetTypeIndex(X("TextureBrowsingType")))
#define CreateTextureBrowsingType (Mp7JrsFactory::CreateObject(TypeOfTextureBrowsingType))
class Mp7JrsTextureBrowsingType;
class IMp7JrsTextureBrowsingType;
/** Smart pointer to instance of IMp7JrsTextureBrowsingType */
typedef Mp7JrsPtr< IMp7JrsTextureBrowsingType > Mp7JrsTextureBrowsingPtr;

#define TypeOfTextureBrowsingType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("TextureBrowsingType_CollectionType")))
#define CreateTextureBrowsingType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfTextureBrowsingType_CollectionType))
class Mp7JrsTextureBrowsingType_CollectionType;
class IMp7JrsTextureBrowsingType_CollectionType;
/** Smart pointer to instance of IMp7JrsTextureBrowsingType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsTextureBrowsingType_CollectionType > Mp7JrsTextureBrowsingType_CollectionPtr;

#define TypeOfTextureBrowsingType_Direction_LocalType (Mp7JrsFactory::GetTypeIndex(X("TextureBrowsingType_Direction_LocalType")))
#define CreateTextureBrowsingType_Direction_LocalType (Mp7JrsFactory::CreateObject(TypeOfTextureBrowsingType_Direction_LocalType))
class Mp7JrsTextureBrowsingType_Direction_LocalType;
class IMp7JrsTextureBrowsingType_Direction_LocalType;

#define TypeOfTextureBrowsingType_LocalType (Mp7JrsFactory::GetTypeIndex(X("TextureBrowsingType_LocalType")))
#define CreateTextureBrowsingType_LocalType (Mp7JrsFactory::CreateObject(TypeOfTextureBrowsingType_LocalType))
class Mp7JrsTextureBrowsingType_LocalType;
class IMp7JrsTextureBrowsingType_LocalType;
/** Smart pointer to instance of IMp7JrsTextureBrowsingType_LocalType */
typedef Mp7JrsPtr< IMp7JrsTextureBrowsingType_LocalType > Mp7JrsTextureBrowsingType_LocalPtr;

#define TypeOfTextureBrowsingType_Regularity_LocalType (Mp7JrsFactory::GetTypeIndex(X("TextureBrowsingType_Regularity_LocalType")))
#define CreateTextureBrowsingType_Regularity_LocalType (Mp7JrsFactory::CreateObject(TypeOfTextureBrowsingType_Regularity_LocalType))
class Mp7JrsTextureBrowsingType_Regularity_LocalType;
class IMp7JrsTextureBrowsingType_Regularity_LocalType;

#define TypeOfTextureBrowsingType_Scale_LocalType (Mp7JrsFactory::GetTypeIndex(X("TextureBrowsingType_Scale_LocalType")))
#define CreateTextureBrowsingType_Scale_LocalType (Mp7JrsFactory::CreateObject(TypeOfTextureBrowsingType_Scale_LocalType))
class Mp7JrsTextureBrowsingType_Scale_LocalType;
class IMp7JrsTextureBrowsingType_Scale_LocalType;

#define TypeOftextureListType (Mp7JrsFactory::GetTypeIndex(X("textureListType")))
#define CreatetextureListType (Mp7JrsFactory::CreateObject(TypeOftextureListType))
class Mp7JrstextureListType;
class IMp7JrstextureListType;
/** Smart pointer to instance of IMp7JrstextureListType */
typedef Mp7JrsPtr< IMp7JrstextureListType > Mp7JrstextureListPtr;

#define TypeOftextureListType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("textureListType_CollectionType")))
#define CreatetextureListType_CollectionType (Mp7JrsFactory::CreateObject(TypeOftextureListType_CollectionType))
class Mp7JrstextureListType_CollectionType;
class IMp7JrstextureListType_CollectionType;
/** Smart pointer to instance of IMp7JrstextureListType_CollectionType */
typedef Mp7JrsPtr< IMp7JrstextureListType_CollectionType > Mp7JrstextureListType_CollectionPtr;

#define TypeOftimeOffsetType (Mp7JrsFactory::GetTypeIndex(X("timeOffsetType")))
#define CreatetimeOffsetType (Mp7JrsFactory::CreateObject(TypeOftimeOffsetType))
class Mp7JrstimeOffsetType;
class IMp7JrstimeOffsetType;
/** Smart pointer to instance of IMp7JrstimeOffsetType */
typedef Mp7JrsPtr< IMp7JrstimeOffsetType > Mp7JrstimeOffsetPtr;

#define TypeOftimePointType (Mp7JrsFactory::GetTypeIndex(X("timePointType")))
#define CreatetimePointType (Mp7JrsFactory::CreateObject(TypeOftimePointType))
class Mp7JrstimePointType;
class IMp7JrstimePointType;
/** Smart pointer to instance of IMp7JrstimePointType */
typedef Mp7JrsPtr< IMp7JrstimePointType > Mp7JrstimePointPtr;

#define TypeOfTimeType (Mp7JrsFactory::GetTypeIndex(X("TimeType")))
#define CreateTimeType (Mp7JrsFactory::CreateObject(TypeOfTimeType))
class Mp7JrsTimeType;
class IMp7JrsTimeType;
/** Smart pointer to instance of IMp7JrsTimeType */
typedef Mp7JrsPtr< IMp7JrsTimeType > Mp7JrsTimePtr;

#define TypeOfTitleMediaType (Mp7JrsFactory::GetTypeIndex(X("TitleMediaType")))
#define CreateTitleMediaType (Mp7JrsFactory::CreateObject(TypeOfTitleMediaType))
class Mp7JrsTitleMediaType;
class IMp7JrsTitleMediaType;
/** Smart pointer to instance of IMp7JrsTitleMediaType */
typedef Mp7JrsPtr< IMp7JrsTitleMediaType > Mp7JrsTitleMediaPtr;

#define TypeOfTitleType (Mp7JrsFactory::GetTypeIndex(X("TitleType")))
#define CreateTitleType (Mp7JrsFactory::CreateObject(TypeOfTitleType))
class Mp7JrsTitleType;
class IMp7JrsTitleType;
/** Smart pointer to instance of IMp7JrsTitleType */
typedef Mp7JrsPtr< IMp7JrsTitleType > Mp7JrsTitlePtr;

#define TypeOfTitleType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("TitleType_type_LocalType")))
#define CreateTitleType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfTitleType_type_LocalType))
class Mp7JrsTitleType_type_LocalType;
class IMp7JrsTitleType_type_LocalType;

#define TypeOfTitleType_type_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("TitleType_type_LocalType0")))
#define CreateTitleType_type_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfTitleType_type_LocalType0))
class Mp7JrsTitleType_type_LocalType0;
class IMp7JrsTitleType_type_LocalType0;
/** Smart pointer to instance of IMp7JrsTitleType_type_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsTitleType_type_LocalType0 > Mp7JrsTitleType_type_Local0Ptr;

#define TypeOfTitleType_type_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("TitleType_type_LocalType1")))
#define CreateTitleType_type_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfTitleType_type_LocalType1))
class Mp7JrsTitleType_type_LocalType1;
class IMp7JrsTitleType_type_LocalType1;
/** Smart pointer to instance of IMp7JrsTitleType_type_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsTitleType_type_LocalType1 > Mp7JrsTitleType_type_Local1Ptr;

#define TypeOfTitleType_type_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("TitleType_type_LocalType2")))
#define CreateTitleType_type_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfTitleType_type_LocalType2))
class Mp7JrsTitleType_type_LocalType2;
class IMp7JrsTitleType_type_LocalType2;
/** Smart pointer to instance of IMp7JrsTitleType_type_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsTitleType_type_LocalType2 > Mp7JrsTitleType_type_Local2Ptr;

#define TypeOfUniqueIDType (Mp7JrsFactory::GetTypeIndex(X("UniqueIDType")))
#define CreateUniqueIDType (Mp7JrsFactory::CreateObject(TypeOfUniqueIDType))
class Mp7JrsUniqueIDType;
class IMp7JrsUniqueIDType;
/** Smart pointer to instance of IMp7JrsUniqueIDType */
typedef Mp7JrsPtr< IMp7JrsUniqueIDType > Mp7JrsUniqueIDPtr;

#define TypeOfUniqueIDType_encoding_LocalType (Mp7JrsFactory::GetTypeIndex(X("UniqueIDType_encoding_LocalType")))
#define CreateUniqueIDType_encoding_LocalType (Mp7JrsFactory::CreateObject(TypeOfUniqueIDType_encoding_LocalType))
class Mp7JrsUniqueIDType_encoding_LocalType;
class IMp7JrsUniqueIDType_encoding_LocalType;

#define TypeOfunsigned1 (Mp7JrsFactory::GetTypeIndex(X("unsigned1")))
#define Createunsigned1 (Mp7JrsFactory::CreateObject(TypeOfunsigned1))
class Mp7Jrsunsigned1;
class IMp7Jrsunsigned1;
/** Smart pointer to instance of IMp7Jrsunsigned1 */
typedef Mp7JrsPtr< IMp7Jrsunsigned1 > Mp7Jrsunsigned1Ptr;

#define TypeOfunsigned10 (Mp7JrsFactory::GetTypeIndex(X("unsigned10")))
#define Createunsigned10 (Mp7JrsFactory::CreateObject(TypeOfunsigned10))
class Mp7Jrsunsigned10;
class IMp7Jrsunsigned10;
/** Smart pointer to instance of IMp7Jrsunsigned10 */
typedef Mp7JrsPtr< IMp7Jrsunsigned10 > Mp7Jrsunsigned10Ptr;

#define TypeOfunsigned11 (Mp7JrsFactory::GetTypeIndex(X("unsigned11")))
#define Createunsigned11 (Mp7JrsFactory::CreateObject(TypeOfunsigned11))
class Mp7Jrsunsigned11;
class IMp7Jrsunsigned11;
/** Smart pointer to instance of IMp7Jrsunsigned11 */
typedef Mp7JrsPtr< IMp7Jrsunsigned11 > Mp7Jrsunsigned11Ptr;

#define TypeOfunsigned12 (Mp7JrsFactory::GetTypeIndex(X("unsigned12")))
#define Createunsigned12 (Mp7JrsFactory::CreateObject(TypeOfunsigned12))
class Mp7Jrsunsigned12;
class IMp7Jrsunsigned12;
/** Smart pointer to instance of IMp7Jrsunsigned12 */
typedef Mp7JrsPtr< IMp7Jrsunsigned12 > Mp7Jrsunsigned12Ptr;

#define TypeOfunsigned13 (Mp7JrsFactory::GetTypeIndex(X("unsigned13")))
#define Createunsigned13 (Mp7JrsFactory::CreateObject(TypeOfunsigned13))
class Mp7Jrsunsigned13;
class IMp7Jrsunsigned13;
/** Smart pointer to instance of IMp7Jrsunsigned13 */
typedef Mp7JrsPtr< IMp7Jrsunsigned13 > Mp7Jrsunsigned13Ptr;

#define TypeOfunsigned14 (Mp7JrsFactory::GetTypeIndex(X("unsigned14")))
#define Createunsigned14 (Mp7JrsFactory::CreateObject(TypeOfunsigned14))
class Mp7Jrsunsigned14;
class IMp7Jrsunsigned14;
/** Smart pointer to instance of IMp7Jrsunsigned14 */
typedef Mp7JrsPtr< IMp7Jrsunsigned14 > Mp7Jrsunsigned14Ptr;

#define TypeOfunsigned15 (Mp7JrsFactory::GetTypeIndex(X("unsigned15")))
#define Createunsigned15 (Mp7JrsFactory::CreateObject(TypeOfunsigned15))
class Mp7Jrsunsigned15;
class IMp7Jrsunsigned15;
/** Smart pointer to instance of IMp7Jrsunsigned15 */
typedef Mp7JrsPtr< IMp7Jrsunsigned15 > Mp7Jrsunsigned15Ptr;

#define TypeOfunsigned16 (Mp7JrsFactory::GetTypeIndex(X("unsigned16")))
#define Createunsigned16 (Mp7JrsFactory::CreateObject(TypeOfunsigned16))
class Mp7Jrsunsigned16;
class IMp7Jrsunsigned16;
/** Smart pointer to instance of IMp7Jrsunsigned16 */
typedef Mp7JrsPtr< IMp7Jrsunsigned16 > Mp7Jrsunsigned16Ptr;

#define TypeOfunsigned17 (Mp7JrsFactory::GetTypeIndex(X("unsigned17")))
#define Createunsigned17 (Mp7JrsFactory::CreateObject(TypeOfunsigned17))
class Mp7Jrsunsigned17;
class IMp7Jrsunsigned17;
/** Smart pointer to instance of IMp7Jrsunsigned17 */
typedef Mp7JrsPtr< IMp7Jrsunsigned17 > Mp7Jrsunsigned17Ptr;

#define TypeOfunsigned18 (Mp7JrsFactory::GetTypeIndex(X("unsigned18")))
#define Createunsigned18 (Mp7JrsFactory::CreateObject(TypeOfunsigned18))
class Mp7Jrsunsigned18;
class IMp7Jrsunsigned18;
/** Smart pointer to instance of IMp7Jrsunsigned18 */
typedef Mp7JrsPtr< IMp7Jrsunsigned18 > Mp7Jrsunsigned18Ptr;

#define TypeOfunsigned19 (Mp7JrsFactory::GetTypeIndex(X("unsigned19")))
#define Createunsigned19 (Mp7JrsFactory::CreateObject(TypeOfunsigned19))
class Mp7Jrsunsigned19;
class IMp7Jrsunsigned19;
/** Smart pointer to instance of IMp7Jrsunsigned19 */
typedef Mp7JrsPtr< IMp7Jrsunsigned19 > Mp7Jrsunsigned19Ptr;

#define TypeOfunsigned2 (Mp7JrsFactory::GetTypeIndex(X("unsigned2")))
#define Createunsigned2 (Mp7JrsFactory::CreateObject(TypeOfunsigned2))
class Mp7Jrsunsigned2;
class IMp7Jrsunsigned2;
/** Smart pointer to instance of IMp7Jrsunsigned2 */
typedef Mp7JrsPtr< IMp7Jrsunsigned2 > Mp7Jrsunsigned2Ptr;

#define TypeOfunsigned20 (Mp7JrsFactory::GetTypeIndex(X("unsigned20")))
#define Createunsigned20 (Mp7JrsFactory::CreateObject(TypeOfunsigned20))
class Mp7Jrsunsigned20;
class IMp7Jrsunsigned20;
/** Smart pointer to instance of IMp7Jrsunsigned20 */
typedef Mp7JrsPtr< IMp7Jrsunsigned20 > Mp7Jrsunsigned20Ptr;

#define TypeOfunsigned21 (Mp7JrsFactory::GetTypeIndex(X("unsigned21")))
#define Createunsigned21 (Mp7JrsFactory::CreateObject(TypeOfunsigned21))
class Mp7Jrsunsigned21;
class IMp7Jrsunsigned21;
/** Smart pointer to instance of IMp7Jrsunsigned21 */
typedef Mp7JrsPtr< IMp7Jrsunsigned21 > Mp7Jrsunsigned21Ptr;

#define TypeOfunsigned22 (Mp7JrsFactory::GetTypeIndex(X("unsigned22")))
#define Createunsigned22 (Mp7JrsFactory::CreateObject(TypeOfunsigned22))
class Mp7Jrsunsigned22;
class IMp7Jrsunsigned22;
/** Smart pointer to instance of IMp7Jrsunsigned22 */
typedef Mp7JrsPtr< IMp7Jrsunsigned22 > Mp7Jrsunsigned22Ptr;

#define TypeOfunsigned23 (Mp7JrsFactory::GetTypeIndex(X("unsigned23")))
#define Createunsigned23 (Mp7JrsFactory::CreateObject(TypeOfunsigned23))
class Mp7Jrsunsigned23;
class IMp7Jrsunsigned23;
/** Smart pointer to instance of IMp7Jrsunsigned23 */
typedef Mp7JrsPtr< IMp7Jrsunsigned23 > Mp7Jrsunsigned23Ptr;

#define TypeOfunsigned24 (Mp7JrsFactory::GetTypeIndex(X("unsigned24")))
#define Createunsigned24 (Mp7JrsFactory::CreateObject(TypeOfunsigned24))
class Mp7Jrsunsigned24;
class IMp7Jrsunsigned24;
/** Smart pointer to instance of IMp7Jrsunsigned24 */
typedef Mp7JrsPtr< IMp7Jrsunsigned24 > Mp7Jrsunsigned24Ptr;

#define TypeOfunsigned25 (Mp7JrsFactory::GetTypeIndex(X("unsigned25")))
#define Createunsigned25 (Mp7JrsFactory::CreateObject(TypeOfunsigned25))
class Mp7Jrsunsigned25;
class IMp7Jrsunsigned25;
/** Smart pointer to instance of IMp7Jrsunsigned25 */
typedef Mp7JrsPtr< IMp7Jrsunsigned25 > Mp7Jrsunsigned25Ptr;

#define TypeOfunsigned26 (Mp7JrsFactory::GetTypeIndex(X("unsigned26")))
#define Createunsigned26 (Mp7JrsFactory::CreateObject(TypeOfunsigned26))
class Mp7Jrsunsigned26;
class IMp7Jrsunsigned26;
/** Smart pointer to instance of IMp7Jrsunsigned26 */
typedef Mp7JrsPtr< IMp7Jrsunsigned26 > Mp7Jrsunsigned26Ptr;

#define TypeOfunsigned27 (Mp7JrsFactory::GetTypeIndex(X("unsigned27")))
#define Createunsigned27 (Mp7JrsFactory::CreateObject(TypeOfunsigned27))
class Mp7Jrsunsigned27;
class IMp7Jrsunsigned27;
/** Smart pointer to instance of IMp7Jrsunsigned27 */
typedef Mp7JrsPtr< IMp7Jrsunsigned27 > Mp7Jrsunsigned27Ptr;

#define TypeOfunsigned28 (Mp7JrsFactory::GetTypeIndex(X("unsigned28")))
#define Createunsigned28 (Mp7JrsFactory::CreateObject(TypeOfunsigned28))
class Mp7Jrsunsigned28;
class IMp7Jrsunsigned28;
/** Smart pointer to instance of IMp7Jrsunsigned28 */
typedef Mp7JrsPtr< IMp7Jrsunsigned28 > Mp7Jrsunsigned28Ptr;

#define TypeOfunsigned29 (Mp7JrsFactory::GetTypeIndex(X("unsigned29")))
#define Createunsigned29 (Mp7JrsFactory::CreateObject(TypeOfunsigned29))
class Mp7Jrsunsigned29;
class IMp7Jrsunsigned29;
/** Smart pointer to instance of IMp7Jrsunsigned29 */
typedef Mp7JrsPtr< IMp7Jrsunsigned29 > Mp7Jrsunsigned29Ptr;

#define TypeOfunsigned3 (Mp7JrsFactory::GetTypeIndex(X("unsigned3")))
#define Createunsigned3 (Mp7JrsFactory::CreateObject(TypeOfunsigned3))
class Mp7Jrsunsigned3;
class IMp7Jrsunsigned3;
/** Smart pointer to instance of IMp7Jrsunsigned3 */
typedef Mp7JrsPtr< IMp7Jrsunsigned3 > Mp7Jrsunsigned3Ptr;

#define TypeOfunsigned30 (Mp7JrsFactory::GetTypeIndex(X("unsigned30")))
#define Createunsigned30 (Mp7JrsFactory::CreateObject(TypeOfunsigned30))
class Mp7Jrsunsigned30;
class IMp7Jrsunsigned30;
/** Smart pointer to instance of IMp7Jrsunsigned30 */
typedef Mp7JrsPtr< IMp7Jrsunsigned30 > Mp7Jrsunsigned30Ptr;

#define TypeOfunsigned31 (Mp7JrsFactory::GetTypeIndex(X("unsigned31")))
#define Createunsigned31 (Mp7JrsFactory::CreateObject(TypeOfunsigned31))
class Mp7Jrsunsigned31;
class IMp7Jrsunsigned31;
/** Smart pointer to instance of IMp7Jrsunsigned31 */
typedef Mp7JrsPtr< IMp7Jrsunsigned31 > Mp7Jrsunsigned31Ptr;

#define TypeOfunsigned32 (Mp7JrsFactory::GetTypeIndex(X("unsigned32")))
#define Createunsigned32 (Mp7JrsFactory::CreateObject(TypeOfunsigned32))
class Mp7Jrsunsigned32;
class IMp7Jrsunsigned32;
/** Smart pointer to instance of IMp7Jrsunsigned32 */
typedef Mp7JrsPtr< IMp7Jrsunsigned32 > Mp7Jrsunsigned32Ptr;

#define TypeOfunsigned4 (Mp7JrsFactory::GetTypeIndex(X("unsigned4")))
#define Createunsigned4 (Mp7JrsFactory::CreateObject(TypeOfunsigned4))
class Mp7Jrsunsigned4;
class IMp7Jrsunsigned4;
/** Smart pointer to instance of IMp7Jrsunsigned4 */
typedef Mp7JrsPtr< IMp7Jrsunsigned4 > Mp7Jrsunsigned4Ptr;

#define TypeOfunsigned5 (Mp7JrsFactory::GetTypeIndex(X("unsigned5")))
#define Createunsigned5 (Mp7JrsFactory::CreateObject(TypeOfunsigned5))
class Mp7Jrsunsigned5;
class IMp7Jrsunsigned5;
/** Smart pointer to instance of IMp7Jrsunsigned5 */
typedef Mp7JrsPtr< IMp7Jrsunsigned5 > Mp7Jrsunsigned5Ptr;

#define TypeOfunsigned6 (Mp7JrsFactory::GetTypeIndex(X("unsigned6")))
#define Createunsigned6 (Mp7JrsFactory::CreateObject(TypeOfunsigned6))
class Mp7Jrsunsigned6;
class IMp7Jrsunsigned6;
/** Smart pointer to instance of IMp7Jrsunsigned6 */
typedef Mp7JrsPtr< IMp7Jrsunsigned6 > Mp7Jrsunsigned6Ptr;

#define TypeOfunsigned7 (Mp7JrsFactory::GetTypeIndex(X("unsigned7")))
#define Createunsigned7 (Mp7JrsFactory::CreateObject(TypeOfunsigned7))
class Mp7Jrsunsigned7;
class IMp7Jrsunsigned7;
/** Smart pointer to instance of IMp7Jrsunsigned7 */
typedef Mp7JrsPtr< IMp7Jrsunsigned7 > Mp7Jrsunsigned7Ptr;

#define TypeOfunsigned8 (Mp7JrsFactory::GetTypeIndex(X("unsigned8")))
#define Createunsigned8 (Mp7JrsFactory::CreateObject(TypeOfunsigned8))
class Mp7Jrsunsigned8;
class IMp7Jrsunsigned8;
/** Smart pointer to instance of IMp7Jrsunsigned8 */
typedef Mp7JrsPtr< IMp7Jrsunsigned8 > Mp7Jrsunsigned8Ptr;

#define TypeOfunsigned9 (Mp7JrsFactory::GetTypeIndex(X("unsigned9")))
#define Createunsigned9 (Mp7JrsFactory::CreateObject(TypeOfunsigned9))
class Mp7Jrsunsigned9;
class IMp7Jrsunsigned9;
/** Smart pointer to instance of IMp7Jrsunsigned9 */
typedef Mp7JrsPtr< IMp7Jrsunsigned9 > Mp7Jrsunsigned9Ptr;

#define TypeOfUsageDescriptionType (Mp7JrsFactory::GetTypeIndex(X("UsageDescriptionType")))
#define CreateUsageDescriptionType (Mp7JrsFactory::CreateObject(TypeOfUsageDescriptionType))
class Mp7JrsUsageDescriptionType;
class IMp7JrsUsageDescriptionType;
/** Smart pointer to instance of IMp7JrsUsageDescriptionType */
typedef Mp7JrsPtr< IMp7JrsUsageDescriptionType > Mp7JrsUsageDescriptionPtr;

#define TypeOfUsageDescriptionType_UsageInformation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UsageDescriptionType_UsageInformation_CollectionType")))
#define CreateUsageDescriptionType_UsageInformation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUsageDescriptionType_UsageInformation_CollectionType))
class Mp7JrsUsageDescriptionType_UsageInformation_CollectionType;
class IMp7JrsUsageDescriptionType_UsageInformation_CollectionType;
/** Smart pointer to instance of IMp7JrsUsageDescriptionType_UsageInformation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUsageDescriptionType_UsageInformation_CollectionType > Mp7JrsUsageDescriptionType_UsageInformation_CollectionPtr;

#define TypeOfUsageHistoryType (Mp7JrsFactory::GetTypeIndex(X("UsageHistoryType")))
#define CreateUsageHistoryType (Mp7JrsFactory::CreateObject(TypeOfUsageHistoryType))
class Mp7JrsUsageHistoryType;
class IMp7JrsUsageHistoryType;
/** Smart pointer to instance of IMp7JrsUsageHistoryType */
typedef Mp7JrsPtr< IMp7JrsUsageHistoryType > Mp7JrsUsageHistoryPtr;

#define TypeOfUsageHistoryType_UserActionHistory_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UsageHistoryType_UserActionHistory_CollectionType")))
#define CreateUsageHistoryType_UserActionHistory_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUsageHistoryType_UserActionHistory_CollectionType))
class Mp7JrsUsageHistoryType_UserActionHistory_CollectionType;
class IMp7JrsUsageHistoryType_UserActionHistory_CollectionType;
/** Smart pointer to instance of IMp7JrsUsageHistoryType_UserActionHistory_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUsageHistoryType_UserActionHistory_CollectionType > Mp7JrsUsageHistoryType_UserActionHistory_CollectionPtr;

#define TypeOfUsageInformationType (Mp7JrsFactory::GetTypeIndex(X("UsageInformationType")))
#define CreateUsageInformationType (Mp7JrsFactory::CreateObject(TypeOfUsageInformationType))
class Mp7JrsUsageInformationType;
class IMp7JrsUsageInformationType;
/** Smart pointer to instance of IMp7JrsUsageInformationType */
typedef Mp7JrsPtr< IMp7JrsUsageInformationType > Mp7JrsUsageInformationPtr;

#define TypeOfUsageInformationType_Availability_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UsageInformationType_Availability_CollectionType")))
#define CreateUsageInformationType_Availability_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUsageInformationType_Availability_CollectionType))
class Mp7JrsUsageInformationType_Availability_CollectionType;
class IMp7JrsUsageInformationType_Availability_CollectionType;
/** Smart pointer to instance of IMp7JrsUsageInformationType_Availability_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUsageInformationType_Availability_CollectionType > Mp7JrsUsageInformationType_Availability_CollectionPtr;

#define TypeOfUsageInformationType_UsageRecord_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UsageInformationType_UsageRecord_CollectionType")))
#define CreateUsageInformationType_UsageRecord_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUsageInformationType_UsageRecord_CollectionType))
class Mp7JrsUsageInformationType_UsageRecord_CollectionType;
class IMp7JrsUsageInformationType_UsageRecord_CollectionType;
/** Smart pointer to instance of IMp7JrsUsageInformationType_UsageRecord_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUsageInformationType_UsageRecord_CollectionType > Mp7JrsUsageInformationType_UsageRecord_CollectionPtr;

#define TypeOfUsageRecordType (Mp7JrsFactory::GetTypeIndex(X("UsageRecordType")))
#define CreateUsageRecordType (Mp7JrsFactory::CreateObject(TypeOfUsageRecordType))
class Mp7JrsUsageRecordType;
class IMp7JrsUsageRecordType;
/** Smart pointer to instance of IMp7JrsUsageRecordType */
typedef Mp7JrsPtr< IMp7JrsUsageRecordType > Mp7JrsUsageRecordPtr;

#define TypeOfUserActionHistoryType (Mp7JrsFactory::GetTypeIndex(X("UserActionHistoryType")))
#define CreateUserActionHistoryType (Mp7JrsFactory::CreateObject(TypeOfUserActionHistoryType))
class Mp7JrsUserActionHistoryType;
class IMp7JrsUserActionHistoryType;
/** Smart pointer to instance of IMp7JrsUserActionHistoryType */
typedef Mp7JrsPtr< IMp7JrsUserActionHistoryType > Mp7JrsUserActionHistoryPtr;

#define TypeOfUserActionHistoryType_ObservationPeriod_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserActionHistoryType_ObservationPeriod_CollectionType")))
#define CreateUserActionHistoryType_ObservationPeriod_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserActionHistoryType_ObservationPeriod_CollectionType))
class Mp7JrsUserActionHistoryType_ObservationPeriod_CollectionType;
class IMp7JrsUserActionHistoryType_ObservationPeriod_CollectionType;
/** Smart pointer to instance of IMp7JrsUserActionHistoryType_ObservationPeriod_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserActionHistoryType_ObservationPeriod_CollectionType > Mp7JrsUserActionHistoryType_ObservationPeriod_CollectionPtr;

#define TypeOfUserActionHistoryType_UserActionList_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserActionHistoryType_UserActionList_CollectionType")))
#define CreateUserActionHistoryType_UserActionList_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserActionHistoryType_UserActionList_CollectionType))
class Mp7JrsUserActionHistoryType_UserActionList_CollectionType;
class IMp7JrsUserActionHistoryType_UserActionList_CollectionType;
/** Smart pointer to instance of IMp7JrsUserActionHistoryType_UserActionList_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserActionHistoryType_UserActionList_CollectionType > Mp7JrsUserActionHistoryType_UserActionList_CollectionPtr;

#define TypeOfUserActionListType (Mp7JrsFactory::GetTypeIndex(X("UserActionListType")))
#define CreateUserActionListType (Mp7JrsFactory::CreateObject(TypeOfUserActionListType))
class Mp7JrsUserActionListType;
class IMp7JrsUserActionListType;
/** Smart pointer to instance of IMp7JrsUserActionListType */
typedef Mp7JrsPtr< IMp7JrsUserActionListType > Mp7JrsUserActionListPtr;

#define TypeOfUserActionListType_UserAction_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserActionListType_UserAction_CollectionType")))
#define CreateUserActionListType_UserAction_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserActionListType_UserAction_CollectionType))
class Mp7JrsUserActionListType_UserAction_CollectionType;
class IMp7JrsUserActionListType_UserAction_CollectionType;
/** Smart pointer to instance of IMp7JrsUserActionListType_UserAction_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserActionListType_UserAction_CollectionType > Mp7JrsUserActionListType_UserAction_CollectionPtr;

#define TypeOfUserActionType (Mp7JrsFactory::GetTypeIndex(X("UserActionType")))
#define CreateUserActionType (Mp7JrsFactory::CreateObject(TypeOfUserActionType))
class Mp7JrsUserActionType;
class IMp7JrsUserActionType;
/** Smart pointer to instance of IMp7JrsUserActionType */
typedef Mp7JrsPtr< IMp7JrsUserActionType > Mp7JrsUserActionPtr;

#define TypeOfUserActionType_ActionDataItem_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserActionType_ActionDataItem_CollectionType")))
#define CreateUserActionType_ActionDataItem_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserActionType_ActionDataItem_CollectionType))
class Mp7JrsUserActionType_ActionDataItem_CollectionType;
class IMp7JrsUserActionType_ActionDataItem_CollectionType;
/** Smart pointer to instance of IMp7JrsUserActionType_ActionDataItem_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserActionType_ActionDataItem_CollectionType > Mp7JrsUserActionType_ActionDataItem_CollectionPtr;

#define TypeOfUserActionType_ActionTime_LocalType (Mp7JrsFactory::GetTypeIndex(X("UserActionType_ActionTime_LocalType")))
#define CreateUserActionType_ActionTime_LocalType (Mp7JrsFactory::CreateObject(TypeOfUserActionType_ActionTime_LocalType))
class Mp7JrsUserActionType_ActionTime_LocalType;
class IMp7JrsUserActionType_ActionTime_LocalType;
/** Smart pointer to instance of IMp7JrsUserActionType_ActionTime_LocalType */
typedef Mp7JrsPtr< IMp7JrsUserActionType_ActionTime_LocalType > Mp7JrsUserActionType_ActionTime_LocalPtr;

#define TypeOfuserChoiceType (Mp7JrsFactory::GetTypeIndex(X("userChoiceType")))
#define CreateuserChoiceType (Mp7JrsFactory::CreateObject(TypeOfuserChoiceType))
class Mp7JrsuserChoiceType;
class IMp7JrsuserChoiceType;

#define TypeOfUserDescriptionType (Mp7JrsFactory::GetTypeIndex(X("UserDescriptionType")))
#define CreateUserDescriptionType (Mp7JrsFactory::CreateObject(TypeOfUserDescriptionType))
class Mp7JrsUserDescriptionType;
class IMp7JrsUserDescriptionType;
/** Smart pointer to instance of IMp7JrsUserDescriptionType */
typedef Mp7JrsPtr< IMp7JrsUserDescriptionType > Mp7JrsUserDescriptionPtr;

#define TypeOfUserDescriptionType_UsageHistory_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserDescriptionType_UsageHistory_CollectionType")))
#define CreateUserDescriptionType_UsageHistory_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserDescriptionType_UsageHistory_CollectionType))
class Mp7JrsUserDescriptionType_UsageHistory_CollectionType;
class IMp7JrsUserDescriptionType_UsageHistory_CollectionType;
/** Smart pointer to instance of IMp7JrsUserDescriptionType_UsageHistory_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserDescriptionType_UsageHistory_CollectionType > Mp7JrsUserDescriptionType_UsageHistory_CollectionPtr;

#define TypeOfUserDescriptionType_UserPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserDescriptionType_UserPreferences_CollectionType")))
#define CreateUserDescriptionType_UserPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserDescriptionType_UserPreferences_CollectionType))
class Mp7JrsUserDescriptionType_UserPreferences_CollectionType;
class IMp7JrsUserDescriptionType_UserPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsUserDescriptionType_UserPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserDescriptionType_UserPreferences_CollectionType > Mp7JrsUserDescriptionType_UserPreferences_CollectionPtr;

#define TypeOfUserIdentifierType (Mp7JrsFactory::GetTypeIndex(X("UserIdentifierType")))
#define CreateUserIdentifierType (Mp7JrsFactory::CreateObject(TypeOfUserIdentifierType))
class Mp7JrsUserIdentifierType;
class IMp7JrsUserIdentifierType;
/** Smart pointer to instance of IMp7JrsUserIdentifierType */
typedef Mp7JrsPtr< IMp7JrsUserIdentifierType > Mp7JrsUserIdentifierPtr;

#define TypeOfUserPreferencesType (Mp7JrsFactory::GetTypeIndex(X("UserPreferencesType")))
#define CreateUserPreferencesType (Mp7JrsFactory::CreateObject(TypeOfUserPreferencesType))
class Mp7JrsUserPreferencesType;
class IMp7JrsUserPreferencesType;
/** Smart pointer to instance of IMp7JrsUserPreferencesType */
typedef Mp7JrsPtr< IMp7JrsUserPreferencesType > Mp7JrsUserPreferencesPtr;

#define TypeOfUserPreferencesType_BrowsingPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserPreferencesType_BrowsingPreferences_CollectionType")))
#define CreateUserPreferencesType_BrowsingPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserPreferencesType_BrowsingPreferences_CollectionType))
class Mp7JrsUserPreferencesType_BrowsingPreferences_CollectionType;
class IMp7JrsUserPreferencesType_BrowsingPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsUserPreferencesType_BrowsingPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserPreferencesType_BrowsingPreferences_CollectionType > Mp7JrsUserPreferencesType_BrowsingPreferences_CollectionPtr;

#define TypeOfUserPreferencesType_FilteringAndSearchPreferences_CollectionType (Mp7JrsFactory::GetTypeIndex(X("UserPreferencesType_FilteringAndSearchPreferences_CollectionType")))
#define CreateUserPreferencesType_FilteringAndSearchPreferences_CollectionType (Mp7JrsFactory::CreateObject(TypeOfUserPreferencesType_FilteringAndSearchPreferences_CollectionType))
class Mp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionType;
class IMp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionType;
/** Smart pointer to instance of IMp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionType */
typedef Mp7JrsPtr< IMp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionType > Mp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionPtr;

#define TypeOfVariationDescriptionType (Mp7JrsFactory::GetTypeIndex(X("VariationDescriptionType")))
#define CreateVariationDescriptionType (Mp7JrsFactory::CreateObject(TypeOfVariationDescriptionType))
class Mp7JrsVariationDescriptionType;
class IMp7JrsVariationDescriptionType;
/** Smart pointer to instance of IMp7JrsVariationDescriptionType */
typedef Mp7JrsPtr< IMp7JrsVariationDescriptionType > Mp7JrsVariationDescriptionPtr;

#define TypeOfVariationDescriptionType_Variation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VariationDescriptionType_Variation_CollectionType")))
#define CreateVariationDescriptionType_Variation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVariationDescriptionType_Variation_CollectionType))
class Mp7JrsVariationDescriptionType_Variation_CollectionType;
class IMp7JrsVariationDescriptionType_Variation_CollectionType;
/** Smart pointer to instance of IMp7JrsVariationDescriptionType_Variation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVariationDescriptionType_Variation_CollectionType > Mp7JrsVariationDescriptionType_Variation_CollectionPtr;

#define TypeOfVariationDescriptionType_VariationSet_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VariationDescriptionType_VariationSet_CollectionType")))
#define CreateVariationDescriptionType_VariationSet_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVariationDescriptionType_VariationSet_CollectionType))
class Mp7JrsVariationDescriptionType_VariationSet_CollectionType;
class IMp7JrsVariationDescriptionType_VariationSet_CollectionType;
/** Smart pointer to instance of IMp7JrsVariationDescriptionType_VariationSet_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVariationDescriptionType_VariationSet_CollectionType > Mp7JrsVariationDescriptionType_VariationSet_CollectionPtr;

#define TypeOfVariationSetType (Mp7JrsFactory::GetTypeIndex(X("VariationSetType")))
#define CreateVariationSetType (Mp7JrsFactory::CreateObject(TypeOfVariationSetType))
class Mp7JrsVariationSetType;
class IMp7JrsVariationSetType;
/** Smart pointer to instance of IMp7JrsVariationSetType */
typedef Mp7JrsPtr< IMp7JrsVariationSetType > Mp7JrsVariationSetPtr;

#define TypeOfVariationSetType_Variation_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VariationSetType_Variation_CollectionType")))
#define CreateVariationSetType_Variation_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVariationSetType_Variation_CollectionType))
class Mp7JrsVariationSetType_Variation_CollectionType;
class IMp7JrsVariationSetType_Variation_CollectionType;
/** Smart pointer to instance of IMp7JrsVariationSetType_Variation_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVariationSetType_Variation_CollectionType > Mp7JrsVariationSetType_Variation_CollectionPtr;

#define TypeOfVariationType (Mp7JrsFactory::GetTypeIndex(X("VariationType")))
#define CreateVariationType (Mp7JrsFactory::CreateObject(TypeOfVariationType))
class Mp7JrsVariationType;
class IMp7JrsVariationType;
/** Smart pointer to instance of IMp7JrsVariationType */
typedef Mp7JrsPtr< IMp7JrsVariationType > Mp7JrsVariationPtr;

#define TypeOfVariationType_VariationRelationship_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VariationType_VariationRelationship_CollectionType")))
#define CreateVariationType_VariationRelationship_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVariationType_VariationRelationship_CollectionType))
class Mp7JrsVariationType_VariationRelationship_CollectionType;
class IMp7JrsVariationType_VariationRelationship_CollectionType;
/** Smart pointer to instance of IMp7JrsVariationType_VariationRelationship_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_CollectionType > Mp7JrsVariationType_VariationRelationship_CollectionPtr;

#define TypeOfVariationType_VariationRelationship_LocalType (Mp7JrsFactory::GetTypeIndex(X("VariationType_VariationRelationship_LocalType")))
#define CreateVariationType_VariationRelationship_LocalType (Mp7JrsFactory::CreateObject(TypeOfVariationType_VariationRelationship_LocalType))
class Mp7JrsVariationType_VariationRelationship_LocalType;
class IMp7JrsVariationType_VariationRelationship_LocalType;

#define TypeOfVariationType_VariationRelationship_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("VariationType_VariationRelationship_LocalType0")))
#define CreateVariationType_VariationRelationship_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfVariationType_VariationRelationship_LocalType0))
class Mp7JrsVariationType_VariationRelationship_LocalType0;
class IMp7JrsVariationType_VariationRelationship_LocalType0;
/** Smart pointer to instance of IMp7JrsVariationType_VariationRelationship_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_LocalType0 > Mp7JrsVariationType_VariationRelationship_Local0Ptr;

#define TypeOfVariationType_VariationRelationship_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("VariationType_VariationRelationship_LocalType1")))
#define CreateVariationType_VariationRelationship_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfVariationType_VariationRelationship_LocalType1))
class Mp7JrsVariationType_VariationRelationship_LocalType1;
class IMp7JrsVariationType_VariationRelationship_LocalType1;
/** Smart pointer to instance of IMp7JrsVariationType_VariationRelationship_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_LocalType1 > Mp7JrsVariationType_VariationRelationship_Local1Ptr;

#define TypeOfVariationType_VariationRelationship_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("VariationType_VariationRelationship_LocalType2")))
#define CreateVariationType_VariationRelationship_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfVariationType_VariationRelationship_LocalType2))
class Mp7JrsVariationType_VariationRelationship_LocalType2;
class IMp7JrsVariationType_VariationRelationship_LocalType2;
/** Smart pointer to instance of IMp7JrsVariationType_VariationRelationship_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsVariationType_VariationRelationship_LocalType2 > Mp7JrsVariationType_VariationRelationship_Local2Ptr;

#define TypeOfVideoSegmentMediaSourceDecompositionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentMediaSourceDecompositionType")))
#define CreateVideoSegmentMediaSourceDecompositionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentMediaSourceDecompositionType))
class Mp7JrsVideoSegmentMediaSourceDecompositionType;
class IMp7JrsVideoSegmentMediaSourceDecompositionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentMediaSourceDecompositionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentMediaSourceDecompositionType > Mp7JrsVideoSegmentMediaSourceDecompositionPtr;

#define TypeOfVideoSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentMediaSourceDecompositionType_CollectionType")))
#define CreateVideoSegmentMediaSourceDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentMediaSourceDecompositionType_CollectionType))
class Mp7JrsVideoSegmentMediaSourceDecompositionType_CollectionType;
class IMp7JrsVideoSegmentMediaSourceDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentMediaSourceDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentMediaSourceDecompositionType_CollectionType > Mp7JrsVideoSegmentMediaSourceDecompositionType_CollectionPtr;

#define TypeOfVideoSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentMediaSourceDecompositionType_LocalType")))
#define CreateVideoSegmentMediaSourceDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentMediaSourceDecompositionType_LocalType))
class Mp7JrsVideoSegmentMediaSourceDecompositionType_LocalType;
class IMp7JrsVideoSegmentMediaSourceDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsVideoSegmentMediaSourceDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentMediaSourceDecompositionType_LocalType > Mp7JrsVideoSegmentMediaSourceDecompositionType_LocalPtr;

#define TypeOfVideoSegmentSpatialDecompositionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentSpatialDecompositionType")))
#define CreateVideoSegmentSpatialDecompositionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentSpatialDecompositionType))
class Mp7JrsVideoSegmentSpatialDecompositionType;
class IMp7JrsVideoSegmentSpatialDecompositionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentSpatialDecompositionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatialDecompositionType > Mp7JrsVideoSegmentSpatialDecompositionPtr;

#define TypeOfVideoSegmentSpatialDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentSpatialDecompositionType_CollectionType")))
#define CreateVideoSegmentSpatialDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentSpatialDecompositionType_CollectionType))
class Mp7JrsVideoSegmentSpatialDecompositionType_CollectionType;
class IMp7JrsVideoSegmentSpatialDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentSpatialDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatialDecompositionType_CollectionType > Mp7JrsVideoSegmentSpatialDecompositionType_CollectionPtr;

#define TypeOfVideoSegmentSpatialDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentSpatialDecompositionType_LocalType")))
#define CreateVideoSegmentSpatialDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentSpatialDecompositionType_LocalType))
class Mp7JrsVideoSegmentSpatialDecompositionType_LocalType;
class IMp7JrsVideoSegmentSpatialDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsVideoSegmentSpatialDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatialDecompositionType_LocalType > Mp7JrsVideoSegmentSpatialDecompositionType_LocalPtr;

#define TypeOfVideoSegmentSpatioTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentSpatioTemporalDecompositionType")))
#define CreateVideoSegmentSpatioTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentSpatioTemporalDecompositionType))
class Mp7JrsVideoSegmentSpatioTemporalDecompositionType;
class IMp7JrsVideoSegmentSpatioTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentSpatioTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatioTemporalDecompositionType > Mp7JrsVideoSegmentSpatioTemporalDecompositionPtr;

#define TypeOfVideoSegmentSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentSpatioTemporalDecompositionType_CollectionType")))
#define CreateVideoSegmentSpatioTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentSpatioTemporalDecompositionType_CollectionType))
class Mp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionType;
class IMp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionType > Mp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionPtr;

#define TypeOfVideoSegmentSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentSpatioTemporalDecompositionType_LocalType")))
#define CreateVideoSegmentSpatioTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentSpatioTemporalDecompositionType_LocalType))
class Mp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalType;
class IMp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalType > Mp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalPtr;

#define TypeOfVideoSegmentTemporalDecompositionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentTemporalDecompositionType")))
#define CreateVideoSegmentTemporalDecompositionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentTemporalDecompositionType))
class Mp7JrsVideoSegmentTemporalDecompositionType;
class IMp7JrsVideoSegmentTemporalDecompositionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentTemporalDecompositionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentTemporalDecompositionType > Mp7JrsVideoSegmentTemporalDecompositionPtr;

#define TypeOfVideoSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentTemporalDecompositionType_CollectionType")))
#define CreateVideoSegmentTemporalDecompositionType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentTemporalDecompositionType_CollectionType))
class Mp7JrsVideoSegmentTemporalDecompositionType_CollectionType;
class IMp7JrsVideoSegmentTemporalDecompositionType_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentTemporalDecompositionType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentTemporalDecompositionType_CollectionType > Mp7JrsVideoSegmentTemporalDecompositionType_CollectionPtr;

#define TypeOfVideoSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentTemporalDecompositionType_LocalType")))
#define CreateVideoSegmentTemporalDecompositionType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentTemporalDecompositionType_LocalType))
class Mp7JrsVideoSegmentTemporalDecompositionType_LocalType;
class IMp7JrsVideoSegmentTemporalDecompositionType_LocalType;
/** Smart pointer to instance of IMp7JrsVideoSegmentTemporalDecompositionType_LocalType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentTemporalDecompositionType_LocalType > Mp7JrsVideoSegmentTemporalDecompositionType_LocalPtr;

#define TypeOfVideoSegmentType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentType")))
#define CreateVideoSegmentType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentType))
class Mp7JrsVideoSegmentType;
class IMp7JrsVideoSegmentType;
/** Smart pointer to instance of IMp7JrsVideoSegmentType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType > Mp7JrsVideoSegmentPtr;

#define TypeOfVideoSegmentType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentType_CollectionType")))
#define CreateVideoSegmentType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentType_CollectionType))
class Mp7JrsVideoSegmentType_CollectionType;
class IMp7JrsVideoSegmentType_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_CollectionType > Mp7JrsVideoSegmentType_CollectionPtr;

#define TypeOfVideoSegmentType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentType_CollectionType0")))
#define CreateVideoSegmentType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentType_CollectionType0))
class Mp7JrsVideoSegmentType_CollectionType0;
class IMp7JrsVideoSegmentType_CollectionType0;
/** Smart pointer to instance of IMp7JrsVideoSegmentType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_CollectionType0 > Mp7JrsVideoSegmentType_Collection0Ptr;

#define TypeOfVideoSegmentType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentType_LocalType")))
#define CreateVideoSegmentType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentType_LocalType))
class Mp7JrsVideoSegmentType_LocalType;
class IMp7JrsVideoSegmentType_LocalType;
/** Smart pointer to instance of IMp7JrsVideoSegmentType_LocalType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_LocalType > Mp7JrsVideoSegmentType_LocalPtr;

#define TypeOfVideoSegmentType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentType_LocalType0")))
#define CreateVideoSegmentType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentType_LocalType0))
class Mp7JrsVideoSegmentType_LocalType0;
class IMp7JrsVideoSegmentType_LocalType0;
/** Smart pointer to instance of IMp7JrsVideoSegmentType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_LocalType0 > Mp7JrsVideoSegmentType_Local0Ptr;

#define TypeOfVideoSegmentType_Mosaic_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoSegmentType_Mosaic_CollectionType")))
#define CreateVideoSegmentType_Mosaic_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoSegmentType_Mosaic_CollectionType))
class Mp7JrsVideoSegmentType_Mosaic_CollectionType;
class IMp7JrsVideoSegmentType_Mosaic_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoSegmentType_Mosaic_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoSegmentType_Mosaic_CollectionType > Mp7JrsVideoSegmentType_Mosaic_CollectionPtr;

#define TypeOfVideoTextType (Mp7JrsFactory::GetTypeIndex(X("VideoTextType")))
#define CreateVideoTextType (Mp7JrsFactory::CreateObject(TypeOfVideoTextType))
class Mp7JrsVideoTextType;
class IMp7JrsVideoTextType;
/** Smart pointer to instance of IMp7JrsVideoTextType */
typedef Mp7JrsPtr< IMp7JrsVideoTextType > Mp7JrsVideoTextPtr;

#define TypeOfVideoTextType_textType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoTextType_textType_LocalType")))
#define CreateVideoTextType_textType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoTextType_textType_LocalType))
class Mp7JrsVideoTextType_textType_LocalType;
class IMp7JrsVideoTextType_textType_LocalType;

#define TypeOfVideoTextType_textType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("VideoTextType_textType_LocalType0")))
#define CreateVideoTextType_textType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfVideoTextType_textType_LocalType0))
class Mp7JrsVideoTextType_textType_LocalType0;
class IMp7JrsVideoTextType_textType_LocalType0;
/** Smart pointer to instance of IMp7JrsVideoTextType_textType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsVideoTextType_textType_LocalType0 > Mp7JrsVideoTextType_textType_Local0Ptr;

#define TypeOfVideoTextType_textType_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("VideoTextType_textType_LocalType1")))
#define CreateVideoTextType_textType_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfVideoTextType_textType_LocalType1))
class Mp7JrsVideoTextType_textType_LocalType1;
class IMp7JrsVideoTextType_textType_LocalType1;
/** Smart pointer to instance of IMp7JrsVideoTextType_textType_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsVideoTextType_textType_LocalType1 > Mp7JrsVideoTextType_textType_Local1Ptr;

#define TypeOfVideoTextType_textType_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("VideoTextType_textType_LocalType2")))
#define CreateVideoTextType_textType_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfVideoTextType_textType_LocalType2))
class Mp7JrsVideoTextType_textType_LocalType2;
class IMp7JrsVideoTextType_textType_LocalType2;
/** Smart pointer to instance of IMp7JrsVideoTextType_textType_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsVideoTextType_textType_LocalType2 > Mp7JrsVideoTextType_textType_Local2Ptr;

#define TypeOfVideoType (Mp7JrsFactory::GetTypeIndex(X("VideoType")))
#define CreateVideoType (Mp7JrsFactory::CreateObject(TypeOfVideoType))
class Mp7JrsVideoType;
class IMp7JrsVideoType;
/** Smart pointer to instance of IMp7JrsVideoType */
typedef Mp7JrsPtr< IMp7JrsVideoType > Mp7JrsVideoPtr;

#define TypeOfVideoViewGraphType (Mp7JrsFactory::GetTypeIndex(X("VideoViewGraphType")))
#define CreateVideoViewGraphType (Mp7JrsFactory::CreateObject(TypeOfVideoViewGraphType))
class Mp7JrsVideoViewGraphType;
class IMp7JrsVideoViewGraphType;
/** Smart pointer to instance of IMp7JrsVideoViewGraphType */
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType > Mp7JrsVideoViewGraphPtr;

#define TypeOfVideoViewGraphType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("VideoViewGraphType_CollectionType")))
#define CreateVideoViewGraphType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfVideoViewGraphType_CollectionType))
class Mp7JrsVideoViewGraphType_CollectionType;
class IMp7JrsVideoViewGraphType_CollectionType;
/** Smart pointer to instance of IMp7JrsVideoViewGraphType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType_CollectionType > Mp7JrsVideoViewGraphType_CollectionPtr;

#define TypeOfVideoViewGraphType_CollectionType0 (Mp7JrsFactory::GetTypeIndex(X("VideoViewGraphType_CollectionType0")))
#define CreateVideoViewGraphType_CollectionType0 (Mp7JrsFactory::CreateObject(TypeOfVideoViewGraphType_CollectionType0))
class Mp7JrsVideoViewGraphType_CollectionType0;
class IMp7JrsVideoViewGraphType_CollectionType0;
/** Smart pointer to instance of IMp7JrsVideoViewGraphType_CollectionType0 */
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType_CollectionType0 > Mp7JrsVideoViewGraphType_Collection0Ptr;

#define TypeOfVideoViewGraphType_LocalType (Mp7JrsFactory::GetTypeIndex(X("VideoViewGraphType_LocalType")))
#define CreateVideoViewGraphType_LocalType (Mp7JrsFactory::CreateObject(TypeOfVideoViewGraphType_LocalType))
class Mp7JrsVideoViewGraphType_LocalType;
class IMp7JrsVideoViewGraphType_LocalType;
/** Smart pointer to instance of IMp7JrsVideoViewGraphType_LocalType */
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType_LocalType > Mp7JrsVideoViewGraphType_LocalPtr;

#define TypeOfVideoViewGraphType_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("VideoViewGraphType_LocalType0")))
#define CreateVideoViewGraphType_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfVideoViewGraphType_LocalType0))
class Mp7JrsVideoViewGraphType_LocalType0;
class IMp7JrsVideoViewGraphType_LocalType0;
/** Smart pointer to instance of IMp7JrsVideoViewGraphType_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType_LocalType0 > Mp7JrsVideoViewGraphType_Local0Ptr;

#define TypeOfViewDecompositionType (Mp7JrsFactory::GetTypeIndex(X("ViewDecompositionType")))
#define CreateViewDecompositionType (Mp7JrsFactory::CreateObject(TypeOfViewDecompositionType))
class Mp7JrsViewDecompositionType;
class IMp7JrsViewDecompositionType;
/** Smart pointer to instance of IMp7JrsViewDecompositionType */
typedef Mp7JrsPtr< IMp7JrsViewDecompositionType > Mp7JrsViewDecompositionPtr;

#define TypeOfViewDescriptionType (Mp7JrsFactory::GetTypeIndex(X("ViewDescriptionType")))
#define CreateViewDescriptionType (Mp7JrsFactory::CreateObject(TypeOfViewDescriptionType))
class Mp7JrsViewDescriptionType;
class IMp7JrsViewDescriptionType;
/** Smart pointer to instance of IMp7JrsViewDescriptionType */
typedef Mp7JrsPtr< IMp7JrsViewDescriptionType > Mp7JrsViewDescriptionPtr;

#define TypeOfViewDescriptionType_View_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ViewDescriptionType_View_CollectionType")))
#define CreateViewDescriptionType_View_CollectionType (Mp7JrsFactory::CreateObject(TypeOfViewDescriptionType_View_CollectionType))
class Mp7JrsViewDescriptionType_View_CollectionType;
class IMp7JrsViewDescriptionType_View_CollectionType;
/** Smart pointer to instance of IMp7JrsViewDescriptionType_View_CollectionType */
typedef Mp7JrsPtr< IMp7JrsViewDescriptionType_View_CollectionType > Mp7JrsViewDescriptionType_View_CollectionPtr;

#define TypeOfViewDescriptionType_ViewDecomposition_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ViewDescriptionType_ViewDecomposition_CollectionType")))
#define CreateViewDescriptionType_ViewDecomposition_CollectionType (Mp7JrsFactory::CreateObject(TypeOfViewDescriptionType_ViewDecomposition_CollectionType))
class Mp7JrsViewDescriptionType_ViewDecomposition_CollectionType;
class IMp7JrsViewDescriptionType_ViewDecomposition_CollectionType;
/** Smart pointer to instance of IMp7JrsViewDescriptionType_ViewDecomposition_CollectionType */
typedef Mp7JrsPtr< IMp7JrsViewDescriptionType_ViewDecomposition_CollectionType > Mp7JrsViewDescriptionType_ViewDecomposition_CollectionPtr;

#define TypeOfViewDescriptionType_ViewSet_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ViewDescriptionType_ViewSet_CollectionType")))
#define CreateViewDescriptionType_ViewSet_CollectionType (Mp7JrsFactory::CreateObject(TypeOfViewDescriptionType_ViewSet_CollectionType))
class Mp7JrsViewDescriptionType_ViewSet_CollectionType;
class IMp7JrsViewDescriptionType_ViewSet_CollectionType;
/** Smart pointer to instance of IMp7JrsViewDescriptionType_ViewSet_CollectionType */
typedef Mp7JrsPtr< IMp7JrsViewDescriptionType_ViewSet_CollectionType > Mp7JrsViewDescriptionType_ViewSet_CollectionPtr;

#define TypeOfViewSetType (Mp7JrsFactory::GetTypeIndex(X("ViewSetType")))
#define CreateViewSetType (Mp7JrsFactory::CreateObject(TypeOfViewSetType))
class Mp7JrsViewSetType;
class IMp7JrsViewSetType;
/** Smart pointer to instance of IMp7JrsViewSetType */
typedef Mp7JrsPtr< IMp7JrsViewSetType > Mp7JrsViewSetPtr;

#define TypeOfViewSetType_CollectionType (Mp7JrsFactory::GetTypeIndex(X("ViewSetType_CollectionType")))
#define CreateViewSetType_CollectionType (Mp7JrsFactory::CreateObject(TypeOfViewSetType_CollectionType))
class Mp7JrsViewSetType_CollectionType;
class IMp7JrsViewSetType_CollectionType;
/** Smart pointer to instance of IMp7JrsViewSetType_CollectionType */
typedef Mp7JrsPtr< IMp7JrsViewSetType_CollectionType > Mp7JrsViewSetType_CollectionPtr;

#define TypeOfViewSetType_LocalType (Mp7JrsFactory::GetTypeIndex(X("ViewSetType_LocalType")))
#define CreateViewSetType_LocalType (Mp7JrsFactory::CreateObject(TypeOfViewSetType_LocalType))
class Mp7JrsViewSetType_LocalType;
class IMp7JrsViewSetType_LocalType;
/** Smart pointer to instance of IMp7JrsViewSetType_LocalType */
typedef Mp7JrsPtr< IMp7JrsViewSetType_LocalType > Mp7JrsViewSetType_LocalPtr;

#define TypeOfViewSetType_setProperty_LocalType (Mp7JrsFactory::GetTypeIndex(X("ViewSetType_setProperty_LocalType")))
#define CreateViewSetType_setProperty_LocalType (Mp7JrsFactory::CreateObject(TypeOfViewSetType_setProperty_LocalType))
class Mp7JrsViewSetType_setProperty_LocalType;
class IMp7JrsViewSetType_setProperty_LocalType;

#define TypeOfViewSetType_setProperty_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("ViewSetType_setProperty_LocalType0")))
#define CreateViewSetType_setProperty_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfViewSetType_setProperty_LocalType0))
class Mp7JrsViewSetType_setProperty_LocalType0;
class IMp7JrsViewSetType_setProperty_LocalType0;
/** Smart pointer to instance of IMp7JrsViewSetType_setProperty_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsViewSetType_setProperty_LocalType0 > Mp7JrsViewSetType_setProperty_Local0Ptr;

#define TypeOfViewSetType_setProperty_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("ViewSetType_setProperty_LocalType1")))
#define CreateViewSetType_setProperty_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfViewSetType_setProperty_LocalType1))
class Mp7JrsViewSetType_setProperty_LocalType1;
class IMp7JrsViewSetType_setProperty_LocalType1;
/** Smart pointer to instance of IMp7JrsViewSetType_setProperty_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsViewSetType_setProperty_LocalType1 > Mp7JrsViewSetType_setProperty_Local1Ptr;

#define TypeOfViewSetType_setProperty_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("ViewSetType_setProperty_LocalType2")))
#define CreateViewSetType_setProperty_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfViewSetType_setProperty_LocalType2))
class Mp7JrsViewSetType_setProperty_LocalType2;
class IMp7JrsViewSetType_setProperty_LocalType2;
/** Smart pointer to instance of IMp7JrsViewSetType_setProperty_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsViewSetType_setProperty_LocalType2 > Mp7JrsViewSetType_setProperty_Local2Ptr;

#define TypeOfViewType (Mp7JrsFactory::GetTypeIndex(X("ViewType")))
#define CreateViewType (Mp7JrsFactory::CreateObject(TypeOfViewType))
class Mp7JrsViewType;
class IMp7JrsViewType;
/** Smart pointer to instance of IMp7JrsViewType */
typedef Mp7JrsPtr< IMp7JrsViewType > Mp7JrsViewPtr;

#define TypeOfVisualDSType (Mp7JrsFactory::GetTypeIndex(X("VisualDSType")))
#define CreateVisualDSType (Mp7JrsFactory::CreateObject(TypeOfVisualDSType))
class Mp7JrsVisualDSType;
class IMp7JrsVisualDSType;
/** Smart pointer to instance of IMp7JrsVisualDSType */
typedef Mp7JrsPtr< IMp7JrsVisualDSType > Mp7JrsVisualDSPtr;

#define TypeOfVisualDType (Mp7JrsFactory::GetTypeIndex(X("VisualDType")))
#define CreateVisualDType (Mp7JrsFactory::CreateObject(TypeOfVisualDType))
class Mp7JrsVisualDType;
class IMp7JrsVisualDType;
/** Smart pointer to instance of IMp7JrsVisualDType */
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

#define TypeOfVisualSummaryComponentType (Mp7JrsFactory::GetTypeIndex(X("VisualSummaryComponentType")))
#define CreateVisualSummaryComponentType (Mp7JrsFactory::CreateObject(TypeOfVisualSummaryComponentType))
class Mp7JrsVisualSummaryComponentType;
class IMp7JrsVisualSummaryComponentType;
/** Smart pointer to instance of IMp7JrsVisualSummaryComponentType */
typedef Mp7JrsPtr< IMp7JrsVisualSummaryComponentType > Mp7JrsVisualSummaryComponentPtr;

#define TypeOfVisualTimeSeriesType (Mp7JrsFactory::GetTypeIndex(X("VisualTimeSeriesType")))
#define CreateVisualTimeSeriesType (Mp7JrsFactory::CreateObject(TypeOfVisualTimeSeriesType))
class Mp7JrsVisualTimeSeriesType;
class IMp7JrsVisualTimeSeriesType;
/** Smart pointer to instance of IMp7JrsVisualTimeSeriesType */
typedef Mp7JrsPtr< IMp7JrsVisualTimeSeriesType > Mp7JrsVisualTimeSeriesPtr;

#define TypeOfWordFormType (Mp7JrsFactory::GetTypeIndex(X("WordFormType")))
#define CreateWordFormType (Mp7JrsFactory::CreateObject(TypeOfWordFormType))
class Mp7JrsWordFormType;
class IMp7JrsWordFormType;
/** Smart pointer to instance of IMp7JrsWordFormType */
typedef Mp7JrsPtr< IMp7JrsWordFormType > Mp7JrsWordFormPtr;

#define TypeOfWordFormType_terms_CollectionType (Mp7JrsFactory::GetTypeIndex(X("WordFormType_terms_CollectionType")))
#define CreateWordFormType_terms_CollectionType (Mp7JrsFactory::CreateObject(TypeOfWordFormType_terms_CollectionType))
class Mp7JrsWordFormType_terms_CollectionType;
class IMp7JrsWordFormType_terms_CollectionType;
/** Smart pointer to instance of IMp7JrsWordFormType_terms_CollectionType */
typedef Mp7JrsPtr< IMp7JrsWordFormType_terms_CollectionType > Mp7JrsWordFormType_terms_CollectionPtr;

#define TypeOfWordFormType_type_CollectionType (Mp7JrsFactory::GetTypeIndex(X("WordFormType_type_CollectionType")))
#define CreateWordFormType_type_CollectionType (Mp7JrsFactory::CreateObject(TypeOfWordFormType_type_CollectionType))
class Mp7JrsWordFormType_type_CollectionType;
class IMp7JrsWordFormType_type_CollectionType;
/** Smart pointer to instance of IMp7JrsWordFormType_type_CollectionType */
typedef Mp7JrsPtr< IMp7JrsWordFormType_type_CollectionType > Mp7JrsWordFormType_type_CollectionPtr;

#define TypeOfWordFormType_type_LocalType (Mp7JrsFactory::GetTypeIndex(X("WordFormType_type_LocalType")))
#define CreateWordFormType_type_LocalType (Mp7JrsFactory::CreateObject(TypeOfWordFormType_type_LocalType))
class Mp7JrsWordFormType_type_LocalType;
class IMp7JrsWordFormType_type_LocalType;

#define TypeOfWordFormType_type_LocalType0 (Mp7JrsFactory::GetTypeIndex(X("WordFormType_type_LocalType0")))
#define CreateWordFormType_type_LocalType0 (Mp7JrsFactory::CreateObject(TypeOfWordFormType_type_LocalType0))
class Mp7JrsWordFormType_type_LocalType0;
class IMp7JrsWordFormType_type_LocalType0;
/** Smart pointer to instance of IMp7JrsWordFormType_type_LocalType0 */
typedef Mp7JrsPtr< IMp7JrsWordFormType_type_LocalType0 > Mp7JrsWordFormType_type_Local0Ptr;

#define TypeOfWordFormType_type_LocalType1 (Mp7JrsFactory::GetTypeIndex(X("WordFormType_type_LocalType1")))
#define CreateWordFormType_type_LocalType1 (Mp7JrsFactory::CreateObject(TypeOfWordFormType_type_LocalType1))
class Mp7JrsWordFormType_type_LocalType1;
class IMp7JrsWordFormType_type_LocalType1;
/** Smart pointer to instance of IMp7JrsWordFormType_type_LocalType1 */
typedef Mp7JrsPtr< IMp7JrsWordFormType_type_LocalType1 > Mp7JrsWordFormType_type_Local1Ptr;

#define TypeOfWordFormType_type_LocalType2 (Mp7JrsFactory::GetTypeIndex(X("WordFormType_type_LocalType2")))
#define CreateWordFormType_type_LocalType2 (Mp7JrsFactory::CreateObject(TypeOfWordFormType_type_LocalType2))
class Mp7JrsWordFormType_type_LocalType2;
class IMp7JrsWordFormType_type_LocalType2;
/** Smart pointer to instance of IMp7JrsWordFormType_type_LocalType2 */
typedef Mp7JrsPtr< IMp7JrsWordFormType_type_LocalType2 > Mp7JrsWordFormType_type_Local2Ptr;

#define TypeOfWordLexiconIndexType (Mp7JrsFactory::GetTypeIndex(X("WordLexiconIndexType")))
#define CreateWordLexiconIndexType (Mp7JrsFactory::CreateObject(TypeOfWordLexiconIndexType))
class Mp7JrsWordLexiconIndexType;
class IMp7JrsWordLexiconIndexType;
/** Smart pointer to instance of IMp7JrsWordLexiconIndexType */
typedef Mp7JrsPtr< IMp7JrsWordLexiconIndexType > Mp7JrsWordLexiconIndexPtr;

#define TypeOfWordLexiconType (Mp7JrsFactory::GetTypeIndex(X("WordLexiconType")))
#define CreateWordLexiconType (Mp7JrsFactory::CreateObject(TypeOfWordLexiconType))
class Mp7JrsWordLexiconType;
class IMp7JrsWordLexiconType;
/** Smart pointer to instance of IMp7JrsWordLexiconType */
typedef Mp7JrsPtr< IMp7JrsWordLexiconType > Mp7JrsWordLexiconPtr;

#define TypeOfWordLexiconType_Token_CollectionType (Mp7JrsFactory::GetTypeIndex(X("WordLexiconType_Token_CollectionType")))
#define CreateWordLexiconType_Token_CollectionType (Mp7JrsFactory::CreateObject(TypeOfWordLexiconType_Token_CollectionType))
class Mp7JrsWordLexiconType_Token_CollectionType;
class IMp7JrsWordLexiconType_Token_CollectionType;
/** Smart pointer to instance of IMp7JrsWordLexiconType_Token_CollectionType */
typedef Mp7JrsPtr< IMp7JrsWordLexiconType_Token_CollectionType > Mp7JrsWordLexiconType_Token_CollectionPtr;

#define TypeOfWordType (Mp7JrsFactory::GetTypeIndex(X("WordType")))
#define CreateWordType (Mp7JrsFactory::CreateObject(TypeOfWordType))
class Mp7JrsWordType;
class IMp7JrsWordType;
/** Smart pointer to instance of IMp7JrsWordType */
typedef Mp7JrsPtr< IMp7JrsWordType > Mp7JrsWordPtr;

#define TypeOfxPathAbsoluteSelectorType (Mp7JrsFactory::GetTypeIndex(X("xPathAbsoluteSelectorType")))
#define CreatexPathAbsoluteSelectorType (Mp7JrsFactory::CreateObject(TypeOfxPathAbsoluteSelectorType))
class Mp7JrsxPathAbsoluteSelectorType;
class IMp7JrsxPathAbsoluteSelectorType;
/** Smart pointer to instance of IMp7JrsxPathAbsoluteSelectorType */
typedef Mp7JrsPtr< IMp7JrsxPathAbsoluteSelectorType > Mp7JrsxPathAbsoluteSelectorPtr;

#define TypeOfxPathFieldType (Mp7JrsFactory::GetTypeIndex(X("xPathFieldType")))
#define CreatexPathFieldType (Mp7JrsFactory::CreateObject(TypeOfxPathFieldType))
class Mp7JrsxPathFieldType;
class IMp7JrsxPathFieldType;
/** Smart pointer to instance of IMp7JrsxPathFieldType */
typedef Mp7JrsPtr< IMp7JrsxPathFieldType > Mp7JrsxPathFieldPtr;

#define TypeOfxPathRefType (Mp7JrsFactory::GetTypeIndex(X("xPathRefType")))
#define CreatexPathRefType (Mp7JrsFactory::CreateObject(TypeOfxPathRefType))
class Mp7JrsxPathRefType;
class IMp7JrsxPathRefType;
/** Smart pointer to instance of IMp7JrsxPathRefType */
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

#define TypeOfxPathSelectorType (Mp7JrsFactory::GetTypeIndex(X("xPathSelectorType")))
#define CreatexPathSelectorType (Mp7JrsFactory::CreateObject(TypeOfxPathSelectorType))
class Mp7JrsxPathSelectorType;
class IMp7JrsxPathSelectorType;
/** Smart pointer to instance of IMp7JrsxPathSelectorType */
typedef Mp7JrsPtr< IMp7JrsxPathSelectorType > Mp7JrsxPathSelectorPtr;

#define TypeOfxPathType (Mp7JrsFactory::GetTypeIndex(X("xPathType")))
#define CreatexPathType (Mp7JrsFactory::CreateObject(TypeOfxPathType))
class Mp7JrsxPathType;
class IMp7JrsxPathType;
/** Smart pointer to instance of IMp7JrsxPathType */
typedef Mp7JrsPtr< IMp7JrsxPathType > Mp7JrsxPathPtr;

#define TypeOfzeroToOneType (Mp7JrsFactory::GetTypeIndex(X("zeroToOneType")))
#define CreatezeroToOneType (Mp7JrsFactory::CreateObject(TypeOfzeroToOneType))
class Mp7JrszeroToOneType;
class IMp7JrszeroToOneType;
/** Smart pointer to instance of IMp7JrszeroToOneType */
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

#include "Mp7JrsPtrTypes.h"

#endif // MP7JRSFACTORYDEFINES_H
